# JuliaFormatter.jl

[![Documenter: stable](https://img.shields.io/badge/docs-stable-blue.svg)](https://juliaeditorsupport.github.io/JuliaFormatter.jl/stable/)
![Build Status](https://github.com/juliaeditorsupport/JuliaFormatter.jl/actions/workflows/ci.yml/badge.svg)

Width-sensitive formatter for Julia code.
Inspired by gofmt, refmt, and black.

> [!NOTE]
> In JuliaFormatter v2, SciMLStyle and YASStyle still have a number of rough edges.
> If you are using these styles please consider using v1 of JuliaFormatter.
>
> Default and Blue styles should _largely_ be stable from v2.10 onwards.
>
> See also the [Project Status](https://juliaeditorsupport.github.io/JuliaFormatter.jl/stable/status) section of the docs for more details.

## Installation

```julia
pkg> add JuliaFormatter
```

## Quick Start

```julia
julia> using JuliaFormatter

# Recursively formats all Julia files in the current directory
julia> format(".")

# Formats an individual file
julia> format_file("foo.jl")

# Formats a string (contents of a Julia file)
julia> format_text(str)
```

Check out [the docs](https://juliaeditorsupport.github.io/JuliaFormatter.jl/stable/) for further description of the formatter and its options.

## Command Line Tool

Starting from version 2.2.0, JuliaFormatter provides a command-line executable `jlfmt`.

To install:

```julia
pkg> app add JuliaFormatter
```

Usage:

```bash
# Format a file and write to stdout
jlfmt src/file.jl

# Format a file in place
jlfmt --inplace src/file.jl

# Check if all files in a directory are already formatted with verbose mode
jlfmt --check -v src/

# Format all files in a directory with multiple threads
jlfmt --threads=6 -- --inplace -v src/

# Show diff without modifying files
jlfmt --diff src/file.jl
```

Run `jlfmt --help` for more options.

Check out [the CLI docs](https://juliaeditorsupport.github.io/JuliaFormatter.jl/stable/cli) for further description of the formatter and its options.

using Test

# Make sure to develop the local version of the package. Otherwise the jlfmt app tests can
# end up using a stale version.
using Pkg: Pkg
Pkg.develop(; path = dirname(@__DIR__))

@testset "JuliaFormatter" begin
    include("dispatch.jl")
    include("internal_utils.jl")
    include("default_style.jl")
    include("yas_style.jl")
    include("blue_style.jl")
    include("sciml_style.jl")
    include("multidimensional_array.jl")
    include("issues.jl")
    include("inline_comments.jl")
    include("options.jl")
    include("options/always_use_return.jl")
    include("options/annotate_untyped_fields_with_any.jl")
    include("options/for_to_in.jl")
    include("options/import_to_using.jl")
    include("options/long_to_short_function_def.jl")
    include("options/short_circuit_to_if.jl")
    include("options/trailing_comma.jl")
    include("options/v2_stable_multiline_strings.jl")
    include("options/separate_kwargs_with_semicolons.jl")
    include("options/transform_syntax_in_macros.jl")
    include("options/format_docstrings.jl")
    include("options/enforce_triplequoted_docstrings.jl")
    include("line_ranges.jl")
    include("interface.jl")
    include("config.jl")
    include("argparse.jl")
    include("jlfmt_app.jl")
end

@enum(
    FNode,

    # dummy
    NONE,

    # leaf nodes
    NEWLINE,
    SEMICOLON,
    WHITESPACE,
    PLACEHOLDER,
    NOTCODE,
    INLINECOMMENT,
    TRAILINGCOMMA,
    KEYWORD,
    LITERAL,
    OPERATOR,
    PUNCTUATION,
    IDENTIFIER,
    MACRONAME,
    HASHEQCOMMENT,

    # non-leaf nodes
    Accessor,
    MacroBlock,
    MacroCall,
    MacroStr,
    Macroname,
    GlobalRefDoc,
    TupleN,
    CartesianIterator,
    RefN,
    ModuleN,
    Unary,
    Binary,
    Chain,
    Comparison,
    Conditional,
    Where,
    Vect,
    Braces,
    Brackets,
    Curly,
    Call,
    Parameters,
    Kw,
    Vcat,
    Hcat,
    Ncat,
    TypedVcat,
    TypedNcat,
    TypedHcat,
    Row,
    NRow,
    BracesCat,
    TypedComprehension,
    Comprehension,
    Generator,
    Filter,
    Flatten,
    For,
    While,
    If,
    Begin,
    Try,
    Quote,
    Do,
    Let,
    Block,
    BareModule,
    TopLevel,
    StringN,
    Macro,
    FunctionN,
    Struct,
    Mutable,
    Primitive,
    Abstract,
    Return,
    Local,
    Outer,
    Global,
    Const,
    Import,
    Export,
    Public,
    Using,
    File,
    Quotenode,
    Unknown,
    As,
    NonStdIdentifier, # i.e. var"##iv369"
    ImportPath,
    Juxtapose,
    Break,
    Continue,
    Inert,
    TupleBlock,
)

@enum(NestBehavior, AllowNest, AlwaysNest, NeverNest, NeverNestNode, AllowNestButDontRemove)

struct Metadata
    op_kind::JuliaSyntax.Kind

    # Indicates that the node is a shortcircuiting logical operator (`&&` or `||`) whose
    # value is not used in any way, i.e., it exists solely for the side effects.
    is_standalone_shortcircuit::Bool
    # If the above is true, this field indicates whether it should be expanded into a full
    # if-else statement if `short_circuit_to_if` is true. This mainly exists to catch the
    # case where it's inside a macro/expr, which causes the transformation to be disabled.
    # 
    # Note that because `is_standalone_shortcircuit` has impacts on alignment as well, we
    # need to have a separate flag instead of just setting it to false when inside
    # macros/exprs.
    is_expandable_shortcircuit::Bool

    is_short_form_function::Bool
    is_assignment::Bool

    # Indicates that this is a long-form function def that can be contracted to a short-form
    # one if needed.
    is_contractable_function::Bool

    has_multiline_argument::Bool

    # True for a StringN node built from a NON-triple-quoted multiline literal, e.g.
    #
    #     x = "line one
    #     line two"
    #
    # or the `cmd`/`r"..."`/`raw"..."` equivalents. Unlike `"""..."""` literals, these have
    # no dedent semantics: every interior line (and the closing-delimiter line) is part of
    # the string's value, so the printer must emit those lines verbatim at their original
    # columns and must not re-indent them when the surrounding code shifts. See issue #1251.
    is_opaque_string::Bool
end

function Metadata(k::JuliaSyntax.Kind)
    return Metadata(k, false, false, false, false, true, false, false)
end

"""
Formatted Syntax Tree
"""
mutable struct FST
    typ::FNode

    # Start and end lines of the node
    # in the original source file.
    startline::Int
    endline::Int

    # TODO(penelopeysm): This field should be calculated based on display width. I'm not
    # sure that this is consistently obeyed in the codebase, so it's more of an aspirational
    # comment rather than a true invariant right now.
    indent::Int

    # Display width of the node's content (measured in terminal columns via `textwidth`).
    len::Int
    val::String
    # Note that nodes = () indicates a leaf node, whereas nodes = [] indicates a tree node
    # with no leaves (yet).
    #
    # TODO(penelopeysm): The former case should probably be `nothing`.
    nodes::Union{Tuple{},Vector{FST}}
    nest_behavior::NestBehavior

    # Extra margin caused by parent nodes.
    # i.e. `(f(arg))`
    #
    # `f(arg)` would have `extra_margin` = 1
    # due to `)` after `f(arg)`.
    extra_margin::Int
    line_offset::Int

    metadata::Union{Nothing,Metadata}
end

function show(io::IO, fst::FST)
    show(io, MIME("text/plain"), fst)
end

COLORS = (:blue, :green, :red, :cyan, :magenta, :yellow)

function _print_prefix(io::IO, prefix::Vector{String})
    for (k, seg) in enumerate(prefix)
        printstyled(io, seg; color = COLORS[mod1(k, length(COLORS))])
    end
end

function show(
    io::IO,
    ::MIME"text/plain",
    fst::FST;
    prefix::Vector{String} = String[],
    level::Int = 1,
)
    color = COLORS[mod1(level, length(COLORS))]
    extra_indent = level > 1 ? "    " : "" # to account for [N] prefix

    if !is_leaf(fst)
        nodes = fst.nodes::Vector{FST}
        n = length(nodes)
        printstyled(io, "$(fst.typ) $n"; color = color, bold = true)
        printstyled(
            io,
            " lines=$(fst.startline)-$(fst.endline) indent=$(fst.indent) len=$(fst.len)\n";
            color = color,
        )
        _print_prefix(io, prefix)
        printstyled(io, "nest_behavior=$(fst.nest_behavior)"; color = color)
        printstyled(io, " extra_margin=$(fst.extra_margin)\n"; color = color)

        for (i, node) in enumerate(nodes)
            is_last = i == n
            connector = is_last ? "└── " : "├── "
            continuation = is_last ? "    " : "│   "
            next_color = COLORS[mod1(level + 1, length(COLORS))]
            child_prefix = [prefix; continuation]

            _print_prefix(io, prefix)
            printstyled(io, connector; color = color)
            printstyled(io, "[$i] "; color = next_color, bold = true)
            show(io, MIME("text/plain"), node; prefix = child_prefix, level = level + 1)
        end
    else
        printstyled(io, "$(fst.typ)"; color = color, bold = true)
        printstyled(
            io,
            " lines=$(fst.startline)-$(fst.endline) val=$(repr(fst.val))\n";
            color = color,
        )
        _print_prefix(io, prefix)
        printstyled(io, "$(extra_indent)line_offset=$(fst.line_offset)"; color = color)
        printstyled(io, " indent=$(fst.indent)\n"; color = color)
    end
end

function FST(typ::FNode, indent::Int)
    FST(typ, 0, 0, indent, 0, "", FST[], AllowNest, 0, -1, nothing)
end

function FST(
    typ::FNode,
    line_offset::Int,
    startline::Int,
    endline::Int,
    val::AbstractString,
)
    FST(
        typ,
        startline,
        endline,
        0,
        textwidth(val),
        val,
        (),
        AllowNest,
        0,
        line_offset,
        nothing,
    )
end

function Base.setindex!(fst::FST, node::FST, ind::Int)
    nodes = fst.nodes::Vector{FST}
    fst.len -= nodes[ind].len
    nodes[ind] = node
    fst.len += node.len
end
Base.getindex(fst::FST, inds...) = (fst.nodes::Vector{FST})[inds...]
Base.lastindex(fst::FST) = length(fst.nodes::Vector{FST})
Base.firstindex(fst::FST) = 1
Base.length(fst::FST) = fst.len
function Base.iterate(fst::FST, state = 1)
    nodes = fst.nodes::Vector{FST}
    if state > length(nodes::Vector{FST})
        return nothing
    end
    return nodes[state], state + 1
end

function Base.insert!(fst::FST, ind::Int, node::FST)
    insert!(fst.nodes::Vector{FST}, ind, node)
    fst.len += node.len
    return
end

# nesting behaviors
must_nest(fst::FST) = fst.nest_behavior === AlwaysNest
cant_nest(fst::FST) = fst.nest_behavior === NeverNest
function any_descendant(f, fst::FST)
    is_leaf(fst) && return false
    for n in fst.nodes::Vector{FST}
        f(n) && return true
        any_descendant(f, n) && return true
    end
    return false
end
can_nest(fst::FST) = fst.nest_behavior in (AllowNest, AllowNestButDontRemove)
can_remove(fst::FST) = fst.nest_behavior !== AllowNestButDontRemove

function Newline(; length = 0, nest_behavior = AllowNest)
    FST(NEWLINE, 0, 0, 0, length, "\n", (), nest_behavior, 0, -1, nothing)
end
Semicolon() = FST(SEMICOLON, 0, 0, 0, 1, ";", (), AllowNest, 0, -1, nothing)
TrailingComma() = FST(TRAILINGCOMMA, 0, 0, 0, 0, "", (), AllowNest, 0, -1, nothing)
Whitespace(n) = FST(WHITESPACE, 0, 0, 0, n, " "^n, (), AllowNest, 0, -1, nothing)
Placeholder(n) = FST(PLACEHOLDER, 0, 0, 0, n, " "^n, (), AllowNest, 0, -1, nothing)
function Notcode(startline, endline)
    FST(NOTCODE, startline, endline, 0, 0, "", (), AllowNest, 0, -1, nothing)
end
function InlineComment(line)
    FST(INLINECOMMENT, line, line, 0, 0, "", (), AllowNest, 0, -1, nothing)
end

is_leaf(cst::JuliaSyntax.GreenNode) = !haschildren(cst)
is_leaf(fst::FST) = typeof(fst.nodes) === Tuple{}

function is_punc(cst::JuliaSyntax.GreenNode)
    punctuation = KSet", ( ) [ ] { } @"
    return kind(cst) in punctuation || (kind(cst) === K"." && !haschildren(cst))
end
is_punc(fst::FST) = fst.typ === PUNCTUATION

is_end(x::JuliaSyntax.GreenNode) = kind(x) === K"end"
is_end(x::FST) = x.typ === KEYWORD && x.val == "end"

is_colon(x::FST) = x.typ === OPERATOR && x.val == ":"

is_comma(fst::FST) = fst.typ === TRAILINGCOMMA || (is_punc(fst) && fst.val == ",")
is_comment(fst::FST) = fst.typ in (INLINECOMMENT, NOTCODE, HASHEQCOMMENT)

is_identifier(x) = kind(x) === K"Identifier" && !haschildren(x)

"""
    block_has_statements(cst) -> Bool

Whether the `block` node `cst` contains any statements.

Semicolons don't count. They are only statement separators and are dropped when the block
is printed (see `p_block`), so `function f(); end` is just as empty as `function f() end`
and both are printed the same way. Counting the `;` as a statement would instead give
`function f()\\nend` on the first pass, which the empty-block handling then collapses to
`function f() end` on the second — i.e. not idempotent.
"""
function block_has_statements(cst)
    haschildren(cst) || return false
    any(c -> !Shims.is_really_whitespace(c) && kind(c) !== K";", children(cst))
end

function is_multiline(fst::FST)
    fst.endline > fst.startline &&
        fst.typ in (StringN, Vcat, TypedVcat, Ncat, TypedNcat, MacroStr)
end

is_macrocall(fst::FST) = fst.typ in (MacroCall, MacroBlock)

function is_macrodoc(fst::FST)::Bool
    fst.typ === GlobalRefDoc ||
        (fst.typ === MacroBlock && fst[1].typ === Macroname && fst[1][1].val == "@doc")
end

function is_macrostr(t::JuliaSyntax.GreenNode)::Bool
    kind(t) == K"macrocall" && haschildren(t) && contains_macrostr(t[1])
end

function contains_macrostr(t::JuliaSyntax.GreenNode)::Bool
    if kind(t) in KSet"StringMacroName CmdMacroName"
        return true
    elseif kind(t) === "quote" && haschildren(t)
        return contains_macrostr(t[1])
    elseif kind(t) === K"." && haschildren(t)
        return any(contains_macrostr, reverse(children(t)))
    end
    return false
end

function defines_function(x::JuliaSyntax.GreenNode)
    if kind(x) in KSet"function macro" && haschildren(x)
        return true
    elseif is_assignment(x) && haschildren(x)
        childs = children(x)
        idx = findfirst(n -> !JuliaSyntax.is_whitespace(n), childs)
        return !isnothing(idx) && Shims.is_caller_in_function_def(childs[idx])
    end
    return false
end

is_if(cst::JuliaSyntax.GreenNode) = kind(cst) in KSet"if elseif else" && haschildren(cst)

function is_try(cst::JuliaSyntax.GreenNode)
    kind(cst) in KSet"try catch finally" && haschildren(cst)
end

function is_custom_leaf(fst::FST)
    fst.typ in
    (NEWLINE, WHITESPACE, PLACEHOLDER, NOTCODE, INLINECOMMENT, TRAILINGCOMMA, HASHEQCOMMENT)
end

contains_comment(nodes::Vector{FST}) = findfirst(is_comment, nodes) !== nothing
function contains_comment(fst::FST)
    !is_leaf(fst) && contains_comment(fst.nodes::Vector{FST})
end

function get_args(t::JuliaSyntax.GreenNode)
    nodes = JuliaSyntax.GreenNode[]
    !haschildren(t) && return nodes
    childs = children(t)
    childs isa Tuple{} && return nodes

    k = kind(t)
    ret = if k == K"where"
        if is_leaf(childs[end])
            JuliaSyntax.GreenNode[childs[end]]
        else
            get_args(childs[end])
        end
    else
        _idx = findfirst(n -> kind(n) in KSet"( { [", childs)
        idx = isnothing(_idx) ? 1 : _idx + 1
        get_args(childs[idx:end])
    end
    append!(nodes, ret)
    return nodes
end

function get_args(args::Vector{JuliaSyntax.GreenNode{T}}) where {T}
    result = JuliaSyntax.GreenNode[]
    for c in args
        if !(
            is_punc(c) ||
            kind(c) == K";" ||
            JuliaSyntax.is_whitespace(c) ||
            kind(c) in KSet"` ``` \" \"\"\""
        )
            if kind(c) === K"parameters"
                append!(result, get_args(c))
            else
                push!(result, c)
            end
        end
    end
    return result
end

get_args(_) = ()
n_args(x) = length(get_args(x))

is_arg(fst::FST) = !(fst.typ in (PUNCTUATION, SEMICOLON) || is_custom_leaf(fst))

function n_args(fst::FST)
    is_leaf(fst) && return 0
    nodes = fst.nodes::Vector{FST}
    idx = findfirst(is_opener, nodes) |> x -> isnothing(x) ? 1 : x
    count(is_arg, nodes[idx:end])
end

function is_prev_newline(fst::FST)
    return if fst.typ === NEWLINE
        true
    elseif is_leaf(fst) || length(fst.nodes::Vector) == 0
        false
    else
        is_prev_newline(fst[end])
    end
end
function remove_prev_newline!(fst::FST)
    if is_leaf(fst) || length(fst.nodes::Vector) == 0
        error("Cannot remove previous newline from a leaf node or empty FST")
    elseif fst[end].typ === NEWLINE
        pop!(fst.nodes::Vector{FST})
        # no need to decrement fst.len because Newline nodes have len 0
    else
        remove_prev_newline!(fst[end])
        # likewise no need to decrement fst.len
    end
    return nothing
end

"""
    length_to(x::FST, ntyps; start::Int = 1)

Returns the length to any node type in `ntyps` based off the `start` index.
"""
function length_to(fst::FST, ntyps; start::Int = 1)
    if fst.typ in ntyps
        return 0, true
    end
    if is_leaf(fst)
        return length(fst), false
    end
    len = 0
    nodes = fst.nodes::Vector
    for i in start:length(nodes)
        l, found = length_to(nodes[i], ntyps)
        len += l
        if found
            return len, found
        end
    end
    return len, false
end

function is_closer(fst::FST)
    fst.typ === PUNCTUATION && (fst.val == "}" || fst.val == ")" || fst.val == "]")
end
is_closer(t::JuliaSyntax.GreenNode) = kind(t) in KSet"} ) ]"

function is_opener(fst::FST)
    fst.typ === PUNCTUATION && (fst.val == "{" || fst.val == "(" || fst.val == "[")
end
is_opener(t::JuliaSyntax.GreenNode) = kind(t) in KSet"{ ( ["

function is_iterable(t::JuliaSyntax.GreenNode)
    kind(t) in
    KSet"parens tuple vect vcat braces curly comprehension typed_comprehension macrocall ref typed_vcat import using export public" ||
        Shims.is_function_call(t)
end

function is_iterable(x::FST)
    is_named_iterable(x) || is_unnamed_iterable(x) || is_import_expr(x)
end
is_iterable(::Nothing) = false

function is_unnamed_iterable(x::FST)
    return x.typ in (TupleN, Vect, Vcat, Ncat, Braces, Comprehension, Brackets)
end

function is_named_iterable(x::FST)
    return x.typ in (Call, Curly, TypedComprehension, MacroCall, RefN, TypedVcat, TypedNcat)
end

function is_import_expr(x::FST)
    return x.typ in (Import, Using, Export, Public)
end

"""
    is_indent_nest(fst::FST)

Whether nesting the binary call `fst` at its operator indents the RHS by one level from the
start of the line:

```julia
aaaaaaaaaaaa =>
    rhs
```

as opposed to bringing it back to the column the LHS starts at, which is what every other
operator does:

```julia
aaaaaaaaaaaa in
rhs
```

True for assignments, `=>`, `->` and standalone short-circuits.
"""
function is_indent_nest(fst::FST)
    md = fst.metadata
    return (!isnothing(md) && (md::Metadata).is_short_form_function) ||
           is_assignment(fst) ||
           op_kind(fst) in KSet"=> ->" ||
           (!isnothing(md) && (md::Metadata).is_standalone_shortcircuit)
end

"""
    is_column_aligned(fst::FST)

Whether YASStyle lays out the continuation lines of `fst` relative to the column at which
`fst` itself starts, rather than relative to the start of the line it appears on.

Iterables are column-aligned, because their arguments line up with the bracket that opens
them, as is `where`, whose type parameters line up with the `{`:

```julia
f(aaaaaaaaaaaaaaaaaaaaaa,
  bbbbbbbbbbbbbbbbbbbbbb)

Foo{A} where {Aaaaaaaaaaaaaaa<:Xxxxxxxxxxxx,
              Bbbbbbbbbbbbbbb<:Yyyyyyyyyyyy}
```

Block-like constructs are not, because their bodies are indented by one level from the
start of the line, regardless of where `function f()` starts:

```julia
function f()
    body
end
```

For nested constructs we might need to inspect their children. For example in

```julia
@mymacro [aaaaaaaaaaaaaaaaaaaa,
          bbbbbbbbbbbbbbbbbbbb]
```

the second line is indented according to the `[` iff the last argument of the
macro is column-aligned.

A binary call is column-aligned unless its operator is one of those that indents the RHS
from the start of the line instead (see [`is_indent_nest`](@ref)).

`Chain`, `Comparison` and `Conditional` are column-aligned in YASStyle too, but they are
deliberately not listed here because the only caller (`n_binaryopcall!`) accounts for their
full width before it will consider undoing a nesting, so it never has to move one of them
that has already been split over several lines.
"""
function is_column_aligned(fst::FST)
    return if is_leaf(fst)
        false
    elseif fst.typ === Binary
        nodes = fst.nodes::Vector{FST}
        if any(n -> n.typ === NEWLINE, nodes)
            # It has been split across its own operator, so `n_binaryopcall!` decided
            # where the RHS goes.
            !is_indent_nest(fst)
        else
            # It is still on one line, so any continuation lines belong to the RHS
            # operand. In `@mac aaaa = [bbbbb, ccccc]` it is the vector literal, not the
            # assignment, that the second line is aligned against.
            is_column_aligned(nodes[end])
        end
    elseif fst.typ === MacroBlock
        # The trailing argument is the one that continuation lines follow on from.
        nodes = fst.nodes::Vector{FST}
        !isempty(nodes) && is_column_aligned(nodes[end])
    elseif fst.typ === Unary
        # Either `!x` or `x...`; in both cases it's the operand that matters, not the
        # operator.
        nodes = fst.nodes::Vector{FST}
        idx = findfirst(n -> n.typ !== OPERATOR, nodes)
        idx !== nothing && is_column_aligned(nodes[idx])
    elseif fst.typ === Where # `where {...}`
        true
    elseif is_iterable(fst)
        true
    else
        false
    end
end

"""
Returns whether `fst` can be an iterable argument. For example in
the case of a function call, which is of type `Call`:

```julia
(a, b, c; k1=v1)
```

This would return `true` for `a`, `b`, `c` and `k1=v1` and `false` for all other nodes.
"""
function is_iterable_arg(fst::FST)
    !(fst.typ in (PUNCTUATION, KEYWORD, OPERATOR, SEMICOLON) || is_custom_leaf(fst))
end

function is_comprehension(x::JuliaSyntax.GreenNode)
    kind(x) in KSet"comprehension typed_comprehension"
end

function is_comprehension(x::FST)
    x.typ in (Comprehension, TypedComprehension)
end

function first_nontrivial_child_is_block(cst::JuliaSyntax.GreenNode, style::AbstractStyle)
    JuliaSyntax.is_leaf(cst) && return false
    for c in children(cst)
        if JuliaSyntax.is_whitespace(c)
            continue
        else
            return is_block(c, style)
        end
    end
    return false
end

function is_block(x::JuliaSyntax.GreenNode, style::AbstractStyle)
    is_if(x) ||
        kind(x) in KSet"do try for while let" ||
        (
            kind(x) == K"block" &&
            haschildren(x) &&
            !JuliaSyntax.has_flags(x, JuliaSyntax.PARENS_FLAG)
        ) ||
        (kind(x) == K"quote" && haschildren(x) && is_block(x[1], style)) ||
        # For BlueStyle, chained ternaries will be expanded into blocks so we want to make
        # formatting decisions with that in mind.
        (style isa BlueStyle && is_chained_ternary(x))
end

# A chained ternary `a ? b : c ? d : e` is a K"?" node whose "else" branch (the last
# non-whitespace child) is itself a K"?" node.
function is_chained_ternary(cst::JuliaSyntax.GreenNode)
    kind(cst) !== K"?" && return false
    haschildren(cst) || return false
    rhs = findlast(c -> !JuliaSyntax.is_whitespace(c), children(cst))
    return rhs !== nothing && kind(cst[rhs]) === K"?" && haschildren(cst[rhs])
end

function is_block(x::FST)
    x.typ in (Block, If, Do, Try, Begin, For, While, Let) ||
        (x.typ === Quote && x[1].val == "quote")
end

function is_typedef(fst::FST)
    fst.typ in (Struct, Mutable, Primitive, Abstract)
end

function is_opcall(x::JuliaSyntax.GreenNode)
    if is_binary(x) || kind(x) == K"comparison" || is_chain(x) || unary_info(x) !== nothing
        return true
    end
    if kind(x) === K"parens" && haschildren(x)
        childs = children(x)
        idx = findfirst(
            n -> !JuliaSyntax.is_whitespace(kind(n)) && !(kind(n) in KSet"( )"),
            childs,
        )
        if isnothing(idx)
            return false
        end
        return is_opcall(childs[idx])
    end
    return false
end

function is_gen(x::JuliaSyntax.GreenNode)
    kind(x) in KSet"generator filter"
end

function is_gen(x::FST)
    x.typ in (Generator, Filter, Flatten)
end

function _callinfo(x::JuliaSyntax.GreenNode)
    if !haschildren(x)
        return 0, 0
    end
    k = kind(x)
    if k === K"call" && JuliaSyntax.is_infix_op_call(x)
        args = count(n -> !JuliaSyntax.is_whitespace(n), children(x))
        return div(args - 1, 2), div(args + 1, 2)
    elseif k === K"dotcall" && JuliaSyntax.is_infix_op_call(x)
        args = count(n -> !JuliaSyntax.is_whitespace(n), children(x))
        nops = div(args - 1, 3)
        return nops, nops + 1
    elseif k === K"op="
        return 1, 2
    elseif JuliaSyntax.is_operator(x) && haschildren(x)
        args = count(n -> !JuliaSyntax.is_whitespace(n), children(x))
        if args >= 3
            return div(args - 1, 2), div(args + 1, 2)
        end
    end
    n_operators = 0
    n_args = 0

    for c in children(x)
        if JuliaSyntax.is_whitespace(c) || is_punc(c)
            continue
        elseif haschildren(c) || (!haschildren(c) && !JuliaSyntax.is_operator(c))
            n_args += 1
        elseif k == K"dotcall" && JuliaSyntax.is_operator(c) && kind(c) == K"."
            continue
        elseif JuliaSyntax.is_operator(c)
            n_operators += 1
        end
    end
    return n_operators, n_args
end

"""
    unary_info(x::JuliaSyntax.GreenNode)::Union{Bool,Nothing}

Returns:

- `true` if `x` is a prefix unary operator application, such as `+x` or `<:x`

- `false` if `x` is a postfix unary operator application, such as `x'` or `x...`;

- `nothing` if `x` is not an application of a unary operator.
"""
function unary_info(x::JuliaSyntax.GreenNode)
    return if JuliaSyntax.is_prefix_op_call(x)
        # `+x`
        true
    elseif JuliaSyntax.is_postfix_op_call(x)
        # `x'` or `x'ᵀ`
        false
    elseif JuliaSyntax.is_operator(x) && haschildren(x)
        # `<:x` or `x...`
        childs_no_whitespace = filter(c -> !JuliaSyntax.is_whitespace(c), children(x))
        if length(childs_no_whitespace) != 2
            # Not unary at all
            nothing
        elseif JuliaSyntax.is_operator(childs_no_whitespace[1])
            # `<:x`
            true
        elseif JuliaSyntax.is_operator(childs_no_whitespace[end])
            # `x...`
            false
        else
            error("unreachable: unary operation node with no child operator")
        end
    else
        # Not unary at all
        nothing
    end
end

function is_binary(x)
    # TODO(penelopeysm): There is a bug in `is_binary` in that it returns true for
    # `<:(args...)` and `>:(args...)` as well. This is currently papered over in pretty() by
    # checking Shims.is_function_call(x) first, which will catch those cases, before
    # checking is_binary.
    #
    if !JuliaSyntax.is_infix_op_call(x) && !(JuliaSyntax.is_operator(x) && haschildren(x))
        # "Genuine" operators are caught by is_infix_op_call.
        #
        # The second predicate catches things like:
        #   - assignments `x = y`
        #   - field access `x.y`
        #   - logic operators `x && y` or `x || y`
        #   - membership `x in y`
        #   - anonymous functions `x -> y`
        return false
    end
    nops, nargs = _callinfo(x)
    return nops == 1 && nargs == 2
end

function is_chain(x::JuliaSyntax.GreenNode)
    if !(kind(x) in KSet"call dotcall")
        return false
    end
    nops, nargs = _callinfo(x)
    return nops > 1 && nargs > 2
end

function is_assignment(x::FST)
    if x.typ === Binary
        if isnothing(x.metadata)
            return false
        else
            return (x.metadata::Metadata).is_assignment
        end
    end

    if (
        x.typ === Const ||
        x.typ === Local ||
        x.typ === Global ||
        x.typ === Outer ||
        x.typ === MacroBlock
    ) && is_assignment(x[end])
        return true
    end

    return false
end

function is_assignment(t::JuliaSyntax.GreenNode)
    return JuliaSyntax.is_syntactic_assignment(t) && haschildren(t)
end
is_assignment(::Nothing) = false

function is_pairarrow(cst::JuliaSyntax.GreenNode)::Bool
    op = get_op(cst)
    isnothing(op) ? false : kind(op) === K"=>"
end

function is_function_or_macro_def(cst::JuliaSyntax.GreenNode)
    JuliaSyntax.is_leaf(cst) && return false
    k = kind(cst)
    # Long-form definition
    k in KSet"function macro" && return true
    # Short-form definition
    if JuliaSyntax.is_operator(cst) && k === K"="
        idx = findfirst(n -> !JuliaSyntax.is_whitespace(n), children(cst))
        if isnothing(idx)
            return false
        end
        return Shims.is_caller_in_function_def(cst[idx])
    end

    return false
end

function is_short_function_def(cst::JuliaSyntax.GreenNode)
    kind(cst) === K"function" &&
        JuliaSyntax.has_flags(cst, JuliaSyntax.SHORT_FORM_FUNCTION_FLAG)
end

function has_leading(n::JuliaSyntax.GreenNode, kinds::NTuple{N,JuliaSyntax.Kind}) where {N}
    return kind(n) in kinds ||
           (haschildren(n) && length(children(n)) > 0 && has_leading(n[1], kinds))
end

function has_trailing(n::JuliaSyntax.GreenNode, kinds::NTuple{N,JuliaSyntax.Kind}) where {N}
    return kind(n) in kinds ||
           (haschildren(n) && length(children(n)) > 0 && has_trailing(n[end], kinds))
end

function remove_empty_notcode(fst::FST)
    fst.typ in (Binary, Conditional, Comparison, Chain) || is_iterable(fst)
end

"""
    has_delimiters(cst::JuliaSyntax.GreenNode)

`cst` is assumed to be a single child node. Returns true if the node is of the syntactic
form `{...}, [...], or (...)`.
"""
function has_delimiters(cst::JuliaSyntax.GreenNode)
    kind(cst) in KSet"tuple vect braces bracescat comprehension parens"
end

function should_allow_nesting_call_args(args, disallow_single_arg_nesting::Bool)
    return length(args) > 0 && !(length(args) == 1 &&
             # If the argument has delimiters, it can itself be nested, so we
             # don't need to nest the call expression.
             (has_delimiters(args[1]) || disallow_single_arg_nesting))
end

function is_binaryop_nestable(::AbstractStyle, cst::JuliaSyntax.GreenNode)
    if (is_assignment(cst) || is_pairarrow(cst) || defines_function(cst)) &&
       haschildren(cst)
        childs = children(cst)
        idx = findlast(n -> !JuliaSyntax.is_whitespace(n), childs)::Int
        return !is_str_or_cmd(childs[idx])
    end
    true
end

function nest_rhs(cst::JuliaSyntax.GreenNode, style::AbstractStyle)::Bool
    # TODO(penelopeysm): I don't entirely understand this one here tbh: it seems quite
    # unprincipled for us to not use `is_block(cst, style)`
    if defines_function(cst) && haschildren(cst)
        for c in children(cst)
            if is_if(c) || kind(c) in KSet"do try for while let" && haschildren(c)
                return true
            end
            if style isa BlueStyle && is_chained_ternary(c)
                return true
            end
        end
    end
    false
end

function get_op(cst::JuliaSyntax.GreenNode)::Union{JuliaSyntax.GreenNode,Nothing}
    if JuliaSyntax.is_operator(cst)
        return cst
    end
    if (
        is_binary(cst) ||
        kind(cst) in KSet"comparison dotcall call" ||
        is_chain(cst) ||
        unary_info(cst) !== nothing
    ) && haschildren(cst)
        for c in children(cst)
            if kind(cst) === K"dotcall" && kind(c) === K"."
                continue
            elseif JuliaSyntax.is_operator(c) && !haschildren(c)
                return c
            end
        end
    end
    return nothing
end

function op_kind(cst::JuliaSyntax.GreenNode)::JuliaSyntax.Kind
    op = get_op(cst)
    isnothing(op) ? K"None" : kind(op)
end

function op_kind(fst::FST)::JuliaSyntax.Kind
    return isnothing(fst.metadata) ? K"None" : (fst.metadata::Metadata).op_kind
end

"""
    is_opaque_string(fst::FST)::Bool

Whether `fst` is a `StringN` node built from a non-triple-quoted multiline literal, whose
interior lines must be emitted verbatim (see the `is_opaque_string` field of `Metadata`).
"""
function is_opaque_string(fst::FST)::Bool
    return fst.typ === StringN &&
           !isnothing(fst.metadata) &&
           (fst.metadata::Metadata).is_opaque_string
end

# """
#     is_standalone_shortcircuit(cst::JuliaSyntax.GreenNode)
#
# Returns `true` if the `cst` is a short-circuit expression (uses `&&`, `||`)
# and is *standalone*, meaning it's not directly associated with another statement or
# expression.
#
# ### Examples
#
# ```julia
# # this IS a standalone short-circuit
# a && b
#
# # this IS NOT a standalone short-circuit
# if a && b
# end
#
# # this IS NOT a standalone short-circuit
# var = a && b
#
# # this IS NOT a standalone short-circuit
# @macro a && b
#
# # operation inside parenthesis IS NOT a standalone short-circuit
# # operation outside parenthesis IS a standalone short-circuit
# (a && b) && c
# ```
# """

"""
    eq_to_in_normalization!(fst::FST, always_for_in::Bool, for_in_replacement::String)
    eq_to_in_normalization!(fst::FST, always_for_in::Nothing, for_in_replacement::String)

Transforms

```julia
for i = iter body end

=>

for i in iter body end
```

AND

```julia
for i in 1:10 body end

=>

for i = 1:10 body end
```

`always_for_in=nothing` disables this normalization behavior.

- <https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/34>
"""
function eq_to_in_normalization!(fst::FST, always_for_in::Bool, for_in_replacement::String)
    if fst.typ === Binary
        idx = findfirst(n -> n.typ === OPERATOR, fst.nodes::Vector)
        if isnothing(idx)
            return
        end
        op = fst[idx]

        # surround op with ws
        if for_in_replacement != "=" && fst[idx-1].typ !== WHITESPACE
            insert!(fst, idx, Whitespace(1))
            insert!(fst, idx + 2, Whitespace(1))
        end

        old_op_len = op.len
        if always_for_in
            op.val = for_in_replacement
            op.len = textwidth(op.val)
        elseif op.val == "=" && op_kind(fst[end]) !== K":"
            op.val = "in"
            op.len = textwidth(op.val)
        elseif op.val == "in" && op_kind(fst[end]) === K":"
            op.val = "="
            op.len = textwidth(op.val)
        end
        fst.len += op.len - old_op_len
        if !isnothing(fst.metadata)
            metadata = fst.metadata::Metadata
            opkind = JuliaSyntax.Kind(op.val)
            fst.metadata = Metadata(
                opkind,
                metadata.is_standalone_shortcircuit,
                metadata.is_expandable_shortcircuit,
                metadata.is_short_form_function,
                opkind === K"=",
                metadata.is_contractable_function,
                metadata.has_multiline_argument,
                metadata.is_opaque_string,
            )
        end
    elseif fst.typ === Block || fst.typ === Brackets || fst.typ === Filter
        past_if = false
        for n in fst.nodes::Vector
            if n.typ === KEYWORD && n.val == "if"
                # [x for x in xs if x in 1:length(ys)]
                # we do not want to convert the binary operations after an "if" keyword.
                past_if = true
            end
            if past_if
                break
            end
            eq_to_in_normalization!(n, always_for_in, for_in_replacement)
        end
    end
end
eq_to_in_normalization!(::FST, ::Nothing, ::String) = nothing

# Check if the caller of a call is in `list`
# Note that this also works for JuliaSyntax.GreenNode
function caller_in_list(fst::FST, list::Vector{String})
    if is_leaf(fst[1]) && (fst[1].val) in list
        return true
    elseif !is_leaf(fst[1]) && is_leaf(fst[1][1]) && (fst[1][1].val) in list
        return true
    end

    return false
end

function caller_in_list(caller::AbstractString, list::Vector{String})
    return caller in list
end

function is_str_or_cmd(t::JuliaSyntax.GreenNode)
    kind(t) in KSet"doc string cmdstring String CmdString"
end

function is_lazy_op(t::Union{JuliaSyntax.GreenNode,JuliaSyntax.Kind})
    kind(t) in KSet"|| &&"
end

function has_more_args_to_come(::Tuple{}, _, _)
    return false
end

"""
    has_more_args_to_come

Searches `childs[start_index:end]` for the first non-whitespace node and returns whether it
is not of kind `stop_kind`.

If the first non-whitespace node is of kind `stop_kind`, that implies that there are no more
arguments to process in the current argument list / indexing expression / etc.
"""
function has_more_args_to_come(
    childs::Vector{JuliaSyntax.GreenNode{T}},
    start_index::Int,
    stop_kind::JuliaSyntax.Kind,
) where {T}
    j = start_index
    while j <= length(childs)
        if !JuliaSyntax.is_whitespace(childs[j])
            return kind(childs[j]) !== stop_kind
        end
        j += 1
    end
    return false
end

function next_node_is(k::JuliaSyntax.Kind, nn::JuliaSyntax.GreenNode)
    kind(nn) === k || (haschildren(nn) && next_node_is(k, nn[1]))
end

function next_node_is(f::Function, nn::JuliaSyntax.GreenNode)
    f(nn) || (haschildren(nn) && next_node_is(f, nn[1]))
end

function ends_with_macro_or_global(fst::FST)
    # Detects constructs such as
    #    @macro foo
    #    arg = @macro foo
    #    arg => @macro foo
    #    () -> global x = true
    # which cause parse errors if a comma is inserted after them.
    return if fst.typ === MacroCall || fst.typ === MacroBlock || fst.typ === Global
        true
    elseif is_leaf(fst)
        false
    elseif fst.typ === Kw || fst.typ === Binary
        length(fst.nodes) > 0 && ends_with_macro_or_global(fst[end])
    else
        false
    end
end
function skip_trailing_comma(fst::FST)
    prev_node = fst[end]
    return if is_comma(prev_node) && fst.typ === TupleN && n_args(fst) == 1
        # e.g. `(x,)` -- removing the comma changes the meaning
        true
    elseif (
        prev_node.typ === Generator ||
        prev_node.typ === Filter ||
        prev_node.typ === Flatten ||
        prev_node.typ === SEMICOLON ||
        prev_node.typ === HASHEQCOMMENT ||
        # Things that end with macros can't have a trailing comma inserted after them
        # as that causes Julia to fail to parse.
        # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/1017
        ends_with_macro_or_global(prev_node)
    )
        true
    else
        false
    end
end

"""
    add_node!(
        t::FST,
        n::FST,
        s::State;
        join_lines::Bool = false,
        max_padding::Int = -1,
        override_join_lines_based_on_source::Bool = false,
    )

Appends `n` to `t`.

- `join_lines`: if `true`, `n` is placed on the same line as the previous node. If `false`
  (the default), a NEWLINE is inserted before `n` so it appears on the next line.

- `max_padding`: controls how `n`'s length contributes to `t.len`, if `n` is not the first
  node being added.

  - When negative (the default), `n`'s length is added: `t.len += length(n)`. This is
    appropriate for nodes that continue the current line (e.g. an argument in a call).

  - When non-negative, we calculate `npad = length(n) + max_padding` (i.e., the horizontal
    extent of `n` plus some specified padding) and set `t.len = max(t.len, npad)`. For
    example, in `p_if`, when adding the `if`/`elseif`/`else` keywords, we use `max_padding =
    0`. This means that that `t.len` extends only up to the end of the keyword. That's
    because the keyword starts a new line and we don't want it to inflate the length of the
    parent.

  For the first node that's added, it always contributes its full length to `t.len`
  regardless of the value of `max_padding`.

- `override_join_lines_based_on_source`: when the `join_lines_based_on_source` option is
  `true`, this flag overrides it so that `n` is added as if `join_lines_based_on_source`
  were `false`.
"""
function add_node!(
    t::FST,
    n::FST,
    s::State;
    join_lines::Bool = false,
    max_padding::Int = -1,
    override_join_lines_based_on_source::Bool = false,
)
    tnodes = t.nodes::Vector{FST}

    if n.typ === NONE
        if length(tnodes::Vector{FST}) == 0
            t.startline = n.startline
            t.endline = n.endline
        end
        return
    end

    if n.typ === TRAILINGCOMMA
        en = (tnodes::Vector{FST})[end]
        if skip_trailing_comma(t)
            # do not insert trailing comma
            false
        elseif s.opts.trailing_comma === nothing
            # preserve original source code
            false
        elseif !s.opts.trailing_comma::Bool
            # remove preexisting comma in FST
            if is_comma(en)
                t[end] = Whitespace(0)
            end
        elseif is_comma(en)
            t[end] = n
        elseif en.typ === Parameters && length(en.nodes) > 0 && is_comma(en[end])
            en[end] = n
        elseif en.typ === Parameters && length(en.nodes) > 0 && en[end].typ === SEMICOLON
            # do nothing
        else
            t.len += length(n)
            n.startline = t.endline
            n.endline = t.endline
            push!(tnodes::Vector{FST}, n)
        end
        return
    elseif n.typ === NOTCODE
        n.indent = s.indent
        push!(tnodes::Vector{FST}, n)
        return
    elseif n.typ === INLINECOMMENT
        push!(tnodes::Vector{FST}, n)
        return
    elseif is_custom_leaf(n) && n.typ !== HASHEQCOMMENT
        t.len += length(n)
        # Treat the node as extending the line of the previous node (...?)
        n.startline = t.endline
        n.endline = t.endline
        push!(tnodes::Vector{FST}, n)
        return
    end

    if n.typ === Block && length(n) == 0
        push!(tnodes::Vector{FST}, n)
        return
    elseif s.opts.import_to_using && n.typ === Import && can_transform_syntax(s, true)
        usings = import_to_usings(n, s)
        if length(usings) > 0
            for (i, nn) in enumerate(usings)
                # The first using replaces the original import, so it should
                # inherit the caller's join_lines (e.g. stay on the same line
                # in `@eval import Foo` -> `@eval using Foo: Foo`).
                # Subsequent usings always start on a new line.
                jl = i == 1 ? join_lines : false
                if !jl && length(tnodes) > 0 && (tnodes[end]::FST).typ === WHITESPACE
                    tnodes[end]::FST = Whitespace(0)
                end
                add_node!(t, nn, s; join_lines = jl, max_padding = 0)
            end
            return
        end
    elseif n.typ === Binary && n[1].typ === Binary && n[1][end].typ === Where
        # normalize FST representation for Where
        binaryop_to_whereop!(n, s)
    end

    # Handle whitespace around HASHEQCOMMENT nodes.
    if n.typ === HASHEQCOMMENT && !isempty(tnodes)
        if t.endline >= n.startline
            # The comment is on the same line as the previous node in the source
            # (e.g. `a #= hi =#`). Force join to keep it there.
            join_lines = true
        elseif max_padding == -1
            # The caller didn't explicitly request a new line (max_padding = -1 is the
            # default, used by e.g. add_hasheq_comment! and the hcat handler). Force
            # join_lines = true to preserve the old behavior for those call sites.
            join_lines = true
        end
        # Add a space before a `#= =#` comment to avoid it being
        # glued to the previous node when printed, but only when the comment
        # stays on the same line (join_lines = true).
        #
        # TODO(penelopeysm): The PLACEHOLDER check catches cases where there is a
        # Placeholder(1) before the comment, which can be turned into a Whitespace(1).
        # I'm not sure if this check is therefore overly broad since it also catches
        # Placeholder(0) nodes.
        if join_lines
            nt = (tnodes[end]::FST).typ
            if nt !== WHITESPACE &&
               nt !== NEWLINE &&
               nt !== PLACEHOLDER &&
               !is_opener(tnodes[end])
                add_node!(t, Whitespace(1), s)
            end
        end
    end

    if length(tnodes::Vector{FST}) == 0
        t.startline = n.startline
        t.endline = n.endline
        t.len += length(n)
        t.line_offset = n.line_offset
        push!(tnodes, n)
        return
    end

    # if `max_padding` >= 0 `n` should appear on the next line
    # even if it's contrary to the original source.
    if s.opts.join_lines_based_on_source &&
       !override_join_lines_based_on_source &&
       max_padding == -1 &&
       !(
           n.typ === SEMICOLON ||
           is_comma(n) ||
           is_block(t) ||
           t.typ === FunctionN ||
           t.typ === Macro ||
           is_typedef(t) ||
           t.typ === ModuleN ||
           t.typ === BareModule ||
           is_end(n)
       )
        # join based on position in original file
        join_lines = t.endline == n.startline
    end

    # Keep a space after an inline `#= =#` comment when the following code stays on the
    # same line (e.g. `f(x, #= c =# z)`), instead of gluing them together.
    if join_lines &&
       (tnodes[end]::FST).typ === HASHEQCOMMENT &&
       !is_closer(n) &&
       !is_comma(n) &&
       n.typ !== SEMICOLON
        add_node!(t, Placeholder(1), s)
    end

    if !is_prev_newline(tnodes[end]::FST)
        current_line = t.endline
        notcode_startline = current_line + 1
        notcode_endline = n.startline - 1
        nt = (tnodes[end]::FST).typ

        if notcode_startline <= notcode_endline
            # If there are comments in between node elements
            # nesting is forced in an effort to preserve them.

            rm_block_nl =
                s.opts.remove_extra_newlines &&
                t.typ !== ModuleN &&
                (n.typ === Block || is_end(n))

            # Force nesting
            nest = true
            # Unless it's not worth nesting (e.g., inside a function call, or binary op)
            if remove_empty_notcode(t) || rm_block_nl
                nest = false
                # ... Unless there are comments, in which case we can't nest
                for l in notcode_startline:notcode_endline
                    if hascomment(s.doc, l)
                        nest = true
                        break
                    end
                end
            end
            if nest || hascomment(s.doc, current_line)
                t.nest_behavior = AlwaysNest
            end

            # If the previous node type is WHITESPACE - reset it.
            # This fixes cases similar to the one shown in issue #51.
            if nt === WHITESPACE
                tnodes[end]::FST = Whitespace(0)
            end

            if hascomment(s.doc, current_line)
                add_node!(t, InlineComment(current_line), s)
            end

            # A newline is mandatory if we're about to emit a Notcode node or an inline
            # comment (both of which occupy the rest of the line), and it's what the caller
            # asked for if `join_lines` is false. Otherwise the caller wants `n` on the same
            # line as the previous node and the only thing in between is a blank line that
            # we are dropping anyway, so there is nothing to separate them with. For
            # example, YASStyle adds the closer of `[\n a,\n b,\n\n]` with
            # `override_join_lines_based_on_source = true` -- i.e. 'always glue `]` to the
            # last argument' -- and breaking the line here would strand it as `[a,\n b\n ]`.
            force_newline = !join_lines || nest || hascomment(s.doc, current_line)

            if nt !== PLACEHOLDER && force_newline
                add_node!(t, Newline(; nest_behavior = AlwaysNest), s)
            elseif hascomment(s.doc, current_line) && nt === PLACEHOLDER
                # swap PLACEHOLDER (will be NEWLINE) with INLINECOMMENT node
                idx = length(tnodes::Vector{FST})
                tnodes[idx-1], tnodes[idx] = tnodes[idx], tnodes[idx-1]
            elseif !join_lines
                # We know that `n` belongs on its own line, but we are not adding a Notcode
                # node (which would come with its own NEWLINE), so unless we do something
                # here the only thing separating `n` from the previous node is the
                # PLACEHOLDER. That relies on the nesting pass later converting that
                # PLACEHOLDER into a NEWLINE, which is not guaranteed: with
                # `join_lines_based_on_source` (MinimalStyle, YAS, SciML) placeholders are
                # only converted when the margin is exceeded (see `nest_if_over_margin!`),
                # so the placeholder survives and `n` gets glued onto the previous line.
                # Emit the NEWLINE explicitly -- exactly as the `!join_lines` branch below
                # does when there is no blank line to divert us into this branch.
                #
                # Without this, the blank lines in
                #
                #     [               f(              [a
                #         a,              a,
                #         b,          )               b]
                #                                     ^ two-element vcat
                #     ]
                #
                # respectively produce `[\n a,\n b,]`, `f(\n a,)` and `[a b]` (a 1x2 hcat!),
                # instead of just being dropped. Likewise
                #
                #     [a
                #         []
                #                    <- blank line
                #     if b
                #         c
                #     end
                #     ]
                #
                # glues `[]` and `if b` together.
                add_node!(t, Newline(; nest_behavior = AlwaysNest), s)
            end

            if nest
                add_node!(t, Notcode(notcode_startline, notcode_endline), s)
                add_node!(t, Newline(; nest_behavior = AlwaysNest), s)
            end
        elseif !join_lines
            if hascomment(s.doc, current_line) && current_line != n.startline
                add_node!(t, InlineComment(current_line), s)
            end
            add_node!(t, Newline(; nest_behavior = AlwaysNest), s)
        elseif nt === PLACEHOLDER &&
               current_line != n.startline &&
               hascomment(s.doc, current_line)
            t.nest_behavior = AlwaysNest
            add_node!(t, InlineComment(current_line), s)
            # swap PLACEHOLDER (will be NEWLINE) with INLINECOMMENT node
            idx = length(tnodes)
            tnodes[idx-1], tnodes[idx] = tnodes[idx], tnodes[idx-1]
        elseif hascomment(s.doc, current_line) && current_line != n.startline
            if nt === WHITESPACE
                # Avoid printing excess whitespace before the comment, since
                # print_inlinecomment will handle the spacing before the comment.
                tnodes[end] = Whitespace(0)
            end
            add_node!(t, InlineComment(current_line), s)
            add_node!(t, Newline(; nest_behavior = AlwaysNest), s)
        end
    end

    if n.startline < t.startline || t.startline == 0
        t.startline = n.startline
    end
    if n.endline > t.endline || t.endline == 0
        t.endline = n.endline
    end

    if !join_lines && is_end(n)
        # end keyword isn't useful w.r.t margin lengths
    elseif t.typ === StringN
        if !s.opts.v2_stable_multiline_strings
            # The length of this node is the length of the longest string. The length of the
            # string is only considered "in the positive" when it's past the hits the
            # initial """ offset, i.e. `t.indent`.
            t.len = max(t.len, n.indent + length(n) - t.indent)
        else
            # Only the first line (the opening `"""`) contributes to the parent's line
            # width. Note that the first line will be the first node that's added to the
            # StringN FST, so its width will be added in the part above which checks
            #
            #    if length(tnodes::Vector{FST}) == 0 ... end
            #
            # Using only the first-line width makes `len` independent of the string's
            # indentation context, which prevents idempotence bugs where shifting the string
            # changes its `len`, which changes ancestor nesting decisions.
            false
        end
    elseif is_multiline(n) ||
           (!isnothing(t.metadata) && (t.metadata::Metadata).has_multiline_argument)
        if isnothing(t.metadata)
            t.metadata = Metadata(K"None", false, false, false, false, true, true, false)
        else
            metadata = t.metadata::Metadata
            t.metadata = Metadata(
                metadata.op_kind,
                metadata.is_standalone_shortcircuit,
                metadata.is_expandable_shortcircuit,
                metadata.is_short_form_function,
                metadata.is_assignment,
                metadata.is_contractable_function,
                true,
                metadata.is_opaque_string,
            )
        end
        if is_iterable(t) && n_args(t) > 1
            t.nest_behavior = AlwaysNest
        end
        t.len += length(n)
    elseif max_padding >= 0
        t.len = max(t.len, length(n) + max_padding)
    else
        t.len += length(n)
    end

    if n.typ === Parameters
        if n.nest_behavior === AlwaysNest
            t.nest_behavior = n.nest_behavior
        end
        # no args before kwargs
        placeholder_ind = findfirst(n -> n.typ === PLACEHOLDER, tnodes)
        if placeholder_ind == length(tnodes)
            t[placeholder_ind] = Whitespace(0)
        end
        for nn in n.nodes
            push!(tnodes, nn)
            if n.startline < t.startline || t.startline == 0
                t.startline = n.startline
            end
            if n.endline > t.endline || t.endline == 0
                t.endline = n.endline
            end
        end
        return
    end

    push!(tnodes, n)
    return
end

struct FormatSkip
    startline::Int
    endline::Int
    startoffset::Int
    endoffset::Int
end

struct Document
    srcfile::JuliaSyntax.SourceFile
    format_skips::Vector{FormatSkip}
    # Line where there's a noindent comment. "#! format: noindent". This is checked during
    # the print stage to know if the contents of the block (recursive) should not be indented.
    noindent_blocks::Vector{Int}

    comments::Dict{Int,Tuple{Int,String}}

    ends_on_nl::Bool
end

function Document(text::AbstractString)
    format_skips = FormatSkip[]
    noindent_blocks = Int[]
    stack = Tuple{Int,Int}[]
    comments = Dict{Int,Tuple{Int,String}}()

    srcfile = JuliaSyntax.SourceFile(text)
    tokens = JuliaSyntax.tokenize(text)

    ends_on_nl = kind(tokens[end]) === K"NewlineWs"

    for (i, t) in enumerate(tokens)
        if kind(t) === K"Comment"
            ws = 0
            if i > 1 &&
               (kind(tokens[i-1]) === K"Whitespace" || kind(tokens[i-1]) === K"NewlineWs")
                pt = tokens[i-1]
                prevval = try
                    srcfile.code[first(pt.range):last(pt.range)]
                catch e
                    if isa(e, StringIndexError)
                        srcfile.code[first(pt.range):prevind(text, last(pt.range))]
                    else
                        rethrow(e)
                    end
                end

                idx = findlast(c -> c == '\n', prevval)
                if idx === nothing
                    idx = 1
                end
                ws = count(c -> c == ' ', prevval[idx:end])
            end

            startline = JuliaSyntax.source_line(srcfile, first(t.range))
            endline = JuliaSyntax.source_line(srcfile, last(t.range))
            val = try
                srcfile.code[first(t.range):last(t.range)]
            catch
                srcfile.code[first(t.range):prevind(srcfile.code, last(t.range))]
            end

            if startswith(val, "#=") && endswith(val, "=#")
                # Block comments (#= ... =#) are handled as HASHEQCOMMENT FST
                # nodes in p_comment(), so we don't store them in the dict.
            elseif startline == endline
                comments[startline] = (ws, val)
            else
                # multiline comment
                idx = findfirst(x -> x == '\n', val)::Int + 1
                fc2 = findfirst(c -> !isspace(c), val[idx:end])

                lr = JuliaSyntax.source_line_range(srcfile, first(t.range))
                lineoffset = (first(t.range) - lr[1]) + 1
                ws2 = fc2 === nothing || lineoffset < fc2 ? ws : max(ws, fc2 - 1)

                line = startline
                cs = ""
                for (i, c) in enumerate(val)
                    cs *= c
                    if c == '\n'
                        fc = findfirst(c -> !isspace(c), cs)
                        if fc === nothing
                            # comment is all whitespace
                            comments[line] = (ws, cs[end:end])
                        else
                            idx = min(fc, ws + 1)
                            comments[line] = (ws, cs[idx:end])
                        end
                        line += 1
                        ws = ws2
                        cs = ""
                    end
                end
                # last comment
                idx = min(findfirst(c -> !isspace(c), cs)::Int, ws + 1)
                comments[line] = (ws, cs[idx:end])
            end

            if length(stack) == 0 && occursin(r"^#!\s*format\s*:\s*off\s*$", val)
                # There should not be more than 1
                # "off" tag on the stack at a time.
                offset = first(t.range)
                r = JuliaSyntax.source_line_range(srcfile, offset)
                line = JuliaSyntax.source_line(srcfile, offset)
                push!(stack, (line, first(r)))
            elseif length(stack) > 0 && occursin(r"^#!\s*format\s*:\s*on\s*$", val)
                # If "#! format: off" has not been seen
                # "#! format: on" is treated as a normal comment.
                offset = last(t.range)
                r = JuliaSyntax.source_line_range(srcfile, offset)
                line = JuliaSyntax.source_line(srcfile, offset)
                v = pop!(stack)
                push!(format_skips, FormatSkip(v[1], line, v[2], last(r)))
            end
            if occursin(r"^#!\s*format\s*:\s*noindent\s*$", val)
                line = JuliaSyntax.source_line(srcfile, first(t.range))
                push!(noindent_blocks, line)
            end
        elseif kind(t) === K"ErrorEofMultiComment"
            l = JuliaSyntax.source_line(srcfile, first(t.range))
            throw(
                ErrorException(
                    """Unable to format. Multi-line comment on line $l is not closed.""",
                ),
            )
        end
    end

    # If there is a SINGLE "#! format: off" tag
    # do not format from the "off" tag onwards.
    if length(stack) == 1 && length(format_skips) == 0
        # -1 signifies everything afterwards "#! format: off"
        # will not formatted.
        v = pop!(stack)
        line = numlines(srcfile)
        r = JuliaSyntax.source_line_range(srcfile, srcfile.line_starts[line])
        push!(format_skips, FormatSkip(v[1], line, v[2], last(r)))
    end

    return Document(srcfile, format_skips, noindent_blocks, comments, ends_on_nl)
end

function has_noindent_block(d::Document, r::Tuple{Int,Int})
    for b in d.noindent_blocks
        if b in r
            return true
        end
    end
    return false
end

numlines(sf::JuliaSyntax.SourceFile) = length(sf.line_starts) - 1
numlines(d::Document) = numlines(d.srcfile)

function getsrcval(d::Document, r::UnitRange{T}) where {T<:Union{Int,UInt}}
    code = JuliaSyntax.sourcetext(d.srcfile)
    try
        code[r]
    catch
        code[first(r):prevind(code, last(r))]
    end
end

module TrailingCommaTests

using JuliaFormatter: DefaultStyle, YASStyle, BlueStyle, SciMLStyle, MinimalStyle, format_text
using JuliaFormatter.Internal: test_format
using Test

@testset "trailing_comma" begin
    @testset "remove trailing comma" begin
        for str_ in (
            "funccall(arg1, arg2, arg3,)",
            "funccall(arg1, arg2, arg3)",
        )
            str = """
            funccall(
                arg1,
                arg2,
                arg3
            )"""
            test_format(str_, str; margin=1, trailing_comma = false)
        end

        str_ = "funccall(arg1, arg2, arg3,)"
        str = "funccall(arg1, arg2, arg3)"
        test_format(str_, str; trailing_comma = false)
    end

    @testset "doesn't change tuples" begin
        str_ = "(tuple,)"
        str = """
        (
            tuple,
        )"""
        test_format(str_, str; margin=1, trailing_comma = true)
        test_format(str_, str; margin=1, trailing_comma = false)
        test_format(str_, str; indent=4, margin=1, trailing_comma = nothing)
    end

    @testset "trailing_comma=nothing" begin
        str = """
        funccall(
            arg1,
            arg2,
            arg3
        )"""
        str_ = "funccall(arg1, arg2, arg3)"
        test_format(str_, str; indent=4, margin=1, trailing_comma = nothing)

        # last comma is stays
        str_ = "funccall(arg1, arg2, arg3,)"
        str = """
        funccall(
            arg1,
            arg2,
            arg3,
        )"""
        test_format(str_, str; indent=4, margin=1, trailing_comma = nothing)
        test_format(str_, str_; indent=4, margin=100, trailing_comma = nothing)
    end

    @testset "YASStyle" begin
        # Ordinarily with YAS, the closing paren is placed on the same line as the last
        # argument, meaning that there are no trailing commas. But if the last argument is
        # followed by a comment, the closing paren will be on the next line, and a trailing
        # comma should be added (or to be precise, the `trailing_comma` option should be
        # respected).
        s1 = """
        f(aaaaaaa,
          bbbbbbbbb,
          ccccccccc # comment
        )"""
        s1 = """
        f(aaaaaaa,
          bbbbbbbbb,
          ccccccccc, # comment
          )"""
        test_format(s1, s1, YASStyle(); margin=2)

        s2_ = """
        f(aaaaaaa,
          bbbbbbbbb,
          ccccccccc
        )"""
        s2 = """
        f(aaaaaaa,
          bbbbbbbbb,
          ccccccccc)"""
        test_format(s2_, s2, YASStyle(); margin=2)
    end
end

end # module

options(::DefaultStyle) = Options()

@kwdef struct PrettyContext
    # If true, ensure that no whitespace is added around binary operators.
    # In general, this can be inferred from the source. However, this is
    # overridden specifically for macro keyword arguments in SciML style.
    # See https://github.com/SciML/SciMLStyle/tree/3f6fa61c6cc6fcf1c23177fab187d0c85197acfc#macros
    nospace::Bool = false

    nonest::Bool = false
    standalone_binary_circuit::Bool = true
    from_typedef::Bool = false
    from_let::Bool = false
    from_ref::Bool = false
    from_colon::Bool = false
    from_for::Bool = false

    # These two flags are used to compensate for weird structure of ncat and nrow
    # nodes in JuliaSyntax. See p_ncat for more info
    #
    # indicates whether newlines inside are semantically meaningful
    from_nrow::Bool = false
    # indicates whether newlines at the end are semantically meaningful
    is_last_ncat_or_nrow_arg::Bool = false

    # indicates whether the caller in a function definition has been parenthesised
    # see p_call for explanation
    is_parenthesised_caller::Bool = false

    ignore_single_line::Bool = false
    from_quote::Bool = false
    join_body::Bool = false
    from_module::Bool = false
    from_docstring::Bool = false

    # Indicates a context in which we are allowed to rewrite f(x, y=z) to f(x; y=z).
    # This is disabled in macros as well as in function definitions.
    can_separate_kwargs::Bool = true
end

function newctx(s::PrettyContext; kwargs...)
    fields = fieldnames(PrettyContext)
    values = map(field -> get(kwargs, field, getfield(s, field)), fields)
    PrettyContext(values...)
end

"""
    source_op_kind_from_offset(s, cst, offset)::Union{Nothing,JuliaSyntax.Kind}

Return the operator kind of `cst`, using the source text at `offset` if necessary to help
determine this. If `cst` is not an operator, returns `nothing`.

Note that this function may still return a K"Identifier"! This is because Julia allows some
weird postfix operators. See the comments in the function for more info.

The check against the source is needed because JuliaSyntax v1 can encode source operators as
Identifier leaves in call forms. For example:

```julia
julia> JuliaSyntax.parseall(JuliaSyntax.GreenNode, "+y")
     1:2      │[toplevel]
     1:2      │  [call]
     1:1      │    Identifier           ✔
     2:2      │    Identifier           ✔
```

See https://github.com/JuliaLang/JuliaSyntax.jl/issues/548 for more information.
"""
function source_op_kind_from_offset(s::State, cst::JuliaSyntax.GreenNode, offset::Integer)
    return if JuliaSyntax.is_operator(cst) && !haschildren(cst)
        # Already have the right kind stored in the GreenNode
        kind(cst)
    elseif kind(cst) === K"Identifier" && !haschildren(cst)
        # The operator was reduced to an Identifier (this happens in JuliaSyntax v1).
        # Attempt to recover the original kind from the source.
        span(cst) == 0 && return nothing
        source_text = getsrcval(s.doc, offset:(offset+span(cst)-1))
        try
            # Parse the source text and check whether it's a valid operator.
            k = JuliaSyntax.Kind(source_text)
            return if JuliaSyntax.is_operator(k)
                # This is the happy path. It's hit for things like e.g. "+x".
                k
            else
                # There are a lot of Identifiers which can be parsed as kinds, but aren't
                # operators. For example, the `string` in `string(x)` will be converted to
                # K"string" here, which is totally not what we want. Hence we return
                # nothing.
                nothing
            end
        catch
            # There are some operators for which JuliaSyntax does not actually have a
            # dedicated kind. For example, `a'ᵀ` is a postfix operator `'ᵀ`, and
            # JuliaSyntax.is_postfix_op_call will correctly return true. Specifically, the '
            # postfix operator can be followed by any Unicode modifier:
            # https://github.com/JuliaLang/julia/pull/37247
            #
            # However, the operator is stored as Identifier and calling Kind("'ᵀ") throws an
            # error. We catch such instances here. Thankfully, Base gives us a function
            # (albeit unexported) to detect these. If this function returns K"Identifier",
            # then we know that it's one of these odd postfix operators.
            return if kind(cst) === K"Identifier" && Base.ispostfixoperator(source_text)
                K"Identifier"
            else
                nothing
            end
        end
    else
        # Can't be an operator at all
        nothing
    end
end

"""
    first_nonws_leaf_and_offset(
        node::JuliaSyntax.GreenNode,
    )::Union{Nothing,Tuple{JuliaSyntax.GreenNode,Int}

Return the first non-whitespace leaf node in `node` plus its offset from the beginning of
`node`, or `nothing` if there are no non-whitespace leaves.
"""
function first_nonws_leaf_and_offset(
    node::JuliaSyntax.GreenNode,
    # Callers should not set _acc, this is only used in this function to recurse
    _acc::Integer = 0,
)::Union{Nothing,Tuple{JuliaSyntax.GreenNode,Int}}
    if JuliaSyntax.is_leaf(node)
        return JuliaSyntax.is_whitespace(node) ? nothing : (node, _acc)
    end
    # Recursively search children
    for c in children(node)
        result = first_nonws_leaf_and_offset(c, _acc)
        if result !== nothing
            return result
        end
        _acc += span(c)
    end
    return nothing
end

"""
   source_begins_with_op_needing_parens(s, cst, offset) 

Check whether the first token of `cst` is an operator. Used in `p_kw`: if the value on the
rhs of `kwarg=value` begins with an operator, then we parenthesise `value` to avoid
ambiguity.

Note that the behaviour of this differs from `unary_info(cst)`: for example,
`unary_info(cst)` does not pick up  expressions such as `>=(1)`, which is interpreted as a
function call, not an application of a unary operator. However, these are exactly the sort
of things that we want to parenthesise in `p_kw` -- hence this function.
"""
function source_begins_with_op_needing_parens(
    s::State,
    cst::JuliaSyntax.GreenNode,
    offset::Integer,
)
    # Get the first leaf of `cst` that isn't whitespace.
    result = first_nonws_leaf_and_offset(cst)
    result === nothing && return false
    # Check if it's an operator and specifically one that we care about putting
    # parentheses around.
    leaf, extra_offset = result
    opkind = source_op_kind_from_offset(s, leaf, offset + extra_offset)
    return (
        opkind !== nothing &&
        JuliaSyntax.is_operator(opkind)
        # is_word_operator filters out things like `isa`.
        &&
        !JuliaSyntax.is_word_operator(opkind)
        # Ignore `K":"` as that indicates the beginning of a symbol, which we don't care
        # about parenthesising.
        &&
        opkind !== K":"
    )
end

function is_source_operator(s::State, cst::JuliaSyntax.GreenNode, offset::Integer)
    # TODO(penelopeysm): do we need to check JuliaSyntax.is_operator as well?
    !isnothing(source_op_kind_from_offset(s, cst, offset))
end

function source_unary_operator_index(is_prefix::Bool, cst::JuliaSyntax.GreenNode, s::State)
    if !haschildren(cst) ||
       !(JuliaSyntax.is_operator(cst) || kind(cst) in KSet"call dotcall")
        return nothing
    end

    childs = children(cst)
    args = findall(n -> !JuliaSyntax.is_whitespace(n), childs)
    isempty(args) && return nothing

    op_arg = if is_prefix
        if (
            kind(cst) === K"dotcall" &&
            length(args) >= 2 &&
            kind(childs[args[1]]) === K"." &&
            !haschildren(childs[args[1]])
        )
            # e.g. `.+x`
            args[2]
        else
            # e.g. `+x`
            args[1]
        end
    else
        # postfix operator
        args[end]
    end
    offset = s.offset + sum(span, childs[1:(op_arg-1)]; init = 0)
    return is_source_operator(s, childs[op_arg], offset) ? op_arg : nothing
end

function source_operator_indices(cst::JuliaSyntax.GreenNode)
    haschildren(cst) || return Int[]

    childs = children(cst)
    args = findall(n -> !JuliaSyntax.is_whitespace(n), childs)
    nonws_args = length(args)
    nonws_args == 0 &&
        error("no non-whitespace children found for operator node; should not happen")

    if kind(cst) === K"op="
        # 4 args for `x += y`, 5 args for `x .+= y` (the dot is preserved as a
        # flag in JuliaSyntax but the kind is the same).
        (nonws_args == 4 || nonws_args == 5) ||
            error("unexpected number of args for op= node", nonws_args, cst)
        return args[2:(end-1)]
    elseif kind(cst) === K"comparison"
        # `x < y < z < ... < w` has `2n - 1` args where `n >= 2`.
        (iseven(nonws_args) || nonws_args < 3) &&
            error("unexpected number of args for comparison node", nonws_args, cst)
        return args[2:2:(end-1)]
    elseif is_short_function_def(cst)
        nonws_args != 3 && error(
            "unexpected number of args for short function definition node",
            nonws_args,
            cst,
        )
        return Int[args[2]]
    elseif JuliaSyntax.is_operator(cst)
        nonws_args != 3 &&
            error("unexpected number of args for operator node", nonws_args, cst)
        return args[2:(end-1)]
    elseif JuliaSyntax.is_prefix_op_call(cst)
        if kind(cst) === K"dotcall" &&
           length(args) >= 2 &&
           kind(childs[args[1]]) === K"." &&
           !haschildren(childs[args[1]])
            return args[1:2]
        else
            return Int[args[1]]
        end
    elseif JuliaSyntax.is_infix_op_call(cst)
        op_indices = Int[]
        i = 2
        while i < length(args)
            push!(op_indices, args[i])
            if kind(cst) === K"dotcall" &&
               i < length(args) &&
               kind(childs[args[i]]) === K"." &&
               !haschildren(childs[args[i]])
                push!(op_indices, args[i+1])
                i += 1
            end
            i += 2
        end
        return op_indices
    elseif JuliaSyntax.is_postfix_op_call(cst)
        return Int[args[end]]
    end

    return Int[]
end

function source_op_kind(s::State, cst::JuliaSyntax.GreenNode)
    opkind = op_kind(cst)
    opkind !== K"None" && opkind !== K"Identifier" && return opkind

    childs = children(cst)
    for i in source_operator_indices(cst)
        c = childs[i]
        offset = Int(s.offset) + sum(span, childs[1:(i-1)]; init = 0)
        k = source_op_kind_from_offset(s, c, offset)
        if !isnothing(k) && !(kind(cst) === K"dotcall" && k === K".")
            return k
        end
    end
    return opkind
end

function do_block_index(childs::Vector{JuliaSyntax.GreenNode{T}}) where {T}
    findfirst(n -> kind(n) === K"do" && haschildren(n), childs)
end

function has_do_block_call(cst::JuliaSyntax.GreenNode)
    kind(cst) in KSet"call dotcall macrocall" && haschildren(cst) || return nothing
    do_block_index(children(cst))
end

function call_args(childs::Vector{JuliaSyntax.GreenNode{T}}) where {T}
    idx = findfirst(n -> kind(n) in KSet"( { [", childs)
    start = isnothing(idx) ? 1 : idx + 1
    get_args(childs[start:end])
end

function last_code_child(cst::JuliaSyntax.GreenNode)
    haschildren(cst) || return nothing
    idx = findlast(n -> !JuliaSyntax.is_whitespace(n), children(cst))
    isnothing(idx) ? nothing : children(cst)[idx]
end

function iteration_rhs(cst::JuliaSyntax.GreenNode)
    rhs = last_code_child(cst)
    if kind(cst) === K"iteration" && !isnothing(rhs) && haschildren(rhs)
        rhs = last_code_child(rhs)
    end
    rhs
end

function iteration_has_comma(cst::JuliaSyntax.GreenNode)
    haschildren(cst) && any(n -> kind(n) === K",", children(cst))
end

"""
    _with_no_transforms(f, s::State, new_status)

Run `f` with a modified state where syntax transformations may be disabled.
"""
function _with_no_transforms(f, s::State, new_status::SyntaxTransformsStatus)
    prev = s.syntax_transforms_status
    s.syntax_transforms_status = new_status
    ret = f()
    s.syntax_transforms_status = prev
    ret
end

function pretty(
    ds::AbstractStyle,
    node::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)::FST
    k = kind(node)
    style = getstyle(ds)
    do_block_idx = has_do_block_call(node)
    push!(lineage, (k, is_iterable(node), is_assignment(node)))

    _unaryinfo = unary_info(node)

    ret = if k == K"Identifier" && !haschildren(node)
        p_identifier(style, node, s, ctx, lineage)
        # Example: `try f() catch g() end` has a zero-width Placeholder
        # where a catch binding would appear.
    elseif k === K"Placeholder"
        s.offset += span(node)
        FST(NONE, 0, 0, 0, "")
    elseif JuliaSyntax.is_operator(node) && !haschildren(node)
        p_operator(style, node, s, ctx, lineage)
    elseif k == K"Comment"
        p_comment(style, node, s, ctx, lineage)
    elseif JuliaSyntax.is_whitespace(node)
        p_whitespace(style, node, s, ctx, lineage)
    elseif k == K";"
        p_semicolon(style, node, s, ctx, lineage)
    elseif is_punc(node) && !haschildren(node)
        p_punctuation(style, node, s, ctx, lineage)
    elseif JuliaSyntax.is_keyword(node) && !haschildren(node)
        p_keyword(style, node, s, ctx, lineage)
    elseif k in KSet"string cmdstring char"
        p_stringh(style, node, s, ctx, lineage)
    elseif JuliaSyntax.is_literal(node) || k in KSet"\" \"\"\" ` ```"
        p_literal(style, node, s, ctx, lineage)
    elseif k == K"as"
        p_as(style, node, s, ctx, lineage)
    elseif k === K"." && haschildren(node)
        p_accessor(style, node, s, ctx, lineage)
    elseif k === K"block" && length(children(node)) > 1 && kind(node[1]) === K"begin"
        p_begin(style, node, s, ctx, lineage)
    elseif k === K"block"
        p_block(style, node, s, ctx, lineage)
        # Example: `f(x) = x` is a function node flagged as short-form.
    elseif is_short_function_def(node)
        p_binaryopcall(style, node, s, ctx, lineage)
    elseif k === K"function"
        p_functiondef(style, node, s, ctx, lineage)
    elseif k in KSet"MacroName StringMacroName CmdMacroName"
        p_macroname(style, node, s, ctx, lineage)
    elseif k === K"macro"
        p_macro(style, node, s, ctx, lineage)
    elseif k === K"struct" && !JuliaSyntax.has_flags(node, JuliaSyntax.MUTABLE_FLAG)
        p_struct(style, node, s, ctx, lineage)
    elseif k === K"struct" && JuliaSyntax.has_flags(node, JuliaSyntax.MUTABLE_FLAG)
        p_mutable(style, node, s, ctx, lineage)
    elseif k === K"for"
        p_for(style, node, s, ctx, lineage)
    elseif k === K"while"
        p_while(style, node, s, ctx, lineage)
    elseif k === K"do"
        p_do(style, node, s, ctx, lineage)
    elseif k === K"var"
        p_var(style, node, s, ctx, lineage)
    elseif is_try(node) ||
           # issue #912
           (k === K"else" && !isnothing(lineage) && lineage[end-1][1] === K"try")
        p_try(style, node, s, ctx, lineage)
    elseif is_if(node)
        p_if(style, node, s, ctx, lineage)
    elseif k === K"toplevel"
        p_toplevel(style, node, s, ctx, lineage)
    elseif k === K"quote" && haschildren(node) && kind(node[1]) === K":"
        _with_no_transforms(s, InsideExpr) do
            p_quotenode(style, node, s, ctx, lineage)
        end
    elseif k === K"quote" && haschildren(node)
        _with_no_transforms(s, InsideExpr) do
            p_quote(style, node, s, ctx, lineage)
        end
    elseif k === K"let"
        p_let(style, node, s, ctx, lineage)
    elseif k === K"vect"
        p_vect(style, node, s, ctx, lineage)
    elseif k === K"comprehension"
        p_comprehension(style, node, s, ctx, lineage)
    elseif k === K"typed_comprehension"
        p_typedcomprehension(style, node, s, ctx, lineage)
    elseif k === K"braces"
        p_braces(style, node, s, ctx, lineage)
    elseif k === K"bracescat"
        p_bracescat(style, node, s, ctx, lineage)
    elseif k === K"tuple"
        p_tuple(style, node, s, ctx, lineage)
        # Example: `for x in xs, y in ys` uses an iteration node.
    elseif k === K"iteration"
        p_iteration(style, node, s, ctx, lineage)
    elseif k === K"parens"
        p_parens(style, node, s, ctx, lineage)
    elseif k === K"curly"
        p_curly(style, node, s, ctx, lineage)
    elseif is_macrostr(node)
        p_macrostr(style, node, s, ctx, lineage)
    elseif k === K"doc"
        p_globalrefdoc(style, node, s, ctx, lineage)
    elseif k === K"macrocall"
        _with_no_transforms(s, InsideMacro) do
            if !isnothing(do_block_idx)
                p_do_call(style, node, s, ctx, lineage, do_block_idx)
            else
                p_macrocall(style, node, s, ctx, lineage)
            end
        end
    elseif k === K"where"
        p_whereopcall(style, node, s, ctx, lineage)
    elseif k === K"?" && haschildren(node)
        p_conditionalopcall(style, node, s, ctx, lineage)
    elseif !isnothing(do_block_idx)
        # Example: `map(xs) do x; x + 1; end` is a call node with a do child.
        p_do_call(style, node, s, ctx, lineage, do_block_idx)
    elseif _unaryinfo !== nothing
        # _unaryinfo === nothing means that it's not unary; true/false indicates whether
        # it's a prefix/postfix.
        p_unaryopcall(style, node, s, ctx, lineage, _unaryinfo)
    elseif Shims.is_function_call(node)
        p_call(style, node, s, ctx, lineage)
    elseif is_binary(node)
        # nodes of the exact form `a OP b`
        p_binaryopcall(style, node, s, ctx, lineage)
    elseif is_chain(node)
        p_chainopcall(style, node, s, ctx, lineage)
    elseif k === K"comparison"
        p_comparison(style, node, s, ctx, lineage)
    elseif k in KSet"dotcall call"
        p_binaryopcall(style, node, s, ctx, lineage)
    elseif k === K"parameters"
        p_parameters(style, node, s, ctx, lineage)
    elseif k === K"local"
        p_local(style, node, s, ctx, lineage)
    elseif k === K"global"
        p_global(style, node, s, ctx, lineage)
    elseif k === K"const"
        p_const(style, node, s, ctx, lineage)
    elseif k === K"return"
        p_return(style, node, s, ctx, lineage)
    elseif k === K"outer"
        p_outer(style, node, s, ctx, lineage)
    elseif k === K"import"
        p_import(style, node, s, ctx, lineage)
    elseif k === K"export"
        p_export(style, node, s, ctx, lineage)
    elseif k === K"public"
        p_public(style, node, s, ctx, lineage)
    elseif k === K"using"
        p_using(style, node, s, ctx, lineage)
    elseif k === K"importpath"
        p_importpath(style, node, s, ctx, lineage)
    elseif k === K"abstract"
        p_abstract(style, node, s, ctx, lineage)
    elseif k === K"primitive"
        p_primitive(style, node, s, ctx, lineage)
        # Example: `baremodule A end` is a module node with BARE_MODULE_FLAG.
    elseif k === K"module" && JuliaSyntax.has_flags(node, JuliaSyntax.BARE_MODULE_FLAG)
        p_baremodule(style, node, s, ctx, lineage)
    elseif k === K"module"
        p_module(style, node, s, ctx, lineage)
    elseif k === K"baremodule"
        p_baremodule(style, node, s, ctx, lineage)
    elseif k === K"row"
        p_row(style, node, s, ctx, lineage)
    elseif k === K"nrow"
        p_nrow(style, node, s, ctx, lineage)
    elseif k === K"ncat"
        p_ncat(style, node, s, ctx, lineage)
    elseif k === K"typed_ncat"
        p_typedncat(style, node, s, ctx, lineage)
    elseif k === K"vcat"
        p_vcat(style, node, s, ctx, lineage)
    elseif k === K"typed_vcat"
        p_typedvcat(style, node, s, ctx, lineage)
    elseif k === K"hcat"
        p_hcat(style, node, s, ctx, lineage)
    elseif k === K"typed_hcat"
        p_typedhcat(style, node, s, ctx, lineage)
    elseif k === K"ref"
        p_ref(style, node, s, ctx, lineage)
    elseif k === K"generator"
        p_generator(style, node, s, ctx, lineage)
    elseif k === K"filter"
        p_filter(style, node, s, ctx, lineage)
    elseif k === K"juxtapose"
        p_juxtapose(style, node, s, ctx, lineage)
    elseif k === K"break"
        p_break(style, node, s, ctx, lineage)
    elseif k === K"continue"
        p_continue(style, node, s, ctx, lineage)
    elseif k === K"inert"
        p_inert(style, node, s, ctx, lineage)
    else
        @warn "unknown node" k node cursor_loc(s)
        if is_leaf(node)
            s.offset += span(node)
            FST(NONE, 0, 0, 0, "")
        else
            tt = FST(Unknown, nspaces(s))
            for a in children(node)
                add_node!(tt, pretty(style, a, s, ctx, lineage), s; join_lines = true)
            end
            tt
        end
    end

    pop!(lineage)

    return ret
end
pretty(style::AbstractStyle, node::JuliaSyntax.GreenNode, s::State)::FST =
    pretty(style, node, s, PrettyContext(), Tuple{JuliaSyntax.Kind,Bool,Bool}[])

function p_identifier(
    ::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    loc = cursor_loc(s)
    val = getsrcval(s.doc, (s.offset):(s.offset+span(cst)-1))
    s.offset += span(cst)
    FST(IDENTIFIER, loc[2], loc[1], loc[1], val)
end

function p_whitespace(
    ::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    loc = cursor_loc(s)
    val = getsrcval(s.doc, (s.offset):(s.offset+span(cst)-1))
    s.offset += span(cst)
    FST(NONE, loc[2], loc[1], loc[1], val)
end

function p_comment(
    ::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    loc = cursor_loc(s)
    same_line = on_same_line(s, s.offset, s.offset + span(cst) - 1)
    val = getsrcval(s.doc, (s.offset):(s.offset+span(cst)-1))
    s.offset += span(cst)
    return if startswith(val, "#=") && endswith(val, "=#")
        endloc = cursor_loc(s, s.offset - 1)
        FST(HASHEQCOMMENT, loc[2], loc[1], endloc[1], val)
    else
        # Line comments (`# ...`) are ignored for now but will be added back
        # later inside `add_node!`.
        FST(NONE, loc[2], loc[1], loc[1], "")
    end
end

function p_semicolon(
    ::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ::PrettyContext,
    ::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    loc = cursor_loc(s)
    s.offset += span(cst)
    FST(SEMICOLON, loc[2], loc[1], loc[1], ";")
end

function p_macroname(
    ::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ::PrettyContext,
    ::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    loc = cursor_loc(s)
    val = getsrcval(s.doc, (s.offset):(s.offset+span(cst)-1))
    s.offset += span(cst)
    FST(MACRONAME, loc[2], loc[1], loc[1], val)
end

function p_operator(
    ::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ::PrettyContext,
    ::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    loc = cursor_loc(s)
    val = getsrcval(s.doc, (s.offset):(s.offset+span(cst)-1))
    s.offset += span(cst)
    t = FST(OPERATOR, loc[2], loc[1], loc[1], val)
    t.metadata = Metadata(kind(cst))
    return t
end

function p_keyword(
    ::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ::PrettyContext,
    ::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    loc = cursor_loc(s)
    val = getsrcval(s.doc, (s.offset):(s.offset+span(cst)-1))
    s.offset += span(cst)
    FST(KEYWORD, loc[2], loc[1], loc[1], val)
end

function p_punctuation(
    ::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ::PrettyContext,
    ::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    loc = cursor_loc(s)
    val = getsrcval(s.doc, (s.offset):(s.offset+span(cst)-1))
    s.offset += span(cst)
    FST(PUNCTUATION, loc[2], loc[1], loc[1], val)
end

function p_juxtapose(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Juxtapose, nspaces(s))
    if !haschildren(cst)
        return t
    end

    for c in children(cst)
        add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
    end

    return t
end

function p_continue(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Continue, nspaces(s))
    if !haschildren(cst)
        return t
    end

    for c in children(cst)
        add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
    end

    return t
end

function p_break(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Break, nspaces(s))
    if !haschildren(cst)
        return t
    end

    for c in children(cst)
        add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
    end

    return t
end

# $
function p_inert(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Inert, nspaces(s))
    if !haschildren(cst)
        return t
    end

    for c in children(cst)
        add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
    end

    return t
end

function p_macrostr(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(MacroStr, nspaces(s))
    if !haschildren(cst)
        return t
    end

    for c in children(cst)
        add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
    end

    return t
end

# what mean
#
# julia> t = parseall(JuliaSyntax.GreenNode, """r"hello"x""")
#      1:9      │[toplevel]
#      1:9      │  [macrocall]
#      1:1      │    StringMacroName      ✔
#      2:8      │    [string]
#      2:2      │      "
#      3:7      │      String             ✔
#      8:8      │      "
#      9:9      │    String               ✔
#
# if cst.head === :FLOAT && !startswith(val, "0x")
#     if (fidx = findlast(==('f'), val)) === nothing
#         float_suffix = ""
function p_literal(
    ::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    loc = cursor_loc(s)
    val = getsrcval(s.doc, (s.offset):(s.offset+span(cst)-1))

    if !is_str_or_cmd(cst)
        if kind(cst) in KSet"Float Float32" && !startswith(val, r"[+-]?0x")
            float_suffix = if (fidx = findlast(==('f'), val)) === nothing
                ""
            else
                fs = val[fidx:end]
                val = val[1:(fidx-1)]
                fs
            end
            if findfirst(c -> c == 'e' || c == 'E', val) === nothing
                if (dotidx = findlast(==('.'), val)) === nothing
                    val *= s.opts.trailing_zero ? ".0" : ""  # append a trailing zero prior to the suffix
                elseif dotidx == length(val)
                    val *= s.opts.trailing_zero ? "0" : ""  # if a float literal ends in `.`, add trailing zero.
                elseif dotidx == 1
                    val = '0' * val  # leading zero
                elseif dotidx == 2 && (val[1] == '-' || val[1] == '+')
                    val = val[1] * '0' * val[2:end]  # leading zero on signed numbers
                end
            end
            val *= float_suffix
        end
    end

    s.offset += span(cst)
    return FST(LITERAL, loc[2], loc[1], loc[1], val)
end

function p_accessor(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Accessor, nspaces(s))
    if !haschildren(cst)
        return t
    end

    for c in children(cst)
        add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
    end
    t
end

# StringH
function p_stringh(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    ::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    loc = cursor_loc(s)
    if !haschildren(cst)
        return FST(StringN, loc[2] - 1)
    end
    loc2 = cursor_loc(s, s.offset + span(cst) - 1)

    val = getsrcval(s.doc, (s.offset):(s.offset+span(cst)-1))
    startline = loc[1]
    endline = loc2[1]

    s.offset += span(cst)

    if ctx.from_docstring && s.opts.format_docstrings
        val = format_docstring(style, s, val)
    end

    if isnothing(findfirst('\n', val))
        return FST(LITERAL, loc[2], startline, startline, val)
    end

    # The indent for the StringN FST should be the display width of the first line prior
    # to the opening quote. loc[2] is already a display column (1-indexed).
    t = FST(StringN, loc[2] - 1)
    t.line_offset = loc[2]

    lines = split(val, "\n")
    # Calculate the display column of the first non-whitespace character in the string
    # literal.
    sidx = loc[2]  # Display column of the opening quote.
    for l in lines[2:end]
        # Note that `fc` is actually a byte index, not a display column. This works only
        # insofar as all whitespace characters (as defined by isspace(c)) have the same
        # display width and byte width (for example, for a regular space both are 1). This
        # is not, in general, true: for example, for U+3000 IDEOGRAPHIC SPACE we have that
        #    isspace('\u3000')     ==>  true
        #    ncodeunits('\u3000')  ==>  3
        #    textwidth('\u3000')   ==>  2
        # However, this is pathological enough to not worry about.
        fc = findfirst(c -> !isspace(c), l)
        if !isnothing(fc)
            sidx = min(sidx, fc)
        end
    end

    for (i, l) in enumerate(lines)
        # When format_docstrings is enabled, the formatted docstring may have more lines
        # than the original (e.g. blank lines added around code fences). Clamping prevents
        # add_node! from checking source lines outside the docstring for comments. See
        # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/1223
        ln = min(startline + i - 1, endline)
        l = i == 1 ? l : l[sidx:end]
        n = FST(LITERAL, ln, ln, sidx - 1, textwidth(l), l, (), AllowNest, 0, -1, nothing)
        # override_join_lines_based_on_source ensures that the lines are always printed on
        # separate lines rather than being joined, even if join_lines_based_on_source has
        # been enabled by the user
        add_node!(t, n, s; override_join_lines_based_on_source = true)
    end

    # we need to maintain the start and endlines of the original source
    t.startline = startline
    t.endline = endline
    return t
end

# GlobalRefDoc (docstring)
function p_globalrefdoc(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(GlobalRefDoc, nspaces(s))
    if !haschildren(cst)
        return t
    end

    childs = children(cst)
    for (i, c) in enumerate(childs)
        if i == 1
            add_node!(
                t,
                pretty(style, c, s, newctx(ctx; from_docstring = true), lineage),
                s;
                max_padding = 0,
            )
        elseif i == length(childs)
            end_node = pretty(style, c, s, ctx, lineage)
            end_node.startline = t.endline
            add_node!(t, end_node, s; max_padding = 0)
        else
            add_node!(t, pretty(style, c, s, ctx, lineage), s)
        end
    end

    return t
end

# MacroCall
function p_macrocall(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}};
    do_block_idx::Union{Int,Nothing} = nothing,
)
    style = getstyle(ds)
    t = FST(MacroCall, nspaces(s))
    JuliaSyntax.is_leaf(cst) && return t

    args = get_args(cst)
    nest = should_allow_nesting_call_args(args, s.opts.disallow_single_arg_nesting)
    childs = children(cst)

    # A macrocall may be followed by a do-block, e.g. `@modify(x) do y ... end`.
    # `p_do_call` formats the head here (truncating the do-block) and wraps the
    # result in a `Do` node. Without this the do-block's closer is mistaken for
    # the macrocall closer, the args are treated as a macroblock, and extraneous
    # whitespace is emitted (e.g. `@modify(x)  do`).
    if !isnothing(do_block_idx)
        if !checkbounds(Bool, childs, do_block_idx) ||
           kind(childs[do_block_idx]) !== K"do" ||
           !haschildren(childs[do_block_idx])
            error("p_macrocall called with an invalid do block index")
        end
        childs = childs[1:(do_block_idx-1)]
    end

    has_closer = is_closer(childs[end])
    is_macroblock = !has_closer

    if is_macroblock
        t.typ = MacroBlock
    end

    for (i, a) in enumerate(childs)
        n = pretty(style, a, s, ctx, lineage)::FST
        if JuliaSyntax.is_macro_name(a)
            add_node!(t, n, s; join_lines = true)
        elseif kind(a) === K"("
            add_node!(t, n, s; join_lines = true)
            if nest
                add_node!(t, Placeholder(0), s)
            else
                false
            end
        elseif kind(a) === K")"
            if nest
                add_node!(t, Placeholder(0), s)
            else
                false
            end
            add_node!(t, n, s; join_lines = true)
        elseif kind(a) === K","
            add_node!(t, n, s; join_lines = true)
            if has_more_args_to_come(childs, i + 1, K")")
                add_node!(t, Placeholder(1), s)
            end
        elseif JuliaSyntax.is_whitespace(a)
            add_node!(t, n, s; join_lines = true)
        elseif is_macroblock
            if n.typ === MacroBlock && t[end].typ === WHITESPACE
                t[end] = Placeholder(length(t[end].val))
            end

            max_padding = is_block(n) ? 0 : -1
            join_lines = t.endline == n.startline

            if join_lines && (i > 1 && Shims.is_really_whitespace(childs[i-1])) ||
               next_node_is(Shims.is_really_whitespace, childs[i])
                add_node!(t, Whitespace(1), s)
            end
            add_node!(t, n, s; join_lines, max_padding)
        else
            if has_closer
                add_node!(t, n, s; join_lines = true)
            else
                padding = is_block(n) ? 0 : -1
                add_node!(t, n, s; join_lines = true, max_padding = padding)
            end
        end
    end

    # move placement of @ to the end
    #
    # @Module.macro -> Module.@macro
    t[1] = move_at_sign_to_the_end(t[1], s)
    t
end

# `#= ... =#` comments are reported as whitespace by JuliaSyntax, so block
# handlers that skip whitespace would otherwise drop them. Append the comment
# (keeping it on the current line when it trails code) instead of losing it.
#
# Returns true if the comment was added, false otherwise.
"""
Add a `#= =#` comment node to the FST. Returns `false` if `n` is not a HASHEQCOMMENT.

When `force_join` is `true`, the comment is always joined to the previous node
(used by contexts like hcat where the nesting phase manages line breaks). When
`false` (the default), a comment that appears on its own line in the source is
placed on a new line instead of being merged onto the previous statement.
"""
function add_hasheq_comment!(t::FST, n::FST, s::State; force_join::Bool = false)
    n.typ === HASHEQCOMMENT || return false
    tnodes = t.nodes::Vector{FST}
    if isempty(tnodes)
        # A leading comment establishes the block's line tracking. Without this
        # the custom-leaf path in `add_node!` copies `t.endline` (still 0), and
        # the next code node computes a bogus NOTCODE range spanning the whole
        # preceding source, duplicating unrelated comments.
        t.startline = n.startline
        t.endline = n.endline
        add_node!(t, n, s; join_lines = true)
    elseif !force_join && t.endline < n.startline && !is_prev_newline(tnodes[end])
        # The comment is on its own line in the source. Use max_padding = 0 so
        # that add_node! respects this and inserts a newline (its HASHEQCOMMENT
        # handler only forces join_lines when max_padding is -1).
        add_node!(t, n, s; max_padding = 0)
    else
        if !(tnodes[end].typ in (NEWLINE, WHITESPACE, PLACEHOLDER, NOTCODE))
            add_node!(t, Whitespace(1), s)
        end
        add_node!(t, n, s; join_lines = true)
    end
    return true
end

"""
Recursively check whether a CST node contains a `return` node anywhere inside it.
Used to avoid prepending `return` to expressions like `x > 0 ? (return 1) : (return 2)`.
"""
function _contains_return(cst::JuliaSyntax.GreenNode)::Bool
    kind(cst) === K"return" && return true
    haschildren(cst) && return any(_contains_return, children(cst))
    return false
end

"""
    should_add_return_to_last_statement(cst, s, style, lineage)

For a block `cst`, determine whether we should add a `return` to the last statement in the block.
"""
function should_add_return_to_last_statement(
    cst::JuliaSyntax.GreenNode,
    s::State,
    style::AbstractStyle,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    kind(cst) === K"block" ||
        error("should_add_return_to_last_statement called on a non-block node")

    # If the option is not enabled, don't add return.
    s.opts.always_use_return || return false
    can_transform_syntax(s, true) || return false

    # If the block is empty, don't add return.
    last_stmt_idx =
        findlast(n -> !JuliaSyntax.is_whitespace(n) && kind(n) !== K";", children(cst))
    last_stmt_idx === nothing && return false

    # Only add return if the block is the body of a function/macro definition or a do-block
    # in a function/macro call.
    if !(
        length(lineage) >= 2 && lineage[end-1][1] in KSet"function macro" ||
        length(lineage) >= 3 &&
        lineage[end-1][1] === K"do" &&
        lineage[end-2][1] in KSet"call macrocall"
    )
        return false
    end

    # Need to check the children carefully now.
    last_stmt = children(cst)[last_stmt_idx]
    # If the last statement is already a return or a macro, don't add return.
    if kind(last_stmt) in KSet"return macrocall"
        return false
    end
    # If the last statement is a block, don't add return.
    if is_block(last_stmt, style)
        return false
    end
    # Do-blocks don't get caught by `is_block()` because they have K"call" or K"macrocall",
    # so we search for them separately here and disable them here too.
    if has_do_block_call(last_stmt) !== nothing
        return false
    end

    # If the last statement already contains a `return` somewhere inside it (e.g.
    # `x > 0 ? (return 1) : (return 2)`), don't add another one.
    if _contains_return(last_stmt)
        return false
    end

    # If the last statement is something that has a docstring attached to it, don't add
    # return. See https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/405
    #
    # There are several cases we have to deal with here:
    #
    #     @doc """string"""\n f -- in this case the last statement is the entire macrocall
    #                              and so will be skipped by the previous branch, we don't
    #                              need to worry about it here.
    #     raw"""string"""\n f   -- [macrocall] -> NewlineWS -> Identifier
    #     """string"""\n f      -- [string] -> NewlineWS -> Identifier
    if last_stmt_idx >= 3
        preceded_by_newline = kind(cst[last_stmt_idx-1]) === K"NewlineWs"
        maybe_docstring = cst[last_stmt_idx-2]
        then_preceded_by_docstring =
            kind(maybe_docstring) === K"string" || (
                kind(maybe_docstring) === K"macrocall" &&
                haschildren(maybe_docstring) &&
                kind(maybe_docstring[1]) === K"StringMacroName"
            )
        if preceded_by_newline && then_preceded_by_docstring
            return false
        end
    end

    return true
end

# Block
# length Block is the length of the longest expr
function p_block(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Block, nspaces(s))
    if !haschildren(cst)
        return t
    end

    # We might want to add return to the last statement.
    add_return_to_last_statement =
        should_add_return_to_last_statement(cst, s, style, lineage)
    # Technically this doesn't need to be computed if add_return_to_last_statement is false,
    # but it's cheap.
    last_stmt_idx =
        findlast(n -> !JuliaSyntax.is_whitespace(n) && kind(n) !== K";", children(cst))

    join_body = ctx.join_body
    ignore_single_line = ctx.ignore_single_line
    from_quote = ctx.from_quote

    childs = children(cst)
    has_paren = !isnothing(findfirst(n -> kind(n) === K"(", childs))

    if has_paren && !from_quote
        return p_tupleblock(style, cst, s, ctx, lineage)
    end

    single_line =
        ignore_single_line ? false : on_same_line(s, s.offset, s.offset + span(cst) - 1)

    before_first_arg = true

    # TODO: fix this so we can pass it through
    ctx = newctx(ctx; ignore_single_line = false, join_body = false, from_quote = false)

    for (i, a) in enumerate(childs)
        if kind(a) === K"Comment"
            add_hasheq_comment!(t, pretty(style, a, s, ctx, lineage), s)
            continue
        elseif JuliaSyntax.is_whitespace(a)
            s.offset += span(a)
            continue
        end

        if from_quote && !single_line
            n = pretty(style, a, s, ctx, lineage)
            if kind(a) in KSet"; ) ("
                add_node!(t, n, s; join_lines = true)
            elseif kind(a) === K","
                add_node!(t, n, s; join_lines = true)
                if has_more_args_to_come(childs, i + 1, K")")
                    add_node!(t, Whitespace(1), s)
                end
            elseif JuliaSyntax.is_whitespace(a)
                add_node!(t, n, s; join_lines = true)
            elseif before_first_arg
                add_node!(t, n, s; join_lines = true)
                before_first_arg = false
            else
                add_node!(t, n, s; max_padding = 0)
            end
        elseif single_line
            n = pretty(style, a, s, ctx, lineage)
            if kind(a) in KSet", ;"
                add_node!(t, n, s; join_lines = true)
                if has_more_args_to_come(childs, i + 1, K")")
                    add_node!(t, Placeholder(1), s)
                end
            else
                add_node!(t, n, s; join_lines = true)
            end
        else
            if kind(a) === K","
                n = pretty(style, a, s, ctx, lineage)
                add_node!(t, n, s; join_lines = true)
                if join_body && has_more_args_to_come(childs, i + 1, K")")
                    add_node!(t, Placeholder(1), s)
                end
            elseif kind(a) === K";"
                if join_body
                    # Collapsing the statements onto a single line, so print the semicolon
                    add_node!(t, pretty(style, a, s, ctx, lineage), s; join_lines = true)
                else
                    # Breaking onto multiple lines so just skip over it
                    s.offset += span(a)
                end
            elseif join_body
                n = pretty(style, a, s, ctx, lineage)
                add_node!(t, n, s; join_lines = true)
            else
                # Other statements.
                node_to_add = if i === last_stmt_idx && add_return_to_last_statement
                    # Add a return statement to the last statement in the block.
                    c = cursor_loc(s)
                    return_fst = FST(Return, nspaces(s))
                    add_node!(
                        return_fst,
                        FST(KEYWORD, c[2], c[1], c[1], "return"),
                        s;
                        join_lines = true,
                    )
                    add_node!(return_fst, Whitespace(1), s; join_lines = true)
                    # have to push to lineage to make sure that the return value node is
                    # formatted properly. See #1125.
                    push!(lineage, (K"return", false, false))
                    n = pretty(style, a, s, ctx, lineage)
                    pop!(lineage)
                    add_node!(return_fst, n, s; join_lines = true)
                    return_fst
                else
                    pretty(style, a, s, ctx, lineage)
                end
                add_node!(t, node_to_add, s; max_padding = 0)
            end
        end
    end

    t
end

function p_block(
    ds::AbstractStyle,
    nodes::Vector{JuliaSyntax.GreenNode{T}},
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
) where {T}
    style = getstyle(ds)
    t = FST(Block, nspaces(s))

    ctx = newctx(ctx; ignore_single_line = false, join_body = false, from_quote = false)
    for (i, a) in enumerate(nodes)
        if kind(a) === K"Comment"
            add_hasheq_comment!(t, pretty(style, a, s, ctx, lineage), s)
            continue
        elseif JuliaSyntax.is_whitespace(a) || kind(a) === K";"
            s.offset += span(a)
            continue
        end
        n = pretty(style, a, s, ctx, lineage)
        if i < length(nodes) && kind(a) === K"," && is_punc(nodes[i+1])
            add_node!(t, n, s; join_lines = true)
        elseif kind(a) === K"," && i != length(nodes)
            add_node!(t, n, s; join_lines = true)
        elseif kind(a) === K";"
            add_node!(t, n, s; join_lines = true)
        else
            add_node!(t, n, s; max_padding = 0)
        end
    end
    t
end

# Abstract
function p_abstract(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Abstract, nspaces(s))
    if !haschildren(cst)
        return t
    end

    for c in children(cst)
        add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
        if !JuliaSyntax.is_whitespace(c) && kind(c) !== K"end"
            add_node!(t, Whitespace(1), s)
        end
    end
    t
end

# Primitive
function p_primitive(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Primitive, nspaces(s))
    if !haschildren(cst)
        return t
    end

    for c in children(cst)
        add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
        if !JuliaSyntax.is_whitespace(c) && kind(c) !== K"end"
            add_node!(t, Whitespace(1), s)
        end
    end
    t
end

function p_var(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(NonStdIdentifier, nspaces(s))
    if !haschildren(cst)
        return t
    end

    for c in children(cst)
        add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
    end
    t
end

# function/macro
function p_functiondef(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(FunctionN, nspaces(s))
    JuliaSyntax.is_leaf(cst) && return t

    function_or_macro_keyword_idx = findfirst(
        n -> kind(n) in KSet"function macro" && JuliaSyntax.is_leaf(n),
        children(cst),
    )

    # We might want to disable separate_kwargs_with_semicolon for the initial
    # call in a function/macro definition.
    caller_idx = findnext(
        n -> !JuliaSyntax.is_whitespace(n),
        children(cst),
        function_or_macro_keyword_idx + 1,
    )
    if !Shims.is_caller_in_function_def(cst[caller_idx])
        # If that child doesn't look like a function call, then it's an anonymous function.
        # In that case we can disable the check.
        caller_idx = nothing
    end

    collapse_end_onto_same_line = true
    childs = children(cst)
    seen_body = false
    extra_block_node = nothing

    for (i, c) in enumerate(childs)
        if i == function_or_macro_keyword_idx
            n = pretty(style, c, s, ctx, lineage)
            add_node!(t, n, s)
            add_node!(t, Whitespace(1), s)
        elseif kind(c) === K"end"
            n = pretty(style, c, s, ctx, lineage)
            if extra_block_node !== nothing
                add_node!(t, extra_block_node, s)
                s.indent -= s.opts.indent
                collapse_end_onto_same_line = false
            end
            if collapse_end_onto_same_line
                if s.opts.join_lines_based_on_source
                    join_lines = t.endline == n.startline
                    if join_lines
                        add_node!(t, Whitespace(1), s)
                    end
                    add_node!(t, n, s; join_lines = join_lines)
                else
                    # Force the end keyword to go onto the same line as the definition.
                    add_node!(t, Whitespace(1), s)
                    # Override n.startline so that the `end` keyword ends up on the same
                    # line as the rest of the function def. But don't override n.endline,
                    # otherwise extra newlines will be inserted after the `end`.
                    n.startline = t.endline
                    add_node!(t, n, s; join_lines = true)
                end
            else
                add_node!(t, n, s)
            end
        elseif seen_body && !Shims.is_really_whitespace(c)
            if kind(c) !== K"Comment"
                error("Unexpected node after function body: $(kind(c))")
            end
            if extra_block_node === nothing
                s.indent += s.opts.indent
                extra_block_node = FST(Block, nspaces(s))
            end
            n = pretty(style, c, s, ctx, lineage)
            add_node!(extra_block_node, n, s)
        elseif kind(c) === K"block" && haschildren(c)
            collapse_end_onto_same_line = !block_has_statements(c)
            s.indent += s.opts.indent
            n = pretty(style, c, s, newctx(ctx; ignore_single_line = true), lineage)
            add_node!(t, n, s; max_padding = s.opts.indent)
            s.indent -= s.opts.indent
            seen_body = true
        elseif i === caller_idx
            n = pretty(style, c, s, newctx(ctx; can_separate_kwargs = false), lineage)
            add_node!(t, n, s; join_lines = true)
        else
            add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
        end
    end
    t.metadata = Metadata(
        kind(cst),
        false,
        false,
        false,
        false,
        can_transform_syntax(s, true),
        false,
    )
    t
end

function p_macro(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    t = p_functiondef(ds, cst, s, ctx, lineage)
    t.typ = Macro
    t
end

# struct
function p_struct(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Struct, nspaces(s))
    if !haschildren(cst)
        return t
    end

    block_has_contents = false
    childs = children(cst)
    for (i, c) in enumerate(childs)
        if i == 1
            n = pretty(style, c, s, ctx, lineage)
            add_node!(t, n, s)
            add_node!(t, Whitespace(1), s)
        elseif kind(c) === K"end"
            n = pretty(style, c, s, ctx, lineage)
            if s.opts.join_lines_based_on_source && !block_has_contents
                join_lines = t.endline == n.startline
                if join_lines
                    (add_node!(t, Whitespace(1), s))
                else
                    false
                end
                add_node!(t, n, s; join_lines = join_lines)
            elseif block_has_contents
                add_node!(t, n, s)
            else
                add_node!(t, Whitespace(1), s)
                add_node!(t, n, s; join_lines = true)
            end
        elseif kind(c) === K"block" && haschildren(c)
            block_has_contents = block_has_statements(c)
            s.indent += s.opts.indent
            n = pretty(style, c, s, newctx(ctx; ignore_single_line = true), lineage)
            if s.opts.annotate_untyped_fields_with_any && can_transform_syntax(s, true)
                annotate_typefields_with_any!(n, s)
            end
            add_node!(t, n, s; max_padding = s.opts.indent)
            s.indent -= s.opts.indent
        else
            add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
        end
    end
    t
end

# mutable
function p_mutable(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Mutable, nspaces(s))
    if !haschildren(cst)
        return t
    end

    block_has_contents = false
    childs = children(cst)
    for c in childs
        if kind(c) in KSet"struct mutable"
            n = pretty(style, c, s, ctx, lineage)
            add_node!(t, n, s; join_lines = true)
            add_node!(t, Whitespace(1), s)
        elseif kind(c) === K"end"
            n = pretty(style, c, s, ctx, lineage)
            if s.opts.join_lines_based_on_source && !block_has_contents
                join_lines = t.endline == n.startline
                if join_lines
                    (add_node!(t, Whitespace(1), s))
                else
                    false
                end
                add_node!(t, n, s; join_lines = join_lines)
            elseif block_has_contents
                add_node!(t, n, s)
            else
                add_node!(t, Whitespace(1), s)
                add_node!(t, n, s; join_lines = true)
            end
        elseif kind(c) === K"block" && haschildren(c)
            block_has_contents = block_has_statements(c)
            s.indent += s.opts.indent
            n = pretty(style, c, s, newctx(ctx; ignore_single_line = true), lineage)
            if s.opts.annotate_untyped_fields_with_any && can_transform_syntax(s, true)
                annotate_typefields_with_any!(n, s)
            end
            add_node!(t, n, s; max_padding = s.opts.indent)
            s.indent -= s.opts.indent
        else
            add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
        end
    end
    t
end

# module/baremodule
function p_module(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(ModuleN, nspaces(s))
    if !haschildren(cst)
        return t
    end

    from_module = ctx.from_module
    block_has_contents = false
    childs = children(cst)
    indent_module = s.opts.indent_submodule && from_module

    for c in childs
        if kind(c) in KSet"module baremodule" && !haschildren(c)
            n = pretty(style, c, s, ctx, lineage)
            add_node!(t, n, s; join_lines = true)
            add_node!(t, Whitespace(1), s)
        elseif kind(c) === K"end"
            n = pretty(style, c, s)
            if s.opts.join_lines_based_on_source && !block_has_contents
                join_lines = t.endline == n.startline
                if join_lines
                    (add_node!(t, Whitespace(1), s))
                else
                    false
                end
                add_node!(t, n, s; join_lines = join_lines)
            elseif block_has_contents
                add_node!(t, n, s)
            else
                add_node!(t, Whitespace(1), s)
                add_node!(t, n, s; join_lines = true)
            end
        elseif kind(c) === K"block" && haschildren(c)
            block_has_contents = block_has_statements(c)

            if indent_module
                s.indent += s.opts.indent
            end
            n = pretty(
                style,
                c,
                s,
                newctx(ctx; from_module = true, ignore_single_line = true),
                lineage,
            )
            if indent_module
                add_node!(t, n, s; max_padding = s.opts.indent)
                s.indent -= s.opts.indent
            else
                add_node!(t, n, s; max_padding = 0)
            end
        else
            add_node!(
                t,
                pretty(style, c, s, newctx(ctx; from_module = true), lineage),
                s;
                join_lines = true,
            )
        end
    end
    t
end

function p_baremodule(
    style::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    t = p_module(style, cst, s, ctx, lineage)
    t.typ = BareModule
    t
end

function p_return(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    t = p_const(ds, cst, s, ctx, lineage)
    t.typ = Return
    t
end

# const/local/global/outer/return
function p_const(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Const, nspaces(s))
    if !haschildren(cst)
        return t
    end

    for c in children(cst)
        if kind(c) === K","
        elseif !JuliaSyntax.is_whitespace(c) && !JuliaSyntax.is_keyword(c)
            add_node!(t, Whitespace(1), s)
        elseif !JuliaSyntax.is_whitespace(c) && JuliaSyntax.is_keyword(c) && haschildren(c)
            add_node!(t, Whitespace(1), s)
        end
        add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
    end
    t
end

function p_local(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    t = p_const(ds, cst, s, ctx, lineage)
    t.typ = Local
    t
end

function p_global(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    t = p_const(ds, cst, s, ctx, lineage)
    t.typ = Global
    t
end

function p_outer(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    t = p_const(ds, cst, s, ctx, lineage)
    t.typ = Outer
    t
end

function p_toplevel(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(TopLevel, nspaces(s))
    if !haschildren(cst)
        return t
    end

    for a in children(cst)
        n = pretty(style, a, s, ctx, lineage)
        if kind(a) === K";"
            # Can't drop top-level semicolons as that leads to different behaviour
            # in REPL for example
            add_node!(t, n, s; join_lines = true)
        else
            add_node!(t, n, s; max_padding = 0)
        end
    end
    t
end

function p_begin(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Begin, nspaces(s))
    if !haschildren(cst)
        return t
    end

    childs = children(cst)
    add_node!(t, pretty(style, childs[1], s, ctx, lineage), s)

    # == 2 because the two children are `begin` and `end`
    empty_body = count(n -> !Shims.is_really_whitespace(n) && kind(n) !== K";", childs) == 2

    if empty_body && !s.opts.join_lines_based_on_source
        for c in childs[2:(end-1)]
            pretty(style, c, s, ctx, lineage)
        end
        add_node!(t, Whitespace(1), s)
        # Override the `end` keyword's startline to match `begin`, so that add_node! doesn't
        # detect a source line gap and insert a NEWLINE. Without this, `begin\n\nend` is
        # formatted to `begin\nend` and then `begin end`
        end_node = pretty(style, cst[end], s)
        end_node.startline = t.endline
        # But don't override endline or else that inserts extra newlines at the end
        add_node!(t, end_node, s; join_lines = true)
    else
        push!(lineage, (K"block", false, false))
        s.indent += s.opts.indent
        add_node!(
            t,
            p_block(style, childs[2:(end-1)], s, ctx, lineage),
            s;
            max_padding = s.opts.indent,
        )
        s.indent -= s.opts.indent
        pop!(lineage)
        add_node!(t, pretty(style, cst[end], s), s)
    end
    t
end

function p_quote(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Quote, nspaces(s))
    if !haschildren(cst)
        return t
    end

    childs = children(cst)
    if kind(childs[1]) === K"block"
        add_node!(t, p_begin(style, childs[1], s, ctx, lineage), s; join_lines = true)
        for i in 2:length(childs)
            add_node!(t, pretty(style, childs[i], s, ctx, lineage), s; join_lines = true)
        end
    else
        for c in childs
            add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
        end
    end

    return t
end

function p_quotenode(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Quotenode, nspaces(s))
    if !haschildren(cst)
        return t
    end

    ctx = newctx(ctx; from_quote = true)
    for a in children(cst)
        add_node!(t, pretty(style, a, s, ctx, lineage), s; join_lines = true)
    end
    t
end

# Let
#
# two forms:
#
# let var1 = value1, var2
#     body
# end
#
# y, back = let
#     body
# end
# #
#
# let
# [block]
# ...
# [block]
# end
function p_let(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Let, nspaces(s))
    if !haschildren(cst)
        return t
    end
    block_id = 1

    has_let_args = false

    childs = children(cst)
    for (i, c) in enumerate(childs)
        if kind(c) === K"block"
            s.indent += s.opts.indent
            if block_id == 1
                has_let_args =
                    haschildren(c) &&
                    any(n -> kind(n) === K"," || is_iterable(n), children(c))
                add_node!(
                    t,
                    pretty(
                        style,
                        c,
                        s,
                        newctx(ctx; join_body = true, from_let = true),
                        lineage,
                    ),
                    s;
                    join_lines = true,
                )
            else
                add_node!(
                    t,
                    pretty(
                        style,
                        c,
                        s,
                        newctx(ctx; ignore_single_line = true, from_let = true),
                        lineage,
                    ),
                    s;
                    max_padding = s.opts.indent,
                )
                if has_let_args && (t.nodes::Vector{FST})[end-2].typ !== NOTCODE
                    insert!(t, length(t.nodes) - 1, Placeholder(0))
                end
            end
            s.indent -= s.opts.indent
            block_id += 1
        elseif kind(c) === K"let"
            add_node!(t, pretty(style, c, s, ctx, lineage), s)
            if block_id == 1 &&
               kind(childs[i+1]) === K"block" &&
               length(children(childs[i+1])) > 0
                add_node!(t, Whitespace(1), s)
            end
        elseif kind(c) === K"end"
            add_node!(t, pretty(style, c, s, ctx, lineage), s)
        elseif kind(c) === K";"
            # The `;` between the binding list and the body of `let x = 1; body; end`.
            # The body is always emitted on its own line, so the newline separates the
            # two and the `;` is redundant:
            #
            #     let x = 1; body; end  ->  let x = 1
            #                                   body
            #                               end
            s.offset += span(c)
        else
            add_node!(
                t,
                pretty(style, c, s, newctx(ctx; from_let = true), lineage),
                s;
                join_lines = true,
            )
        end
    end
    t
end

# For/While
function p_for(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(For, nspaces(s))
    if !haschildren(cst)
        return t
    end

    ends_in_iterable = false
    is_while_cond = false
    seen_body = false
    extra_block_node = nothing

    for c in children(cst)
        if kind(c) in KSet"for while" && !haschildren(c)
            add_node!(t, pretty(style, c, s), s)
            if kind(c) === K"while"
                is_while_cond = true
            end
        elseif kind(c) === K"end"
            if extra_block_node !== nothing
                add_node!(t, extra_block_node, s)
                s.indent -= s.opts.indent
            end
            add_node!(t, pretty(style, c, s), s)
        elseif seen_body && !Shims.is_really_whitespace(c)
            # These are things that came after the loop body, but somehow aren't `end`.
            # This can happen with constructs such as `for i in 1:10; #= hello =# end`,
            # where JuliaSyntax parses the comment as a child of the `for` node instead
            # of the block.
            #
            # To handle such cases, we create a fake block node that contains the remaining
            # children. It's hacky, but I strongly suspect that the only thing that can
            # occur here is whitespace / comments so it might be fine.
            if kind(c) !== K"Comment"
                error("Unexpected node after loop body: $(kind(c))")
            end
            if extra_block_node === nothing
                s.indent += s.opts.indent
                extra_block_node = FST(Block, nspaces(s))
            end
            n = pretty(style, c, s, ctx, lineage)
            add_node!(extra_block_node, n, s)
        elseif kind(c) === K"block"
            # We need `is_while_cond` to determine whether the block we see is the body of
            # the loop, or the condition of a while loop such as `while (a; b; c) ... end`.
            # See also `p_if` for similar considerations.
            if is_while_cond
                is_while_cond = false
                add_node!(t, Whitespace(1), s)
                add_node!(t, pretty(style, c, s), s; join_lines = true)
            else
                # The body of the for/while loop.
                s.indent += s.opts.indent
                n = pretty(style, c, s, newctx(ctx; ignore_single_line = true), lineage)
                add_node!(t, n, s; max_padding = s.opts.indent)
                s.indent -= s.opts.indent

                if !ends_in_iterable && (t.nodes::Vector{FST})[end-2].typ !== NOTCODE
                    insert!(t, length(t.nodes) - 1, Placeholder(0))
                end
                seen_body = true
            end
        elseif JuliaSyntax.is_whitespace(c)
            add_node!(t, pretty(style, c, s, ctx, lineage), s)
        else
            # Non-block while conditions or for loop iterables fall here.
            is_while_cond = false
            add_node!(t, Whitespace(1), s)
            n = if kind(c) === K"iteration"
                rhs_is_iterable = !iteration_has_comma(c) && is_iterable(iteration_rhs(c))
                if !rhs_is_iterable
                    s.indent += s.opts.indent
                end
                n = pretty(style, c, s, newctx(ctx; from_for = true), lineage)
                if !rhs_is_iterable
                    s.indent -= s.opts.indent
                end
                if rhs_is_iterable
                    ends_in_iterable = true
                end
                n
            else
                n = pretty(style, c, s, newctx(ctx; from_for = true), lineage)
                if !is_leaf(n::FST) && length(n.nodes) > 1 && is_iterable(n[end])
                    ends_in_iterable = true
                end
                n
            end
            if kind(cst) === K"for"
                eq_to_in_normalization!(n, s.opts.always_for_in, s.opts.for_in_replacement)
            end
            add_node!(t, n, s; join_lines = true)
        end
    end

    t
end

function p_iteration(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(CartesianIterator, nspaces(s))
    if !haschildren(cst)
        return t
    end

    childs = children(cst)
    for (i, c) in enumerate(childs)
        n = pretty(style, c, s, ctx, lineage)
        if kind(c) === K","
            add_node!(t, n, s; join_lines = true)
            if has_more_args_to_come(childs, i + 1, K")")
                add_node!(t, Placeholder(1), s)
            end
        elseif !JuliaSyntax.is_whitespace(c)
            if ctx.from_for
                eq_to_in_normalization!(n, s.opts.always_for_in, s.opts.for_in_replacement)
            end
            add_node!(t, n, s; join_lines = true)
        else
            add_node!(t, n, s; join_lines = true)
        end
    end

    t
end

function p_while(
    style::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    t = p_for(style, cst, s, ctx, lineage)
    t.typ = While
    t
end

function append_do_nodes!(
    t::FST,
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    if !haschildren(cst)
        return t
    end

    childs = children(cst)
    for (i, c) in enumerate(childs)
        if kind(c) === K"do" && !haschildren(c)
            add_node!(t, Whitespace(1), s)
            add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
        elseif kind(c) === K"end"
            add_node!(t, pretty(style, c, s, ctx, lineage), s)
        elseif kind(c) === K"block"
            s.indent += s.opts.indent
            n = pretty(style, c, s, newctx(ctx; ignore_single_line = true), lineage)
            add_node!(t, n, s; max_padding = s.opts.indent)
            s.indent -= s.opts.indent
        elseif kind(c) === K"tuple"
            # the thing immediately after the do.
            n = pretty(style, c, s, ctx, lineage)
            if !isempty(n.nodes)
                # if it's a nontrivial tuple then we need to separate it from the do.
                add_node!(t, Whitespace(1), s)
            end
            add_node!(t, n, s; join_lines = true)
        else
            add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
        end
    end
    t
end

# Do
# node [nodes] do [nodes] node node end
function p_do(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    t = FST(Do, nspaces(s))
    append_do_nodes!(t, ds, cst, s, ctx, lineage)
end

function p_do_call(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
    do_block_idx::Int,
)
    t = FST(Do, nspaces(s))
    childs = children(cst)
    if !checkbounds(Bool, childs, do_block_idx) ||
       kind(childs[do_block_idx]) !== K"do" ||
       !haschildren(childs[do_block_idx])
        error("p_do_call called without a do block")
    end

    head = if kind(cst) === K"macrocall"
        p_macrocall(ds, cst, s, ctx, lineage; do_block_idx = do_block_idx)
    else
        p_call(ds, cst, s, ctx, lineage; do_block_idx = do_block_idx)
    end
    add_node!(t, head, s; join_lines = true)

    do_node = childs[do_block_idx]
    push!(lineage, (kind(do_node), is_iterable(do_node), is_assignment(do_node)))
    append_do_nodes!(t, ds, do_node, s, ctx, lineage)
    pop!(lineage)

    t
end

# Try
function p_try(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Try, nspaces(s))
    if !haschildren(cst)
        return t
    end

    # With JuliaSyntax this is now a tree structure instead of being linear
    # since we're still picking up comments in add_node! if the comment is at
    # the end of block it will be added as a comment in the parent node and hence
    # have a lower indentation than the rest of the block. To counteract that we reduce
    # the indent when we encounter "catch finally end" keywords.
    #
    # Apparently "try catch else end" is also valid.

    childs = children(cst)
    for c in childs
        if kind(c) in KSet"try catch finally else"
            if !haschildren(c)
                if kind(c) in KSet"catch finally else"
                    s.indent -= s.opts.indent
                end
                add_node!(t, pretty(style, c, s, ctx, lineage), s; max_padding = 0)
            else
                len = length(t)
                n = pretty(style, c, s, ctx, lineage)
                add_node!(t, n, s; max_padding = 0)
                t.len = max(len, length(n))
            end
        elseif kind(c) === K"end"
            s.indent -= s.opts.indent
            add_node!(t, pretty(style, c, s, ctx, lineage), s)
        elseif kind(c) === K"block"
            s.indent += s.opts.indent
            add_node!(
                t,
                pretty(style, c, s, newctx(ctx; ignore_single_line = true), lineage),
                s;
                max_padding = s.opts.indent,
            )
        elseif !JuliaSyntax.is_whitespace(c)
            # "catch" vs "catch ..."
            if !(kind(cst) === K"catch" && any(n -> kind(n) === K"Placeholder", childs))
                add_node!(t, Whitespace(1), s)
            end
            add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
        else
            add_node!(t, pretty(style, c, s, ctx, lineage), s)
        end
    end
    t
end

# If
function p_if(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(If, nspaces(s))
    if !haschildren(cst)
        return t
    end

    # Flag to indicate when we are processing the condition of an if or elseif.
    is_cond = false
    # Whether or not we've read in a body following the if/elseif/else yet.
    seen_body = false
    extra_block_node = nothing

    for c in children(cst)
        if kind(c) in KSet"if elseif else"
            if !haschildren(c)
                add_node!(t, pretty(style, c, s, ctx, lineage), s; max_padding = 0)
                seen_body = false
            else
                if extra_block_node !== nothing
                    add_node!(t, extra_block_node, s)
                    s.indent -= s.opts.indent
                    extra_block_node = nothing
                    seen_body = false
                end
                len = length(t)
                n = pretty(style, c, s, ctx, lineage)
                add_node!(t, n, s)
                t.len = max(len, length(n))
            end
            if kind(c) in KSet"if elseif"
                # The next non-whitespace node we see is the condition.
                is_cond = true
            end
        elseif kind(c) === K"end"
            if extra_block_node !== nothing
                add_node!(t, extra_block_node, s)
                s.indent -= s.opts.indent
                extra_block_node = nothing
            end
            add_node!(t, pretty(style, c, s, ctx, lineage), s)
        elseif seen_body && !Shims.is_really_whitespace(c)
            # See comments in `p_for` for explanation of this
            if kind(c) !== K"Comment"
                error("Unexpected node after if body: $(kind(c))")
            end
            if extra_block_node === nothing
                s.indent += s.opts.indent
                extra_block_node = FST(Block, nspaces(s))
            end
            n = pretty(style, c, s, ctx, lineage)
            add_node!(extra_block_node, n, s)
        elseif kind(c) === K"block"
            # This block could either be the condition (if it immediatelly follows an `if`
            # or `elseif`, ignoring whitespace), or it could be the actual body. This is
            # determined by the `is_cond` flag.
            if is_cond
                add_node!(t, Whitespace(1), s)
                add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
                # The next block will be the body.
                is_cond = false
            else
                s.indent += s.opts.indent
                add_node!(
                    t,
                    pretty(style, c, s, newctx(ctx; ignore_single_line = true), lineage),
                    s;
                    max_padding = s.opts.indent,
                )
                s.indent -= s.opts.indent
                seen_body = true
            end
        elseif !JuliaSyntax.is_whitespace(c)
            # This branch is hit for non-block conditions (i.e. simple things like the `x`
            # in `if x; ...`).
            add_node!(t, Whitespace(1), s)
            add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
            if is_cond # should be true, but check just to be safe
                is_cond = false
            end
        else
            add_node!(t, pretty(style, c, s, ctx, lineage), s)
        end
    end

    # This branch can be hit in cases like
    #     s = "if x; elseif y; #= comment =# end"
    # because `comment` is the final child of the elseif and there's no node after it to
    # trigger addition of `extra_block_node`.
    if extra_block_node !== nothing
        add_node!(t, extra_block_node, s)
        s.indent -= s.opts.indent
        extra_block_node = nothing
        seen_body = false
    end

    return t
end

# Chain/Comparison
function p_chainopcall(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    t = p_binaryopcall(ds, cst, s, ctx, lineage)
    t.typ = Chain
    t
end

function p_comparison(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    t = p_binaryopcall(ds, cst, s, ctx, lineage)
    t.typ = Comparison
    t
end

# Kw
# this is only called on it's own so we need to add the lineage
function p_kw(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Kw, nspaces(s))
    if !haschildren(cst)
        return t
    end

    push!(lineage, (kind(cst), false, true))

    # We need to process the LHS and RHS slightly differently in the loop below.
    equal_idx = findfirst(n -> kind(n) === K"=", children(cst))
    equal_idx === nothing && error("unreachable: kw node without an equal sign")
    immediate_rhs_idx =
        findnext(n -> !Shims.is_really_whitespace(n), children(cst), equal_idx + 1)
    immediate_lhs_idx =
        findprev(n -> !Shims.is_really_whitespace(n), children(cst), equal_idx - 1)
    immediate_rhs_idx === nothing && error("unreachable: kw node without a RHS")
    immediate_lhs_idx === nothing && error("unreachable: kw node without a LHS")

    for (i, c) in enumerate(children(cst))
        if kind(c) === K"="
            s.opts.whitespace_in_kwargs && add_node!(t, Whitespace(1), s)
            add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
            s.opts.whitespace_in_kwargs && add_node!(t, Whitespace(1), s)
        else
            child_offset = s.offset
            n = pretty(style, c, s, ctx, lineage)
            # Check if the name of the kwarg ends with an exclamation mark, or if the name
            # of the kwarg is an op (note that the name has to be a single identifier so
            # checking that it begins with an op is equivalent to checking that is an op),
            # or if the value of the kwarg begins with an op.
            #
            # In all of these cases, we need to parenthesise it to avoid ambiguity.
            parenthesise =
                !s.opts.whitespace_in_kwargs && begin
                    if i == immediate_rhs_idx && kind(c) !== K"Comment"
                        source_begins_with_op_needing_parens(s, c, child_offset)
                    elseif i === immediate_lhs_idx && kind(c) === K"Identifier"
                        endswith(n.val, "!") || Shims.is_valid_nonword_operator(n.val)
                    else
                        false
                    end
                end

            node = if parenthesise
                paren_fst = FST(Brackets, nspaces(s))
                add_node!(
                    paren_fst,
                    FST(PUNCTUATION, -1, n.startline, n.startline, "("),
                    s;
                    join_lines = true,
                )
                add_node!(paren_fst, Placeholder(0), s)
                add_node!(paren_fst, n, s; join_lines = true)
                add_node!(paren_fst, Placeholder(0), s)
                add_node!(
                    paren_fst,
                    FST(PUNCTUATION, -1, n.startline, n.startline, ")"),
                    s;
                    join_lines = true,
                )
                paren_fst
            else
                n
            end
            add_node!(t, node, s; join_lines = true)
        end
    end

    pop!(lineage)

    t
end

"""
    p_pipe_to_call

Take a CST of the form `x |> y` or `x .|> y`, but return a FST with the equivalent function
call `y(x)` or `y.(x)` instead.

Note that this function is only called for certain pipe-applications. See the call site in
`p_binaryopcall` for details.
"""
function p_pipe_to_call(
    style::AbstractStyle,
    # cst here must be a binary op call with |> as the operator (possibly dotted).
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    # WARNING: This transformation can lead to semantic changes. See e.g.
    # - https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/439
    # - https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/647
    # 
    # This should really be removed in a future version of JuliaFormatter.
    @warn (
        "JuliaFormatter transformed one or more expressions with the form `x |> f` into" *
        " the equivalent function call `f(x)`.\n\nNote that that this can lead to" *
        " semantic changes if `|>` has been overloaded or otherwise has a custom meaning!" *
        "\n\nYou can disable this behaviour by setting the `pipe_to_function_call` option" *
        " to `false`. Note that this option is `true` by default for Blue and YAS styles," *
        " meaning that you must explicitly opt out. Alternatively, you can use" *
        " `#! format: off` and `#! format: on` to disable formatting for specific" *
        " sections of code that use `|>`."
    ) maxlog = 1

    call_node = FST(Call, nspaces(s))
    childs = children(cst)

    # Identify the operator LHS (callee) and RHS (caller).
    lhs_idx = findfirst(n -> !JuliaSyntax.is_whitespace(n), childs)
    rhs_idx = findlast(n -> !JuliaSyntax.is_whitespace(n), childs)
    if isnothing(lhs_idx) || isnothing(rhs_idx) || lhs_idx >= rhs_idx
        error(
            "pipe operator with lhs_idx=$(lhs_idx) and rhs_idx=$(rhs_idx): should not happen",
        )
    end

    # Convert each node to an FST, storing references to the LHS and RHS nodes for later.
    lhs, rhs = nothing, nothing
    for (i, c) in enumerate(childs)
        if i == lhs_idx
            if kind(c) === K"parens" && haschildren(c) && !any(is_assignment, children(c))
                # If the lhs is a parenthesised expression, we can strip the parentheses.
                # For example
                #     (x) |> f
                # can just become f(x) rather than f((x)). However, we need to make sure
                # we don't do this for assignments, because
                #     (x = y) |> f
                # is not the same as f(x = y)!
                for pc in children(c)
                    if kind(pc) in KSet"( )" || JuliaSyntax.is_whitespace(pc)
                        s.offset += span(pc)
                    else
                        lhs = pretty(style, pc, s, ctx, lineage)
                    end
                end
            else
                lhs = pretty(style, c, s, ctx, lineage)
            end
        elseif i == rhs_idx
            rhs = pretty(style, c, s, ctx, lineage)
        else
            s.offset += span(c)
        end
    end

    # Handle the caller.
    #
    # Some things need to be wrapped in parens. We behave conservatively here and only opt
    # out of wrapping for the following callers:
    #
    #   - a plain identifier               arg |> f     -> f(arg)
    #   - a field access                   arg |> obj.f -> obj.f(arg)
    #   - something already parenthesised  arg |> (f)   -> (f)(arg)
    #   - a function call                  arg |> f()   -> f()(arg)
    #   - a parametrised type constructor  arg |> F{x}  -> F{x}(arg)
    #
    # There are two edge cases (of course there are).
    #
    # 1. For the function call case, we need to parenthesise a function call with a
    #    do-block:
    #
    #     arg |> f() do           (f() do
    #         g()          --->        g()
    #     end                     end)(arg)
    #
    # 2. For the identifier case, if it's a dotted operator, we need to store a flag,
    #    `is_dotted_operator`. This is because
    #
    #        arg .|> ! 
    #
    #    should become `.!(arg)` rather than `!.(arg)` which is a parse error.
    #    (Alternatively, (!).(arg) would work too, but looks uglier.)
    rhs_cst = childs[rhs_idx]
    is_dotted_operator = if kind(cst) === K"dotcall" && kind(rhs_cst) === K"Identifier"
        try
            k = JuliaSyntax.Kind(rhs.val)
            JuliaSyntax.is_operator(k) && !JuliaSyntax.is_word_operator(k)
        catch
            false
        end
    else
        false
    end
    caller_needs_parens = if kind(rhs_cst) in KSet"Identifier . parens curly"
        false
    elseif kind(rhs_cst) === K"call" && haschildren(rhs_cst)
        # In JuliaSyntax, infix operators are also parsed as `call`, so we need to really
        # check that it is a function call with parentheses.
        has_parens = any(n -> kind(n) === K"(", children(rhs_cst))
        has_do = any(n -> kind(n) === K"do", children(rhs_cst))
        if has_parens
            has_do
        else
            true # infix operator
        end
    else
        true
    end

    # Add a dot *before* the function if needed.
    if kind(cst) === K"dotcall" && is_dotted_operator
        add_node!(
            call_node,
            FST(PUNCTUATION, -1, rhs.startline, rhs.startline, "."),
            s;
            join_lines = true,
        )
    end

    # Add the function, parenthesising if needed.
    maybe_parenthesised_caller_node = if caller_needs_parens
        parens_fst = FST(Brackets, nspaces(s))
        add_node!(
            parens_fst,
            FST(PUNCTUATION, -1, rhs.startline, rhs.startline, "("),
            s;
            join_lines = true,
        )
        add_node!(parens_fst, Placeholder(0), s; join_lines = true)
        add_node!(parens_fst, rhs, s; join_lines = true)
        add_node!(parens_fst, Placeholder(0), s; join_lines = true)
        add_node!(
            parens_fst,
            FST(PUNCTUATION, -1, rhs.startline, rhs.startline, ")"),
            s;
            join_lines = true,
        )
        parens_fst
    else
        rhs
    end
    add_node!(call_node, maybe_parenthesised_caller_node, s; join_lines = true)

    # Add a dot *after* the function if needed.
    if kind(cst) === K"dotcall" && !is_dotted_operator
        add_node!(
            call_node,
            FST(PUNCTUATION, -1, rhs.startline, rhs.startline, "."),
            s;
            join_lines = true,
        )
    end

    # Handle the callee.
    nest =
        should_allow_nesting_call_args([cst[lhs_idx]], s.opts.disallow_single_arg_nesting)
    add_node!(
        call_node,
        FST(PUNCTUATION, -1, rhs.startline, rhs.startline, "("),
        s;
        join_lines = true,
    )
    if nest
        add_node!(call_node, Placeholder(0), s)
    end
    add_node!(call_node, lhs, s; join_lines = true)
    if nest
        add_node!(call_node, TrailingComma(), s)
        add_node!(call_node, Placeholder(0), s)
    end
    add_node!(
        call_node,
        FST(PUNCTUATION, -1, rhs.startline, rhs.startline, ")"),
        s;
        join_lines = true,
    )

    return call_node
end

function p_binaryopcall(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Binary, nspaces(s))
    if !haschildren(cst)
        return t
    end

    childs = children(cst)
    op_indices = source_operator_indices(cst)
    opkind = source_op_kind(s, cst)
    lhs_idx = findfirst(n -> !JuliaSyntax.is_whitespace(n), childs)
    rhs_idx = findlast(n -> !JuliaSyntax.is_whitespace(n), childs)

    # Intercept piped function calls and construct a normal function call FST instead. NOTE:
    # If overloading `p_binaryopcall` for a custom style you will have to make sure to
    # include this logic!
    if opkind === K"|>" &&
       s.opts.pipe_to_function_call &&
       can_transform_syntax(s, false) &&
       rhs_idx !== nothing
        # We purposely exclude one more case: `x .|> (f1, f2)`. This is a very weird Julia
        # quirk where you can broadcast over the _caller_ rather than the callee. There's no
        # equivalent way to express this in function call form, so we shouldn't try to
        # transform it.
        # See https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/647
        rhs_cst = childs[rhs_idx]
        dotted_tuple = kind(cst) === K"dotcall" && kind(rhs_cst) === K"tuple"
        if !dotted_tuple
            return p_pipe_to_call(ds, cst, s, ctx, lineage)
        end
    end

    nonest = ctx.nonest || opkind === K":"

    nrhs = nest_rhs(cst, style)
    if nrhs
        t.nest_behavior = AlwaysNest
    end
    nest = (is_binaryop_nestable(style, cst) && !nonest) || nrhs
    if opkind === K"=>" && haschildren(cst)
        if !isnothing(rhs_idx) && is_str_or_cmd(childs[rhs_idx])
            nest = false
        end
    end

    # Catches e.g. `f(x) = x + 1`; but _not_ `let f(x) = x + 1; body; end` since expanding
    # that would lead to invalid Julia code, and also disable it if it's in a macro/Expr.
    is_short_func = defines_function(cst)
    is_expandable_short_func =
        is_short_func && !ctx.from_let && can_transform_syntax(s, true)
    standalone_binary_circuit = ctx.standalone_binary_circuit

    # For the lhs of a short-form function, we can't enable separate_kwargs_with_semicolon.
    # Find its index now.
    lhs_of_short_func_idx = if is_short_func
        findfirst(Shims.is_caller_in_function_def, childs)
    else
        nothing
    end

    lazy_op = is_lazy_op(opkind)
    # Check if expression is a lazy circuit. If it is, this does two things: first it causes
    # the indentation to be increased for subsequent lines -- for example
    #
    #    aaaaa ||        rather than      aaaaa ||
    #        bbbbb                        bbbbb
    #
    # Secondly if `short_circuit_to_if` is true, then this allows the expression to be
    # expanded to if/elseif/else.
    #
    # cf. https://github.com/JuliaEditorSupport/JuliaFormatter.jl/pull/224
    if lazy_op && standalone_binary_circuit
        if length(lineage) >= 2
            parent_node, _, is_assign = lineage[end-1]
            # Disable if the binary expression is "used" in a certain context --
            # for example
            #
            # parens      (a && b)
            # macrocall   @foo a && b
            # return      return a && b
            # while       while a && b  (see also #940)
            # if          if a && b
            # elseif      elseif a && b
            # ternary     a && b ? c : d
            if parent_node in KSet"parens macrocall return while if elseif ?" || is_assign
                standalone_binary_circuit = false
            end
        end
    end

    is_standalone_shortcircuit = lazy_op && standalone_binary_circuit
    t.metadata = Metadata(
        opkind,
        is_standalone_shortcircuit,
        is_standalone_shortcircuit && can_transform_syntax(s, true),
        is_expandable_short_func,
        is_assignment(cst) || defines_function(cst),
        false,
        false,
    )

    has_ws_around_op = false

    for (i, c) in enumerate(childs)
        if i > 1 && Shims.is_really_whitespace(c)
            has_ws_around_op = true
            break
        end
    end
    # Check if LHS ends, or RHS begins with whitespace
    if lhs_idx !== nothing
        lhs_cst = childs[lhs_idx]
        if has_trailing(lhs_cst, KSet"Whitespace NewlineWs")
            has_ws_around_op = true
        end
    end
    if rhs_idx !== nothing
        rhs_cst = childs[rhs_idx]
        if has_leading(rhs_cst, KSet"Whitespace NewlineWs")
            has_ws_around_op = true
        end
    end

    from_colon = ctx.from_colon
    from_typedef = ctx.from_typedef

    remove_space_around_op = ctx.nospace
    if opkind === K":"
        remove_space_around_op = true
        from_colon = true
    elseif opkind === K"::"
        remove_space_around_op = true
    elseif is_short_func && opkind === K"="
        remove_space_around_op = false
        has_ws_around_op = true
    elseif kind(cst) === K"comparison"
        remove_space_around_op = false
    elseif opkind in KSet"in ∈ isa ."
        remove_space_around_op = false
    elseif from_typedef && opkind in KSet"<: >:"
        if s.opts.whitespace_typedefs
            remove_space_around_op = false
            has_ws_around_op = true
        else
            remove_space_around_op = true
            has_ws_around_op = false
        end
    elseif ctx.from_ref || from_colon
        if s.opts.whitespace_ops_in_indices
            remove_space_around_op = false
            has_ws_around_op = true
        else
            remove_space_around_op = true
            has_ws_around_op = false
        end
    elseif from_colon
        remove_space_around_op = true
    end
    nws = !remove_space_around_op && has_ws_around_op ? 1 : 0

    has_dot = false
    if kind(cst) === K"dotcall"
        remove_space_around_op = false
        nws = 1
        has_dot = true
    end

    nlws_count = 0
    after_op = false
    skip_until = 0
    for (i, c) in enumerate(childs)
        i <= skip_until && continue

        # Determine whether we can separate kwargs with a semicolon.
        can_separate_kwargs = if opkind === K"::"
            # Pass through to children, since `::` might be used in function definitions.
            ctx.can_separate_kwargs
        elseif is_short_func && i === lhs_of_short_func_idx
            # Not for the lhs of a function definition.
            false
        else
            # Everywhere else is fine.
            true
        end

        if kind(cst) === K"op=" && !isempty(op_indices) && i == first(op_indices)
            loc = cursor_loc(s)
            op_span = sum(span, childs[first(op_indices):last(op_indices)]; init = 0)
            val = getsrcval(s.doc, (s.offset):(s.offset+op_span-1))
            s.offset += op_span
            n = FST(OPERATOR, loc[2], loc[1], loc[1], val)
            n.metadata = Metadata(K"op=")
            if nws > 0 && i > 1
                add_node!(t, Whitespace(nws), s)
            end
            add_node!(t, n, s; join_lines = true)
            if nws > 0
                if nest
                    add_node!(t, Placeholder(nws), s)
                else
                    add_node!(t, Whitespace(nws), s)
                end
            end
            after_op = true
            skip_until = last(op_indices)
            continue
        end

        offset = s.offset
        n = pretty(
            style,
            c,
            s,
            newctx(
                ctx;
                standalone_binary_circuit = standalone_binary_circuit &&
                                            !(is_lazy_op(c) && kind(c) !== opkind),
                can_separate_kwargs = can_separate_kwargs,
                nonest = nonest,
                from_colon = from_colon,
            ),
            lineage,
        )

        is_dot = kind(c) === K"."
        is_op = i in op_indices && is_source_operator(s, c, offset)
        if is_op && n.typ === IDENTIFIER
            n.typ = OPERATOR
            n.metadata =
                Metadata(source_op_kind_from_offset(s, c, offset)::JuliaSyntax.Kind)
        end
        if is_dot && haschildren(c) && length(children(c)) == 2
            # [.]
            #   .
            #   <=
            ns = is_dot ? 1 : nws

            # Add whitespace before the operator, unless it's a dot in a dotted operator
            if ns > 0
                add_node!(t, Whitespace(ns), s)
            end
            add_node!(t, n, s; join_lines = true)
            # Add whitespace after the operator
            if ns > 0
                if nest
                    add_node!(t, Placeholder(ns), s)
                else
                    add_node!(t, Whitespace(ns), s)
                end
            end
            after_op = true
        elseif is_op && !haschildren(c)
            # there are some weird cases where we can assign an operator a value so that
            # the arguments are operators as well.
            #
            # a .* %
            ns = is_dot ? 1 : nws

            # Add whitespace before the operator, unless it's a dot in a dotted operator
            if ns > 0 && i > 1
                if kind(childs[i-1]) !== K"."  # Don't add space if previous was a dot
                    add_node!(t, Whitespace(ns), s)
                elseif kind(childs[i-1]) === K"." && haschildren(childs[i-1])  # Don't add space if previous was a dot
                    add_node!(t, Whitespace(ns), s)
                end
            end

            add_node!(t, n, s; join_lines = true)

            # Add whitespace after the operator
            if !is_dot && ns > 0
                if nest
                    add_node!(t, Placeholder(ns), s)
                else
                    add_node!(t, Whitespace(ns), s)
                end
            end

            after_op = true
        elseif JuliaSyntax.is_whitespace(c)
            add_node!(t, n, s; join_lines = true)
        else
            if (opkind === K":" && is_opcall(c) && !(kind(c) in KSet"parens ."))
                # Add parentheses around expressions on either side of a range. We manually
                # exclude field access to avoid parenthesising e.g. [1:a.b] -> [1:(a.b)].
                # TODO(penelopeysm): Add a config option for this parenthesisation (false
                # should preserve the original parens, true should add parens if there are
                # none).
                bracket_fst = FST(Brackets, nspaces(s))
                add_node!(
                    bracket_fst,
                    FST(PUNCTUATION, -1, n.startline, n.startline, "("),
                    s;
                    join_lines = true,
                )
                if after_op
                    add_node!(
                        bracket_fst,
                        n,
                        s;
                        join_lines = true,
                        override_join_lines_based_on_source = !nest,
                    )
                else
                    add_node!(bracket_fst, n, s; join_lines = true)
                end
                add_node!(
                    bracket_fst,
                    FST(PUNCTUATION, -1, n.startline, n.startline, ")"),
                    s;
                    join_lines = true,
                )
                add_node!(t, bracket_fst, s; join_lines = true)
            else
                if after_op
                    add_node!(
                        t,
                        n,
                        s;
                        join_lines = true,
                        override_join_lines_based_on_source = !nest,
                    )
                else
                    add_node!(t, n, s; join_lines = true)
                end
            end
        end

        if kind(c) === K"NewlineWs"
            nlws_count += 1
        end
    end

    if nest && (
        kind(cst) === K"op=" ||
        length(op_indices) == 1 ||
        (length(op_indices) == 2 && has_dot)
    )
        # for indent, will be converted to `indent` if needed
        insert!(t.nodes::Vector{FST}, length(t.nodes::Vector{FST}), Placeholder(0))
    end

    t
end

function p_whereopcall(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Where, nspaces(s))
    if !haschildren(cst)
        return t
    end

    args = get_args(cst)
    nest = should_allow_nesting_call_args(args, s.opts.disallow_single_arg_nesting)

    childs = children(cst)
    where_idx = findfirst(c -> kind(c) === K"where" && !haschildren(c), childs)
    curly_ctx = if where_idx === nothing
        ctx.from_typedef
    else
        if !(ctx.from_typedef)
            any(c -> kind(c) in KSet"curly bracescat braces", childs[(where_idx+1):end])
        else
            true
        end
    end
    add_braces = s.opts.surround_whereop_typeparameters && !curly_ctx

    nws = s.opts.whitespace_typedefs ? 1 : 0

    after_where = false
    for (i, a) in enumerate(childs)
        if kind(a) === K"where" && !haschildren(a)
            add_node!(t, Whitespace(1), s)
            add_node!(t, pretty(style, a, s, ctx, lineage), s; join_lines = true)
            add_node!(t, Whitespace(1), s)
            after_where = true
        elseif kind(a) === K"{" && nest
            add_node!(t, pretty(style, a, s, ctx, lineage), s; join_lines = true)
            add_node!(t, Placeholder(0), s)
            s.indent += s.opts.indent
        elseif kind(a) === K"}" && nest
            add_node!(t, TrailingComma(), s)
            add_node!(t, Placeholder(0), s)
            add_node!(t, pretty(style, a, s, ctx, lineage), s; join_lines = true)
            s.indent -= s.opts.indent
        elseif kind(a) === K","
            add_node!(t, pretty(style, a, s, ctx, lineage), s; join_lines = true)
            if has_more_args_to_come(childs, i + 1, K"}")
                add_node!(t, Placeholder(nws), s)
            end
        elseif JuliaSyntax.is_whitespace(a)
            add_node!(t, pretty(style, a, s), s; join_lines = true)
        else
            n = pretty(style, a, s, newctx(ctx; from_typedef = after_where), lineage)
            if after_where && add_braces
                # Essentially, here we're doing the same thing as in p_braces, because we
                # want to make sure that it generates the same FST. This is another case
                # where it would be really useful to have an IR where we can make such
                # transformations prior to generating the FST.
                brace_fst = FST(Braces, nspaces(s))
                nest_braces =
                    should_allow_nesting_call_args([a], s.opts.disallow_single_arg_nesting)
                lbrace = FST(PUNCTUATION, -1, n.endline, n.endline, "{")
                add_node!(brace_fst, lbrace, s; join_lines = true)
                nest_braces && add_node!(brace_fst, Placeholder(0), s)
                add_node!(brace_fst, n, s; join_lines = true)
                nest_braces && add_node!(brace_fst, TrailingComma(), s)
                nest_braces && add_node!(brace_fst, Placeholder(0), s)
                rbrace = FST(PUNCTUATION, -1, n.endline, n.endline, "}")
                add_node!(brace_fst, rbrace, s; join_lines = true)
                add_node!(t, brace_fst, s; join_lines = true)
            else
                add_node!(t, n, s; join_lines = true)
            end
        end
    end

    t
end

function p_conditionalopcall(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Conditional, nspaces(s))
    if !haschildren(cst)
        return t
    end

    for c in children(cst)
        if kind(c) in KSet"? :" && !haschildren(c)
            add_node!(t, Whitespace(1), s)
            add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
            add_node!(t, Placeholder(1), s)
        else
            add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
        end
    end

    t
end

function p_unaryopcall(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
    is_prefix::Bool,
)
    style = getstyle(ds)
    t = FST(Unary, nspaces(s))
    if !haschildren(cst)
        return t
    end

    childs = children(cst)
    first_idx = findfirst(n -> !JuliaSyntax.is_whitespace(n), childs)
    op_idx = source_unary_operator_index(is_prefix, cst, s)
    if isnothing(op_idx)
        op_idx = first_idx
    end
    opkind = isnothing(op_idx) ? op_kind(cst) : source_op_kind(s, cst)

    t.metadata = Metadata(opkind)

    for (i, c) in enumerate(childs)
        offset = s.offset
        if i > 1 && kind(c) === K"Whitespace"
            add_node!(t, Whitespace(1), s)
        end
        n = pretty(style, c, s, ctx, lineage)
        if i == op_idx && n.typ === IDENTIFIER
            k = source_op_kind_from_offset(s, c, offset)
            if !isnothing(k)
                n.typ = OPERATOR
                n.metadata = Metadata(k)
            end
        end
        add_node!(t, n, s; join_lines = true)
    end
    t
end

function p_curly(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Curly, nspaces(s))
    if !haschildren(cst)
        return t
    end

    args = get_args(cst)
    nest = should_allow_nesting_call_args(args, s.opts.disallow_single_arg_nesting)

    nws = s.opts.whitespace_typedefs ? 1 : 0

    childs = children(cst)
    for (i, a) in enumerate(childs)
        n = pretty(style, a, s, newctx(ctx; from_typedef = true), lineage)

        if kind(a) === K"{"
            add_node!(t, n, s; join_lines = true)
            if nest
                add_node!(t, Placeholder(0), s)
            end
        elseif kind(a) === K"}"
            if nest
                add_node!(t, TrailingComma(), s)
                add_node!(t, Placeholder(0), s)
            end
            add_node!(t, n, s; join_lines = true)
        elseif kind(a) === K","
            add_node!(t, n, s; join_lines = true)
            if has_more_args_to_come(childs, i + 1, K"}")
                add_node!(t, Placeholder(nws), s)
            end
        else
            add_node!(t, n, s; join_lines = true)
        end
    end
    t
end

function p_call(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}};
    do_block_idx::Union{Int,Nothing} = nothing,
)
    style = getstyle(ds)
    t = FST(Call, nspaces(s))
    if !haschildren(cst)
        return t
    end

    # If `ctx.can_separate_kwargs` is false, we don't want to modify the semicolon in this
    # particular call expression; but we CAN re-enable it for its children. For example, in
    #
    #     function foo(
    #         a,
    #         b=goo(x, y=z)
    #     )
    #         body
    #     end
    #
    # we don't want to change the comma between `a` and `b`, but we can change the comma
    # between `x` and `y=z`. So we reset `can_separate_kwargs` to true for the children of
    # this call expression.
    can_separate_kwargs_for_this_call = ctx.can_separate_kwargs
    ctx = newctx(ctx; can_separate_kwargs = true)

    childs = children(cst)
    if !isnothing(do_block_idx)
        if !checkbounds(Bool, childs, do_block_idx) ||
           kind(childs[do_block_idx]) !== K"do" ||
           !haschildren(childs[do_block_idx])
            error("p_call called with an invalid do block index")
        end
        childs = childs[1:(do_block_idx-1)]
    end

    caller_idx = findfirst(n -> !JuliaSyntax.is_whitespace(n), childs)
    args = call_args(childs)
    nest = should_allow_nesting_call_args(args, s.opts.disallow_single_arg_nesting)

    for (i, a) in enumerate(childs)
        k = kind(a)
        if k === K"("
            n = pretty(style, a, s, ctx, lineage)
            add_node!(t, n, s; join_lines = true)
            if nest
                add_node!(t, Placeholder(0), s)
            end
        elseif k === K")"
            n = pretty(style, a, s, ctx, lineage)
            if nest
                add_node!(t, TrailingComma(), s)
                add_node!(t, Placeholder(0), s)
            end
            add_node!(t, n, s; join_lines = true)
        elseif k === K","
            n = pretty(style, a, s, ctx, lineage)
            add_node!(t, n, s; join_lines = true)

            # figure out if we need to put a placeholder
            if has_more_args_to_come(childs, i + 1, K")")
                add_node!(t, Placeholder(1), s)
            end
        elseif k == K"=" && haschildren(a)
            n = p_kw(style, a, s, ctx, lineage)
            add_node!(t, n, s; join_lines = true)
        else
            # If the caller is parenthesised (usually callable struct, but not necessarily),
            # avoid inserting placeholders after ( and before ), because that causes
            # JuliaSyntax@1.0.2 to parse it wrongly. Hopefully this will be fixed one day
            # https://github.com/JuliaLang/julia/issues/62124 but we have to keep it in
            # for now since it's already broken on Julia 1.12.6.
            ctx2 = if i == caller_idx && k === K"parens" && haschildren(a)
                newctx(ctx; is_parenthesised_caller = true)
            else
                ctx
            end
            n = pretty(style, a, s, ctx2, lineage)
            add_node!(t, n, s; join_lines = true)
        end
    end

    if (
        s.opts.separate_kwargs_with_semicolon &&
        can_separate_kwargs_for_this_call &&
        can_transform_syntax(s, false)
    )
        separate_kwargs_with_semicolon!(t)
    end

    t
end

function p_parens(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Brackets, nspaces(s))
    if !haschildren(cst)
        return t
    end

    args = get_args(cst)
    nest = if length(args) > 0
        arg = args[1]
        if is_block(arg, style) || (
            # this branch covers something like (BLOCK for x in y)
            kind(arg) === K"generator" && first_nontrivial_child_is_block(arg, style)
        )
            t.nest_behavior = AlwaysNest
        end
        if !ctx.nonest && !s.opts.disallow_single_arg_nesting
            !is_iterable(arg)
        else
            false
        end
    else
        false
    end

    # This is a workaround for 
    # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/1114
    # https://github.com/JuliaLang/julia/issues/62124
    #
    # For a construct like
    #
    #     function (expr)(args...) [where S [where T ...]]
    #         body
    #     end
    #
    # we can't put newlines around `expr` as that causes JuliaSyntax to
    # parse the resulting code incorrectly.
    #
    # The case we want to catch is K"function" [-> K"where"]* -> K"call" -> K"parens"
    function is_from_function_def(lineage)
        length(lineage) >= 3 || return false
        lineage[end][1] === K"parens" || return false
        lineage[end-1][1] === K"call" || return false
        # any number of `where`s
        i = length(lineage) - 2
        while i > 0 && lineage[i][1] === K"where"
            i -= 1
        end
        return i > 0 && lineage[i][1] === K"function"
    end
    disable_nesting = (ctx.is_parenthesised_caller && is_from_function_def(lineage))
    nest = nest && !disable_nesting
    # turn off the is_parenthesised_caller flag so that it's not propagated to children.
    ctx = newctx(ctx; is_parenthesised_caller = false)

    for c in children(cst)
        if kind(c) === K"("
            add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
            if nest
                add_node!(t, Placeholder(0), s)
            end
        elseif kind(c) === K")"
            if nest
                add_node!(t, Placeholder(0), s)
            end
            add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
        elseif kind(c) === K"block"
            add_node!(
                t,
                pretty(style, c, s, newctx(ctx; from_quote = true), lineage),
                s;
                join_lines = true,
            )
        elseif is_opcall(c)
            add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
        else
            add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
        end
    end

    t
end

function p_tupleblock(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(TupleBlock, nspaces(s))
    if !haschildren(cst)
        return t
    end

    args = get_args(cst)
    nest = should_allow_nesting_call_args(args, s.opts.disallow_single_arg_nesting)

    childs = children(cst)
    for (i, a) in enumerate(childs)
        n = if kind(a) === K"=" && haschildren(a)
            p_kw(style, a, s, ctx, lineage)
        else
            pretty(style, a, s, ctx, lineage)
        end
        if kind(a) === K"("
            add_node!(t, n, s; join_lines = true)
            if nest
                add_node!(t, Placeholder(0), s)
            end
        elseif kind(a) === K")"
            if nest
                add_node!(t, Placeholder(0), s)
            end
            add_node!(t, n, s; join_lines = true)
        elseif kind(a) in KSet", ;"
            add_node!(t, n, s; join_lines = true)
            if has_more_args_to_come(childs, i + 1, K")")
                add_node!(t, Placeholder(1), s)
            end
        else
            add_node!(t, n, s; join_lines = true)
        end
    end
    t
end

function p_tuple(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(TupleN, nspaces(s))
    if !haschildren(cst)
        return t
    end

    args = get_args(cst)
    allow_nest = should_allow_nesting_call_args(args, s.opts.disallow_single_arg_nesting)

    childs = children(cst)
    for (i, a) in enumerate(childs)
        n = if kind(a) === K"=" && haschildren(a)
            p_kw(style, a, s, ctx, lineage)
        else
            pretty(style, a, s, ctx, lineage)
        end

        if kind(a) === K"("
            add_node!(t, n, s; join_lines = true)
            if allow_nest
                add_node!(t, Placeholder(0), s)
            end
        elseif kind(a) === K")"
            # An odd case but this could occur if there are no keyword arguments.
            # In which case ";," is invalid syntax.
            #
            # no trailing comma since (arg) is semantically different from (arg,) !!!
            if allow_nest
                if t[end].typ !== SEMICOLON && length(args) > 1
                    add_node!(t, TrailingComma(), s)
                end
                add_node!(t, Placeholder(0), s)
            end
            add_node!(t, n, s; join_lines = true)
        elseif kind(a) in KSet", ;"
            add_node!(t, n, s; join_lines = true)
            if has_more_args_to_come(childs, i + 1, K")")
                add_node!(t, Placeholder(1), s)
            end
        else
            add_node!(t, n, s; join_lines = true)
        end
    end
    t
end

function p_braces(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Braces, nspaces(s))
    if !haschildren(cst)
        return t
    end

    args = get_args(cst)
    nest = should_allow_nesting_call_args(args, s.opts.disallow_single_arg_nesting)

    nws = ctx.from_typedef && !s.opts.whitespace_typedefs ? 0 : 1

    childs = children(cst)
    for (i, a) in enumerate(childs)
        n = pretty(style, a, s, ctx, lineage)

        if kind(a) === K"{"
            add_node!(t, n, s; join_lines = true)
            if nest
                add_node!(t, Placeholder(0), s)
            end
        elseif kind(a) === K"}"
            if nest
                add_node!(t, TrailingComma(), s)
                add_node!(t, Placeholder(0), s)
            end
            add_node!(t, n, s; join_lines = true)
        elseif kind(a) === K","
            add_node!(t, n, s; join_lines = true)
            if has_more_args_to_come(childs, i + 1, K"}")
                add_node!(t, Placeholder(nws), s)
            end
        else
            add_node!(t, n, s; join_lines = true)
        end
    end
    t
end

function p_bracescat(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(BracesCat, nspaces(s))
    if !haschildren(cst)
        return t
    end

    args = get_args(cst)
    nest = should_allow_nesting_call_args(args, s.opts.disallow_single_arg_nesting)

    nws = ctx.from_typedef && !s.opts.whitespace_typedefs ? 0 : 1
    childs = children(cst)

    for (i, a) in enumerate(childs)
        n = pretty(style, a, s, ctx, lineage)

        if kind(a) === K"{"
            add_node!(t, n, s; join_lines = true)
            if nest
                add_node!(t, Placeholder(0), s)
            else
                false
            end
        elseif kind(a) === K"}"
            if nest
                add_node!(t, Placeholder(0), s)
            end
            add_node!(t, n, s; join_lines = true)
        elseif kind(a) === K";"
            if has_more_args_to_come(childs, i + 1, K"}")
                add_node!(t, n, s; join_lines = true)
                add_node!(t, Placeholder(nws), s)
            end
        else
            add_node!(t, n, s; join_lines = true)
        end
    end
    t
end

function p_vect(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Vect, nspaces(s))
    if !haschildren(cst)
        return t
    end

    args = get_args(cst)
    nest = should_allow_nesting_call_args(args, s.opts.disallow_single_arg_nesting)

    childs = children(cst)
    for (i, a) in enumerate(childs)
        n = pretty(style, a, s, ctx, lineage)

        if kind(a) === K"["
            add_node!(t, n, s; join_lines = true)
            if nest
                add_node!(t, Placeholder(0), s)
            else
                false
            end
        elseif kind(a) === K"]"
            if nest
                add_node!(t, TrailingComma(), s)
                add_node!(t, Placeholder(0), s)
            end
            add_node!(t, n, s; join_lines = true)
        elseif kind(a) === K","
            add_node!(t, n, s; join_lines = true)
            if has_more_args_to_come(childs, i + 1, K"]")
                add_node!(t, Placeholder(1), s)
            end
        else
            add_node!(t, n, s; join_lines = true)
        end
    end
    t
end

function p_comprehension(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Comprehension, nspaces(s))
    if !haschildren(cst)
        return t
    end

    childs = children(cst)

    opening_brace_idx = findfirst(n -> kind(n) === K"[", childs)
    body_idx = findnext(n -> !JuliaSyntax.is_whitespace(n), childs, opening_brace_idx + 1)
    body_arg = childs[body_idx]

    if is_block(body_arg, style) || (
        # this branch covers something like [BLOCK for x in y]
        kind(body_arg) === K"generator" && first_nontrivial_child_is_block(body_arg, style)
    )
        t.nest_behavior = AlwaysNest
    end

    for c in childs
        n = pretty(style, c, s, ctx, lineage)
        if kind(c) === K"["
            add_node!(t, n, s; join_lines = true)
            add_node!(t, Placeholder(0), s)
        elseif kind(c) === K"]"
            add_node!(t, Placeholder(0), s)
            add_node!(t, n, s; join_lines = true)
        else
            add_node!(t, n, s; join_lines = true)
        end
    end

    t
end

function p_typedcomprehension(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    t = p_comprehension(ds, cst, s, ctx, lineage)
    t.typ = TypedComprehension
    t
end

function p_parameters(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Parameters, nspaces(s))
    if !haschildren(cst)
        return t
    end

    nws = ctx.from_typedef && !s.opts.whitespace_typedefs ? 0 : 1

    childs = children(cst)
    for (i, a) in enumerate(childs)
        n = if kind(a) === K"=" && haschildren(a)
            p_kw(style, a, s, ctx, lineage)
        else
            pretty(style, a, s, ctx, lineage)
        end

        if kind(a) in KSet", ;"
            add_node!(t, n, s; join_lines = true)
            if has_more_args_to_come(childs, i + 1, K")")
                add_node!(t, Placeholder(nws), s)
            end
        else
            add_node!(t, n, s; join_lines = true)
        end
    end
    t
end

_maybe_linebreak_after_import_colon(::AbstractStyle) = true
function p_import(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Import, nspaces(s))
    if !haschildren(cst)
        return t
    end

    for a in children(cst)
        if kind(a) in KSet"import using"
            add_node!(t, pretty(style, a, s, ctx, lineage), s; join_lines = true)
            add_node!(t, Whitespace(1), s)
        elseif kind(a) === K":" && haschildren(a)
            nodes = children(a)
            for n in nodes
                add_node!(t, pretty(style, n, s, ctx, lineage), s; join_lines = true)
                if kind(n) in KSet"import using"
                    add_node!(t, Whitespace(1), s)
                elseif kind(n) === K","
                    add_node!(t, Placeholder(1), s)
                elseif kind(n) === K":"
                    if _maybe_linebreak_after_import_colon(style)
                        # true for most but false for YAS
                        add_node!(t, Placeholder(1), s)
                    else
                        add_node!(t, Whitespace(1), s)
                    end
                end
            end
        elseif kind(a) in KSet", :"
            add_node!(t, pretty(style, a, s, ctx, lineage), s; join_lines = true)
            add_node!(t, Placeholder(1), s)
        else
            add_node!(t, pretty(style, a, s, ctx, lineage), s; join_lines = true)
        end
    end
    t
end

function p_export(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Export, nspaces(s))
    if !haschildren(cst)
        return t
    end

    for a in children(cst)
        add_node!(t, pretty(style, a, s, ctx, lineage), s; join_lines = true)
        if kind(a) in KSet"export public"
            add_node!(t, Whitespace(1), s)
        elseif kind(a) === K","
            add_node!(t, Placeholder(1), s)
        end
    end
    t
end

function p_public(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    t = p_export(ds, cst, s, ctx, lineage)
    t.typ = Public
    t
end

function p_using(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    t = p_import(ds, cst, s, ctx, lineage)
    t.typ = Using
    t
end

function p_importpath(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(ImportPath, nspaces(s))
    if !haschildren(cst)
        return t
    end

    for a in children(cst)
        n = pretty(style, a, s, ctx, lineage)
        add_node!(t, n, s; join_lines = true)
    end
    t
end

function p_as(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(As, nspaces(s))
    if !haschildren(cst)
        return t
    end

    for c in children(cst)
        n = pretty(style, c, s, ctx, lineage)
        if kind(c) === K"as"
            add_node!(t, Whitespace(1), s)
            add_node!(t, n, s; join_lines = true)
            add_node!(t, Whitespace(1), s)
        else
            add_node!(t, n, s; join_lines = true)
        end
    end

    t
end

function p_ref(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(RefN, nspaces(s))
    if !haschildren(cst)
        return t
    end

    args = get_args(cst)
    nest = length(args) > 1

    childs = children(cst)
    for (i, a) in enumerate(childs)
        if kind(a) === K"]"
            if nest
                add_node!(t, TrailingComma(), s)
                add_node!(t, Placeholder(0), s)
            end
            add_node!(t, pretty(style, a, s, ctx, lineage), s; join_lines = true)
        elseif kind(a) === K"["
            add_node!(t, pretty(style, a, s, ctx, lineage), s; join_lines = true)
            if nest
                add_node!(t, Placeholder(0), s)
            else
                false
            end
        elseif kind(a) === K","
            add_node!(t, pretty(style, a, s, ctx, lineage), s; join_lines = true)
            if has_more_args_to_come(childs, i + 1, K"]")
                add_node!(t, Placeholder(1), s)
            end
        elseif is_opcall(a)
            n = pretty(style, a, s, newctx(ctx; from_ref = true, nonest = true), lineage)
            add_node!(t, n, s; join_lines = true)
        else
            add_node!(t, pretty(style, a, s, ctx, lineage), s; join_lines = true)
        end
    end
    t
end

function p_vcat(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Vcat, nspaces(s))
    if !haschildren(cst)
        return t
    end

    args = get_args(cst)
    nest = should_allow_nesting_call_args(args, s.opts.disallow_single_arg_nesting)
    childs = children(cst)
    opening_idx = findfirst(n -> kind(n) === K"[", childs)::Int
    closing_idx = findlast(n -> kind(n) === K"]", childs)::Int
    first_arg_idx = findnext(n -> !JuliaSyntax.is_whitespace(n), childs, opening_idx + 1)
    last_arg_idx = findprev(n -> !JuliaSyntax.is_whitespace(n), childs, closing_idx - 1)

    for (i, a) in enumerate(childs)
        n = if i == last_arg_idx
            ctx2 = newctx(ctx; is_last_ncat_or_nrow_arg = true)
            pretty(style, a, s, ctx2, lineage)
        else
            pretty(style, a, s)
        end

        diff_line = t.endline != t.startline
        # If arguments are on different lines then always nest
        if diff_line
            t.nest_behavior = AlwaysNest
        end

        if kind(a) === K"["
            add_node!(t, n, s; join_lines = true)
            if nest
                add_node!(t, Placeholder(0), s)
            end
        elseif kind(a) === K"]"
            if nest
                add_node!(t, Placeholder(0), s)
            end
            add_node!(t, n, s; join_lines = true)
        elseif JuliaSyntax.is_whitespace(a)
            add_node!(t, n, s; join_lines = true)
        elseif kind(a) === K";"
            add_node!(t, n, s; join_lines = true)
        else
            if !isnothing(first_arg_idx) && i > first_arg_idx
                # Remove newline from **inside** the last argument if present. That newline
                # might be semantically significant, so this seems dangerous.
                #
                # However, we are going to add a Placeholder back right after this, and
                # because the presence of a newline indicates that there was one in the
                # source, `diff_line` above will be true, and we can guarantee that the
                # Placeholder will eventually be converted into a newline.
                #
                # Using the Placeholder over the Newline ensures that subsequent nodes in
                # the FST will be indented correctly.
                #
                # This is 100% a hack, but undoing this requires rewriting the structure of
                # the CST so that the newlines between arguments are part of the top-level
                # structure rather than being buried inside the arguments themselves.
                if is_prev_newline(t)
                    remove_prev_newline!(t)
                end
                add_node!(t, Placeholder(1), s)
            end

            add_node!(t, n, s; join_lines = true)
        end
    end
    t
end

function p_typedvcat(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    t = p_vcat(ds, cst, s, ctx, lineage)
    t.typ = TypedVcat
    t
end

"""
    is_newline_after_2semicolons(cst::JuliaSyntax.GreenNode, i::Int)

Detect if child node `i` of `cst` is a newline that follows two semicolons. For example,
this will detect the newline in constructs such as

    [a b;;
     c d]
"""
function is_newline_after_2semicolons(cst::JuliaSyntax.GreenNode, i::Int)
    return i >= 3 &&
           kind(cst[i]) === K"NewlineWs" &&
           kind(cst[i-1]) === K";" &&
           kind(cst[i-2]) === K";"
end

"""
    hcat_allow_boundary_newlines(style::AbstractStyle)

Determine whether newlines are allowed immediately after the opening `[` and immediately
before the closing `]` of an hcat node.

Most styles allow this, but YAS doesn't (and SciML too, since it dispatches to YAS).

In principle this can be generalised to vcat and ncat as well; I just haven't done so.
"""
hcat_allow_boundary_newlines(::AbstractStyle) = true

function p_hcat(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Hcat, nspaces(s))
    if !haschildren(cst)
        return t
    end
    childs = children(cst)

    # Identify the first argument inside the square brackets
    idx = findfirst(n -> kind(n) === K"[", childs)::Int
    first_arg_idx = findnext(n -> !JuliaSyntax.is_whitespace(n), childs, idx + 1)

    # Handling newlines in hcat nodes
    # -------------------------------
    #
    # hcat is very sensitive towards newlines. There are several potential separators that
    # *semantically*, lead to horizontal concatenation of the arguments:
    #
    #  (A) spaces, e.g. `[1 2 3]`
    #  (B) double semicolon, e.g. `[1;; 2;; 3;; 4]`
    #  (C) double semicolon followed by newline, e.g. `[1;;\n 2;;\n 3;;\n 4]`
    #
    # However, *syntactically*, an expression is only parsed as a `hcat` if it contains **at
    # least one** space separator (i.e., (A)). That means that 
    #
    #    `[1 2 3]`         -> parsed as hcat
    #    `[1 2;;\n3]`      -> parsed as hcat
    #
    # but anything _without_ space separators is parsed as `ncat`, even if semantically
    # it means the same thing as `hcat`.
    #
    #    `[1;; 2;; 3]`     -> parsed as ncat
    #    `[1;;\n2;;\n3]`   -> parsed as ncat
    #
    # Now, the catch (see the Julia docs:)
    # https://docs.julialang.org/en/v1/manual/arrays/#man-array-concatenation)
    # is that (A) and (B) *cannot* be mixed, but (A) and (C) can be mixed.
    #
    # Given that in this function we *must* have at least one (A) separator, this implies
    # that if we have a (C) ";;\\n", we *must not* remove the newline to make a (B) ";;".
    # Otherwise, this would lead to a mixture of (A) and (B), which is disallowed.
    #
    # Furthermore, it's otherwise illegal to have a newline separator between hcat
    # arguments. The meaning of newline is 'vertical concatenation', and any vertical concat
    # would turn the hcat node into ncat, so a hcat node itself can't have newline
    # separators. This implies that we *must not* add newline separators on our own accord
    # as that would change the semantics.
    #
    # The only other place where newlines are allowed to be present are after the opening
    # `[` and before the closing `]`. Let's call these 'boundary newlines'. We are allowed
    # to decide whether to place boundary newlines. In other words, we can safely insert
    # Placeholder nodes at these positions.

    prev_comment_was_dropped = false
    for (i, a) in enumerate(childs)
        n = pretty(style, a, s, ctx, lineage)
        if kind(a) === K"["
            add_node!(t, n, s; join_lines = true)
            if hcat_allow_boundary_newlines(style)
                add_node!(t, Placeholder(0), s)
            end
        elseif kind(a) === K"]"
            if !hcat_allow_boundary_newlines(style)
                # Always join ] to the last argument: remove the newline from the last
                # argument if it exists
                if is_prev_newline(t)
                    remove_prev_newline!(t)
                end
                add_node!(
                    t,
                    n,
                    s;
                    join_lines = true,
                    override_join_lines_based_on_source = true,
                )
            else
                # Let the nesting algo decide whether to insert a newline
                add_node!(t, Placeholder(0), s)
                add_node!(t, n, s; join_lines = true)
            end
        elseif kind(a) === K";"
            add_node!(t, n, s; join_lines = true)
        elseif JuliaSyntax.is_whitespace(a)
            if kind(a) === K"Comment"
                prev_comment_was_dropped = !add_hasheq_comment!(t, n, s; force_join = true)
            elseif is_newline_after_2semicolons(cst, i)
                # See above: we cannot convert ';;\n' to ';;'
                add_node!(t, Newline(; nest_behavior = AlwaysNest), s)
                # Additionally, because the contents of the hcat will be on different lines
                # and there's no way to later un-nest it without breaking semantics, we can
                # set the nest behaviour of the entire hcat to AlwaysNest. This means that
                # later on, `n_tuple!` will insert newlines after the `[` and before the
                # `].`
                t.nest_behavior = AlwaysNest
                prev_comment_was_dropped = false
            elseif !(kind(cst[i+1]) in KSet"; ] Comment") && !(kind(cst[i-1]) in KSet"; [")
                # Whitespace is generally important to retain, because it can be a separator
                # -- but we should omit it in a few cases:
                # 1. If it's followed by / before a ';;' separator, since it's not needed.
                # 2. Directly after the opening bracket.
                # 3. Directly before the closing bracket.
                #
                # There's also some special logic for comments, because the current way that
                # JuliaFormatter deals with comments is crazily hacky.
                if !isnothing(first_arg_idx) &&
                   i < first_arg_idx &&
                   prev_comment_was_dropped
                    # Before the first argument, after a dropped regular # comment.
                    # Suppress whitespace so NOTCODE gap detection can reconstruct
                    # the comment at the parent level.
                elseif prev_comment_was_dropped
                    # After a dropped regular # comment, past the first argument.
                    # Remove the preceding forced NEWLINE (e.g. from ;;) so that
                    # add_node!'s gap detection is not short-circuited by
                    # is_prev_newline, and can insert NOTCODE for the comment.
                    if is_prev_newline(t)
                        remove_prev_newline!(t)
                    end
                else
                    add_node!(t, Whitespace(1), s)
                end
                prev_comment_was_dropped = false
            else
                prev_comment_was_dropped = false
            end
        elseif i == 1 && kind(a) !== K"["
            # Type preceding the `[`, e.g. `T` in `T[1 2 3]`.
            add_node!(t, n, s; join_lines = true)
        else
            # Argument that is being hcatted. Annoyingly, the CST doesn't always place
            # whitespace between hcat arguments (see e.g. `[1:2 3:4 5:6]`), so sometimes we
            # have to manually add some ourselves.
            # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/1038
            if !JuliaSyntax.is_whitespace(childs[i-1]) && kind(childs[i-1]) !== K"["
                add_node!(t, Whitespace(1), s)
            end
            # If this is the first argument, and we don't want to allow boundary newlines,
            # then we have to force-join it to the opening [, even if the source had a
            # newline after it.
            override_join_lines =
                (i == first_arg_idx) && !hcat_allow_boundary_newlines(style)
            add_node!(
                t,
                n,
                s;
                join_lines = true,
                override_join_lines_based_on_source = override_join_lines,
            )
        end
    end
    t
end

function p_typedhcat(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    t = p_hcat(ds, cst, s, ctx, lineage)
    t.typ = TypedHcat
    t
end

function p_ncat(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    # Unfortunately `ncat` nodes cover a diverse range of syntax and the way the parser
    # groups it can be somewhat inconsistent at times.
    #
    # It's very lucky that we can simply delegate to `p_vcat` and have it Just Work; but
    # it's still worth documenting and understanding this. The main reason why `p_vcat`
    # handles it correctly is because the main separator is a sequence of semicolons (see
    # (1)), and newlines inserted after those separators have no effect on the semantics.
    # This is the same as for a vcat node which has single semicolons as separators.
    #
    # (1) In general, arguments to `ncat` are separated by 2 or more semicolons. The 'main'
    #     separator is the longest contiguous sequence of semicolons.
    #
    #        `[1;; 2]` is ncat with main separator ';;'
    #                           and arguments `1` and `2`
    #
    #        `[1; 2;; 3; 4]` is ncat with main separator ';;'
    #                                 and arguments `1; 2` and `3; 4`
    #
    #        `[1; 2;; 3;;; 4]` is ncat with main separator ';;;'
    #                                   and arguments `1; 2;; 3` and `4`
    #
    # (2) When the arguments don't contain semicolons, they are placed at the top level of
    #     the `ncat` node. The semicolon separators that follow them are also placed at the
    #     top level of the `ncat` node.
    #
    # (3) When the arguments themselves contain semicolons, they are further grouped into `nrow`
    #     nodes. In the above examples, the arguments `1; 2`, `3; 4`, and `1; 2;; 3` are all
    #     parsed as `nrow` nodes.
    #
    # (4) Main separators that follow `nrow` nodes are placed *inside* the `nrow` node, NOT
    #     at the top level of the `ncat` node.
    #
    # (5) When `nrow` nodes contain different *levels* of semicolons, they themselves will
    #     contain `nrow` nodes. Just like for `ncat` nodes, the 'main' separator for the
    #     `nrow` node will be the longest contiguous sequence of semicolons. In the above
    #     examples, the `nrow` node `1; 2;; 3` has main separator ';;' and arguments `1; 2`
    #     `3`.
    t = p_vcat(ds, cst, s, ctx, lineage)
    t.typ = Ncat
    return t
end

function p_typedncat(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    t = p_ncat(ds, cst, s, ctx, lineage)
    t.typ = TypedNcat
    t
end

"""
    is_semantically_important_newline

Checks whether the `i`-th child of `row_cst` is a newline that is semantically important.
See comment in `p_row` for details.
"""
function is_semantically_important_newline(
    row_cst::JuliaSyntax.GreenNode,
    i::Int,
    is_last_arg_of_parent::Bool,
)
    kind(row_cst[i]) === K"NewlineWs" || return false
    n = length(children(row_cst))
    # Start of the row - not important
    i == 1 && return false
    # A newline is not important if it's adjacent to a comment and all the children
    # between the comment and the boundary of the row (start or end) are whitespace.
    #
    # Trailing comment case: all children after this newline are whitespace, and at least
    # one is a comment. Example: `3 4\n # bar\n` — the newline before `# bar` is not a row
    # separator. We don't need to include it.
    if all(j -> JuliaSyntax.is_whitespace(row_cst[j]), (i+1):n) &&
       any(j -> kind(row_cst[j]) === K"Comment", (i+1):n)
        return false
    end
    # Leading comment case: all children before this newline are whitespace, and at least
    # one is a comment. Example: `\n # foo\n 1 2` — the newline after `# foo` is not a row
    # separator. We can drop all newlines after the comment, because the insertion of the
    # newline after the comment is handled by the NOTCODE mechanism later on.
    if all(j -> JuliaSyntax.is_whitespace(row_cst[j]), 1:(i-1)) &&
       any(j -> kind(row_cst[j]) === K"Comment", 1:(i-1))
        return false
    end
    # End of the row -- might be important
    i == n && return (!is_last_arg_of_parent && kind(row_cst[i-1]) !== K";")
    # Otherwise it's important
    return true
end

# `nrow` and `row` nodes both delegate to this function, and the underlying logic is the
# same, but newlines need to be handled differently, which motivates the `ctx.from_nrow`
# and `ctx.is_last_ncat_or_nrow_arg` flags.
#
# There are two kinds of newlines:
#
#  - Those that are semantically *necessary*, because they are used to indicate vertical
#    concatenation. These can be:
#
#    (1) Newlines in the middle of the row: [1\n2;; 3\n4]
#    (2) Newlines at the end of a row: [1 2 3\n4 5 6]. In general, all newlines at the end
#        of a row are considered semantically important, with the exceptions listed below.
#    (3) `hcat` or `row` node that contains at least one space separator. For example:
#        [1 2 ;;\n 3 4] (which is a hcat) or [1 2 ;;\n 3 4 ;;; 5 6 7 8] (which is a row
#        inside an ncat).
#
#  - Those that are semantically *unnecessary*. These could be:
#
#    (4) Newlines at the start of the row, e.g. [\n1 2;; 3 4].
#    (5) Newlines at the end of the row but preceded by a semicolon, e.g. [1; 2;;;\n 3; 4].
#    (6) Newlines at the end of the row but before the closing brace, e.g. [1 2;; 3 4\n].
#
# The annoying thing about JuliaSyntax's parser is that all the newlines are placed inside
# the child nodes rather than the parent nodes. For example, in the last example
#
#     [1 2;; 3 4\n]
#
# the newline is a child of the last row, rather than a child of the ncat. (If it were
# the latter, then this would be trivial to handle since we could just check if it's the
# last child before the closing brace!) This means that we have to thread this information
# into each recursive pretty() call to tell us whether we are allowed to remove the newline
# or not.
function p_row(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    is_last_arg_of_parent = ctx.is_last_ncat_or_nrow_arg

    style = getstyle(ds)
    t = FST(Row, nspaces(s))
    if !haschildren(cst)
        return t
    end

    childs = children(cst)
    first_arg_idx = findfirst(n -> !JuliaSyntax.is_whitespace(n), childs)
    last_arg_idx = findlast(n -> !JuliaSyntax.is_whitespace(n), childs)

    # To detect the final newline i.e. (6) above, we need to handle two cases:
    #
    # (a) Either the newline is part of this node, in which case it will be the last child
    #     of this node.
    # (b) Or this node will have an nrow/row child that ends with a newline.

    for (i, a) in enumerate(childs)
        nonest = is_opcall(a)
        # Threading is_last_ncat_or_nrow_arg through here handles case (b).
        is_last_ncat_or_nrow_arg =
            is_last_arg_of_parent && i == last_arg_idx && kind(a) in KSet"nrow row"
        n = pretty(
            style,
            a,
            s,
            newctx(
                ctx;
                nonest = nonest,
                is_last_ncat_or_nrow_arg = is_last_ncat_or_nrow_arg,
            ),
            lineage,
        )
        if kind(a) === K";"
            add_node!(t, n, s; join_lines = true)
        elseif JuliaSyntax.is_whitespace(a)
            # is_semantically_important_newline handles case (a)
            if is_semantically_important_newline(cst, i, is_last_arg_of_parent)
                # Must force this newline!
                add_node!(t, Newline(; nest_behavior = AlwaysNest), s)
            else
                add_node!(t, n, s; join_lines = true)
            end
        else
            if !isnothing(first_arg_idx) && i > first_arg_idx && !is_prev_newline(t)
                # Insert whitespace before starting a new argument
                add_node!(t, Whitespace(1), s; join_lines = true)
            end
            add_node!(t, n, s; join_lines = true)
        end
    end

    # Prevent the Row *and* its child elements from being nested, unless any of them NEED
    # to be nested. This is very subtle!
    #
    # The problem with unconditionally putting NeverNest is that it actually gets propagated
    # to the children, so if a parent node has NeverNest the children can't nest either,
    # even if the children are set to AlwaysNest. (See the opening lines of `nest!` in
    # src/styles/default/nest.jl.) This can change the meaning of things inside the row's
    # elements if they don't get nested. See
    # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/1168
    #
    # This behaviour of NeverNest is arguably too aggressive, but apparently it is intended.
    # For example, changing that breaks the `align_...` series of options, so we can't
    # really change that without introducing other regressions.
    #
    # The alternative option is to never put NeverNest, just allowing its descendants to
    # nest as they please. The issue with this is that it means that array elements like
    # `f(1, 2)` might end up being nested, which is really ugly.
    if !any_descendant(must_nest, t)
        t.nest_behavior = NeverNest
    end
    t
end

function p_nrow(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    t = p_row(ds, cst, s, newctx(ctx; from_nrow = true), lineage)
    t.typ = NRow
    t
end

function p_generator(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ds)
    t = FST(Generator, nspaces(s))
    JuliaSyntax.is_leaf(cst) && return t

    has_for_kw = false
    from_iterable = false
    for (kind, is_itr, _) in Iterators.reverse(lineage)
        if kind in KSet"parens generator filter"
            continue
        elseif is_itr
            from_iterable = true
            break
        end
    end

    childs = children(cst)

    has_for_kw = findfirst(n -> kind(n) === K"for", childs) !== nothing
    from_for = has_for_kw || ctx.from_for

    for (i, a) in enumerate(childs)
        n = pretty(style, a, s, newctx(ctx; from_for = from_for), lineage)
        if JuliaSyntax.is_keyword(a) && !haschildren(a)
            # for keyword can only be on the following line
            # if this expression is within an iterable expression
            if kind(a) === K"for" && from_iterable
                add_node!(t, Placeholder(1), s)
            else
                add_node!(t, Whitespace(1), s)
            end

            add_node!(t, n, s; join_lines = true)
            add_node!(t, Placeholder(1), s)
        elseif kind(a) === K","
            add_node!(t, n, s; join_lines = true)
            if has_more_args_to_come(childs, i + 1, K")")
                add_node!(t, Placeholder(1), s)
            end
        else
            add_node!(t, n, s; join_lines = true)
        end

        if from_for && kind(a) === K"iteration"
            eq_to_in_normalization!(n, s.opts.always_for_in, s.opts.for_in_replacement)
        end
    end
    t
end

function p_filter(
    ds::AbstractStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    t = p_generator(ds, cst, s, ctx, lineage)
    t.typ = Filter
    t
end

module DefaultTests

using Test
using JuliaSyntax
using JuliaFormatter: JuliaFormatter, DefaultStyle, Options, format_file
using JuliaFormatter.Internal: test_format, ALL_STYLES

function run_pretty(text::String; style = DefaultStyle(), opts = Options())
    d = JuliaFormatter.Document(text)
    s = JuliaFormatter.State(d, opts)
    g = JuliaSyntax.parseall(JuliaSyntax.GreenNode, text; version=JuliaFormatter.SUPPORTED_SYNTAX_VERSION)
    t = JuliaFormatter.pretty(style, g, s)
    t
end
run_pretty(text::String, margin::Int) = run_pretty(text, opts = Options(margin = margin))

function run_nest(text::String; opts = Options(), style = DefaultStyle())
    d = JuliaFormatter.Document(text)
    s = JuliaFormatter.State(d, opts)
    g = JuliaSyntax.parseall(JuliaSyntax.GreenNode, text; version=JuliaFormatter.SUPPORTED_SYNTAX_VERSION)
    t = JuliaFormatter.pretty(style, g, s)
    JuliaFormatter.nest!(style, t, s)
    t, s
end
run_nest(text::String, margin::Int) = run_nest(text, opts = Options(margin = margin))

@testset "Default Style" begin
    @testset "basic" begin
        test_format("", "")
        test_format("a", "a")
        test_format("a  #foo", "a  #foo")
        test_format("#foo", "#foo")
    end

    @testset "hasheq comments" begin
        str = """
        begin
            #=
               Hello, world!
             =#
        end
        """
        test_format(str, str)

        str = """
        #=
        Hello, world!
        =#
        a"""
        test_format(str, str)

        for str in (
            "a #= hi =#",
            "a, #= hi =# b",
            "a #= hi =#, b",
            "a(#= hi =#)",
        )
            test_format(str, str)
        end
    end

    @testset "format toggle" begin
        str = "#! format: off\n module Foo a \n end"
        test_format(str, str)

        str = "#! format: off\n#! format: on"
        test_format(str, str)

        str = """
        begin
            #! format: off
            don't
                  format
                         this
            #! format: on
        end"""
        test_format(str, str)

        str = """
        begin
            #! format: off
            # don't
            #     format
            #            this
            #! format: on
        end"""
        test_format(str, str)

        str = """
        # this should be formatted
        a = f(aaa, bbb, ccc)

        #! format: off
        # anything past this point should not be formatted !!!
        a = f(aaa,
            bbb,ccc)

        c = 102000

        d = @foo 10 20
        #! format: onono

        e = "what the foocho"

        # comment"""
        str_ = """
        # this should be formatted
        a = f(aaa,
            bbb,ccc)

        #! format: off
        # anything past this point should not be formatted !!!
        a = f(aaa,
            bbb,ccc)

        c = 102000

        d = @foo 10 20
        #! format: onono

        e = "what the foocho"

        # comment"""
        test_format(str_, str)

        str = """
        # this should be formatted
        a = f(aaa, bbb, ccc)

        #! format: off
        # this section is not formatted !!!
        a = f(aaa,
            bbb,ccc)

        c = 102000

        d = @foo 10 20
        # turning formatting back on
        #! format: on
        # back in business !!!

        e = "what the foocho"
        a = f(aaa, bbb, ccc)

        #! format: off
        b = 10*20
        #! format: on
        b = 10 * 20

        # comment"""

        str_ = """
        # this should be formatted
        a = f(aaa, bbb, ccc)

        #! format: off
        # this section is not formatted !!!
        a = f(aaa,
            bbb,ccc)

        c = 102000

        d = @foo 10 20
        # turning formatting back on
        #! format: on
        # back in business !!!

        e = "what the foocho"
        a = f(aaa,
            bbb,      ccc)

        #! format: off
        b = 10*20
        #! format: on
        b = 10 *20

        # comment"""
        test_format(str_, str)

        str = """
        # this should be formatted
        a = f(aaa, bbb, ccc)

        #! format: off
        # this section is not formatted !!!
        a = f(aaa,
            bbb,ccc)

        c = 102000

        #=
        α
        =#
        x =      1

        d = @foo 10 20"""
        test_format(str, str)
    end

    @testset "dot op" begin
        test_format("10 .^ a", "10 .^ a")
        test_format("10.0 .^ a", "10.0 .^ a")
        test_format("a.^b", "a .^ b")
        test_format("a.^10.", "a .^ 10.0")
        test_format("a.//10", "a .// 10")

        test_format("a .^ b", "a .^ b")
        test_format("a .^ 10.", "a .^ 10.0")
        test_format("a .// 10", "a .// 10")
    end

    @testset "toplevel" begin
        str = """

        hello = "string";

        a = 10;


        c = 50;

        #comment"""
        str_ = """

        hello = "string";

        a = 10        ;


        c = 50;

        #comment"""
        test_format(str_, str)
        t = run_pretty(str, 80)
        @test length(t) == 17
    end

    @testset "for = vs in normalization" begin
        str = """
        for i = 1:n
            println(i)
        end"""
        test_format(str, str)

        str = """
        for i in itr
            println(i)
        end"""
        test_format(str, str)

        str = """
        for i = 1:n
            println(i)
        end"""
        str_ = """
        for i in 1:n
            println(i)
        end"""
        test_format(str_, str)

        str = """
        for i in itr
            println(i)
        end"""
        str_ = """
        for i = itr
            println(i)
        end"""
        test_format(str_, str)

        str_ = """
        for i = I1, j in I2
            println(i, j)
        end"""
        str = """
        for i in I1, j in I2
            println(i, j)
        end"""
        test_format(str_, str)

        str_ = """
        for i = 1:30, j in 100:-2:1
            println(i, j)
        end"""
        str = """
        for i = 1:30, j = 100:-2:1
            println(i, j)
        end"""
        test_format(str_, str)

        str_ = "[(i,j) for i=I1,j=I2]"
        str = "[(i, j) for i in I1, j in I2]"
        test_format(str_, str)

        str_ = "((i,j) for i=I1,j=I2)"
        str = "((i, j) for i in I1, j in I2)"
        test_format(str_, str)

        str_ = "[(i,j) for i in 1:2:10,j  in 100:-1:10]"
        str = "[(i, j) for i = 1:2:10, j = 100:-1:10]"
        test_format(str_, str)

        str_ = "((i,j) for i in 1:2:10,j  in 100:-1:10)"
        str = "((i, j) for i = 1:2:10, j = 100:-1:10)"
        test_format(str_, str)
    end

    @testset "tuples" begin
        test_format("(a,)", "(a,)")
        test_format("a,b", "a, b")
        test_format("a ,b", "a, b")
        test_format("(a,b)", "(a, b)")
        test_format("(a ,b)", "(a, b)")
        test_format("( a, b)", "(a, b)")
        test_format("(a, b )", "(a, b)")
        test_format("(a, b ,)", "(a, b)")
        test_format("(a,    b ,\nc)", "(a, b, c)")
    end

    @testset "curly" begin
        test_format("X{a,b}", "X{a,b}")
        test_format("X{ a,b}", "X{a,b}")
        test_format("X{a ,b}", "X{a,b}")
        test_format("X{a, b}", "X{a,b}")
        test_format("X{a,b }", "X{a,b}")
        test_format("X{a,b }", "X{a,b}")

        str = """
        mutable struct Foo{A<:Bar,Union{B<:Fizz,C<:Buzz},<:Any}
            a::A
        end"""
        test_format(str, str)
        t = run_pretty(str, 80)
        @test length(t) == 55

        str = """
        struct Foo{A<:Bar,Union{B<:Fizz,C<:Buzz},<:Any}
            a::A
        end"""
        test_format(str, str)
        t = run_pretty(str, 80)
        @test length(t) == 47
    end

    @testset "where op" begin
        str = "Atomic{T}(value) where {T<:AtomicTypes} = new(value)"
        str_ = "Atomic{T}(value) where T <: AtomicTypes = new(value)"
        test_format(str, str)
        test_format(str_, str)

        str = "Vector{Vector{T} where T}"
        test_format(str, str)

        str_ = "Vector{Vector{T}} where T"
        str = "Vector{Vector{T}} where {T}"
        test_format(str_, str)
        test_format(str, str)
    end

    @testset "unary ops" begin
        test_format("! x", "! x")
        test_format("x ...", "x ...")
        test_format("!x", "!x")
        test_format("x...", "x...")

        # Issue 110
        str = raw"""
        if x
            if y
                :(
                    $lhs = fffffffffffffffffffffff(
                        xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx,
                        yyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyy,
                    )
                )
            end
        end"""
        test_format(str, str)

        str_ = "foo(args...)"
        str = """
        foo(
            args...,
        )"""
        test_format(str_, str; margin = 1)
        test_format(str, str; margin = 1)
    end

    @testset ": op" begin
        test_format("a:b:c", "a:b:c")
        test_format("a :b:c", "a:b:c")
        test_format("a: b:c", "a:b:c")
        test_format("a:b :c", "a:b:c")
        test_format("a:b: c", "a:b:c")
        test_format("a:b:c ", "a:b:c")
    end

    @testset "binary ops" begin

        @testset "whitespace addition" begin
            # For these 'operators' whitespace should only be added if there is already some
            # whitespace around the operator. (Note that the word 'operator' is used here
            # lightly, because many of these are parsed as infix _function calls_ rather
            # than infix _operators_ per se -- IMO we need clearer nomenclature.) There are
            # probably more that we need to test...
            for op in ("+", "*", "/", "-", "^", "%", "<", ">", "<=", ">=", "=>", "->", "-->", "<--", "~", "<:", ">:", "=", "==", "+=", "-=", "&&", "||")
                # see typedef section below also for <: and >:
                for (a, b) in (("a", "b"), ("[a", "b]"), ("(a", "b)"))
                    test_format("$a$(op)$b", "$a$(op)$b")
                    test_format("$a$(op) $b", "$a $(op) $b")
                    test_format("$a $(op) $b", "$a $(op) $b")
                    test_format("$a  $(op)  $b", "$a $(op) $b")

                    # Some of these are unary operators, so [a <op>b] means a 1x2 matrix
                    # with `a` and `<op>b` as elements, rather than a length-1 vector with
                    # `a<op>b` as its element. We skip those tests.
                    if !(op in ("+", "-", "~") && a == "[a")
                        test_format("$a $(op)$b", "$a $(op) $b")
                    end
                end
            end
            # For these ops there should never be whitespace
            for op in (":", "::")
                for (a, b) in (("a", "b"), ("[a", "b]"), ("(a", "b)"))
                    target = "$a$(op)$b"
                    test_format("$a$(op)$b", target)
                    test_format("$a$(op) $b", target)
                    test_format("$a $(op) $b", target)
                    test_format("$a  $(op)  $b", target)

                    # Just like above, `[a :b]` means a 1x2 matrix wtih with `a` and `:b`
                    # (i.e. a symbol) as elements, rather than a length-1 vector with `a:b`
                    # as its element. We skip those tests.
                    if !(op == ":" && a == "[a")
                        test_format("$a $(op)$b", target)
                    end

                end
            end
            # Supertypes / subtypes have special behaviour within typedefs
            for op in ("<:", ">:")
                target = "function f() where {a$(op)b} end"
                test_format("function f() where {a$(op)b} end", target)
                test_format("function f() where {a $(op)b} end", target)
                test_format("function f() where {a$(op) b} end", target)
                test_format("function f() where {a $(op) b} end", target)
                test_format("function f() where {a  $(op)  b} end", target)
            end
        end

        test_format("a+b*c", "a+b*c")
        test_format("a +b *c", "a + b * c")
        test_format("a + b      *c", "a + b * c")
        test_format("a +b*c", "a + b*c")
        test_format("a + b*c", "a + b*c")
        test_format("a+b *c", "a+b * c")
        test_format("a+b* c", "a+b * c")
        test_format("a+b*c ", "a+b*c")
        test_format("a:b", "a:b")
        test_format("a : b", "a:b")
        test_format("a: b", "a:b")
        test_format("a :b", "a:b")
        test_format("a +1 :b -1", "(a+1):(b-1)")
        test_format("a.b:c.d", "a.b:c.d") # shouldn't add parens

        test_format("a::b:: c", "a::b::c")
        test_format("a :: b::c", "a::b::c")
        test_format("a      :: b   :: c", "a::b::c")
        # issue 74
        test_format("0:1/3:2", "0:(1/3):2")
        test_format("2a", "2a")
        # issue 251
        test_format("2(a   + 1)", "2(a + 1)")
        test_format("2(a+1)", "2(a+1)")
        test_format("1 / 2a^2", "1 / 2a^2")

        str_ = "a[1:2 * num_source * num_dump-1]"
        str = "a[1:(2*num_source*num_dump-1)]"
        test_format(str_, str; indent=4, margin=1)

        str_ = "a[2 * num_source * num_dump-1:1]"
        str = "a[(2*num_source*num_dump-1):1]"
        test_format(str_, str; indent=4, margin=1)

        str = "!(typ <: ArithmeticTypes)"
        test_format(str, str)

        text = "a + b"
        d = JuliaFormatter.Document(text)
        s = JuliaFormatter.State(d, Options())
        g = JuliaSyntax.parseall(JuliaSyntax.GreenNode, text; version=JuliaFormatter.SUPPORTED_SYNTAX_VERSION)
        op = JuliaSyntax.children(only(JuliaSyntax.children(g)))[3]
        @test JuliaFormatter.source_op_kind_from_offset(s, op, UInt32(3)) ===
              JuliaSyntax.Kind("+")

        test_format("1 // 2 + 3^4", "1 // 2 + 3^4")
        test_format("1 // 2 + 3 ^ 4", "1 // 2 + 3 ^ 4")

        # Function def

        str_ = """foo() = if cond a else b end"""
        str = """
        foo() =
            if cond
                a
            else
                b
            end"""
        test_format(str_, str)

        str_ = """
        foo() = begin
            body
        end"""
        str = """
        foo() =
            begin
                body
            end"""
        test_format(str, str_)
        test_format(str_, str; indent=4, margin=1)

        str_ = """
        foo() = quote
            body
        end"""
        str = """
        foo() =
            quote
                body
            end"""
        test_format(str, str_)
        test_format(str_, str; indent=4, margin=1)

        str = """foo() = :(Union{})"""
        test_format(str, str)

        str_ = """foo() = for i=1:10 body end"""
        str = """
        foo() =
            for i = 1:10
                body
            end"""
        test_format(str_, str)

        str_ = """foo() = for outer i=1:10 body end"""
        str = """
        foo() =
            for outer i = 1:10
                body
            end"""
        test_format(str_, str)

        str_ = """foo() = while cond body end"""
        str = """
        foo() =
            while cond
                body
            end"""
        test_format(str_, str)

        str_ = """foo() = try body1 catch e body2 finally body3 end"""
        str = """
        foo() =
            try
                body1
            catch e
                body2
            finally
                body3
            end"""
        test_format(str_, str)

        # Assignment op

        str_ = """foo = if cond a else b end"""
        str = """
        foo =
          if cond
            a
          else
            b
          end"""
        test_format(str_, str; indent=2, margin=1)

        str_ = """foo = begin body end"""
        str = """
        foo = begin
          body
        end"""
        test_format(str_, str; indent=2, margin=11)
        str = """
        foo =
          begin
            body
          end"""
        test_format(str_, str; indent=2, margin=10)

        str_ = """foo = quote body end"""
        str = """
        foo = quote
          body
        end"""
        test_format(str_, str; indent=2, margin=11)
        str = """
        foo =
          quote
            body
          end"""
        test_format(str_, str; indent=2, margin=10)

        str_ = """foo = for i=1:10 body end"""
        str = """
        foo = for i = 1:10
          body
        end"""
        test_format(str_, str; indent=2, margin=18)
        str = """
        foo =
          for i = 1:10
            body
          end"""
        test_format(str_, str; indent=2, margin=17)

        str_ = """foo = while cond body end"""
        str = """
        foo =
          while cond
            body
          end"""
        test_format(str_, str; indent=2, margin=1)

        str_ = """foo = try body1 catch e body2 finally body3 end"""
        str = """
        foo =
          try
            body1
          catch e
            body2
          finally
            body3
          end"""
        test_format(str_, str; indent=2, margin=1)

        str_ = """
        foo = let
          body
        end"""
        test_format(str_, str_; indent=2, margin=9)
        str = """
        foo =
          let
            body
          end"""
        test_format(str_, str; indent=2, margin=8)
        str = """
        foo =
          let
            body
          end"""
        test_format(str_, str; indent=2, margin=1)

        str_ = """a, b = cond ? e1 : e2"""

        str = """
        a, b =
            cond ? e1 : e2"""
        test_format(str_, str; indent=4, margin=length(str_) - 1)
        test_format(str_, str; indent=4, margin=18)

        str = """
        a, b =
            cond ? e1 :
            e2"""
        test_format(str_, str; indent=4, margin=17)
        test_format(str_, str; indent=4, margin=15)

        str = """
        a, b =
            cond ?
            e1 : e2"""
        test_format(str_, str; indent=4, margin=14)
        test_format(str_, str; indent=4, margin=11)

        str = """
        a, b =
            cond ?
            e1 :
            e2"""
        test_format(str_, str; indent=4, margin=10)

        str = """
        begin
            variable_name =
                argument1 + argument2
        end"""
        test_format(str, str; indent=4, margin=40)

        str = """
        begin
            variable_name =
                argument1 +
                argument2
        end"""
        test_format(str, str; indent=4, margin=28)

        str = """
        begin
            variable_name =
                conditional ? expression1 : expression2
        end"""
        test_format(str, str; indent=4, margin=58)

        str = """
        begin
            variable_name =
                conditional ? expression1 :
                expression2
        end"""
        test_format(str, str; indent=4, margin=46)

        str = """
        begin
            variable_name =
                conditional ?
                expression1 : expression2
        end"""
        test_format(str, str; indent=4, margin=34)
        test_format(str, str; indent=4, margin=33)

        str = """
        begin
            variable_name =
                conditional ?
                expression1 :
                expression2
        end"""
        test_format(str, str; indent=4, margin=32)

        str = "shmem[pout*rows+row] += shmem[pin*rows+row] + shmem[pin*rows+row-offset]"

        str_ = """
        shmem[pout*rows+row] +=
               shmem[pin*rows+row] + shmem[pin*rows+row-offset]"""
        test_format(str, str_; indent=7, margin=71)
        str_ = """
        shmem[pout*rows+row] +=
               shmem[pin*rows+row] +
               shmem[pin*rows+row-offset]"""
        test_format(str, str_; indent=7, margin=54)

        str = """
        begin
           var = func(arg1, arg2, arg3) * num
        end"""
        test_format(str, str; indent=3, margin=37)

        str_ = """
        begin
           var =
              func(arg1, arg2, arg3) * num
        end"""
        test_format(str, str_; indent=3, margin=36)
        test_format(str, str_; indent=3, margin=34)

        str_ = """
        begin
           var =
              func(arg1, arg2, arg3) *
              num
        end"""
        test_format(str, str_; indent=3, margin=33)
        test_format(str, str_; indent=3, margin=30)

        str_ = """
        begin
           var =
              func(
                 arg1,
                 arg2,
                 arg3,
              ) * num
        end"""
        test_format(str, str_; indent=3, margin=29)

        str_ = """
        begin
           var =
              func(
                 arg1,
                 arg2,
                 arg3,
              ) *
              num
        end"""
        test_format(str, str_; indent=3, margin=1)

        str = """
        begin
            foo() =
                (one, x -> (true, false))
        end"""
        test_format(str, str; indent=4, margin=36)
        test_format(str, str; indent=4, margin=33)

        str = """
        begin
            foo() = (
                one,
                x -> (true, false),
            )
        end"""
        test_format(str, str; indent=4, margin=32)
        test_format(str, str; indent=4, margin=27)
        str = """
        begin
            foo() = (
                one,
                x -> (
                    true,
                    false,
                ),
            )
        end"""
        test_format(str, str; indent=4, margin=26)

        str = """
        ignored_f(f) = f in (
            GlobalRef(Base, :not_int),
            GlobalRef(Core.Intrinsics, :not_int),
            GlobalRef(Core, :(===)),
            GlobalRef(Core, :apply_type),
            GlobalRef(Core, :typeof),
            GlobalRef(Core, :throw),
            GlobalRef(Base, :kwerr),
            GlobalRef(Core, :kwfunc),
            GlobalRef(Core, :isdefined),
        )"""
        test_format(str, str)

        str = """
        ignored_f(f) = f in foo([{
            GlobalRef(Base, :not_int),
            GlobalRef(Core.Intrinsics, :not_int),
            GlobalRef(Core, :(===)),
            GlobalRef(Core, :apply_type),
            GlobalRef(Core, :typeof),
            GlobalRef(Core, :throw),
            GlobalRef(Base, :kwerr),
            GlobalRef(Core, :kwfunc),
            GlobalRef(Core, :isdefined),
        }])"""
        test_format(str, str)

        str = """
        ignored_f(f) = f in foo(((
            GlobalRef(Base, :not_int),
            GlobalRef(Core.Intrinsics, :not_int),
            GlobalRef(Core, :(===)),
            GlobalRef(Core, :apply_type),
            GlobalRef(Core, :typeof),
            GlobalRef(Core, :throw),
            GlobalRef(Base, :kwerr),
            GlobalRef(Core, :kwfunc),
            GlobalRef(Core, :isdefined),
        )))"""
        test_format(str, str)

        str = "var = \"a_long_function_stringggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggggg\""
        test_format(str, str; indent=4, margin=1)
    end

    @testset "op chain" begin
        test_format("a+b+c+d", "a+b+c+d")
        test_format("a + b + c +d", "a + b + c + d")
    end

    @testset "comparison chain" begin
        test_format("a<b==c≥d", "a<b==c≥d")
        test_format("a<b == c≥d", "a < b == c ≥ d")
    end

    @testset "single line block" begin
        test_format("(a;b;c)", "(a; b; c)")
    end

    @testset "func call" begin
        test_format("func(a, b, c)", "func(a, b, c)")
        test_format("func(a,b,c)", "func(a, b, c)")
        test_format("func(a,b,c,)", "func(a, b, c)")
        test_format("func(a,b,c, )", "func(a, b, c)")
        test_format("func( a,b,c    )", "func(a, b, c)")
        test_format("func(a, b, c) ", "func(a, b, c)")
        test_format("func(a, b; c)", "func(a, b; c)")
        test_format("func(  a, b; c)", "func(a, b; c)")
        test_format("func(a  ,b; c)", "func(a, b; c)")
        test_format("func(a=1,b; c=1)", "func(a = 1, b; c = 1)")

        str = """
        func(;
          c = 1,
        )"""
        test_format("func(; c = 1)", str; indent=2, margin=1)

        test_format("func(; c = 1,)", "func(; c = 1)")
        test_format("func(a;)", "func(a;)")

        str = """
        func(;
            a,
            b,
        )"""
        test_format(str, str; indent=4, margin=1)

        str = """
        func(
            x;
            a,
            b,
        )"""
        test_format(str, str; indent=4, margin=1)
    end

    @testset "macro call" begin
        str = """
        @f(
            a,
            b;
            x
        )"""
        str_ = "@f(a, b; x)"
        test_format(str_, str_)
        test_format(str_, str; indent=4, margin=1)

        str = """
        @f(
            a;
            x
        )"""
        str_ = "@f(a; x)"
        test_format(str_, str_)
        test_format(str_, str; indent=4, margin=1)

        str = """
        @f(;
          x
        )"""
        str_ = "@f(; x)"
        test_format(str_, str_)
        test_format(str_, str; indent=2, margin=1)

        str = """
        @f(;
            a,
            b
        )"""
        test_format(str, str; indent=4, margin=1)

        str = """
        @f(
            x;
            a,
            b
        )"""
        test_format(str, str; indent=4, margin=1)

        str = """@warn("Text")"""
        test_format(str, str)

        str_ = "@Module.macro"
        str = "Module.@macro"
        test_format(str_, str)
        test_format(str, str)

        str_ = "\$Module.@macro"
        str = "\$Module.@macro"
        test_format(str_, str)
        test_format(str, str)

        # @doc here should not be parsed as a macro string
        str = raw"push!(docs, :(@doc($meta, $(each.args[end]), $define)))"
        test_format(str, str)
    end

    @testset "macro block" begin
        str = raw"""
        @spawn begin
            acc = acc′′
            for _ in _
                a
                b
                ccc = dddd(ee, fff, gggggggggggg)
            end
            return
        end"""
        t = run_pretty(str, 80)
        @test length(t) == 41

        str_ = "__module__ == Main || @warn \"Replacing docs for `\$b :: \$sig` in module `\$(__module__)`\""
        str = """
        __module__ == Main ||
            @warn \"Replacing docs for `\$b :: \$sig` in module `\$(__module__)`\""""
        test_format(str_, str; indent=4, margin=length(str_) - 1)
    end

    @testset "begin" begin
        str = """
        begin
            arg
        end"""
        test_format("""
                    begin
                    arg
                    end""", str)
        test_format("""
                    begin
                        arg
                    end""", str)
        test_format("""
                    begin
                        arg
                    end""", str)
        test_format("""
                    begin
                            arg
                    end""", str)
        str = """
        begin
            begin
                arg
            end
        end"""
        test_format("""
                    begin
                    begin
                    arg
                    end
                    end""", str)
        test_format("""
                    begin
                                begin
                    arg
                    end
                    end""", str)
        test_format("""
                    begin
                                begin
                    arg
                            end
                    end""", str)

        str = """
        begin
            s = foo(aaa, bbbb, cccc)
            s = foo(
                aaaa,
                bbbb,
                cccc,
            )
        end"""
        test_format(str, str; indent=4, margin=28)
    end

    @testset "quote" begin
        str = """
        quote
            arg
        end"""
        test_format("""
        quote
            arg
        end""", str)
        test_format("""
        quote
        arg
        end""", str)
        test_format("""
        quote
                arg
            end""", str)

        str = """:(a = 10; b = 20; c = a * b)"""
        test_format(":(a = 10; b = 20; c = a * b)", str)

        str = """
        :(endidx = ndigits;
        while endidx > 1 && digits[endidx] == UInt8('0')
            endidx -= 1
        end;
        if endidx > 1
            print(out, '.')
            unsafe_write(out, pointer(digits) + 1, endidx - 1)
        end)"""

        str_ = """
    :(endidx = ndigits;
                while endidx > 1 && digits[endidx] == UInt8('0')
                    endidx -= 1
                end;
                if endidx > 1
                    print(out, '.')
                    unsafe_write(out, pointer(digits) + 1, endidx - 1)
                end)"""
        test_format(str_, str)
        test_format(str, str)

        str = """
        quote
            s = foo(aaa, bbbb, cccc)
            s = foo(
                aaaa,
                bbbb,
                cccc,
            )
        end"""
        test_format(str, str; indent=4, margin=28)
    end

    @testset "do" begin
        str = """
        map(args) do x
            y = 20
            return x * y
        end"""

        test_format("""
        map(args) do x
          y = 20
                            return x * y
            end""", str)

        str = """
        map(1:10, 11:20) do x, y
            x + y
        end"""
        t = run_pretty(str, 80)
        @test length(t) == 24

        str = """
        map(1:10, 11:20) do x, y
            z = reallylongvariablename
        end"""
        t = run_pretty(str, 80)
        @test length(t) == 30

        # issue 58

        str_ = """
        model = SDDP.LinearPolicyGraph(stages = 2, lower_bound = 1, direct_mode = false) do (subproblem1, subproblem2, subproblem3, subproblem4, subproblem5, subproblem6, subproblem7, subproblem8)
            body
        end"""
        str = """
        model = SDDP.LinearPolicyGraph(
            stages = 2,
            lower_bound = 1,
            direct_mode = false,
        ) do (
            subproblem1,
            subproblem2,
            subproblem3,
            subproblem4,
            subproblem5,
            subproblem6,
            subproblem7,
            subproblem8,
        )
            body
        end"""
        test_format(str_, str)

        str_ = """
        model = SDDP.LinearPolicyGraph(stages = 2, lower_bound = 1, direct_mode = false) do subproblem1, subproblem2
            body
        end"""
        str = """
        model = SDDP.LinearPolicyGraph(
            stages = 2,
            lower_bound = 1,
            direct_mode = false,
        ) do subproblem1, subproblem2
            body
        end"""
        test_format(str_, str)
    end

    @testset "for" begin
        str = """
        for iter in I
            arg
        end"""
        test_format("""
        for iter in I
            arg
        end""", str)
        test_format("""
        for iter in I
        arg
        end""", str)
        test_format("""
        for iter in I
          arg
        end""", str)

        str = """
        for iter in I, iter2 in I2
            arg
        end"""
        test_format("""
        for iter = I, iter2= I2
            arg
        end""", str)
        test_format("""
        for iter= I, iter2=I2
        arg
        end""", str)
        test_format("""
        for iter    = I, iter2 = I2
                arg
            end""", str)

        str = """
        a = 10000
        for i = 1:10
            body
        end"""
        t = run_pretty(str, 80)
        @test length(t) == 12

        str = """
        a = 1
        for i in 1:10
            bodybodybodybody
        end"""
        t = run_pretty(str, 80)
        @test length(t) == 20
    end

    @testset "while" begin
        str = """
        while cond
            arg
        end"""
        test_format("""
        while cond
            arg
        end""", str)
        test_format("""
        while cond
        arg
        end""", str)
        test_format("""
        while cond
                arg
            end""", str)

        # This will be a FileH header
        # with no blocks
        str = """
        a = 1
        while a < 100
            a += 1
        end"""
        t = run_pretty(str, 80)
        @test length(t) == 13

        str = """
        a = 1
        while a < 100
            a += 1
            thisisalongnameforabody
        end"""
        t = run_pretty(str, 80)
        @test length(t) == 27

        @testset "block conditions" begin
            s1 = """while (a; b)
                c
            end"""
            test_format(s1, s1)
            s2 = """while begin
                a
                b
            end
                c
            end"""
            test_format(s2, s2)
            s3_ = """while (prettylong; prettylongtoo)
                c
            end"""
            s3 = """while (
                prettylong;
                prettylongtoo
            )
                c
            end"""
            test_format(s3_, s3; indent=4, margin=20)
        end
    end

    @testset "let" begin
        str = """
        let x=X
            arg
        end"""
        test_format("""
        let x=X
            arg
        end""", str)
        test_format("""
        let x=X
        arg
        end""", str)
        test_format("""
        let x=X
            arg
        end""", str)

        str = """
        let x = X, y = Y
            arg
        end"""
        test_format("""
        let x = X, y = Y
            arg
        end""", str)
        test_format("""
        let x = X, y = Y
        arg
        end""", str)

        str = """
        y, back = let
            body
        end"""
        test_format("""
        y,back = let
          body
        end""", str)

        str = """
        let x = a,
            # comment
            b,
            c

            body
        end"""
        test_format("""
        let x = a,
            # comment
               b,
              c
           body
           end""", str)

        str = """
        let x = X, y = Y
            body
        end"""
        t = run_pretty(str, 80)
        @test length(t) == 16

        str = """
        let x = X, y = Y
        letthebodieshitthefloor
        end"""
        t = run_pretty(str, 80)
        @test length(t) == 27
    end

    @testset "try" begin
        str = """
        try
            arg
        catch
            arg
        end"""
        test_format("""
        try
            arg
        catch
            arg
        end""", str)

        test_format("""
        try
        arg
        catch
        arg
        end""", str)

        test_format("""
        try
                arg
            catch
                arg
            end""", str)

        str = """
        try
            arg
        catch
            arg
        end"""
        test_format("""
        try
            arg
        catch
            arg
        end""", str)

        test_format("""
        try
        arg
        catch
        arg
        end""", str)

        test_format("""
        try
                arg
            catch
                arg
            end""", str)

        str = """
        try
            arg
        catch err
            arg
        end"""

        test_format("""
        try
            arg
        catch err
            arg
        end""", str)

        test_format("""
        try
        arg
        catch err
        arg
        end""", str)

        test_format("""
        try
                arg
            catch err
                arg
            end""", str)

        str = """
        try
            a111111
            a2
        catch error123
            b1
            b2
        finally
            c1
            c2
        end"""
        t = run_pretty(str, 80)
        @test length(t) == 14

        str = """
        try
            a111111
            a2
        catch erro
            b1
            b2
        finally
            c1
            c2
        end"""
        t = run_pretty(str, 80)
        @test length(t) == 11
    end

    @testset "if" begin
        str = """
        if cond1
            e1
            e2
        elseif cond2
            e3
            e4
        elseif cond33
            e5
            e6
        else
            e7
            e88888
        end"""
        t = run_pretty(str, 80)
        @test length(t) == 13

        str = """
        if cond1
            e1
            e2
        elseif cond2
            e3
            e4
        elseif cond33
            e5
            e6
        else
            e7
            e888888888
        end"""
        t = run_pretty(str, 80)
        @test length(t) == 14

        @testset "block conditions" begin
            # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/1025
            for block in (
                "(a; b)",
                "begin\n    a\n    b\nend\n",
            )
                str = """
                if $block
                    foo
                end
                """
                test_format(str, str)

                str = """
                if x
                    foo
                elseif $block
                    bar
                end
                """
                test_format(str, str)

                str = """
                if $block
                    foo
                elseif $block
                    bar
                end
                """
                test_format(str, str)

                str = """
                if $block
                    foo
                else
                    bar
                end
                """
                test_format(str, str)
            end

            # Nesting
            str_ = """if (veryverylong; veryverylongtoo)
                f
            end"""
            str = """if (
                veryverylong;
                veryverylongtoo
            )
                f
            end"""
            test_format(str_, str; indent=4, margin=20)
        end

    end

    @testset "strings" begin
        str = """
        \"""
        Interpolate using `\\\$`
        \"""
        a"""
        test_format(str, str)

        str = """error("foo\\n\\nbar")"""
        test_format(str, str)

        str = """
        \"""
        \\\\
        \"""
        x"""
        test_format(str, str)

        str = """
        begin
            s = \"\"\"This is a multiline string.
                    This is another line.
                          Look another 1 that is indented a bit.

                          cool!\"\"\"
        end"""
        str_ = """
        begin
        s = \"\"\"This is a multiline string.
                This is another line.
                      Look another 1 that is indented a bit.

                      cool!\"\"\"
        end"""
        test_format(str_, str)

        @testset "multiline string starting on line with display width != bytes" begin
            # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/974
            #
            # Anonymous function form. Test both the case where the second line begins
            # after the starting quote of the first line, and the opposite.
            s1a = raw"""
            error_str = Δa -> "Change in activity must be within the valid range: \
                                Δa ∈ [1, 2], but Δa = $Δa"
            """
            s1b = raw"""
            error_str = Δa -> "Change in activity must be within the valid range: \
                  Δa ∈ [1, 2], but Δa = $Δa"
            """
            # Explicit function definition
            s2a = raw"""
            error_str(Δa) = "Change in activity must be within the valid range: \
                                Δa ∈ [1, 2], but Δa = $Δa"
            """
            s2b = raw"""
            error_str(Δa) = "Change in activity must be within the valid range: \
              Δa ∈ [1, 2], but Δa = $Δa"
            """
            # Using triple quoted strings
            s3a = raw"""
            error_str(Δa) = \"""Change in activity must be within the valid range: \
                                Δa ∈ [1, 2], but Δa = $Δa\"""
            """
            s3b = raw"""
            error_str(Δa) = \"""Change in activity must be within the valid range: \
              Δa ∈ [1, 2], but Δa = $Δa\"""
            """
            for s in (s1a, s1b, s2a, s2b, s3a, s3b)
                # Need to normalise line endings because \ at the end of a raw_str behaves
                # weirdly on Windows causing CI to fail.
                # https://github.com/JuliaLang/julia/issues/38908
                s = replace(s, "\r\n" => "\n")
                test_format(s, s)
            end
        end

        str_ = """
        begin
        begin
           throw(ErrorException(\"""An error occured formatting \$filename. :-(

                                Please file an issue at https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues
                                with a link to a gist containing the contents of the file. A gist
                                can be created at https://gist.github.com/.\"""))
           end
        end"""
        str = """
        begin
            begin
                throw(ErrorException(\"""An error occured formatting \$filename. :-(

                                     Please file an issue at https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues
                                     with a link to a gist containing the contents of the file. A gist
                                     can be created at https://gist.github.com/.\"""))
            end
        end"""
        test_format(str_, str; indent=4, margin=120)

        str = raw"""
        begin
            begin
                throw(
                    ErrorException(
                        \"""An error occured formatting $filename. :-(

                        Please file an issue at https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues
                        with a link to a gist containing the contents of the file. A gist
                        can be created at https://gist.github.com/.\""",
                    ),
                )
            end
        end"""
        test_format(str_, str; indent=4, margin=1)

        str = """
        foo() = llvmcall(\"""
                         llvm1
                         llvm2
                         \""")"""
        test_format(str, str)
        # nests and then unnests
        test_format(str, str; indent=2, margin=20)

        str_ = """
        foo() =
          llvmcall(\"""
                   llvm1
                   llvm2
                   \""")"""
        test_format(str, str_; indent=2, margin=19)

        # the length calculation is kind of wonky here
        # but it's still a worthwhile test
        str_ = """
        foo() =
            llvmcall(\"""
                     llvm1
                     llvm2
                     \""")"""
        test_format(str, str_; indent=4, margin=19)

        str_ = """
        foo() = llvmcall(
            \"""
            llvm1
            llvm2
            \""",
        )"""
        test_format(str, str_; indent=4, margin=18)

        str_ = """
        foo() =
          llvmcall(
            \"""
            llvm1
            llvm2
            \""",
          )"""
        test_format(str, str_; indent=2, margin=10)

        str = """
        str = \"""
        begin
            arg
        end\"""
        """
        test_format(str, str)

        str = """
        str = \"""
              begin
                  arg
              end\"""
        """
        test_format(str, str)

        str = raw"""@test :(x`s`flag) == :(@x_cmd "s" "flag")"""
        test_format(str, str)

        str = raw"""
        if free < min_space
            throw(ErrorException(\"""
            Free space: \$free Gb
            Please make sure to have at least \$min_space Gb of free disk space
            before downloading the $database_name database.
            \"""))
        end"""
        str_ = raw"""
        if free <
           min_space
            throw(
                ErrorException(
                    \"""
        Free space: \$free Gb
        Please make sure to have at least \$min_space Gb of free disk space
        before downloading the $database_name database.
        \""",
                ),
            )
        end"""
        test_format(str, str)
        test_format(str, str_; indent=4, margin=1)

        str_ = """foo(r"hello"x)"""
        str = """
        foo(
            r"hello"x,
        )"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """foo(r`hello`x)"""
        str = """
        foo(
            r`hello`x,
        )"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """foo(r\"""hello\"""x)"""
        str = """
        foo(
            r\"""hello\"""x,
        )"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """foo(r```hello```x)"""
        str = """foo(
            r```hello```x,
        )"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """foo(\"""hello\""")"""
        str = """foo(
            \"""hello\""",
        )"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """foo(```hello```)"""
        str = """foo(
            ```hello```,
        )"""
        test_format(str_, str; indent=4, margin=1)

        str_ = raw"""
        occursin(r"^#!\s*format\s*:\s*off\s*$", t.val)
        """
        test_format(str_, str_)

        str = raw"""
        occursin(
            r"^#!\s*format\s*:\s*off\s*$",
            t.val,
        )
        """
        test_format(str_, str; indent=4, margin=1)
    end

    @testset "comments" begin
        str = """
        module Foo
        # comment 0
        # comment 1
        begin

            # comment 2
            # comment 3

            begin



                # comment 4
                # comment 5
                a = 10
                # comment 6
            end

        end

        end"""
        test_format(str, str)
        t = run_pretty(str, 80)
        @test length(t) == 14

        str_ = """
        module Foo
        # comment 0
        # comment 1
        begin

        # comment 2
        # comment 3

        begin



        # comment 4
        # comment 5
        a = 10
        # comment 6
        end

        end

        end"""
        str = """
        module Foo
        # comment 0
        # comment 1
        begin

            # comment 2
            # comment 3

            begin



                # comment 4
                # comment 5
                a = 10
                # comment 6
            end

        end

        end"""
        test_format(str_, str)

        str = "# comment 0\n\n\n\n\na = 1\n\n# comment 1\n\n\n\n\nb = 2\n\n\nc = 3\n\n# comment 2\n\n"
        test_format(str, str)

        str = """
        #=
        hello
        world
        =#
        const a = \"hi there\""""
        test_format(str, str)

        str = """
        if a
            # comment above var
            var = 10
            # comment below var
        else
            something_else()
        end"""
        test_format(str, str)

        str = """
        begin
            a = 10 # foo
            b = 20           # foo
        end    # trailing comment"""
        str_ = """
        begin
        a = 10 # foo
        b = 20           # foo
        end    # trailing comment"""
        test_format(str_, str)

        str = """
        function bar(x, y)
            # single comment ending in a subscriptₙ
            x - y
        end"""
        test_format("""
        function bar(x, y)
            # single comment ending in a subscriptₙ
            x- y
        end""", str)

        str_ = """
        var = foo(      # eat
            a, b, # comment 1
            c, # comment 2
            # in between comment
            d # comment 3
        )        # pancakes"""
        str = """
        var = foo(      # eat
            a,
            b, # comment 1
            c, # comment 2
            # in between comment
            d, # comment 3
        )        # pancakes"""
        test_format(str_, str)

        str_ = """
        var = foo(      # eat
            a, b, # comment 1
            c, # comment 2
            d # comment 3
        )        # pancakes"""
        str = """
        var = foo(      # eat
            a,
            b, # comment 1
            c, # comment 2
            d, # comment 3
        )        # pancakes"""
        test_format(str_, str)

        str = """
        A ? # foo
        # comment 1

        B :    # bar
        # comment 2
        C"""
        test_format(str, str)

        str = """
        A ? B :
        # comment

        C"""
        test_format(str, str)

        str_ = """
        foo = A ?
            # comment 1

            B : C"""

        str = """
        foo =
            A ?
            # comment 1

            B : C"""
        test_format(str_, str)

        str = """
        foo =
           A ?
           # comment 1

           B :
           C"""
        test_format(str_, str; indent=3, margin=1)

        str_ = """
        foo = A +
            # comment 1

            B + C"""

        str = """
        foo =
           A +
           # comment 1

           B +
           C"""
        test_format(str_, str; indent=3, margin=100)
        test_format(str_, str; indent=3, margin=1)

        str = """
        begin
            var =
                a +
                # comment
                b
        end
        """
        test_format(str, str)

        str = """
        begin
            var() =
                a +
                # comment
                b
        end
        """
        test_format(str, str)

        str_ = """
        begin
            var = a +  # inline
                  # comment

                  b
        end
        """
        str = """
        begin
            var =
                a +  # inline
                # comment

                b
        end
        """
        test_format(str_, str)

        str_ = """
        begin
            var = a +  # inline
                  b
        end
        """
        str = """
        begin
          var =
            a +  # inline
            b
        end
        """
        test_format(str_, str; indent=2, margin=92)

        str = """
        foo() = 10 where {
            # comment
            A,
            # comment
            B,
            # comment
        }"""
        test_format(str, str)

        str = """
        foo() = 10 where Foo{
            # comment
            A,
            # comment
            B,
            # comment
        }"""
        test_format(str, str)

        str = """
        foo() = Foo(
            # comment
            A,
            # comment
            B,
            # comment
        )"""
        test_format(str, str)

        str = """
        foo(
            # comment
            ;
            # comment
            a = b, # comment
            c = d,
            # comment
        )"""
        test_format(str, str)

        str = """
        foo(;
            a = b, # comment
            c = d,
            # comment
        )"""

        str_ = """
        foo(
            ;
            a = b, # comment
            c = d,
            # comment
        )"""
        test_format(str_, str)

        str = """
        foo(;;
            a = b, # comment
            c = d,
            # comment
        )"""

        str_ = """
        foo(
            ;
            ;a = b, # comment
            c = d,
            # comment
        )"""
        test_format(str_, str)

        str_ = """
        foo( ;
            ;a = b, # comment
            c = d,
            # comment
        )"""
        test_format(str_, str)

        # Issue #51
        # NOTE: `str_` has extra whitespace after
        # keywords on purpose
        str_ = "begin \n # comment\n end"
        str = """
        begin
          # comment
        end"""
        test_format(str_, str; indent=2, margin=92)

        str_ = "try \n # comment\n catch e\n # comment\nbody\n # comment\n finally \n # comment\n end"
        str = """
        try
              # comment
        catch e
              # comment
              body
              # comment
        finally
              # comment
        end"""
        test_format(str_, str; indent=6, margin=92)

        str_ = "if a \n # comment\n body \n# comment\n elseif b\n # comment\nbody\n #comment\n else\n # comment\n body \n #comment\n end"
        str = """
        if a
              # comment
              body
              # comment
        elseif b
              # comment
              body
              #comment
        else
              # comment
              body
              #comment
        end"""
        test_format(str_, str; indent=6, margin=92)

        str = """a = "hello ##" # # # α"""
        test_format(str, str)

        # issue #65
        str = "1 # α"
        test_format(str, str)

        str = "# α"
        test_format(str, str)

        str = """
        #=
        α
        =#
        x = 1
        """
        test_format(str, str)

        str_ = """
          \"\"\"
          - ΩCL
          - ΩVc
          -  ΩKa
          - ΩVp
          - ΩQ
          \"\"\"
          f
        """
        str = """
        \"\"\"
          - ΩCL
          - ΩVc
          - ΩKa
          - ΩVp
          - ΩQ
        \"\"\"
        f
        """
        test_format(str_, str; format_docstrings = true)

        str = """
        # comments
        # before
        # code

        #comment
        if a
            #comment
        elseif b
            #comment
        elseif c
            #comment
            if aa
                #comment
            elseif bb
                #comment
                #comment
            else
                #comment
            end
            #comment
        elseif cc
            #comment
        elseif dd
            #comment
            if aaa
                #comment
            elseif bbb
                #comment
            else
                #comment
            end
            #comment
        end
        #comment
        """
        test_format(str, str)

        str = """
        foo = [
            # comment
            1,
            2,
            3,
        ]"""
        test_format(str, str)

        # issue 152
        str = """
        try
        catch
        end   # comment"""
        str_ = """try; catch;  end   # comment"""
        test_format(str_, str)

        str = """
        try
        catch
        end   # comment
        a = 10"""
        str_ = """
        try; catch;  end   # comment
        a = 10"""
        test_format(str_, str)
    end

    @testset "pretty" begin
        str = """function foo end"""
        test_format("""
            function  foo
            end""", str)
        t = run_pretty(str, 80)
        @test length(t) == 16

        str = """function foo() end"""
        test_format("""
                     function  foo()
            end""", str)
        t = run_pretty(str, 80)
        @test length(t) == 18

        str = """function foo()
                     10
                     20
                 end"""
        test_format("""function foo() 10;  20 end""", str)
        t = run_pretty(str, 80)
        @test length(t) == 14

        str = """abstract type AbstractFoo end"""
        test_format("""abstract type
                     AbstractFoo
                end""", str)

        str = "primitive type A <: B 32 end"
        test_format("""primitive type
                     A   <: B
                     32
                end""", str)

        str = """for i = 1:10
                     1
                     2
                     3
                 end"""
        test_format("""for i=1:10 1; 2; 3 end""", str)

        str = """while true
                     1
                     2
                     3
                 end"""
        test_format("""while true 1; 2; 3 end""", str)

        str = """try
                     a
                 catch e
                     b
                 end"""
        test_format("""try a catch e b end""", str)

        str = """try
                     a1
                     a2
                 catch e
                     b1
                     b2
                 finally
                     c1
                     c2
                 end"""
        test_format("""try a1;a2 catch e b1;b2 finally c1;c2 end""", str)

        str = """map(a) do b, c
                     e
                 end"""
        test_format("""map(a) do b,c
                     e end""", str)

        str = """let a=b, c = d
                     e1
                     e2
                     e3
                 end"""
        test_format("""let a=b,c  =  d  \ne1; e2; e3 end""", str)

        str = """let a, b
                     e
                 end"""
        test_format("""let a,b
                     e end""", str)

        str = """return a, b, c"""
        test_format("""return a,b,
                     c""", str)

        str = """begin
                     a
                     b
                     c
                 end"""
        test_format("""begin a; b; c end""", str)

        str = """begin end"""
        test_format("""begin \n            end""", str)

        str = """quote
                     a
                     b
                     c
                 end"""
        test_format("""quote a; b; c end""", str)

        str = """quote end"""
        test_format("""quote \n end""", str)

        str = """if cond1
                     e1
                     e2
                 end"""
        test_format("if cond1 e1;e2 end", str)

        str = """if cond1
                     e1
                     e2
                 else
                     e3
                     e4
                 end"""
        test_format("if cond1 e1;e2 else e3;e4 end", str)

        str = """begin
                     if cond1
                         e1
                         e2
                     elseif cond2
                         e3
                         e4
                     elseif cond3
                         e5
                         e6
                     else
                         e7
                         e8
                     end
                 end"""
        test_format(
            "begin if cond1 e1; e2 elseif cond2 e3; e4 elseif cond3 e5;e6 else e7;e8  end end",
            str)

        str = """if cond1
                     e1
                     e2
                 elseif cond2
                     e3
                     e4
                 end"""
        test_format("if cond1 e1;e2 elseif cond2 e3; e4 end", str)

        str = """
        [a b c]"""
        test_format("[a   b         c   ]", str)

        str = """
        [a; b; c;]"""
        test_format("[a;   b;         c;   ]", str)
        str = """
        [a; b; c]"""
        test_format("[a;   b;         c   ]", str)

        str = """
        T[a b c]"""
        test_format("T[a   b         c   ]", str)

        str = """T[a; b; c]"""
        test_format("T[a;   b;         c   ]", str)
        str = """T[a; b; c;]"""
        test_format("T[a;   b;         c;   ]", str)

        str = """
        T[
            a;
            b;
            c;
        ]"""
        test_format("T[a;   b;         c;   ]", str; indent=4, margin=1)

        str = """
        T[
            a;
            b;
            c
        ]"""
        test_format("T[a;   b;         c   ]", str; indent=4, margin=1)

        str = """
        T[a; b; c; e d f]"""
        test_format("T[a;   b;         c;   e  d    f   ]", str)

        str = """
        T[a; b; c; e d f;]"""
        test_format("T[a;   b;         c;   e  d    f;   ]", str)

        str = """
        T[
            a;
            b;
            c;
            e d f
        ]"""
        test_format("T[a;   b;         c;   e  d    f   ]", str; indent=4, margin=1)

        str = """
        T[
            a;
            b;
            c;
            e d f;
        ]"""
        test_format("T[a;   b;         c;   e  d    f;   ]", str; indent=4, margin=1)

        str = "T[a;]"
        test_format(str, str)

        str = "[a;]"
        test_format(str, str)

        str = """T[e for e in x]"""
        test_format("T[e  for e= x  ]", str)

        str = """T[e for e = 1:2:50]"""
        test_format("T[e  for e= 1:2:50  ]", str)

        str = """struct Foo end"""
        test_format("struct Foo\n      end", str)

        str = """
        struct Foo
            body::Any
        end"""
        test_format("struct Foo\n    body  end", str)

        str = """macro foo() end"""
        test_format("macro foo()\n      end", str)

        str = """macro foo end"""
        test_format("macro foo\n      end", str)

        str = """
        macro foo()
            body
        end"""
        test_format("macro foo()\n    body  end", str)

        str = """mutable struct Foo end"""
        test_format("mutable struct Foo\n      end", str)

        str = """
        mutable struct Foo
            body::Any
        end"""
        test_format("mutable struct Foo\n    body  end", str)

        str = """
        module A
        bodybody
        end"""
        test_format("module A\n    bodybody  end", str)
        t = run_pretty(str, 80)
        @test length(t) == 8

        str = """
        module Foo end"""
        test_format("module Foo\n    end", str)
        t = run_pretty(str, 80)
        @test length(t) == 14

        str = """
        baremodule A
        bodybody
        end"""
        test_format("baremodule A\n    bodybody  end", str)
        t = run_pretty(str, 80)
        @test length(t) == 12

        str = """
        baremodule Foo end"""
        test_format("baremodule Foo\n    end", str)
        t = run_pretty(str, 80)
        @test length(t) == 18

        str = """
        if cond1
        elseif cond2
        elseif cond3
        elseif cond4
        elseif cond5
        elseif cond6
        elseif cond7
        else
        end"""
        test_format(str, str)

        str = """
        try
        catch
        finally
        end"""
        test_format(str, str)

        str = """
        (args...; kwargs) -> begin
            body
        end"""
        test_format(str, str)

        test_format("ref[a: (b + c)]", "ref[a:(b+c)]")
        test_format("ref[a in b]", "ref[a in b]")
        test_format("ref[a:b.c]", "ref[a:b.c]") # shouldn't add parens
    end

    @testset "nesting" begin
        str = """
        function f(
            arg1::A,
            key1 = val1;
            key2 = val2,
        ) where {
            A,
            F{
                B,
                C,
            },
        }
            10
            20
        end"""
        str_ = "function f(arg1::A,key1=val1;key2=val2) where {A,F{B,C}} 10; 20 end"
        test_format(str_, str; indent=4, margin=1)

        str = """
        function f(
            arg1::A,
            key1 = val1;
            key2 = val2,
        ) where {
            A,
            F{B,C},
        }
            10
            20
        end"""
        test_format(str_, str; indent=4, margin=17)

        str = """
        function f(
            arg1::A,
            key1 = val1;
            key2 = val2,
        ) where {A,F{B,C}}
            10
            20
        end"""
        test_format(str_, str; indent=4, margin=18)

        str = """
        a |
        b |
        c |
        d"""
        test_format("a | b | c | d", str; indent=4, margin=1)

        str = """
        a, b, c, d"""
        test_format("a, b, c, d", str; indent=4, margin=10)

        str = """
        a,
        b,
        c,
        d"""
        test_format("a, b, c, d", str; indent=4, margin=9)

        str = """(a, b, c, d)"""
        test_format("(a, b, c, d)", str; indent=4, margin=12)

        str = """
        (
            a,
            b,
            c,
            d,
        )"""
        test_format("(a, b, c, d)", str; indent=4, margin=11)

        str = """{a, b, c, d}"""
        test_format("{a, b, c, d}", str; indent=4, margin=12)

        str = """
        {
            a,
            b,
            c,
            d,
        }"""
        test_format("{a, b, c, d}", str; indent=4, margin=11)

        str = """[a, b, c, d]"""
        test_format("[a, b, c, d]", str; indent=4, margin=12)

        str = """
        [
            a,
            b,
            c,
            d,
        ]"""
        test_format("[a, b, c, d]", str; indent=4, margin=11)

        str = """
        cond ?
        e1 :
        e2"""
        test_format("cond ? e1 : e2", str; indent=4, margin=1)

        str = """
        cond ? e1 :
        e2"""
        test_format("cond ? e1 : e2", str; indent=4, margin=12)

        str = """
        cond1 ? e1 :
        cond2 ? e2 :
        cond3 ? e3 :
        e4"""
        test_format("cond1 ? e1 : cond2 ? e2 : cond3 ? e3 : e4", str; indent=4, margin=13)

        # I'm an importer/exporter
        str = """
        export a,
            b"""
        test_format("export a,b", str; indent=4, margin=1)

        str = """
        using a,
          b"""
        test_format("using a,b", str; indent=2, margin=1)

        str_ = "using M1.M2.M3: bar, baz"
        str = """
        using M1.M2.M3:
            bar, baz"""
        test_format(str, str_; indent=4, margin=24)
        test_format(str_, str; indent=4, margin=23)
        test_format(str_, str; indent=4, margin=12)

        str = """
        using M1.M2.M3:
            bar,
            baz"""
        test_format(str_, str; indent=4, margin=11)

        str_ = "import M1.M2.M3: bar, baz"
        str = """
        import M1.M2.M3:
            bar, baz"""
        test_format(str, str_; indent=4, margin=25)
        test_format(str_, str; indent=4, margin=24)
        test_format(str_, str; indent=4, margin=12)

        str = """
        import M1.M2.M3:
            bar,
            baz"""
        test_format(str_, str; indent=4, margin=11)

        str_ = """
        using A,

        B, C"""
        str = "using A, B, C"
        test_format(str_, str)

        str_ = """
        using A,
                  # comment
        B, C"""
        str = """
        using A,
          # comment
          B,
          C"""
        test_format(str_, str; indent=2, margin=80)

        str_ = """
        using A,  #inline
                  # comment
        B, C#inline"""
        str = """
        using A,  #inline
          # comment
          B,
          C#inline"""
        test_format(str_, str; indent=2, margin=80)

        str = """
        @somemacro function (fcall_ | fcall_)
            body_
        end"""
        test_format("@somemacro function (fcall_ | fcall_) body_ end", str; indent=4, margin=37)

        str = """
        @somemacro function (
            fcall_ | fcall_
        )
            body_
        end"""
        test_format("@somemacro function (fcall_ | fcall_) body_ end", str; indent=4, margin=36)
        test_format("@somemacro function (fcall_ | fcall_) body_ end", str; indent=4, margin=20)

        str = """
        @somemacro function (
            fcall_ |
            fcall_
        )
            body_
        end"""
        test_format("@somemacro function (fcall_ | fcall_) body_ end", str; indent=4, margin=19)

        str = "Val(x) = (@_pure_meta; Val{x}())"
        test_format("Val(x) = (@_pure_meta ; Val{x}())", str; indent=4, margin=80)

        # TODO: if this ends up being a issue fix it but it doesn't seem
        # like it actually occurs in the wild.
        str = "(a; b; c)"
        test_format("(a;b;c)", str; indent=4, margin=100)
        str = """
        (
            a;
            b;
            c
        )"""
        test_format("(a;b;c)", str; indent=4, margin=1)

        str = "(x for x = 1:10)"
        test_format("(x   for x  in  1 : 10)", str; indent=4, margin=100)

        str = """
        (
          x for
          x = 1:10
        )"""
        test_format("(x   for x  in  1 : 10)", str; indent=2, margin=10)

        str = """
        (
          x for
          x =
            1:10
        )"""
        test_format("(x   for x  in  1 : 10)", str; indent=2, margin=1)

        # indent for TupleN with no parens
        str = """
        function foo()
            arg1,
            arg2
        end"""
        test_format("function foo() arg1, arg2 end", str; indent=4, margin=1)

        str = """
        function foo()
            # comment
            arg
        end"""
        test_format(str, str; indent=4, margin=1)

        str = """
        A where {
            B,
        }"""
        str_ = "A where {B}"
        test_format(str_, str_)
        test_format(str_, str; indent=4, margin=1)

        str = """
        foo(
          arg1,
        )"""
        str_ = "foo(arg1)"
        test_format(str_, str_)
        test_format(str, str; indent=2, margin=1)

        str = """
        [
          arg1,
        ]"""
        str_ = "[arg1]"
        test_format(str_, str_)
        test_format(str, str; indent=2, margin=1)

        str = """
        {
          arg1,
        }"""
        str_ = "{arg1}"
        test_format(str_, str_)
        test_format(str, str; indent=2, margin=1)

        str = """
        (
          arg1
        )"""
        str_ = "(arg1)"
        test_format(str_, str_)
        test_format(str_, str; indent=2, margin=1)

        # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/9#issuecomment-481607068
        str = """
        this_is_a_long_variable_name = Dict{Symbol,Any}(
            :numberofpointattributes => NAttributes,
            :numberofpointmtrs => NMTr,
            :numberofcorners => NSimplex,
            :firstnumber => Cint(1),
            :mesh_dim => Cint(3),
        )"""

        str_ = """this_is_a_long_variable_name = Dict{Symbol,Any}(:numberofpointattributes => NAttributes,
               :numberofpointmtrs => NMTr, :numberofcorners => NSimplex, :firstnumber => Cint(1),
               :mesh_dim => Cint(3),)"""
        test_format(str_, str; indent=4, margin=80)

        str = """
        this_is_a_long_variable_name =
             Dict{Symbol,Any}(
                  :numberofpointattributes =>
                       NAttributes,
                  :numberofpointmtrs =>
                       NMTr,
                  :numberofcorners =>
                       NSimplex,
                  :firstnumber =>
                       Cint(1),
                  :mesh_dim =>
                       Cint(3),
             )"""
        test_format(str_, str; indent=5, margin=23)

        str = """
        this_is_a_long_variable_name =
             Dict{Symbol,Any}(
                  :numberofpointattributes =>
                       NAttributes,
                  :numberofpointmtrs =>
                       NMTr,
                  :numberofcorners =>
                       NSimplex,
                  :firstnumber =>
                       Cint(
                            1,
                       ),
                  :mesh_dim =>
                       Cint(
                            3,
                       ),
             )"""
        test_format(str_, str; indent=5, margin=22)

        str = """
        this_is_a_long_variable_name =
             Dict{
                  Symbol,
                  Any,
             }(
                  :numberofpointattributes =>
                       NAttributes,
                  :numberofpointmtrs =>
                       NMTr,
                  :numberofcorners =>
                       NSimplex,
                  :firstnumber =>
                       Cint(
                            1,
                       ),
                  :mesh_dim =>
                       Cint(
                            3,
                       ),
             )"""
        test_format(str_, str; indent=5, margin=1)

        str = """
        this_is_a_long_variable_name = (
            :numberofpointattributes => NAttributes,
            :numberofpointmtrs => NMTr,
            :numberofcorners => NSimplex,
            :firstnumber => Cint(1),
            :mesh_dim => Cint(3),
        )"""

        str_ = """this_is_a_long_variable_name = (:numberofpointattributes => NAttributes,
               :numberofpointmtrs => NMTr, :numberofcorners => NSimplex, :firstnumber => Cint(1),
               :mesh_dim => Cint(3),)"""
        test_format(str_, str; indent=4, margin=80)

        str = """
        func(
            a,
            \"""this
            is another
            multi-line
            string.
            Longest line
            \""",
            foo(b, c),
        )"""

        str_ = """
        func(a, \"""this
                is another
                multi-line
                string.
                Longest line
                \""", foo(b, c))"""
        test_format(str_, str)
        str_ = """
        func(
            a,
            \"""this
            is another
            multi-line
            string.
            Longest line
            \""",
            foo(
                b,
                c,
            ),
        )"""
        test_format(str, str_; indent=4, margin=1)

        # Ref
        str = "a[1+2]"
        test_format("a[1 + 2]", str; indent=4, margin=1)

        str = "a[(1+2)]"
        test_format("a[(1 + 2)]", str; indent=4, margin=1)

        str_ = "(a + b + c + d)"
        test_format(str_, str_; indent=4, margin=length(str_))

        str = """
        (
          a +
          b +
          c +
          d
        )"""
        test_format(str_, str; indent=2, margin=length(str_) - 1)
        test_format(str_, str; indent=2, margin=1)

        str_ = "(a <= b <= c <= d)"
        test_format(str_, str_; indent=4, margin=length(str_))

        str = """
        (
           a <=
           b <=
           c <=
           d
        )"""
        test_format(str_, str; indent=3, margin=length(str_) - 1)
        test_format(str_, str; indent=3, margin=1)

        # Don't join the first argument in a comparison
        # or chainopcall node, even if possible.
        str_ = "const a = arg1 + arg2 + arg3"
        str = """
        const a =
            arg1 +
            arg2 +
            arg3"""
        test_format(str_, str; indent=4, margin=18)

        str_ = "const a = arg1 == arg2 == arg3"
        str = """
        const a =
            arg1 ==
            arg2 ==
            arg3"""
        test_format(str_, str; indent=4, margin=19)

        # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/60
        str_ = """
        function write_subproblem_to_file(
                node::Node, filename::String;
                format::Symbol=:both, throw_error::Bool = false)
            body
        end"""
        str = """
        function write_subproblem_to_file(
            node::Node,
            filename::String;
            format::Symbol = :both,
            throw_error::Bool = false,
        )
            body
        end"""
        test_format(str_, str)

        # any pairing of argument, kawrg, or param should nest
        str = """
        f(
            arg;
            a = 1,
        )"""
        test_format("f(arg;a=1)", str; indent=4, margin=1)

        str = """
        f(
           arg,
           a = 1,
        )"""
        test_format("f(arg,a=1)", str; indent=3, margin=1)

        str = """
        f(
         a = 1;
         b = 2,
        )"""
        test_format("f(a=1; b=2)", str; indent=1, margin=1)

        str = """
        begin
            if foo
            elseif baz
            elseif a ||
                   b &&
                   c
            elseif bar
            else
            end
        end"""
        test_format(str, str; indent=4, margin=1)

        # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/453
        str = """
        bar = Dict(
            :foo => \"""A triple quoted literal string
                    with some words in it.\""",
        )
        """
        test_format(str, str; indent=4, margin=20)
    end

    @testset "nesting line offset" begin
        str = "a - b + c * d"
        _, s = run_nest(str, 100)
        @test s.line_offset == length(str)
        _, s = run_nest(str, length(str) - 1)
        @test s.line_offset == 5
        _, s = run_nest(str, 1)
        @test s.line_offset == 1

        str = "c ? e1 : e2"
        _, s = run_nest(str, 100)
        @test s.line_offset == length(str)
        _, s = run_nest(str, length(str) - 1)
        @test s.line_offset == 2
        _, s = run_nest(str, 8)
        @test s.line_offset == 2
        _, s = run_nest(str, 1)
        @test s.line_offset == 2

        str = "c1 ? e1 : c2 ? e2 : c3 ? e3 : c4 ? e4 : e5"
        _, s = run_nest(str, 100)
        @test s.line_offset == length(str)
        _, s = run_nest(str, length(str) - 1)
        @test s.line_offset == 32
        _, s = run_nest(str, 30)
        @test s.line_offset == 22
        _, s = run_nest(str, 20)
        @test s.line_offset == 12
        _, s = run_nest(str, 10)
        @test s.line_offset == 2
        _, s = run_nest(str, 1)
        @test s.line_offset == 2

        str = "f(a, b, c) where {A,B,C}"
        _, s = run_nest(str, 100)
        @test s.line_offset == length(str)
        _, s = run_nest(str, length(str) - 1)
        @test s.line_offset == 15
        _, s = run_nest(str, 14)
        @test s.line_offset == 1
        _, s = run_nest(str, 1)
        @test s.line_offset == 1

        str = "f(a, b, c) where Union{A,B,C}"
        _, s = run_nest(str, 100)
        @test s.line_offset == length(str)
        _, s = run_nest(str, length(str) - 1)
        @test s.line_offset == 20
        _, s = run_nest(str, 19)
        @test s.line_offset == 1
        _, s = run_nest(str, 1)
        @test s.line_offset == 1

        str = "f(a, b, c) where {A}"
        _, s = run_nest(str, 100)
        # adds surrounding {...} after `where`
        @test s.line_offset == length(str)
        _, s = run_nest(str, 1)
        @test s.line_offset == 1

        str = "f(a, b, c) where {A<:S}"
        _, s = run_nest(str, 100)
        @test s.line_offset == length(str)
        _, s = run_nest(str, length(str) - 1)
        @test s.line_offset == 14
        _, s = run_nest(str, 1)
        @test s.line_offset == 1

        str = "f(a, b, c) where Union{A,B,Union{C,D,E}}"
        _, s = run_nest(str, 100)
        @test s.line_offset == length(str)
        _, s = run_nest(str, length(str) - 1)
        @test s.line_offset == 31
        _, s = run_nest(str, 30)
        @test s.line_offset == 1
        _, s = run_nest(str, 1)
        @test s.line_offset == 1

        str = "f(a, b, c) where {A,{B, C, D},E}"
        _, s = run_nest(str, 100)
        # -2 whitespace in the brackets
        @test s.line_offset == length(str) - 2
        _, s = run_nest(str, 1)
        @test s.line_offset == 1

        str = "(a, b, c, d)"
        _, s = run_nest(str, 100)
        @test s.line_offset == length(str)
        _, s = run_nest(str, length(str) - 1)
        @test s.line_offset == 1

        str = "a, b, c, d"
        _, s = run_nest(str, 100)
        @test s.line_offset == length(str)
        _, s = run_nest(str, length(str) - 1)
        @test s.line_offset == 1

        str = """
        splitvar(arg) =
            @match arg begin
                ::T_ => (nothing, T)
                name_::T_ => (name, T)
                x_ => (x, :Any)
            end"""
        _, s = run_nest(str, 96)
        @test s.line_offset == 3
        _, s = run_nest(str, 1)
        @test s.line_offset == 7

        str = "prettify(ex; lines = false) = ex |> (lines ? identity : striplines) |> flatten |> unresolve |> resyntax |> alias_gensyms"
        _, s = run_nest(str, 80)
        @test s.line_offset == 17

        str = "foo() = a + b"
        _, s = run_nest(str, length(str))
        @test s.line_offset == length(str)
        _, s = run_nest(str, length(str) - 1)
        @test s.line_offset == 9
        _, s = run_nest(str, 1)
        @test s.line_offset == 5

        str_ = """
        @Expr(:scope_block, begin
                    body1
                    @Expr :break loop_cont
                    body2
                    @Expr :break loop_exit2
                    body3
                end)"""

        str = """
        @Expr(:scope_block, begin
            body1
            @Expr :break loop_cont
            body2
            @Expr :break loop_exit2
            body3
        end)"""
        test_format(str_, str; indent=4, margin=100)

        str = """
        @Expr(
            :scope_block,
            begin
                body1
                @Expr :break loop_cont
                body2
                @Expr :break loop_exit2
                body3
            end
        )"""
        test_format(str_, str; indent=4, margin=20)

        str = "export @esc, isexpr, isline, iscall, rmlines, unblock, block, inexpr, namify, isdef"
        _, s = run_nest(str, length(str))
        @test s.line_offset == length(str)
        _, s = run_nest(str, length(str) - 1)
        @test s.line_offset == 74
        _, s = run_nest(str, 73)
        @test s.line_offset == 9

        # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/9#issuecomment-481607068
        str = """this_is_a_long_variable_name = Dict{Symbol,Any}(:numberofpointattributes => NAttributes,
               :numberofpointmtrs => NMTr, :numberofcorners => NSimplex, :firstnumber => Cint(1),
               :mesh_dim => Cint(3),)"""
        _, s = run_nest(str, 80)
        @test s.line_offset == 1

        str = """this_is_a_long_variable_name = (:numberofpointattributes => NAttributes,
               :numberofpointmtrs => NMTr, :numberofcorners => NSimplex, :firstnumber => Cint(1),
               :mesh_dim => Cint(3),)"""
        _, s = run_nest(str, 80)
        @test s.line_offset == 1

        str = "import A: foo, bar, baz"
        _, s = run_nest(str, 22)
        @test s.line_offset == 17
        _, s = run_nest(str, 16)
        @test s.line_offset == 7
    end

    @testset "additional length" begin
        str_ = "f(a, @g(b, c), d)"
        str = """
        f(
            a,
            @g(b, c),
            d,
        )"""
        test_format(str_, str; indent=4, margin=13)
        test_format(str, str_; indent=4, margin=length(str))

        str_ = "f(a, @g(b, c), d)"
        str = """
        f(
            a,
            @g(
                b,
                c
            ),
            d,
        )"""
        test_format(str_, str; indent=4, margin=12)
        test_format(str, str_; indent=4, margin=length(str))

        str_ = "(a, (b, c), d)"
        str = """
        (
            a,
            (b, c),
            d,
        )"""
        test_format(str_, str; indent=4, margin=11)
        test_format(str, str_; indent=4, margin=length(str))

        str = """
        (
            a,
            (
                b,
                c,
            ),
            d,
        )"""
        test_format(str_, str; indent=4, margin=10)

        str_ = "(a, {b, c}, d)"
        str = """
        (
            a,
            {b, c},
            d,
        )"""
        test_format(str_, str; indent=4, margin=12)
        test_format(str_, str; indent=4, margin=11)

        str = """
        (
            a,
            {
                b,
                c,
            },
            d,
        )"""
        test_format(str_, str; indent=4, margin=10)
        test_format(str, str_; indent=4, margin=length(str))

        str_ = "(a, [b, c], d)"
        str = """
        (
            a,
            [b, c],
            d,
        )"""
        test_format(str_, str; indent=4, margin=13)
        test_format(str_, str; indent=4, margin=11)

        str = """
        (
            a,
            [
                b,
                c,
            ],
            d,
        )"""
        test_format(str_, str; indent=4, margin=10)
        test_format(str, str_; indent=4, margin=length(str))

        str_ = "a, (b, c), d"
        str = """
        a,
        (b, c),
        d"""
        test_format(str_, str; indent=4, margin=length(str_) - 1)
        test_format(str_, str; indent=4, margin=7)

        str = """
        a,
        (
            b,
            c,
        ),
        d"""
        test_format(str_, str; indent=4, margin=6)
        test_format(str, str_; indent=4, margin=length(str))

        str_ = "(var1,var2) && var3"
        str = """
        (var1, var2) &&
            var3"""
        test_format(str_, str; indent=4, margin=19)
        test_format(str_, str; indent=4, margin=15)

        str = """
        (
            var1,
            var2,
        ) && var3"""
        test_format(str_, str; indent=4, margin=14)

        str = """
        (
            var1,
            var2,
        ) &&
            var3"""
        test_format(str_, str; indent=4, margin=1)

        str_ = "(var1,var2) ? (var3,var4) : var5"
        str = """
        (var1, var2) ?
        (var3, var4) :
        var5"""
        test_format(str_, str; indent=4, margin=14)

        str = """
        (
            var1,
            var2,
        ) ?
        (
            var3,
            var4,
        ) : var5"""
        test_format(str_, str; indent=4, margin=13)
        test_format(str_, str; indent=4, margin=8)

        str = """
        (
            var1,
            var2,
        ) ?
        (
            var3,
            var4,
        ) :
        var5"""
        test_format(str_, str; indent=4, margin=7)

        str = """
        (var1, var2) ? (var3, var4) :
        var5"""
        test_format(str_, str; indent=4, margin=29)

        str = """
        (var1, var2) ?
        (var3, var4) : var5"""
        test_format(str_, str; indent=4, margin=28)

        str = """
        f(
            var1::A,
            var2::B,
        ) where {A,B}"""
        test_format("f(var1::A, var2::B) where {A,B}", str; indent=4, margin=30)

        str = """
        f(
            var1::A,
            var2::B,
        ) where {
            A,
            B,
        }"""
        test_format("f(var1::A, var2::B) where {A,B}", str; indent=4, margin=12)

        str = "foo(a, b, c)::Rtype where {A,B} = 10"
        str_ = "foo(a, b, c)::Rtype where {A,B,} = 10"
        test_format(str, str; indent=4, margin=length(str))
        test_format(str_, str; indent=4, margin=length(str_))

        str_ = """
        foo(a, b, c)::Rtype where {A,B} =
            10"""
        test_format(str, str_; indent=4, margin=35)
        test_format(str, str_; indent=4, margin=33)

        str_ = """
        foo(
            a,
            b,
            c,
        )::Rtype where {A,B} = 10"""
        test_format(str, str_; indent=4, margin=32)
        test_format(str, str_; indent=4, margin=25)

        str_ = """
        foo(
            a,
            b,
            c,
        )::Rtype where {A,B} =
            10"""
        test_format(str, str_; indent=4, margin=24)
        test_format(str, str_; indent=4, margin=22)

        str_ = """
        foo(
            a,
            b,
            c,
        )::Rtype where {
            A,
            B,
        } = 10"""
        test_format(str, str_; indent=4, margin=21)

        str_ = """
        foo(
          a,
          b,
          c,
        )::Rtype where {
          A,
          B,
        } =
          10"""
        test_format(str, str_; indent=2, margin=1)

        str_ = """
        foo(
              a,
              b,
              c,
        )::Rtype where {
              A,
              B,
        } = 10"""
        test_format(str, str_; indent=6, margin=18)

        str = "keytype(::Type{<:AbstractDict{K,V}}) where {K,V} = K"
        test_format(str, str; indent=4, margin=52)

        str_ = "transcode(::Type{THISISONESUPERLONGTYPE1234567}) where {T<:Union{Int32,UInt32}} = transcode(T, String(Vector(src)))"

        str = """
        transcode(
          ::Type{THISISONESUPERLONGTYPE1234567},
        ) where {T<:Union{Int32,UInt32}} = transcode(T, String(Vector(src)))"""
        test_format(str_, str; indent=2, margin=80)
        test_format(str_, str; indent=2, margin=68)

        str = """
        transcode(
          ::Type{THISISONESUPERLONGTYPE1234567},
        ) where {T<:Union{Int32,UInt32}} =
          transcode(T, String(Vector(src)))"""
        test_format(str_, str; indent=2, margin=67)
        test_format(str_, str; indent=2, margin=40)

        str = """
        transcode(
          ::Type{
            THISISONESUPERLONGTYPE1234567,
          },
        ) where {T<:Union{Int32,UInt32}} =
          transcode(T, String(Vector(src)))"""
        test_format(str_, str; indent=2, margin=39)

        str_ = "transcode(::Type{T}, src::AbstractVector{UInt8}) where {T<:Union{Int32,UInt32}} = transcode(T, String(Vector(src)))"
        str = """
        transcode(
          ::Type{T},
          src::AbstractVector{UInt8},
        ) where {T<:Union{Int32,UInt32}} = transcode(T, String(Vector(src)))"""
        test_format(str_, str; indent=2, margin=80)
        test_format(str_, str; indent=2, margin=68)

        str = """
        transcode(
          ::Type{T},
          src::AbstractVector{UInt8},
        ) where {T<:Union{Int32,UInt32}} =
          transcode(T, String(Vector(src)))"""
        test_format(str_, str; indent=2, margin=67)

        # issue 56
        str_ = "a_long_function_name(Array{Float64,2}[[1.0], [0.5 0.5], [0.5 0.5; 0.5 0.5], [0.5 0.5; 0.5 0.5]])"
        str = """
        a_long_function_name(
            Array{Float64,2}[[1.0], [0.5 0.5], [0.5 0.5; 0.5 0.5], [0.5 0.5; 0.5 0.5]],
        )"""
        test_format(str, str_; indent=4, margin=length(str))
        test_format(str_, str; indent=4, margin=length(str_) - 1)
        test_format(str_, str; indent=4, margin=79)

        str = """
        a_long_function_name(
            Array{Float64,2}[
                [1.0],
                [0.5 0.5],
                [0.5 0.5; 0.5 0.5],
                [0.5 0.5; 0.5 0.5],
            ],
        )"""
        test_format(str_, str; indent=4, margin=78)

        # unary op
        str_ = "[1, 1]'"
        str = """
        [
          1,
          1,
        ]'"""
        test_format(str, str_; indent=2, margin=length(str))
        test_format(str_, str; indent=2, margin=length(str_) - 1)
    end

    @testset "Trailing zeros" begin
        test_format("1.", "1.0")
        test_format("a * 1. + b", "a * 1.0 + b")
        test_format("1. + 2. * im", "1.0 + 2.0 * im")
        test_format("[1., 2.]", "[1.0, 2.0]")
        test_format("""
        1. +
            2.
        """, "1.0 + 2.0\n")
    end

    @testset "Leading zeros" begin
        test_format(".1", "0.1")
        test_format("a * .1 + b", "a * 0.1 + b")
        test_format(".1 + .2 * im", "0.1 + 0.2 * im")
        test_format("[.1, .2]", "[0.1, 0.2]")
        test_format("""
        .1 +
            .2
        """, "0.1 + 0.2\n")
    end

    # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/77
    @testset "matrices" begin
        str_ = """
        [ a b expr()
        d e expr()]"""
        str = """
        [
          a b expr()
          d e expr()
        ]"""
        test_format(str_, str; indent=2, margin=92)

        str_ = """
        T[ a b Expr()
        d e Expr()]"""
        str = """
        T[
            a b Expr()
            d e Expr()
        ]"""
        test_format(str_, str)

        str_ = """
        [ a b Expr();
        d e Expr();]"""
        str = """
        [
           a b Expr();
           d e Expr();
        ]"""
        test_format(str_, str; indent=3, margin=92)
        str_ = "[a b Expr(); d e Expr()]"
        test_format(str_, str_)
        str = """
        [
           a b Expr();
           d e Expr()
        ]"""
        test_format(str_, str; indent=3, margin=1)

        str_ = """
        T[ a b Expr();
        d e Expr();]"""
        str = """
        T[
            a b Expr();
            d e Expr();
        ]"""
        test_format(str_, str)

        str_ = "T[a b Expr(); d e Expr()]"
        test_format(str_, str_)
        str = """
        T[
            a b Expr();
            d e Expr()
        ]"""
        test_format(str_, str; indent=4, margin=1)

        str = """
        [
          0.0 0.0 0.0 1.0
          0.0 0.0 0.1 1.0
          0.0 0.0 0.2 1.0
          0.0 0.0 0.3 1.0
          0.0 0.0 0.4 1.0
          0.0 0.0 0.5 1.0
          0.0 0.0 0.6 1.0
          0.0 0.0 0.7 1.0
          0.0 0.0 0.8 1.0
          0.0 0.0 0.9 1.0
          0.0 0.0 1.0 1.0
          0.0 0.0 0.0 1.0
          0.0 0.1 0.1 1.0
          0.0 0.2 0.2 1.0
          0.0 0.3 0.3 1.0
          0.0 0.4 0.4 1.0
          0.0 0.5 0.5 1.0
          0.0 0.6 0.6 1.0
          0.0 0.7 0.7 1.0
          0.0 0.8 0.8 1.0
          0.0 0.9 0.9 1.0
          0.0 1.0 1.0 1.0
          0.0 0.0 0.0 1.0
          0.1 0.1 0.1 1.0
          0.2 0.2 0.2 1.0
          0.3 0.3 0.3 1.0
          0.4 0.4 0.4 1.0
          0.5 0.5 0.5 1.0
        ]"""
        test_format(str, str; indent=2, margin=92)
    end

    @testset "multi-variable `for` and `let`" begin
        str = """
        for a in x, b in y, c in z

            body
        end"""
        str_ = """
        for a in x,
            b in y,
            c in z

            body
        end"""
        test_format(str_, str)

        str_ = """
        for a in
            x,
            b in
            y,
            c in
            z

            body
        end"""
        test_format(str, str_; indent=4, margin=1)
        test_format(str_, str)

        str = """
        let a = x, b = y, c = z

            body
        end"""
        str_ = """
        let a = x,
            b = y,
            c = z

            body
        end"""
        test_format(str_, str)

        str_ = """
        let a = x,
            b = y,
            c = z

            body
        end"""
        test_format(str_, str)

        str_ = """
        let a =
                x,
            b =
                y,
            c =
                z

            body
        end"""
        test_format(str, str_; indent=4, margin=1)

        str = """
        let
            # comment
            list = [1, 2, 3]

            body
        end"""
        test_format(str, str)

        # issue 155
        str_ = raw"""
        @testset begin
            @testset "some long title $label1 $label2" for (
                                                               label1,
                                                               x1,
                                                           ) in [
                                                               (
                                                                   "label-1-1",
                                                                   medium_sized_expression,
                                                               ),
                                                               (
                                                                   "label-1-2",
                                                                   medium_sized_expression,
                                                               ),
                                                           ],
                                                           (
                                                               label2,
                                                               x2,
                                                           ) in [
                                                               (
                                                                   "label-2-1",
                                                                   medium_sized_expression,
                                                               ),
                                                               (
                                                                   "label-2-2",
                                                                   medium_sized_expression,
                                                               ),
                                                           ]

                @test x1 == x2
            end
        end"""
        str = raw"""@testset begin
            @testset "some long title $label1 $label2" for (label1, x1) in [
                    ("label-1-1", medium_sized_expression),
                    ("label-1-2", medium_sized_expression),
                ],
                (label2, x2) in [
                    ("label-2-1", medium_sized_expression),
                    ("label-2-2", medium_sized_expression),
                ]

                @test x1 == x2
            end
        end"""
        test_format(str_, str; margin=80)
    end

    @testset "single newline at end of file" begin
        str = "a = 10\n"

        f1 = tempname() * ".jl"
        open(f1, "w") do io
            write(io, "a = 10\n\n\n\n\n\n")
        end
        @test format_file(f1) == false
        @test format_file(f1) == true
        open(f1) do io
            res = read(io, String)
            @test res == str
        end
        rm(f1)
    end

    @testset "trailing comma - breaking cases" begin
        # A trailing comma here is ambiguous
        # It'll cause a parsing error.
        str = """
        gen2 = Iterators.filter(
            x -> x[1] % 2 == 0 && x[2] % 2 == 0,
            (x, y) for x = 1:10, y = 1:10
        )"""
        str_ = "gen2 = Iterators.filter(x -> x[1] % 2 == 0 && x[2] % 2 == 0, (x, y) for x = 1:10, y = 1:10)"

        test_format(str_, str; indent=4, margin=80)

        # With macro calls, a trailing comma can
        # change the semantics of the macro.
        #
        # Keeping this in mind it should not be
        # automatically added.
        str = """
        @func(
            a,
            b,
            c
        )"""
        test_format("@func(a, b, c)", str; indent=4, margin=1)

        str = """
        @func(
            a,
            b,
            c,
        )"""
        test_format("@func(a, b, c,)", str; indent=4, margin=1)
    end

    @testset "comprehension types" begin
        str_ = "var = ((x, y) for x = 1:10, y = 1:10)"
        str = """
        var =
            ((x, y) for x = 1:10, y = 1:10)"""
        test_format(str_, str; indent=4, margin=length(str_) - 1)
        test_format(str_, str; indent=4, margin=35)

        str = """
        var = (
            (x, y) for x = 1:10, y = 1:10
        )"""
        test_format(str_, str; indent=4, margin=34)

        str = """
        var = (
            (x, y) for
            x = 1:10, y = 1:10
        )"""
        test_format(str_, str; indent=4, margin=30)

        str = """
        var = (
            (x, y) for
            x = 1:10,
            y = 1:10
        )"""
        test_format(str_, str; indent=4, margin=20)

        str = """
        var =
            (
                (
                    x,
                    y,
                ) for
                x =
                    1:10,
                y =
                    1:10
            )"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """
        begin
        weights = Dict((file, i) => w for (file, subject) in subjects for (
                i,
                w,
            ) in enumerate(weightfn.(eachrow(subject.events))))
        end"""
        str = """
        begin
            weights = Dict(
                (file, i) => w for (file, subject) in subjects for
                (i, w) in enumerate(weightfn.(eachrow(subject.events)))
            )
        end"""
        test_format(str_, str; indent=4, margin=90)

        str = """
        begin
            weights = Dict(
                (file, i) => w for (file, subject) in subjects
                for (i, w) in
                enumerate(weightfn.(eachrow(subject.events)))
            )
        end"""
        test_format(str_, str; indent=4, margin=60)

        str = """
        begin
            weights = Dict(
                (file, i) => w for
                (file, subject) in subjects for
                (i, w) in enumerate(
                    weightfn.(eachrow(subject.events)),
                )
            )
        end"""
        test_format(str_, str; indent=4, margin=50)

        str_ = "(b for b in bar if b == 0 for bar in foo)"
        test_format(str_, str_)

        str = """
        (
            b for
            b in
            bar if
            b ==
            0 for
            bar in
            foo
        )"""
        test_format(str_, str; indent=4, margin=1)
    end

    @testset "parens" begin
        str = """
        some_function(
            (((
                very_very_very_very_very_very_very_very_very_very_very_very_long_function_name(
                    very_very_very_very_very_very_very_very_very_very_very_very_long_argument,
                    very_very_very_very_very_very_very_very_very_very_very_very_long_argument,
                ) for x in xs
            ))),
            another_argument,
        )"""
        test_format(str, str)

        str_ = """
some_function(
(((
               very_very_very_very_very_very_very_very_very_very_very_very_long_function_name(
                   very_very_very_very_very_very_very_very_very_very_very_very_long_argument,
                   very_very_very_very_very_very_very_very_very_very_very_very_long_argument,
               )
               for x in xs
))),
           another_argument,
        )"""
        test_format(str_, str)

        str = """
        if ((
          aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa ||
          aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa ||
          aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa
        ))
          nothing
        end"""
        test_format(str, str; indent=2, margin=92)

        str = """
        begin
                if ((
                        aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa ||
                        aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa ||
                        aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa
                ))
                        nothing
                end
        end"""
        test_format(str, str; indent=8, margin=92)

        #
        # Don't nest the op if an arg is parens
        #

        str_ = """
        begin
        if foo
        elseif baz
        elseif (a || b) && c
        elseif bar
        else
        end
        end"""

        str = """
        begin
            if foo
            elseif baz
            elseif (a || b) && c
            elseif bar
            else
            end
        end"""
        test_format(str_, str; indent=4, margin=24)

        str = """
        begin
            if foo
            elseif baz
            elseif (a || b) &&
                   c
            elseif bar
            else
            end
        end"""
        test_format(str_, str; indent=4, margin=23)

        str = """
        begin
            if foo
            elseif baz
            elseif (
                a || b
            ) && c
            elseif bar
            else
            end
        end"""
        test_format(str_, str; indent=4, margin=15)

        str = """
        begin
            if foo
            elseif baz
            elseif (
                a ||
                b
            ) && c
            elseif bar
            else
            end
        end"""
        test_format(str_, str; indent=4, margin=14)
        test_format(str_, str; indent=4, margin=10)

        str = """
        begin
            if foo
            elseif baz
            elseif (
                a ||
                b
            ) &&
                   c
            elseif bar
            else
            end
        end"""
        test_format(str_, str; indent=4, margin=9)
        test_format(str_, str; indent=4, margin=1)

        str_ = """
        if s.opts.ignore_maximum_width && !(is_comma(n) || is_block(t) || t.typ === FunctionN ||
                    t.typ  === Macro || is_typedef(t))
                # join based on position in original file
                join_lines = t.endline == n.startline
        end
        """
        str = """
        if s.opts.ignore_maximum_width && !(
            is_comma(n) ||
            is_block(t) ||
            t.typ === FunctionN ||
            t.typ === Macro ||
            is_typedef(t)
        )
            # join based on position in original file
            join_lines = t.endline == n.startline
        end
        """
        test_format(str_, str; indent=4, margin=80)
    end

    @testset "unnest" begin
        str = """
        let X = LinearAlgebra.Symmetric{T,S} where {S<:(AbstractArray{U,2} where {U<:T})} where {T},
            Y = Union{
                LinearAlgebra.Hermitian{T,S} where {S<:(AbstractArray{U,2} where {U<:T})} where T,
                LinearAlgebra.Symmetric{T,S} where {S<:(AbstractArray{U,2} where {U<:T})} where T,
            }

            @test X <: Y
        end"""
        test_format(str, str; indent=4, margin=92)

        str = """
        let X = LinearAlgebra.Symmetric{
                T,
                S,
            } where {S<:(AbstractArray{U,2} where {U<:T})} where {T},
            Y = Union{
                LinearAlgebra.Hermitian{T,S} where {S<:(AbstractArray{U,2} where {U<:T})} where T,
                LinearAlgebra.Symmetric{T,S} where {S<:(AbstractArray{U,2} where {U<:T})} where T,
            }

            @test X <: Y
        end"""
        test_format(str, str; indent=4, margin=90)

        str = """
        ys = map(xs) do x
            return (
                very_very_very_very_very_very_very_very_very_very_very_long_expr,
                very_very_very_very_very_very_very_very_very_very_very_long_expr,
            )
        end"""
        test_format(str, str)
    end

    @testset "remove excess newlines" begin
        str_ = """
        var = foo(a,

        b,     c,





        d)"""
        str = "var = foo(a, b, c, d)"
        test_format(str_, str)

        str = """
        var =
            foo(
                a,
                b,
                c,
                d,
            )"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """
        var = foo(a,

        b,     c,


        # comment !!!


        d)"""
        str = """
        var = foo(
            a,
            b,
            c,


            # comment !!!


            d,
        )"""
        test_format(str_, str)

        str = """
        var = foo(
            a,
            b,
            c,

            # comment !!!

            d,
        )"""
        test_format(str_, str; remove_extra_newlines = true)

        str_ = """
        var =

            func(a,

            b,

            c)"""
        str = """var = func(a, b, c)"""
        test_format(str_, str)
        test_format(str_, str; remove_extra_newlines = true)

        str_ = """
        var =

            a &&


        b &&
        c"""
        str = """var = a && b && c"""
        test_format(str_, str)
        test_format(str_, str; remove_extra_newlines = true)

        # Inline comment on the line before blank lines should force nesting
        str_ = """
        x =

            a && # inline

            b"""
        str = """
        x =
            a && # inline
            b"""
        test_format(str_, str)

        # Comment in gap lines should force nesting
        str_ = """
        x =

            a &&
            # comment
            b"""
        str = """
        x =
            a &&
            # comment
            b"""
        test_format(str_, str)

        str_ = """
        var =

            a ?


        b :



        c"""
        str = """var = a ? b : c"""
        test_format(str_, str)
        test_format(str_, str; remove_extra_newlines = true)

        str_ = """
        var =

            a +


        b +



        c"""
        str = """var = a + b + c"""
        test_format(str_, str)
        test_format(str_, str; remove_extra_newlines = true)

        str_ = """
        var =

            a   ==


        b   ==



        c"""
        str = """var = a == b == c"""
        test_format(str_, str)
        test_format(str_, str; remove_extra_newlines = true)
    end

    @testset "align ChainOpCall indent" begin
        str_ = """
        function _()
            return some_expression *
            some_expression *
            some_expression *
            some_expression *
            some_expression *
            some_expression *
            some_expression
        end"""
        str = """
        function _()
            return some_expression *
                   some_expression *
                   some_expression *
                   some_expression *
                   some_expression *
                   some_expression *
                   some_expression
        end"""
        test_format(str_, str)

        str_ = """
        @some_macro some_expression *
        some_expression *
        some_expression *
        some_expression *
        some_expression *
        some_expression *
        some_expression"""
        str = """
        @some_macro some_expression *
                    some_expression *
                    some_expression *
                    some_expression *
                    some_expression *
                    some_expression *
                    some_expression"""
        test_format(str_, str)

        str_ = """
        if some_expression && some_expression && some_expression && some_expression

            body
        end"""
        str = """
        if some_expression &&
           some_expression &&
           some_expression &&
           some_expression

            body
        end"""
        test_format(str_, str; margin = 74)
        test_format(str, str_; margin = 75)

        str_ = """
        if argument1 && argument2 && (argument3 || argument4 || argument5) && argument6

            body
        end"""
        str = """
        if argument1 &&
           argument2 &&
           (argument3 || argument4 || argument5) &&
           argument6

            body
        end"""
        test_format(str_, str; margin = 43)

        str = """
        if argument1 &&
           argument2 &&
           (
               argument3 ||
               argument4 ||
               argument5
           ) &&
           argument6

            body
        end"""
        test_format(str_, str; margin = 42)
    end

    @testset "standalone lazy expr indent" begin
        str = """
        begin
          a &&
            b
          a ||
            b
        end"""
        test_format(str, str; indent=2, margin=1)

        str_ = """
        begin
         a && b || c && d
        end"""

        str = """
        begin
            a && b ||
                c && d
        end"""
        test_format(str_, str; indent=4, margin=19)

        str = """
        begin
            a && b ||
                c &&
                d
        end"""
        test_format(str_, str; indent=4, margin=13)

        str = """
        begin
            a &&
            b ||
                c &&
                d
        end"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """
        begin
        a || (b && c && d)
        end"""

        str = """
        begin
            a ||
                (
                    b &&
                    c &&
                    d
                )
        end"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """
        begin
        (a && b && c) || d
        end"""

        str = """
        begin
            (
                a &&
                b &&
                c
            ) ||
                d
        end"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """
        begin
         a || b && c || d
        end"""

        str = """
        begin
            a ||
                b && c ||
                d
        end"""
        test_format(str_, str; indent=4, margin=19)

        str = """
        begin
            a ||
                b &&
                c ||
                d
        end"""
        test_format(str_, str; indent=4, margin=16)

        str_ = """
        begin
         a && b || c || d || e
        end"""
        str = """
        begin
            a &&
            b ||
                c ||
                d ||
                e
        end"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """
        begin
         a || b && c && d && e
        end"""
        str = """
        begin
            a ||
                b &&
                c &&
                d &&
                e
        end"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """
        if aa && bb
        end

        if (aa && bb)
        end"""

        str = """
        if aa &&
           bb
        end

        if (
            aa &&
            bb
        )
        end"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """
        if aa || bb || cc
        end

        if (aa || bb || cc)
        end"""

        str = """
        if aa ||
           bb ||
           cc
        end

        if (
            aa ||
            bb ||
            cc
        )
        end"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """var = a && b"""
        str = """
        var =
            a &&
            b"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """var() = a && b"""
        str = """
        var() =
            a &&
            b"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """var = a || b || c"""
        str = """
        var =
            a ||
            b ||
            c"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """var() = a || b || c"""
        str = """
        var() =
            a ||
            b ||
            c"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """
        @hello arg1 && arg2 && return arg3"""
        str = """
        @hello arg1 &&
               arg2 &&
               return arg3"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """
        @hello arg1 || return arg2"""
        str = """
        @hello arg1 ||
               return arg2"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """
        return arg1 || arg2"""
        str = """
        return arg1 ||
               arg2"""
        test_format(str_, str; indent=4, margin=1)

        str_ = raw"""
        @othermacro begin
                x isa Matrix &&
                   @testset "$MT" for MT in (Diagonal, UpperTriangular, LowerTriangular)
                       test_rrule(fnorm, MT(x), p; kwargs..., check_inferred=VERSION >= v"1.5")
                   end
        end
        """
        str = raw"""
        @othermacro begin
            x isa Matrix &&
                @testset "$MT" for MT in (Diagonal, UpperTriangular, LowerTriangular)
                    test_rrule(
                        fnorm,
                        MT(x),
                        p;
                        kwargs...,
                        check_inferred = VERSION >= v"1.5",
                    )
                end
        end
        """
        test_format(str_, str; indent=4, margin=80)
    end

    @testset "source file line offset with unicode" begin
        # These just check to see formatting runs without error

        str = """
        a = 10
        # └─ code.jl (before -> after2)
        v = "test_basic_config"
        """
        test_format(str, str)

        str = """
        a = 10
        unicode_str = "α10′"
        v = "test_basic_config"
        """
        test_format(str, str)

        str = """
        a = 10
        unicode_op = 5 ⪅ 10.0
        v = "test_basic_config"
        """
        test_format(str, str)

        str = """
        a = 10
        unicode_identifier′ = 10
        v = "test_basic_config"
        """
        test_format(str, str)

        str = "const FOO = ['😢']"
        test_format(str, str)

        str = "const FOO = '😢'"
        test_format(str, str)
    end

    @testset "comprehension leftover extra margin" begin
        str_ = """
        src_idx = [mod1(div(dest_idx[dim] - 1, inner[dim]) + 1, S[dim]) for dim = 1:length(S)]
        """
        str = """
        src_idx = [
            mod1(div(dest_idx[dim] - 1, inner[dim]) + 1, S[dim]) for dim = 1:length(S)
        ]
        """
        test_format(str_, str; indent=4, margin=78)
    end

    @testset "operators as arguments" begin
        str_ = "a    .*     %"
        str = "a .* %"
        test_format(str_, str; indent=4, margin=100)

        str_ = "a    *     %"
        str = "a * %"
        test_format(str_, str; indent=4, margin=100)

        @test run_pretty("+(y)", 80)[1].typ === JuliaFormatter.Unary
        @test run_pretty(">=(y)", 80)[1].typ === JuliaFormatter.Call
    end

    @testset "binary shortcircuit" begin
        s1 = """
        if a || b
            body
        elseif c || d
            body2 && body2
        elseif e || f
            body3 || body3
        else
            body4 && body4
        end
        """
        s2 = """
        if a ||
           b
                body
        elseif c ||
               d
                body2 &&
                        body2
        elseif e ||
               f
                body3 ||
                        body3
        else
                body4 &&
                        body4
        end
        """
        test_format(s1, s2; indent=8, margin=1)

        str_ = """
        a =     if where_idx === nothing
               from_typedef
           else
               from_typedef ||
               b
           end
        """
        str = """
        a =
            if where_idx ===
               nothing
                from_typedef
            else
                from_typedef ||
                    b
            end
        """
        test_format(str_, str; indent=4, margin=1)
    end

    @testset "parameter to call nesting" begin
        # always nest is in parameters
        s = raw"""
        test_rrule(
            SymHerm,
            x,
            uplo;
            output_tangent = ΔΩ,
            # type stability here critically relies on uplo being constant propagated,
            # so we need to test this more carefully below
            check_inferred = false,
        )
        """
        test_format(s, s; indent=4, margin=100)

        # always nest is outsite of parameters in the call
        s = raw"""
        test_rrule(  # 5 arg version with scaling scalar
            gemm,
            tA,
            tB,
            randn(T),
            A,
            B;
            check_inferred = false,
        )
        """
        test_format(s, s; indent=4, margin=100)
    end

    @testset "no args before kwargs ; placement" begin
        str_ = """(; a = b, c = d)"""
        str = """
        (;
            a = b,
            c = d,
        )"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """(;  # inline
            a = b, c = d)"""
        str = """
        (;  # inline
            a = b,
            c = d,
        )"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """(;
            # comment
            a = b, c = d)"""
        str = """
        (;
            # comment
            a = b,
            c = d,
        )"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """(arg;
            # comment
            a = b, c = d)"""
        str = """
        (
            arg;
            # comment
            a = b,
            c = d,
        )"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """(arg; # inline
            a = b, c = d)"""
        str = """
        (
            arg; # inline
            a = b,
            c = d,
        )"""
        test_format(str_, str; indent=4, margin=1)

        str_ = """(arg;
            a = b, c = d)"""
        str = """
        (
            arg;
            a = b,
            c = d,
        )"""
        test_format(str_, str; indent=4, margin=1)
    end

    @testset "for loop, extra placeholder not added" begin
        str_ = """
        for i in [a,b,c]
            body
        end
        """
        str = """
        for i in
            [
            a,
            b,
            c,
        ]
            body
        end
        """
        test_format(str_, str; indent=4, margin=1)
    end

    @testset "for loop, placeholder not removed" begin
        str_ = """
        for f in (A, B), T in (C, D)
            a
            b
        end"""
        str = """
        for f in (A, B),
            T in (C, D)

            a
            b
        end"""
        test_format(str_, str; indent=4, margin=27)
        test_format(str, str; indent=4, margin=27, join_lines_based_on_source = true)
    end

    @testset "block automatically assume nested when join_lines_based_on_source" begin
        str_ = """
        let y = a, z = b
            body
        end"""
        str = """
        let y = a,
            z = b

            body
        end"""
        test_format(str_, str_; indent=4, margin=16, join_lines_based_on_source = true)
        test_format(str_, str; indent=4, margin=15, join_lines_based_on_source = true)
    end

    @testset "public keyword support" begin
        str_ = """
        public    a,b,
         c
        """
        str = """
        public a, b, c
        """
        test_format(str_, str; indent=4, margin=14)
        str = """
        public a,
            b,
            c
        """
        test_format(str_, str; indent=4, margin=1)
    end

    @testset "semicolon statement separators are dropped" begin
        test_format("begin; end", "begin end")
        test_format("for i = 1:10; x = 1; y = 2; end", "for i = 1:10\n    x = 1\n    y = 2\nend")
        test_format("for i = 1:2; end", "for i = 1:2\nend")
        test_format("function f(); end", "function f() end")
        test_format("function f(); x = 1; end", "function f()\n    x = 1\nend")
        test_format("if a; b; else; c; end", "if a\n    b\nelse\n    c\nend")
        test_format("if a; end", "if a\nend")
        test_format("let a = 1, b = 2; x; end", "let a = 1, b = 2\n    x\nend")
        test_format("let a = 1; b = 2; x; end", "let a = 1\n    b = 2\n    x\nend")
        test_format("let; end", "let\nend")
        test_format("macro m(); end", "macro m() end")
        test_format("module A; end", "module A end")
        test_format("mutable struct A; end", "mutable struct A end")
        test_format("mutable struct A; x::Int; end", "mutable struct A\n    x::Int\nend")
        test_format("quote; end", "quote end")
        test_format("quote; x = 1; end", "quote\n    x = 1\nend")
        test_format("struct A; end", "struct A end")
        test_format("struct A; x::Int; end", "struct A\n    x::Int\nend")
        test_format("try; catch; end", "try\ncatch\nend")
        test_format("while a; b; end", "while a\n    b\nend")
        test_format("while a; end", "while a\nend")

        @testset "top-level semicolons aren't dropped" begin
            test_format("hello();", "hello();")
            test_format("x = 1; y = 2", "x = 1;\ny = 2")
        end

        @testset "semantically significant semicolons aren't dropped" begin
            test_format("(a; b)", "(a; b)")
            test_format("f(a; b = 1)", "f(a; b = 1)")
        end
    end

    @testset "comments after empty block body" begin
        for style in ALL_STYLES
            for loop_start in ("for x in y", "while x", "if x", "if x\n    f\nelseif x", "let x = y", "function f()", "macro m()")
                s_ = "$(loop_start); #= comment =# end"
                s = """
                $(loop_start)
                    #= comment =#
                end"""
                test_format(s_, s, style)

                s_ = "$(loop_start); #= comment1 =# #= comment2 =# end"
                s = """
                $(loop_start)
                    #= comment1 =# #= comment2 =#
                end"""
                test_format(s_, s, style)

                s_ = "$(loop_start); # comment\n end"
                s = """
                $(loop_start) # comment
                end"""
                test_format(s_, s, style)
            end
        end
    end
end

end # module

# When formatting Julia code inside docstrings, we need to know whether it's inside
# a single-quoted Julia docstring, a triple-quoted Julia docstring, or just a Markdown
# file. This affects how we handle escape sequences.
@enum FormatDocstringContext SingleQuotedDocstring TripleQuotedDocstring MarkdownFile

struct FormatRule
    style::AbstractStyle
    opts::Options{Union{}}
    context::FormatDocstringContext
end

const _REPLACEMENT_PAIRS = (
    # Not sure what other replacements are needed?
    "\\\\" => "\\",
    "\\\$" => "\$",
    "\\\"" => "\"",
)
function unescape_docstring_code(text::AbstractString, context::FormatDocstringContext)
    return if context === MarkdownFile
        text
    else
        replace(text, (k => v for (k, v) in _REPLACEMENT_PAIRS)...)
    end
end
function escape_docstring_code(text::AbstractString, context::FormatDocstringContext)
    return if context === MarkdownFile
        text
    elseif context === TripleQuotedDocstring
        # If the output is within a triple-quoted docstring, then we don't need to
        # fully escape `"""`: we can get away with just doing `\\"""`.
        text_chunks = split(text, "\"\"\"")
        text_chunks = map(x -> escape_docstring_code(x, SingleQuotedDocstring), text_chunks)
        join(text_chunks, "\\\"\"\"")
    else
        replace(text, (v => k for (k, v) in _REPLACEMENT_PAIRS)...)
    end
end

function format_docstring_code(text::AbstractString, fr::FormatRule)
    try
        # Julia code within docstrings may contain escape sequences. For example if we want
        # to write `A \ b` in a docstring, it has to be written as (for example)
        # 
        #     """
        #     [...]
        #     julia> A \\ b
        #
        #     [...]
        #     """
        #     function foo end
        #
        # However, this means that the `text` we receive here is actually doubly
        # escaped because it's the literal contents of the docstring:
        #
        #     text = "A \\\\ b"
        #
        # which is not the same thing as the code we want to format, which is
        #
        #     code = "A \\ b"
        #
        # So we need to unescape it before formatting, and then re-escape it afterwards.
        # Note that docstrings have to be `"""..."""`: prefixed strings (e.g.
        # `raw"""..."""`) are not valid docstrings, so we don't have to worry about them.
        #
        # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/1224
        escape_docstring_code(
            _format_text(unescape_docstring_code(text, fr.context), fr.style, fr.opts),
            fr.context,
        )
    catch e
        if e isa JuliaSyntax.ParseError
            # Original code was invalid Julia (not through any fault of ours). Just pass it
            # through.
            return text
        else
            rethrow(e)
        end
    end
end

function block_modifier(rule::FormatRule)
    Rule(1) do _, block
        if block.t isa CodeBlock &&
           startswith(block.t.info, r"@example|@repl|@eval|julia|{julia}|jldoctest")
            code = block.literal::String

            block.literal = if occursin(r"^julia> "m, code)
                doctests = IOBuffer()
                chunks = repl_splitter(code)
                for (i, (an_input, output)) in enumerate(chunks)
                    write(doctests, "julia> ")
                    for (j, line) in
                        enumerate(split(format_docstring_code(an_input, rule), '\n'))
                        if j > 1
                            if line == ""
                                write(doctests, "\n")
                            else
                                write(doctests, "\n       ")
                            end
                        end
                        write(doctests, line)
                    end
                    write(doctests, '\n')
                    write(doctests, output)

                    if i < length(chunks)
                        if output == ""
                            write(doctests, "\n")
                        else
                            write(doctests, "\n\n")
                        end
                    end
                end
                write(doctests, '\n')
                String(take!(doctests))
            elseif occursin(r"\n+# output\n+", code)
                input, output = split(code, r"\n+# output\n+"; limit = 2)
                string(
                    format_docstring_code(String(input), rule),
                    "\n\n# output\n\n",
                    output,
                )
            else
                format_docstring_code(code, rule)
            end
        end
    end
end

function format_docstring(style::AbstractStyle, state::State, text::AbstractString)
    is_triple_quoted =
        state.opts.enforce_triplequoted_docstrings ||
        (startswith(text, "\"\"\"") && endswith(text, "\"\"\""))
    start_boundary = findfirst(!=('"'), text)
    # if the docstring is non-empty
    if !isnothing(start_boundary)
        _end_boundary = findlast(!=('"'), text)
        end_boundary = isnothing(_end_boundary) ? length(text) : _end_boundary
        # first, we need to remove any user indent
        # only some lines will "count" towards increasing the user indent
        # start at a very big guess
        user_indent = typemax(Int)
        user_indented = text[start_boundary:end_boundary]
        deindented = IOBuffer()
        user_lines = split(user_indented, '\n')
        for (index, line) in enumerate(user_lines)
            # the first line doesn't count
            if index != 1
                num_spaces = 0
                for c in line
                    if !(isspace(c))
                        break
                    else
                        true
                    end
                    num_spaces += 1
                end
                # if the line is only spaces, it only counts if it is the last line
                if num_spaces < length(line) || index == length(user_lines)
                    user_indent = min(user_indent, num_spaces)
                end
            end
        end
        deindented_string =
        # if there are no lines at all, or if the user indent is zero, we don't have to change anything
            if user_indent == typemax(Int) || user_indent == 0
                user_indented
            else
                # else, deindent non-first lines
                first_line = true
                for line in split(user_indented, '\n')
                    if first_line
                        first_line = false
                        write(deindented, line)
                    else
                        write(deindented, '\n')
                        write(deindented, chop(line; head = user_indent, tail = 0))
                    end
                end
                String(take!(deindented))
            end

        # then, we format
        formatted = markdown(
            enable!(
                Parser(),
                [
                    AdmonitionRule(),
                    FootnoteRule(),
                    MathRule(),
                    TableRule(),
                    FrontMatterRule(),
                    FormatRule(style, state.opts, if is_triple_quoted
                        TripleQuotedDocstring
                    else
                        SingleQuotedDocstring
                    end),
                ],
            )(
                deindented_string,
            ),
        )
    else
        # the docstring is empty
        formatted = ""
    end
    # Render into text lines, taking care of original indentation,
    quot = is_triple_quoted ? "\"\"\"" : "\""
    indentation = " "^state.indent
    indent(line) = indentation * line
    clean(line) = all(isspace, line) ? "" : line # don't write empty lines #667
    lines = split(formatted, '\n')
    last(lines) == "" || # Legacy guarantee.
        error("unreachable: `formatted` should end in empty string. Please report this at \
               https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues!")
    if is_triple_quoted
        prep = line -> clean(indent(line)) # All lines are prepared the same way.
        lines = Iterators.map(prep, lines)
        quot * '\n' * join(lines, '\n') * indent(quot)
    else
        # The first line needs no indentation.
        first = clean(lines[1])
        prep = line -> '\n' * indent(line)
        lines = Iterators.map(prep, lines[2:(end-1)]) # (drop last empty line)
        quot * first * join(lines) * quot
    end
end

module ArgParse

import ..JuliaFormatter:
    AbstractStyle,
    DefaultStyle,
    BlueStyle,
    SciMLStyle,
    YASStyle,
    MinimalStyle,
    STYLE_MAP,
    Configuration,
    configuration_from_kwargs,
    Options

struct ParseArgsError <: Exception
    message::String
end

# Enums that are attached to OptSpec that are used purely for help text rendering.
@enum OptKind FlagKind OptionKind NegatableFlagKind
@enum OptGroup GeneralGroup FormattingGroup DeprecatedGroup

"""
    OptionSpec

A declarative (ish) specification of a command-line option, designed to mimic
Haskell's `optparse-applicative`.

These, combined with the actual arguments, are parsed into a `Dict{Symbol,Any}`.
"""
struct OptSpec
    "The prefixes that trigger this option, e.g. `-c` or `--check`."
    names::Vector{String}
    "Help text"
    help::String
    "The key in the result dictionary where the parsed value will be stored."
    dest::Symbol
    "A function that consumes the option from the argument list. Takes the remaining
    arguments (starting with the matched token) and returns `(value, rest)`."
    consume::Function
    "If true, values are collected into a vector instead of overwriting."
    multi::Bool
    "What kind of option this is, for help text rendering."
    kind::OptKind
    "Group for help text output. Options with the same group are displayed together."
    group::OptGroup
    "Placeholder for the value in help text, e.g. `<n>` or `<file>`."
    metavar::String
end

# --- Combinators for building specs ---

# Generic value parser.
function parse_value(::Type{T}, raw::AbstractString, option_name::String) where {T}
    T <: AbstractString && return raw
    try
        return Base.parse(T, raw)
    catch
        throw(ParseArgsError("invalid value `$raw` for option `$option_name`"))
    end
end

function parse_value(::Type{Union{Nothing,Bool}}, raw::AbstractString, option_name::String)
    raw == "true" && return true
    raw == "false" && return false
    raw == "nothing" && return nothing
    throw(
        ParseArgsError(
            "invalid value `$raw` for option `$option_name` (expected `true`, `false`, or `nothing`)",
        ),
    )
end

# Parse (x, y) where x <= y. Used in --lines.
function parse_value(::Type{Tuple{Int,Int}}, raw::AbstractString, option_name::String)
    m = match(r"^(\d+):(\d+)$", raw)
    if m === nothing
        throw(
            ParseArgsError(
                "invalid value `$raw` for option `$option_name` (expected `<start>:<stop>` with 1-based line numbers)",
            ),
        )
    end
    start_line = Base.parse(Int, m.captures[1]::AbstractString)
    stop_line = Base.parse(Int, m.captures[2]::AbstractString)
    if start_line > stop_line
        throw(
            ParseArgsError(
                "invalid value `$raw` for option `$option_name`: start is greater than stop",
            ),
        )
    end
    return (start_line, stop_line)
end

# Parse styles.
function parse_value(::Type{AbstractStyle}, raw::AbstractString, option_name::String)
    style = get(STYLE_MAP, raw, nothing)
    if style === nothing
        valid = join(sort!(collect(keys(STYLE_MAP))), ", ")
        throw(
            ParseArgsError(
                "invalid value `$raw` for option `$option_name` (expected one of: $valid)",
            ),
        )
    end
    return style
end

# Flag: `--check` / `-c` sets dest to true.
function flag(names; dest::Symbol, help::String, group::OptGroup = GeneralGroup)
    OptSpec(
        names,
        help,
        dest,
        argv -> (true, @view argv[2:end]),
        false,
        FlagKind,
        group,
        "",
    )
end

# Negatable flag (DEPRECATED): `--always_for_in` / `--no-always_for_in`.
# Deprecated in favour of `--always-for-in=true` / `--always-for-in=false`.
function negatable_flag(name::String; dest::Symbol)
    pos = "--$name"
    neg = "--no-$name"
    OptSpec(
        [pos, neg],
        "",
        dest,
        argv -> (argv[1] == pos, @view argv[2:end]),
        false,
        NegatableFlagKind,
        DeprecatedGroup,
        "",
    )
end

# Option with a value: `--margin=92` or `--margin 92` or `-o file`.
# `names` is a vector of names, e.g. `["-o", "--output"]`.
_metavar(::Type{Int}) = "<n>"
_metavar(::Type{Bool}) = "true|false"
_metavar(::Type{Union{Nothing,Bool}}) = "true|false|nothing"
_metavar(::Type{String}) = "<value>"
_metavar(::Type) = "<value>"

function option(
    names;
    dest::Symbol,
    type::Type,
    help::String,
    multi::Bool = false,
    group::OptGroup = GeneralGroup,
    metavar::String = _metavar(type),
)
    OptSpec(
        names,
        help,
        dest,
        argv -> begin
            x = argv[1]
            eq = findfirst('=', x)
            if eq !== nothing
                raw = x[(eq+1):end]
                (parse_value(type, raw, x), @view argv[2:end])
            else
                length(argv) < 2 && throw(ParseArgsError("expected value after `$x`"))
                (parse_value(type, argv[2], x), @view argv[3:end])
            end
        end,
        multi,
        OptionKind,
        group,
        metavar,
    )
end

option(name::String; kw...) = option([name]; kw...)

# --- The parser: a list of specs ---

struct ArgParser
    specs::Vector{OptSpec}
    # Map from option name to index in `specs` for fast lookup.
    index::Dict{String,Int}

    function ArgParser(specs::OptSpec...)
        index = Dict{String,Int}()
        for (i, spec) in enumerate(specs)
            for name in spec.names
                haskey(index, name) && throw(ArgumentError("duplicate option name `$name`"))
                index[name] = i
            end
        end
        new(collect(specs), index)
    end
end

function maybe_get_spec(parser::ArgParser, token::String)::Union{OptSpec,Nothing}
    name = first(split(token, '='; limit = 2))
    i = get(parser.index, name, nothing)
    return if i === nothing
        nothing
    else
        parser.specs[i]
    end
end

function parse_raw(parser::ArgParser, argv::Vector{String})
    positional_args = String[]
    options = Dict{Symbol,Any}()

    remaining = @view argv[:]
    while !isempty(remaining)
        token = first(remaining)
        spec = maybe_get_spec(parser, token)
        if spec !== nothing
            if spec.group == DeprecatedGroup
                @warn """Options with underscores (e.g. `--always_for_in`) are deprecated \
                    and will be removed in a future version. \
                    Use hyphens instead (e.g. `--always-for-in=true`).""" maxlog = 1
            end
            value, remaining = spec.consume(remaining)
            if spec.multi
                # append
                if !haskey(options, spec.dest)
                    options[spec.dest] = typeof(value)[]
                end
                push!(options[spec.dest], value)
            else
                # overwrite
                options[spec.dest] = value
            end
        else
            push!(positional_args, token)
            remaining = @view remaining[2:end]
        end
    end

    options[:paths] = positional_args
    return options
end

# --- Typed result ---

@enum OutputMode StdoutMode InplaceMode CheckMode

Base.@kwdef struct ParsedArgs
    help::Bool = false
    version::Bool = false
    mode::OutputMode = StdoutMode
    diff::Bool = false
    verbose::Bool = false
    config_priority::Bool = false
    ignore_config::Bool = false
    outputfile::Union{String,Nothing} = nothing
    stdin_filename::String = "stdin"
    config_dir::String = ""
    line_ranges::Vector{Tuple{Int,Int}} = Tuple{Int,Int}[]
    config::Configuration = Configuration()
    paths::Vector{String} = String[]
end

# All format option keys — these are collected from the raw dict into format_options.
const FORMAT_OPTION_KEYS = Set{Symbol}(fieldnames(Options))

const PARSER = ArgParser(
    flag(["-h", "--help"]; dest = :help, help = "Print this message."),
    flag(["--version"]; dest = :version, help = "Print version information."),
    flag(["-c", "--check"]; dest = :check, help = "Check formatting without writing."),
    flag(["-i", "--inplace"]; dest = :inplace, help = "Format files in place."),
    flag(["-d", "--diff"]; dest = :diff, help = "Print diff to stderr."),
    option(
        ["-o", "--output"];
        dest = :outputfile,
        type = String,
        metavar = "<file>",
        help = "File to write formatted output to.",
    ),
    flag(["-v", "--verbose"]; dest = :verbose, help = "Enable verbose output."),
    option(
        "--config-dir";
        dest = :config_dir,
        type = String,
        metavar = "<dir>",
        help = "Directory path for .JuliaFormatter.toml config lookup.",
    ),
    option(
        "--format-markdown";
        dest = :format_markdown,
        type = Bool,
        help = "Also format code blocks in Markdown files.",
    ),
    option(
        "--ignore";
        dest = :ignore,
        type = String,
        multi = true,
        metavar = "<pattern>",
        help = "Ignore files matching the given pattern. Can be repeated.",
    ),
    flag(
        ["--ignore-config"];
        dest = :ignore_config,
        help = "Do not use .JuliaFormatter.toml config files.",
    ),
    option(
        "--lines";
        dest = :lines,
        type = Tuple{Int,Int},
        multi = true,
        metavar = "<start:stop>",
        help = "Only format the given range of lines. Can be repeated.",
    ),
    flag(
        ["--prioritize-config-file"];
        dest = :config_priority,
        help = "Prioritize config file options over command-line options.",
    ),
    option(
        "--stdin-filename";
        dest = :stdin_filename,
        type = String,
        metavar = "<name>",
        help = "Assumed filename when formatting from stdin.",
    ),
    # --- Formatting options ---
    option(
        "--style";
        dest = :style,
        type = AbstractStyle,
        metavar = "default|blue|sciml|yas|minimal",
        help = "Formatting style.",
        group = FormattingGroup,
    ),
    option(
        "--align-assignment";
        dest = :align_assignment,
        type = Bool,
        help = "Align assignment operators.",
        group = FormattingGroup,
    ),
    option(
        "--align-conditional";
        dest = :align_conditional,
        type = Bool,
        help = "Align conditional operators.",
        group = FormattingGroup,
    ),
    option(
        "--align-matrix";
        dest = :align_matrix,
        type = Bool,
        help = "Preserve whitespace alignment of matrix elements.",
        group = FormattingGroup,
    ),
    option(
        "--align-pair-arrow";
        dest = :align_pair_arrow,
        type = Bool,
        help = "Align pair arrows (=>).",
        group = FormattingGroup,
    ),
    option(
        "--align-struct-field";
        dest = :align_struct_field,
        type = Bool,
        help = "Align struct field type annotations.",
        group = FormattingGroup,
    ),
    option(
        "--always-for-in";
        dest = :always_for_in,
        type = Union{Nothing,Bool},
        help = "Normalise `in` to/from `=` in for loops.",
        group = FormattingGroup,
    ),
    option(
        "--always-use-return";
        dest = :always_use_return,
        type = Bool,
        help = "Add explicit 'return' statements to function definitions.",
        group = FormattingGroup,
    ),
    option(
        "--annotate-untyped-fields-with-any";
        dest = :annotate_untyped_fields_with_any,
        type = Bool,
        help = "Annotate untyped struct fields with '::Any'.",
        group = FormattingGroup,
    ),
    option(
        "--conditional-to-if";
        dest = :conditional_to_if,
        type = Bool,
        help = "Convert ternary expressions to if/else blocks when over margin.",
        group = FormattingGroup,
    ),
    option(
        "--disallow-single-arg-nesting";
        dest = :disallow_single_arg_nesting,
        type = Bool,
        help = "Prevent nesting of a single argument in parentheses.",
        group = FormattingGroup,
    ),
    option(
        "--enforce-triplequoted-docstrings";
        dest = :enforce_triplequoted_docstrings,
        type = Bool,
        help = """Transform `"..."` into `\"""...\"""` in docstrings.""",
        group = FormattingGroup,
    ),
    option(
        "--for-in-replacement";
        dest = :for_in_replacement,
        type = String,
        metavar = "in|=|∈",
        help = "Replacement for `=` in for loops when always_for_in is true.",
        group = FormattingGroup,
    ),
    option(
        "--force-long-function-def";
        dest = :force_long_function_def,
        type = Bool,
        help = "Force short-to-long function def transformation regardless of length.",
        group = FormattingGroup,
    ),
    option(
        "--format-docstrings";
        dest = :format_docstrings,
        type = Bool,
        help = "Format docstrings.",
        group = FormattingGroup,
    ),
    option(
        "--import-to-using";
        dest = :import_to_using,
        type = Bool,
        help = "Convert 'import' to 'using'.",
        group = FormattingGroup,
    ),
    option(
        "--indent";
        dest = :indent,
        type = Int,
        help = "Indentation width.",
        group = FormattingGroup,
    ),
    option(
        "--indent-binary-continuations";
        dest = :indent_binary_continuations,
        type = Bool,
        help = "Indent the continuation lines of binary operations instead of aligning" *
               "them to the first operand.",
        group = FormattingGroup,
    ),
    option(
        "--indent-submodule";
        dest = :indent_submodule,
        type = Bool,
        help = "Indent submodules appearing in the same file.",
        group = FormattingGroup,
    ),
    option(
        "--join-lines-based-on-source";
        dest = :join_lines_based_on_source,
        type = Bool,
        help = "Join lines as they appear in the original source file.",
        group = FormattingGroup,
    ),
    option(
        "--long-to-short-function-def";
        dest = :long_to_short_function_def,
        type = Bool,
        help = "Convert long function definitions to short form.",
        group = FormattingGroup,
    ),
    option(
        "--margin";
        dest = :margin,
        type = Int,
        help = "Maximum line width.",
        group = FormattingGroup,
    ),
    option(
        "--normalize-line-endings";
        dest = :normalize_line_endings,
        type = String,
        metavar = "auto|unix|windows",
        help = "Normalize line endings.",
        group = FormattingGroup,
    ),
    option(
        "--pipe-to-function-call";
        dest = :pipe_to_function_call,
        type = Bool,
        help = "Convert pipe operator to function calls.",
        group = FormattingGroup,
    ),
    option(
        "--remove-extra-newlines";
        dest = :remove_extra_newlines,
        type = Bool,
        help = "Remove extra newlines.",
        group = FormattingGroup,
    ),
    option(
        "--sciml-margin-overrun";
        dest = :sciml_margin_overrun,
        type = Int,
        help = "Additional columns SciMLStyle may use.",
        group = FormattingGroup,
    ),
    option(
        "--separate-kwargs-with-semicolon";
        dest = :separate_kwargs_with_semicolon,
        type = Bool,
        help = "Separate keyword arguments with a semicolon.",
        group = FormattingGroup,
    ),
    option(
        "--short-circuit-to-if";
        dest = :short_circuit_to_if,
        type = Bool,
        help = "Convert short-circuit operators to if-expressions.",
        group = FormattingGroup,
    ),
    option(
        "--short-to-long-function-def";
        dest = :short_to_long_function_def,
        type = Bool,
        help = "Convert short function definitions to long form.",
        group = FormattingGroup,
    ),
    option(
        "--surround-whereop-typeparameters";
        dest = :surround_whereop_typeparameters,
        type = Bool,
        help = "Add curly braces around where type parameters.",
        group = FormattingGroup,
    ),
    option(
        "--trailing-comma";
        dest = :trailing_comma,
        type = Union{Nothing,Bool},
        help = "Add trailing commas.",
        group = FormattingGroup,
    ),
    option(
        "--trailing-zero";
        dest = :trailing_zero,
        type = Bool,
        help = "Add trailing zeros to floats.",
        group = FormattingGroup,
    ),
    option(
        "--transform-syntax-in-macros";
        dest = :transform_syntax_in_macros,
        type = Bool,
        help = "Apply syntax transformations inside macro calls.",
        group = FormattingGroup,
    ),
    option(
        "--v2-stable-multiline-strings";
        dest = :v2_stable_multiline_strings,
        type = Bool,
        help = "Use stable multiline string length calculation.",
        group = FormattingGroup,
    ),
    option(
        "--variable-call-indent";
        dest = :variable_call_indent,
        type = String,
        multi = true,
        metavar = "<name>",
        help = "Allow variable indentation for calls to this function. Can be repeated.",
        group = FormattingGroup,
    ),
    option(
        "--whitespace-in-kwargs";
        dest = :whitespace_in_kwargs,
        type = Bool,
        help = "Add whitespace in keyword arguments.",
        group = FormattingGroup,
    ),
    option(
        "--whitespace-ops-in-indices";
        dest = :whitespace_ops_in_indices,
        type = Bool,
        help = "Add whitespace around binary operations in indices.",
        group = FormattingGroup,
    ),
    option(
        "--whitespace-typedefs";
        dest = :whitespace_typedefs,
        type = Bool,
        help = "Add whitespace around '::' in type definitions.",
        group = FormattingGroup,
    ),
    option(
        "--yas-style-nesting";
        dest = :yas_style_nesting,
        type = Bool,
        help = "Use YASStyle nesting rules in SciMLStyle.",
        group = FormattingGroup,
    ),
    # Deprecated options (for backward compatibility)
    option(
        "--sciml_margin_overrun";
        dest = :sciml_margin_overrun,
        type = Int,
        help = "",
        group = DeprecatedGroup,
    ),
    option(
        "--normalize_line_endings";
        dest = :normalize_line_endings,
        type = String,
        help = "",
        group = DeprecatedGroup,
    ),
    flag(
        ["--format_markdown"];
        dest = :format_markdown,
        help = "",
        group = DeprecatedGroup,
    ),
    negatable_flag("always_for_in"; dest = :always_for_in),
    negatable_flag("whitespace_typedefs"; dest = :whitespace_typedefs),
    negatable_flag("remove_extra_newlines"; dest = :remove_extra_newlines),
    negatable_flag("import_to_using"; dest = :import_to_using),
    negatable_flag("pipe_to_function_call"; dest = :pipe_to_function_call),
    negatable_flag("short_to_long_function_def"; dest = :short_to_long_function_def),
    negatable_flag("always_use_return"; dest = :always_use_return),
    negatable_flag("whitespace_in_kwargs"; dest = :whitespace_in_kwargs),
    negatable_flag("format_docstrings"; dest = :format_docstrings),
    negatable_flag("align_struct_field"; dest = :align_struct_field),
    negatable_flag("align_assignment"; dest = :align_assignment),
    negatable_flag("align_conditional"; dest = :align_conditional),
    negatable_flag("align_pair_arrow"; dest = :align_pair_arrow),
    negatable_flag("trailing_comma"; dest = :trailing_comma),
    negatable_flag("trailing_zero"; dest = :trailing_zero),
    negatable_flag("v2_stable_multiline_strings"; dest = :v2_stable_multiline_strings),
    negatable_flag("conditional_to_if"; dest = :conditional_to_if),
)

function print_help(parser::ArgParser; io::IO = stdout)
    function section(title)
        printstyled(io, title; bold = true)
        println(io)
    end

    section("NAME")
    println(io, "       jlfmt - An opinionated code formatter for Julia\n")

    section("SYNOPSIS")
    println(
        io,
        """
       jlfmt [<julia_options> --] [<options>] <path>...
       jlfmt [<julia_options> --] [<options>] -
       ... | jlfmt [<julia_options> --] [<options>]

       where <julia_options> are options passed to the Julia
       interpreter (e.g. --threads=auto), and <options> are
       options for JuliaFormatter.
""",
    )

    section("DESCRIPTION")
    println(
        io,
        """
       `jlfmt` formats Julia source code using JuliaFormatter.jl.
       This tool can also be invoked as `julia -m JuliaFormatter`.
""",
    )

    section("OPTIONS")
    println(
        io,
        """
       <path>...
           Input path(s) (files and/or directories) to process. For directories,
           all files (recursively) with the '*.jl' suffix are used as input files
           (also '*.md', '*.jmd', '*.qmd' if --format-markdown is specified).
           If no path is given, or if path is `-`, input is read from stdin.
""",
    )

    for group in instances(OptGroup)
        group == DeprecatedGroup && continue
        if group == FormattingGroup
            section("FORMATTING OPTIONS")
            println(
                io,
                """
           These options control the formatting style. They can also be set in
           a `.JuliaFormatter.toml` config file.

           Note that options are merged from the config file and command-line
           arguments. If the same option is specified both a config file and
           command-line options are specified, the CLI arguments take priority
           by default. With `--prioritize-config-file`, the config file takes
           priority instead.

           If the same option is specified multiple times on the command line,
           the last value is used.
    """,
            )
        end
        for spec in parser.specs
            spec.group != group && continue
            label = if spec.kind == FlagKind
                join(spec.names, ", ")
            elseif spec.kind == OptionKind
                m = spec.metavar
                join([startswith(n, "--") ? "$n=$m" : "$n $m" for n in spec.names], ", ")
            else
                join(spec.names, " / ")
            end
            println(io, "       ", label)
            println(io, "           ", spec.help, "\n")
        end
    end

    section("EXAMPLES")
    println(
        io,
        """
       Format a file and write to stdout:
           jlfmt src/file.jl

       Format a file in place:
           jlfmt --inplace src/file.jl

       Format all files in a directory with the verbose mode:
           jlfmt --inplace --verbose src/

       Check if a file is formatted:
           jlfmt --check src/file.jl

       Format only lines 1-10 and 42-47 of a file:
           jlfmt --lines=1:10 --lines=42:47 src/file.jl

       Check if all files in a directory are formatted with multiple threads:
           jlfmt --threads=4 -- --check src/

       Show diff for formatting with 2-space indentations:
           jlfmt --diff --indent=2 src/file.jl

       Format from stdin (pipe):
           echo 'f(x,y)=x+y' | jlfmt

       Format from stdin (explicit):
           jlfmt - < input.jl

       Format from stdin using project config:
           echo 'f(x,y)=x+y' | jlfmt --config-dir=./src

       Use specific style:
           jlfmt --style=blue src/file.jl

       Combine options:
           echo 'for i=1:10; end' | jlfmt --always-for-in=true
""",
    )
    return
end

function parse_args(argv::Vector{String})::ParsedArgs
    raw = parse_raw(PARSER, argv)

    # --- Output mode (mutually exclusive) ---
    has_check = get(raw, :check, false)
    has_inplace = get(raw, :inplace, false)
    has_output = haskey(raw, :outputfile)
    if has_check && has_inplace
        throw(ParseArgsError("options `--check` and `--inplace` are mutually exclusive"))
    end
    if has_inplace && has_output
        throw(ParseArgsError("options `--inplace` and `--output` are mutually exclusive"))
    end
    if has_check && has_output
        throw(ParseArgsError("options `--check` and `--output` are mutually exclusive"))
    end
    mode = if has_check
        CheckMode
    elseif has_inplace
        InplaceMode
    else
        StdoutMode
    end

    # --- ignore-config is mutually exclusive with config-related options ---
    ignore_config = get(raw, :ignore_config, false)
    config_priority = get(raw, :config_priority, false)
    if ignore_config && config_priority
        throw(
            ParseArgsError(
                "options `--ignore-config` and `--prioritize-config-file` are mutually exclusive",
            ),
        )
    end
    if ignore_config && get(raw, :config_dir, "") != ""
        throw(
            ParseArgsError(
                "options `--ignore-config` and `--config-dir` are mutually exclusive",
            ),
        )
    end

    # --- Build Configuration from CLI options ---
    formatting_options = Dict{Symbol,Any}()
    for key in FORMAT_OPTION_KEYS
        key == :style && continue
        if haskey(raw, key)
            formatting_options[key] = raw[key]
        end
    end
    # We leave `verbose` unset because the app uses a separate verbosity flag from
    # the `verbose` passed to the formatter.
    config = configuration_from_kwargs(;
        style = get(raw, :style, nothing),
        ignore = let v = get(raw, :ignore, String[])
            isempty(v) ? nothing : v
        end,
        format_markdown = if haskey(raw, :format_markdown)
            raw[:format_markdown]::Bool
        else
            nothing
        end,
        formatting_options...,
    )

    return ParsedArgs(;
        help = get(raw, :help, false),
        version = get(raw, :version, false),
        mode,
        diff = get(raw, :diff, false),
        verbose = get(raw, :verbose, false),
        config_priority,
        ignore_config,
        outputfile = get(raw, :outputfile, nothing),
        stdin_filename = get(raw, :stdin_filename, "stdin"),
        config_dir = get(raw, :config_dir, ""),
        line_ranges = get(raw, :lines, Tuple{Int,Int}[]),
        config,
        paths = raw[:paths],
    )
end

end # module

function options(::YASStyle)
    return Options(;
        always_for_in = true,
        whitespace_ops_in_indices = true,
        remove_extra_newlines = true,
        import_to_using = true,
        pipe_to_function_call = true,
        short_to_long_function_def = true,
        long_to_short_function_def = false,
        always_use_return = true,
        whitespace_in_kwargs = false,
        join_lines_based_on_source = true,
        separate_kwargs_with_semicolon = true,
        indent = 4,
        margin = 92,
        whitespace_typedefs = false,
        annotate_untyped_fields_with_any = true,
        format_docstrings = false,
        align_struct_field = false,
        align_assignment = false,
        align_conditional = false,
        align_pair_arrow = false,
        conditional_to_if = false,
        normalize_line_endings = "auto",
        align_matrix = false,
        trailing_comma = true,
        trailing_zero = true,
        indent_submodule = false,
        surround_whereop_typeparameters = true,
        variable_call_indent = [],
        yas_style_nesting = false,
    )
end

function is_binaryop_nestable(::YASStyle, cst::JuliaSyntax.GreenNode)
    return !(defines_function(cst) || is_assignment(cst) || op_kind(cst) in KSet"=> ->")
end

# Implementation of p_import for YAS is the same as for DefaultStyle, except that we don't
# add a linebreak after the colon in `import Foo: X, Y, Z`.
_maybe_linebreak_after_import_colon(::YASStyle) = false

function p_curly(
    ys::YASStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ys)
    nws = s.opts.whitespace_typedefs ? 1 : 0
    t = FST(Curly, nspaces(s))
    if !haschildren(cst)
        return t
    end

    childs = children(cst)
    idx = findfirst(n -> kind(n) === K"{", childs)::Int
    first_arg_idx = findnext(n -> !JuliaSyntax.is_whitespace(n), childs, idx + 1)

    for (i, a) in enumerate(childs)
        n = pretty(style, a, s, newctx(ctx; from_typedef = true), lineage)

        override = (i == first_arg_idx) || kind(a) === K"}"

        if kind(a) === K","
            if has_more_args_to_come(childs, i + 1, K"}")
                add_node!(t, n, s; join_lines = true)
                add_node!(t, Placeholder(nws), s)
            end
        else
            add_node!(
                t,
                n,
                s;
                join_lines = true,
                override_join_lines_based_on_source = override,
            )
        end
    end
    t
end

function p_braces(
    ys::YASStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ys)
    t = FST(Braces, nspaces(s))
    if !haschildren(cst)
        return t
    end
    from_typedef = ctx.from_typedef

    childs = children(cst)
    idx = findfirst(n -> kind(n) === K"{", childs)::Int
    first_arg_idx = findnext(n -> !JuliaSyntax.is_whitespace(n), childs, idx + 1)

    nws = from_typedef && !s.opts.whitespace_typedefs ? 0 : 1

    for (i, a) in enumerate(childs)
        n = pretty(style, a, s, ctx, lineage)

        override = (i == first_arg_idx) || kind(a) === K"}"

        if kind(a) === K","
            if has_more_args_to_come(childs, i + 1, K"}")
                add_node!(t, n, s; join_lines = true)
                add_node!(t, Placeholder(nws), s)
            end
        else
            add_node!(
                t,
                n,
                s;
                join_lines = true,
                override_join_lines_based_on_source = override,
            )
        end
    end
    t
end

function p_bracescat(
    ys::YASStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ys)
    t = FST(BracesCat, nspaces(s))
    if !haschildren(cst)
        return t
    end
    from_typedef = ctx.from_typedef

    childs = children(cst)
    idx = findfirst(n -> kind(n) === K"{", childs)::Int
    first_arg_idx = findnext(n -> !JuliaSyntax.is_whitespace(n), childs, idx + 1)

    nws = from_typedef && !s.opts.whitespace_typedefs ? 0 : 1

    for (i, a) in enumerate(childs)
        n = pretty(style, a, s, ctx, lineage)

        override = (i == first_arg_idx) || kind(a) === K"}"

        if kind(a) === K";"
            if has_more_args_to_come(childs, i + 1, K"}")
                add_node!(t, n, s; join_lines = true)
                add_node!(t, Placeholder(nws), s)
            end
        else
            add_node!(
                t,
                n,
                s;
                join_lines = true,
                override_join_lines_based_on_source = override,
            )
        end
    end
    t
end

function p_tupleblock(
    ys::YASStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ys)
    t = FST(TupleBlock, nspaces(s))
    if !haschildren(cst)
        return t
    end

    nargs = length(get_args(cst))
    childs = children(cst)
    idx = findfirst(n -> kind(n) === K"(", childs)
    first_arg_idx =
        isnothing(idx) ? -1 : findnext(n -> !JuliaSyntax.is_whitespace(n), childs, idx + 1)

    for (i, a) in enumerate(childs)
        n = if kind(a) === K"=" && haschildren(a)
            p_kw(style, a, s, ctx, lineage)
        else
            pretty(style, a, s, ctx, lineage)
        end

        override = (i == first_arg_idx) || kind(a) === K")"

        if kind(a) in KSet"; ,"
            if nargs == 1
                add_node!(t, n, s; join_lines = true)
            elseif has_more_args_to_come(childs, i + 1, K")")
                add_node!(t, n, s; join_lines = true)
                add_node!(t, Placeholder(1), s)
            end
        else
            add_node!(
                t,
                n,
                s;
                join_lines = true,
                override_join_lines_based_on_source = override,
            )
        end
    end
    t
end

function p_tuple(
    ys::YASStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ys)
    t = FST(TupleN, nspaces(s))
    if !haschildren(cst)
        return t
    end

    nargs = length(get_args(cst))
    childs = children(cst)
    idx = findfirst(n -> kind(n) === K"(", childs)
    first_arg_idx =
        isnothing(idx) ? -1 : findnext(n -> !JuliaSyntax.is_whitespace(n), childs, idx + 1)

    for (i, a) in enumerate(childs)
        n = if kind(a) === K"=" && haschildren(a)
            p_kw(style, a, s, ctx, lineage)
        else
            pretty(style, a, s, ctx, lineage)
        end

        override = (i == first_arg_idx) || kind(a) === K")"

        if kind(a) === K","
            if nargs == 1
                add_node!(t, n, s; join_lines = true)
            elseif has_more_args_to_come(childs, i + 1, K")")
                add_node!(t, n, s; join_lines = true)
                add_node!(t, Placeholder(1), s)
            end
        else
            add_node!(
                t,
                n,
                s;
                join_lines = true,
                override_join_lines_based_on_source = override,
            )
        end
    end
    t
end

function p_parens(
    ys::YASStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ys)
    t = FST(Brackets, nspaces(s))
    if !haschildren(cst)
        return t
    end

    args = get_args(cst)
    if length(args) > 0
        arg = args[1]
        if is_block(arg, style) ||
           (kind(arg) === K"generator" && haschildren(arg) && is_block(arg[1], style))
            t.nest_behavior = AlwaysNest
        end
    end

    for c in children(cst)
        n = if kind(c) === K"block"
            pretty(style, c, s, newctx(ctx; from_quote = true), lineage)
        else
            pretty(style, c, s, ctx, lineage)
        end
        add_node!(t, n, s; join_lines = true, override_join_lines_based_on_source = true)
    end

    t
end

function p_call(
    ys::YASStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ys)
    t = FST(Call, nspaces(s))
    if !haschildren(cst)
        return t
    end

    childs = children(cst)
    can_separate_kwargs = ctx.can_separate_kwargs
    # Don't propagate `can_separate_kwargs` to children.
    ctx = newctx(ctx; can_separate_kwargs = true)

    # # With `variable_call_indent`, check if the caller is in the list
    # and use `p_call` from `DefaultStyle` instead to allow both
    # `caller(something,...)` and `caller(\n,...)`.
    if length(s.opts.variable_call_indent) > 0
        # Need to check whether the caller is of the form f(...) or f{T}(...). In both
        # cases, we need to extract only `f`, and not `f{T}` in the latter case.
        caller_span = if kind(childs[1]) === K"curly"
            span(childs[1][1])
        else
            span(childs[1])
        end
        val = getsrcval(s.doc, (s.offset):(s.offset+caller_span-1))
        if val in s.opts.variable_call_indent
            return p_call(DefaultStyle(style), cst, s, ctx, lineage)
        end
    end

    idx = findfirst(n -> kind(n) === K"(", childs)
    first_arg_idx = if idx === nothing
        # it might just be `+(x)` in which case there is no K"(" but only
        # K"parens"...
        nothing
    else
        findnext(n -> !JuliaSyntax.is_whitespace(n), childs, idx + 1)
    end

    for (i, a) in enumerate(childs)
        k = kind(a)
        n = if k == K"=" && haschildren(a)
            p_kw(style, a, s, ctx, lineage)
        else
            pretty(style, a, s, ctx, lineage)
        end

        override = (i === first_arg_idx) || k === K")"

        if k === K","
            if has_more_args_to_come(childs, i + 1, K")")
                add_node!(t, n, s; join_lines = true)
                add_node!(t, Placeholder(1), s)
            end
        else
            # For YAS style, the trailing comma usually won't be seen, because the closing
            # paren should be placed on the same line as the last argument. However, in the
            # case where the last argument is followed by a comment, the closing paren will
            # be placed on the next line, and in that case we want to allow a trailing
            # comma.
            # If `i == first_arg_idx`, then the function call is empty. In such cases adding
            # a trailing comma causes a syntax error, so don't do it
            if k === K")" && i != first_arg_idx
                add_node!(t, TrailingComma(), s)
            end

            add_node!(
                t,
                n,
                s;
                join_lines = true,
                override_join_lines_based_on_source = override,
            )
        end
    end

    if (
        s.opts.separate_kwargs_with_semicolon &&
        can_separate_kwargs &&
        can_transform_syntax(s, false)
    )
        separate_kwargs_with_semicolon!(t)
    end

    t
end

function p_vect(
    ys::YASStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ys)
    t = FST(Vect, nspaces(s))
    if !haschildren(cst)
        return t
    end

    childs = children(cst)
    idx = findfirst(n -> kind(n) === K"[", childs)::Int
    first_arg_idx = findnext(n -> !JuliaSyntax.is_whitespace(n), childs, idx + 1)

    for (i, a) in enumerate(childs)
        k = kind(a)
        n = pretty(style, a, s, ctx, lineage)

        override = (i == first_arg_idx) || k === K"]"

        if kind(a) === K","
            if has_more_args_to_come(childs, i + 1, K"]")
                add_node!(t, n, s; join_lines = true)
                add_node!(t, Placeholder(1), s)
            end
        else
            add_node!(
                t,
                n,
                s;
                join_lines = true,
                override_join_lines_based_on_source = override,
            )
        end
    end
    t
end

function p_vcat(
    ys::YASStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ys)
    t = FST(Vcat, nspaces(s))
    if !haschildren(cst)
        return t
    end

    childs = children(cst)
    idx = findfirst(n -> kind(n) === K"[", childs)::Int
    first_arg_idx = findnext(n -> !JuliaSyntax.is_whitespace(n), childs, idx + 1)

    for (i, a) in enumerate(childs)
        n = pretty(style, a, s, ctx, lineage)

        if kind(a) === K"["
            add_node!(t, n, s; join_lines = true)
        elseif kind(a) === K"]"
            if is_prev_newline(t)
                # newline before closing bracket is not semantically important
                remove_prev_newline!(t)
            end
            add_node!(
                t,
                n,
                s;
                join_lines = true,
                override_join_lines_based_on_source = true,
            )
        elseif JuliaSyntax.is_whitespace(a)
            add_node!(t, n, s; join_lines = true)
        elseif kind(a) === K";"
            add_node!(t, n, s; join_lines = true)
        else
            join_lines = i == first_arg_idx || t.endline == n.startline
            override = i == first_arg_idx

            if !isnothing(first_arg_idx) && i > first_arg_idx
                if is_prev_newline(t)
                    # This is a hack, see default/pretty for explanation -- but tldr if the
                    # previous argument ends with a newline, we want to move the newline out
                    # of that inner argument up into the current level of the FST.
                    remove_prev_newline!(t)
                end
                if join_lines
                    add_node!(t, Placeholder(1), s)
                end
                # if !join_lines, then the call to add_node! below will add a newline at the
                # top level of the vcat FST so we won't be losing the newline.
            end

            add_node!(
                t,
                n,
                s;
                join_lines = join_lines,
                override_join_lines_based_on_source = override,
            )
        end
    end
    t
end

hcat_allow_boundary_newlines(::YASStyle) = false

function p_ref(
    ys::YASStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ys)
    t = FST(RefN, nspaces(s))
    if !haschildren(cst)
        return t
    end

    childs = children(cst)
    idx = findfirst(n -> kind(n) === K"[", childs)::Int
    first_arg_idx = findnext(n -> !JuliaSyntax.is_whitespace(n), childs, idx + 1)

    for (i, a) in enumerate(childs)
        n = if is_opcall(a)
            pretty(style, a, s, newctx(ctx; nonest = true), lineage)
        else
            pretty(style, a, s, ctx, lineage)
        end

        override = (i == first_arg_idx) || kind(a) === K"]"

        if kind(a) === K","
            if has_more_args_to_come(childs, i + 1, K"]")
                add_node!(t, n, s; join_lines = true)
                add_node!(t, Placeholder(1), s)
            end
        else
            add_node!(
                t,
                n,
                s;
                join_lines = true,
                override_join_lines_based_on_source = override,
            )
        end
    end
    t
end

function p_comprehension(
    ys::YASStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ys)
    t = FST(Comprehension, nspaces(s))
    if !haschildren(cst)
        return t
    end

    childs = children(cst)
    idx = findfirst(
        n -> !JuliaSyntax.is_whitespace(kind(n)) && !(kind(n) in KSet"[ ]"),
        childs,
    )
    arg = childs[idx]

    if is_block(arg, style) ||
       (kind(arg) === K"generator" && haschildren(arg) && is_block(arg[1], style))
        t.nest_behavior = AlwaysNest
    end

    for c in childs
        n = pretty(style, c, s, ctx, lineage)
        if kind(c) === K"["
            add_node!(t, n, s; join_lines = true)
        else
            add_node!(
                t,
                n,
                s;
                join_lines = true,
                override_join_lines_based_on_source = true,
            )
        end
    end

    t
end

function p_typedcomprehension(
    ys::YASStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    t = p_comprehension(ys, cst, s, ctx, lineage)
    t.typ = TypedComprehension
    t
end

function p_macrocall(
    ys::YASStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ys)
    t = FST(MacroCall, nspaces(s))
    if !haschildren(cst)
        return t
    end

    childs = children(cst)
    has_closer = is_closer(childs[end])
    is_macroblock = !has_closer

    if is_macroblock
        t.typ = MacroBlock
    end

    idx = findfirst(n -> kind(n) === K"(", childs)
    first_arg_idx =
        isnothing(idx) ? -1 : findnext(n -> !JuliaSyntax.is_whitespace(n), childs, idx + 1)

    for (i, a) in enumerate(childs)
        n = pretty(style, a, s, newctx(ctx; can_separate_kwargs = false), lineage)::FST

        override = (i == first_arg_idx) || kind(a) === K")"

        if JuliaSyntax.is_macro_name(a) || kind(a) === K"("
            add_node!(t, n, s; join_lines = true)
        elseif kind(a) === K","
            add_node!(t, n, s; join_lines = true)
            if has_more_args_to_come(childs, i + 1, K")")
                add_node!(t, Placeholder(1), s)
            end
        elseif JuliaSyntax.is_whitespace(a)
            add_node!(t, n, s; join_lines = true)
        elseif is_macroblock
            if n.typ === MacroBlock && t[end].typ === WHITESPACE
                t[end] = Placeholder(length(t[end].val))
            end

            max_padding = is_block(n) ? 0 : -1
            join_lines = t.endline == n.startline

            if join_lines && (i > 1 && kind(childs[i-1]) in KSet"NewlineWs Whitespace") ||
               next_node_is(nn -> kind(nn) in KSet"NewlineWs Whitespace", childs[i])
                add_node!(t, Whitespace(1), s)
            end
            add_node!(t, n, s; join_lines, max_padding)
        else
            add_node!(
                t,
                n,
                s;
                join_lines = true,
                override_join_lines_based_on_source = override,
            )
        end
    end
    # move placement of @ to the end
    #
    # @Module.macro -> Module.@macro
    t[1] = move_at_sign_to_the_end(t[1], s)
    t
end

function p_whereopcall(
    ys::YASStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ys)
    t = FST(Where, nspaces(s))
    if !haschildren(cst)
        return t
    end

    from_typedef = ctx.from_typedef

    childs = children(cst)
    where_idx = findfirst(c -> kind(c) === K"where" && !haschildren(c), childs)
    curly_ctx = if where_idx === nothing
        from_typedef
    else
        if !(from_typedef)
            any(c -> kind(c) in KSet"curly bracescat braces", childs[(where_idx+1):end])
        else
            true
        end
    end
    add_braces = s.opts.surround_whereop_typeparameters && !curly_ctx

    nws = s.opts.whitespace_typedefs ? 1 : 0

    idx = findfirst(n -> kind(n) === K"{", childs)
    first_arg_idx =
        isnothing(idx) ? -1 : findnext(n -> !JuliaSyntax.is_whitespace(n), childs, idx + 1)

    after_where = false
    for (i, a) in enumerate(childs)
        if kind(a) === K"where" && !haschildren(a)
            add_node!(t, Whitespace(1), s)
            add_node!(t, pretty(style, a, s, ctx, lineage), s; join_lines = true)
            add_node!(t, Whitespace(1), s)
            after_where = true
        elseif kind(a) === K"{"
            add_node!(t, pretty(style, a, s, ctx, lineage), s; join_lines = true)
            s.indent += s.opts.indent
        elseif kind(a) === K"}"
            add_node!(
                t,
                pretty(style, a, s, ctx, lineage),
                s;
                join_lines = true,
                override_join_lines_based_on_source = true,
            )
            s.indent -= s.opts.indent
        elseif kind(a) === K","
            if has_more_args_to_come(childs, i + 1, K"}")
                add_node!(t, pretty(style, a, s, ctx, lineage), s; join_lines = true)
                add_node!(t, Placeholder(nws), s)
            end
        elseif JuliaSyntax.is_whitespace(a)
            add_node!(t, pretty(style, a, s), s; join_lines = true)
        else
            n = pretty(style, a, s, newctx(ctx; from_typedef = after_where), lineage)

            if after_where && add_braces
                brace = FST(PUNCTUATION, -1, n.endline, n.endline, "{")
                add_node!(t, brace, s; join_lines = true)
            end

            override = i == first_arg_idx
            add_node!(
                t,
                n,
                s;
                join_lines = true,
                override_join_lines_based_on_source = override,
            )

            if after_where && add_braces
                brace = FST(PUNCTUATION, -1, n.endline, n.endline, "}")
                add_node!(t, brace, s; join_lines = true)
            end
        end
    end

    t
end

function p_generator(
    ys::YASStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}} = Tuple{JuliaSyntax.Kind,Bool,Bool}[],
)
    style = getstyle(ys)
    t = FST(Generator, nspaces(s))
    if !haschildren(cst)
        return t
    end

    has_for_kw = false

    from_iterable = false

    for (kind, is_itr, _) in Iterators.reverse(lineage)
        if kind in KSet"parens generator filter"
            continue
        elseif is_itr
            from_iterable = true
            break
        end
    end

    childs = children(cst)
    has_for_kw = findfirst(n -> kind(n) === K"for", childs) !== nothing
    from_for = has_for_kw || ctx.from_for

    for (i, a) in enumerate(childs)
        n = pretty(style, a, s, newctx(ctx; from_for = from_for), lineage)
        if JuliaSyntax.is_keyword(a) && !haschildren(a)
            idx = findprev(n -> !JuliaSyntax.is_whitespace(n), childs, i - 1)
            if !isnothing(idx) && is_block(childs[idx], style)
                add_node!(t, Newline(; length = 1), s)
            elseif from_iterable
                add_node!(t, Placeholder(1), s)
            elseif !isnothing(idx)
                add_node!(t, Whitespace(1), s)
            end
            add_node!(t, n, s; join_lines = true)
            add_node!(t, Whitespace(1), s)
        elseif kind(a) === K","
            if has_more_args_to_come(childs, i + 1, K")")
                add_node!(t, n, s; join_lines = true)
                add_node!(t, Placeholder(1), s)
            end
        else
            add_node!(t, n, s; join_lines = true)
        end

        if from_for && kind(a) === K"iteration"
            eq_to_in_normalization!(n, s.opts.always_for_in, s.opts.for_in_replacement)
        end
    end

    t
end

function p_filter(
    ys::YASStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    t = p_generator(ys, cst, s, ctx, lineage)
    t.typ = Filter
    t
end

module DispatchTests

using Test
using JuliaFormatter:
    format,
    format_text,
    format_file,
    format_md,
    DefaultStyle,
    BlueStyle,
    YASStyle,
    SciMLStyle,
    MinimalStyle

# A simple unformatted string and its expected output, used throughout.
const UNFORMATTED = "f( x,y )"
const FORMATTED_DEFAULT = "f(x, y)"

# BlueStyle removes spaces around kwargs `=`
const UNFORMATTED_KW = "foo(; k = v)"
const FORMATTED_BLUE_KW = "foo(; k=v)"

# ---------------------------------------------------------------------------
# format_text
# ---------------------------------------------------------------------------

@testset "format_text" begin
    @testset "keyword style" begin
        @test format_text(UNFORMATTED) == FORMATTED_DEFAULT
        @test format_text(UNFORMATTED; style = BlueStyle()) == FORMATTED_DEFAULT
        @test format_text(UNFORMATTED_KW; style = BlueStyle()) == FORMATTED_BLUE_KW
    end

    @testset "positional style" begin
        @test format_text(UNFORMATTED, DefaultStyle()) == FORMATTED_DEFAULT
        @test format_text(UNFORMATTED, BlueStyle()) == FORMATTED_DEFAULT
        @test format_text(UNFORMATTED_KW, BlueStyle()) == FORMATTED_BLUE_KW
    end

    @testset "keyword and positional style agree" begin
        for style in (DefaultStyle(), BlueStyle(), YASStyle(), SciMLStyle(), MinimalStyle())
            kw = format_text(UNFORMATTED; style)
            pos = format_text(UNFORMATTED, style)
            @test kw == pos
        end
    end

    @testset "extra kwargs are forwarded" begin
        @test format_text(UNFORMATTED_KW, BlueStyle(); whitespace_in_kwargs = true) ==
              UNFORMATTED_KW
        @test format_text(UNFORMATTED_KW; style = BlueStyle(), whitespace_in_kwargs = true) ==
              UNFORMATTED_KW
    end

    @testset "unrecognised kwargs emit error message" begin
        s = @test_logs (:info, r"ignoring invalid formatting option") format_text("1 +     1"; foo=2)
        # but it should still format it
        @test s == "1 + 1"
    end

    @testset "empty string is returned unchanged" begin
        @test format_text("") == ""
        @test format_text("", BlueStyle()) == ""
        @test format_text("", SciMLStyle()) == ""
    end

    @testset "already-formatted string is idempotent" begin
        @test format_text(FORMATTED_DEFAULT) == FORMATTED_DEFAULT
    end
end

# ---------------------------------------------------------------------------
# format_text with SciMLStyle fixpoint iteration
# ---------------------------------------------------------------------------

@testset "format_text SciMLStyle" begin
    @testset "keyword and positional style agree" begin
        kw = format_text(UNFORMATTED; style = SciMLStyle())
        pos = format_text(UNFORMATTED, SciMLStyle())
        @test kw == pos
    end

end

# ---------------------------------------------------------------------------
# format_md
# ---------------------------------------------------------------------------

@testset "format_md" begin
    md = """
    Some text.

    ```julia
    f( x,y )
    ```
    """
    @testset "keyword style" begin
        out = format_md(md)
        @test occursin("f(x, y)", out)
    end
    @testset "positional style" begin
        out = format_md(md, DefaultStyle())
        @test occursin("f(x, y)", out)
    end
    @testset "keyword and positional agree" begin
        @test format_md(md) == format_md(md, DefaultStyle())
        @test format_md(md; style = BlueStyle()) == format_md(md, BlueStyle())
    end
    @testset "empty string" begin
        @test format_md("") == ""
        @test format_md("", BlueStyle()) == ""
    end
end

# ---------------------------------------------------------------------------
# format_file and format (file paths)
# ---------------------------------------------------------------------------

function with_tempfile(f, content; ext = ".jl")
    mktempdir() do dir
        path = joinpath(dir, "test$ext")
        write(path, content)
        f(path)
    end
end

@testset "format_file" begin
    @testset "formats a file and returns whether it was already formatted" begin
        with_tempfile(UNFORMATTED) do path
            already = format_file(path)
            @test already == false
            @test readchomp(path) == FORMATTED_DEFAULT
            # second call: already formatted
            @test format_file(path) == true
        end
    end

    @testset "keyword style" begin
        with_tempfile(UNFORMATTED_KW) do path
            format_file(path; style = BlueStyle())
            @test readchomp(path) == FORMATTED_BLUE_KW
        end
    end

    @testset "positional style" begin
        with_tempfile(UNFORMATTED_KW) do path
            format_file(path, BlueStyle())
            @test readchomp(path) == FORMATTED_BLUE_KW
        end
    end

    @testset "overwrite=false leaves file unchanged" begin
        with_tempfile(UNFORMATTED) do path
            already = format_file(path; overwrite = false)
            @test already == false
            @test readchomp(path) == UNFORMATTED
        end
    end
end

@testset "format (single file)" begin
    @testset "formats a file" begin
        with_tempfile(UNFORMATTED) do path
            already = format(path)
            @test already == false
            @test readchomp(path) == FORMATTED_DEFAULT
        end

        # Check that it doesn't fail on empty files
        with_tempfile("") do path
            already = format(path)
            @test already == false # format() will add a newline
            @test readchomp(path) == ""
            @test format(path) # already formatted
        end
    end

    @testset "newline handling" begin
        for nls in ("", "\n", "\n\n")
            with_tempfile(nls) do path
                already = format(path)
                @test read(path, String) == "\n"
            end
        end

        for nls in ("\r\n", "\r\n\r\n")
            with_tempfile(nls) do path
                already = format(path)
                @test read(path, String) == "\r\n"
            end
        end
    end

    @testset "keyword style" begin
        with_tempfile(UNFORMATTED_KW) do path
            format(path; style = BlueStyle())
            @test readchomp(path) == FORMATTED_BLUE_KW
        end
    end

    @testset "positional style" begin
        with_tempfile(UNFORMATTED_KW) do path
            format(path, BlueStyle())
            @test readchomp(path) == FORMATTED_BLUE_KW
        end
    end
end

@testset "format (directory)" begin
    dir = mktempdir()
    try
        write(joinpath(dir, "a.jl"), UNFORMATTED)
        write(joinpath(dir, "b.jl"), UNFORMATTED_KW)
        write(joinpath(dir, "c.txt"), "not julia")

        already = format(dir; style = BlueStyle())
        @test already == false
        @test readchomp(joinpath(dir, "a.jl")) == FORMATTED_DEFAULT
        @test readchomp(joinpath(dir, "b.jl")) == FORMATTED_BLUE_KW
        # Non-Julia files are left alone
        @test read(joinpath(dir, "c.txt"), String) == "not julia"
    finally
        rm(dir; recursive = true)
    end
end

@testset "format (collection of paths)" begin
    mktempdir() do dir
        p1 = joinpath(dir, "a.jl")
        p2 = joinpath(dir, "b.jl")
        write(p1, UNFORMATTED)
        write(p2, UNFORMATTED)

        already = format([p1, p2])
        @test already == false
        @test readchomp(p1) == FORMATTED_DEFAULT
        @test readchomp(p2) == FORMATTED_DEFAULT
    end
end

# ---------------------------------------------------------------------------
# format_file and format agree
# ---------------------------------------------------------------------------

@testset "format_file and format produce the same result" begin
    for style in (DefaultStyle(), BlueStyle())
        with_tempfile(UNFORMATTED_KW) do path1
            with_tempfile(UNFORMATTED_KW) do path2
                format_file(path1; style)
                format(path2; style)
                @test read(path1, String) == read(path2, String)
            end
        end
    end
end

# ---------------------------------------------------------------------------
# Error behaviour: format swallows ParseError, format_file does not
# ---------------------------------------------------------------------------

@testset "error handling" begin
    invalid_julia = "function f(\n"

    @testset "format_text throws on unparseable input" begin
        @test_throws Exception format_text(invalid_julia)
    end

    @testset "format swallows ParseError on files" begin
        with_tempfile(invalid_julia) do path
            # format() warns and returns true (skips the file)
            already = @test_logs (:warn,) format(path)
            @test already == true
            # file is not modified
            @test read(path, String) == invalid_julia
        end
    end

    @testset "format_file propagates ParseError" begin
        with_tempfile(invalid_julia) do path
            # format_file delegates to format, which swallows ParseError —
            # so format_file also swallows it. This test documents current behaviour.
            already = @test_logs (:warn,) match_mode=:any format_file(path)
            @test already == true
        end
    end

    @testset "throw_on_error rethrows instead of warning" begin
        with_tempfile(invalid_julia) do path
            @test_throws Exception format(path; throw_on_error = true)
            # file is not modified
            @test read(path, String) == invalid_julia
        end
    end

    @testset "throw_on_error works on directories" begin
        mktempdir() do dir
            write(joinpath(dir, "good.jl"), "x = 1\n")
            write(joinpath(dir, "bad.jl"), invalid_julia)
            @test_throws Exception format(dir; throw_on_error = true)
        end
    end
end

# ---------------------------------------------------------------------------
# format_md with markdown files via format/format_file
# ---------------------------------------------------------------------------

@testset "format/format_file on markdown" begin
    md_content = "# Title\n\n```julia\nf( x,y )\n```\n"
    with_tempfile(md_content; ext = ".md") do path
        # Without format_markdown=true, markdown files are skipped
        @test format_file(path; format_markdown = false) == true
        @test read(path, String) == md_content

        # With format_markdown=true, Julia code blocks are formatted
        format_file(path; format_markdown = true)
        @test occursin("f(x, y)", read(path, String))
    end
end

end

using TOML: TOML

const CONFIG_FILE_NAME = ".JuliaFormatter.toml"

"""
    Configuration

A `Configuration` represents a collection of both formatting options and file options.

`Configuration`s can be constructed from:

- default values.
- keyword arguments passed to `format()`;
- a `$CONFIG_FILE_NAME` configuration file; or
- arguments passed on the command-line to `jlfmt`.
"""
struct Configuration
    options::Options{_Unset}
    # In `Configuration`, we use `nothing` to indicate that these fields were not specified.
    # We could in principle use the same `_Unset` trick as in Options, but that feels a bit
    # over-engineered for five fields.
    style::Union{Nothing,AbstractStyle}
    ignore::Union{Nothing,Vector{String}}
    verbose::Union{Nothing,Bool}
    overwrite::Union{Nothing,Bool}
    format_markdown::Union{Nothing,Bool}
end

function Configuration()
    return Configuration(Options{_Unset}(), DefaultStyle(), [], false, true, false)
end

function configuration_from_kwargs(;
    style = nothing,
    ignore = nothing,
    verbose = nothing,
    overwrite = nothing,
    format_markdown = nothing,
    formatting_options...,
)
    options = Options{_Unset}(; formatting_options...)
    return Configuration(options, style, ignore, verbose, overwrite, format_markdown)
end

function configuration_from_file(tomlfile::AbstractString)
    config_dict::Dict{String,Any} = TOML.parsefile(tomlfile)

    options_kws = Dict{Symbol,Any}()
    for field in fieldnames(Options)
        val = get(config_dict, string(field), _Unset())
        # TOML doesn't have a null value, so we use the string "nothing" to represent
        # it.
        if val == "nothing"
            val = nothing
        end
        options_kws[field] = val
    end
    options = Options{_Unset}(; options_kws...)

    style = get(config_dict, "style", nothing)
    if style !== nothing
        if haskey(STYLE_MAP, style)
            style = STYLE_MAP[style]
        else
            error("Unknown style: $style. Valid styles are: $(keys(STYLE_MAP))")
        end
    end

    ignore = get(config_dict, "ignore", nothing)
    verbose = get(config_dict, "verbose", nothing)
    overwrite = get(config_dict, "overwrite", nothing)
    format_markdown = get(config_dict, "format_markdown", nothing)
    return Configuration(options, style, ignore, verbose, overwrite, format_markdown)
end

"""
    find_config_file(path::AbstractString)::Union{Nothing,AbstractString}

Search for a `.JuliaFormatter.toml` configuration file in the directory of `path` and its
ancestors. Returns the path to the configuration file if found, or `nothing` if not found.
"""
function find_config_file(path::AbstractString)::Union{Nothing,AbstractString}
    # If asked to find a config file for a file, look in the containing directory.
    # Convert to absolute path while we're at it.
    path = if isfile(path)
        dirname(realpath(path))
    elseif isdir(path)
        realpath(path)
    else
        throw(ArgumentError("config search path $path does not exist"))
    end
    # Search upwards. dirname(path) == path indicates filesystem root.
    while dirname(path) != path
        maybe_config_path = joinpath(path, CONFIG_FILE_NAME)
        if isfile(maybe_config_path)
            return maybe_config_path
        end
        path = dirname(path)
    end
    # Failed to find
    return nothing
end

"""
    isignored(path::AbstractString, config::Configuration)::Bool

Determine if the given `path` should be ignored based on the ignore patterns in the
`config`. Returns `true` if the path matches any of the ignore patterns.
"""
function isignored(path, config::Configuration)
    @assert config.ignore !== nothing "Configuration ignore patterns are not set. This is a bug in JuliaFormatter."
    # Glob.jl only matches paths that have '/' as the pathsep, so we need to normalise to
    # that before matching, otherwise ignore patterns won't work on Windows
    path_posix = replace(path, Base.Filesystem.path_separator => "/")
    return any(x -> occursin(Glob.FilenameMatch("*$x"), path_posix), config.ignore)
end

"""
    merge_config(config1::Configuration, config2::Configuration)::Configuration

Merge two sources of configurations.
"""
function merge_config(config1::Configuration, config2::Configuration)::Configuration
    merged_options = merge_options(config1.options, config2.options)
    merged_style = config2.style === nothing ? config1.style : config2.style
    merged_ignore = config2.ignore === nothing ? config1.ignore : config2.ignore
    merged_verbose = config2.verbose === nothing ? config1.verbose : config2.verbose
    merged_overwrite = config2.overwrite === nothing ? config1.overwrite : config2.overwrite
    merged_format_markdown = if config2.format_markdown === nothing
        config1.format_markdown
    else
        config2.format_markdown
    end
    return Configuration(
        merged_options,
        merged_style,
        merged_ignore,
        merged_verbose,
        merged_overwrite,
        merged_format_markdown,
    )
end

function get_formatting_options(config::Configuration)::Options
    config.style === nothing &&
        error("Configuration style is not set. This is a bug in JuliaFormatter.")
    return merge_options(options(config.style), config.options)
end

using CairoMakie

# https://github.com/JuliaLang/julia-logo-graphics
const RED = "#CB3C33"
const GREEN = "#389826"
const PURPLE = "#9558B2"
# Other colours used for logo
const GREY = "#555562"
const CARDBG = "#FAFAFA"
const CARDBORDER = "#E4E4E7"

# Build a rounded rectangle.
#    x = left edge
#    y = bottom edge
#    w = width
#    h = height
#    r = corner radius
function roundedrect(x, y, w, h, r)
    r = min(r, w / 2, h / 2)
    arc(cx, cy, θ0, θ1) =
        [Point2f(cx + r * cos(t), cy + r * sin(t)) for t in range(θ0, θ1; length = 16)]
    pts = Point2f[]
    append!(pts, arc(x + r, y + r, 1.0π, 1.5π))  # bottom-left
    append!(pts, arc(x + w - r, y + r, 1.5π, 2.0π))  # bottom-right
    append!(pts, arc(x + w - r, y + h - r, 0.0, 0.5π))  # top-right
    append!(pts, arc(x + r, y + h - r, 0.5π, 1.0π))  # top-left
    return pts
end

fig = Figure(; size = (512, 512), backgroundcolor = :transparent)
ax = Axis(fig[1, 1]; aspect = DataAspect(), backgroundcolor = :transparent)
hidedecorations!(ax)
hidespines!(ax)
SIZE = 100
limits!(ax, 0, SIZE, 0, SIZE)

RADIUS = 6
DOT_X = 27
Y_SEPARATION = 18
RED_DOT_Y = (SIZE / 2) + Y_SEPARATION
GREEN_DOT_Y = (SIZE / 2)
PURPLE_DOT_Y = (SIZE / 2) - Y_SEPARATION

# Rounded background
poly!(
    ax,
    roundedrect(6, 6, 88, 88, 10);
    color = CARDBG,
    strokecolor = CARDBORDER,
    strokewidth = 1,
)

# Dashed left margin
lines!(
    ax,
    [DOT_X - RADIUS, DOT_X - RADIUS],
    [PURPLE_DOT_Y - 10, RED_DOT_Y + 10];
    color = GREY,
    linewidth = 2,
    linestyle = :dash,
)

# Trailing code lines
CODE_X = DOT_X + (2 * RADIUS)
MAX_WIDTH = SIZE - CODE_X - (DOT_X - RADIUS) # last term is the right margin
for (cy, w) in
    [(RED_DOT_Y, MAX_WIDTH), (GREEN_DOT_Y, MAX_WIDTH - 20), (PURPLE_DOT_Y, MAX_WIDTH - 10)]
    poly!(ax, roundedrect(DOT_X + (2 * RADIUS), cy - 4, w, 8, 4); color = GREY)
end

# Julia dots
for (cy, col) in [(RED_DOT_Y, RED), (GREEN_DOT_Y, GREEN), (PURPLE_DOT_Y, PURPLE)]
    poly!(ax, Circle(Point2f(DOT_X, cy), 6.0f0); color = col)
end

save("logo.svg", fig)

for f in [
    :n_import!,
    :n_using!,
    :n_export!,
    :n_public!,
    :n_vcat!,
    :n_ncat!,
    :n_typedvcat!,
    :n_typedncat!,
    :n_row!,
    :n_nrow!,
    :n_hcat!,
    :n_comprehension!,
    :n_typedcomprehension!,
    :n_generator!,
    :n_filter!,
]
    @eval function $f(
        ss::SciMLStyle,
        fst::FST,
        s::State,
        lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
    )
        $f(YASStyle(getstyle(ss)), fst, s, lineage)
    end
end

function n_functiondef!(
    ss::SciMLStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    style = getstyle(ss)
    nested = false
    if s.opts.yas_style_nesting
        nested |= nest!(
            YASStyle(style),
            fst.nodes::Vector,
            s,
            fst.indent,
            lineage;
            extra_margin = fst.extra_margin,
        )
    else
        base_indent = fst.indent
        add_indent!(fst[3], s, s.opts.indent)

        nested |= nest!(
            ss,
            fst.nodes::Vector,
            s,
            fst.indent,
            lineage;
            extra_margin = fst.extra_margin,
        )

        f =
            (fst::FST, s::State) -> begin
                if is_closer(fst) && fst.indent == base_indent + s.opts.indent
                    fst.indent -= s.opts.indent
                end
            end
        lo = s.line_offset
        walk(f, fst[3], s)
        s.line_offset = lo
    end
    return nested
end

function n_macro!(
    ss::SciMLStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_functiondef!(ss, fst, s, lineage)
end

function _n_tuple!(
    ss::SciMLStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    style = getstyle(ss)
    line_margin = s.line_offset + length(fst) + fst.extra_margin

    nodes = fst.nodes::Vector
    has_closer = is_closer(fst[end])
    start_line_offset = s.line_offset

    if has_closer
        fst[end].indent = fst.indent
    end
    if !(fst.typ in (TupleN, CartesianIterator, Parameters)) || has_closer
        fst.indent += s.opts.indent
    end

    # "foo(a, b, c)" is true if "foo" and "c" are on different lines
    src_diff_line = if s.opts.join_lines_based_on_source
        last_arg_idx = findlast(is_iterable_arg, nodes)
        last_arg = last_arg_idx === nothing ? fst[end] : fst[last_arg_idx]
        fst[1].endline != last_arg.startline
    else
        false
    end

    nested = false
    # Let find_optimal_nest_placeholders decide whether a for-loop tuple
    # binding can remain flat instead of overriding binary-op nesting.
    for_tuple_binding_lhs = _is_for_tuple_binding_lhs(fst, lineage)
    optimal_placeholders = find_optimal_nest_placeholders(
        fst,
        fst.indent,
        s.opts;
        margin_line_offset = start_line_offset,
        for_tuple_binding_lhs,
    )
    if length(optimal_placeholders) > 0
        nested = true
    end

    for i in optimal_placeholders
        fst[i] = Newline(; length = fst[i].len)
    end

    placeholder_inds = findall(n -> n.typ === PLACEHOLDER, fst.nodes)
    for (i, ph) in enumerate(placeholder_inds)
        if i == 1 ||
           i == length(placeholder_inds) ||
           (ph < length(fst) && is_comment(fst[ph+1])) ||
           (ph > 1 && is_comment(fst[ph-1]))
            continue
        end
        fst[ph] = Whitespace(fst[ph].len)
    end

    # macrocall doesn't have a placeholder before the closing parenthesis
    if fst.typ !== MacroCall && has_closer && length(placeholder_inds) > 0
        fst[placeholder_inds[end]] = Whitespace(0)
    end
    idx = findlast(n -> n.typ === PLACEHOLDER, nodes)

    # Check if we should apply conservative nesting rules
    should_nest = line_margin > s.opts.margin || must_nest(fst) || src_diff_line

    # For certain types, be more conservative about nesting
    if for_tuple_binding_lhs && isempty(optimal_placeholders)
        # The tuple binding already fit under the SciML overrun budget.
        should_nest = false
    elseif should_nest && !must_nest(fst) && !src_diff_line
        total_length = line_margin
        if (
            fst.typ === Call &&
            length(placeholder_inds) <= 5 &&
            total_length <= s.opts.margin + default_margin_overrun(s.opts)
        )
            should_nest = false
        elseif (fst.typ === Binary || fst.typ === Chain) &&
               length(placeholder_inds) <= 6 &&
               total_length <= s.opts.margin + default_margin_overrun(s.opts)
            should_nest = false
        elseif (
            fst.typ === RefN &&
            length(placeholder_inds) <= 4 &&
            total_length <= s.opts.margin + index_margin_overrun(s.opts)
        )
            # Keep array indexing together when reasonable (e.g., du[i, j, 1])
            should_nest = false
        end
    end

    if idx !== nothing && should_nest
        for (i, n) in enumerate(nodes)
            if n.typ === NEWLINE
                s.line_offset = fst.indent
            elseif n.typ === PLACEHOLDER
                si = findnext(n -> n.typ === PLACEHOLDER || n.typ === NEWLINE, nodes, i + 1)
                nested2 = nest_if_over_margin!(style, fst, s, i, lineage; stop_idx = si)
                nested |= nested2
                if has_closer && !nested2 && n.startline == fst[end].startline
                    # trailing types are automatically converted, undo this if
                    # there is no nest and the closer is on the same in the
                    # original source.
                    if fst[i-1].typ === TRAILINGCOMMA
                        fst[i-1].val = ""
                        fst[i-1].len = 0
                    end
                end
            elseif n.typ === TRAILINGCOMMA
                n.val = ","
                n.len = 1
                nested |= nest!(style, n, s, lineage)
            elseif has_closer && (i == 1 || i == length(nodes))
                nested |= nest!(style, n, s, lineage)
            else
                diff = fst.indent - fst[i].indent
                add_indent!(n, s, diff)
                n.extra_margin = 1

                nested |= nest!(style, n, s, lineage)
            end
        end

        if has_closer
            s.line_offset = fst[end].indent + 1
        end
    else
        extra_margin = fst.extra_margin
        if has_closer
            (extra_margin += 1)
        else
            false
        end
        nested |= nest!(style, nodes, s, fst.indent, lineage; extra_margin = extra_margin)
    end

    s.line_offset = start_line_offset
    walk(unnest!(style; dedent = false), fst, s)
    s.line_offset = start_line_offset
    walk(increment_line_offset!, fst, s)

    return nested
end

for f in [
    :n_ref!,
    :n_tuple!,
    :n_call!,
    :n_curly!,
    :n_macrocall!,
    :n_braces!,
    :n_parameters!,
    :n_parens!,
    :n_bracescat!,
]
    @eval function $f(
        ss::SciMLStyle,
        fst::FST,
        s::State,
        lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
    )
        if s.opts.yas_style_nesting
            $f(YASStyle(getstyle(ss)), fst, s, lineage)
        else
            _n_tuple!(getstyle(ss), fst, s, lineage)
        end
    end
end

function n_vect!(
    ss::SciMLStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    if s.opts.yas_style_nesting
        # Allow a line break after the opening brackets without aligning
        n_vect!(DefaultStyle(getstyle(ss)), fst, s, lineage)
    else
        _n_tuple!(getstyle(ss), fst, s, lineage)
    end
end

for f in [:n_chainopcall!, :n_comparison!, :n_for!]
    @eval function $f(
        ss::SciMLStyle,
        fst::FST,
        s::State,
        lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
    )
        if s.opts.yas_style_nesting
            $f(YASStyle(getstyle(ss)), fst, s, lineage)
        else
            $f(DefaultStyle(getstyle(ss)), fst, s, lineage)
        end
    end
end

module SeparateKwargsWithSemicolonTests

using JuliaFormatter: DefaultStyle, YASStyle, BlueStyle, SciMLStyle, MinimalStyle, format_text
using JuliaFormatter.Internal: test_format, ALL_STYLES
using Test

@testset "separate_kwargs_with_semicolon" begin
    @testset "basic" begin
        str_ = "f(a, b = 10)"
        str_space = "f(a; b = 10)"
        test_format(str_, str_space, DefaultStyle(); separate_kwargs_with_semicolon = true)
        test_format(str_, str_space, SciMLStyle(); separate_kwargs_with_semicolon = true)
        str_nospace = "f(a; b=10)"
        test_format(str_, str_nospace, MinimalStyle(); separate_kwargs_with_semicolon = true)
        test_format(str_, str_nospace, BlueStyle(); separate_kwargs_with_semicolon = true)
        test_format(str_, str_nospace, YASStyle(); separate_kwargs_with_semicolon = true)
    end

    # Now that we've explicitly tested the spacing, we're just going to use
    # whitespace_in_kwargs=true for everything

    @testset "in assignment" begin
        str_ = "xy = f(x, y=3)"
        str = "xy = f(x; y = 3)"
        for style in ALL_STYLES
            test_format(str_, str, style; separate_kwargs_with_semicolon = true, whitespace_in_kwargs = true)
        end
    end

    @testset "not in macro or expr" begin
        for str in (
            "@f(x, y=3)",
            ":(f(x, y=3))",
        )
            for style in ALL_STYLES
                test_format(str, str, style; separate_kwargs_with_semicolon = true, whitespace_in_kwargs = false)
            end
        end
    end

    @testset "fancy caller" begin
        for caller in (
            "(obj)",
            "(obj::T)",
            "(x + y)",
        )
            s_ = "$(caller)(a, b = 1)"
            s = "$(caller)(a; b = 1)"
            for style in ALL_STYLES
                test_format(s_, s, style; separate_kwargs_with_semicolon = true, whitespace_in_kwargs = true)
            end
        end
    end

    @testset "addition of semicolon at start" begin
        for str_ in ("xy = f(x=1, y=2)", "xy = f(x = 1; y = 2)")
            str = "xy = f(; x = 1, y = 2)"
            for style in ALL_STYLES
                test_format(str_, str, style; separate_kwargs_with_semicolon = true, whitespace_in_kwargs = true)
            end
        end
    end

    @testset "function definitions are untouched" begin
        for str in (
            """function g(x, y = 1)
                return x + y
            end""",
            """function g(x, y = 1) where {T}
                return x + y
            end""",
            """function (g)(x, y = 1)
                return x + y
            end""",
            """function g(x, y = 1)::Int
                return x + y
            end""",
            """function g(x, y = 1)::Int where T
                return x + y
            end""",
            """function g(x, y = 1)::Int where T where S
                return x + y
            end""",
            """function g(x, y = 1)::Int where {T,S}
                return x + y
            end""",
            """macro h(x, y = 1)
                return nothing
            end""",
            "shortdef1(MatrixT, VectorT = nothing) = nothing",
            "shortdef2(MatrixT, VectorT = nothing) where {T} = nothing",
        )
            for style in ALL_STYLES
                # need some extra options to stop other unrelated changes
                test_format(str, str, style; separate_kwargs_with_semicolon = true, whitespace_in_kwargs = true, whitespace_typedefs = false, surround_whereop_typeparameters = false)
            end
        end
    end

    @testset "nesting" begin
        str_ = """
        x = foo(var = "some really really really really really really really really really really long string")
        """
        str = """
        x = foo(;
            var = "some really really really really really really really really really really long string",
        )
        """
        test_format(str_, str; separate_kwargs_with_semicolon = true)

        str_ = """
        x = foo(var = "some really really really really really really really really really really long string")
        """
        str = """
        x = foo(;
                var="some really really really really really really really really really really long string")
        """
        test_format(str_, str, YASStyle(); separate_kwargs_with_semicolon = true)
    end

    @testset "calls as default values are changed" begin
        # g should be changed but not f
        s_ = """
        function f(x, y=g(a, b=1))
            return foo
        end"""
        s = """
        function f(x, y = g(a; b = 1))
            return foo
        end"""
        for style in ALL_STYLES
            test_format(s_, s, style; separate_kwargs_with_semicolon = true, whitespace_in_kwargs = true)
        end
    end

    @testset "rhs of short function def is changed" begin
        # g should be changed but not f
        s_ = "f(x, y=z) = g(p, q=r)"
        s = "f(x, y = z) = g(p; q = r)"
        for style in ALL_STYLES
            test_format(s_, s, style; separate_kwargs_with_semicolon = true, whitespace_in_kwargs = true)
        end

        # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/1161
        s_= "-(x::T) = f(x, y=z)"
        s = "-(x::T) = f(x; y = z)"
        for style in ALL_STYLES
            test_format(s_, s, style; separate_kwargs_with_semicolon = true, whitespace_in_kwargs = true)
        end
    end

    @testset "anonymous functions definitions are untouched" begin
        for str in (
            """function (x, y = 1)
                return x + y
            end""",
            """function (x, y = 1)::T
                return x + y
            end""",
            """function (x::T, y = 1) where {T}
                return x + y
            end""",
        )
            for style in ALL_STYLES
                test_format(str, str, style; separate_kwargs_with_semicolon = true, whitespace_in_kwargs = true)
            end
        end

        # This lhs is K"tuple" not K"call" anyway so should be fine, but just to be sure
        s = "(x, y = 1) -> x + y"
        for style in ALL_STYLES
            test_format(s, s, style; separate_kwargs_with_semicolon = true, whitespace_in_kwargs = true)
        end

        # change f but not the inner one
        s_ = "f(x, callback = (a, b = 1) -> a + b)"
        s = "f(x; callback = (a, b = 1) -> a + b)"
        for style in ALL_STYLES
            test_format(s_, s, style; separate_kwargs_with_semicolon = true, whitespace_in_kwargs = true)
        end
    end

    @testset "#625: don't convert sneaky positional arguments" begin
        s = "foo(x, bar = 0, y)"
        for style in ALL_STYLES
            test_format(s, s, style; separate_kwargs_with_semicolon = true, whitespace_in_kwargs = true)
        end
        
        # try with comments all over the place just to be safe
        s = "foo(x, #=hi=# bar = 0 #=hi=#, #=hi=# y #=hi=#)"
        for style in ALL_STYLES
            test_format(s, s, style; separate_kwargs_with_semicolon = true, whitespace_in_kwargs = true)
        end

        s = """
        foo(
            x,
            bar = 0, # hi
            z, # hi
        )"""
        for style in ALL_STYLES
            # indentation & trailing comma differs, just check that AST is same
            test_format(s, nothing, style; ast=true)
        end
    end

    @testset "#1133: idempotence with short_to_long_function_def" begin
        # https://github.com/MakieOrg/Makie.jl/blob/31de53c4643b41605b3a4e23ad68449e13de14de/Makie/src/basic_recipes/contourf.jl#L53
        s_= "_get_isoband_levels(levels::Int, mi, ma) = collect(range(Float32(mi), nextfloat(Float32(ma)), length = levels + 1))"
        s = """
        function _get_isoband_levels(levels::Int, mi, ma)
            return collect(range(Float32(mi), nextfloat(Float32(ma)); length=levels + 1))
        end"""
        test_format(s_, s, BlueStyle())

        # minimised version of the above
        s_ = "foo(x) = goo(x, k=v)"
        s = """
        function foo(
            x
        )
            return goo(
                x;
                k=v,
            )
        end"""
        test_format(s_, s, BlueStyle(); margin=10)

        # https://github.com/SciML/OrdinaryDiffEq.jl/blob/0bda3109a1b9581450776b0e5f9607c2dd5e5281/test/AD/ad_tests.jl#L29-L34
        s_ = """
        begin
            get_gradient_backends() = [AutoForwardDiff(), AutoEnzyme(mode = Enzyme.set_runtime_activity(Enzyme.Reverse))]
        end"""
        s = """
        begin
            function get_gradient_backends()
                return [
                    AutoForwardDiff(),
                    AutoEnzyme(; mode=Enzyme.set_runtime_activity(Enzyme.Reverse)),
                ]
            end
        end"""
        test_format(s_, s, BlueStyle())
    end
end

end # module

# A flag to indicate whether we are inside an `Expr` (in which case all syntax
# transformations should be suppressed), inside a macro (in which case some syntax
# transformations can still be enabled if the user explicitly says so), or neither (in which
# case all syntax transformations can be enabled).
@enum SyntaxTransformsStatus InsideExpr InsideMacro None

mutable struct State
    doc::Document
    indent::Int
    offset::Int
    line_offset::Int

    # If true, output is formatted text otherwise
    # it's source text
    on::Bool
    opts::Options

    # When true, syntax transformations (e.g. import_to_using) are suppressed.
    # Set inside quote, quotenode, and macro nodes, where transforming the code
    # would change the semantics of the expression.
    syntax_transforms_status::SyntaxTransformsStatus
end
State(doc, opts) = State(doc, 0, 1, 0, true, opts, None)

"""
    can_transform_syntax(s::State, allow_in_macros::Bool)

Check whether according to the current state we are allowed to perform a syntax
transformation. The `allow_in_macros` argument indicates whether the syntax transformation
should be allowed inside macros when `s.opts.transform_syntax_in_macros` is true. Some
syntax transformations are simply not safe to perform inside macros so are disabled even if
`s.opts.transform_syntax_in_macros` is true.
"""
function can_transform_syntax(s::State, allow_in_macros::Bool)
    s.syntax_transforms_status == None || (
        allow_in_macros &&
        s.syntax_transforms_status == InsideMacro &&
        s.opts.transform_syntax_in_macros
    )
end

nspaces(s::State) = s.indent
hascomment(d::Document, line::Integer) = haskey(d.comments, line)

function cursor_loc(s::State, offset::Integer)
    l = JuliaSyntax.source_line(s.doc.srcfile, offset)
    r = JuliaSyntax.source_line_range(s.doc.srcfile, offset)
    code = JuliaSyntax.sourcetext(s.doc.srcfile)
    line_start = first(r)
    display_col = if offset <= line_start
        1
    else
        textwidth(code[line_start:prevind(code, offset)]) + 1
    end
    return (l, display_col)
end
cursor_loc(s::State) = cursor_loc(s, s.offset)

function on_same_line(s::State, offset1::Integer, offset2::Integer)
    l1 = JuliaSyntax.source_line(s.doc.srcfile, offset1)
    l2 = JuliaSyntax.source_line(s.doc.srcfile, offset2)
    return l1 == l2
end

function linerange(s::State, line::Integer)
    f = s.doc.srcfile.line_starts[line]
    r = JuliaSyntax.source_line_range(s.doc.srcfile, f)
    return (first(r), last(r))
end

"""
    align_fst!(fst::FST, opts::Options)

Walk `fst` and apply the alignment passes enabled by `opts`.
"""
function align_fst!(fst::FST, opts::Options)
    if is_leaf(fst)
        return
    end
    assignment_inds = Int[]
    pair_arrow_inds = Int[]

    for (i, n) in enumerate(fst.nodes)
        if is_leaf(n)
            continue
        elseif opts.align_struct_field && (n.typ === Struct || n.typ === Mutable)
            align_struct!(n)
        elseif opts.align_conditional && n.typ === Conditional
            align_conditional!(n)
        elseif opts.align_matrix && (
            n.typ === Vcat || n.typ === TypedVcat || n.typ === Ncat || n.typ === TypedNcat
        )
            align_matrix!(n)
        else
            align_fst!(n, opts)
        end

        if opts.align_assignment && (is_assignment(n) || n.typ === Kw)
            # Gather all assignments within the current code block
            # they will be aligned at the end
            push!(assignment_inds, i)
        elseif opts.align_pair_arrow && n.typ === Binary && op_kind(n) === K"=>"
            push!(pair_arrow_inds, i)
        end
    end

    align_binaryopcalls!(fst, assignment_inds)
    align_binaryopcalls!(fst, pair_arrow_inds)
end

"""
    AlignGroup

Group of FST node indices and required metadata to potentially align them.

- `node_inds`. Indices of FST nodes affected by alignment.
- `nodes`. FST nodes affected by alignment.
- `line_offsets`. Display line offset of the character nodes may be aligned
  to in the source file.
- `lens`. Length of the FST node prior to the alignment character. Used
  to calculate extra whitespace padding.
- `whitespaces`. Number of whitespaces between the alignment character and
  the prior FST node. If this is > 1 it signifies additional whitespace was
  manually added by the user since the formatter would only use 0 or 1 whitespaces.
"""
struct AlignGroup
    nodes::Vector{FST}
    node_inds::Vector{Int}
    line_offsets::Vector{Int}
    lens::Vector{Int}
    whitespaces::Vector{Int}
end
AlignGroup() = AlignGroup(FST[], Int[], Int[], Int[], Int[])

function Base.push!(g::AlignGroup, n::FST, ind::Int, line_offset::Int, len::Int, ws::Int)
    push!(g.nodes, n)
    push!(g.node_inds, ind)
    push!(g.line_offsets, line_offset)
    push!(g.lens, len)
    push!(g.whitespaces, ws)
    return
end

function Base.show(io::IO, g::AlignGroup)
    println(io, "AlignGroup:")
    println(io, "  node_inds: ", g.node_inds)
    println(io, "  line_offsets: ", g.line_offsets)
    println(io, "  lens: ", g.lens)
    println(io, "  whitespaces: ", g.whitespaces)
end

function align_to(g::AlignGroup)::Union{Nothing,Int}
    if !(length(g.lens) > 0)
        return nothing
    end
    # determine whether alignment might be warranted
    max_len, max_ind = findmax(g.lens)
    max_inds = findall(==(g.line_offsets[max_ind]), g.line_offsets)
    if !(length(max_inds) > 1)
        return nothing
    end

    # Is there custom whitespace?
    # Formatter would only add 0 or 1 whitespaces.
    # > 2 implies a manual edit in the source file.
    for i in max_inds
        if g.whitespaces[i] > 1
            return max_len
        end
    end

    return nothing
end

function align_binaryopcall!(fst::FST, diff::Int)
    # insert whitespace before and after operator
    find = findfirst(x -> x.typ === WHITESPACE, fst.nodes)
    lind = findlast(x -> x.typ === WHITESPACE, fst.nodes)

    if find === nothing
        insert!(fst, 2, Whitespace(diff))
    else
        fst[find] = Whitespace(diff)
    end

    if lind === nothing
        insert!(fst, 4, Whitespace(1))
    end
end

function node_align_length(n::FST)
    if is_leaf(n)
        return textwidth(n.val)
    end
    margin = 0
    for nn in n.nodes
        margin += node_align_length(nn)
    end
    return margin
end

function node_align_length(nodes::Vector{FST})
    margin = 0
    for nn in nodes
        margin += node_align_length(nn)
    end
    return margin
end

"""
    align_binaryopcalls!(fst::FST, op_inds::Vector{Int})

Aligns binary operator expressions.

Additionally handles the case where a keyword such as `const` is used prior to the binary op
call.
"""
function align_binaryopcalls!(fst::FST, op_inds::Vector{Int})
    if !(length(op_inds) > 1)
        return
    end
    prev_endline = fst[op_inds[1]].endline
    groups = AlignGroup[]
    g = AlignGroup()

    for i in op_inds
        n = fst[i]
        if n.startline - prev_endline > 1
            push!(groups, g)
            g = AlignGroup()
        end

        binop, nlen, ws = if n.typ === Binary || n.typ === Kw
            nlen = node_align_length(n[1])
            n, nlen, n[3].line_offset - n.line_offset - nlen
        else
            binop::Union{FST,Nothing} = nothing
            sn = n
            nlen = 0
            ws = 0

            # the binary op may not be at the top level
            # for instance, @call1 @call2 @call3 x = 10
            while sn.nodes !== nothing
                binop_ind = findfirst(nn -> nn.typ === Binary, sn.nodes)
                nlen += node_align_length(sn[1:(end-1)])
                if binop_ind === nothing
                    sn = (sn.nodes::Vector{FST})[end]
                else
                    binop = (sn.nodes::Vector{FST})[binop_ind]
                    nlen += node_align_length(binop[1])
                    ws = binop[3].line_offset - n.line_offset - nlen
                    break
                end
            end
            binop, nlen, ws
        end

        if binop === nothing
            @warn "Binary operator not found in node" n.typ
            continue
        end

        push!(g.nodes, binop)
        push!(g.node_inds, i)
        push!(g.line_offsets, binop[3].line_offset)
        push!(g.lens, nlen)
        push!(g.whitespaces, ws)

        prev_endline = n.endline
    end
    push!(groups, g)

    for g in groups
        align_len = align_to(g)
        if isnothing(align_len)
            continue
        end

        for (i, n) in enumerate(g.nodes)
            diff = align_len - g.lens[i] + 1
            align_binaryopcall!(n, diff)
            n.nest_behavior = NeverNest
        end
    end

    return
end

"""
    align_struct!(fst::FST)

Aligns struct fields.
"""
function align_struct!(fst::FST)
    ind = findfirst(n -> n.typ === Block, fst.nodes)
    if isnothing(ind) || length(fst[ind]) == 0
        return
    end

    block_fst = fst[ind]
    prev_endline = block_fst[1].endline
    groups = AlignGroup[]
    g = AlignGroup()

    for (i, n) in enumerate(block_fst.nodes)
        if n.typ === Binary
            if n.startline - prev_endline > 1
                push!(groups, g)
                g = AlignGroup()
            end

            nlen = node_align_length(n[1])
            ind = findfirst(x -> x.typ === OPERATOR, n.nodes)
            # issue 757
            # "foo
            # """
            # a::B
            #
            # This is parsed as a concatenated string of "foo" and ""
            if ind === nothing
                continue
            end

            ws = n[ind].line_offset - n.line_offset - nlen

            push!(g.nodes, n)
            push!(g.node_inds, i)
            push!(g.line_offsets, n[ind].line_offset)
            push!(g.lens, nlen)
            push!(g.whitespaces, ws)

            prev_endline = n.endline
        elseif n.typ === Const && n[end].typ === Binary
            if n.startline - prev_endline > 1
                push!(groups, g)
                g = AlignGroup()
            end

            nlen = node_align_length(n[1]) + node_align_length(n[2])
            binop = n[end]
            nlen += node_align_length(binop[1])
            ind = findfirst(x -> x.typ === OPERATOR, binop.nodes)
            if ind === nothing
                continue
            end
            ws = binop[ind].line_offset - n.line_offset - nlen

            push!(g.nodes, binop)
            push!(g.node_inds, i)
            push!(g.line_offsets, binop[ind].line_offset)
            push!(g.lens, nlen)
            push!(g.whitespaces, ws)

            prev_endline = n.endline
        end
    end
    push!(groups, g)

    for g in groups
        align_len = align_to(g)
        if align_len === nothing
            continue
        end
        for (i, n) in enumerate(g.nodes)
            diff = align_len - g.lens[i] + 1
            align_binaryopcall!(n, diff)
            n.nest_behavior = NeverNest
        end
    end
end

"""
    align_conditional!(fst::FST)

Aligns a conditional expression.
"""
function align_conditional!(fst::FST)
    nodes = flatten_conditionalopcall(fst)

    cond_group = AlignGroup()
    cond_prev_endline = 0

    colon_group = AlignGroup()
    colon_prev_endline = 0

    for (i, n) in enumerate(nodes)
        if n.typ === OPERATOR && n.val == "?"
            if cond_prev_endline != n.endline
                nlen = node_align_length(nodes[i-2])
                ws = n.line_offset - nodes[i-2].line_offset - nlen

                push!(cond_group.nodes, n)
                push!(cond_group.node_inds, i)
                push!(cond_group.line_offsets, n.line_offset)
                push!(cond_group.lens, nlen)
                push!(cond_group.whitespaces, ws)
            end
            cond_prev_endline = n.endline
        elseif n.typ === OPERATOR && n.val == ":"
            if colon_prev_endline != n.endline
                nlen = node_align_length(nodes[i-2])
                ws = n.line_offset - nodes[i-2].line_offset - nlen

                push!(colon_group.nodes, n)
                push!(colon_group.node_inds, i)
                push!(colon_group.line_offsets, n.line_offset)
                push!(colon_group.lens, nlen)
                push!(colon_group.whitespaces, ws)
            end
            colon_prev_endline = n.endline
        end
    end
    if !(length(cond_group.lens) > 1)
        return
    end

    cond_len = align_to(cond_group)
    colon_len = align_to(colon_group)

    if cond_len === nothing && colon_len === nothing
        return
    end

    if cond_len !== nothing
        for (i, ind) in enumerate(cond_group.node_inds)
            diff = cond_len - cond_group.lens[i] + 1
            nodes[ind-1] = Whitespace(diff)
        end
    end

    for (i, ind) in enumerate(colon_group.node_inds)
        # the placeholder would be i+1 if not for a possible inline comment
        nind = findnext(n -> n.typ === PLACEHOLDER, nodes, ind + 1)::Int
        if nodes[nind+1].startline != nodes[nind].startline
            nodes[nind] = Newline(; nest_behavior = AlwaysNest)
        end

        if colon_len !== nothing
            diff = colon_len - colon_group.lens[i] + 1
            nodes[ind-1] = Whitespace(diff)
        end
    end

    fst.nodes = nodes
    fst.nest_behavior = NeverNest
    fst.indent = fst.line_offset - 1

    return
end

"""
    align_matrix!(fst::FST)

Adjust whitespace between matrix elements so it matches the original source layout.
"""
function align_matrix!(fst::FST)
    rows = filter(n -> n.typ === Row, fst.nodes::Vector{FST})
    if length(rows) == 0
        return
    end

    min_offset = minimum(r -> r[1].line_offset, rows)

    line = 0
    # add whitespace prior to initial element if elements are aligned to the right and
    # it's the first row on that line.
    for r in rows
        row_offset = r[1].line_offset
        if row_offset > min_offset && line != r.startline
            diff = row_offset - min_offset
            if diff > 0
                insert!(r.nodes::Vector{FST}, 1, Whitespace(diff))
            end
        end
        line = r.startline
    end

    for r in rows
        for (i, n) in enumerate(r.nodes)
            # skip whitespace nodes appearing before initial element
            if i > 1 && n.typ === WHITESPACE
                n1 = r[i-1]
                n2 = r[i+1]

                diff = n2.line_offset - n1.line_offset - node_align_length(n1)

                # fix #694 and #713
                if diff > 0
                    r[i] = Whitespace(diff)
                end
            end
        end
    end

    return
end

module ArgparseTests

using Test: @test, @testset, @test_throws, @test_logs
using JuliaFormatter.ArgParse: ParseArgsError, ParsedArgs, parse_args, parse_raw, PARSER,
    StdoutMode, InplaceMode, CheckMode
using JuliaFormatter: DefaultStyle, YASStyle, BlueStyle, SciMLStyle, MinimalStyle, _Unset, Options

@testset "argparse" begin
    @testset "parse_raw" begin
        @testset "empty args" begin
            raw = parse_raw(PARSER, String[])
            @test raw[:paths] == []
        end

        @testset "flag short and long forms" begin
            raw = parse_raw(PARSER, ["-c", "foo.jl"])
            @test raw[:check] == true
            raw = parse_raw(PARSER, ["--check", "foo.jl"])
            @test raw[:check] == true
        end

        @testset "option with = and space" begin
            raw = parse_raw(PARSER, ["--margin=80"])
            @test raw[:margin] == 80
            raw = parse_raw(PARSER, ["--margin", "80"])
            @test raw[:margin] == 80
        end

        @testset "option with multiple names" begin
            raw = parse_raw(PARSER, ["-o", "out.jl"])
            @test raw[:outputfile] == "out.jl"
            raw = parse_raw(PARSER, ["--output=out.jl"])
            @test raw[:outputfile] == "out.jl"
            raw = parse_raw(PARSER, ["--output", "out.jl"])
            @test raw[:outputfile] == "out.jl"
        end

        @testset "negatable flag (deprecated)" begin
            raw = parse_raw(PARSER, ["--always_for_in"])
            @test raw[:always_for_in] == true
            raw = parse_raw(PARSER, ["--no-always_for_in"])
            @test raw[:always_for_in] == false
        end

        @testset "boolean option with = syntax" begin
            raw = parse_raw(PARSER, ["--always-for-in=true"])
            @test raw[:always_for_in] == true
            raw = parse_raw(PARSER, ["--always-for-in=false"])
            @test raw[:always_for_in] == false
        end

        @testset "multi option collects values" begin
            raw = parse_raw(PARSER, ["--ignore=*.tmp", "--ignore=*/test/*"])
            @test raw[:ignore] == ["*.tmp", "*/test/*"]
        end

        @testset "last value wins for non-multi" begin
            raw = parse_raw(PARSER, ["--margin=10", "--margin=20"])
            @test raw[:margin] == 20
        end

        @testset "positional args preserved in order" begin
            raw = parse_raw(PARSER, ["a.jl", "-c", "b.jl", "--margin=1", "c.jl"])
            @test raw[:paths] == ["a.jl", "b.jl", "c.jl"]
        end

        @testset "unknown flags treated as positional" begin
            raw = parse_raw(PARSER, ["--unknown", "foo.jl"])
            @test raw[:paths] == ["--unknown", "foo.jl"]
        end

        @testset "missing value for option" begin
            @test_throws ParseArgsError parse_raw(PARSER, ["--margin"])
        end

        @testset "invalid value for option" begin
            @test_throws ParseArgsError parse_raw(PARSER, ["--margin=abc"])
        end

        @testset "line ranges" begin
            raw = parse_raw(PARSER, ["--lines=1:10", "--lines=42:47"])
            @test raw[:lines] == [(1, 10), (42, 47)]
        end

        @testset "line range errors" begin
            @test_throws ParseArgsError parse_raw(PARSER, ["--lines=abc"])
            @test_throws ParseArgsError parse_raw(PARSER, ["--lines=5:2"])
        end
    end

    @testset "parse_args" begin
        @testset "defaults" begin
            args = parse_args(String[])
            @test args.help == false
            @test args.version == false
            @test args.mode == StdoutMode
            @test args.diff == false
            @test args.config_priority == false
            @test args.ignore_config == false
            @test args.outputfile === nothing
            @test args.stdin_filename == "stdin"
            @test args.config_dir == ""
            @test args.line_ranges == []
            @test args.config.options == Options{_Unset}()
            @test args.config.ignore === nothing
            @test args.config.verbose === nothing
            @test args.config.format_markdown === nothing
            @test args.config.overwrite === nothing
            @test args.paths == []
        end

        @testset "help and version" begin
            @test parse_args(["-h"]).help == true
            @test parse_args(["--help"]).help == true
            @test parse_args(["--version"]).version == true
        end

        @testset "output mode" begin
            @test parse_args(["-c"]).mode == CheckMode
            @test parse_args(["--check"]).mode == CheckMode
            @test parse_args(["-i"]).mode == InplaceMode
            @test parse_args(["--inplace"]).mode == InplaceMode
            @test parse_args(["f.jl"]).mode == StdoutMode
        end

        @testset "output mode mutual exclusion" begin
            @test_throws ParseArgsError parse_args(["--check", "--inplace"])
            @test_throws ParseArgsError parse_args(["--check", "-o", "out.jl"])
            @test_throws ParseArgsError parse_args(["--inplace", "--output=out.jl"])
        end

        @testset "outputfile" begin
            args = parse_args(["-o", "out.jl"])
            @test args.outputfile == "out.jl"
            args = parse_args(["--output=out.jl"])
            @test args.outputfile == "out.jl"
            @test parse_args(["f.jl"]).outputfile === nothing
            @test_throws ParseArgsError parse_args(["-o"])
        end

        @testset "simple flags" begin
            @test parse_args(["-d"]).diff == true
            @test parse_args(["-v"]).verbose == true
            @test parse_args(["--prioritize-config-file"]).config_priority == true
            @test parse_args(["--ignore-config"]).ignore_config == true
        end

        @testset "format-markdown" begin
            # Not passed: nothing (defer to config file)
            @test parse_args(["f.jl"]).config.format_markdown === nothing
            # Explicit true
            @test parse_args(["--format-markdown=true"]).config.format_markdown === true
            # Explicit false (can override config file)
            @test parse_args(["--format-markdown=false"]).config.format_markdown === false
            # Deprecated flag (still works, sets true)
            @test parse_args(["--format_markdown"]).config.format_markdown === true
        end

        @testset "config file options mutual exclusion" begin
            @test_throws ParseArgsError parse_args(["--prioritize-config-file", "--ignore-config"])
            @test_throws ParseArgsError parse_args(["--ignore-config", "--config-dir", "foo"])
        end

        @testset "string options" begin
            @test parse_args(["--stdin-filename=foo.jl"]).stdin_filename == "foo.jl"
            @test parse_args(["--config-dir=/some/path"]).config_dir == "/some/path"
        end

        @testset "style" begin
            @test parse_args(["--style=default"]).config.style == DefaultStyle()
            @test parse_args(["--style=yas"]).config.style == YASStyle()
            @test parse_args(["--style=blue"]).config.style == BlueStyle()
            @test parse_args(["--style=sciml"]).config.style == SciMLStyle()
            @test parse_args(["--style=minimal"]).config.style == MinimalStyle()
            @test_throws ParseArgsError parse_args(["--style=nonexistent"])
        end

        @testset "ignore patterns" begin
            args = parse_args(["--ignore=*.tmp"])
            @test args.config.ignore == ["*.tmp"]
            args = parse_args(["--ignore=*.tmp", "--ignore=*/test/*"])
            @test args.config.ignore == ["*.tmp", "*/test/*"]
            @test parse_args(["f.jl"]).config.ignore === nothing
        end

        @testset "line ranges" begin
            args = parse_args(["--lines=1:10"])
            @test args.line_ranges == [(1, 10)]
            args = parse_args(["--lines=1:10", "--lines=42:47"])
            @test args.line_ranges == [(1, 10), (42, 47)]
            @test parse_args(["f.jl"]).line_ranges == []
        end

        @testset "format options from value options" begin
            args = parse_args(["--indent=2", "--margin=80"])
            @test args.config.options.indent == 2
            @test args.config.options.margin == 80
        end

        @testset "format options from negatable flags" begin
            args = parse_args(["--always_for_in"])
            @test args.config.options.always_for_in == true

            args = parse_args(["--no-always_for_in"])
            @test args.config.options.always_for_in == false
        end

        @testset "unset format options are absent" begin
            args = parse_args(["--always_for_in"])
            @test args.config.options.always_for_in == true
            @test args.config.options.trailing_comma === _Unset()
        end

        @testset "mixed flags and paths" begin
            args = parse_args(["-i", "--margin=80", "-d", "-v", "--style=blue", "src/", "lib/"])
            @test args.mode == InplaceMode
            @test args.diff == true
            @test args.verbose == true
            @test args.config.style == BlueStyle()
            @test args.config.options.margin == 80
            @test args.paths == ["src/", "lib/"]
        end

        @testset "flags can appear in any order" begin
            a = parse_args(["-c", "-d", "--margin=80"])
            b = parse_args(["--margin=80", "-d", "-c"])
            @test a.mode == b.mode == CheckMode
            @test a.diff == b.diff == true
            @test a.config.options.margin == b.config.options.margin == 80
        end

        @testset "for-in-replacement" begin
            for val in ["in", "=", "∈"]
                @test parse_args(["--for-in-replacement=$val"]).config.options.for_in_replacement == val
            end
        end

        @testset "normalize-line-endings" begin
            for mode in ["auto", "unix", "windows"]
                @test parse_args(["--normalize-line-endings=$mode"]).config.options.normalize_line_endings == mode
            end
        end

        @testset "all formatting options (new-style)" begin
            # int options
            @test parse_args(["--indent=2"]).config.options.indent == 2
            @test parse_args(["--margin=80"]).config.options.margin == 80
            @test parse_args(["--sciml-margin-overrun=10"]).config.options.sciml_margin_overrun == 10
            # bool options (alphabetical)
            @test parse_args(["--align-assignment=true"]).config.options.align_assignment == true
            @test parse_args(["--align-assignment=false"]).config.options.align_assignment == false
            @test parse_args(["--align-conditional=true"]).config.options.align_conditional == true
            @test parse_args(["--align-conditional=false"]).config.options.align_conditional == false
            @test parse_args(["--align-matrix=true"]).config.options.align_matrix == true
            @test parse_args(["--align-matrix=false"]).config.options.align_matrix == false
            @test parse_args(["--align-pair-arrow=true"]).config.options.align_pair_arrow == true
            @test parse_args(["--align-pair-arrow=false"]).config.options.align_pair_arrow == false
            @test parse_args(["--align-struct-field=true"]).config.options.align_struct_field == true
            @test parse_args(["--align-struct-field=false"]).config.options.align_struct_field == false
            @test parse_args(["--always-for-in=true"]).config.options.always_for_in == true
            @test parse_args(["--always-for-in=false"]).config.options.always_for_in == false
            @test parse_args(["--always-for-in=nothing"]).config.options.always_for_in === nothing
            @test parse_args(["--always-use-return=true"]).config.options.always_use_return == true
            @test parse_args(["--always-use-return=false"]).config.options.always_use_return == false
            @test parse_args(["--annotate-untyped-fields-with-any=true"]).config.options.annotate_untyped_fields_with_any == true
            @test parse_args(["--annotate-untyped-fields-with-any=false"]).config.options.annotate_untyped_fields_with_any == false
            @test parse_args(["--conditional-to-if=true"]).config.options.conditional_to_if == true
            @test parse_args(["--conditional-to-if=false"]).config.options.conditional_to_if == false
            @test parse_args(["--disallow-single-arg-nesting=true"]).config.options.disallow_single_arg_nesting == true
            @test parse_args(["--disallow-single-arg-nesting=false"]).config.options.disallow_single_arg_nesting == false
            @test parse_args(["--enforce-triplequoted-docstrings=true"]).config.options.enforce_triplequoted_docstrings == true
            @test parse_args(["--enforce-triplequoted-docstrings=false"]).config.options.enforce_triplequoted_docstrings == false
            @test parse_args(["--force-long-function-def=true"]).config.options.force_long_function_def == true
            @test parse_args(["--force-long-function-def=false"]).config.options.force_long_function_def == false
            @test parse_args(["--format-docstrings=true"]).config.options.format_docstrings == true
            @test parse_args(["--format-docstrings=false"]).config.options.format_docstrings == false
            @test parse_args(["--import-to-using=true"]).config.options.import_to_using == true
            @test parse_args(["--import-to-using=false"]).config.options.import_to_using == false
            @test parse_args(["--indent-submodule=true"]).config.options.indent_submodule == true
            @test parse_args(["--indent-submodule=false"]).config.options.indent_submodule == false
            @test parse_args(["--join-lines-based-on-source=true"]).config.options.join_lines_based_on_source == true
            @test parse_args(["--join-lines-based-on-source=false"]).config.options.join_lines_based_on_source == false
            @test parse_args(["--long-to-short-function-def=true"]).config.options.long_to_short_function_def == true
            @test parse_args(["--long-to-short-function-def=false"]).config.options.long_to_short_function_def == false
            @test parse_args(["--pipe-to-function-call=true"]).config.options.pipe_to_function_call == true
            @test parse_args(["--pipe-to-function-call=false"]).config.options.pipe_to_function_call == false
            @test parse_args(["--remove-extra-newlines=true"]).config.options.remove_extra_newlines == true
            @test parse_args(["--remove-extra-newlines=false"]).config.options.remove_extra_newlines == false
            @test parse_args(["--separate-kwargs-with-semicolon=true"]).config.options.separate_kwargs_with_semicolon == true
            @test parse_args(["--separate-kwargs-with-semicolon=false"]).config.options.separate_kwargs_with_semicolon == false
            @test parse_args(["--short-circuit-to-if=true"]).config.options.short_circuit_to_if == true
            @test parse_args(["--short-circuit-to-if=false"]).config.options.short_circuit_to_if == false
            @test parse_args(["--short-to-long-function-def=true"]).config.options.short_to_long_function_def == true
            @test parse_args(["--short-to-long-function-def=false"]).config.options.short_to_long_function_def == false
            @test parse_args(["--surround-whereop-typeparameters=true"]).config.options.surround_whereop_typeparameters == true
            @test parse_args(["--surround-whereop-typeparameters=false"]).config.options.surround_whereop_typeparameters == false
            @test parse_args(["--trailing-comma=true"]).config.options.trailing_comma == true
            @test parse_args(["--trailing-comma=false"]).config.options.trailing_comma == false
            @test parse_args(["--trailing-comma=nothing"]).config.options.trailing_comma === nothing
            @test parse_args(["--trailing-zero=true"]).config.options.trailing_zero == true
            @test parse_args(["--trailing-zero=false"]).config.options.trailing_zero == false
            @test parse_args(["--transform-syntax-in-macros=true"]).config.options.transform_syntax_in_macros == true
            @test parse_args(["--transform-syntax-in-macros=false"]).config.options.transform_syntax_in_macros == false
            @test parse_args(["--v2-stable-multiline-strings=true"]).config.options.v2_stable_multiline_strings == true
            @test parse_args(["--v2-stable-multiline-strings=false"]).config.options.v2_stable_multiline_strings == false
            @test parse_args(["--variable-call-indent=Dict"]).config.options.variable_call_indent == ["Dict"]
            @test parse_args(["--variable-call-indent=Dict", "--variable-call-indent=Foo"]).config.options.variable_call_indent == ["Dict", "Foo"]
            @test parse_args(["--whitespace-in-kwargs=true"]).config.options.whitespace_in_kwargs == true
            @test parse_args(["--whitespace-in-kwargs=false"]).config.options.whitespace_in_kwargs == false
            @test parse_args(["--whitespace-ops-in-indices=true"]).config.options.whitespace_ops_in_indices == true
            @test parse_args(["--whitespace-ops-in-indices=false"]).config.options.whitespace_ops_in_indices == false
            @test parse_args(["--whitespace-typedefs=true"]).config.options.whitespace_typedefs == true
            @test parse_args(["--whitespace-typedefs=false"]).config.options.whitespace_typedefs == false
            @test parse_args(["--yas-style-nesting=true"]).config.options.yas_style_nesting == true
            @test parse_args(["--yas-style-nesting=false"]).config.options.yas_style_nesting == false
        end

        @testset "deprecated underscored options still work" begin
            @test parse_args(["--sciml_margin_overrun=10"]).config.options.sciml_margin_overrun == 10
            @test parse_args(["--normalize_line_endings=unix"]).config.options.normalize_line_endings == "unix"
        end

        @testset "all formatting options (deprecated negatable flags still work)" begin
            @test parse_args(["--always_for_in"]).config.options.always_for_in == true
            @test parse_args(["--no-always_for_in"]).config.options.always_for_in == false
            @test parse_args(["--whitespace_typedefs"]).config.options.whitespace_typedefs == true
            @test parse_args(["--no-whitespace_typedefs"]).config.options.whitespace_typedefs == false
            @test parse_args(["--remove_extra_newlines"]).config.options.remove_extra_newlines == true
            @test parse_args(["--no-remove_extra_newlines"]).config.options.remove_extra_newlines == false
            @test parse_args(["--import_to_using"]).config.options.import_to_using == true
            @test parse_args(["--no-import_to_using"]).config.options.import_to_using == false
            @test parse_args(["--pipe_to_function_call"]).config.options.pipe_to_function_call == true
            @test parse_args(["--no-pipe_to_function_call"]).config.options.pipe_to_function_call == false
            @test parse_args(["--short_to_long_function_def"]).config.options.short_to_long_function_def == true
            @test parse_args(["--no-short_to_long_function_def"]).config.options.short_to_long_function_def == false
            @test parse_args(["--always_use_return"]).config.options.always_use_return == true
            @test parse_args(["--no-always_use_return"]).config.options.always_use_return == false
            @test parse_args(["--whitespace_in_kwargs"]).config.options.whitespace_in_kwargs == true
            @test parse_args(["--no-whitespace_in_kwargs"]).config.options.whitespace_in_kwargs == false
            @test parse_args(["--format_docstrings"]).config.options.format_docstrings == true
            @test parse_args(["--no-format_docstrings"]).config.options.format_docstrings == false
            @test parse_args(["--align_struct_field"]).config.options.align_struct_field == true
            @test parse_args(["--no-align_struct_field"]).config.options.align_struct_field == false
            @test parse_args(["--align_assignment"]).config.options.align_assignment == true
            @test parse_args(["--no-align_assignment"]).config.options.align_assignment == false
            @test parse_args(["--align_conditional"]).config.options.align_conditional == true
            @test parse_args(["--no-align_conditional"]).config.options.align_conditional == false
            @test parse_args(["--align_pair_arrow"]).config.options.align_pair_arrow == true
            @test parse_args(["--no-align_pair_arrow"]).config.options.align_pair_arrow == false
            @test parse_args(["--trailing_comma"]).config.options.trailing_comma == true
            @test parse_args(["--no-trailing_comma"]).config.options.trailing_comma == false
            @test parse_args(["--trailing_zero"]).config.options.trailing_zero == true
            @test parse_args(["--no-trailing_zero"]).config.options.trailing_zero == false
            @test parse_args(["--v2_stable_multiline_strings"]).config.options.v2_stable_multiline_strings == true
            @test parse_args(["--no-v2_stable_multiline_strings"]).config.options.v2_stable_multiline_strings == false
            @test parse_args(["--conditional_to_if"]).config.options.conditional_to_if == true
            @test parse_args(["--no-conditional_to_if"]).config.options.conditional_to_if == false
        end

        @testset "last value wins for repeated options" begin
            @test parse_args(["--style=blue", "--style=yas"]).config.style == YASStyle()
            @test parse_args(["--indent=2", "--indent=4"]).config.options.indent == 4
            # new-style option overrides deprecated flag (and vice versa)
            args = parse_args(["--always_for_in", "--always-for-in=false"])
            @test args.config.options.always_for_in == false
            args = parse_args(["--always-for-in=false", "--always_for_in"])
            @test args.config.options.always_for_in == true
        end

        @testset "positional paths" begin
            @test parse_args(["foo.jl"]).paths == ["foo.jl"]
            @test parse_args(["foo.jl", "bar.jl", "src/"]).paths == ["foo.jl", "bar.jl", "src/"]
        end

        @testset "stdin marker" begin
            @test parse_args(["-"]).paths == ["-"]
        end

        @testset "variable-call-indent unset when not specified" begin
            @test parse_args(["f.jl"]).config.options.variable_call_indent isa _Unset
        end
    end
end

end # module

module OptionsEnforceTriplequotedDocstringsTests

using JuliaFormatter.Internal: test_format
using Test

@testset "Basic" begin
    opts = (; format_docstrings = true)

    # (use begin blocks to check indentation)
    triple = """
    begin
        \"""
        doc
        \"""
        f() = 0
    end
    """

    single = """
    begin
        "doc"
        f() = 0
    end
    """

    # Normalize to triple by default.
    test_format(triple, triple; opts...)
    test_format(single, triple; opts...)

    # Unless we opt out.
    opts = (; format_docstrings = true, enforce_triplequoted_docstrings = false)
    test_format(single, single; opts...)

    # Not exactly good taste, but the option leaves it alone as promised.
    single_multiline = """
    begin
        "line1\\n\\
        line2"
        f() = 0
    end
    """
    test_format(single_multiline, single_multiline; opts...)

    # Still drop trailing whitespace on the first line (#667).
    test_format(
        """
        begin
            "$(" \t \t ")
            doc
            "
            f() = 0
        end
        """,
        """
        begin
            "doc"
            f() = 0
        end
        """,
        ;
        opts...,
    )
end

end

module InlineCommentTests

using JuliaFormatter: DefaultStyle, YASStyle, BlueStyle, MinimalStyle, SciMLStyle
using JuliaFormatter.Internal: test_format, ALL_STYLES
using Test

@testset "Inline comments" begin
    @testset "hasheq comment on its own line is not merged into previous line (#1194)" begin
        # Single newline between statement and comment
        s = "x = 42\n#= this is a multi-line comment\n=#\n"
        for style in ALL_STYLES
            test_format(s, s, style)
        end

        # Two newlines between statement and comment
        s = "x = 42\n\n#= this is a multi-line comment\n=#\n"
        for style in ALL_STYLES
            test_format(s, s, style)
        end

        # Multiple statements with own-line hasheq comments
        s = "x = 1\n#= comment 1 =#\ny = 2\n#= comment 2 =#\n"
        for style in ALL_STYLES
            test_format(s, s, style)
        end

        # Standalone hasheq comment before a statement
        s = "#= standalone comment =#\nx = 1\n"
        for style in ALL_STYLES
            test_format(s, s, style)
        end
    end

    @testset "hasheq comment on its own line inside a block (#1194)" begin
        s = "begin\n    x = 1\n    #= comment =#\nend\n"
        for style in ALL_STYLES
            test_format(s, s, style)
        end

        s = "function foo()\n    x = 1\n    #= block comment =#\n    y = 2\nend\n"
        for style in (DefaultStyle(), SciMLStyle(), MinimalStyle())
            test_format(s, s, style)
        end
        # BlueStyle and YASStyle add `return` before the last statement
        s_return = "function foo()\n    x = 1\n    #= block comment =#\n    return y = 2\nend\n"
        for style in (BlueStyle(), YASStyle())
            test_format(s, s_return, style)
        end
    end

    @testset "inline hasheq comment stays on the same line" begin
        s = "x = 42 #= inline comment =#\n"
        for style in ALL_STYLES
            test_format(s, s, style)
        end

        s = "f(x, #= c =# z)\n"
        for style in ALL_STYLES
            test_format(s, s, style)
        end
    end
end

end

module LineRangesTests

using JuliaFormatter
using JuliaFormatter: BlueStyle, format_text, normalize_line_ranges
using JuliaFormatter.Internal: test_format
using Test

# DefaultStyle leaves `a=1` and `x+y` untouched but turns `f(x,y)` into `f(x, y)`, so we use
# comma spacing to force a visible, line-count-preserving change on a targeted line.

@testset "line ranges (`lines` kwarg)" begin
    @testset "normalize_line_ranges" begin
        # `(start, stop)` tuples are converted to sorted UnitRange{Int}
        @test normalize_line_ranges([(1, 3)]) == [1:3]
        # sorting
        @test normalize_line_ranges([(5, 6), (1, 2)]) == [1:2, 5:6]
        # overlapping ranges merge
        @test normalize_line_ranges([(1, 3), (2, 5)]) == [1:5]
        # adjacent ranges merge (touching, gap of 0)
        @test normalize_line_ranges([(1, 2), (3, 4)]) == [1:4]
        # non-adjacent stay separate (gap >= 1 blank line between)
        @test normalize_line_ranges([(1, 2), (4, 5)]) == [1:2, 4:5]
        # duplicates collapse
        @test normalize_line_ranges([(2, 4), (2, 4)]) == [2:4]

        @test_throws ArgumentError normalize_line_ranges([(0, 1)])   # 0 is not 1-based
        @test_throws ArgumentError normalize_line_ranges([(3, 2)])   # empty (start > stop)
    end

    @testset "single range" begin
        # only line 1 is formatted; line 2 kept verbatim (note odd spacing preserved)
        test_format("f(x,y)=1\ng( a ,b )=2\n", "f(x, y) = 1\ng( a ,b )=2\n"; lines = [(1, 1)])
        # only line 2 is formatted; line 1 kept verbatim
        test_format("f( x ,y)=1\ng(a,b)=2\n", "f( x ,y)=1\ng(a, b) = 2\n"; lines = [(2, 2)])
    end

    @testset "multiple ranges" begin
        # lines 1 and 3 formatted, line 2 verbatim
        test_format(
            "f(a,b)=1\ng( x ,y )=2\nh(c,d)=3\n",
            "f(a, b) = 1\ng( x ,y )=2\nh(c, d) = 3\n";
            lines = [(1, 1), (3, 3)],
        )
        # ranges may be given out of order
        test_format(
            "f(a,b)=1\ng( x ,y )=2\nh(c,d)=3\n",
            "f(a, b) = 1\ng( x ,y )=2\nh(c, d) = 3\n";
            lines = [(3, 3), (1, 1)],
        )
    end

    @testset "merged ranges" begin
        # adjacent (1,1)+(2,2) -> 1:2, so lines 1 and 2 formatted, line 3 verbatim
        test_format(
            "f(a,b)=1\ng(c,d)=2\nh( e ,f )=3\n",
            "f(a, b) = 1\ng(c, d) = 2\nh( e ,f )=3\n";
            lines = [(1, 1), (2, 2)],
        )
        # overlapping ranges format the union
        test_format(
            "f(a,b)=1\ng(c,d)=2\nh(e,f)=3\n",
            format_text("f(a,b)=1\ng(c,d)=2\nh(e,f)=3\n");
            lines = [(1, 2), (2, 3)],
        )
    end

    @testset "whole-file range matches plain formatting" begin
        s = "f(a,b)=1\ng(c,d)=2\n"
        test_format(s, format_text(s); lines = [(1, 2)])
    end

    @testset "verbatim out-of-range" begin
        # leading/odd whitespace on out-of-range lines is preserved exactly
        test_format("   x  =  1\nf(a,b)=2\n", "   x  =  1\nf(a, b) = 2\n"; lines = [(2, 2)])
        # comments out of range preserved (including their internal spacing)
        test_format(
            "# keep  me\nf(a,b)=1\n# and  me\n",
            "# keep  me\nf(a, b) = 1\n# and  me\n";
            lines = [(2, 2)],
        )
    end

    @testset "line count changes within the range" begin
        # The splice synchronizes on the markers, not on line numbers, so the in-range block
        # may grow or shrink. Out-of-range lines (here both before and after the range) are
        # kept exactly -- note they are not reflowed even when they, too, exceed the margin.
        # (`test_format` is not used here: re-applying the same line range to output whose
        # line count changed would target different lines, so it is not idempotent.)

        # in-range expands: a one-line call spread across several lines by a tiny margin
        @test format_text("g(p, q)\nfoo(a, b, c)\nh(r, s)\n"; lines = [(2, 2)], margin = 5) ==
              "g(p, q)\nfoo(\n    a,\n    b,\n    c,\n)\nh(r, s)\n"

        # in-range collapses: a multi-line call merged back onto a single line
        @test format_text("g(p, q)\nfoo(a,\n  b,\n  c\n)\nh(r, s)\n"; lines = [(2, 5)]) ==
              "g(p, q)\nfoo(a, b, c)\nh(r, s)\n"
    end

    @testset "inside a block" begin
        # only the inner statement's line is formatted; the signature stays verbatim
        test_format(
            "function f( a ,b )\n    g(x,y)\nend\n",
            "function f( a ,b )\n    g(x, y)\nend\n";
            lines = [(2, 2)],
        )
    end

    @testset "interaction with #! format: off" begin
        # a user `#! format: off` region outside the requested range stays verbatim
        test_format(
            "f(a,b)=1\n#! format: off\nz  =  2\n#! format: on\n",
            "f(a, b) = 1\n#! format: off\nz  =  2\n#! format: on\n";
            lines = [(1, 1)],
        )
    end

    @testset "trailing newline handling" begin
        # range reaches the final newline-less line: output preserves the missing newline,
        # matching whole-file `format_text` behavior
        @test format_text("f(a,b)=1\ng(c,d)=2"; lines = [(2, 2)]) == "f(a,b)=1\ng(c, d) = 2"
        # range targets an earlier line: the newline-less last line stays verbatim
        @test format_text("f(a,b)=1\ng(c,d)=2"; lines = [(1, 1)]) == "f(a, b) = 1\ng(c,d)=2"
    end

    @testset "trailing newline phantom line" begin
        # Many editors / LSP clients count the position after a file's final newline as an
        # extra (empty) line, so a 2-line file ending in `\n` may be referenced with line 3.
        # `add_line_range_markers` accepts such references by clamping (or skipping) them.
        s = "f(a,b)=1\ng(c,d)=2\n"  # 2 real lines; the phantom line is line 3
        # a range that is *only* the phantom line formats nothing
        @test format_text(s; lines = [(3, 3)]) == s
        # a range spanning into the phantom line is clamped to the last real line
        @test format_text(s; lines = [(1, 3)]) == format_text(s)
        @test format_text(s; lines = [(2, 3)]) == "f(a,b)=1\ng(c, d) = 2\n"
        # without a trailing newline there is no phantom line, so line 3 is out of bounds
        @test_throws ArgumentError format_text("f(a,b)=1\ng(c,d)=2"; lines = [(3, 3)])
    end

    @testset "empty ranges" begin
        # nothing requested -> input returned unchanged
        @test format_text("f(a,b)=1\n"; lines = Tuple{Int,Int}[]) == "f(a,b)=1\n"
    end

    @testset "styles and options thread through" begin
        # `lines` composes with the chosen style and other options
        s = "f(a,b)=1\ng(c,d)=2\n"
        @test format_text(s, BlueStyle(); lines = [(1, 1)]) ==
              format_text("f(a,b)=1\n", BlueStyle()) * "g(c,d)=2\n"
        @test format_text(s; lines = [(1, 1)], whitespace_in_kwargs = false) ==
              "f(a, b) = 1\ng(c,d)=2\n"
    end

    @testset "out-of-bounds errors" begin
        @test_throws ArgumentError format_text("f(a,b)=1\n"; lines = [(1, 99)])
        @test_throws ArgumentError format_text("f(a,b)=1\n"; lines = [(0, 1)])
        @test_throws ArgumentError format_text("f(a,b)=1\n"; lines = [(2, 1)])
    end
end

end # module

module ConfigTests

using JuliaFormatter: format, CONFIG_FILE_NAME, format_text
using JuliaFormatter: BlueStyle, YASStyle
using Test

@testset ".JuliaFormatter.toml config" begin
    config2 = "indent = 2"
    config4 = "indent = 4"
    before = "begin rand() end\n"
    after2 = "begin\n  rand()\nend\n"
    after4 = "begin\n    rand()\nend\n"

    @testset "basic configuration" begin
        # ├─ .JuliaFormatter.toml (config2)
        # └─ code.jl (before -> after2)
        mktempdir() do dir
            code_path = joinpath(dir, "code.jl")
            write(joinpath(dir, CONFIG_FILE_NAME), config2)
            write(code_path, before)

            @test format(code_path) == false
            @test read(code_path, String) == after2
        end
    end

    @testset "upward config search" begin
        # ├─ .JuliaFormatter.toml (config2)
        # └─ sub
        #    ├─ sub_code.jl (before -> after2)
        #    └─ subsub
        #       └─ subsub_code.jl (before -> after2)
        mktempdir() do dir
            sub_dir = mkdir(joinpath(dir, "sub"))
            subsub_dir = mkdir(joinpath(sub_dir, "sub"))
            sub_code_path = joinpath(sub_dir, "sub_code.jl")
            subsub_code_path = joinpath(subsub_dir, "sub_code.jl")
            write(joinpath(dir, CONFIG_FILE_NAME), config2)
            write(sub_code_path, before)
            write(subsub_code_path, before)

            @test format(sub_code_path) == false
            @test read(sub_code_path, String) == after2
            @test format(subsub_code_path) == false
            @test read(subsub_code_path, String) == after2
            @test format(sub_code_path) == true
            @test format(subsub_code_path) == true
        end
    end

    @testset "basic directory walk" begin
        # ├─ .JuliaFormatter.toml (config2)
        # ├─ code.jl (before -> after2)
        # └─ sub
        #    └─ sub_code.jl (before -> after2)
        mktempdir() do dir
            sub_dir = mkdir(joinpath(dir, "sub"))
            code_path = joinpath(dir, "code.jl")
            sub_code_path = joinpath(sub_dir, "sub_code.jl")
            write(joinpath(dir, CONFIG_FILE_NAME), config2)
            write(code_path, before)
            write(sub_code_path, before)

            @test format(dir) == false
            @test read(code_path, String) == after2
            @test read(sub_code_path, String) == after2
            @test format(dir) == true
        end
    end

    @testset "directory walk with nested configs" begin
        # ├─ .JuliaFormatter.toml (config2)
        # ├─ code.jl (before -> after2)
        # ├─ sub1
        # │  ├─ .JuliaFormatter.toml (config4)
        # │  └─ sub_code1.jl (before -> after4)
        # └─ sub2
        #    └─ sub_code2.jl (before -> after2)
        mktempdir() do dir
            sub1_dir = mkdir(joinpath(dir, "sub1"))
            sub2_dir = mkdir(joinpath(dir, "sub2"))
            code_path = joinpath(dir, "code.jl")
            sub_code1_path = joinpath(sub1_dir, "sub_code1.jl")
            sub_code2_path = joinpath(sub2_dir, "sub_code2.jl")
            write(joinpath(dir, CONFIG_FILE_NAME), config2)
            write(joinpath(sub1_dir, CONFIG_FILE_NAME), config4)
            write(code_path, before)
            write(sub_code1_path, before)
            write(sub_code2_path, before)

            @test format(dir) == false
            @test read(code_path, String) == after2
            @test read(sub_code1_path, String) == after4
            @test read(sub_code2_path, String) == after2
            @test format(dir) == true
        end
    end

    @testset "per-file format with nested configs" begin
        # Same layout as the directory walk test, but format() each file individually.
        # ├─ .JuliaFormatter.toml (config2)
        # ├─ code.jl (before -> after2)
        # ├─ sub1
        # │  ├─ .JuliaFormatter.toml (config4)
        # │  └─ sub_code1.jl (before -> after4)
        # └─ sub2
        #    └─ sub_code2.jl (before -> after2)
        mktempdir() do dir
            sub1_dir = mkdir(joinpath(dir, "sub1"))
            sub2_dir = mkdir(joinpath(dir, "sub2"))
            code_path = joinpath(dir, "code.jl")
            sub_code1_path = joinpath(sub1_dir, "sub_code1.jl")
            sub_code2_path = joinpath(sub2_dir, "sub_code2.jl")
            write(joinpath(dir, CONFIG_FILE_NAME), config2)
            write(joinpath(sub1_dir, CONFIG_FILE_NAME), config4)
            write(code_path, before)
            write(sub_code1_path, before)
            write(sub_code2_path, before)

            # Root file picks up root config (indent=2)
            @test format(code_path) == false
            @test read(code_path, String) == after2
            # sub1 file picks up sub1 config (indent=4), not root
            @test format(sub_code1_path) == false
            @test read(sub_code1_path, String) == after4
            # sub2 file has no local config, walks up to root (indent=2)
            @test format(sub_code2_path) == false
            @test read(sub_code2_path, String) == after2
            # Idempotence
            @test format(code_path) == true
            @test format(sub_code1_path) == true
            @test format(sub_code2_path) == true
        end
    end

    @testset "directory walk with nested configs toplevel" begin
        # Same as "directory walk with nested configs" except format from within the
        # top level directory, i.e. `format(".")`
        mktempdir() do dir
            sub1_dir = mkdir(joinpath(dir, "sub1"))
            sub2_dir = mkdir(joinpath(dir, "sub2"))
            code_path = joinpath(dir, "code.jl")
            sub_code1_path = joinpath(sub1_dir, "sub_code1.jl")
            sub_code2_path = joinpath(sub2_dir, "sub_code2.jl")
            write(joinpath(dir, CONFIG_FILE_NAME), config2)
            write(joinpath(sub1_dir, CONFIG_FILE_NAME), config4)
            write(code_path, before)
            write(sub_code1_path, before)
            write(sub_code2_path, before)

            cd(dir) do
                @test format(".") == false
                @test read(code_path, String) == after2
                @test read(sub_code1_path, String) == after4
                @test read(sub_code2_path, String) == after2
                @test format(".") == true
            end
        end
    end

    @testset "directory walk with nested styles" begin
        # ├─ .JuliaFormatter.toml (style = "yas")
        # ├─ code.jl (before -> yas)
        # ├─ sub1
        # │  ├─ .JuliaFormatter.toml (style = "blue")
        # │  └─ sub_code1.jl (before -> blue)
        # └─ sub2
        #    └─ sub_code2.jl (before -> yas, from the root config)
        #
        # The call is long enough to be nested, which is where yas and blue disagree.
        before = "function f()\n  some_function_name(argument_one, argument_two, argument_three, argument_four, arg_five)\nend\n"
        after_yas = format_text(before; style = YASStyle())
        after_blue = format_text(before; style = BlueStyle())
        @test after_yas != after_blue

        mktempdir() do dir
            sub1_dir = mkdir(joinpath(dir, "sub1"))
            sub2_dir = mkdir(joinpath(dir, "sub2"))
            code_path = joinpath(dir, "code.jl")
            sub_code1_path = joinpath(sub1_dir, "sub_code1.jl")
            sub_code2_path = joinpath(sub2_dir, "sub_code2.jl")
            write(joinpath(dir, CONFIG_FILE_NAME), """style = "yas"\n""")
            write(joinpath(sub1_dir, CONFIG_FILE_NAME), """style = "blue"\n""")
            write(code_path, before)
            write(sub_code1_path, before)
            write(sub_code2_path, before)

            @test format(dir) == false
            @test read(code_path, String) == after_yas
            @test read(sub_code1_path, String) == after_blue
            @test read(sub_code2_path, String) == after_yas
            @test format(dir) == true
        end
    end

    @testset "markdown formatting" begin
        config2 = """
        indent = 2
        format_markdown = true
        """

        before = """
        # hello world

        ```julia
        begin body end
        ```
        - a
        -             b
        """
        after2 = """
        # hello world

        ```julia
        begin
          body
        end
        ```

          - a
          -             b
        """
        # ├─ .JuliaFormatter.toml (config2)
        # └─ file.md (before -> after2)
        mktempdir() do dir
            md_path = joinpath(dir, "file.md")
            write(joinpath(dir, CONFIG_FILE_NAME), config2)
            write(md_path, before)

            @test format(md_path) == false
            @test read(md_path, String) == after2
        end
    end

    @testset "jmd formatting" begin
        config2 = """
        indent = 2
        format_markdown = true
        """

        before = """
        ---
        title: Test file
        author: JuliaFormatter
        ---

        # hello world

        ```julia
        begin body end
        ```
        - a
        -             b
        """
        after2 = """
        ---
        title: Test file
        author: JuliaFormatter
        ---

        # hello world

        ```julia
        begin
          body
        end
        ```

          - a
          -             b
        """
        # ├─ .JuliaFormatter.toml (config2)
        # └─ file.jmd (before -> after2)
        mktempdir() do dir
            md_path = joinpath(dir, "file.jmd")
            write(joinpath(dir, CONFIG_FILE_NAME), config2)
            write(md_path, before)

            @test format(md_path) == false
            @test read(md_path, String) == after2
        end
    end

    @testset "qmd formatting" begin
        config2 = """
        indent = 2
        format_markdown = true
        """

        before = """
        ---
        title: Test file
        author: JuliaFormatter
        ---

        # hello world

        ```{julia}
        begin body end
        ```
        - a
        -             b
        """
        after2 = """
        ---
        title: Test file
        author: JuliaFormatter
        ---

        # hello world

        ```{julia}
        begin
          body
        end
        ```

          - a
          -             b
        """
        # ├─ .JuliaFormatter.toml (config2)
        # └─ file.qmd (before -> after2)
        mktempdir() do dir
            md_path = joinpath(dir, "file.qmd")
            write(joinpath(dir, CONFIG_FILE_NAME), config2)
            write(md_path, before)

            @test format(md_path) == false
            @test read(md_path, String) == after2
        end
    end

    @testset "trailing_comma = nothing" begin
        config_trailing_comma_nothing = """
        trailing_comma = "nothing"
        """

        code_trailing_comma = """
        const A_SET_OF_SYMBOLS_WITH_TRAILING_COMMA = Set([
            :accesses, :allowedtypes, :connector, :digits, :equals, :expand,
            :ignores, :sigdigits, :sort, :val_to_string,
        ])
        const A_SET_OF_SYMBOLS_WITHOUT_TRAILING_COMMA = Set([
            :accesses, :allowedtypes, :connector, :digits, :equals, :expand,
            :ignores, :sigdigits, :sort, :val_to_string
        ])
        """
        code_trailing_comma_after = """
        const A_SET_OF_SYMBOLS_WITH_TRAILING_COMMA = Set([
            :accesses,
            :allowedtypes,
            :connector,
            :digits,
            :equals,
            :expand,
            :ignores,
            :sigdigits,
            :sort,
            :val_to_string,
        ])
        const A_SET_OF_SYMBOLS_WITHOUT_TRAILING_COMMA = Set([
            :accesses,
            :allowedtypes,
            :connector,
            :digits,
            :equals,
            :expand,
            :ignores,
            :sigdigits,
            :sort,
            :val_to_string
        ])
        """
        # ├─ .JuliaFormatter.toml (config_trailing_comma_nothing)
        # └─ code.jl (code_trailing_comma -> code_trailing_comma_after)
        mktempdir() do dir
            code_path = joinpath(dir, "code.jl")
            write(joinpath(dir, CONFIG_FILE_NAME), config_trailing_comma_nothing)
            write(code_path, code_trailing_comma)

            @test format(code_path) == false
            @test read(code_path, String) == code_trailing_comma_after
        end
    end

    @testset "always_for_in = nothing" begin
        config_always_for_in_nothing = """
        always_for_in = "nothing"
        """
        code_always_for_in = """
        for i in 1:10
                for j = 1:10
            end
        end
        """
        code_always_for_in_after = """
        for i in 1:10
            for j = 1:10
            end
        end
        """

        # ├─ .JuliaFormatter.toml (always_for_in_nothing)
        # └─ code.jl (code_always_for_in -> code_always_for_in_after)
        mktempdir() do dir
            code_path = joinpath(dir, "code.jl")
            write(joinpath(dir, CONFIG_FILE_NAME), config_always_for_in_nothing)
            write(code_path, code_always_for_in)

            @test format(code_path) == false
            @test read(code_path, String) == code_always_for_in_after
        end
    end

    @testset "ignore" begin
        # Root config ignores "b.*" and "ignored_directory".
        # third_directory has its own config that ignores "a.jl".
        #
        # ├─ .JuliaFormatter.toml          ignore = ["b.*", "ignored_directory"]
        # ├─ a.jl                          formatted
        # ├─ b.jl                          ignored (b.*)
        # ├─ ignored_directory/
        # │  └─ a.jl                       ignored (ignored_directory)
        # ├─ other_directory/
        # │  ├─ a.jl                       formatted
        # │  ├─ directory/
        # │  │  ├─ a.jl                    formatted
        # │  │  └─ b.jl                    ignored (b.*)
        # │  └─ ignored_directory/
        # │     └─ a.jl                    ignored (ignored_directory)
        # └─ third_directory/
        #    ├─ .JuliaFormatter.toml       ignore = ["a.jl"]
        #    ├─ a.jl                       ignored (a.jl)
        #    ├─ b.jl                       formatted (third_directory config has no b.*)
        #    └─ ignored_directory/
        #       ├─ a.jl                    ignored (a.jl)
        #       └─ b.jl                    formatted
        unformatted = "( )"
        mktempdir() do dir
            # Helper to write a file, creating parent directories as needed
            function writefile(path, content)
                mkpath(dirname(joinpath(dir, path)))
                write(joinpath(dir, path), content)
            end

            # Write configs
            writefile(CONFIG_FILE_NAME, """ignore = ["b.*", "ignored_directory"]\n""")
            writefile("third_directory/$CONFIG_FILE_NAME", """ignore = ["a.jl"]\n""")

            # Write unformatted code to all .jl files
            files_to_be_ignored = [
                "b.jl",
                "ignored_directory/a.jl",
                "other_directory/ignored_directory/a.jl",
                "other_directory/directory/b.jl",
                "third_directory/a.jl",
                "third_directory/ignored_directory/a.jl",
            ]
            files_to_be_formatted = [
                "a.jl",
                "other_directory/a.jl",
                "other_directory/directory/a.jl",
                "third_directory/b.jl",
                "third_directory/ignored_directory/b.jl",
            ]
            for file in (files_to_be_ignored..., files_to_be_formatted...)
                writefile(file, unformatted)
            end

            @test format(dir) == false
            @test format(dir) == true
            for file in files_to_be_ignored
                @test readchomp(joinpath(dir, file)) == unformatted
            end
            for file in files_to_be_formatted
                @test readchomp(joinpath(dir, file)) == format_text(unformatted)
            end
        end
    end
end

end

function n_tuple!(
    bs::BlueStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    style = getstyle(bs)
    line_margin = s.line_offset + length(fst) + fst.extra_margin
    nodes = fst.nodes::Vector
    lidx = findlast(n -> n.typ === PLACEHOLDER, nodes)
    fidx = findfirst(n -> n.typ === PLACEHOLDER, nodes)
    multiline_arg = findfirst(is_block, nodes) !== nothing
    indent = fst.indent
    if multiline_arg
        fst.nest_behavior = AlwaysNest
    end
    has_closer = is_closer(fst[end])
    nested = false

    # "foo(a, b, c)" is true if "foo" and "c" are on different lines
    src_diff_line = if s.opts.join_lines_based_on_source && length(nodes) > 1
        last_arg_idx = findlast(is_iterable_arg, nodes)
        last_arg = last_arg_idx === nothing ? fst[end] : fst[last_arg_idx]
        fst[1].endline != last_arg.startline
    else
        false
    end

    if has_closer
        fst[end].indent = fst.indent
    end
    if !(fst.typ in (TupleN, CartesianIterator, Parameters)) || has_closer
        fst.indent += s.opts.indent
    end

    if !isnothing(lidx) && (line_margin > s.opts.margin || must_nest(fst) || src_diff_line)
        fidx = fidx::Int
        args_range = (fidx+1):(lidx-1)
        args_margin = sum(length.(fst[args_range]))
        nested = true

        nest_to_oneline =
        # Vcat/Ncat types set AlwaysNest in default/pretty's `p_vcat` when the source is
        # multi-line. We have to disable nest_to_oneline for these because if it gets
        # nested to oneline (i.e., `[\n1;2;3;4\n]`), the next pass through p_vcat will
        # set AlwaysNest, which then causes nest_to_oneline to be disabled when we hit
        # this function again, causing the output to be reformatted to
        # `[\n1;\n2;\n3;\n4\n]`...... oh well.
            if fst.typ in (Vcat, TypedVcat, Ncat, TypedNcat)
                false
            elseif can_nest(fst) && (indent + s.opts.indent + args_margin <= s.opts.margin)
                !contains_comment(nodes[args_range])
            else
                false
            end

        args_diff_line = if src_diff_line
            # first arg
            first_arg_idx =
                if fst.typ in (TupleN, CartesianIterator, Parameters) && !has_closer
                    1
                elseif is_opener(fst[1])
                    # (...)
                    findfirst(is_iterable_arg, nodes)
                else
                    # f(...)
                    findnext(is_iterable_arg, nodes, 2)
                end
            first_arg = first_arg_idx === nothing ? fst[1] : fst[first_arg_idx]
            # last arg
            last_arg_idx = findlast(is_iterable_arg, nodes)
            last_arg = last_arg_idx === nothing ? fst[end] : fst[last_arg_idx]

            first_arg.endline != last_arg.startline
        else
            false
        end

        add_trailing_comma =
            (src_diff_line && args_diff_line) || (!src_diff_line && !nest_to_oneline)

        for (i, n) in enumerate(nodes)
            if n.typ === NEWLINE
                s.line_offset = fst.indent
            elseif (i == fidx || i == lidx) && !src_diff_line && nest_to_oneline
                fst[i] = Newline(; length = n.len)
                s.line_offset = fst.indent
            elseif n.typ === PLACEHOLDER
                if src_diff_line
                    si = findnext(
                        n -> n.typ === PLACEHOLDER || n.typ === NEWLINE,
                        nodes,
                        i + 1,
                    )
                    nested2 = nest_if_over_margin!(style, fst, s, i, lineage; stop_idx = si)
                    if has_closer && !nested2 && n.startline == fst[end].startline
                        # trailing types are automatically converted, undo this if
                        # there is no nest and the closer is on the same in the
                        # original source.
                        if fst[i-1].typ === TRAILINGCOMMA
                            fst[i-1].val = ""
                            fst[i-1].len = 0
                        end
                    end
                elseif !nest_to_oneline
                    fst[i] = Newline(; length = n.len)
                    s.line_offset = fst.indent
                else
                    nest!(style, n, s, lineage)
                end
            elseif n.typ === TRAILINGCOMMA
                if add_trailing_comma ||
                   nodes[i-1].typ === OPERATOR && op_kind(nodes[i-1]) === K":"
                    # if add_trailing_comma  || nodes[i-1].typ === OPERATOR && nodes[i-1].val == ":"
                    n.val = ","
                    n.len = 1
                end
                nest!(style, n, s, lineage)
            elseif has_closer && (i == 1 || i == length(nodes))
                nest!(style, n, s, lineage)
            else
                diff = fst.indent - fst[i].indent
                add_indent!(n, s, diff)
                n.extra_margin =
                    !nest_to_oneline ? 1 : i < length(nodes) ? length(fst[i+1]) : 0
                nest!(style, n, s, lineage)
            end
        end

        if has_closer
            s.line_offset = fst[end].indent + 1
        end

    else
        extra_margin = fst.extra_margin
        if has_closer
            (extra_margin += 1)
        else
            false
        end
        nested |= nest!(style, nodes, s, fst.indent, lineage; extra_margin = extra_margin)
    end
    return nested
end
function n_call!(
    bs::BlueStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(bs, fst, s, lineage)
end
function n_curly!(
    bs::BlueStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(bs, fst, s, lineage)
end
function n_macrocall!(
    bs::BlueStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(bs, fst, s, lineage)
end
function n_ref!(
    bs::BlueStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(bs, fst, s, lineage)
end
function n_braces!(
    bs::BlueStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(bs, fst, s, lineage)
end
function n_vect!(
    bs::BlueStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(bs, fst, s, lineage)
end
function n_parameters!(
    bs::BlueStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(bs, fst, s, lineage)
end
function n_parens!(
    bs::BlueStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(bs, fst, s, lineage)
end
function n_bracescat!(
    bs::BlueStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(bs, fst, s, lineage)
end
function n_cartesian_iterator!(
    bs::BlueStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(bs, fst, s, lineage)
end

function n_binaryopcall!(
    bs::BlueStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    style = getstyle(bs)
    if length(lineage) > 1 && lineage[end-1][1] in (If, MacroCall, MacroBlock)
        n_binaryopcall!(
            YASStyle(style),
            fst,
            s,
            lineage;
            indent = fst.indent + s.opts.indent,
        )
    else
        n_binaryopcall!(YASStyle(style), fst, s, lineage)
    end
end

function n_chainopcall!(
    bs::BlueStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    style = getstyle(bs)
    if length(lineage) > 1 && lineage[end-1][1] in (If, MacroCall, MacroBlock)
        n_block!(YASStyle(style), fst, s, lineage; indent = fst.indent + s.opts.indent)
    else
        n_block!(DefaultStyle(style), fst, s, lineage; indent = s.line_offset)
    end
end

function n_comparison!(
    bs::BlueStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_chainopcall!(bs, fst, s, lineage)
end

module IndentChainsTests

using JuliaFormatter: BlueStyle, MinimalStyle, YASStyle
using JuliaFormatter.Internal: test_format
using Test

@testset "indent_binary_continuations" begin
    # `join_lines_based_on_source` keeps the line breaks of the input, so the chains below
    # stay nested and we can observe how the continuation lines are indented.
    @testset "disabled (default)" begin
        # continuation lines are aligned to the column the expression starts at, and a
        # top-level chain gets no indentation at all
        test_format(
            "aaa |>\nbbb |>\nccc\n",
            "aaa |>\nbbb |>\nccc\n";
            join_lines_based_on_source=true,
            ast=true,
        )
        test_format(
            "x = (aaa |>\n     bbb)\n",
            "x = (aaa |>\n     bbb)\n";
            join_lines_based_on_source=true,
            ast=true,
        )
        test_format(
            "function g()\n    return aaa |>\n           bbb\nend\n",
            "function g()\n    return aaa |>\n           bbb\nend\n";
            join_lines_based_on_source=true,
            ast=true,
        )
        test_format(
            "x = aaaaaaaa == bbbbbbbbb == cccccccc\n",
            "x =\n    aaaaaaaa ==\n    bbbbbbbbb ==\n    cccccccc\n";
            margin=20,
            ast=true,
        )
        test_format(
            "x = aaaaaaaa == bbbbbbbbb == cccccccc\n",
            "x = aaaaaaaa ==\n    bbbbbbbbb ==\n    cccccccc\n",
            YASStyle();
            margin=20,
            ast=true,
        )
    end

    @testset "enabled" begin
        # each continuation line receives one indent level relative to the statement
        test_format(
            "aaa |>\nbbb\n",
            "aaa |>\n    bbb\n";
            indent_binary_continuations=true,
            join_lines_based_on_source=true,
            ast=true,
        )
        test_format(
            "aaa |>\nbbb |>\nccc\n",
            "aaa |>\n    bbb |>\n    ccc\n";
            indent_binary_continuations=true,
            join_lines_based_on_source=true,
            ast=true,
        )
        # aligned input converges to the indented form
        test_format(
            "f() = aaa |>\n      bbb |>\n      ccc\n",
            "f() = aaa |>\n    bbb |>\n    ccc\n";
            indent_binary_continuations=true,
            join_lines_based_on_source=true,
            ast=true,
        )
        test_format(
            "x = (aaa |>\n     bbb)\n",
            "x = (aaa |>\n    bbb)\n";
            indent_binary_continuations=true,
            join_lines_based_on_source=true,
            ast=true,
        )
        # inside a function body the extra indent is relative to the statement
        test_format(
            "function g()\n    return aaa |>\n           bbb\nend\n",
            "function g()\n    return aaa |>\n        bbb\nend\n";
            indent_binary_continuations=true,
            join_lines_based_on_source=true,
            ast=true,
        )
        # comparisons in an if condition
        test_format(
            "if aaa ==\n   bbb\n    x\nend\n",
            "if aaa ==\n    bbb\n    x\nend\n";
            indent_binary_continuations=true,
            join_lines_based_on_source=true,
            ast=true,
        )
        # nested chains each get one extra level
        test_format(
            "x = aaa(bbb |>\nccc) |>\nddd\n",
            "x = aaa(bbb |>\n    ccc) |>\n    ddd\n";
            indent_binary_continuations=true,
            join_lines_based_on_source=true,
            ast=true,
        )
        # the option also applies when nesting is driven by the margin rather than by the
        # line breaks of the source. Here the comparison itself is already on an indented
        # line (the RHS of the assignment), so its continuations get one level on top.
        test_format(
            "x = aaaaaaaa == bbbbbbbbb == cccccccc\n",
            "x =\n    aaaaaaaa ==\n        bbbbbbbbb ==\n        cccccccc\n";
            indent_binary_continuations=true,
            margin=20,
            ast=true,
        )
    end

    @testset "standalone short-circuit chains" begin
        # `n_block!` already indents these by one level; the option must not double it
        for indent_binary_continuations in (false, true)
            test_format(
                "aa &&\nbb\n",
                "aa &&\n    bb\n";
                indent_binary_continuations,
                join_lines_based_on_source=true,
                ast=true,
            )
            test_format(
                "aa &&\nbb &&\ncc\n",
                "aa &&\n    bb &&\n    cc\n";
                indent_binary_continuations,
                join_lines_based_on_source=true,
                ast=true,
            )
            test_format(
                "f(aa &&\nbb)\n",
                "f(aa &&\n    bb)\n";
                indent_binary_continuations,
                join_lines_based_on_source=true,
                ast=true,
            )
        end
    end

    @testset "MinimalStyle enables it by default" begin
        test_format("aaa |>\nbbb\n", "aaa |>\n    bbb\n", MinimalStyle(); ast=true)
        test_format(
            "x = (aaa |>\n     bbb)\n",
            "x = (aaa |>\n    bbb)\n",
            MinimalStyle();
            ast=true,
        )
        test_format(
            "if aaa ==\n   bbb\n    x\nend\n",
            "if aaa ==\n    bbb\n    x\nend\n",
            MinimalStyle();
            ast=true,
        )
        # opting back out restores the aligned layout
        test_format(
            "x = (aaa |>\n     bbb)\n",
            "x = (aaa |>\n     bbb)\n",
            MinimalStyle();
            indent_binary_continuations=false,
            ast=true,
        )
    end

    @testset "BlueStyle" begin
        test_format(
            "x = (aaa +\n     bbb +\n     ccc)\n",
            "x = (aaa +\n     bbb +\n     ccc)\n",
            BlueStyle();
            join_lines_based_on_source=true,
            ast=true,
        )
        test_format(
            "x = (aaa +\n     bbb +\n     ccc)\n",
            "x = (aaa +\n    bbb +\n    ccc)\n",
            BlueStyle();
            indent_binary_continuations=true,
            join_lines_based_on_source=true,
            ast=true,
        )
    end
end

end # module

module BlueTests

using JuliaFormatter.Internal: test_format
using Test
using JuliaFormatter: BlueStyle

@testset "Blue Style" begin
    @testset "nest to one line" begin
        str_ = """
        var = [arg1, #com
        arg2]
        """
        str = """
        var = [
            arg1, #com
            arg2,
        ]
        """
        test_format(str_, str, BlueStyle())

        str_ = """
        var = (arg1,
        arg2)
        """
        str = """
        var = (arg1, arg2)
        """
        test_format(str_, str, BlueStyle(); indent=4, margin=18)

        str_ = """
        var = {arg1,
        arg2}
        """
        str = """
        var = {
            arg1, arg2
        }
        """
        test_format(str_, str, BlueStyle(); indent=4, margin=17)
        test_format(str_, str, BlueStyle(); indent=4, margin=14)

        str_ = """
        var = call(arg1,
        arg2)
        """
        str = """
        var = call(
            arg1, arg2
        )
        """
        test_format(str_, str, BlueStyle(); indent=4, margin=14)

        str = """
        var = call(
            arg1,
            arg2,
        )
        """
        test_format(str_, str, BlueStyle(); indent=4, margin=13)

        str_ = """
        var = ref[arg1,
        arg2]
        """
        str = """
        var = ref[
            arg1, arg2
        ]
        """
        test_format(str_, str, BlueStyle(); indent=4, margin=14)

        str = """
        var = ref[
            arg1,
            arg2,
        ]
        """
        test_format(str_, str, BlueStyle(); indent=4, margin=13)

        str_ = """
        var = ABC{arg1,
        arg2}
        """
        str = """
        var = ABC{
            arg1,arg2
        }
        """
        test_format(str_, str, BlueStyle(); indent=4, margin=13)

        str = """
        var = ABC{
            arg1,
            arg2,
        }
        """
        test_format(str_, str, BlueStyle(); indent=4, margin=12)

        str_ = """
        var = @call(arg1,
        arg2)
        """
        str = """
        var = @call(
            arg1, arg2
        )
        """
        test_format(str_, str, BlueStyle(); indent=4, margin=14)

        str = """
        var = @call(
            arg1,
            arg2
        )
        """
        test_format(str_, str, BlueStyle(); indent=4, margin=13)

        str_ = """
        function long_name_of_function_because_i_am_writing_an_example(
            arg1, arg2, arg3, arg4, arg5, arg6
        )
            # code
        end
        """
        test_format(str_, str_, BlueStyle(); indent=4, margin=38)

        str = """
        function long_name_of_function_because_i_am_writing_an_example(
            arg1,
            arg2,
            arg3,
            arg4,
            arg5,
            arg6,
        )
            # code
        end
        """
        test_format(str_, str, BlueStyle(); indent=4, margin=37)

        str = """
        Dict(
            "options" => join(
                imap(Iterators.filter(keep_option, connection_options)) do (k, v)
                    "-c k=(show_option(v))"
                end,
                " ",
            ),
        )
        """
        test_format(str_, str_, BlueStyle(); indent=4, margin=92)

        str_ = """
        var = foo(
            map(arr) do x
                x * 10
            end, "")
        """
        str = """
        var = foo(
            map(arr) do x
                return x * 10
            end,
            "",
        )
        """
        test_format(str_, str, BlueStyle(); indent=4, margin=92)

        str_ = """
        df[:, :some_column] = [some_big_function_name(blahhh) for (fooooo, blahhh) in my_long_list_of_vars]
        """
        str = """
        df[:, :some_column] = [
            some_big_function_name(blahhh) for (fooooo, blahhh) in my_long_list_of_vars
        ]
        """
        test_format(str_, str, BlueStyle(); indent=4, margin=92)

        str_ = """
        function f()
            for i = 1:n
         @inbounds mul!(
             reshape(view(C, :, i), eye_n, k),
             reshape(view(B, :, i), eye_n, l),
             transpose(A, B),
         )
            end
        end
        """
        str = """
        function f()
            for i in 1:n
                @inbounds mul!(
                    reshape(view(C, :, i), eye_n, k), reshape(view(B, :, i), eye_n, l), transpose(A, B)
                )
            end
        end
        """
        test_format(str_, str, BlueStyle(); indent=4, margin=95)

        str = """
        function f()
            for i in 1:n
                @inbounds mul!(
                    reshape(view(C, :, i), eye_n, k),
                    reshape(view(B, :, i), eye_n, l),
                    transpose(A, B),
                )
            end
        end
        """
        test_format(str_, str, BlueStyle(); indent=4, margin=94)

        str = """
        function f()
            for i in 1:n
                @inbounds mul!(
                    reshape(
                        view(
                            C, :, i
                        ),
                        eye_n,
                        k,
                    ),
                    reshape(
                        view(
                            B, :, i
                        ),
                        eye_n,
                        l,
                    ),
                    transpose(A, B),
                )
            end
        end
        """
        test_format(str_, str, BlueStyle(); indent=4, margin=28)

        str = """
        function f()
            for i in 1:n
                @inbounds mul!(
                    reshape(
                        view(
                            C, :, i
                        ),
                        eye_n,
                        k,
                    ),
                    reshape(
                        view(
                            B, :, i
                        ),
                        eye_n,
                        l,
                    ),
                    transpose(
                        A, B
                    ),
                )
            end
        end
        """
        test_format(str_, str, BlueStyle(); indent=4, margin=27)
    end

    @testset "do not nest assignments if the RHS is iterable" begin
        str_ = """
        var = foo(
            map(arr) do x
                x * 10
            end, "")
        """
        str = """
        var = foo(
            map(
                arr,
            ) do x
                return x *
                       10
            end,
            "",
        )
        """
        test_format(str_, str, BlueStyle(); indent=4, margin=1)
    end

    @testset "no chained ternary allowed !!!" begin
        str = """
        E1 ? A : B
        """
        test_format(str, str, BlueStyle())

        str_ = """
        E1 ? A : E2 ? B : C
        """
        str = """
        if E1
            A
        elseif E2
            B
        else
            C
        end
        """
        test_format(str_, str, BlueStyle())
    end

    @testset "has always_use_return=true" begin
        str_ = """
        function foo()
            x
        end
        """
        str = """
        function foo()
            return x
        end
        """
        test_format(str_, str, BlueStyle())
    end

    @testset "use `return nothing` instead of `return`" begin
        str_ = """
        function foo()
            return
        end
        """
        str = """
        function foo()
            return nothing
        end
        """
        test_format(str_, str, BlueStyle())

        str_ = "a || return"
        str = "a || return nothing"
        test_format(str_, str, BlueStyle())
    end

    @testset "weird line removal case" begin
        str = raw"""
        const FASTABLE_AST = quote
            @testset "Unary complex functions" begin
                for f in (abs, abs2, conj), z in (-4.1 - 0.02im, 6.4, 3 + im)
                    @testset "Unary complex functions f = $f, z = $z" begin
                        complex_jacobian_test(f, z)
                    end
                end
                # As per PR #196, angle gives a ZeroTangent() pullback for Real z and ΔΩ, rather than
                # the one you'd get from considering the reals as embedded in the complex plane
                # so we need to special case it's tests
                for z in (-4.1 - 0.02im, 6.4 + 0im, 3 + im)
                    complex_jacobian_test(angle, z)
                end
                @test frule((ZeroTangent(), randn()), angle, randn())[2] === ZeroTangent()
                @test rrule(angle, randn())[2](randn())[2] === ZeroTangent()
            end

            @testset "Unary functions" begin
                for x in (-4.1, 6.4, 0.0, 0.0 + 0.0im, 0.5 + 0.25im)
                    test_scalar(+, x)
                    test_scalar(-, x)
                    test_scalar(atan, x)
                end
            end

            @testset "binary functions" begin
                @testset "$f(x, y)" for f in (atan, rem, max, min)
                    # be careful not to sample near singularities for `rem`
                    base = rand() + 1
                    test_frule(f, (rand(0:10) + 0.6rand() + 0.2) * base, base)
                    base = rand() + 1
                    test_rrule(f, (rand(0:10) + 0.6rand() + 0.2) * base, base)
                end

                @testset "$f(x::$T, y::$T)" for f in (/, +, -, hypot), T in (Float64, ComplexF64)
                    test_frule(f, 10rand(T), rand(T))
                    test_rrule(f, 10rand(T), rand(T))
                end
            end
        end
        """
        test_format(str, str, BlueStyle())
    end
end

end

module AnnotateUntypedFieldsWithAnyTests

using JuliaFormatter.Internal: test_format, ALL_STYLES
using Test

@testset "annotate_untyped_fields_with_any" begin
    @testset "basic" begin
        strtrue = """
        struct name
            arg::Any
        end"""
        strfalse = """
        struct name
            arg
        end"""
        for str_ in (
            "struct name\n    arg\nend",
            "struct name\narg\nend",
            "struct name\n        arg\n    end",
        )
            for style in ALL_STYLES
                test_format(str_, strtrue; annotate_untyped_fields_with_any=true)
                test_format(str_, strfalse; annotate_untyped_fields_with_any=false)
            end
        end
    end

    @testset "not in macros/exprs" begin
        str1 = """
        @macro struct name
            arg
        end"""
        str2 = """
        :(struct name
            arg
        end)"""
        str3 = """
        quote
            struct name
                arg
            end
        end"""

        for str in (str1, str2, str3)
            for style in ALL_STYLES
                test_format(str, str; annotate_untyped_fields_with_any=true)
                test_format(str, str; annotate_untyped_fields_with_any=false)
            end
        end
    end
end

end # module

function format_check(io::IOBuffer, fst::FST, s::State)
    # TODO(penelopeysm) This function is REALLY confusing! The logic really needs to be
    # simplified......

    # `fst.typ` must be NOTCODE -- this means that any text in `fst.startline:fst.endline`
    # doesn't need to be formatted and can just be printed verbatim.
    if fst.typ !== NOTCODE
        error("format_check called with node of type $(fst.typ)")
    end

    # Happy path -- no skipped ranges. Just an ordinary comment and/or blank lines.
    if length(s.doc.format_skips) == 0
        print_notcode(io, fst, s)
        return
    end

    # Some skipped ranges. Check to see if the current lines we're printing overlap with it.
    line_range = (fst.startline):(fst.endline)
    skip = s.doc.format_skips[1]
    nlines = numlines(s.doc)

    if s.on &&
       skip.startline in line_range &&
       (skip.endline in line_range || skip.endline == nlines)
        # Either the skip is fully contained within the range of lines we're printing
        # (skip.endline in line_range). In which case we print all the text up to
        # the `#! format: on` tag.
        #
        # Or the skip is at the end of the file (skip.endline == nlines) in which case
        # we just print everything from the current node to the end.

        # Dump the text prior to the #! format: off tag.
        l1 = fst.startline
        l2 = skip.startline - 1
        if l1 <= l2
            r1 = linerange(s, l1)
            r2 = linerange(s, l2)
            write(io, JuliaSyntax.sourcetext(s.doc.srcfile)[first(r1):last(r2)])
        end

        output = JuliaSyntax.sourcetext(s.doc.srcfile)[(skip.startoffset):(skip.endoffset)]
        l1 = skip.endline + 1
        l2 = fst.endline

        if l1 <= l2
            # In this branch, there's more stuff in this NOTCODE node after the #! format:
            # on tag.

            # Dump the text from the #! format: off tag to the #! format: on tag.
            write(io, output)

            # Then anything after the #! format: on tag.
            r1 = linerange(s, l1)
            r2 = linerange(s, l2)
            output = JuliaSyntax.sourcetext(s.doc.srcfile)[first(r1):last(r2)]
            if l1 <= nlines && output[end] == '\n'
                output = output[1:prevind(output, end)]
            end
            write(io, output)
        else
            # In this branch, either the #! format: on tag is at the end of the file, or the
            # #! format: on tag is the last line of this NOTCODE node. In either case, we
            # just need to print the text from the #! format: off tag to the #! format: on
            # tag.
            if l1 <= nlines && output[end] == '\n'
                output = output[1:prevind(output, end)]
            end
            write(io, output)
        end

        # If the skip goes to the end of the file, we disable output, otherwise later on
        # format_text() will end up printing the formatted version of the text. All the
        # output we care about has already been generated above.
        if nlines == skip.endline
            popfirst!(s.doc.format_skips)
            s.on = false
        end
    elseif s.on && skip.startline in line_range
        # Formatting disabled midway through the range of lines. Essentially, this covers
        # the case where formatting is being disabled.

        # Print all text up until, but NOT including, the #! format: off tag.
        l1 = fst.startline       # The start of the NOTCODE node we're looking at.
        l2 = skip.startline - 1  # The line before the #! format: off tag.
        if l1 <= l2
            r1 = linerange(s, l1)
            r2 = linerange(s, l2)
            write(io, JuliaSyntax.sourcetext(s.doc.srcfile)[first(r1):last(r2)])
        end
        # Disable printing of formatted output. Later on, when we hit #! format: on, we'll
        # dump the verbatim source text.
        s.on = false
    elseif !s.on && skip.endline in line_range
        # Formatting enabled midway through the range of lines. Essentially, this covers the
        # case where formatting is being re-enabled.

        # The verbatim source text for the range of lines that are skipped (which may
        # include lines prior to line_range). This includes both the `#! format: off` and
        # `#! format: on` tags.
        output = JuliaSyntax.sourcetext(s.doc.srcfile)[(skip.startoffset):(skip.endoffset)]

        l1 = skip.endline + 1  # The line after the #! format: on tag.
        l2 = fst.endline       # The end of the NOTCODE node we're looking at.

        if l1 <= l2
            # This branch covers the case where there's more text in this NOTCODE node after
            # the #! format: on tag.

            # Verbatim source text from the #! format: off tag to the #! format: on tag.
            write(io, output)

            # Then anything after the #! format: on tag.
            r1 = linerange(s, l1)
            r2 = linerange(s, l2)
            output = JuliaSyntax.sourcetext(s.doc.srcfile)[first(r1):last(r2)]
            if l1 <= nlines && output[end] == '\n'
                output = output[1:prevind(output, end)]
            end
            write(io, output)
        else
            # Just the verbatim source text from the #! format: off tag to the #! format: on
            # tag.
            if l1 <= nlines && output[end] == '\n'
                output = output[1:prevind(output, end)]
            end
            write(io, output)
        end
        # We're done with this skip.
        popfirst!(s.doc.format_skips)
        # Re-enable printing of formatted output.
        s.on = true
    else
        # There are skipped ranges, but not part of this NOTCODE node.
        print_notcode(io, fst, s)
    end
end

function print_leaf(io::IOBuffer, fst::FST, s::State)
    if fst.typ === NOTCODE
        format_check(io, fst, s)
    elseif fst.typ === INLINECOMMENT
        print_inlinecomment(io, fst, s)
    else
        if s.on
            write(io, fst.val)
        end
    end
    s.line_offset += length(fst)
end

function print_tree(io::IOBuffer, fst::FST, s::State)
    notcode_indent = -1
    if (fst.typ === Binary || fst.typ === Conditional || fst.typ === ModuleN)
        notcode_indent = fst.indent
    end
    print_tree(io, fst.nodes::Vector{FST}, s, fst.indent; notcode_indent = notcode_indent)
end

function print_tree(
    io::IOBuffer,
    nodes::Vector{FST},
    s::State,
    indent::Int;
    notcode_indent = -1,
)
    ws = repeat(" ", max(indent, 0))
    for (i, n) in enumerate(nodes)
        if n.typ === NOTCODE
            noindent = has_noindent_block(s.doc, (n.startline, n.endline))
            if notcode_indent > -1
                n.indent = notcode_indent
            elseif i + 1 < length(nodes) && is_end(nodes[i+2])
                n.indent += s.opts.indent
            elseif i + 1 < length(nodes) &&
                   (nodes[i+2].typ === Block || nodes[i+2].typ === Begin)
                if noindent
                    add_indent!(nodes[i+2], s, -s.opts.indent)
                    # this captures the trailing comment is not captured as being part of the block
                    if i + 4 <= length(nodes) && nodes[i+4].typ === NOTCODE
                        nodes[i+4].indent -= s.opts.indent
                    end
                else
                    n.indent = nodes[i+2].indent
                end
            elseif i > 2 && (nodes[i-2].typ === Block || nodes[i-2].typ === Begin)
                if noindent
                    add_indent!(nodes[i-2], s, -s.opts.indent)
                else
                    n.indent = nodes[i-2].indent
                end
            end

            if noindent
                n.indent -= s.opts.indent
            end
        end

        if is_leaf(n)
            print_leaf(io, n, s)
        elseif n.typ === StringN
            print_string(io, n, s)
        else
            print_tree(io, n, s)
        end

        if n.typ === NEWLINE && s.on && i < length(nodes)
            next_node = nodes[i+1]
            if is_closer(next_node) || next_node.typ === Block || next_node.typ === Begin
                if s.on
                    write(io, repeat(" ", max(next_node.indent, 0)))
                end
                s.line_offset = next_node.indent
            elseif !skip_indent(next_node)
                if s.on
                    write(io, ws)
                end
                s.line_offset = indent
            end
        end
    end
end

function print_string(io::IOBuffer, fst::FST, s::State)
    # The indent of StringH is set to the the offset
    # of when the quote is first encountered in the source file.

    if is_opaque_string(fst)
        # Interior lines of non-triple-quoted multiline literals (e.g. a regular "..."
        # string spanning several lines) are stored verbatim, including their original
        # leading whitespace, and must be printed at column 0 so the string's value is
        # unchanged. Only the line containing the opening delimiter moves with the
        # surrounding code. See issue #1251.
        fst.indent = 0
    else
        # This difference notes the indent change due to formatting.
        diff = s.line_offset - fst.indent

        # The new indent for the string is the index of when a character in
        # the multiline string is FIRST encountered in the source file plus
        # the above difference.
        fst.indent = max(fst[1].indent + diff, 0)
    end
    print_tree(io, fst, s)
end

function print_notcode(io::IOBuffer, fst::FST, s::State)
    if !(s.on)
        return
    end
    for l in (fst.startline):(fst.endline)
        _, v = get(s.doc.comments, l, (0, "\n"))
        ws = fst.indent

        # If the current newline is followed by another newline
        # don't print the current newline.
        if s.opts.remove_extra_newlines
            _, vn = get(s.doc.comments, l + 1, (0, "\n"))
            if vn == "\n" && v == "\n"
                (v = "")
            end
        end

        if v == ""
            continue
        end
        if v == "\n"
            (ws = 0)
        end

        if l == fst.endline && v[end] == '\n'
            v = v[1:prevind(v, end)]
        end

        if ws > 0
            write(io, repeat(" ", ws))
        end
        write(io, v)

        if l != fst.endline && v[end] != '\n'
            write(io, "\n")
        end
    end
end

function print_inlinecomment(io::IOBuffer, fst::FST, s::State)
    if !(s.on)
        return
    end
    ws, v = get(s.doc.comments, fst.startline, (0, ""))
    if isempty(v)
        return
    end
    v = v[end] == '\n' ? v[firstindex(v):prevind(v, end)] : v
    if ws > 0
        write(io, repeat(" ", ws))
    elseif startswith(v, "#=") && endswith(v, "=#")
        # hack to overcome the bug noticed in https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/571#issuecomment-1114446297
        # until multiline comments aren't moved to the end of the line.
        write(io, " ")
    end
    write(io, v)
end

module JuliaFormatter

using PrecompileTools: @setup_workload, @compile_workload
using JuliaSyntax
using JuliaSyntax: children, span, @K_str, kind, @KSet_str
using Glob
import CommonMark: block_modifier
using CommonMark:
    AdmonitionRule,
    CodeBlock,
    enable!,
    FootnoteRule,
    markdown,
    MathRule,
    Parser,
    Rule,
    TableRule,
    FrontMatterRule

# The `using` and `import` statements above are separated from the rest of the package code
# in order to accommodate julia-vscode. See
# https://github.com/JuliaEditorSupport/JuliaFormatter.jl/pull/1249
include("packagedef.jl")

end # module JuliaFormatter

"""
    FormattingError(line, column, original_error)

Error thrown when formatting fails. The `line` and `column` fields indicate the location of
the error in the source code.
"""
struct FormattingError <: Exception
    line::Int
    column::Int
    original_error::Exception
end
function Base.showerror(io::IO, fe::FormattingError)
    print(io, "formatting error at line $(fe.line), column $(fe.column)\n")
end

"""
    InvalidFormattedTextError(msg)

Error thrown when the formatted text is invalid.
"""
struct InvalidFormattedTextError <: Exception
    juliasyntax_error::JuliaSyntax.ParseError
end
function Base.showerror(io::IO, ie::InvalidFormattedTextError)
    print(io, "formatted text could not be parsed as valid Julia\n")
    showerror(io, ie.juliasyntax_error)
end

"""
    InvalidFileError(filename)

Error thrown when the file to be formatted is not a valid Julia or Markdown file.
"""
struct InvalidFileError <: Exception
    filename::AbstractString
end
function Base.showerror(io::IO, e::InvalidFileError)
    print(
        io,
        "\nthe file to be formatted ($(e.filename)) was not a Julia or Markdown file\n",
    )
end

const UNIX_TO_WINDOWS = r"\r?\n" => "\r\n"
const WINDOWS_TO_UNIX = "\r\n" => "\n"
function choose_line_ending_replacer(text)
    rn = count("\r\n", text)
    n = count(r"(?<!\r)\n", text)
    n >= rn ? WINDOWS_TO_UNIX : UNIX_TO_WINDOWS
end
normalize_line_ending(s::AbstractString, replacer = WINDOWS_TO_UNIX) = replace(s, replacer)

"""
    _format_text(
        text::AbstractString, style::AbstractStyle, opts::Options{Union{}};
        check_output::Bool=true,
        maxiters::Int=1,
        ensure_trailing_newline::Bool=false
    )

The lower-level entry point for text formatting.

`check_output` is a boolean flag that indicates whether the output should be checked for
validity. If set to `true`, the function will attempt to parse the formatted text and throw
an `InvalidFormattedTextError` if it is not valid Julia code. If `false` it will just return
the formatted text, which may be invalid!

The `maxiters` keyword argument is specified in order to allow the formatting algorithm to
iterate to a fixed point. This is a hack and should really not be used, but currently
SciMLStyle is not idempotent and requires multiple iterations to reach a fixed point. By
default `maxiters` is set to 1, i.e., only one pass.

If `ensure_trailing_newline` is set to `true`, the function will ensure that the formatted
text ends with a single newline character. This might be either CRLF or LF depending on the
line ending normalization settings. If set to `false`, the function will not modify the
trailing newline character(s) in the formatted text. This option is useful when formatting
files.
"""
function _format_text(
    text::AbstractString,
    style::AbstractStyle,
    opts::Options{Union{}};
    check_output::Bool = true,
    maxiters::Int = opts.max_iterations,
    ensure_trailing_newline::Bool = false,
)
    maxiters <= 0 && return text
    if isempty(text)
        if ensure_trailing_newline
            return opts.normalize_line_endings == "windows" ? "\r\n" : "\n"
        end
        return text
    end

    node = JuliaSyntax.parseall(
        JuliaSyntax.GreenNode,
        text;
        ignore_warnings = true,
        version = SUPPORTED_SYNTAX_VERSION,
    )

    s = State(Document(text), opts)
    fst::FST = try
        pretty(style, node, s)
    catch e
        loc = cursor_loc(s, s.offset)
        throw(FormattingError(loc[1], loc[2], e))
    end
    if hascomment(s.doc, fst.endline)
        add_node!(fst, InlineComment(fst.endline), s)
    end

    flatten_fst!(fst)

    if s.opts.short_circuit_to_if
        short_circuit_to_if_pass!(fst, s)
    end

    if needs_alignment(s.opts)
        align_fst!(fst, s.opts)
    end

    nest!(style, fst, s)

    # ignore maximum width can be extra whitespace at the end of lines
    # remove it all before we print.
    if s.opts.join_lines_based_on_source
        remove_superfluous_whitespace!(fst)
    end

    s.line_offset = 0
    io = IOBuffer()

    # Print comments and whitespace before code.
    if fst.startline > 1
        format_check(io, Notcode(1, fst.startline - 1), s)
        print_leaf(io, Newline(), s)
    end
    print_tree(io, fst, s)
    nlines = numlines(s.doc)
    if fst.endline < nlines
        if s.on
            print_leaf(io, Newline(), s)
        end
        format_check(io, Notcode(fst.endline + 1, nlines), s)
    end
    if s.doc.ends_on_nl
        print_leaf(io, Newline(), s)
    end
    output = String(take!(io))

    replacer = if s.opts.normalize_line_endings == "unix"
        WINDOWS_TO_UNIX
    elseif s.opts.normalize_line_endings == "windows"
        UNIX_TO_WINDOWS
    else
        choose_line_ending_replacer(s.doc.srcfile.code)
    end
    output = normalize_line_ending(output, replacer)

    output = if ensure_trailing_newline
        if replacer == WINDOWS_TO_UNIX
            replace(output, r"\n*$" => "\n")
        else
            replace(output, r"(\r\n)*$" => "\r\n")
        end
    else
        output
    end

    if check_output
        try
            JuliaSyntax.parseall(
                JuliaSyntax.GreenNode,
                output;
                ignore_warnings = true,
                version = SUPPORTED_SYNTAX_VERSION,
            )
        catch err
            if err isa JuliaSyntax.ParseError
                # rethrow() is a bit of bad practice, but
                # otherwise you'll see the failed parse twice.
                rethrow(InvalidFormattedTextError(err))
            else
                rethrow(err)
            end
        end
    end
    return if output == text
        output
    else
        _format_text(
            output,
            style,
            opts;
            check_output = check_output,
            maxiters = maxiters - 1,
        )
    end
end

const FORMATTABLE_EXTENSIONS = (".jl", ".md", ".jmd", ".qmd")
const JULIA_SHEBANG_PATTERN = r"^#!\s*/.*\bjulia[0-9.-]*\b"

"""
    is_formattable_file(filename) -> Bool

Check whether `filename` is a file that JuliaFormatter can format, based on its extension
or the presence of a Julia shebang line (e.g. `#!/usr/bin/env julia`).
"""
function is_formattable_file(filename::AbstractString)::Bool
    isfile(filename) || return false
    _, ext = splitext(filename)
    ext in FORMATTABLE_EXTENSIONS && return true
    return match(JULIA_SHEBANG_PATTERN, readline(filename)) !== nothing
end

function _format_file(filename::AbstractString, config::Configuration)::Bool
    _, ext = splitext(filename)
    merged_options = get_formatting_options(config)

    formatted_str = if ext in (".md", ".jmd", ".qmd")
        config.format_markdown || return true
        config.verbose && println("Formatting $filename")
        str = String(read(filename))
        # Already guarantees trailing newline, although newlines in Markdown are not
        # normalised (that's a CommonMark thing, not JuliaFormatter).
        _format_md(str, config.style, merged_options)
    elseif ext == ".jl" || match(JULIA_SHEBANG_PATTERN, readline(filename)) !== nothing
        config.verbose && println("Formatting $filename")
        str = String(read(filename))
        _format_text(str, config.style, merged_options; ensure_trailing_newline = true)
    else
        throw(InvalidFileError(filename))
    end

    already_formatted = (formatted_str == str)
    if config.overwrite && !already_formatted
        write(filename, formatted_str)
    end
    return already_formatted
end

function options(::SciMLStyle)
    return Options(;
        always_for_in = true,
        always_use_return = false,
        annotate_untyped_fields_with_any = true,
        conditional_to_if = false,
        import_to_using = false,
        join_lines_based_on_source = true,
        normalize_line_endings = "unix",
        pipe_to_function_call = false,
        remove_extra_newlines = true,
        short_to_long_function_def = true,
        long_to_short_function_def = false,
        whitespace_in_kwargs = true,
        whitespace_ops_in_indices = true,
        whitespace_typedefs = true,
        indent = 4,
        margin = 92,
        # Massive hack, should really be disabled
        max_iterations = 4,
        format_docstrings = false,
        align_struct_field = false,
        align_assignment = false,
        align_conditional = false,
        align_pair_arrow = false,
        align_matrix = false,
        trailing_comma = false,
        trailing_zero = true,
        indent_submodule = false,
        separate_kwargs_with_semicolon = false,
        surround_whereop_typeparameters = true,
        variable_call_indent = [],
        yas_style_nesting = false,
        sciml_margin_overrun = 20,
        disallow_single_arg_nesting = true,
    )
end

function is_binaryop_nestable(::SciMLStyle, cst::JuliaSyntax.GreenNode)
    !defines_function(cst) && !is_assignment(cst) && !(op_kind(cst) in KSet"=> -> in")
end

const CST_T = [JuliaSyntax.GreenNode]
const TUPLE_T = [JuliaSyntax.GreenNode, Vector{JuliaSyntax.GreenNode}]
for f in [
    :p_import,
    :p_using,
    :p_export,
    :p_public,
    :p_vcat,
    :p_ncat,
    :p_typedvcat,
    :p_typedncat,
    :p_row,
    :p_nrow,
    :p_hcat,
    :p_comprehension,
    :p_typedcomprehension,
    :p_generator,
    :p_filter,
]
    @eval function $f(
        ss::SciMLStyle,
        cst::JuliaSyntax.GreenNode,
        s::State,
        ctx::PrettyContext,
        lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
    )
        $f(YASStyle(getstyle(ss)), cst, s, ctx, lineage)
    end
end

for f in [
    :p_call,
    :p_curly,
    :p_ref,
    :p_braces,
    # :p_vect, don't use YAS style vector formatting with `yas_style_nesting = true`
    :p_parameters,
    :p_parens,
    :p_bracescat,
]
    @eval function $f(
        ss::SciMLStyle,
        cst::JuliaSyntax.GreenNode,
        s::State,
        ctx::PrettyContext,
        lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
    )
        if s.opts.yas_style_nesting
            $f(YASStyle(getstyle(ss)), cst, s, ctx, lineage)
        else
            $f(DefaultStyle(getstyle(ss)), cst, s, ctx, lineage)
        end
    end
end

function p_tuple(
    ss::SciMLStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    if s.opts.yas_style_nesting
        p_tuple(YASStyle(getstyle(ss)), cst, s, ctx, lineage)
    else
        p_tuple(DefaultStyle(getstyle(ss)), cst, s, ctx, lineage)
    end
end

function p_macrocall(
    ss::SciMLStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(ss)
    t = FST(MacroCall, nspaces(s))
    if !haschildren(cst)
        return t
    end

    childs = children(cst)
    has_closer = is_closer(childs[end])
    is_macroblock = !has_closer

    if is_macroblock
        t.typ = MacroBlock
    end

    idx = findfirst(a -> kind(a) === K"(", childs)
    first_arg_idx =
        idx === nothing ? -1 : findnext(a -> !JuliaSyntax.is_whitespace(a), childs, idx + 1)

    # https://github.com/SciML/SciMLStyle?tab=readme-ov-file#macros
    n_kw_args = count(a -> kind(a) === K"=" && haschildren(a), childs)
    nospace = n_kw_args > 1

    for (i, a) in enumerate(childs)
        n = pretty(style, a, s, newctx(ctx; nospace = nospace), lineage)::FST

        override = (i == first_arg_idx) || kind(a) === K")"

        if JuliaSyntax.is_macro_name(a) || kind(a) === K"("
            add_node!(t, n, s; join_lines = true)
        elseif kind(a) === K","
            add_node!(t, n, s; join_lines = true)
            if has_more_args_to_come(childs, i + 1, K")")
                add_node!(t, Placeholder(1), s)
            end
        elseif JuliaSyntax.is_whitespace(a)
            add_node!(t, n, s; join_lines = true)
        elseif is_macroblock
            if n.typ === MacroBlock && t[end].typ === WHITESPACE
                t[end] = Placeholder(length(t[end].val))
            end

            max_padding = is_block(n) ? 0 : -1
            join_lines = t.endline == n.startline

            if join_lines && (i > 1 && kind(childs[i-1]) in KSet"NewlineWs Whitespace") ||
               next_node_is(nn -> kind(nn) in KSet"NewlineWs Whitespace", childs[i])
                add_node!(t, Whitespace(1), s)
            end
            add_node!(t, n, s; join_lines, max_padding)
        else
            add_node!(
                t,
                n,
                s;
                join_lines = true,
                override_join_lines_based_on_source = override,
            )
        end
    end
    # move placement of @ to the end
    #
    # @Module.macro -> Module.@macro
    t[1] = move_at_sign_to_the_end(t[1], s)
    t
end

function n_call!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    style = getstyle(ys)

    # With `variable_call_indent`, check if the caller is in the list
    if caller_in_list(fst, s.opts.variable_call_indent) &&
       length(fst.nodes::Vector{FST}) > 5
        # Determine whether the call has the form `caller(something,...)` or
        # `caller(\n...)`. There may be a comment or both an inline comment and a comment in
        # a separate line before the first argument, so check for that as well.
        notcode(n) = n.typ === NOTCODE || n.typ === INLINECOMMENT || n.typ === PLACEHOLDER
        # The first three nodes must be the caller, the opening paren, and a placeholder.
        # TODO(penelopeysm): Can we make this cleaner, e.g. checking the source line of the
        # opening paren and the first argument (if it exists)...?
        has_linebreak_after_parens =
            fst[4].typ === NEWLINE ||
            notcode(fst[4]) && fst[5].typ === NEWLINE ||
            notcode(fst[4]) && notcode(fst[5]) && fst[6].typ === NEWLINE

        # If it's the latter, we can defer to DefaultStyle -- no need to align with the
        # opening parenthesis
        if has_linebreak_after_parens
            return n_call!(DefaultStyle(ys), fst, s, lineage)
        end
    end

    function find_next_ph_or_nl(nodes::Vector{FST}, idx::Int)
        while idx < length(nodes)
            n = nodes[idx]
            if n.typ === PLACEHOLDER || n.typ === NEWLINE
                return idx
            elseif n.typ === Parameters
                return find_next_ph_or_nl(n.nodes, 1)
            end
            idx += 1
        end
        return nothing
    end

    nodes = fst.nodes::Vector

    nested = false
    for (i, n) in enumerate(nodes)
        if is_opener(n)
            # The indent is set here to handle the edge
            # case where the first argument of Call is
            # nestable.
            # ref https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/387
            fst.indent = s.line_offset + 1
        end

        if n.typ === NEWLINE
            s.line_offset = fst.indent
        elseif n.typ === PLACEHOLDER
            # si = findnext(find_next_ph_or_nl, nodes, i + 1)
            si = find_next_ph_or_nl(nodes, i + 1)
            nested |= nest_if_over_margin!(style, fst, s, i, lineage; stop_idx = si)
        elseif is_gen(n)
            n.indent = fst.indent
            n.extra_margin = 1
            nested |= nest!(style, n, s, lineage)
        else
            diff = fst.indent - fst[i].indent
            add_indent!(n, s, diff)
            n.extra_margin = 1
            nested |= nest!(style, n, s, lineage)
        end
    end

    # Now that we've performed nesting, we can check if the trailing comma needs to be
    # materialised. Note that by doing this after nesting, we ensure that the length of the
    # comma is not taken into account when calculating whether the (un-nested) line would go
    # over the margin or not.
    trailing_comma_idx = findlast(n -> n.typ === TRAILINGCOMMA, nodes)
    if trailing_comma_idx !== nothing
        for idx in (trailing_comma_idx+1):length(nodes)
            if nodes[idx].typ === NEWLINE
                # The closing paren will be on a new line, so we need to materialise the
                # trailing comma.
                nodes[trailing_comma_idx].val = ","
                nodes[trailing_comma_idx].len = 1
                break
            elseif is_closer(nodes[idx])
                # The closing paren is right after the trailing comma, so no need to
                # materialise it.
                break
            end
        end
    end

    return nested
end

function n_curly!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_call!(ys, fst, s, lineage)
end
function n_ref!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_call!(ys, fst, s, lineage)
end
function n_macrocall!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_call!(ys, fst, s, lineage)
end
function n_typedcomprehension!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_call!(ys, fst, s, lineage)
end
function n_typedvcat!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_call!(ys, fst, s, lineage)
end

function n_tuple!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}};
    indent::Int = -1,
)
    style = getstyle(ys)
    # SciML can opt into YAS nesting, but the tuple-binding margin overrun is
    # still SciML-specific. Plain YASStyle should keep its existing behavior.
    for_tuple_binding_lhs = style isa SciMLStyle && _is_for_tuple_binding_lhs(fst, lineage)
    if for_tuple_binding_lhs
        optimal_placeholders = find_optimal_nest_placeholders(
            fst,
            fst.indent,
            s.opts;
            margin_line_offset = s.line_offset,
            for_tuple_binding_lhs,
        )
        if isempty(optimal_placeholders)
            walk(increment_line_offset!, fst, s)
            return false
        end
    end

    if indent > -1
        fst.indent = indent
    else
        fst.indent = s.line_offset
    end
    nodes = fst.nodes::Vector
    if length(nodes) > 0 && is_opener(fst[1])
        (fst.indent += 1)
    else
        false
    end

    f = n -> n.typ === PLACEHOLDER || n.typ === NEWLINE

    nested = false
    for (i, n) in enumerate(nodes)
        if n.typ === NEWLINE
            s.line_offset = fst.indent
        elseif n.typ === PLACEHOLDER
            si = findnext(f, nodes, i + 1)
            nested |= nest_if_over_margin!(style, fst, s, i, lineage; stop_idx = si)
        elseif is_gen(n)
            n.indent = fst.indent
            n.extra_margin = 1
            nested |= nest!(style, n, s, lineage)
        else
            diff = fst.indent - fst[i].indent
            add_indent!(n, s, diff)
            n.extra_margin = 1
            nested |= nest!(style, n, s, lineage)
        end
    end
    return nested
end
function n_braces!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ys, fst, s, lineage)
end
function n_vect!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ys, fst, s, lineage)
end
function n_parameters!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ys, fst, s, lineage)
end
function n_parens!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ys, fst, s, lineage)
end
function n_comprehension!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ys, fst, s, lineage)
end
function n_vcat!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ys, fst, s, lineage)
end
function n_hcat!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ys, fst, s, lineage)
end
function n_bracescat!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ys, fst, s, lineage)
end
function n_cartesian_iterator!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ys, fst, s, lineage)
end
function n_tupleblock!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ys, fst, s, lineage)
end

function n_generator!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    style = getstyle(ys)
    diff = s.line_offset - fst[1].indent

    # if the first argument is not a leaf
    # aligns it to be inside the generator
    # expression
    add_indent!(fst[1], s, diff)

    nodes = fst.nodes::Vector
    nested = false
    for (i, n) in enumerate(nodes)
        if n.typ === NEWLINE
            s.line_offset = fst.indent
        elseif n.typ === PLACEHOLDER
            si = findnext(n -> n.typ === PLACEHOLDER, nodes, i + 1)
            nested |= nest_if_over_margin!(style, fst, s, i, lineage; stop_idx = si)
        elseif is_gen(n)
            n.indent = fst.indent
            n.extra_margin = 1
            nested |= nest!(style, n, s, lineage)
        else
            n.extra_margin = 1
            nested |= nest!(style, n, s, lineage)
        end
    end
    return nested
end
function n_filter!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_generator!(ys, fst, s, lineage)
end

function n_whereopcall!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    style = getstyle(ys)
    fst.indent = s.line_offset
    # after "A where "
    Blen = sum(length.(fst[2:end]))
    fst[1].extra_margin = Blen + fst.extra_margin

    nodes = fst.nodes::Vector

    nested = false
    for (i, n) in enumerate(nodes)
        if n.typ === NEWLINE
            s.line_offset = fst.indent
        elseif n.typ === PLACEHOLDER
            si = findnext(n -> n.typ === PLACEHOLDER, nodes, i + 1)
            nested |= nest_if_over_margin!(style, fst, s, i, lineage; stop_idx = si)
        elseif is_opener(n) && n.val == "{"
            fst.indent = s.line_offset + 1
            nested |= nest!(style, n, s, lineage)
        elseif i == 1 || i == length(nodes)
            nested |= nest!(style, n, s, lineage)
        else
            n.extra_margin = 1
            nested |= nest!(style, n, s, lineage)
        end
    end
    return nested
end

function n_using!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    style = getstyle(ys)
    nodes = fst.nodes::Vector
    # Determine the indent based on whether there is a `:` in the import / using statement.
    idx = findfirst(n -> n.val == ":", nodes)
    fst.indent = s.line_offset
    if idx === nothing
        # If there isn't, then align to past the `using ` or `import `.
        fst.indent += sum(length, fst[1:2])
    else
        # If there is, then align to past the space after the colon.
        fst.indent += sum(length, fst[1:(idx+1)])
    end
    nested = false
    for (i, n) in enumerate(nodes)
        if n.typ === PLACEHOLDER
            si = findnext(n -> n.typ === PLACEHOLDER, nodes, i + 1)
            nested |= nest_if_over_margin!(style, fst, s, i, lineage; stop_idx = si)
        elseif n.typ === NEWLINE
            s.line_offset = fst.indent
        else
            nested |= nest!(style, n, s, lineage)
        end
    end
    return nested
end

function n_import!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_using!(ys, fst, s, lineage)
end

function n_export!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    style = getstyle(ys)
    nodes = fst.nodes::Vector
    # Always indent to past the `export ` or `public `. Technically this is always
    # seven characters...
    fst.indent = s.line_offset + sum(length, fst[1:2])
    nested = false
    for (i, n) in enumerate(nodes)
        if n.typ === PLACEHOLDER
            si = findnext(n -> n.typ === PLACEHOLDER, nodes, i + 1)
            nested |= nest_if_over_margin!(style, fst, s, i, lineage; stop_idx = si)
        elseif n.typ === NEWLINE
            s.line_offset = fst.indent
        else
            nested |= nest!(style, n, s, lineage)
        end
    end
    return nested
end
function n_public!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_export!(ys, fst, s, lineage)
end

function n_chainopcall!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    style = getstyle(ys)
    n_block!(
        DefaultStyle(style),
        fst,
        s,
        lineage;
        indent = chain_continuation_indent(fst, s),
    )
end

function n_comparison!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    style = getstyle(ys)
    n_block!(
        DefaultStyle(style),
        fst,
        s,
        lineage;
        indent = chain_continuation_indent(fst, s),
    )
end

function n_binaryopcall!(
    ys::YASStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}};
    indent::Int = -1,
)
    style = getstyle(ys)
    nodes = fst.nodes::Vector

    if any(n -> n.typ === PLACEHOLDER, nodes)
        return n_binaryopcall!(DefaultStyle(style), fst, s, lineage; indent = indent)
    end

    nested = false
    for (i, n) in enumerate(nodes)
        if i == length(nodes) || must_nest(n) || any_descendant(must_nest, n)
            nested |= nest!(style, n, s, lineage)
        else
            walk(increment_line_offset!, n, s)
        end
    end
    return nested
end

# This module contains helper functions to run formatting up until a certain point and to
# see the output, as well as some shorthands for test utilities. As the name suggests, these
# are for internal use only, and can break at any time.

module Internal

# Use relative import for JuliaSyntax to avoid importing external package, see
# https://github.com/JuliaEditorSupport/JuliaFormatter.jl/pull/1249
import ..JuliaSyntax as JS
import ..JuliaFormatter as JF
using Test

"""
    JuliaFormatter.Internal.ALL_STYLES

Tuple of Default, YAS, Blue, SciML, and Minimal styles.
"""
const ALL_STYLES =
    (JF.DefaultStyle(), JF.YASStyle(), JF.BlueStyle(), JF.SciMLStyle(), JF.MinimalStyle())

"""
    JuliaFormatter.Internal.format_to_stage(
        stage::Symbol,
        text::AbstractString,
        [style=DefaultStyle(),]
        options...
    )

Run formatting on a given string up until a certain stage, and return the output of that
stage.

Available stages:

 - `:gn` or `:cst`: the output of the JuliaSyntax parser, which is a
   `JuliaSyntax.GreenNode`. Note that directly calling `JuliaSyntax.parseall` will yield a
   `toplevel` node with the actual tree of interest as its only child. This function will
   directly return the child.

 - `:fst`: the output of prettification.

 - `:nest`: the nested FST.
 
 - `:out`: the string output of the formatter.

 - `:print`: the string output but printed. Saves you having to wrap it in `print()`.

!!! tip
    For a utility that is meant to be convenient to access, typing the full qualified
    name can be a bit of a hassle! If you are using this function a lot, you may want
    to use [BasicAutoloads.jl](https://github.com/LilithHafner/BasicAutoloads.jl) to
    automatically import it, and possibly even with a shorter name. For example, you
    can add something like this to your `~/.julia/config/startup.jl`:

    ```julia
    if isinteractive()
        import BasicAutoloads
        BasicAutoloads.register_autoloads([
            ["fs"] => :(using JuliaFormatter.Internal: format_to_stage as fs),
        ])
    end
    ```

    and then just call `fs(:gn, "1 + 2")` from the REPL without having to import it.
"""
function format_to_stage(
    stage::Symbol,
    text::AbstractString,
    style::JF.AbstractStyle = JF.DefaultStyle();
    options...,
)
    # :cst
    cst = JS.parseall(JS.GreenNode, text; version = JF.SUPPORTED_SYNTAX_VERSION)
    stage in (:gn, :cst) && return cst[1]

    # :fst
    opts = JF.merge_options(JF.options(style), JF.Options{JF._Unset}(; options...))
    state = JF.State(JF.Document(text), opts)
    fst = JF.pretty(style, cst, state)
    stage === :fst && return fst

    # :nest
    if JF.hascomment(state.doc, fst.endline)
        JF.add_node!(fst, JF.InlineComment(fst.endline), state)
    end
    JF.flatten_fst!(fst)
    if state.opts.short_circuit_to_if
        JF.short_circuit_to_if_pass!(fst, state)
    end
    if JF.needs_alignment(state.opts)
        JF.align_fst!(fst, state.opts)
    end
    JF.nest!(style, fst, state)
    if state.opts.join_lines_based_on_source
        JF.remove_superfluous_whitespace!(fst)
    end
    stage === :nest && return fst

    # :out
    state.line_offset = 0
    io = IOBuffer()
    if fst.startline > 1
        JF.format_check(io, JF.Notcode(1, fst.startline - 1), state)
        JF.print_leaf(io, JF.Newline(), state)
    end
    JF.print_tree(io, fst, state)
    nlines = JF.numlines(state.doc)
    if state.on && fst.endline < nlines
        JF.print_leaf(io, JF.Newline(), state)
        JF.format_check(io, JF.Notcode(fst.endline + 1, nlines), state)
    end
    if state.doc.ends_on_nl
        JF.print_leaf(io, JF.Newline(), state)
    end
    out = String(take!(io))
    replacer = if state.opts.normalize_line_endings == "unix"
        JF.WINDOWS_TO_UNIX
    elseif state.opts.normalize_line_endings == "windows"
        JF.UNIX_TO_WINDOWS
    else
        JF.choose_line_ending_replacer(state.doc.srcfile.code)
    end
    out = JF.normalize_line_ending(out, replacer)
    stage === :out && return out

    stage === :print && return print(out)

    throw(ArgumentError("unknown stage: $stage"))
end

"""
    _repro_hint(input, style, options)

Generate a hint for how to reproduce a failure in `test_format`, given the input string,
style, and options.
"""
function _repro_hint(input, style, options)
    opts_str = if isempty(options)
        ""
    else
        "; " * join(["$k=$(repr(v))" for (k, v) in pairs(options)], ", ")
    end
    style_str = if style isa JF.DefaultStyle
        ""
    else
        ", $(nameof(typeof(style)))()"
    end
    return "s = $(repr(input))\nformat_text(s$(style_str)$(opts_str))"
end

"""
    _normalise_ast!(ex)

Normalise ASTs (mostly by removing line number nodes, which are not relevant for semantics).
"""
_normalise_ast!(ex) = ex
function _normalise_ast!(ex::Expr)
    if ex.head === :block || ex.head === :quote || ex.head === :toplevel
        filter!(ex.args) do x
            !(isa(x, Expr) && x.head === :line || isa(x, LineNumberNode))
        end
    end
    # macrocall's apparently _need_ to have a line number node or something in that
    # position, so we can't remove it altogether -- but we can replace all such nodes with
    # `nothing` so that they compare equal. See: https://stackoverflow.com/a/53285644
    if ex.head === :macrocall
        new_args = map(ex.args) do x
            x isa LineNumberNode ? nothing : x
        end
        ex.args = new_args
    end
    for subex in ex.args
        subex isa Expr && _normalise_ast!(subex)
    end
    return ex
end

"""
    JuliaFormatter.Internal.test_format(
        input::AbstractString,
        expected::Union{Nothing,AbstractString},
        [style::AbstractStyle=DefaultStyle();]
        testset::Bool=false,
        ast::Bool=false,
        options...
    )

Test that formatting `input` produces `expected`, and that `expected` is idempotent under
formatting.

If `ast=true` additionally tests that the input text and formatted text parse to the same
AST.

If `expected` is `nothing`, doesn't test for an exact output, but still checks idempotence
(and also semantic invariance if `ast=true`).

If `testset=true`, wraps the function call in a `@testset`.
"""
function test_format(
    input::AbstractString,
    expected::Union{Nothing,AbstractString},
    style::JF.AbstractStyle = JF.DefaultStyle();
    testset::Bool = false,
    ast::Bool = false,
    options...,
)
    if testset
        maxlen = 15
        truncated_input = length(input) > maxlen ? input[1:(maxlen-1)] * "…" : input
        return @testset "$truncated_input" begin
            test_format(input, expected, style; testset = false, ast = ast, options...)
        end
    end

    out = JF.format_text(input, style; options...)
    if !isnothing(expected)
        if out != expected
            printstyled(
                "Formatting output did not match expected value.\n\n";
                color = :cyan,
            )
            printstyled("Expected:\n$expected\n\n"; color = :green)
            printstyled("Got:\n$out\n\n"; color = :red)
            printstyled("Repro:\n$(_repro_hint(input, style, options))\n"; color = :cyan)
        end
        @test out == expected
    end

    out2 = JF.format_text(out, style; options...)
    if out2 != out
        printstyled("Formatting was not idempotent.\n\n"; color = :cyan)
        printstyled("First pass:\n$out\n\n"; color = :green)
        printstyled("Second pass:\n$out2\n\n"; color = :red)
        printstyled("Repro:\n$(_repro_hint(input, style, options))\n"; color = :cyan)
    end
    @test out2 == out

    if ast
        ast_in = Meta.parse(input)
        ast_out = Meta.parse(out)
        _normalise_ast!(ast_in)
        _normalise_ast!(ast_out)
        if ast_in != ast_out
            printstyled("AST of input and output did not match.\n\n"; color = :cyan)
            printstyled("Input AST:\n$ast_in\n\n"; color = :green)
            printstyled("Output AST:\n$ast_out\n\n"; color = :red)
            printstyled("Repro:\n$(_repro_hint(input, style, options))\n"; color = :cyan)
        end
        @test ast_in == ast_out
    end
end

end # module

module OptionsTests

using JuliaFormatter
using JuliaFormatter: DefaultStyle, YASStyle, BlueStyle, Options, format_text
using JuliaFormatter.Internal: test_format
using JuliaSyntax
using Test

function run_pretty(text::String; style = DefaultStyle(), opts = Options())
    d = JuliaFormatter.Document(text)
    s = JuliaFormatter.State(d, opts)
    g = JuliaSyntax.parseall(
        JuliaSyntax.GreenNode,
        text;
        version = JuliaFormatter.SUPPORTED_SYNTAX_VERSION,
    )
    t = JuliaFormatter.pretty(style, g, s)
    t
end

@testset "Formatting Options" begin
    @testset "remove extra newlines" begin
        str_ = """
        a = 10

        # foo1
        # ooo



        # aooo


        # aaaa
        b = 20



        # hello
        """
        str = """
        a = 10

        # foo1
        # ooo

        # aooo

        # aaaa
        b = 20

        # hello
        """
        test_format(str_, str; remove_extra_newlines = true)
        test_format(str_, str_; remove_extra_newlines = false)

        str_ = """
        module M


        function foo(bar::Int64, baz::Int64)


            return bar + baz
        end

        function foo(bar::In64, baz::Int64)
            return bar + baz


        end


        end
        """
        str = """
        module M

        function foo(bar::Int64, baz::Int64)
            return bar + baz
        end

        function foo(bar::In64, baz::Int64)
            return bar + baz
        end

        end
        """
        test_format(str_, str; remove_extra_newlines = true)
        test_format(str_, str_; remove_extra_newlines = false)
    end

    @testset "whitespace in typedefs" begin
        str_ = "Foo{A,B,C}"
        str = "Foo{A, B, C}"
        test_format(str_, str; whitespace_typedefs = true)

        str_ = """
        struct Foo{A<:Bar,Union{B<:Fizz,C<:Buzz},<:Any}
            a::A
        end"""
        str = """
        struct Foo{A <: Bar, Union{B <: Fizz, C <: Buzz}, <:Any}
            a::A
        end"""
        test_format(str_, str; whitespace_typedefs = true)

        str_ = """
        function foo() where {A,B,C{D,E,F{G,H,I},J,K},L,M<:N,Y>:Z}
            body
        end
        """
        str = """
        function foo() where {A, B, C{D, E, F{G, H, I}, J, K}, L, M <: N, Y >: Z}
            body
        end
        """
        test_format(str_, str; whitespace_typedefs = true)

        str_ = "foo() where {A,B,C{D,E,F{G,H,I},J,K},L,M<:N,Y>:Z} = body"
        str = "foo() where {A, B, C{D, E, F{G, H, I}, J, K}, L, M <: N, Y >: Z} = body"
        test_format(str_, str; whitespace_typedefs = true)
    end

    @testset "whitespace ops in indices" begin
        str = "arr[1 + 2]"
        test_format("arr[1+2]", str; margin = 1, whitespace_ops_in_indices = true)

        str = "arr[(1 + 2)]"
        test_format("arr[(1+2)]", str; margin = 1, whitespace_ops_in_indices = true)

        str_ = "arr[1:2*num_source*num_dump-1]"
        str = "arr[1:(2 * num_source * num_dump - 1)]"
        test_format(str_, str; margin = 1, whitespace_ops_in_indices = true)

        str_ = "arr[2*num_source*num_dump-1:1]"
        str = "arr[(2 * num_source * num_dump - 1):1]"
        test_format(str_, str; margin = 1, whitespace_ops_in_indices = true)

        str = "arr[(a + b):c]"
        test_format("arr[(a+b):c]", str; margin = 1, whitespace_ops_in_indices = true)

        str = "arr[a in b]"
        test_format(str, str; margin = 1, whitespace_ops_in_indices = true)

        # In v1
        str_ = "a:b+c:d-e"
        str = "a:(b + c):(d - e)"
        test_format(str_, str; margin = 1, whitespace_ops_in_indices = true)
        str = "a:(b+c):(d-e)"
        test_format(str_, str; margin = 1, whitespace_ops_in_indices = false)

        str_ = "s[m+i+1]"
        # issue 180
        str = "s[m+i+1]"
        test_format(str, str; margin = 1, whitespace_ops_in_indices = false)

        str = "s[m + i + 1]"
        test_format(str_, str; margin = 1, whitespace_ops_in_indices = true)
    end

    @testset "rewrite x |> f to f(x)" begin
        @testset "basic cases" begin
            for dot in ("", ".")
                test_format("x $dot|> f", "f$dot(x)"; pipe_to_function_call = true)
                test_format("x $dot|> f()", "f()$dot(x)"; pipe_to_function_call = true)
                test_format("x $dot|> f(a)", "f(a)$dot(x)"; pipe_to_function_call = true)
                test_format("x $dot|> M.f", "M.f$dot(x)"; pipe_to_function_call = true)
                test_format("x $dot|> T{x}", "T{x}$dot(x)"; pipe_to_function_call = true)
                # Check that callable is parenthesised if necessary
                test_format(
                    "x $dot|> y -> y + 1",
                    "(y -> y + 1)$dot(x)";
                    pipe_to_function_call = true,
                )
                test_format(
                    "x $dot|> f ∘ g",
                    "(f ∘ g)$dot(x)";
                    pipe_to_function_call = true,
                )
            end
        end

        @testset "operators on rhs" begin
            test_format("x |> !", "!(x)"; pipe_to_function_call = true)
            test_format("x .|> !", ".!(x)"; pipe_to_function_call = true)
        end

        @testset "elision of extra argument parentheses" begin
            test_format("(x) |> f", "f(x)"; pipe_to_function_call = true)
            test_format("(x) .|> f", "f.(x)"; pipe_to_function_call = true)
            test_format(
                "(a for a in x) |> f()",
                "f()(a for a in x)";
                pipe_to_function_call = true,
            )
            # make sure that genuine tuples don't get de-parenthesised
            test_format("(x, y) |> f()", "f()((x, y))"; pipe_to_function_call = true)
            test_format("(x,) |> f()", "f()((x,))"; pipe_to_function_call = true)
            test_format("(; x) |> f()", "f()((; x))"; pipe_to_function_call = true)
        end

        @testset "chained pipes" begin
            str_ = "var = func1(arg1) |> func2 |> func3 |> func4 |> func5"
            str = "var = func5(func4(func3(func2(func1(arg1)))))"
            test_format(str_, str; pipe_to_function_call = true)
            str_nested = format_text(str; margin = 1)
            test_format(str_, str_nested; pipe_to_function_call = true, margin = 1)
            test_format("x .|> f .|> g", "g.(f.(x))"; pipe_to_function_call = true)
            test_format("(x |> f) |> g", "g(f(x))"; pipe_to_function_call = true)
            test_format("x |> f .|> g", "g.(f(x))"; pipe_to_function_call = true)
            test_format("x .|> f |> g", "g(f.(x))"; pipe_to_function_call = true)
            test_format("x |> y -> y |> f", "(y -> f(y))(x)"; pipe_to_function_call = true)
        end

        @testset "expressions on lhs" begin
            test_format("f(a, b) |> g", "g(f(a, b))"; pipe_to_function_call = true)
            test_format("a + b |> f", "f(a + b)"; pipe_to_function_call = true)
            test_format("[1...] |> f", "f([1...])"; pipe_to_function_call = true)
            test_format("1:10 |> collect", "collect(1:10)"; pipe_to_function_call = true)
        end

        @testset "nesting" begin
            for dot in ("", ".")
                f = "some_long_function_name"
                x = "very_long_variable_name"
                str_ = "$x $(dot)|> $f"
                str = "$f$(dot)($x)"
                str_nested = format_text(str; margin = 1)
                test_format(str_, str_nested; pipe_to_function_call = true, margin = 1)
            end

            @testset "extra idempotence test" begin
                # Make sure that nesting decisions are made correctly the first time
                # see https://github.com/JuliaEditorSupport/JuliaFormatter.jl/pull/1023
                # Formatting the string below used to not be idempotent.
                str_ = """
                function f()
                    ps_mods = map(
                        layer_mods -> (
                            layer_mods === nothing ? () :
                                map(l -> initialparameters(rng, l), layer_mods) |> Tuple
                        ),
                        mods
                    ) |> Tuple
                end"""
                str = """
                function f()
                    ps_mods = Tuple(
                        map(
                            layer_mods -> (
                                layer_mods === nothing ? () :
                                Tuple(map(l -> initialparameters(rng, l), layer_mods))
                            ),
                            mods,
                        ),
                    )
                end"""
                test_format(str_, str; pipe_to_function_call = true)
                test_format(str, str; pipe_to_function_call = true)
            end
        end

        @testset "block argument" begin
            for dot in ("", ".")
                str_ = """begin
                    f
                end $dot|> g"""
                str = """g$dot(begin
                    f
                end)"""
                test_format(str_, str; pipe_to_function_call = true)
            end
        end

        @testset "function with do block" begin
            for dot in ("", ".")
                str_ = """
                x $dot|> f(a) do a
                    g(a)
                end
                """
                str = """
                (f(a) do a
                    g(a)
                end)$dot(x)
                """
                test_format(str_, str; pipe_to_function_call = true)
            end
        end

        @testset "cases where transformation should not happen" begin
            # inside macro
            smacro = "@macro x |> f"
            test_format(smacro, smacro; pipe_to_function_call = true)
            smacro2 = "@macro function f()\n    x |> g\nend"
            test_format(smacro2, smacro2; pipe_to_function_call = true)

            # inside Expr
            sexpr = ":(x |> f)"
            test_format(sexpr, sexpr; pipe_to_function_call = true)
            squote = "quote\n    x |> f\nend"
            test_format(squote, squote; pipe_to_function_call = true)

            # dotted tuple of functions
            # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/647
            sdotcall = "x .|> (f, g)"
            test_format(sdotcall, sdotcall; pipe_to_function_call = true)
        end
    end

    @testset "function shortdef to longdef" begin
        str_ = "foo(a) = bodybodybody"
        str = """
        function foo(a)
            bodybodybody
        end"""
        test_format(
            str_,
            str_;
            indent = 4,
            margin = length(str_),
            short_to_long_function_def = true,
        )
        test_format(
            str_,
            str;
            indent = 4,
            margin = length(str_) - 1,
            short_to_long_function_def = true,
        )

        str_ = "foo(a::T) where {T} = bodybodybodybodybodybodyb"
        str = """
        function foo(a::T) where {T}
            bodybodybodybodybodybodyb
        end"""
        test_format(
            str_,
            str_;
            indent = 4,
            margin = length(str_),
            short_to_long_function_def = true,
        )
        test_format(
            str_,
            str;
            indent = 4,
            margin = length(str_) - 1,
            short_to_long_function_def = true,
        )

        str_ = "foo(a::T)::R where {T} = bodybodybodybodybodybodybody"
        str = """
        function foo(a::T)::R where {T}
            bodybodybodybodybodybodybody
        end"""
        test_format(
            str_,
            str_;
            indent = 4,
            margin = length(str_),
            short_to_long_function_def = true,
        )
        test_format(
            str_,
            str;
            indent = 4,
            margin = length(str_),
            short_to_long_function_def = true,
            force_long_function_def = true,
        )
        test_format(
            str_,
            str_;
            indent = 4,
            margin = length(str_),
            short_to_long_function_def = false,
            force_long_function_def = false,
        )
        test_format(
            str_,
            str;
            indent = 4,
            margin = length(str_) - 1,
            short_to_long_function_def = true,
        )
    end

    @testset "whitespace in keyword arguments" begin
        str_ = "f(; a = b)"
        str = "f(; a=b)"
        test_format(str_, str; indent = 4, margin = 92, whitespace_in_kwargs = false)

        str = "f(; a!) = a!"
        test_format(str, str; indent = 4, margin = 92, whitespace_in_kwargs = false)

        # issue 242
        str_ = "f(a, b! = 1; c! = 2, d = 3, e! = 4)"
        str = "f(a, (b!)=1; (c!)=2, d=3, (e!)=4)"
        test_format(str_, str; indent = 4, margin = 92, whitespace_in_kwargs = false)

        str_ = "( k1 =v1,  k2! = v2)"
        str = "(k1=v1, (k2!)=v2)"
        test_format(
            str_,
            str,
            YASStyle();
            indent = 4,
            margin = 80,
            whitespace_in_kwargs = false,
        )
        test_format(str_, str; indent = 4, margin = 80, whitespace_in_kwargs = false)

        str_ = "( k1 =v1,  k2! = v2)"
        str = "(k1 = v1, k2! = v2)"
        test_format(
            str_,
            str,
            YASStyle();
            indent = 4,
            margin = 80,
            whitespace_in_kwargs = true,
        )
        test_format(str_, str; indent = 4, margin = 80, whitespace_in_kwargs = true)

        str_ = "(; g = >=(1))"
        str = "(; g=(>=(1)))"
        test_format(str_, str; indent = 4, margin = 92, whitespace_in_kwargs = false)

        s = "C(; Vt=Ȳ')"
        test_format(s, s; indent = 4, margin = 100, whitespace_in_kwargs = false)
    end

    @testset "align struct fields" begin
        str_ = """
        struct Foo
            a::T
        end"""
        str = """
        struct Foo
            a::T
        end"""
        test_format(str_, str; align_struct_field = true)

        str = """
        struct Foo
            a             :: T
            longfieldname :: B
        end"""
        str_ = """
        struct Foo
            a::T
            longfieldname::B
        end"""
        test_format(str, str; align_struct_field = true)
        test_format(str, str_; align_struct_field = false)

        str_ = """
        Base.@kwdef struct Options
            indent_size::Int                       = 4
            margin::Int                            = 92
            always_for_in::Bool                 = false
            whitespace_typedefs::Bool          = false
            whitespace_ops_in_indices::Bool        = false
            remove_extra_newlines::Bool            = false
            import_to_using::Bool                  = false
            pipe_to_function_call::Bool            = false
            short_to_long_function_def::Bool      = false
            always_use_return::Bool           = false
            whitespace_in_kwargs::Bool          = true
            annotate_untyped_fields_with_any::Bool = true
            format_docstrings::Bool             = false
            align_struct_fields::Bool           = false

            another_field1::BlahBlahBlah = 10
            field2::Foo                          = 10

            Options() = new()
        end"""
        str = """
        Base.@kwdef struct Options
            indent_size::Int                       = 4
            margin::Int                            = 92
            always_for_in::Bool                    = false
            whitespace_typedefs::Bool              = false
            whitespace_ops_in_indices::Bool        = false
            remove_extra_newlines::Bool            = false
            import_to_using::Bool                  = false
            pipe_to_function_call::Bool            = false
            short_to_long_function_def::Bool       = false
            always_use_return::Bool                = false
            whitespace_in_kwargs::Bool             = true
            annotate_untyped_fields_with_any::Bool = true
            format_docstrings::Bool                = false
            align_struct_fields::Bool              = false

            another_field1::BlahBlahBlah = 10
            field2::Foo = 10

            Options() = new()
        end"""
        test_format(str_, str; align_struct_field = true)

        str_ = """
        Base.@kwdef struct Options
            indent_size::Int = 4
            margin::Int = 92
            always_for_in::Bool = false
            whitespace_typedefs::Bool = false
            whitespace_ops_in_indices::Bool = false
            remove_extra_newlines::Bool = false
            import_to_using::Bool = false
            pipe_to_function_call::Bool = false
            short_to_long_function_def::Bool = false
            always_use_return::Bool = false
            whitespace_in_kwargs::Bool = true
            annotate_untyped_fields_with_any::Bool = true
            format_docstrings::Bool = false
            align_struct_fields::Bool = false

            another_field1::BlahBlahBlah = 10
            field2::Foo = 10

            Options() = new()
        end"""
        test_format(str, str; align_struct_field = true)
        test_format(str, str_; align_struct_field = false)

        str = """
        Base.@kwdef struct Options
            indent_size::Int                       = 4
            margin::Int                            = 92
            always_for_in::Bool                    = false
            whitespace_typedefs::Bool              = false
            whitespace_ops_in_indices::Bool        = false
            remove_extra_newlines::Bool            = false
            import_to_using::Bool                  = false
            pipe_to_function_call::Bool            = false
            short_to_long_function_def::Bool       = false
            always_use_return::Bool                = false
            whitespace_in_kwargs::Bool             = true
            annotate_untyped_fields_with_any::Bool = true
            format_docstrings::Bool                = false
            align_struct_fields::Bool              = false

            another_field1::BlahBlahBlah =
                10
            field2::Foo =
                10

            Options() =
                new()
        end"""
        test_format(str, str; indent = 4, margin = 1, align_struct_field = true)
    end

    @testset "align assignment" begin
        str_ = """
        const variable1 = 1
        const var2      = 2
        const var3 = 3
        const var4 = 4"""
        str = """
        const variable1 = 1
        const var2      = 2
        const var3      = 3
        const var4      = 4"""
        test_format(str_, str; align_assignment = true)

        str = """
        const variable1 = 1
        const variable2 = 2
        const var3 = 3
        const var4 = 4"""
        test_format(str, str; align_assignment = true)

        str_ = """
        module Foo

        const UTF8PROC_STABLE    = (1<<1)
        const UTF8PROC_COMPAT    = (1<<2)
        const UTF8PROC_COMPOSE   = (1<<3)
        const UTF8PROC_DECOMPOSE = (1<<4)
        const UTF8PROC_IGNORE    = (1<<5)
        const UTF8PROC_REJECTNA  = (1<<6)
        const UTF8PROC_NLF2LS    = (1<<7)
        const UTF8PROC_NLF2PS    = (1<<8)
        const UTF8PROC_NLF2LF    = (UTF8PROC_NLF2LS | UTF8PROC_NLF2PS)
        const UTF8PROC_STRIPCC   = (1<<9)
        const UTF8PROC_CASEFOLD  = (1<<10)
        const UTF8PROC_CHARBOUND = (1<<11)
        const UTF8PROC_LUMP=(1<<12)
        const UTF8PROC_STRIP         = (1<<13) # align this

        const FOOBAR = 0
        const FOO = 1

        end"""

        str = """
        module Foo

        const UTF8PROC_STABLE    = (1<<1)
        const UTF8PROC_COMPAT    = (1<<2)
        const UTF8PROC_COMPOSE   = (1<<3)
        const UTF8PROC_DECOMPOSE = (1<<4)
        const UTF8PROC_IGNORE    = (1<<5)
        const UTF8PROC_REJECTNA  = (1<<6)
        const UTF8PROC_NLF2LS    = (1<<7)
        const UTF8PROC_NLF2PS    = (1<<8)
        const UTF8PROC_NLF2LF    = (UTF8PROC_NLF2LS | UTF8PROC_NLF2PS)
        const UTF8PROC_STRIPCC   = (1<<9)
        const UTF8PROC_CASEFOLD  = (1<<10)
        const UTF8PROC_CHARBOUND = (1<<11)
        const UTF8PROC_LUMP      = (1<<12)
        const UTF8PROC_STRIP     = (1<<13) # align this

        const FOOBAR = 0
        const FOO = 1

        end"""
        test_format(str_, str; align_assignment = true)
        test_format(str_, str; align_assignment = true, join_lines_based_on_source = true)

        # the aligned consts will NOT be nestable
        str = """
        module Foo

        const UTF8PROC_STABLE    = (1<<1)
        const UTF8PROC_COMPAT    = (1<<2)
        const UTF8PROC_COMPOSE   = (1<<3)
        const UTF8PROC_DECOMPOSE = (1<<4)
        const UTF8PROC_IGNORE    = (1<<5)
        const UTF8PROC_REJECTNA  = (1<<6)
        const UTF8PROC_NLF2LS    = (1<<7)
        const UTF8PROC_NLF2PS    = (1<<8)
        const UTF8PROC_NLF2LF    = (UTF8PROC_NLF2LS | UTF8PROC_NLF2PS)
        const UTF8PROC_STRIPCC   = (1<<9)
        const UTF8PROC_CASEFOLD  = (1<<10)
        const UTF8PROC_CHARBOUND = (1<<11)
        const UTF8PROC_LUMP      = (1<<12)
        const UTF8PROC_STRIP     = (1<<13) # align this

        const FOOBAR =
            0
        const FOO =
            1

        end"""
        test_format(str_, str; indent = 4, margin = 1, align_assignment = true)
        test_format(
            str_,
            str;
            indent = 4,
            margin = 1,
            align_assignment = true,
            join_lines_based_on_source = true,
        )

        str = """
        a  = 1
        bc = 2

        long_variable = 1
        other_var     = 2
        """
        test_format(str, str; indent = 4, margin = 1, align_assignment = true)

        str = """
        eclipse  = true
        s̄_b      = SVector{3,T}(0, 0, 0)
        css_axes = :css_axes_eclipse
        """
        test_format(str, str; align_assignment = true)

        str = """
        vcat(X::T...) where {T}         = T[X[i] for i = 1:length(X)]
        vcat(X::T...) where {T<:Number} = T[X[i] for i = 1:length(X)]
        hcat(X::T...) where {T}         = T[X[j] for i = 1:1, j = 1:length(X)]
        hcat(X::T...) where {T<:Number} = T[X[j] for i = 1:1, j = 1:length(X)]
        """
        test_format(str, str; indent = 4, margin = 1, align_assignment = true)
        test_format(
            str,
            str;
            indent = 4,
            margin = 1,
            align_assignment = true,
            join_lines_based_on_source = true,
        )

        # ambiguous ordering
        str = """
        μs, ns = divrem(ns, 1000)
        ms, μs = divrem(μs, 1000)
        s, ms = divrem(ms, 1000)
        """
        test_format(str, str; align_assignment = true)

        str = """
        run = wandb.init(
            name      = name,
            project   = project,
            config    = config,
            notes     = notes,
            tags      = tags,
            dir       = dir,
            job_type  = job_type,
            entity    = entity,
            group     = group,
            id        = id,
            reinit    = reinit,
            resume    = resume,
            anonymous = anonymous ? "allow" : "never",
        )
        """
        test_format(
            str,
            str;
            indent = 4,
            margin = 100,
            align_assignment = true,
            whitespace_in_kwargs = false,
        )
        test_format(
            str,
            str;
            indent = 4,
            margin = 100,
            align_assignment = true,
            whitespace_in_kwargs = false,
            join_lines_based_on_source = true,
        )

        str_ = """
        s           = model.sys
        @unpack A,K = s
        C           = s.C
        poles       = eigvals(A - K * C)
        """
        str = """
        s            = model.sys
        @unpack A, K = s
        C            = s.C
        poles        = eigvals(A - K * C)
        """
        test_format(str_, str; indent = 4, margin = 100, align_assignment = true)
        test_format(
            str_,
            str;
            indent = 4,
            margin = 100,
            align_assignment = true,
            join_lines_based_on_source = true,
        )

        str_ = """
        s             = model.sys
        @unpack A,K   = s
        C             = s.C
        const polesss = eigvals(A - K * C)
        """
        str = """
        s             = model.sys
        @unpack A, K  = s
        C             = s.C
        const polesss = eigvals(A - K * C)
        """
        test_format(str_, str; indent = 4, margin = 100, align_assignment = true)

        str = """
        function stabilize(model)
            s            = model.sys
            @unpack A, K = s
            C            = s.C
            poles        = eigvals(A - K * C)
            newpoles     = map(poles) do p
                ap = abs(p)
                ap <= 1 && (return p)
                p / (ap + sqrt(eps()))
            end
            K2           = ControlSystems.acker(A', C', newpoles)' .|> real
            all(abs(p) <= 1 for p in eigvals(A - K * C)) || @warn("Failed to stabilize predictor")
            s.K .= K2
            model
        end
        """
        test_format(str, str; indent = 4, margin = 100, align_assignment = true)
        test_format(
            str,
            str;
            indent = 4,
            margin = 100,
            align_assignment = true,
            join_lines_based_on_source = true,
        )
    end

    @testset "align conditionals" begin
        str_ = """
        index = zeros(n <= typemax(Int8)  ? Int8  :
                      n <= typemax(Int16) ? Int16 :
                      n <= typemax(Int32) ? Int32 : Int64, n)
        """

        str = """
        index = zeros(
            n <= typemax(Int8)  ? Int8  :
            n <= typemax(Int16) ? Int16 :
            n <= typemax(Int32) ? Int32 : Int64,
            n,
        )
        """
        test_format(str_, str; align_conditional = true)

        str = """
        index =
            zeros(
                n <= typemax(Int8)  ? Int8  :
                n <= typemax(Int16) ? Int16 :
                n <= typemax(Int32) ? Int32 : Int64,
                n,
            )
        """
        test_format(str_, str; indent = 4, margin = 1, align_conditional = true)

        str_ = """
        index = zeros(n <= typemax(Int8)  ? Int8 :   # inline
                        #comment 1
                      n <= typemax(Int16) ? Int16 :   # inline 2
                              # comment 2
                      n <= typemax(Int32) ? Int32 : # inline 3
                      Int64, n)
        """
        str = """
        index =
            zeros(
                n <= typemax(Int8)  ? Int8 :   # inline
                #comment 1
                n <= typemax(Int16) ? Int16 :   # inline 2
                # comment 2
                n <= typemax(Int32) ? Int32 : # inline 3
                Int64,
                n,
            )
        """
        test_format(str_, str; indent = 4, margin = 1, align_conditional = true)
        test_format(
            str_,
            str;
            indent = 4,
            margin = 1,
            align_conditional = true,
            join_lines_based_on_source = true,
        )

        str_ = """
        index = zeros(n <= typemax(Int8)  ? Int8  :    # inline
                      n <= typemax(Int16) ? Int16 : n <= typemax(Int32) ? Int32 : Int64, n)
        """

        str = """
        index =
            zeros(
                n <= typemax(Int8)  ? Int8  :    # inline
                n <= typemax(Int16) ? Int16 : n <= typemax(Int32) ? Int32 : Int64,
                n,
            )
        """
        test_format(str_, str; indent = 4, margin = 1, align_conditional = true)
        test_format(
            str_,
            str;
            indent = 4,
            margin = 1,
            align_conditional = true,
            join_lines_based_on_source = true,
        )

        str_ = """
        index =
            zeros(
                n <= typemax(Int8)     ? Int8  :
                n <= typemax(Int16A) ? Int16  :
                n <= typemax(Int32)  ? Int322 : Int64,
                n,
            )
        """
        str = """
        index =
            zeros(
                n <= typemax(Int8)   ? Int8   :
                n <= typemax(Int16A) ? Int16  :
                n <= typemax(Int32)  ? Int322 : Int64,
                n,
            )
        """
        test_format(str_, str; indent = 4, margin = 1, align_conditional = true)

        str_ = """
        val = cst.kind === Tokens.ABSTRACT ? "abstract" :
            cst.kind === Tokens.BAREMODULE ? "baremodule" : ""
        """
        str = """
        val = cst.kind === Tokens.ABSTRACT ? "abstract" : cst.kind === Tokens.BAREMODULE ? "baremodule" : ""
        """
        test_format(str_, str; indent = 4, margin = 100, align_conditional = true)

        str_ = """
        val = cst.kind === Tokens.ABSTRACT ? "abstract" :
            cst.kind === Tokens.BAREMODUL  ? "baremodule" : ""
        """
        str = """
        val = cst.kind === Tokens.ABSTRACT  ? "abstract" :
              cst.kind === Tokens.BAREMODUL ? "baremodule" : ""
        """
        test_format(str_, str; indent = 4, margin = 100, align_conditional = true)
        test_format(
            str_,
            str;
            indent = 4,
            margin = 100,
            align_conditional = true,
            join_lines_based_on_source = true,
        )

        str = """
        val =
            cst.kind === Tokens.ABSTRACT  ? "abstract" :
            cst.kind === Tokens.BAREMODUL ? "baremodule" : ""
        """
        test_format(str_, str; indent = 4, margin = 1, align_conditional = true)
        test_format(
            str_,
            str;
            indent = 4,
            margin = 1,
            align_conditional = true,
            join_lines_based_on_source = true,
        )
    end

    @testset "align pair arrow `=>`" begin
        str_ = """
        pages = [
            "Introduction" => "index.md",
            "How It Works" => "how_it_works.md",
            "Code Style"          => "style.md",
            "Skipping Formatting" => "skipping_formatting.md",
            "Syntax Transforms" => "transforms.md",
            "Custom Alignment" => "custom_alignment.md",
            "Custom Styles" => "custom_styles.md",
            "YAS Style" => "yas_style.md",
            "Configuration File" => "config.md",
            "API Reference" => "api.md",
        ]
        """
        str = """
        pages = [
            "Introduction"        => "index.md",
            "How It Works"        => "how_it_works.md",
            "Code Style"          => "style.md",
            "Skipping Formatting" => "skipping_formatting.md",
            "Syntax Transforms"   => "transforms.md",
            "Custom Alignment"    => "custom_alignment.md",
            "Custom Styles"       => "custom_styles.md",
            "YAS Style"           => "yas_style.md",
            "Configuration File"  => "config.md",
            "API Reference"       => "api.md",
        ]
        """
        test_format(str_, str; indent = 4, margin = 100, align_pair_arrow = true)

        str = """
        pages =
            [
                "Introduction"        => "index.md",
                "How It Works"        => "how_it_works.md",
                "Code Style"          => "style.md",
                "Skipping Formatting" => "skipping_formatting.md",
                "Syntax Transforms"   => "transforms.md",
                "Custom Alignment"    => "custom_alignment.md",
                "Custom Styles"       => "custom_styles.md",
                "YAS Style"           => "yas_style.md",
                "Configuration File"  => "config.md",
                "API Reference"       => "api.md",
            ]
        """
        test_format(str_, str; indent = 4, margin = 1, align_pair_arrow = true)
        test_format(
            str_,
            str;
            indent = 4,
            margin = 1,
            align_pair_arrow = true,
            join_lines_based_on_source = true,
        )
    end

    @testset "conditional to `if` block" begin
        str_ = """
        E ? A : B
        """
        test_format(str_, str_; indent = 2, margin = 9, conditional_to_if = true)

        str = """
        if E
          A
        else
          B
        end
        """
        test_format(str_, str; indent = 2, margin = 8, conditional_to_if = true)

        str_ = """
        begin
            E1 ? A : E2 ? B : foo(E333, E444) ? D : E
        end
        """
        test_format(str_, str_; indent = 4, margin = 45, conditional_to_if = true)

        str = """
        begin
            if E1
                A
            elseif E2
                B
            elseif foo(E333, E444)
                D
            else
                E
            end
        end
        """
        test_format(str_, str; indent = 4, margin = 44, conditional_to_if = true)
        test_format(str_, str; indent = 4, margin = 26, conditional_to_if = true)

        str = """
        begin
            if E1
                A
            elseif E2
                B
            elseif foo(
                E333,
                E444,
            )
                D
            else
                E
            end
        end
        """
        test_format(str_, str; indent = 4, margin = 25, conditional_to_if = true)

        str_ = """
        foobar = some_big_long_thing * 10_000 == 2 ?
            #comment
            bar :
            #comment
            another_big_long_thing * 10^300 / this_things_here
        """

        str = """
        foobar = if some_big_long_thing * 10_000 == 2
            #comment
            bar
        else
            #comment
            another_big_long_thing * 10^300 / this_things_here
        end
        """
        test_format(str_, str; conditional_to_if = true)
    end

    @testset "normalize_line_endings" begin
        windows_str = "a\r\nb\r\nc\r\nd"
        unix_str = "a\nb\nc\nd"
        mixed_windows_str = "a\r\nb\r\nc\nd"
        mixed_unix_str = "a\r\nb\nc\nd"

        test_format(windows_str, windows_str; normalize_line_endings = "auto")
        test_format(unix_str, unix_str; normalize_line_endings = "auto")
        test_format(mixed_windows_str, windows_str; normalize_line_endings = "auto")
        test_format(mixed_unix_str, unix_str; normalize_line_endings = "auto")

        test_format(windows_str, unix_str; normalize_line_endings = "unix")
        test_format(unix_str, unix_str; normalize_line_endings = "unix")
        test_format(mixed_windows_str, unix_str; normalize_line_endings = "unix")
        test_format(mixed_unix_str, unix_str; normalize_line_endings = "unix")

        test_format(windows_str, windows_str; normalize_line_endings = "windows")
        test_format(unix_str, windows_str; normalize_line_endings = "windows")
        test_format(mixed_windows_str, windows_str; normalize_line_endings = "windows")
        test_format(mixed_unix_str, windows_str; normalize_line_endings = "windows")
    end

    @testset "align matrix" begin
        # default formatting
        str = """
        a = [
            100 300 400
            1 eee 40000
            2 α b
        ]
        """
        test_format(str, str; align_matrix = true)
        str_ = """
        a = [100 300 400
             1 eee 40000
             2 α b]
        """
        test_format(str, str_, YASStyle(); align_matrix = true)

        # left-aligned
        str = """
        a = [
            100 300 400
            1   eee 40000
            2   α   b
        ]
        """
        test_format(str, str; align_matrix = true)
        str_ = """
        a = [100 300 400
             1   eee 40000
             2   α   b]
        """
        test_format(str, str_, YASStyle(); align_matrix = true)

        # right-aligned
        str = """
        a = [
            100 3000   400
              1  eee     b
              2    α 40000
        ]
        """
        test_format(str, str; align_matrix = true)
        str_ = """
        a = [100 3000   400
               1  eee     b
               2    α 40000]
        """
        test_format(str, str_, YASStyle(); align_matrix = true)
    end

    @testset "ignore maximum width" begin
        @testset "maintain original structure" begin
            for m in (:module, :baremodule)
                str_ = "$m M body end"
                test_format(str_, format_text(str_); join_lines_based_on_source = true)
            end

            str_ = "struct S body end"
            test_format(
                str_,
                format_text(str_; annotate_untyped_fields_with_any = false);
                join_lines_based_on_source = true,
                annotate_untyped_fields_with_any = false,
            )

            str_ = "mutable struct S body end"
            test_format(
                str_,
                format_text(str_; annotate_untyped_fields_with_any = false);
                join_lines_based_on_source = true,
                annotate_untyped_fields_with_any = false,
            )

            str_ = """
            abstract type
            foo

              end"""
            test_format(str_, format_text(str_); join_lines_based_on_source = true)

            str_ = """
            primitive type
            foo

            64

              end"""
            test_format(str_, format_text(str_); join_lines_based_on_source = true)

            str_ = """
            function foo

              end"""
            test_format(str_, "function foo\n\nend"; join_lines_based_on_source = true)

            for f in (:function, :macro)
                str_ = "$f foo() body end"
                test_format(str_, format_text(str_); join_lines_based_on_source = true)
            end

            str_ = "try a catch e finally c end"
            test_format(str_, format_text(str_); join_lines_based_on_source = true)

            str_ = "if a body1 elseif b body2 elseif c body3 else body4 end"
            test_format(str_, format_text(str_); join_lines_based_on_source = true)

            str_ = "begin a;b;c end"
            test_format(str_, format_text(str_); join_lines_based_on_source = true)

            str_ = "function foo() a;b;c end"
            test_format(str_, format_text(str_); join_lines_based_on_source = true)
        end

        @testset "misc" begin
            str = raw"""
            @testset "T=$T, m=$m, n=$n" for T in (Float64, ComplexF64), m in (2, 3), n in (1, 3)
                body
            end
            """
            test_format(
                str,
                str;
                indent = 4,
                margin = 84,
                join_lines_based_on_source = true,
            )

            str_ = """
            function foo(
                arg1,
                arg2,)

                body
            end
            """
            str = """
            function foo(
                arg1,
                arg2)

                body
            end
            """
            test_format(str_, str; join_lines_based_on_source = true)
            str = """
            function foo(
                arg1,
                arg2)

                return body
            end
            """
            # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/1045
            @test_broken false
            # test_format(str_, str, BlueStyle(); join_lines_based_on_source = true)
        end

        @testset "binary op" begin
            str_ = """
            a =
            b
            """
            str = """
            a =
                b
            """
            test_format(str_, str; join_lines_based_on_source = true)
            test_format(str_, str, BlueStyle(); join_lines_based_on_source = true)

            str = """
            a = b
            """
            test_format(str_, str, YASStyle(); join_lines_based_on_source = true)

            str_ = """
            a =
            (b,c)
            """
            str = """
            a =
                (b, c)
            """
            test_format(str_, str; join_lines_based_on_source = true)

            str = """
            a = (b, c)
            """
            test_format(str_, str, YASStyle(); join_lines_based_on_source = true)
            test_format(str_, str, BlueStyle(); join_lines_based_on_source = true)

            str_ = """
            a =
            "hello"
            """
            str = """
            a = "hello"
            """
            test_format(str_, str; join_lines_based_on_source = true)
            test_format(str_, str, BlueStyle(); join_lines_based_on_source = true)
            test_format(str_, str, YASStyle(); join_lines_based_on_source = true)
        end

        @testset "blue style" begin
            str = """
            function foo(
                arg1, arg2
            )
                return body
            end
            """
            test_format(
                str,
                str,
                BlueStyle();
                indent = 4,
                margin = 1000,
                join_lines_based_on_source = true,
            )
            test_format(str, str, BlueStyle(); indent = 4, margin = 15)

            str = """
            function foo(
                arg1,
                arg2,
            )
                return body
            end
            """
            test_format(
                str,
                str,
                BlueStyle();
                indent = 4,
                margin = 1000,
                join_lines_based_on_source = true,
            )
        end

        @testset "yas style" begin
            str_ = """
            function foo(
                arg1,
                arg2,
            ) where {
            T1,
            T2,
            }
                body
            end
            """
            @test format_text(str_, YASStyle(); join_lines_based_on_source = true) ==
                  format_text(
                str_,
                YASStyle();
                indent = 4,
                margin = 1,
                join_lines_based_on_source = false,
            )

            str_ = """
            @foo(
                arg1,
                arg2,
            )
            """
            str = """
            @foo(arg1,
                 arg2,)
            """
            test_format(str_, str, YASStyle(); join_lines_based_on_source = true)

            str_ = """
            (
                arg1,
                arg2,
            )
            """
            str = """
            (arg1,
             arg2)
            """
            test_format(str_, str, YASStyle(); join_lines_based_on_source = true)

            str_ = """
            [
                arg1,
                arg2,
            ]
            """
            str = """
            [arg1,
             arg2]
            """
            test_format(str_, str, YASStyle(); join_lines_based_on_source = true)

            str_ = """
            A[
                arg1,
                arg2,
            ]
            """
            str = """
            A[arg1,
              arg2]
            """
            test_format(str_, str, YASStyle(); join_lines_based_on_source = true)

            str_ = """
            {
                arg1,
                arg2,
            }
            """
            str = """
            {arg1,
             arg2}
            """
            test_format(str_, str, YASStyle(); join_lines_based_on_source = true)

            str_ = """
            A{
                arg1,
                arg2,
            }
            """
            str = """
            A{arg1,
              arg2}
            """
            test_format(str_, str, YASStyle(); join_lines_based_on_source = true)

            str_ = """
            (
                invisbrackets
            )
            """
            str = """
            (invisbrackets)
            """
            test_format(str_, str, YASStyle(); join_lines_based_on_source = true)

            str_ = """
            [
                row1;
                row2;
            ]
            """
            str = """
            [row1;
             row2;]
            """
            test_format(str_, str, YASStyle(); join_lines_based_on_source = true)

            str_ = """
            T[
                row1;
                row2;
            ]
            """
            str = """
            T[row1;
              row2;]
            """
            test_format(str_, str, YASStyle(); join_lines_based_on_source = true)

            str_ = """
            [
            a for a = 1:10
            ]
            """
            str = """
            [a for a in 1:10]
            """
            test_format(str_, str, YASStyle(); join_lines_based_on_source = true)
        end

        @testset "imports" begin
            str_ = """
            using A,  #inline
                      # comment
            B, C#inline"""
            str = """
            using A,  #inline
              # comment
              B, C#inline"""
            test_format(
                str_,
                str;
                indent = 2,
                margin = 80,
                join_lines_based_on_source = true,
            )

            str_ = """
            using CommonMark:
                AdmonitionRule,
                CodeBlock, enable!, FootnoteRule,
                markdown,
                MathRule,
                Parser,
                Rule, TableRule
            """
            str = """
            using CommonMark:
                AdmonitionRule,
                CodeBlock, enable!,
                FootnoteRule,
                markdown,
                MathRule,
                Parser,
                Rule, TableRule
            """
            test_format(
                str_,
                str_;
                indent = 4,
                margin = 37,
                join_lines_based_on_source = true,
            )
            test_format(
                str_,
                str;
                indent = 4,
                margin = 36,
                join_lines_based_on_source = true,
            )

            str = """
            using CommonMark:
                              AdmonitionRule,
                              CodeBlock, enable!, FootnoteRule,
                              markdown,
                              MathRule,
                              Parser,
                              Rule, TableRule
            """
            test_format(
                str_,
                str,
                YASStyle();
                indent = 4,
                margin = 51,
                join_lines_based_on_source = true,
            )

            str = """
            using CommonMark:
                              AdmonitionRule,
                              CodeBlock, enable!,
                              FootnoteRule,
                              markdown,
                              MathRule,
                              Parser,
                              Rule, TableRule
            """
            test_format(
                str_,
                str,
                YASStyle();
                indent = 4,
                margin = 50,
                join_lines_based_on_source = true,
            )
        end

        # NOTE: not sure since test makes sense anymore.
        # It is generally not a great idea to remove the semicolons here since
        # it can be potentially change the semantics or lead to code errors.
        # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/745
        @testset "matrices" begin
            str_ = """
            T[ a b Expr();
            d e Expr();]"""
            str = """
            T[a b Expr();
                d e Expr();]"""
            test_format(str_, str; join_lines_based_on_source = true)
        end

        @testset "function defs" begin
            s = """
            function foo()
            end
            """
            test_format(s, s; join_lines_based_on_source = true)

            s = """
            function foo
            end
            """
            test_format(s, s; join_lines_based_on_source = true)
        end

        @testset "macro defs" begin
            s = """
            macro foo()
            end
            """
            test_format(s, s; join_lines_based_on_source = true)

            s = """
            macro foo
            end
            """
            test_format(s, s; join_lines_based_on_source = true)
        end

        @testset "typedefs" begin
            s = """
            struct S
            end
            """
            test_format(s, s; join_lines_based_on_source = true)

            s = """
            mutable struct S
            end
            """
            test_format(s, s; join_lines_based_on_source = true)
        end

        @testset "modules" begin
            s = """
            module M
            end
            """
            test_format(s, s; join_lines_based_on_source = true)

            s = """
            baremodule BM
            end
            """
            test_format(s, s; join_lines_based_on_source = true)
        end

        @testset "blank lines inside iterables" begin
            # Blank lines inside an iterable are always dropped, but they must not affect
            # anything else: the arguments and the closing bracket stay exactly where the
            # source put them. Previously the blank line diverted `add_node!` into the
            # "notcode" branch, which emitted no NEWLINE at all and left the arguments (or
            # the closer) glued to the previous line, e.g. `[\n a,\n b,]`.
            @testset "$opener … $closer" for (opener, closer) in (
                ("[", "]"),
                ("(", ")"),
                ("f(", ")"),
                ("T{", "}"),
                ("x[", "]"),
                ("{", "}"),
            )
                str = """
                $opener
                    a,
                    b,
                $closer"""

                # blank line before the closing bracket
                str_ = """
                $opener
                    a,
                    b,

                $closer"""
                test_format(str_, str; join_lines_based_on_source = true)

                # ... several of them
                str_ = """
                $opener
                    a,
                    b,



                $closer"""
                test_format(str_, str; join_lines_based_on_source = true)

                # blank line between two arguments
                str_ = """
                $opener
                    a,

                    b,
                $closer"""
                test_format(str_, str; join_lines_based_on_source = true)
            end

            # A comment in the gap is not a blank line: it is preserved, and so is the
            # newline that has to precede it.
            str = """
            [
                a,
                b,

                # hi
            ]"""
            test_format(str, str; join_lines_based_on_source = true)

            # In a vcat the newline between two arguments *is* the separator, so losing it
            # turns `[a\n\nb]` (a 2x1 vcat) into `[a b]` (a 1x2 hcat).
            test_format("[a\n\nb]", "[a\n    b]"; join_lines_based_on_source = true)
            str_ = """
            [a
                []

            if b
                c
            end
            ]"""
            str = """
            [a
                []
                if b
                    c
                end
            ]"""
            test_format(str_, str; join_lines_based_on_source = true)
        end
    end

    @testset "`indent_submodule`" begin
        str_ = """
        "doc"
        module Foo

        function foo(arg)
        body
        end

        module Bar
        x = 2
        y = 4
        baremodule C
                     foo = (arg1, arg2)
            end
        end

        z = 5

        end
        """
        str = """
        "doc"
        module Foo

        function foo(arg)
          body
        end

        module Bar
          x = 2
          y = 4
          baremodule C
            foo = (arg1, arg2)
          end
        end

        z = 5

        end
        """
        test_format(str_, str; indent = 2, margin = 22, indent_submodule = true)

        str = """
        "doc"
        module Foo

        function foo(arg)
          body
        end

        module Bar
          x = 2
          y = 4
          baremodule C
            foo =
              (arg1, arg2)
          end
        end

        z = 5

        end
        """
        test_format(str_, str; indent = 2, margin = 21, indent_submodule = true)
    end

    @testset "`surround_whereop_typeparameters`" begin
        s = """
        function NotificationType(method::AbstractString, ::Type{TPARAM}) where TPARAM
            foo
        end
        """
        test_format(s, s; surround_whereop_typeparameters = false)

        s = """
        function NotificationType(method::AbstractString, ::Type{TPARAM})::R where TPARAM
            foo
        end
        """
        test_format(s, s; surround_whereop_typeparameters = false, margin = 100)

        s = """
        NotificationType(method::AbstractString, ::Type{TPARAM}) where TPARAM = foo
        """
        test_format(s, s; surround_whereop_typeparameters = false)

        s = """
        NotificationType(method::AbstractString, ::Type{TPARAM})::R where TPARAM = foo
        """
        test_format(s, s; surround_whereop_typeparameters = false)
    end

    @testset "trailing zero" begin
        test_format("1e-2", "1e-2"; trailing_zero = true)
        test_format("1f0", "1.0f0"; trailing_zero = true)
        test_format("1.", "1.0"; trailing_zero = true)
        test_format("0x1.fp0", "0x1.fp0"; trailing_zero = true)

        test_format("1e-2", "1e-2"; trailing_zero = false)
        test_format("1f0", "1f0"; trailing_zero = false)
        test_format("1.", "1."; trailing_zero = false)
        test_format("0x1.fp0", "0x1.fp0"; trailing_zero = false)
    end

    @testset "noindent blocks" begin
        s = raw"""
        begin
        @muladd begin
            #! format: noindent
            # dawdawdaw comment
            a = 10
            b = 20

            a * b
        end
                end
        """
        s_ = raw"""
        begin
            @muladd begin
            #! format: noindent
            # dawdawdaw comment
            a = 10
            b = 20

            a * b
            end
        end
        """
        test_format(s, s_)

        s = raw"""
        begin
        @muladd begin
            #! format: noindent
            # dawdawdaw comment
            a = 10
            b = 20
            begin
               # another indent
                z = 33
            end

            a * b
        end
                end
        """
        s_ = raw"""
        begin
            @muladd begin
            #! format: noindent
            # dawdawdaw comment
            a = 10
            b = 20
            begin
                # another indent
                z = 33
            end

            a * b
            end
        end
        """
        test_format(s, s_)

        # recursive
        s = raw"""
        begin
        @muladd begin
            #! format: noindent
            # dawdawdaw comment
            a = 10
            b = 20
            begin
               # another indent
                z = 33
                        begin
                #! format: noindent
                        s = "oh shit here we go again"
                end
            end

            a * b
        end
                end
        """
        s_ = raw"""
        begin
            @muladd begin
            #! format: noindent
            # dawdawdaw comment
            a = 10
            b = 20
            begin
                # another indent
                z = 33
                begin
                #! format: noindent
                s = "oh shit here we go again"
                end
            end

            a * b
            end
        end
        """
        test_format(s, s_)
    end

    @testset "disallow single arg nesting" begin
        s1 = raw"""
        function_call(
            "String argument"
        )
        [array_item(
            10
        )]
        {key => value(
            "String value"
        )}
        """
        s2 = raw"""
        function_call("String argument")
        [array_item(10)]
        {key =>
          value("String value")}
        """
        test_format(s1, s2; indent = 2, margin = 1, disallow_single_arg_nesting = true)
    end
end

end

module InterfaceTests

using JuliaFormatter: format, format_file, BlueStyle
using Test

function test_format_file(fmt, before, after)
    sandbox_dir = joinpath(@__DIR__, "tmp")
    mkdir(sandbox_dir)
    try
        code_path = joinpath(sandbox_dir, "code.jl")
        open(io -> write(io, before), code_path, "w")

        @test fmt(code_path) == false
        @test strip(read(code_path, String)) == after
    finally
        rm(sandbox_dir; recursive = true)
    end
end

@testset "$f interface" for f in (format, format_file)
    before = "foo(; k =v)"
    @testset "style can be positional arg or keyword" begin
        pos = path -> f(path, BlueStyle())
        key = path -> f(path; style = BlueStyle())
        after = "foo(; k=v)"
        test_format_file(pos, before, after)
        test_format_file(key, before, after)
    end
    @testset "other keywords take affect" begin
        pos = path -> f(path, BlueStyle(); whitespace_in_kwargs = true)
        key = path -> f(path; style = BlueStyle(), whitespace_in_kwargs = true)
        after = "foo(; k = v)"
        test_format_file(pos, before, after)
        test_format_file(key, before, after)
    end
end

end

function options(::MinimalStyle)
    return Options(;
        indent = 4,
        indent_binary_continuations = true,
        annotate_untyped_fields_with_any = false,
        join_lines_based_on_source = true,
        trailing_comma = nothing,
        trailing_zero = false,
        margin = 10_000,
        always_for_in = nothing,
        whitespace_in_kwargs = false,
        whitespace_typedefs = false,
        whitespace_ops_in_indices = false,
        remove_extra_newlines = false,
        import_to_using = false,
        pipe_to_function_call = false,
        short_to_long_function_def = false,
        long_to_short_function_def = false,
        always_use_return = false,
        format_docstrings = false,
        align_struct_field = false,
        align_assignment = false,
        align_conditional = false,
        align_pair_arrow = false,
        conditional_to_if = false,
        normalize_line_endings = "auto",
        align_matrix = false,
        indent_submodule = false,
        separate_kwargs_with_semicolon = false,
        surround_whereop_typeparameters = false,
        variable_call_indent = [],
        yas_style_nesting = false,
    )
end

module ImportToUsingTests

using JuliaFormatter: DefaultStyle, YASStyle, BlueStyle, SciMLStyle, MinimalStyle, format_text
using JuliaFormatter.Internal: test_format
using Test

ALL_STYLES = (DefaultStyle(), YASStyle(), BlueStyle(), SciMLStyle(), MinimalStyle())

@testset "import_to_using" begin
    @testset "basic" begin
        str_ = "import A"
        str = "using A: A"
        test_format(str_, str; import_to_using = true)

        str_ = """
        import A,

        B, C"""
        str = """
        using A: A

        using B: B
        using C: C"""
        test_format(str_, str; import_to_using = true)

        str_ = """
        import A,
               # comment
        B, C"""
        str = """
        using A: A
        # comment
        using B: B
        using C: C"""
        test_format(str_, str; import_to_using = true)

        str_ = """
        import A, # inline
               # comment
        B, C # inline"""
        str = """
        using A: A # inline
        # comment
        using B: B
        using C: C # inline"""
        test_format(str_, str; import_to_using = true)
    end

    @testset "232 submodule imports disabled" begin
        # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/232
        str = """import A.b"""
        test_format(str, str; import_to_using = true)

        str = """import A.b: c"""
        test_format(str, str; import_to_using = true)

        str = """import A.b.c"""
        test_format(str, str; import_to_using = true)

        str = """import A.b.c: d"""
        test_format(str, str; import_to_using = true)

        str = "import ..A"
        test_format(str, str; import_to_using = true)
    end

    @testset "396 import X as Y disabled" begin
        # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/396
        str = """import Base.threads as th"""
        test_format(str, str)
        test_format(str, str; margin = 1)
        test_format(str, str; margin = 1, import_to_using = true)
    end

    @testset "664 import relative path disabled" begin
        # `import ..x` should not be converted to `using ..x: x` with `import_to_using`,
        # because `using ..x: x` is invalid when `x` is not a module.
        s = "module M\nimport ..x\ny = x\nend\n"
        test_format(s, s; import_to_using = true)

        str = "import ..A, .B, ...C"
        test_format(str, str; import_to_using = true)
    end

    @testset "disabled inside macro/quote" begin
        for str in (
            ":(import Foo)",
            ":(import Foo, Bar)",
            "quote\n    import Foo\nend",
            "@eval import Foo",
            "@eval(import Foo)",
        )
            for style in ALL_STYLES
                test_format(str, str, style; import_to_using = true)
            end
        end
    end
end

end

# Nest
#
# If the line exceeds the print width it will be nested.
#
# This is done by replacing `PLACEHOLDER` nodes with `NEWLINE`
# nodes and updating the FST's indent.
#
# `extra_margin` provides additional width to consider from
# the top-level node.
#
# Example:
#
#     LHS op RHS
#
# the length of " op" will be considered when nesting LHS

function nest!(
    ds::AbstractStyle,
    nodes::Vector{FST},
    s::State,
    indent::Int,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}};
    extra_margin::Int = 0,
)
    style = getstyle(ds)
    nested = false

    for (i, n) in enumerate(nodes)
        if n.typ === NEWLINE && i < length(nodes) && nodes[i+1].typ === Block
            s.line_offset = nodes[i+1].indent
        elseif n.typ === NOTCODE && i < length(nodes) && nodes[i+1].typ === Block
            s.line_offset = nodes[i+1].indent
        elseif n.typ === NEWLINE
            s.line_offset = indent
        else
            n.extra_margin = extra_margin
            nested |= nest!(style, n, s, lineage)
        end
    end

    return nested
end

function nest!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    if is_leaf(fst)
        s.line_offset += length(fst)
        return false
    elseif cant_nest(fst)
        walk(increment_line_offset!, fst, s)
        return false
    end

    style = getstyle(ds)
    push!(lineage, (fst.typ, fst.metadata))

    if fst.typ === FunctionN &&
       s.opts.long_to_short_function_def &&
       !isnothing(fst.metadata) &&
       (fst.metadata::Metadata).is_contractable_function
        long_to_short_function_def!(fst, s)
    elseif fst.typ === Binary
        line_margin = s.line_offset + length(fst) + fst.extra_margin
        if s.opts.short_to_long_function_def &&
           (line_margin > s.opts.margin || s.opts.force_long_function_def) &&
           !isnothing(fst.metadata) &&
           (fst.metadata::Metadata).is_short_form_function
            short_to_long_function_def!(fst, s, lineage)
        end
    elseif fst.typ === Conditional
        line_margin = s.line_offset + length(fst) + fst.extra_margin
        if s.opts.conditional_to_if && line_margin > s.opts.margin
            conditional_to_if_block!(fst, s, true)
        end
    end

    nested = if fst.typ === Import
        n_import!(style, fst, s, lineage)
    elseif fst.typ === Export
        n_export!(style, fst, s, lineage)
    elseif fst.typ === Public
        n_public!(style, fst, s, lineage)
    elseif fst.typ === Using
        n_using!(style, fst, s, lineage)
    elseif fst.typ === Where
        n_whereopcall!(style, fst, s, lineage)
    elseif fst.typ === Conditional
        n_conditionalopcall!(style, fst, s, lineage)
    elseif fst.typ === Binary
        n_binaryopcall!(style, fst, s, lineage)
    elseif fst.typ === Curly
        n_curly!(style, fst, s, lineage)
    elseif fst.typ === Call
        n_call!(style, fst, s, lineage)
    elseif fst.typ === MacroCall
        n_macrocall!(style, fst, s, lineage)
    elseif fst.typ === RefN
        n_ref!(style, fst, s, lineage)
        # elseif fst.typ === Row
        #     n_row!(style, fst, s)
    elseif fst.typ === TypedVcat
        n_typedvcat!(style, fst, s, lineage)
    elseif fst.typ === TypedNcat
        n_typedvcat!(style, fst, s, lineage)
    elseif fst.typ === TupleN && length(fst.nodes) > 0
        n_tuple!(style, fst, s, lineage)
    elseif fst.typ === CartesianIterator
        n_cartesian_iterator!(style, fst, s, lineage)
    elseif fst.typ === TupleBlock
        n_tupleblock!(style, fst, s, lineage)
    elseif fst.typ === Parameters
        n_parameters!(style, fst, s, lineage)
    elseif fst.typ === Vect
        n_vect!(style, fst, s, lineage)
    elseif fst.typ === Vcat
        n_vcat!(style, fst, s, lineage)
    elseif fst.typ === Hcat || fst.typ === TypedHcat
        n_hcat!(style, fst, s, lineage)
    elseif fst.typ === Ncat
        n_vcat!(style, fst, s, lineage)
    elseif fst.typ === Braces
        n_braces!(style, fst, s, lineage)
    elseif fst.typ === BracesCat
        n_bracescat!(style, fst, s, lineage)
    elseif fst.typ === Brackets
        n_parens!(style, fst, s, lineage)
    elseif fst.typ === Comprehension
        n_comprehension!(style, fst, s, lineage)
    elseif fst.typ === TypedComprehension
        n_typedcomprehension!(style, fst, s, lineage)
    elseif fst.typ === Do
        n_do!(style, fst, s, lineage)
    elseif fst.typ === Generator
        n_generator!(style, fst, s, lineage)
    elseif fst.typ === Filter
        n_filter!(style, fst, s, lineage)
        # elseif fst.typ === Block && is_closer(fst[end]) # (a;b;c)
        #     n_tuple!(style, fst, s, lineage)
    elseif fst.typ === Block
        n_block!(style, fst, s, lineage)
    elseif fst.typ === Chain
        n_chainopcall!(style, fst, s, lineage)
    elseif fst.typ === Comparison
        n_comparison!(style, fst, s, lineage)
    elseif fst.typ === For
        n_for!(style, fst, s, lineage)
    elseif fst.typ === Let
        n_let!(style, fst, s, lineage)
    elseif fst.typ === Unary && length(fst.nodes::Vector) > 1 && fst[2].typ === OPERATOR
        n_unaryopcall!(style, fst, s, lineage)
    elseif fst.typ === StringN
        n_string!(style, fst, s, lineage)
    elseif fst.typ === FunctionN
        n_functiondef!(style, fst, s, lineage)
    elseif fst.typ === Macro
        n_macro!(style, fst, s, lineage)
    else
        nest!(style, fst.nodes::Vector, s, fst.indent, lineage; extra_margin = fst.extra_margin)
    end

    pop!(lineage)

    return nested
end
function nest!(style::AbstractStyle, fst::FST, s::State)
    nest!(style, fst, s, Tuple{FNode,Union{Nothing,Metadata}}[])
end

function n_functiondef!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    nest!(ds, fst.nodes::Vector, s, fst.indent, lineage; extra_margin = fst.extra_margin)
end

function n_macro!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_functiondef!(ds, fst, s, lineage)
end

function n_string!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    style = getstyle(ds)
    # difference in positioning of the string
    # from the source document to the formatted document
    #
    # For opaque strings (non-triple-quoted multiline literals, see issue #1251) the
    # interior lines are never shifted: they are stored verbatim with indent 0 and printed
    # at column 0, so the line offset bookkeeping must not apply the shift either.
    diff = is_opaque_string(fst) ? 0 : s.line_offset - fst.indent

    nested = false
    for (i, n) in enumerate(fst.nodes::Vector)
        if n.typ === NEWLINE
            s.line_offset = fst[i+1].indent + diff
        else
            nested |= nest!(style, n, s, lineage)
        end
    end
    return nested
end

function n_unaryopcall!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    style = getstyle(ds)
    fst[1].extra_margin = fst.extra_margin + length(fst[2])
    nested = false
    # nest!(style, fst.nodes::Vector{FST}, s, fst.indent)
    nested |= nest!(style, fst[1], s, lineage)
    nested |= nest!(style, fst[2], s, lineage)
    return nested
end

function n_do!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    style = getstyle(ds)
    extra_margin = sum(length.(fst[2:3]))
    # make sure there are nodes after "do"
    if fst[4].typ === WHITESPACE
        extra_margin += length(fst[4])
        extra_margin += length(fst[5])
    end
    fst[1].extra_margin = fst.extra_margin + extra_margin
    nested = false
    nested |= nest!(style, fst[1], s, lineage)
    nested |=
        nest!(style, fst[2:end], s, fst.indent, lineage; extra_margin = fst.extra_margin)
    return nested
end

# Import,Using,Export,Public
function n_using!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    style = getstyle(ds)
    line_margin = s.line_offset + length(fst) + fst.extra_margin
    nodes = fst.nodes::Vector
    idx = findfirst(n -> n.typ === PLACEHOLDER, nodes)
    fst.indent += s.opts.indent

    nested = false
    if idx !== nothing && (line_margin > s.opts.margin || must_nest(fst))
        if can_nest(fst)
            if fst.indent + sum(length.(fst[(idx+1):end])) <= s.opts.margin
                fst[idx] = Newline(; length = fst[idx].len)
                walk(increment_line_offset!, fst, s)
                return nested
            end
        end

        for (i, n) in enumerate(nodes)
            if n.typ === NEWLINE
                s.line_offset = fst.indent
            elseif n.typ === PLACEHOLDER
                if s.opts.join_lines_based_on_source
                    si = findnext(n -> n.typ === PLACEHOLDER, nodes, i + 1)
                    nested |= nest_if_over_margin!(style, fst, s, i, lineage; stop_idx = si)
                else
                    fst[i] = Newline(; length = n.len)
                    s.line_offset = fst.indent
                end
            else
                diff = fst.indent - fst[i].indent
                add_indent!(n, s, diff)
                if i < length(nodes)
                    (n.extra_margin = 1)
                else
                    false
                end
                nested |= nest!(style, n, s, lineage)
            end
        end
    else
        nested |=
            nest!(style, nodes, s, fst.indent, lineage; extra_margin = fst.extra_margin)
    end
    return nested
end

function n_export!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_using!(ds, fst, s, lineage)
end

function n_public!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_using!(ds, fst, s, lineage)
end

function n_import!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_using!(ds, fst, s, lineage)
end

function n_tuple!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    style = getstyle(ds)
    line_margin = s.line_offset + length(fst) + fst.extra_margin
    nodes = fst.nodes::Vector
    idx = findlast(n -> n.typ === PLACEHOLDER, nodes)
    has_closer = is_closer(fst[end])

    if has_closer
        fst[end].indent = fst.indent
    end
    if !(fst.typ in (TupleN, CartesianIterator, Parameters)) || has_closer
        fst.indent += s.opts.indent
    end

    # "foo(a, b, c)" is true if "foo" and "c" are on different lines
    src_diff_line = if s.opts.join_lines_based_on_source && length(nodes) > 1
        last_arg_idx = findlast(is_iterable_arg, nodes)
        last_arg = isnothing(last_arg_idx) ? fst[end] : fst[last_arg_idx]
        fst[1].endline != last_arg.startline
    else
        false
    end

    nested = false

    if idx !== nothing && (line_margin > s.opts.margin || must_nest(fst) || src_diff_line)
        nested = true
        for (i, n) in enumerate(nodes)
            if n.typ === NEWLINE
                s.line_offset = fst.indent
            elseif n.typ === PLACEHOLDER
                if src_diff_line
                    si = findnext(
                        n -> n.typ === PLACEHOLDER || n.typ === NEWLINE,
                        nodes,
                        i + 1,
                    )
                    nested2 = nest_if_over_margin!(style, fst, s, i, lineage; stop_idx = si)
                    if has_closer && !nested2 && n.startline == fst[end].startline
                        # trailing types are automatically converted, undo this if
                        # there is no nest and the closer is on the same in the
                        # original source.
                        if fst[i-1].typ === TRAILINGCOMMA
                            fst[i-1].val = ""
                            fst[i-1].len = 0
                        end
                    end
                else
                    fst[i] = Newline(; length = n.len)
                    s.line_offset = fst.indent
                end
            elseif n.typ === TRAILINGCOMMA
                n.val = ","
                n.len = 1
            elseif has_closer && (i == 1 || i == length(nodes))
                nest!(style, n, s, lineage)
            else
                # It's an argument inside the `tuple` which needs to be indented to
                # `fst.indent`. However, we need to be careful to only indent things
                # that are genuinely on a new line.
                if i > 1 && fst[i-1].typ === NEWLINE
                    diff = fst.indent - fst[i].indent
                    add_indent!(n, s, diff)
                elseif n.typ === Row || n.typ === NRow
                    # A Row/NRow that begins on the same line as the opening bracket is not
                    # itself on a new line, but it still carries newlines of its own, which
                    # are concatenation separators belonging to _this_ node (see `p_row`).
                    # Those need to be indented to `fst.indent`. For example, in
                    #
                    #     [1
                    #     2;;
                    #     3
                    #     4]
                    #
                    # the `1\n2;;` NRow starts on the same line as `[`, and the newline
                    # between `1` and `2` belongs to the enclosing Ncat just as much as the
                    # one between `2;;` and `3` does. Both should be indented equally.
                    add_indent_after_row_newlines!(n, s, fst.indent - fst[i].indent)
                end
                n.extra_margin = 1
                nest!(style, n, s, lineage)
            end
        end

        if has_closer
            s.line_offset = fst[end].indent + 1
        end
    else
        extra_margin = if has_closer
            fst.extra_margin + 1
        else
            fst.extra_margin
        end
        nested |= nest!(style, nodes, s, fst.indent, lineage; extra_margin = extra_margin)
    end

    return nested
end

function n_cartesian_iterator!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ds, fst, s, lineage)
end

function n_tupleblock!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ds, fst, s, lineage)
end

function n_vect!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ds, fst, s, lineage)
end

function n_vcat!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ds, fst, s, lineage)
end

function n_hcat!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ds, fst, s, lineage)
end

function n_braces!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ds, fst, s, lineage)
end

function n_bracescat!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ds, fst, s, lineage)
end

function n_parameters!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ds, fst, s, lineage)
end

function n_parens!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ds, fst, s, lineage)
end

function n_call!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ds, fst, s, lineage)
end

function n_curly!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ds, fst, s, lineage)
end

function n_macrocall!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ds, fst, s, lineage)
end

function n_ref!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ds, fst, s, lineage)
end

function n_row!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ds, fst, s, lineage)
end

function n_typedvcat!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_tuple!(ds, fst, s, lineage)
end

function n_comprehension!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    if s.opts.join_lines_based_on_source
        n_tuple!(ds, fst, s, lineage)
    else
        _n_comprehension!(ds, fst, s, lineage)
    end
end

function _n_comprehension!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    style = getstyle(ds)
    line_margin = s.line_offset + length(fst) + fst.extra_margin
    nested = false

    line_margin = s.line_offset + length(fst) + fst.extra_margin
    closer = is_closer(fst[end])
    nodes = fst.nodes::Vector

    if closer && (line_margin > s.opts.margin || must_nest(fst))
        idx = findfirst(n -> n.typ === PLACEHOLDER, nodes)
        if idx !== nothing
            fst[idx] = Newline(; length = fst[idx].len)
        end
        idx = findlast(n -> n.typ === PLACEHOLDER, nodes)
        if idx !== nothing
            fst[idx] = Newline(; length = fst[idx].len)
        end

        add_indent!(fst, s, s.opts.indent)
        fst[end].indent = fst.indent - s.opts.indent
        nested = true
    end

    for (i, n) in enumerate(nodes)
        if n.typ === NEWLINE
            s.line_offset = fst.indent
        elseif n.typ === PLACEHOLDER
            if must_nest(fst)
                fst[i] = Newline(; length = n.len)
                s.line_offset = fst.indent
            else
                nest_if_over_margin!(style, fst, s, i, lineage)
            end
        elseif i == length(nodes) && !closer
            nest!(style, n, s, lineage)
        else
            n.extra_margin = nested ? 0 : 1
            nest!(style, n, s, lineage)
        end
    end

    if closer
        s.line_offset = fst[end].indent + 1
    end

    return nested
end

function n_typedcomprehension!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_comprehension!(ds, fst, s, lineage)
end

function n_generator!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    style = getstyle(ds)
    line_margin = s.line_offset + length(fst) + fst.extra_margin
    line_offset = s.line_offset
    fst.indent = s.line_offset

    nodes = fst.nodes::Vector

    src_diff_line = if s.opts.join_lines_based_on_source && length(nodes) > 1
        last_arg_idx = findlast(is_iterable_arg, nodes)
        last_arg = isnothing(last_arg_idx) ? fst[end] : fst[last_arg_idx]
        fst[1].endline != last_arg.startline
    else
        false
    end

    nested = false

    if line_margin > s.opts.margin || must_nest(fst) || src_diff_line
        nested = true
        phs = reverse(findall(n -> n.typ === PLACEHOLDER, nodes))
        if s.opts.join_lines_based_on_source
            phs = filter(idx -> fst[idx+1].typ !== NEWLINE, phs)
        end
        for (i, idx) in enumerate(phs)
            if i == 1
                fst[idx] = Newline(; length = fst[idx].len)
            else
                nidx = phs[i-1]
                l1 = sum(length.(fst[1:(idx-1)]))
                l2 = sum(length.(fst[idx:(nidx-1)]))
                width = line_offset + l1 + l2
                if must_nest(fst) || width > s.opts.margin
                    fst[idx] = Newline(; length = fst[idx].len)
                end
            end
        end

        for (i, n) in enumerate(nodes)
            if n.typ === NEWLINE
                s.line_offset = fst.indent
            elseif i == length(nodes)
                nest!(style, n, s, lineage)
            else
                n.extra_margin = 1
                nest!(style, n, s, lineage)
            end
        end

        s.line_offset = line_offset
        for (i, n) in enumerate(nodes)
            if n.typ === NEWLINE &&
               !is_comment(fst[i+1]) &&
               !is_comment(fst[i-1]) &&
               i in phs
                # +1 for newline to whitespace conversion
                width = s.line_offset + 1
                w, _ = length_to(fst, (NEWLINE,); start = i + 1)
                # Don't count a trailing PLACEHOLDER/WHITESPACE that immediately
                # precedes the next NEWLINE, because `remove_superfluous_whitespace!`
                # will zero it out. For example, in `expr <NL> for <PH> <NL> iter`,
                # the <PH> between "for" and the second NEWLINE won't appear in the
                # printed output, so it shouldn't count toward the line width.
                next_nl = findnext(x -> x.typ === NEWLINE, nodes, i + 1)
                if next_nl !== nothing && next_nl > i + 1
                    prev = fst[next_nl-1]
                    if (prev.typ === PLACEHOLDER || prev.typ === WHITESPACE) &&
                       can_remove(prev)
                        w -= length(prev)
                    end
                end
                width += w
                if width <= s.opts.margin
                    fst[i] = Whitespace(1)
                    s.line_offset += length(fst[i])
                else
                    s.line_offset = fst.indent
                end
            elseif n.typ === NEWLINE
                s.line_offset = fst.indent
            else
                walk(increment_line_offset!, fst[i], s)
            end
        end

        s.line_offset = line_offset
        walk(increment_line_offset!, fst, s)
    else
        nested |=
            nest!(style, nodes, s, fst.indent, lineage; extra_margin = fst.extra_margin)
    end
    return nested
end

function n_filter!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_generator!(ds, fst, s, lineage)
end

function n_whereopcall!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    style = getstyle(ds)
    line_margin = s.line_offset + length(fst) + fst.extra_margin
    # "B"
    has_braces = is_closer(fst[end])
    if has_braces
        fst[end].indent = fst.indent
    end

    nested = false

    if line_margin > s.opts.margin || must_nest(fst)
        nested = true
        line_offset = s.line_offset
        Blen = sum(length.(fst[2:end]))

        fst[1].extra_margin = Blen + fst.extra_margin
        nest!(style, fst[1], s, lineage)

        over = (s.line_offset + Blen + fst.extra_margin > s.opts.margin) || must_nest(fst)
        fst.indent += s.opts.indent
        for (i, n) in enumerate(fst[2:end])
            if n.typ === NEWLINE
                s.line_offset = fst.indent
            elseif is_opener(n)
                if fst.indent - s.line_offset > 1
                    fst.indent = s.line_offset + 1
                    fst[end].indent = s.line_offset
                end
                nest!(style, n, s, lineage)
            elseif n.typ === PLACEHOLDER && over
                fst[i+1] = Newline(; length = length(n))
                s.line_offset = fst.indent
            elseif n.typ === TRAILINGCOMMA && over
                n.val = ","
                n.len = 1
                nest!(style, n, s, lineage)
            elseif has_braces
                n.extra_margin = 1 + fst.extra_margin
                nest!(style, n, s, lineage)
            else
                n.extra_margin = fst.extra_margin
                nest!(style, n, s, lineage)
            end
        end

        s.line_offset = line_offset
        walk(increment_line_offset!, fst, s)
        return nested
    end

    nested |= nest!(
        style,
        fst.nodes::Vector,
        s,
        fst.indent,
        lineage;
        extra_margin = fst.extra_margin,
    )
    return nested
end

function n_conditionalopcall!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    style = getstyle(ds)
    line_margin = s.line_offset + length(fst) + fst.extra_margin
    line_offset = s.line_offset
    fst.indent = s.line_offset

    nodes = fst.nodes::Vector
    src_diff_line = if s.opts.join_lines_based_on_source && length(nodes) > 1
        last_arg_idx = findlast(is_iterable_arg, nodes)
        last_arg = isnothing(last_arg_idx) ? fst[end] : fst[last_arg_idx]
        fst[1].endline != last_arg.startline
    else
        false
    end
    nested = false

    if line_margin > s.opts.margin || must_nest(fst) || src_diff_line
        nested = true
        phs = reverse(findall(n -> n.typ === PLACEHOLDER, nodes))
        if s.opts.join_lines_based_on_source
            phs = filter(idx -> fst[idx+1].typ !== NEWLINE, phs)
        end
        for (i, idx) in enumerate(phs)
            if i == 1
                fst[idx] = Newline(; length = fst[idx].len)
            else
                nidx = phs[i-1]
                l1 = sum(length.(fst[1:(idx-1)]))
                l2 = sum(length.(fst[idx:(nidx-1)]))
                width = line_offset + l1 + l2
                if must_nest(fst) || width > s.opts.margin
                    fst[idx] = Newline(; length = fst[idx].len)
                end
            end
        end

        for (i, n) in enumerate(nodes)
            if i == length(nodes)
                n.extra_margin = fst.extra_margin
                nest!(style, n, s, lineage)
            elseif fst[i+1].typ === WHITESPACE
                n.extra_margin = length(fst[i+1]) + length(fst[i+2])
                nest!(style, n, s, lineage)
            elseif n.typ === NEWLINE
                s.line_offset = fst.indent
            else
                nest!(style, n, s, lineage)
            end
        end

        s.line_offset = line_offset
        for (i, n) in enumerate(nodes)
            if n.typ === NEWLINE &&
               !is_comment(fst[i+1]) &&
               !is_comment(fst[i-1]) &&
               i in phs
                # +1 for newline to whitespace conversion
                width = s.line_offset + 1
                if i == length(nodes) - 1
                    width += sum(length.(fst[(i+1):end])) + fst.extra_margin
                else
                    width += sum(length.(fst[(i+1):(i+3)]))
                end
                if width <= s.opts.margin
                    fst[i] = Whitespace(1)
                    s.line_offset += length(fst[i])
                else
                    s.line_offset = fst.indent
                end
            elseif n.typ === NEWLINE
                s.line_offset = fst.indent
            else
                walk(increment_line_offset!, n, s)
            end
        end

        s.line_offset = line_offset
        walk(increment_line_offset!, fst, s)
    else
        nested |=
            nest!(style, nodes, s, fst.indent, lineage; extra_margin = fst.extra_margin)
    end
    return nested
end

function no_unnest(fst::FST)
    if fst.typ === Binary ||
       fst.typ === Conditional ||
       fst.typ === Chain ||
       fst.typ === Comparison
        return contains_comment(fst)
    end
    return false
end

function n_binaryopcall!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}};
    indent::Int = -1,
)
    style = getstyle(ds)

    line_offset = s.line_offset
    line_margin = line_offset + length(fst) + fst.extra_margin

    # If there are no top-level placeholders in the FST, the binary call itself is not
    # nestable (although its children, i.e. the operands, might be).
    nodes = fst.nodes::Vector
    placeholder_idxs = findall(n -> n.typ === PLACEHOLDER, nodes)

    rhs = fst[end]
    if rhs.typ === Block
        rhs = rhs[1]
    end

    # is the LHS on a different line than the RHS ?
    src_diff_line =
        s.opts.join_lines_based_on_source && fst[1].endline != fst[end].startline

    nested = false

    if length(placeholder_idxs) == 2 &&
       (line_margin > s.opts.margin || must_nest(fst) || must_nest(rhs) || src_diff_line)
        i1 = placeholder_idxs[1]
        i2 = placeholder_idxs[2]
        fst[i1] = Newline(; length = fst[i1].len)
        nested = true

        indent_nest = is_indent_nest(fst)

        if indent_nest
            s.line_offset = fst.indent + s.opts.indent
            fst[i2] = Whitespace(s.opts.indent)

            # reset the indent of the RHS
            if fst[end].indent > fst.indent
                fst[end].indent = fst.indent
            end
            add_indent!(fst[end], s, s.opts.indent)
        else
            if indent >= 0
                fst.indent = indent
            else
                fst.indent = s.line_offset
            end
        end

        # RHS.

        # Remember the column the RHS starts at in this (nested) layout. Any alignment
        # that nesting the RHS sets up is relative to this column, so if the nesting is
        # undone further below we need to know how far the RHS has moved sideways.
        rhs_line_offset_when_op_nested = s.line_offset
        fst[end].extra_margin = fst.extra_margin
        nest!(style, fst[end], s, lineage)

        # "lhs op" rhs
        s.line_offset = line_offset

        # Nest the LHS, but first update the extra margin corresponding to " op"
        fst[1].extra_margin = length(fst[2]) + length(fst[3])
        nest!(style, fst[1], s, lineage)
        # Nest everything up to the operator
        for n in fst[2:i1]
            nest!(style, n, s, lineage)
        end

        # It's possible that nesting the LHS means that it's shorter, and thus we might not
        # need to nest the entire binaryop (i.e., we might not need newlines around the
        # operator). Attempt to undo the nesting here.
        if can_nest(fst) && !no_unnest(rhs) && !src_diff_line
            line_margin = s.line_offset

            # replace IN with all of precedence level 6
            if (rhs.typ === Binary && !(op_kind(rhs) in KSet"in ::")) ||
               rhs.typ === Unary && rhs[end].typ !== Brackets ||
               rhs.typ === Chain ||
               rhs.typ === Comparison ||
               rhs.typ === Conditional
                line_margin += length(fst[end])
            elseif rhs.typ === Do && is_iterable(rhs[1])
                rw, _ = length_to(fst, (NEWLINE,); start = i2 + 1)
                line_margin += rw
            elseif is_block(rhs)
                idx = findfirst(n -> n.typ === NEWLINE, rhs.nodes)
                if idx === nothing
                    line_margin += length(fst[end])
                else
                    line_margin += sum(length.(rhs[1:(idx-1)]))
                end
            else
                # Calculate how much of the RHS we need to fit on the current line
                rw, _ = length_to(fst, (NEWLINE,); start = i2 + 1)
                line_margin += rw
            end

            if line_margin + fst.extra_margin <= s.opts.margin
                fst[i1] = Whitespace(1)
                if indent_nest || style isa YASStyle
                    fst[i2] = Whitespace(0)
                    line_offset = s.line_offset
                    walk(unnest!(style; dedent = true), rhs, s)
                    # The RHS may span multiple lines, in which case we need to decide
                    # how to reindent its continuation lines.
                    #
                    # If the RHS aligns its continuation lines against the column it
                    # starts at (see `is_column_aligned`), then we need to reuse the
                    # `rhs_line_offset_when_op_nested` that we calculated earlier.
                    #
                    # When we undo the nesting, the rhs gets moved to column `line_offset`,
                    # so every indent inside it has to be offset by the difference with
                    # `rhs_line_offset_when_op_nested`.
                    #
                    # `s.opts.indent` is added back on because `unnest!` above dedented the
                    # whole RHS by one level.
                    if style isa YASStyle && is_column_aligned(rhs)
                        add_indent!(
                            rhs,
                            s,
                            line_offset - rhs_line_offset_when_op_nested + s.opts.indent,
                        )
                    end
                    # For default style, nothing is 'column aligned' so we don't need to do
                    # anything.
                end
            end
        end

        s.line_offset = line_offset
        walk(increment_line_offset!, fst, s)
        return nested
    end

    # When we nest the LHS, we have to do so with some knowledge of how much space the RHS
    # will take up. However, we don't need to account for the _full_ RHS, because the RHS
    # could itself be nested, and in general nesting the RHS is preferable to nesting the
    # LHS as it's prettier. That means we only need to account for the RHS up to the first
    # point where it could be nested.
    #
    # Since node 1 is the LHS, we start looking for the first placeholder from node 2
    # onwards.
    len_to_first_placeholder, found = length_to(fst, (PLACEHOLDER, NEWLINE); start = 2)
    lhs_extra_margin_needed = if found && op_kind(fst) !== K"::"
        len_to_first_placeholder
    else
        # Can't nest the op or RHS. That means that we need to account for the entire RHS,
        # plus anything that comes after the binary expression as well.
        sum(length, fst[2:end]) + fst.extra_margin
    end

    for (i, n) in enumerate(nodes)
        if n.typ === NEWLINE
            s.line_offset = fst.indent
        elseif i == 1
            n.extra_margin = lhs_extra_margin_needed
            nested |= nest!(style, n, s, lineage)
        elseif i == length(nodes)
            # rhs
            if style isa YASStyle
                if is_unnamed_iterable(rhs)
                    extra_indent = if !isempty(rhs.nodes) && is_opener(rhs[1])
                        s.line_offset - fst.indent + 1
                    else
                        s.line_offset - fst.indent
                    end
                    add_indent!(rhs, s, extra_indent)
                elseif is_named_iterable(rhs)
                    extra_indent =
                        s.line_offset - fst.indent + length(rhs[1]) + length(rhs[2])
                    add_indent!(rhs, s, extra_indent)
                end
            end
            n.extra_margin = fst.extra_margin
            nested |= nest!(style, n, s, lineage)
        else
            nested |= nest!(style, n, s, lineage)
        end
    end

    return nested
end

function n_for!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    style = getstyle(ds)

    nested = false
    nodes = fst.nodes::Vector{FST}
    for (i, n) in enumerate(nodes)
        if n.typ === NEWLINE && nodes[i+1].typ === Block
            s.line_offset = nodes[i+1].indent
        elseif n.typ === NOTCODE && nodes[i+1].typ === Block
            s.line_offset = nodes[i+1].indent
        elseif n.typ === NEWLINE
            s.line_offset = fst.indent
        elseif n.typ === PLACEHOLDER && nested
            fst[i] = Newline(; length = n.len, nest_behavior = AllowNestButDontRemove)
            s.line_offset = fst.indent
        else
            n.extra_margin = fst.extra_margin
            nested |= nest!(style, n, s, lineage)
        end
    end

    return nested
end

function n_let!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_for!(ds, fst, s, lineage)
end

function n_block!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}};
    indent::Int = -1,
)
    style = getstyle(ds)

    line_margin = s.line_offset + length(fst) + fst.extra_margin
    nodes = fst.nodes::Vector
    idx = findfirst(n -> n.typ === PLACEHOLDER, nodes)
    has_nl = false
    if indent >= 0
        (fst.indent = indent)
    else
        false
    end

    if fst.typ === Chain &&
       !isnothing(fst.metadata) &&
       (fst.metadata::Metadata).is_standalone_shortcircuit
        fst.indent += s.opts.indent
    end

    src_diff_line = if s.opts.join_lines_based_on_source && length(nodes) > 1
        last_arg_idx = findlast(is_iterable_arg, nodes)
        last_arg = isnothing(last_arg_idx) ? fst[end] : fst[last_arg_idx]
        fst[1].endline != last_arg.startline
    else
        false
    end

    nested = false

    if idx !== nothing && (line_margin > s.opts.margin || must_nest(fst) || src_diff_line)
        nested = true

        for (i, n) in enumerate(nodes)
            if n.typ === NEWLINE
                s.line_offset = fst.indent
                has_nl = true
            elseif n.typ === PLACEHOLDER
                # NOTE:
                #
                # Placeholder at the end of a block is the separator
                # to the body. For example:
                #
                # for x in (a, b), y in (c, d)
                #     body
                # end
                #
                # If "x in (a, b), y in (c, d)" is nested then a newline
                # is inserted to separte "y in (c, d)" from "body":
                #
                # for x in (a, b),
                #     y in (c, d)
                #
                #     body
                # end
                #
                if s.opts.join_lines_based_on_source
                    if i < length(nodes)
                        si = findnext(
                            n -> n.typ === PLACEHOLDER || n.typ === NEWLINE,
                            nodes,
                            i + 1,
                        )
                        nest_if_over_margin!(style, fst, s, i, lineage; stop_idx = si)
                    elseif has_nl
                        fst[i] = Newline(; length = n.len)
                        s.line_offset = fst.indent
                    else
                        nest!(style, n, s, lineage)
                    end
                else
                    fst[i] = Newline(; length = n.len)
                    s.line_offset = fst.indent
                    has_nl = true
                end
            elseif n.typ === TRAILINGCOMMA
                n.val = ","
                n.len = 1
                nest!(style, n, s, lineage)
            else
                diff = fst.indent - fst[i].indent
                add_indent!(n, s, diff)
                if i < length(nodes) - 1 && fst[i+2].typ === OPERATOR
                    # chainopcall / comparison
                    n.extra_margin = 1 + length(fst[i+2])
                elseif i < length(nodes)
                    if !(i == length(nodes) - 1 && fst[i+1].typ === PLACEHOLDER)
                        n.extra_margin = 1
                    end
                end
                nest!(style, n, s, lineage)
            end
        end
    else
        nested |=
            nest!(style, nodes, s, fst.indent, lineage; extra_margin = fst.extra_margin)
    end
    return nested
end

function n_comparison!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_block!(ds, fst, s, lineage; indent = s.line_offset)
end

function n_chainopcall!(
    ds::AbstractStyle,
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    n_block!(ds, fst, s, lineage; indent = s.line_offset)
end

function skip_indent(fst::FST)
    if fst.typ == LITERAL && fst.val == ""
        return true
    elseif fst.typ === NEWLINE || fst.typ === NOTCODE
        return true
    end
    false
end

function walk(f::Function, nodes::Vector{FST}, s::State, indent::Int)
    for (i, n) in enumerate(nodes)
        if n.typ === NEWLINE && i < length(nodes)
            if is_closer(nodes[i+1])
                s.line_offset = nodes[i+1].indent
            elseif !skip_indent(nodes[i+1])
                s.line_offset = indent
            end
        else
            walk(f, n, s)
        end
    end
end

"""
    walk(f, fst::FST, s::State)

Walks `fst` calling `f` on each node.

In situations where descending further into a subtree is not desirable `f`
should return a value other than `nothing`.

!!! note
    This function mutates the State's (`s`) `line_offset`. If this is not desired
    you should save the value before calling this function and restore it after.
"""
function walk(f::Function, fst::FST, s::State)
    stop = f(fst, s)
    if (stop !== nothing || is_leaf(fst))
        return
    end
    walk(f, fst.nodes::Vector, s, fst.indent)
end

function increment_line_offset!(fst::FST, s::State)
    if !(is_leaf(fst))
        return
    end
    s.line_offset += length(fst)
    return nothing
end

function add_indent!(fst::FST, s::State, indent::Int)
    if indent == 0
        return
    end
    f = (fst::FST, _::State) -> begin
        fst.indent += indent
        return nothing
    end
    lo = s.line_offset
    walk(f, fst, s)
    s.line_offset = lo
end

# Indent the lines that a `Row`/`NRow` node starts *itself*, i.e. those that follow one of
# its own newlines, leaving the rest of its descendants alone.
function add_indent_after_row_newlines!(fst::FST, s::State, indent::Int)
    if indent == 0 || is_leaf(fst)
        return
    end
    fst.indent += indent
    nodes = fst.nodes::Vector
    for (i, n) in enumerate(nodes)
        if i > 1 && nodes[i-1].typ === NEWLINE
            add_indent!(n, s, indent)
        elseif n.typ === Row || n.typ === NRow
            add_indent_after_row_newlines!(n, s, indent)
        end
    end
    return nothing
end

function gettreeval(fst::FST)::String
    if is_leaf(fst)
        return fst.val
    end
    ss = ""
    for n in fst.nodes
        ss *= gettreeval(n)
    end
    return ss
end

# unnest, converts newlines to whitespace
function nl_to_ws!(fst::FST, nl_inds::Vector{Int})
    for (i, ind) in enumerate(nl_inds)
        fst[ind] = Whitespace(fst[ind].len)
        if !(i == length(nl_inds))
            continue
        end
        pn = fst[ind-1]
        if pn.typ === TRAILINGCOMMA
            pn.val = ""
            pn.len = 0
        elseif fst.typ === Binary && fst[ind+1].typ === WHITESPACE
            # remove additional indent
            fst[ind+1] = Whitespace(0)
        end
    end
end

function nl_to_ws!(fst::FST, s::State)
    nl_inds = findall(n -> n.typ === NEWLINE && can_nest(n), fst.nodes)
    if !(length(nl_inds) > 0)
        return
    end
    margin = s.line_offset + fst.extra_margin + length(fst)
    if margin <= s.opts.margin
        nl_to_ws!(fst, nl_inds)
    end
    return
end

function dedent!(fst::FST, s::State)
    if is_closer(fst) || fst.typ === NOTCODE
        fst.indent -= s.opts.indent
    elseif is_leaf(fst) || fst.typ === StringN
        return
    else
        fst.indent -= s.opts.indent
    end
end

function unnest!(style::AbstractStyle, fst::FST, s::State; dedent::Bool)
    if is_leaf(fst)
        s.line_offset += length(fst)
    end

    if dedent
        dedent!(fst, s)
    end

    if is_leaf(fst) || fst.typ === StringN || !can_nest(fst)
        return
    end

    nl_to_ws!(fst, s)

    return
end

function unnest!(style::AbstractStyle; dedent::Bool)
    (fst::FST, s::State) -> begin
        unnest!(style, fst, s; dedent = dedent)
    end
end

small_margin_overrun(opts::Options) = opts.sciml_margin_overrun ÷ 2
default_margin_overrun(opts::Options) = opts.sciml_margin_overrun
index_margin_overrun(opts::Options) = (3 * opts.sciml_margin_overrun) ÷ 2
macro_margin_overrun(opts::Options) = 3 * opts.sciml_margin_overrun

"""
    nest_if_over_margin!(
        style,
        fst::FST,
        s::State,
        idx::Int;
        stop_idx::Union{Int,Nothing} = nothing,
    )::Bool

Converts the node at `idx` to a `NEWLINE` if the current margin plus the additional margin
from `fst[idx:stop_idx-1]` is greater than the allowed margin.

If `stop_idx == nothing` the range is `fst[idx:end]`.

Returns whether nesting occurred.
"""
function nest_if_over_margin!(
    style::AbstractStyle,
    fst::FST,
    s::State,
    idx::Int,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}};
    stop_idx::Union{Int,Nothing} = nothing,
)::Bool
    @assert fst[idx].typ == PLACEHOLDER
    margin = s.line_offset
    if stop_idx === nothing
        margin += sum(length.(fst[idx:end])) + fst.extra_margin
    else
        margin += sum(length.(fst[idx:(stop_idx-1)]))
    end

    # Force nesting next to line comments (INLINECOMMENT / NOTCODE) because they
    # extend to end-of-line and anything after them *must* go on a new line.
    # Inline block comments (#= … =#) are truly inline and should only trigger
    # nesting when the margin is actually exceeded.
    _is_line_comment(n) = is_comment(n) && n.typ !== HASHEQCOMMENT
    if margin > s.opts.margin ||
       (idx < length(fst.nodes::Vector) && _is_line_comment(fst[idx+1])) ||
       (idx > 1 && _is_line_comment(fst[idx-1]))
        fst[idx] = Newline(; length = fst[idx].len)
        s.line_offset = fst.indent
        return true
    end

    nest!(style, fst[idx], s, lineage)
    return false
end

# TOOD: further improve the runtime of this function
function find_all_segment_splits(dp::Matrix{Int}, k::Int, max_margin::Int)
    res = Vector{Int}[]
    n = size(dp, 1)

    if n == k
        return Vector{Int}[fill(1, k)]
    elseif k == 1
        return Vector{Int}[[n]]
    end

    # Maximum recursion depth to prevent infinite loops
    max_recursions = 100

    function _backtrack(t::Vector{Int}, current_sum::Int, recursion_count::Int)
        # Check recursion limit
        if recursion_count > max_recursions
            # Early exit if we've recursed too many times
            return
        end

        if length(t) == k
            if current_sum == n
                push!(res, t)
            end
            return
        elseif current_sum >= n
            return
        end

        for i in 1:(n-k+1)
            if current_sum + i > n
                break
            end
            if dp[current_sum+1, current_sum+i] > max_margin
                break
            end
            _backtrack([t; i], current_sum + i, recursion_count + 1)
        end
    end

    for i in 1:(n-k+1)
        cm = dp[1, i]
        if cm > max_margin
            break
        end
        _backtrack([i], i, 1)
    end

    if length(res) == 0
        return [[n]]
    end

    return res
end

"""
Finds the optimal placeholders to turn into a newlines such that the length of the arguments on each line is as close as possible while following margin constraints.
"""
function find_optimal_nest_placeholders(
    fst::FST,
    start_line_offset::Int,
    opts::Options,
    ;
    margin_line_offset::Int = start_line_offset,
    for_tuple_binding_lhs::Bool = false,
)::Vector{Int}
    return find_optimal_nest_placeholders(
        fst,
        start_line_offset,
        opts.margin,
        opts;
        margin_line_offset,
        for_tuple_binding_lhs,
    )
end

function _is_for_tuple_binding_lhs(
    fst::FST,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    # The LHS tuple in `for (a, b, ...) in rhs` is the special case that SciML
    # keeps flat when it fits within the configured margin overrun.
    if fst.typ !== TupleN ||
       length(lineage) < 3 ||
       lineage[end-1][1] !== Binary ||
       lineage[end-2][1] !== CartesianIterator
        return false
    end

    metadata = lineage[end-1][2]
    return metadata isa Metadata && metadata.op_kind in KSet"in ∈"
end

function find_optimal_nest_placeholders(
    fst::FST,
    start_line_offset::Int,
    max_margin::Int,
    opts::Options = Options(),
    ;
    margin_line_offset::Int = start_line_offset,
    for_tuple_binding_lhs::Bool = false,
)::Vector{Int}
    placeholder_inds = findall(n -> n.typ === PLACEHOLDER, fst.nodes)
    total_length = margin_line_offset + length(fst) + fst.extra_margin

    # SciML tuple bindings are allowed to stay flat within margin overrun even
    # when the surrounding iterator expression needs to break.
    if for_tuple_binding_lhs && total_length <= max_margin + default_margin_overrun(opts)
        return Int[]
    elseif length(placeholder_inds) <= 1 || length(placeholder_inds) >= 500
        return placeholder_inds
    end

    # For certain expression types, be more conservative about line breaking
    # to avoid breaking readable expressions across multiple lines
    if (fst.typ === RefN && length(placeholder_inds) <= 4)
        # Don't break short array indexing expressions like II[i, j, 1]
        return Int[]
    elseif (fst.typ === MacroCall && length(placeholder_inds) <= 10)
        # Don't break macro calls like @unpack a, b, c = struct or @time ts, us = func()
        # unless they're significantly over the margin
        if total_length <= max_margin + macro_margin_overrun(opts)
            return Int[]
        end
    elseif (fst.typ === Call && length(placeholder_inds) <= 5)
        # Be more conservative with function calls to avoid awkward breaks
        if total_length <= max_margin + default_margin_overrun(opts)
            return Int[]
        end
    elseif (fst.typ === Curly && length(placeholder_inds) <= 4)
        # Don't break short type parameter lists like Type{A, B, C}
        # unless the margin is extremely tight
        if total_length <= max_margin + small_margin_overrun(opts)
            return Int[]
        end
    elseif (fst.typ === Vect && length(placeholder_inds) <= 4)
        # Don't break short vector literals like [a, b, c] unless necessary
        if total_length <= max_margin + small_margin_overrun(opts)
            return Int[]
        end
    elseif (fst.typ === Binary || fst.typ === Chain || fst.typ === Comparison)
        # Special handling for assignments - don't break LHS
        if fst.typ === Binary &&
           !isnothing(fst.metadata) &&
           (fst.metadata::Metadata).is_assignment
            # For assignments, find the operator position
            # Assignment structure: LHS placeholder op placeholder RHS
            # We want to avoid breaking before the operator
            if length(placeholder_inds) >= 2
                # Skip the first placeholder (which comes after LHS)
                return placeholder_inds[2:end]
            end
        end

        # For mathematical expressions, be conservative about breaking
        # Only break if significantly over margin or has many operations
        if length(placeholder_inds) <= 3 &&
           total_length <= max_margin + default_margin_overrun(opts)
            return Int[]
        elseif length(placeholder_inds) <= 6 && total_length <= max_margin
            return Int[]
        end
    elseif (fst.typ === Conditional)
        # For ternary operators, avoid breaking unless necessary
        if length(placeholder_inds) <= 2 &&
           total_length <= max_margin + small_margin_overrun(opts)
            return Int[]
        end
    end
    newline_inds = findall(n -> n.typ === NEWLINE, fst.nodes)

    placeholder_groups = Vector{Int}[]
    i = 1
    current_group = Int[]
    for ind in placeholder_inds
        if i > length(newline_inds) || ind < newline_inds[i]
            push!(current_group, ind)
        else
            push!(placeholder_groups, current_group)
            current_group = Int[ind]
            i += 1
        end
    end
    push!(placeholder_groups, current_group)

    optimal_placeholders = Int[]
    for (i, g) in enumerate(placeholder_groups)
        optinds = find_optimal_nest_placeholders(
            fst,
            g,
            start_line_offset,
            max_margin;
            last_group = i == length(placeholder_groups),
        )
        push!(optimal_placeholders, optinds...)
    end

    # @info "optimal_placeholders" optimal_placeholders
    return optimal_placeholders
end

function find_optimal_nest_placeholders(
    fst::FST,
    placeholder_inds::Vector{Int},
    initial_offset::Int,
    max_margin::Int;
    last_group::Bool = false,
)::Vector{Int}
    # Function to calculate the length of a segment
    segment_length =
        (start_idx::Int, end_idx::Int) -> begin
            if placeholder_inds[end] == end_idx && last_group
                sum(length.(fst[start_idx:end])) + fst.extra_margin
            else
                sum(length.(fst[start_idx:(end_idx-1)]))
            end
        end

    n = length(placeholder_inds)
    dp = fill(0, n - 1, n - 1)

    # Initialize the lengths of segments with single placeholders
    for i in 1:(n-1)
        for j in (i+1):n
            len = segment_length(placeholder_inds[i], placeholder_inds[j])
            dp[i, j-1] = len
        end
    end

    # @info "" dp placeholder_inds

    N = size(dp, 1)

    function find_best_segments(s::Int)
        if s == 1
            return [(1, N)]
        elseif s == N
            return [(i, i) for i in 1:N]
        end

        _f = (t::Vector{Int}) -> begin
            local ranges = UnitRange{Int}[]
            local s = 1
            for tt in t
                push!(ranges, s:(s+tt-1))
                s += tt
            end
            ranges
        end

        all_splits = find_all_segment_splits(dp, s, max_margin)

        best_split = UnitRange{Int}[]
        min_diff = 1_000_000 # big number!
        # @info "all_splits" s all_splits
        for split in all_splits
            ranges = _f(split)
            # @info "" split ranges
            lens = [dp[r[1], r[end]] for r in ranges]
            diff = maximum(lens) - minimum(lens)
            if diff < min_diff
                min_diff = diff
                best_split = ranges
            end
        end
        return best_split
    end

    # Calculate best splits for each number of segments s
    segments = Tuple{Int,Int}[]
    for s in 1:N
        segments = find_best_segments(s)
        fits = true
        for (i, s) in enumerate(segments)
            if i == 1
                fits &= initial_offset + dp[first(s), last(s)] <= max_margin
            else
                fits &= initial_offset + dp[first(s), last(s)] <= max_margin
            end
        end
        if fits
            break
        end
    end
    # @info "segments" segments placeholder_inds

    # if it's one segment it means it all fits.
    if length(segments) <= 1
        return Int[]
    end

    # ex: (ph, arg, ph, arg, ph, arg, ph)
    # Convert segments to placeholder indices
    optimal_placeholders = Int[]
    for i in 1:(length(segments)-1)
        s2 = segments[i+1]
        i1 = first(s2)
        push!(optimal_placeholders, placeholder_inds[i1])
    end
    return optimal_placeholders
end

"""
    chain_continuation_indent(fst::FST, s::State)

Indentation used for the continuation lines of operator chains, comparisons and binary
operator calls.

By default these are aligned to the column at which the expression starts:

    x = (aaa |>
         bbb |>
         ccc)

When the `indent_binary_continuations` option is enabled they instead receive one indent
level relative to the indentation of the expression itself (see #592):

    x = (aaa |>
        bbb |>
        ccc)
"""
function chain_continuation_indent(fst::FST, s::State)
    s.opts.indent_binary_continuations || return s.line_offset
    md = fst.metadata
    # Standalone short-circuit chains (e.g. a top-level `a && b` used only for its side
    # effect) already receive an extra `s.opts.indent` inside `n_block!`; adding it again
    # here would double it.
    extra = (md isa Metadata && md.is_standalone_shortcircuit) ? 0 : s.opts.indent
    return fst.indent + extra
end

# Shims that provide higher-level functionality for JuliaFormatter to use.

module Shims

using JuliaSyntax
using JuliaSyntax: @KSet_str, @K_str, JuliaSyntax as JS

"""
Determine if a CST represents a function call, i.e., `F(X1, X2, ...)` syntactically.

This covers, for example:

- `f(x)`    ->   K"call"
- `f.(x)`   ->   K"dotcall"
- `<=(x)`   ->   K"call"
- `.<=(x)`  ->   K"call" (with a dotted caller)
- `<:(x)`   ->   K"<:", caught by is_type_operator
- `.<:(x)`  ->   K"call" (with a dotted caller)

`<:` and `>:` are special-cased by JuliaSyntax to return K"<:" and K">:" nodes rather than
K"call", but from a syntax perspective we want to treat them the same as any other function.

We then need to exclude a few things:

- applications of unary operators, for example, `+x`, `-x`, and `<:x`. These are still
  parsed as K"call" but these can be identified by the fact that
  `JuliaSyntax.is_prefix_op_call` returns `true` for these. BUT, we don't want to exclude
  the parenthesised versions +(x), -(x) since these do *look* like function calls (and we
  only care about the syntax, not the semantics)! So need some custom logic to identify
  these...

- bare operators, easily identified by `is_leaf`.

- infix operators, for which `JuliaSyntax.is_infix_op_call` USUALLY returns `true` (but
  not for `a <: b` --- hence why we instead do a check for K"(").

Note: `JuliaSyntax.is_prefix_call` *sounds* like the right thing to check, but for some
reason this returns `true` for tons of things we don't care about. For example:

```julia
julia> JS.is_prefix_call(JS.parseall(JS.GreenNode, "1")[1])
true
```
"""
function is_function_call(cst::JS.GreenNode)
    JS.is_leaf(cst) && return false
    return if JS.is_type_operator(cst)
        any(c -> kind(c) in KSet"( parens", JS.children(cst))
    elseif kind(cst) in KSet"call dotcall"
        if JS.is_infix_op_call(cst)
            false
        elseif JS.is_prefix_op_call(cst)
            # reject +x but not +(x)
            non_ws_idxs = findall(n -> !JS.is_whitespace(n), JS.children(cst))
            if kind(cst) == K"call"
                length(non_ws_idxs) < 2 &&
                    error("unreachable: prefix call with not enough things")
                kind(cst[non_ws_idxs[2]]) in KSet"( parens"
            elseif kind(cst) == K"dotcall"
                length(non_ws_idxs) < 3 &&
                    error("unreachable: prefix call with not enough things")
                kind(cst[non_ws_idxs[3]]) in KSet"( parens"
            end
        else
            true
        end
    else
        false
    end
end

"""
    is_caller_in_function_def(t::JuliaSyntax.GreenNode) -> Bool

Identify the caller in a function definition, i.e., the `f(...)` part in

    function f(...)
        body
    end

This may be more complicated than just `is_function_call`, because the caller may be
`f(...)::T`, `f(...) where T`, or (f(...)) (or combinations thereof).
"""
function is_caller_in_function_def(t::JuliaSyntax.GreenNode)::Bool
    return if is_function_call(t)
        true
    elseif kind(t) in KSet":: where parens" && !JS.is_leaf(t)
        childs = JS.children(t)
        idx = findfirst(n -> !JS.is_whitespace(n) && !(kind(n) in KSet"( )"), childs)
        !isnothing(idx) && is_caller_in_function_def(childs[idx])
    else
        false
    end
end

"""
    is_valid_nonword_operator(s::AbstractString) -> Bool

Check whether the string `s` is a valid operator in Julia, via JuliaSyntax.

Excludes word operators (i.e., `in`, `isa`, and `where`)..
"""
function is_valid_nonword_operator(s::AbstractString)
    try
        k = JS.Kind(s)
        return JS.is_operator(k) && !JS.is_word_operator(k)
    catch
        return false
    end
end

"""
    is_really_whitespace(cst::JS.GreenNode) -> Bool

Check whether a CST node is really whitespace, i.e., either K"Whitespace" or K"NewlineWs".
Note that `JuliaSyntax.is_whitespace` returns true for K"Comment" as well, which we don't
want here.
"""
function is_really_whitespace(cst::JS.GreenNode)
    return kind(cst) in KSet"Whitespace NewlineWs"
end

end # module

module IssuesTests

using JuliaFormatter
using JuliaFormatter: DefaultStyle, YASStyle, BlueStyle, MinimalStyle, SciMLStyle, Options, format_text
using JuliaFormatter.Internal: test_format, ALL_STYLES
using JuliaSyntax
using Test

function run_nest(text::String; opts = Options(), style = DefaultStyle())
    d = JuliaFormatter.Document(text)
    s = JuliaFormatter.State(d, opts)
    g = JuliaSyntax.parseall(JuliaSyntax.GreenNode, text; version=JuliaFormatter.SUPPORTED_SYNTAX_VERSION)
    t = JuliaFormatter.pretty(style, g, s)
    JuliaFormatter.nest!(style, t, s)
    t, s
end

@testset "GitHub Issues" begin
    @testset "137" begin
        str = """
        (
            let x = f() do
                    body
                end
                x
            end for x in xs
        )"""
        str_ = """
        (
               let x = f() do
                       body
                   end
                   x
               end for x in xs
         )"""
        # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/1048
        @test_broken false
        # test_format(str_, str)

        str = """
        (
            let
                x = f() do
                    body
                end
                x
            end for x in xs
        )"""
        str_ = """
        (
              x = f() do
                  body
              end
              x
          end for x in xs)"""
        # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/1048
        @test_broken false
        # test_format(str_, str)

        str = """
        let n = try
                ..
            catch
                ..
            end
            ..
        end"""
        test_format(str, str)

        str = """
        let n = let
                ..
            end
            ..
        end"""
        test_format(str, str)

        str = """
        let n = begin
                ..
            end
            ..
        end"""
        test_format(str, str)
    end

    @testset "139" begin
        str_ = """
        m = match(r\"""
                  (
                      pattern1 |
                      pattern2 |
                      pattern3
                  )
                  \"""x, aaa, str)"""
        str = """
        m = match(
            r\"""
            (
                pattern1 |
                pattern2 |
                pattern3
            )
            \"""x,
            aaa,
            str,
        )"""
        test_format(str_, str)

        str_ = """
        m = match(r```
                  (
                      pattern1 |
                      pattern2 |
                      pattern3
                  )
                  ```x, aaa, str)"""
        str = """
        m = match(
            r```
            (
                pattern1 |
                pattern2 |
                pattern3
            )
            ```x,
            aaa,
            str,
        )"""
        test_format(str_, str)

        str_ = """
        y = similar([
            1
            2
            3
        ], (4, 5))"""
        str = """
        y = similar(
            [
                1
                2
                3
            ],
            (4, 5),
        )"""
        test_format(str_, str)

        str_ = """
        y = similar(T[
            1
            2
            3
        ], (4, 5))"""
        str = """
        y = similar(
            T[
                1
                2
                3
            ],
            (4, 5),
        )"""
        test_format(str_, str)
    end

    @testset "150" begin
        str_ = "const SymReg{B,MT} = ArrayReg{B,Basic,MT} where {MT <:AbstractMatrix{Basic}}"
        str = "const SymReg{B,MT} = ArrayReg{B,Basic,MT} where {MT<:AbstractMatrix{Basic}}"
        test_format(str_, str; whitespace_typedefs = false)

        str = "const SymReg{B, MT} = ArrayReg{B, Basic, MT} where {MT <: AbstractMatrix{Basic}}"
        test_format(str_, str; whitespace_typedefs = true)
    end

    @testset "170" begin
        str_ = """
        ys = ( if p1(x)
                 f1(x)
        elseif p2(x)
            f2(x)
        else
            f3(x)
        end for    x in xs)
        """
        str = """
        ys = (
            if p1(x)
                f1(x)
            elseif p2(x)
                f2(x)
            else
                f3(x)
            end for x in xs
        )
        """
        # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/1048
        @test_broken false
        # test_format(str_, str)

        str = """
        ys = map(xs) do x
            if p1(x)
                f1(x)
            elseif p2(x)
                f2(x)
            else
                f3(x)
            end
        end
        """
        test_format(str, str)

        str_ = """
        y1 = Any[if true
            very_very_very_very_very_very_very_very_very_very_very_very_very_very_very_very_long_expr
        end for i in 1:1]"""
        str = """
        y1 = Any[
            if true
                very_very_very_very_very_very_very_very_very_very_very_very_very_very_very_very_long_expr
            end for i = 1:1
        ]"""
        test_format(str_, str)
        _, s = run_nest(str_; opts = Options(; margin = 100))
        @test s.line_offset == 1

        str_ = """
        y1 = [if true
            very_very_very_very_very_very_very_very_very_very_very_very_very_very_very_very_long_expr
        end for i in 1:1]"""
        str = """
        y1 = [
            if true
                very_very_very_very_very_very_very_very_very_very_very_very_very_very_very_very_long_expr
            end for i = 1:1
        ]"""
        test_format(str_, str)
        _, s = run_nest(str_; opts = Options(; margin = 100))
        @test s.line_offset == 1

        str_ = """
        y1 = [if true
            short_expr
        end for i in 1:1]"""
        str = """
        y1 = [
            if true
                short_expr
            end for i = 1:1
        ]"""
        test_format(str_, str)
        _, s = run_nest(str_; opts = Options(; margin = 100))
        @test s.line_offset == 1
    end

    @testset "183 & 525" begin
        # fixing 525 caused the previous test to fail since it
        # exchanged the semicolon to a trailing comma, which isn't exactly
        # what we wanted and it turns out sometimes the comma was
        # added in addition to the semicolon. Now, if the semicolon
        # is there the trailing comma is not added.
        str_ = """
        function f(args...)

            next!(s.progress;
            # comment
            )
            nothing
        end"""
        str = """
        function f(args...)

            next!(
                s.progress;
                # comment
            )
            nothing
        end"""
        test_format(str_, str)
    end

    @testset "189" begin
        str_ = """
    D2 = [
            (b_hat * y - delta_hat[i] * y) * gamma[i] + (b * y_hat - delta[i] * y_hat) *
                                                            gamma_hat[i] + (b_hat - y_hat) *
                                                                           delta[i] + (b - y) *
                                                                                      delta_hat[i] - delta[i] * delta_hat[i]
            for i = 1:8
        ]"""
        str = """
        D2 = [
            (b_hat * y - delta_hat[i] * y) * gamma[i] +
            (b * y_hat - delta[i] * y_hat) * gamma_hat[i] +
            (b_hat - y_hat) * delta[i] +
            (b - y) * delta_hat[i] - delta[i] * delta_hat[i] for i = 1:8
        ]"""
        test_format(str_, str)
    end

    @testset "193" begin
        str = """
        module Module
        # comment
        end"""
        test_format(str, str)

        str = """
        module Module
        # comment
        @test
        # comment
        end"""
        test_format(str, str)
    end

    @testset "194" begin
        str_ = """
        function mystr( str::String )
        return SubString( str, 1:
        3 )
        end"""
        str = """
        function mystr(str::String)
            return SubString(str, 1:3)
        end"""
        test_format(str_, str)
    end

    @testset "200" begin
        str_ = """
        begin
            f() do
                @info @sprintf \"\"\"
                Δmass   = %.16e\"\"\" abs(weightedsum(Q) - weightedsum(Qe)) / weightedsum(Qe)
            end
        end"""

        # NOTE: this looks slightly off because we're compensating for escaping quotes
        str = """
        begin
            f() do
                @info @sprintf \"\"\"
                Δmass   = %.16e\"\"\" abs(weightedsum(Q) - weightedsum(Qe)) /
                                   weightedsum(Qe)
            end
        end"""
        test_format(str_, str; margin = 81)
        test_format(str, str_; margin = 82)
    end

    @testset "202" begin
        str_ = """
        @inline function _make_zop_getvalues(iterators)
            types = map(iterators) do itr
                t =     constructorof(typeof(itr))::Union{Iterators.ProductIterator,CartesianIndices}
                Val(t)
            end
            return function (xs) end
        end"""
        str = """
        @inline function _make_zop_getvalues(iterators)
            types = map(iterators) do itr
                t = constructorof(typeof(itr))::Union{Iterators.ProductIterator,CartesianIndices}
                Val(t)
            end
            return function (xs) end
        end"""
        test_format(str_, str; margin = 92)

        str_ = """
        @vlplot(
            data = dataset("cars"),
            facet = {row = {field = :Origin, type = :nominal}},
            spec = {
                layer = [
                    {
                        mark = :point,
                        encoding =     {x = {field = :Horsepower}, y = {field = :Miles_per_Gallon}},
                    },
                    {
                        mark = {type = :rule, color = :red},
                        data = {values = [{ref = 10}]},
                        encoding = {y = {field = :ref, type = :quantitative}},
                    },
                ],
            }
        )"""
        str = """
        @vlplot(
            data = dataset("cars"),
            facet = {row = {field = :Origin, type = :nominal}},
            spec = {
                layer = [
                    {
                        mark = :point,
                        encoding = {x = {field = :Horsepower}, y = {field = :Miles_per_Gallon}},
                    },
                    {
                        mark = {type = :rule, color = :red},
                        data = {values = [{ref = 10}]},
                        encoding = {y = {field = :ref, type = :quantitative}},
                    },
                ],
            }
        )"""
        test_format(str_, str; margin = 92)
    end

    @testset "207" begin
        str_ = """
        @traitfn function predict_ar(m::TGP, p::Int = 3, n::Int = 1; y_past = get_y(m)) where {T,TGP<:AbstractGP{T};IsMultiOutput{TGP}}
        end"""

        str = """
        @traitfn function predict_ar(
            m::TGP,
            p::Int = 3,
            n::Int = 1;
            y_past = get_y(m),
        ) where {T,TGP<:AbstractGP{T};IsMultiOutput{TGP}} end"""
        test_format(str_, str; margin = 92)

        str = """
        @traitfn function predict_ar(
            m::TGP,
            p::Int = 3,
            n::Int = 1;
            y_past = get_y(m),
        ) where {T, TGP <: AbstractGP{T}; IsMultiOutput{TGP}} end"""
        test_format(str_, str; margin = 92, whitespace_typedefs = true)

        str_ = """
        @traitfn function predict_ar(m::TGP, p::Int = 3, n::Int = 1; y_past = get_y(m)) where C <: Union{T,TGP<:AbstractGP{T};IsMultiOutput{TGP}}
        end"""

        str = """
        @traitfn function predict_ar(
            m::TGP,
            p::Int = 3,
            n::Int = 1;
            y_past = get_y(m),
        ) where {C<:Union{T,TGP<:AbstractGP{T};IsMultiOutput{TGP}}} end"""
        test_format(str_, str; margin = 92)

        str = """
        @traitfn function predict_ar(
            m::TGP,
            p::Int = 3,
            n::Int = 1;
            y_past = get_y(m),
        ) where {C <: Union{T, TGP <: AbstractGP{T}; IsMultiOutput{TGP}}} end"""
        test_format(str_, str; margin = 92, whitespace_typedefs = true)
    end

    @testset "218" begin
        str_ = raw"""
        for MT in GROUP_MANIFOLD_BASIS_DISAMBIGUATION
            eval(quote
                @invoke_maker 1 Manifold get_vector(M::$MT, e::Identity, X, B::VeeOrthogonalBasis)
            end)
        end"""
        str = raw"""
        for MT in GROUP_MANIFOLD_BASIS_DISAMBIGUATION
            eval(
                quote
                    @invoke_maker 1 Manifold get_vector(
                        M::$MT,
                        e::Identity,
                        X,
                        B::VeeOrthogonalBasis,
                    )
                end,
            )
        end"""
        test_format(str_, str)
        test_format(str_, str)
    end

    @testset "248" begin
        str_ = """
        var = call(a, @macrocall b)"""
        str = """
        var =
            call(
                a,
                @macrocall b
            )"""
        test_format(str_, str; indent=4, margin=1)
    end

    @testset "260 - BracesCat" begin
        str = "{1; 2; 3}"
        test_format(str, str; indent=4, margin=length(str))

        str_ = "{1; 2; 3}"
        str = """
        {
          1;
          2;
          3
        }"""
        test_format(str_, str; indent=2, margin=length(str_) - 1)
        test_format(str, str_; indent=2, margin=length(str_))

        str_ = "{1; 2; 3;}"
        str = "{1; 2; 3}"
        test_format(str_, str; indent=2, margin=90)
    end

    @testset "262 - removal of @ in nested macrocall" begin
        str = raw":($(@__MODULE__).@macro)"
        test_format(str, str)

        str = raw":($(@__MODULE__).property)"
        test_format(str, str)

        str = raw":($(@__MODULE__))"
        test_format(str, str)

        str_ = raw":($(@__MODULE__.macro).field.macro)"
        str = raw":($(__MODULE__.@macro).field.macro)"
        test_format(str_, str)
        test_format(str, str)

        str_ = raw"@a.b.c"
        str = raw"a.b.@c"
        test_format(str_, str)
        test_format(str, str)
    end

    @testset "264 - `let` empty block body" begin
        str_ = "let; end"
        str = """
        let
        end"""
        test_format(str_, str)
    end

    @testset "268 - whitespace around dot op if LHS is number literal" begin
        str = "xs[-5 .<= xs .& xs .<= 5]"
        test_format(str, str)
        str_ = "xs[(-5 .<= xs).&(xs.<=5)]"
        str = "xs[(-5 .<= xs) .& (xs .<= 5)]"
        test_format(str_, str)
    end

    @testset "277 - flatten ops when no whitespace is allowed" begin
        # previously this would remove |>
        str_ = "get_actions(env)[env |> π.learner |> π.explorer]"
        str = "get_actions(env)[env|>π.learner|>π.explorer]"
        test_format(str_, str)
        test_format(str, str_; whitespace_ops_in_indices = true)
    end

    @testset "286 - Float32 leading/trailing zeros" begin
        str_ = """
        a = 3.f0
        b = 3f0
        c = 30f0
        d = 30.0f0
        e = 30.123f0
        f = .123f0
        """
        str = """
        a = 3.0f0
        b = 3.0f0
        c = 30.0f0
        d = 30.0f0
        e = 30.123f0
        f = 0.123f0
        """
        test_format(str_, str)
    end

    @testset "289 - no spaces/nesting for matrix elements" begin
        str_ = """
        A =  [0. 1 0 0
           -k/Jm -c/Jm k/Jm c/Jm
            0 0 0 1
            f(1,2) c/Ja -k/Ja -c/Ja]
        """

        str = """
        A =
            [
                0.0 1 0 0
                -k/Jm -c/Jm k/Jm c/Jm
                0 0 0 1
                f(1, 2) c/Ja -k/Ja -c/Ja
            ]
        """
        test_format(str_, str; indent=4, margin=1)
    end

    @testset "317 - infinite recursion" begin
        str = raw"""
        SUITE["manifolds"][name]["tv = 2 * tv1 + 3 * tv2"] = @benchmarkable $tv =
            2 * $tv1 + 3 * $tv2
        """
        test_format(str, str, BlueStyle())
    end

    @testset "324 - bounds error when aligning binary op calls" begin
        # caused by the star operator
        str_ = """
        θ = eigvals(Matrix([0I(n^2) -I(n^2); P0 P1]), -Matrix([I(n^2) 0I(n^2); 0I(n^2) P2]))
        c = maximum(abs.(θ[(imag.(θ).==0).*(real.(θ).>0)]))
        """
        str = """
        θ = eigvals(Matrix([0I(n^2) -I(n^2); P0 P1]), -Matrix([I(n^2) 0I(n^2); 0I(n^2) P2]))
        c = maximum(abs.(θ[(imag.(θ) .== 0) .* (real.(θ) .> 0)]))
        """
        test_format(str_, str; align_assignment = true)
    end

    @testset "332" begin
        # this string has a nbsp after 'c'
        # so it should have an additional byte because
        # it's unicode
        str_ = """a = b || c ;
               f("A")"""
        str = """a = b || c;
               f("A")"""
        test_format(str_, str)
    end

    @testset "336" begin
        str_ = """
        nzthis = _hessian_slice(d, ex, x, H, obj_factor, nzcount, recovery_tmp_storage, Val{1})::Int
        """
        str = """
        nzthis = _hessian_slice(
            d,
            ex,
            x,
            H,
            obj_factor,
            nzcount,
            recovery_tmp_storage,
            Val{1},
        )::Int
        """
        test_format(str_, str; indent=4, margin=80)
    end

    @testset "375" begin
        s = raw"conflictstatus = @jimport ilog.cp.IloCP$ConflictStatus"
        test_format(s, s)

        s = raw"conflictstatus = @jimport ilog.cp.IloCP$ConflictStatus"
        test_format(s, s, BlueStyle())
    end

    @testset "352" begin
        str_ = """
                      @inbounds for f in 1:n_freqs, m in 1:n_channels, l in 1:n_channels, k in 1:length(weighted_evals)
                         a = f + m + l + k
                      end"""
        str = """
        @inbounds for f in 1:n_freqs, m in 1:n_channels, l in 1:n_channels,
                      k in 1:length(weighted_evals)

            a = f + m + l + k
        end"""
        test_format(str_, str, YASStyle(); always_for_in = true, join_lines_based_on_source = false)

        str_ = """
        using Test

        @testset "A long testset name that is rather long" for variable in 100:200, other_var in 1:100
            @test true
        end
        """
        str = """
        using Test

        @testset "A long testset name that is rather long" for variable in 100:200,
            other_var in 1:100

            @test true
        end
        """
        test_format(str_, str, BlueStyle(); always_for_in = true)
    end

    @testset "387" begin
        str_ = """new{T1,T2}(arg1,arg2)"""
        str = """
        new{T1,
            T2}(arg1,
                arg2)"""
        test_format(str_, str, YASStyle(); margin = 1)
    end

    @testset "405" begin
        str = """
        function __init__()
            raw\""" Doc string.\"""f
        end
        """
        test_format(str, str; always_use_return = true)

        str = """
        function __init__()
            @doc raw\"""
            Doc string.
            \"""
            f
        end
        """
        test_format(str, str; always_use_return = true)

        str = """
        function __init__()
            raw\"""
            Doc string.
            \"""
            f
        end
        """
        test_format(str, str; always_use_return = true)
    end

    @testset "417" begin
        str = """
        formαt"JPEG"
        """
        test_format(str, str)

        str = """
        A.formαt"JPEG"
        """
        test_format(str, str)

        str = """
        A.B.formαt"JPEG"
        """
        test_format(str, str)
    end

    @testset "419" begin
        str = """
        [z for y in x for z in y]
        """
        test_format(str, str, YASStyle())
        test_format(str, str, YASStyle(); margin = 25)

        str_ = """
        [z for y in x
         for z in y]
        """
        test_format(str, str_, YASStyle(); margin = 24)

        str_ = """
        [z
         for y in
             x
         for z in
             y]
        """
        test_format(str, str_, YASStyle(); margin = 1)
    end

    @testset "427" begin
        str = "var\"##iv#469\" = (@variables(t))[1]"
        test_format(str, str)

        str_ = """
        var\"##iv#469\" =
            (@variables(t))[1]"""
        test_format(str, str_; margin = length(str) - 1)
    end

    @testset "429" begin
        str = """
        find_derivatives!(vars, expr::Equation, f=identity) = (find_derivatives!(vars, expr.lhs, f); find_derivatives!(vars, expr.rhs, f); vars)
        """
        str_ = """
        function find_derivatives!(vars, expr::Equation, f = identity)
            (find_derivatives!(vars, expr.lhs, f); find_derivatives!(vars, expr.rhs, f); vars)
        end
        """
        test_format(str, str_; margin = 92, short_to_long_function_def = true)
    end

    @testset "431" begin
        str = """
        local Jcx_rows, Jcx_cols, Jcx_vals, Jct_val
        """
        test_format(str, str)

        str_ = "global a=2,b"
        str = "global a=2, b"
        test_format(str_, str)

        str_ = "global a = 2,b"
        str = "global a = 2, b"
        test_format(str_, str)
    end

    @testset "440" begin
        str = "import Base.+"
        test_format(str, str)
    end

    @testset "444" begin
        str_ = """
        function (a,b,c;)
        body
        end
        """
        str = """
        function (
            a,
            b,
            c;
        )
            body
        end
        """
        test_format(str_, str; margin = 1)
        str = """
        function (
            a,
            b,
            c;
        )
            return body
        end
        """
        test_format(str_, str, BlueStyle(); margin = 1)
    end

    @testset "449" begin
        str = """
        (var"x" = 1.0,)
        """
        test_format(str, str)
    end

    @testset "451" begin
        str_ = raw"""
        function _initialize_backend(pkg::AbstractBackend)
            sym = backend_package_name(pkg)
            @eval Main begin
                import $sym
                export $sym
            end
        end
        """
        str = raw"""
        function _initialize_backend(pkg::AbstractBackend)
            sym = backend_package_name(pkg)
            @eval Main begin
                import $sym
                export $sym
            end
        end
        """
        test_format(str_, str; import_to_using = true)
    end

    @testset "456" begin
        str = """
        function update()
            @debug "isfull" dist = 3
            a = 4
            var3 = 2
        end
        """
        test_format(str, str; align_assignment = true)

        str = """
        function update()
            @debug "isfull" dist = 3
            a                    = 4
            var3    = 5
        end
        """
        str_aligned = """
        function update()
            @debug "isfull" dist = 3
            a                    = 4
            var3                 = 5
        end
        """
        test_format(str, str_aligned; align_assignment = true)
    end

    @testset "460" begin
        str = """
        using Distributed
        @everywhere import Distributed
        have_workers = Distributed.nprocs() - 1
        """
        test_format(str, str; import_to_using = true)
    end

    @testset "463" begin
        str = """
        using Test

        @testset "displayKw" begin
            struct S
                f
            end
        end
        """
        test_format(str, str; annotate_untyped_fields_with_any = false,
            align_struct_field = true)
    end

    @testset "467" begin
        str_ = "-3.. -2"
        str = "-3 .. -2"
        test_format(str_, str)
        test_format(str_, str, BlueStyle())
    end

    @testset "473" begin
        str_ = "[1.0, 2.0, 3.0] .|> Int"
        str = "Int.([1.0, 2.0, 3.0])"
        test_format(str_, str; pipe_to_function_call = true)
    end

    @testset "475" begin
        # with the fix for #494 the keyword arguments transform is no longer applied
        # to macro calls.
        str = """
        @deprecate(
            presign(path::AWSS3.S3Path, duration::Period=Hour(1); config::AWSConfig=aws_config()),
            AWSS3.s3_sign_url(config, path.bucket, path.key, Dates.value(Second(duration))),
        )
        """
        test_format(str, str; indent=4, margin=100, whitespace_in_kwargs = false,
            separate_kwargs_with_semicolon = true)
        str = """
        @deprecate(
            presign(path::AWSS3.S3Path; duration::Period=Hour(1), config::AWSConfig=aws_config()),
            AWSS3.s3_sign_url(config, path.bucket, path.key, Dates.value(Second(duration))),
        )
        """
        test_format(str, str; indent=4, margin=100, whitespace_in_kwargs = false,
            separate_kwargs_with_semicolon = true)

        str = """
        @deprecate(presign(path::AWSS3.S3Path, duration::Period=Hour(1); config::AWSConfig=aws_config()),
                   AWSS3.s3_sign_url(config, path.bucket, path.key, Dates.value(Second(duration))),)
        """
        test_format(str, str, YASStyle(); margin = 100,
            whitespace_in_kwargs = false,
            separate_kwargs_with_semicolon = true)

        str = """
        @deprecate(presign(path::AWSS3.S3Path, duration::Period=Hour(1), config::AWSConfig=aws_config()),
                   AWSS3.s3_sign_url(config, path.bucket, path.key, Dates.value(Second(duration))),)
        """
        test_format(str, str, YASStyle(); margin = 100,
            whitespace_in_kwargs = false,
            separate_kwargs_with_semicolon = true)
    end

    @testset "480" begin
        str = "@show (1,)"
        test_format(str, str)

        str = "@show(1,)"
        test_format(str, str)

        str = """
        @NamedTuple{a::Int, b::Int}[]

        @SVector[@SVector[1, 2], @SVector[1, 2]]
        """
        test_format(str, str)

        str = """
        @NamedTuple {a::Int, b::Int}[]

        @SVector[@SVector[1, 2], @SVector [1, 2]]
        """
        test_format(str, str)
    end

    @testset "485 - blue style binary/chain op nesting" begin
        str = """
        if primal_name isa Symbol ||
            Meta.isexpr(primal_name, :(.)) ||
            Meta.isexpr(primal_name, :curly)
            foo()
        end
        """
        test_format(str, str, BlueStyle(); indent=4, margin=80)

        str_ = """
        if a && b
        end
        """
        str = """
        if a &&
            b
        end
        """
        test_format(str_, str, BlueStyle(); indent=4, margin=1)

        str_ = """
        @test foo == bar == baz
        """
        str = """
        @test foo ==
            bar ==
            baz
        """
        test_format(str_, str, BlueStyle(); indent=4, margin=1)

        str_ = """
        @test foo == bar
        """
        str = """
        @test foo ==
            bar
        """
        test_format(str_, str, BlueStyle(); indent=4, margin=1)

        str = """
        const a =
            arg1 +
            arg2 +
            arg3
        """
        test_format(str, str, BlueStyle(); indent=4, margin=1)

        str = """
        const a =
            arg1 +
            arg2
        """
        test_format(str, str, BlueStyle(); indent=4, margin=1)
    end

    @testset "494" begin
        str = "Base.@deprecate f(x, y=x) g(x, y)\n"
        test_format(str, str, BlueStyle())

        str = "Base.@deprecate f(x, y) g(x, y=y)\n"
        test_format(str, str, BlueStyle())
    end

    @testset "500 - leading zeros with '-.'" begin
        s0 = """
        a = -.2
        b = - .2
        """
        s1 = """
        a = -0.2
        b = - 0.2
        """
        test_format(s0, s1)

        s0 = """
        a = -.2f32
        b = - .2f32
        """
        s1 = """
        a = -0.2f32
        b = - 0.2f32
        """
        test_format(s0, s1)

        s0 = """
        a = -.2f-5
        b = - .2f-5
        """
        s1 = """
        a = -0.2f-5
        b = - 0.2f-5
        """
        test_format(s0, s1)
    end

    @testset "509" begin
        code = """M.var"@f";"""
        test_format(code, code)

        code = """
        const var"@_assert" = Base.var"@assert"
        """
        test_format(code, code)
    end

    @testset "512" begin
        # the 3rd line in the multiline comment contains a bunch of spaces prior
        # to the newline, before this fix the whitespace prior to the start of
        # the comment would be prepended to that line so that on repeated indents
        # the spaces would keep increasing.
        str = """
        function make_router()
            function get_sesh()
                #=
                x

                x=#
            end
        end
        """
        test_format(str, str)
    end

    @testset "513" begin
        # The first 2 tests handle the case presented in the issue.
        # However, during the fix I encountered a separate problem where
        # if there was an inline comment followed 1 or more standalone newlines,
        # such as:
        #
        # ```
        # a * # inline
        #
        # b
        # ```
        #
        # then the inline comment would be removed since removing extra newlines
        # exited the routine before inline comments were handled. To be fair this is
        # quite a far case and has not been reported as of yet.
        str_ = """
        (
            10 # i got removed!
            *
            10 # me too!
            +
            10 # hello
        )
        """
        str = """
        (
            10 # i got removed!
            * 10 # me too!
            + 10 # hello
        )
        """
        test_format(str_, str)

        str_ = """
        (
            10 # i got removed!
            * # omg
            10 # me too!
            + # more
            10 # hello
        )
        """
        str = """
        (
            10 # i got removed!
            * # omg
            10 # me too!
            + # more
            10 # hello
        )
        """
        test_format(str_, str)

        str_ = """
        (
            10 * # i got removed!

            10 + # me too!

            10 # hello
        )
        """
        str = """
        (
            10 * # i got removed!
            10 + # me too!
            10 # hello
        )
        """
        test_format(str_, str)

        # before this would format to f(a, b)
        str_ = """
        f(a, # comment

            b
        )
        """
        str = """
        f(
            a, # comment
            b,
        )
        """
        test_format(str_, str)
    end

    @testset "514" begin
        str_ = "output = input .|> f.g"
        str = "output = f.g.(input)"
        test_format(str_, str; pipe_to_function_call = true)

        str_ = "output = input .|> f.g.h"
        str = "output = f.g.h.(input)"
        test_format(str_, str; pipe_to_function_call = true)
    end

    @testset "526" begin
        str = "Base.:(|>)(r::AbstractRegister, blk::AbstractBlock) = apply!(r, blk)"
        test_format(str, str; pipe_to_function_call = true)
    end

    @testset "530" begin
        radical_ops = ("√", "∛", "∜")
        @testset "DefaultStyle" begin
            for op in radical_ops
                s = "3$(op)2"
                test_format(s, s)
            end
        end

        @testset "DefaultStyle" begin
            for op in radical_ops
                s = "3$(op)2"
                test_format(s, s, BlueStyle())
            end
        end
    end

    @testset "533" begin
        # semicolon should not be added prior to `extrap` since it's a function definition.
        s = "function linterp(x0::T, y0::T, x1::T, y1::T, x::T, extrap::Bool=false)::T where {T<:AbstractFloat} end"
        test_format(s, s, BlueStyle(); margin = 200)
        test_format(s, s, YASStyle(); margin = 200)

        s = "function linterp(x0::T, y0::T, x1::T, y1::T, x::T, extrap::Bool=false)::T end"
        test_format(s, s, BlueStyle(); margin = 200)
        test_format(s, s, YASStyle(); margin = 200)
    end

    @testset "541" begin
        str = """
        [10;]
        """
        test_format(str, str; align_matrix = true)
        str = """
        [0:0.2:50;]
        """
        test_format(str, str; align_matrix = true)
    end

    @testset "543" begin
        str_ = """
        G4 = [ H    Zero  H; Zero    H   H
              Zero  Zero  H]
        """
        str = """
        G4 = [
             H    Zero  H;
            Zero    H   H
            Zero  Zero  H
        ]
        """
        test_format(str_, str; align_matrix = true)

        str_ = """
        H = [1 1; 1 1]
        Zero = [0 0; 0 0]

        G1 = vcat(hcat(H,    Zero, H),
                  hcat(Zero, H,    H),
                  hcat(Zero, Zero, H))

        G2 = [ H    Zero  H
              Zero    H   H
              Zero  Zero  H]

        G3 = [ H    Zero  H;
              Zero    H   H
              Zero  Zero  H]

        G4 = [ H    Zero  H; Zero    H   H
              Zero  Zero  H]
        """
        str = """
        H = [1 1; 1 1]
        Zero = [0 0; 0 0]

        G1 = vcat(hcat(H, Zero, H), hcat(Zero, H, H), hcat(Zero, Zero, H))

        G2 = [
             H    Zero  H
            Zero    H   H
            Zero  Zero  H
        ]

        G3 = [
             H    Zero  H;
            Zero    H   H
            Zero  Zero  H
        ]

        G4 = [
             H    Zero  H;
            Zero    H   H
            Zero  Zero  H
        ]
        """
        test_format(str_, str; align_matrix = true)
    end

    @testset "546" begin
        str = """
        function _plot_augmented_roc(inference_signals::DataFrame, per_threshold_sensitivity,
                                     thresholds; save_dir=nothing, save_prefix="", title_suffix="",
                                     xaxis_prefix="Control dataset: ")
            plot_data = augment_roc_data(inference_signals, thresholds)
            _plot_augmented_roc(plot_data, per_threshold_sensitivity;
                                       save_dir=save_dir, save_prefix=save_prefix,
                                       title_suffix=title_suffix, xaxis_prefix=xaxis_prefix)
        end
        """
        str_ = """
        function _plot_augmented_roc(inference_signals::DataFrame, per_threshold_sensitivity,
                                     thresholds; save_dir=nothing, save_prefix="", title_suffix="",
                                     xaxis_prefix="Control dataset: ")
            plot_data = augment_roc_data(inference_signals, thresholds)
            return _plot_augmented_roc(plot_data, per_threshold_sensitivity;
                                       save_dir=save_dir, save_prefix=save_prefix,
                                       title_suffix=title_suffix, xaxis_prefix=xaxis_prefix)
        end
        """
        test_format(str, str_, YASStyle(); indent=4, margin=92, join_lines_based_on_source = true,
            always_use_return = true,
            whitespace_in_kwargs = false)
    end

    @testset "562" begin
        # An inline `#= =#` comment in a call must keep a space from the following
        # argument (it must not be glued to it or moved to the end of the call).
        for s in (
            "f(x, #= y,=# z)",
            "g(op_data, #= ::OpData =# entry)",
        )
            for style in ALL_STYLES
                test_format(s, s, style)
            end
        end
    end

    @testset "568" begin
        s = """
        function (func(arg))
            body
        end
        """
        # no trailing comma since (arg) is semantically different from (arg,) !!!
        s_ = """
        function (func(
            arg,
        ))
            body
        end
        """
        test_format(s, s_; indent=4, margin=19)
    end

    @testset "571" begin
        s = """
        arraycopy_common(false#=fwd=#, LLVM.Builder(B), orig, origops[1], gutils)
        return nothing
        """
        s_ = """
        arraycopy_common(false #=fwd=#, LLVM.Builder(B), orig, origops[1], gutils)
        return nothing
        """
        test_format(s, s_)

        s1 = """
        foo(a, b, #=c=#)
        """
        s2 = """
        foo(
            a,
            b, #=c=#
        )
        """
        test_format(s1, s2; indent=4, margin=1)
    end

    @testset "604" begin
        str = raw"""
        begin @foo a end
        """
        str_ = raw"""
        begin
            @foo a
        end
        """
        test_format(str, str_, SciMLStyle())

        str = raw"""
        begin @foo(a) end
        """
        str_ = raw"""
        begin
            @foo(a)
        end
        """
        test_format(str, str_, SciMLStyle())
    end

    @testset "609 comments being swallowed" begin
        s = "f(\n    q = 2  # this comment will not be removed\n)"
        test_format(s, s, SciMLStyle())
        s2 = "f(; q=2,  # this comment will not be removed\n  )"
        test_format(s, s2, YASStyle())
    end

    @testset "613" begin
        s = """
        x = ```
        my_cmd very_long command that really should be multi-line but isn't, and exceeds the character limit, will be indented forever by repeated calls to format
        ```
        """
        test_format(s, s)
    end

    @testset "618" begin
        s = """
        2 |> x -> 2x
        """
        s_ = """
        (x -> 2x)(2)
        """
        test_format(s, s_; indent=4, margin=92, pipe_to_function_call = true)
    end

    @testset "619" begin
        # Semicolons in vector literals must be preserved (they denote vcat, not hcat).
        # Previously SciMLStyle dropped semicolons when reformatting.
        eq_str = raw"eqs = [0 ~ -1x_f + (ModelingToolkitComponents.inputsf)(t, dt, x_f_input); 0 ~ -1dm_f1 + (ModelingToolkitComponents.inputsf)(t, dt, dm_f1_input); 0 ~ -1dm_f2 + (ModelingToolkitComponents.inputsf)(t, dt, dm_f2_input); 0 ~ -1csled₊F_brake + (ModelingToolkitComponents.inputsf)(t, csled₊dt, csled₊F_brake_input); 0 ~ -1 * csled₊sled₊k_sled * (-1csled₊sled₊a + csled₊sled₊u) + csled₊sled₊F_sled; 0 ~ -1 * csled₊sled₊k_car * (-1csled₊sled₊w + csled₊sled₊a) + csled₊sled₊F_car; 0 ~ -1csled₊sled₊F_car + csled₊sled₊m_car * csled₊sled₊ddw; 0 ~ -1 * (ifelse)(c4₊f₊vSA₊x > 0, (c4₊f₊vSA₊k1 * (abs)(-1c4₊piston₊v1₊p + c4₊accum_m₊v₊p) * (abs)(c4₊f₊vSA₊x / c4₊f₊vSA₊x_m) + c4₊f₊vSA₊k2 * (abs)(c4₊f₊vSA₊x / c4₊f₊vSA₊x_m) * (sqrt)((abs)(-1c4₊piston₊v1₊p + c4₊accum_m₊v₊p)) + c4₊f₊vSA₊k3 * (c4₊f₊vSA₊x / c4₊f₊vSA₊x_m) ^ 2 * (abs)(-1c4₊piston₊v1₊p + c4₊accum_m₊v₊p)) * (sign)(-1c4₊piston₊v1₊p + c4₊accum_m₊v₊p), 0) + c4₊f₊vSA₊HA₊dm; 0 ~ (-1c4₊accum_m₊v₊y + (ModelingToolkitComponents.delayf)(c4₊accum_m₊v₊y, t, c4₊accum_m₊v₊dt, c4₊accum_m₊v₊dt, c4₊accum_m₊v₊yo)) / c4₊accum_m₊v₊dt + c4₊accum_m₊v₊dy; 0 ~ (-1 * c4₊accum_m₊v₊area * c4₊accum_m₊v₊rho_0 * (c4₊accum_m₊v₊l_int + c4₊accum_m₊v₊y) * c4₊accum_m₊v₊dp) / c4₊accum_m₊v₊bulk + -1 * c4₊accum_m₊v₊area * c4₊accum_m₊v₊rho_0 * (1.0 + c4₊accum_m₊v₊p / c4₊accum_m₊v₊bulk) * c4₊accum_m₊v₊dy + c4₊accum_m₊v₊H₊dm; 0 ~ (-1c4₊piston₊v1₊y + (ModelingToolkitComponents.delayf)(c4₊piston₊v1₊y, t, c4₊piston₊v1₊dt, c4₊piston₊v1₊dt, c4₊piston₊v1₊yo)) / c4₊piston₊v1₊dt + c4₊piston₊ms₊dy; 0 ~ (-1c4₊piston₊v2₊y + (ModelingToolkitComponents.delayf)(c4₊piston₊v2₊y, t, c4₊piston₊v2₊dt, c4₊piston₊v2₊dt, c4₊piston₊v2₊yo)) / c4₊piston₊v2₊dt + -1c4₊piston₊ms₊dy; 0 ~ (-1c4₊piston₊ms₊y + (ModelingToolkitComponents.delayf)(c4₊piston₊ms₊y, t, c4₊piston₊ms₊dt, c4₊piston₊ms₊dt, c4₊piston₊ms₊yo)) / c4₊piston₊ms₊dt + c4₊piston₊ms₊dy; 0 ~ (ifelse)(c4₊piston₊ms₊y < c4₊piston₊ms₊ubnd, (ifelse)(c4₊piston₊ms₊y > c4₊piston₊ms₊lbnd, -1c4₊piston₊ms₊T₊f + c4₊piston₊ms₊m * c4₊piston₊ms₊ddy + -1 * c4₊piston₊ms₊g * c4₊piston₊ms₊m, -1c4₊piston₊ms₊T₊f + -1.0e9c4₊piston₊ms₊lbnd + c4₊piston₊ms₊m * c4₊piston₊ms₊ddy + 1.0e6c4₊piston₊ms₊dy + 1.0e9c4₊piston₊ms₊y + -1 * c4₊piston₊ms₊g * c4₊piston₊ms₊m), -1c4₊piston₊ms₊T₊f + -1.0e9c4₊piston₊ms₊ubnd + c4₊piston₊ms₊m * c4₊piston₊ms₊ddy + 1.0e6c4₊piston₊ms₊dy + 1.0e9c4₊piston₊ms₊y + -1 * c4₊piston₊ms₊g * c4₊piston₊ms₊m); 0 ~ (-1 * c4₊fp₊area * c4₊fp₊length * c4₊fp₊rho_0 * c4₊fp₊dp) / c4₊fp₊bulk + c4₊fp₊H₊dm]"
        output = """
        eqs = [0 ~ -1x_f + (ModelingToolkitComponents.inputsf)(t, dt, x_f_input);
               0 ~ -1dm_f1 + (ModelingToolkitComponents.inputsf)(t, dt, dm_f1_input);
               0 ~ -1dm_f2 + (ModelingToolkitComponents.inputsf)(t, dt, dm_f2_input);
               0 ~
               -1csled₊F_brake +
               (ModelingToolkitComponents.inputsf)(t, csled₊dt, csled₊F_brake_input);
               0 ~ -1 * csled₊sled₊k_sled * (-1csled₊sled₊a + csled₊sled₊u) + csled₊sled₊F_sled;
               0 ~ -1 * csled₊sled₊k_car * (-1csled₊sled₊w + csled₊sled₊a) + csled₊sled₊F_car;
               0 ~ -1csled₊sled₊F_car + csled₊sled₊m_car * csled₊sled₊ddw;
               0 ~
               -1 * (ifelse)(c4₊f₊vSA₊x > 0,
                   (c4₊f₊vSA₊k1 * (abs)(-1c4₊piston₊v1₊p + c4₊accum_m₊v₊p) *
                    (abs)(c4₊f₊vSA₊x / c4₊f₊vSA₊x_m) +
                    c4₊f₊vSA₊k2 * (abs)(c4₊f₊vSA₊x / c4₊f₊vSA₊x_m) *
                    (sqrt)((abs)(-1c4₊piston₊v1₊p + c4₊accum_m₊v₊p)) +
                    c4₊f₊vSA₊k3 * (c4₊f₊vSA₊x / c4₊f₊vSA₊x_m) ^ 2 *
                    (abs)(-1c4₊piston₊v1₊p + c4₊accum_m₊v₊p)) *
                   (sign)(-1c4₊piston₊v1₊p + c4₊accum_m₊v₊p),
                   0) + c4₊f₊vSA₊HA₊dm;
               0 ~
               (-1c4₊accum_m₊v₊y + (ModelingToolkitComponents.delayf)(
                   c4₊accum_m₊v₊y, t, c4₊accum_m₊v₊dt, c4₊accum_m₊v₊dt, c4₊accum_m₊v₊yo)) /
               c4₊accum_m₊v₊dt + c4₊accum_m₊v₊dy;
               0 ~
               (-1 * c4₊accum_m₊v₊area * c4₊accum_m₊v₊rho_0 *
                (c4₊accum_m₊v₊l_int + c4₊accum_m₊v₊y) * c4₊accum_m₊v₊dp) / c4₊accum_m₊v₊bulk +
               -1 * c4₊accum_m₊v₊area * c4₊accum_m₊v₊rho_0 *
               (1.0 + c4₊accum_m₊v₊p / c4₊accum_m₊v₊bulk) * c4₊accum_m₊v₊dy + c4₊accum_m₊v₊H₊dm;
               0 ~
               (-1c4₊piston₊v1₊y + (ModelingToolkitComponents.delayf)(
                   c4₊piston₊v1₊y, t, c4₊piston₊v1₊dt, c4₊piston₊v1₊dt, c4₊piston₊v1₊yo)) /
               c4₊piston₊v1₊dt + c4₊piston₊ms₊dy;
               0 ~
               (-1c4₊piston₊v2₊y + (ModelingToolkitComponents.delayf)(
                   c4₊piston₊v2₊y, t, c4₊piston₊v2₊dt, c4₊piston₊v2₊dt, c4₊piston₊v2₊yo)) /
               c4₊piston₊v2₊dt + -1c4₊piston₊ms₊dy;
               0 ~
               (-1c4₊piston₊ms₊y + (ModelingToolkitComponents.delayf)(
                   c4₊piston₊ms₊y, t, c4₊piston₊ms₊dt, c4₊piston₊ms₊dt, c4₊piston₊ms₊yo)) /
               c4₊piston₊ms₊dt + c4₊piston₊ms₊dy;
               0 ~ (ifelse)(c4₊piston₊ms₊y < c4₊piston₊ms₊ubnd,
                   (ifelse)(c4₊piston₊ms₊y > c4₊piston₊ms₊lbnd,
                       -1c4₊piston₊ms₊T₊f + c4₊piston₊ms₊m * c4₊piston₊ms₊ddy +
                       -1 * c4₊piston₊ms₊g * c4₊piston₊ms₊m,
                       -1c4₊piston₊ms₊T₊f + -1.0e9c4₊piston₊ms₊lbnd +
                       c4₊piston₊ms₊m * c4₊piston₊ms₊ddy + 1.0e6c4₊piston₊ms₊dy +
                       1.0e9c4₊piston₊ms₊y + -1 * c4₊piston₊ms₊g * c4₊piston₊ms₊m),
                   -1c4₊piston₊ms₊T₊f + -1.0e9c4₊piston₊ms₊ubnd +
                   c4₊piston₊ms₊m * c4₊piston₊ms₊ddy + 1.0e6c4₊piston₊ms₊dy + 1.0e9c4₊piston₊ms₊y +
                   -1 * c4₊piston₊ms₊g * c4₊piston₊ms₊m);
               0 ~
               (-1 * c4₊fp₊area * c4₊fp₊length * c4₊fp₊rho_0 * c4₊fp₊dp) / c4₊fp₊bulk + c4₊fp₊H₊dm]
        """ |> strip
        test_format(eq_str, output, SciMLStyle())
        @test Meta.parse(eq_str) == Meta.parse(output)
    end

    @testset "622" begin
        # Array indexing with colon should not produce invalid syntax when nested.
        # Previously, `to_eval[\n    performance_accept, :\n]` had a bare `:` after a
        # newline, which Julia interpreted as the quoting operator.
        s = "chainsamples[α_accept_indices[performance_accept], :] = to_eval[performance_accept, :]\n"
        s_ = """
        chainsamples[α_accept_indices[performance_accept], :] = to_eval[
            performance_accept, :,
        ]
        """
        test_format(s, s_, BlueStyle(); margin = 60)
    end

    @testset "624" begin
        s = """
        deploydocs(;
            repo="github.com/julia-vscode/CSTParser.jl",
        )
        """
        test_format(s, s, MinimalStyle())
    end

    @testset "630" begin
        s = raw"""
        rn = @reaction_network begin
            k/$V, A + B --> C
        end k"""
        test_format(s, s, SciMLStyle())
    end

    @testset "636" begin
        s = "a |> M.f"
        test_format(s, "M.f(a)"; indent=4, margin=92, pipe_to_function_call = true)

        # -> has a higher precedence than |>
        s = """
        coordsperm = coords .|> x -> x.I[[2, 1, 3]] |> CartesianIndex
        """
        s_ = """
        coordsperm = (x -> CartesianIndex(x.I[[2, 1, 3]])).(coords)
        """
        test_format(s, s_; indent=4, margin=92, pipe_to_function_call = true)

        # -> has a higher precedence than |>
        s = """
        coordsperm = coords .|> x -> x.I[[2, 1, 3]] .|> CartesianIndex
        """
        s_ = """
        coordsperm = (x -> CartesianIndex.(x.I[[2, 1, 3]])).(coords)
        """
        test_format(s, s_; indent=4, margin=92, pipe_to_function_call = true)

        s = """
        coordsperm = coords .|> (x -> x.I[[2, 1, 3]]) .|> CartesianIndex
        """
        s_ = """
        coordsperm = CartesianIndex.((x -> x.I[[2, 1, 3]]).(coords))
        """
        test_format(s, s_; indent=4, margin=92, pipe_to_function_call = true)

        s = """
        coordsperm = coords |> (x -> x.I[[2, 1, 3]]) |> CartesianIndex
        """
        s_ = """
        coordsperm = CartesianIndex((x -> x.I[[2, 1, 3]])(coords))
        """
        test_format(s, s_; indent=4, margin=92, pipe_to_function_call = true)
    end

    @testset "642" begin
        # Unary plus in macro call should not break the formatter.
        s = "@constraint(Lower(model), +x[1] + x[2] <= 2)\n"
        test_format(s, s)

        # Unary plus at the start of a chain of multiplications inside `sum()`.
        s_ = """
        sum(
                + _shutdown_margin(u, ng, d, s, t0, t, case, part)
                * _unit_flow_capacity(u, ng, d, s, t0, t)
                * _switch(
                    d; from_node=nonspin_units_started_up, to_node=nonspin_units_shut_down
                )[u, n, s, t_over]
                * overlap_duration(t_over, t)
                for (u, n, s, t_over) in _switch(
                    d; from_node=nonspin_units_started_up_indices, to_node=nonspin_units_shut_down_indices
                )(m; unit=u, stochastic_scenario=s, t=t_overlaps_t(m; t=t));
                init=0
            )
        """
        s = """
        sum(
            + _shutdown_margin(u, ng, d, s, t0, t, case, part) *
            _unit_flow_capacity(u, ng, d, s, t0, t) *
            _switch(d; from_node = nonspin_units_started_up, to_node = nonspin_units_shut_down)[
                u,
                n,
                s,
                t_over,
            ] *
            overlap_duration(t_over, t) for (u, n, s, t_over) in _switch(
                d;
                from_node = nonspin_units_started_up_indices,
                to_node = nonspin_units_shut_down_indices,
            )(
                m;
                unit = u,
                stochastic_scenario = s,
                t = t_overlaps_t(m; t = t),
            );
            init = 0,
        )
        """
        test_format(s_, s)
    end

    @testset "644" begin
        s = """
        @foo @noinline Base.@constprop :none aaaaaaaaaaaaa() = 0
        @foo @noinline Base.@constprop :none bbbbbbbbbbbbbbbbbbb()     = 0
        @foo @foo @ccccccccccccccccccccccccccccccccccccccccccccccccc() = 0
        """
        s_ = """
        @foo @noinline Base.@constprop :none aaaaaaaaaaaaa()           = 0
        @foo @noinline Base.@constprop :none bbbbbbbbbbbbbbbbbbb()     = 0
        @foo @foo @ccccccccccccccccccccccccccccccccccccccccccccccccc() = 0
        """
        test_format(s, s_; indent=4, margin=92, align_assignment = true)

        # no manual edit
        s = """
        @foo @noinline Base.@constprop :none aaaaaaaaaaaaa() = 0
        @foo @noinline Base.@constprop :none bbbbbbbbbbbbbbbbbbbbbbb() = 0
        @foo @foo @ccccccccccccccccccccccccccccccccccccccccccccccccc() = 0
        """
        test_format(s, s; indent=4, margin=92, align_assignment = true)
    end

    @testset "655" begin
        s = """
        [
          a;
        ]
        """
        test_format(s, s; indent=2, margin=92, join_lines_based_on_source = true)
        test_format(s, s; indent=2, margin=1)
        s = """
        [
          a
        ]
        """
        test_format(s, s; indent=2, margin=92, join_lines_based_on_source = true, trailing_comma = nothing)
        test_format(s, s; indent=2, margin=1, trailing_comma = nothing)
    end

    @testset "656" begin
        s = "[x for x in xs if x in 1:length(ys)]"
        test_format(s, s; indent=4, margin=92)
    end

    @testset "667" begin
        s = raw"""
        \"""
            𝐀

        A dimension representing Angle.

        !!! note "Not SI"

            *Angle* is not an SI base dimension.
        \"""
        @dimension 𝐀 "𝐀" Angle true
        """
        test_format(s, s; format_docstrings = true)
    end

    @testset "669" begin
        # Macro call arguments like `xd(t)=xd_start` should not be rewritten to
        # `function xd(t) ... end` when `short_to_long_function_def = true`.
        s = """
        sts = @variables x(t) = x_start [description = "State of filter"] xd(t) = xd_start [
            description = "Derivative state of filter",
        ]
        """
        test_format(s, s; short_to_long_function_def = true)
    end

    @testset "682" begin
        str_ = """
        var = call(a; arg=@macrocall b)"""
        str = """
        var =
            call(
                a;
                arg = @macrocall b
            )"""
        test_format(str_, str; indent=4, margin=1)
    end

    @testset "686" begin
        s1 = """
        abc() = begin
          1
        end
        """
        s2 = """
        function abc()
          1
        end
        """
        test_format(s1, s2; indent=2, margin=5, short_to_long_function_def = true)
    end

    @testset "688" begin
        s = """
        vector_to_concatenate = [
            repeat([foo], foo_times);
            repeat([bar], bar_times)
        ]
        """ |> strip
        test_format(s, s; margin=30)
        test_format(s, s, MinimalStyle())
    end

    @testset "690" begin
        # Inline comments after trailing comma should not be deleted by SciMLStyle.
        s_ = """
        var_to_diff = DiffGraph(
            [2, 3, nothing, 5, 6, nothing], # primal_to_diff
            [nothing, 1, 2, nothing, 4, 5], # diff_to_primal
        )
        """
        s = """
        var_to_diff = DiffGraph(
            [2, 3, nothing, 5, 6, nothing], # primal_to_diff
            [nothing, 1, 2, nothing, 4, 5] # diff_to_primal
        )
        """
        test_format(s_, s, SciMLStyle())

        s_ = """
        if (# opening inline
            some_exceedingly_long_variable_name > some_other_fairly_long_variable_name # another inline
            # stand-alone
            || some_additional_long_variable_name > some_other_fairly_long_variable_name # closing inline
        )
            print("something")
        end
        """
        s = """
        if (# opening inline
            some_exceedingly_long_variable_name > some_other_fairly_long_variable_name # another inline
            # stand-alone
            ||
            some_additional_long_variable_name > some_other_fairly_long_variable_name # closing inline
            )
            print("something")
        end
        """
        test_format(s_, s, YASStyle(); margin=120)

        s60 = """
        if (# opening inline
            some_exceedingly_long_variable_name >
            some_other_fairly_long_variable_name # another inline
            # stand-alone
            ||
            some_additional_long_variable_name >
            some_other_fairly_long_variable_name # closing inline
            )
            print("something")
        end
        """
        test_format(s_, s60, YASStyle(); margin=60)
    end

    @testset "698" begin
        s1 = """
        let hello() = begin
                print("ok")
            end
            hello()
        end

        let hello() = print("ok");
            hello()
        end
        """
        s2 = """
        let hello() =
                begin
                    print(
                        "ok",
                    )
                end
            hello()
        end

        let hello() =
                print(
                    "ok",
                )
            hello()
        end
        """
        test_format(s1, s2; indent=4, margin=10, short_to_long_function_def = true)
    end

    @testset "700" begin
        s1 = """
        a_loooooooooooooooooooooooooooooooooooooooooooooooooooooooooong_array_name = [1 1; 1 1]

        x = a_loooooooooooooooooooooooooooooooooooooooooooooooooooooooooong_array_name[sum(a_loooooooooooooooooooooooooooooooooooooooooooooooooooooooooong_array_name[:, 1]), :]
        """
        s2 = """
        a_loooooooooooooooooooooooooooooooooooooooooooooooooooooooooong_array_name = [1 1; 1 1]

        x = a_loooooooooooooooooooooooooooooooooooooooooooooooooooooooooong_array_name[
            sum(a_loooooooooooooooooooooooooooooooooooooooooooooooooooooooooong_array_name[:, 1]), :,
        ]
        """
        test_format(s1, s2, BlueStyle(); indent=4, margin=92)
    end

    @testset "703" begin
        s = """
        mutable struct A
            const a :: Int
            bcd     :: String
        end
        """
        test_format(s, s; indent=4, margin=92, align_struct_field = true)
    end

    @testset "713" begin
        s1 = """
        [1. 1; 1 -1]
        """
        s2 = """
        [1.0 1; 1 -1]
        """
        test_format(s1, s2; indent=4, margin=92, align_matrix = true)
    end

    @testset "714" begin
        s1 = """
        A = [-2.. -1 3..4; 5..6 7..8]
        """
        s2 = """
        A = [-2 .. -1 3..4; 5..6 7..8]
        """
        test_format(s1, s2; indent=4, margin=92)
    end

    @testset "715" begin
        s = """
        map(1:10) do x
            # empty
        end
        """
        test_format(s, s; indent=4, margin=92, always_use_return = true)
    end
    @testset "728" begin
        s = """
        begin
        #! format: noindent

        # This is OK
        function foo end

        # This is not

        end
        """
        test_format(s, s; indent=4, margin=92)

        s = """
        begin
        #! format: noindent

        end
        """
        test_format(s, s; indent=4, margin=92)
    end

    @testset "736" begin
        # should not get spaces around `in`.
        s = "!in(x, y)"
        for style in ALL_STYLES
            test_format(s, s, style)
        end
    end

    @testset "743" begin
        s = """
        foo(ᶜa) = - ᶜa
        """
        test_format(s, s; indent=4, margin=92)
        test_format(s, s, SciMLStyle())
    end

    @testset "745" begin
        s = "[;;;]"
        test_format(s, s; indent=4, margin=92)
        test_format(s, s; indent=4, margin=1)
    end

    @testset "748" begin
        # this started out as an error with SciMLStyle but I narrowed it down to an edge case
        # with the `join_lines_based_on_source` option with vcat types
        str_ = """
        [0.128483; 1.256853; 0.0030203; 0.0027977; 0.0101511; 0.0422942; 0.2391346;
                  0.0008014; 0.0001464; 2.67e-05; 4.8e-6; 9e-7; 0.0619917; 1.2444292; 0.0486676;
                  199.9383546; 137.4267984; 1.5180203; 1.5180203]
        """
        str = """
        [0.128483; 1.256853; 0.0030203; 0.0027977; 0.0101511; 0.0422942; 0.2391346;
            0.0008014; 0.0001464; 2.67e-05; 4.8e-6; 9e-7; 0.0619917; 1.2444292; 0.0486676;
            199.9383546; 137.4267984; 1.5180203; 1.5180203]
        """
        test_format(str_, str; indent=4, margin=92, join_lines_based_on_source = true)
    end

    @testset "753" begin
        str_ = """
        using ModelingToolkit
        @mtkmodel A begin
                @variables begin
                        i(t) = 0.0, [description = "Line longer than the char limit of 94 characters", unit = u"A"]
                end
        end
        """
        str = """
        using ModelingToolkit
        @mtkmodel A begin
            @variables begin
                i(t) = 0.0,
                [description = "Line longer than the char limit of 94 characters", unit = u"A"]
            end
        end
        """
        test_format(str_, str, SciMLStyle())
    end

    @testset "769" begin
        s = raw"""
        @assert x isa Tuple \"msg\"
        """
        test_format(s, s, SciMLStyle())
    end

    @testset "774" begin
        str = """
        getdata() = rand() < 0.5 ? rand() : missing

        function dowork()
            while !ismissing((val = getdata();))
                println(val^2)
            end
        end
        """
        test_format(str, str)
    end

    @testset "779" begin
        s = "Int <: B where {B} && Int <: C where {C}"
        test_format(s, s)
    end

    @testset "781" begin
        # Previously failed with "hasn't reached fixpoint in 4 iterations".
        s = "f([a b\n            c d])"
        test_format(s, s, SciMLStyle(); align_matrix = true)
    end

    @testset "782" begin
        # `catch (e)` should be preserved as-is, not moved into the catch body.
        # Previously the formatter produced `catch\n    (e)\n    ...` which changes
        # semantics: `e` would no longer be bound to the exception.
        s = """
        try
            error("Whoops")
        catch (e)
            println("Found \$e")
        end
        """
        test_format(s, s)
    end

    @testset "788" begin
        s_ = "c = (\n+d+\n+e)"
        s = "c = (+d + +e)"
        test_format(s_, s)
        for style in ALL_STYLES
            test_format(s, nothing, style; ast=true)
        end
    end

    @testset "795" begin
        s = "a[1 .+ 1 .+ 1]"
        for style in ALL_STYLES
            test_format(s, s, style)
        end
    end

    @testset "802" begin
        s = """
        mutable struct Foo
            const a
        end
        """
        test_format(s, s; indent=4, margin=92, align_struct_field = true)
    end

    @testset "810" begin
        s = """
        @f(a, b, c)
        """
        test_format(s, s, SciMLStyle())
    end

    @testset "815" begin
        s1 = """
        X = (
            xxxxx=["xxxx", "xxxx", "xxxx"],
            xxxxx=["xxxx", "xxxx", "xxxx"]
        )
        """
        s2 = """
        X = (
            xxxxx=["xxxx", "xxxx", "xxxx"],
            xxxxx=["xxxx", "xxxx", "xxxx"],
        )
        """
        test_format(
            s1, s2, BlueStyle();
            trailing_comma = true,
            join_lines_based_on_source = true,
        )

        s1 = """
        XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX = (
            xxxxx=["xxxx", "xxxx", "xxxx"],
            xxxxx=["xxxx", "xxxx", "xxxx"]
        )
        """
        s2 = """
        XXXXXXXXXXXXXXXXXXXXXXXXXXXXXX = (
            xxxxx=["xxxx", "xxxx", "xxxx"],
            xxxxx=["xxxx", "xxxx", "xxxx"],
        )
        """
        test_format(
            s1, s2, BlueStyle(),
            trailing_comma = true,
            join_lines_based_on_source = true,
        )
    end

    @testset "817" begin
        s = raw"""
        a = ["Unknown" => SubRegion.Unknown, "Northern Europe" => SubRegion.Northern_Europe, "Southern Asia" => SubRegion.Southern_Asia, "Western Europe" => SubRegion.Western_Europe, "Sub-Saharan Africa" => SubRegion.Sub_Saharan_Africa, "Western Asia" => SubRegion.Western_Asia, "Eastern Asia" => SubRegion.Eastern_Asia, "Northern America" => SubRegion.Northern_America, "South-eastern Asia" => SubRegion.South_eastern_Asia, "Australia and New Zealand" => SubRegion.Australia_and_New_Zealand, "Eastern Europe" => SubRegion.Eastern_Europe, "Latin America and the Caribbean" => SubRegion.Latin_America_and_the_Caribbean, "Southern Europe" => SubRegion.Southern_Europe, "Central Asia" => SubRegion.Central_Asia]
        """
        s2 = raw"""
        a = ["Unknown" => SubRegion.Unknown, "Northern Europe" => SubRegion.Northern_Europe,
            "Southern Asia" => SubRegion.Southern_Asia,
            "Western Europe" => SubRegion.Western_Europe,
            "Sub-Saharan Africa" => SubRegion.Sub_Saharan_Africa,
            "Western Asia" => SubRegion.Western_Asia, "Eastern Asia" => SubRegion.Eastern_Asia,
            "Northern America" => SubRegion.Northern_America,
            "South-eastern Asia" => SubRegion.South_eastern_Asia,
            "Australia and New Zealand" => SubRegion.Australia_and_New_Zealand,
            "Eastern Europe" => SubRegion.Eastern_Europe,
            "Latin America and the Caribbean" => SubRegion.Latin_America_and_the_Caribbean,
            "Southern Europe" => SubRegion.Southern_Europe,
            "Central Asia" => SubRegion.Central_Asia]
        """
        test_format(s, s2, SciMLStyle())
    end

    @testset "820" begin
        s = "this_func(::Tuple{<:(some_func())}) = nothing"
        test_format(s, s)
    end

    @testset "822" begin
        s = """
        ℯ #=
        =#
        """
        test_format(s, s)

        s = """
        begin
            π => im #=
            comment =#
        end
        """
        test_format(s, s)
    end

    @testset "833" begin
        # spaces around .+ were removed previously
        s = "x[n^2 .+ I]"
        for style in (DefaultStyle(), YASStyle(), MinimalStyle())
            test_format(s, s, style)
        end
        for style in (SciMLStyle(), BlueStyle())
            # spaces around binop in indexing expr
            s2 = "x[n ^ 2 .+ I]"
            test_format(s, s2, style)
        end
    end

    @testset "837" begin
        s = "Bool[;;]"
        for style in ALL_STYLES
            test_format(s, s)
        end
    end

    @testset "850" begin
        s = raw"""println("$x"[1:end-2])"""
        for style in ALL_STYLES
            # output depends on style but we can check AST is unchanged
            out = format_text(s, style)
            @test Meta.parse(s) == Meta.parse(out)
            # test idempotence
            @test format_text(out, style) == out
        end
    end

    @testset "860" begin
        # Integer literals and broadcasting inside `[]` should not cause a parse error.
        s = "a[x+1 .+ 1]"
        test_format(s, s)
        test_format(s, "a[x + 1 .+ 1]"; whitespace_ops_in_indices = true)
    end

    @testset "862" begin
        # Block comments should not be stripped entirely.
        # Previously `T <: Tuple #=...=# && ...` lost the first block comment.
        s = "T <: Tuple #=comment1=# && !(T isa Union) #=comment2=#\n"
        test_format(s, s)
    end

    @testset "876" begin
        str_ = """
        function find_horizontal(geom::GIWrap.Polygon)::Vector{Tuple{Float64,Float64}}
            coords = collect(GI.coordinates(geom)...)
            first_coord = first(coords)
            second_coord = coords[
                (getindex.(coords, 2) .∈ first_coord[2]) .&&
                (getindex.(coords, 1) .∉ first_coord[1])
            ]

            return [tuple(first_coord...), tuple(first(second_coord)...)]
        end
        """
        str = """
        function find_horizontal(geom::GIWrap.Polygon)::Vector{Tuple{Float64,Float64}}
            coords = collect(GI.coordinates(geom)...)
            first_coord = first(coords)
            second_coord = coords[
                (getindex.(coords, 2) .∈ first_coord[2]) .&& (getindex.(coords, 1) .∉ first_coord[1])
            ]

            return [tuple(first_coord...), tuple(first(second_coord)...)]
        end
        """
        test_format(str_, str, BlueStyle(); join_lines_based_on_source = true)
    end

    @testset "880" begin
        s1 = "constant_list[node_index.val:: UInt16]"
        s2 = "constant_list[node_index.val::UInt16]"
        test_format(s1, s2; indent=4, margin=100, whitespace_ops_in_indices = true)

        s1 = "constant_list[node_index.val+ UInt16]"
        s2 = "constant_list[node_index.val + UInt16]"
        test_format(s1, s2; indent=4, margin=100, whitespace_ops_in_indices = true)

        s = ".!purge"
        test_format(s, s; indent=4, margin=100)
    end

    @testset "885" begin
        # Unary minus with sub/superscript variables like `- ᶠb` should not cause a
        # LoadError. The space is needed for Julia to parse `-` as a unary operator
        # before a subscript/superscript identifier.
        for s in (
            "a = - ₐb",
            "a = - ᵃb",
            "a = - ᶠb",
            "a = - ᶜb",
        )
            test_format(s, s)
        end
    end

    @testset "887 short_circuit_to_if + prepend_return" begin
        s = raw"""
        function exampleFunction()
            LOGFILEHANDLE != "notset" && write(LOGFILEHANDLE, "examplestring")
        end"""
        expected = raw"""
        function exampleFunction()
            return LOGFILEHANDLE != "notset" && write(LOGFILEHANDLE, "examplestring")
        end"""
        for style in ALL_STYLES
            test_format(s, expected, style; short_circuit_to_if = true, always_use_return = true)
        end
    end

    @testset "890" begin
        # `public` keyword should not eat the following space.
        # Previously YASStyle turned `public Foo,Bar` into `publicFoo,Bar`.
        s = "public ExcludedRecordingV1, ExcludedRecordingV1SchemaVersion\n"
        s_ = "public ExcludedRecordingV1,ExcludedRecordingV1SchemaVersion\n"
        for style in ALL_STYLES
            test_format(s_, s, style)
        end
    end

    @testset "894" begin
        # MinimalStyle should preserve whitespace around `-`.
        s = """
        function sub(a, b)
            a - b
        end
        """
        test_format(s, s, MinimalStyle())
    end

    @testset "897 BlueStyle chained ternary to if idempotence" begin
        text = "push!(attributes, operandsegmentsizes([1, 1, 1, (lhs_scale==nothing) ? 0 : 1(rhs_scale==nothing) ? 0 : 1]))"
        for style in ALL_STYLES
            if style isa BlueStyle
                # BlueStyle converts the ternary into if/elseif/else so we manually test that
                blue_out = "push!(attributes, operandsegmentsizes([\n    1,\n    1,\n    1,\n    if (lhs_scale==nothing)\n        0\n    elseif 1(rhs_scale==nothing)\n        0\n    else\n        1\n    end,\n]))"
                test_format(text, blue_out, BlueStyle())
            else
                test_format(text, nothing, style)
            end
        end

        # minimised case too
        s = "foooooooo(foooooooo(a ? b : c ? d : e))"
        for style in ALL_STYLES
            test_format(s, nothing, style)
            test_format(s, nothing, style; margin=40)
        end

        # check that comments aren't lost
        s = "#=1=# a #=2=# ? #=3=# b #=4=# : #=5=# c #=6=# ? #=7=# d #=8=# : #=9=# e #=10=#"
        test_format(s, nothing, BlueStyle())
        out = format_text(s, BlueStyle())
        for i in 1:10
            @test occursin("#=$(i)=#", out)
        end
    end

    @testset "902" begin
        # `short_circuit_to_if` should not transform `&&` into `if` inside a closure
        # argument, because that changes the semantics of the code.
        s_ = """
        indices = findall(
            ss ->
                ss == 1 &&
                    ss == 2,
            my_vec)
        """
        s = "indices = findall(ss -> ss == 1 && ss == 2, my_vec)\n"
        test_format(s_, s; short_circuit_to_if = true)
    end

    @testset "904" begin
        # `foo(::Bool=false)` should not get extra parentheses like `foo((::Bool)=false)`.
        s_ = "foo(::Bool=false) = false\n"
        test_format(s_, s_, YASStyle())
        test_format(s_, s_, BlueStyle())
        test_format(s_, s_, MinimalStyle())
        s_ = "foo(::Bool = false) = false\n"
        test_format(s_, s_, DefaultStyle())
        test_format(s_, s_, SciMLStyle())
    end

    @testset "905" begin
        # The `∈`/`in` operator in a generator *body* must not be normalized; only the
        # iteration specifications (after `for`) are affected by `always_for_in`.
        for style in (DefaultStyle(), BlueStyle(), YASStyle())
            test_format(
                "all(v ∈ P for v in mylist)",
                "all(v ∈ P for v in mylist)",
                style;
                always_for_in = true,
            )
            # the iteration spec itself is still normalized
            test_format(
                "all(v ∈ P for v = mylist)",
                "all(v ∈ P for v in mylist)",
                style;
                always_for_in = true,
            )
        end
    end

    @testset "908 comment in do-block" begin
        s = "funct() do # comment\nend"
        test_format(s, s)
    end

    @testset "911" begin
        # `@testset` block should not prevent the formatter from nesting function
        # arguments that exceed the margin.
        s_ = """
        @testset begin
            DynamicPPL.assume(::Random.AbstractRNG, ::DynamicPPL.Sampler{MyEmptyAlg}, dist, vn, vi) = DynamicPPL.assume(
                    dist, vn, vi
                )
        end
        """
        s = """
        @testset begin
            DynamicPPL.assume(
                ::Random.AbstractRNG, ::DynamicPPL.Sampler{MyEmptyAlg}, dist, vn, vi
            ) = DynamicPPL.assume(dist, vn, vi)
        end
        """
        test_format(s_, s, BlueStyle())
    end

    @testset "912" begin
        s = """
        try
            nothing
        catch e
            nothing
        else
            nothing
        end
        """
        test_format(s, s; indent=4, margin=100)

        str_ = """
        try
         # comment
         catch e
         # comment
        body
         # comment
         else
         # comment
         end
        """
        s = """
        try
            # comment
        catch e
            # comment
            body
            # comment
        else
            # comment
        end
        """
        test_format(str_, s; indent=4, margin=100)
    end

    @testset "914" begin
        # SciMLStyle with `yas_style_nesting` should produce consistent indentation
        # regardless of argument length.
        s_ = """
        for some_long_variable in some_long_function(some_even_longer_variable,
                               some_longer_variable)
        end
        """
        s = """
        for some_long_variable in some_long_function(some_even_longer_variable,
                                                     some_longer_variable)
        end
        """
        test_format(s_, s, SciMLStyle(); yas_style_nesting = true)
    end

    @testset "916" begin
        # Generated docstrings with nested interpolation like `$($("@$f"))` should not
        # cause a parsing error.
        s = raw"""
        for f in [:A, :B]
            @eval begin
                export $f
                \"\"\"
                    Function $($("$f")) docstring

                # Example

                ```jldoctest
                julia> $($("@$f")) 1
                1
                ```
                \"\"\"
                macro $f(p)
                    p
                end
            end
        end
        """
        test_format(s, s)
    end

    @testset "917" begin
        s = "using Foo: ( .. )"
        sf = "using Foo: (..)"
        test_format(s, sf; indent=4, margin=100)
    end

    @testset "921" begin
        # These are floating point literals with hexadecimal significands. E.g. 0x1p1 is the
        # float with with 0x1 as the significant and 1 as the exponent.
        s = "0x1p1"
        test_format(s, s)
        s = "+0x1p1"
        test_format(s, s)
        s = "-0x1p1"
        test_format(s, s)
    end

    @testset "922" begin
        s = "x::T{\n    # com\n    F\n} = z()"
        for style in ALL_STYLES
            test_format(s, nothing, style; ast=true)
            sout = format_text(s, style)
            @test occursin("# com", sout)
        end
    end

    @testset "926" begin
        # Function calls with binary operators as arguments should preserve whitespace.
        # Previously `f(*, +, a, b)` was formatted as `f(*,+,a,b)`.
        test_format("f(*, +, a, b)", "f(*, +, a, b)")
        test_format("f(*, +, a, b, c)", "f(*, +, a, b, c)")
    end

    @testset "940 short_circuit_to_if in while cond" begin
        s = """
        function foo(i)
            cond2 = true
            while i < 42 && cond2
                i += 1
            end
            return i
        end"""
        for style in ALL_STYLES
            test_format(s, s, style; short_circuit_to_if = true)
        end
    end

    @testset "941 generator idempotence" begin
        kwargs = (indent=4, margin=120, always_for_in=true, for_in_replacement="∈", whitespace_typedefs=true, whitespace_ops_in_indices=true, remove_extra_newlines=true, whitespace_in_kwargs=false, annotate_untyped_fields_with_any=false, normalize_line_endings="unix")
        text = "idx = (\n    if refdim == 1\n        I\n    elseif refdim == 2\n        J\n    else\n        (:)\n    end for (vdim, refdim) ∈ T.parameters\n)"
        for style in ALL_STYLES
            test_format(text, nothing, style; ast=true, kwargs...)
        end
    end

    @testset "944 for-in scoping" begin
        test_format(
            "[x[i] = y[i] for i = 1:length(y)]",
            "[x[i] = y[i] for i in 1:length(y)]";
            always_for_in = true,
        )
        
        s = "any(x in 1:5 for x in xs)"
        test_format(s, s)
    end

    @testset "946" begin
        # Prior to v2.9.4 the newline didn't get deleted. #1173 introduced a fix for other
        # comment cases that caused the newline to get deleted. However since it doesn't
        # change the meaning, I can't be fussed to look into it further.
        s_ = "function f()\n    #==Pairs Tuple or ValidationResult==#\n    #=\n    So far\n    =#\nend\n"
        s = "function f()\n    #==Pairs Tuple or ValidationResult==# #=\n    So far\n    =#\nend\n"
        for style in ALL_STYLES
            test_format(s, s, style)
        end

        s2 = "function g()\n    y #=c=#\nend"
        for style in (DefaultStyle(), SciMLStyle(), MinimalStyle())
            test_format(s2, s2, style)
        end
        # these have always_use_return=true so test separately
        s2_return = """
        function g()
            return y #=c=#
        end"""
        for style in (BlueStyle(), YASStyle())
            test_format(s2, s2_return, style)
        end
        test_format(s2, s2_return; always_use_return = true)
    end

    @testset "949 format:on after TopLevel FST end but before last line" begin
        for s in (
            "#! format: off\nfoo(   )\n#! format: on\n\n",
            "#! format: off\nfoo(   )\n#! format: on\n",
            "#! format: off\nfoo(   )\n#! format: on",
            "#! format: off\nfoo(   )\n#! format: on\n#hi",
            "#! format: off\nfoo(   )\n#! format: on\n#hi\n",
        )
            for style in ALL_STYLES
                test_format(s, s, style)
            end
        end
    end

    @testset "991 emoji" begin
        s = "e = 🙃 -> \"x\\\n   y\""
        for style in ALL_STYLES
            test_format(s, s, style)
        end
    end

    @testset "1025" begin
        # from julia@1.12.6 Compiler/src/typelimits.jl
        s = """
        if is_lattice_equal(𝕃, ai, bi) || is_lattice_equal(𝕃, ai, ft)
            tyi = ai
        elseif is_lattice_equal(𝕃, bi, ft)
            tyi = bi
        elseif (tyi′ = tmerge_field(𝕃, ai, bi); tyi′ !== nothing)
            tyi = tyi′
        else
            tni = _typename(widenconst(ai))
            if tni isa Const && tni === _typename(widenconst(bi))
                tyi = typeintersect(ft, (tni.val::Core.TypeName).wrapper)
            else
                tyi = ft
            end
        end
        """
        test_format(s, s)
    end

    @testset "1017 trailing commas after macros/global" begin
        # macro
        s_ = "f(a = u -> @. u0)"
        s = "f(\n    a = u ->\n        @. u0\n)"
        for trailing_comma in (true, false, nothing)
            test_format(s_, s_; trailing_comma = trailing_comma)
            test_format(s_, s; margin = 10, trailing_comma = trailing_comma)
            for style in (SciMLStyle(), BlueStyle(), YASStyle(), MinimalStyle())
                test_format(s_, nothing; margin=10, ast=true)
            end
        end

        # global
        s_ = raw"""
        let libccalllazyfoo = LazyLibrary(lclf_path; on_load_callback=() -> global lclf_loaded = true),
            libccalllazybar = LazyLibrary(lclb_path; dependencies=[libccalllazyfoo], on_load_callback=() -> global lclb_loaded = true)
            eval(:(const libccalllazyfoo = $libccalllazyfoo))
            eval(:(const libccalllazybar = $libccalllazybar))
        end"""
        s = raw"""
        let libccalllazyfoo =
                LazyLibrary(lclf_path; on_load_callback = () -> global lclf_loaded = true),
            libccalllazybar = LazyLibrary(
                lclb_path;
                dependencies = [libccalllazyfoo],
                on_load_callback = () -> global lclb_loaded = true
            )

            eval(:(const libccalllazyfoo = $libccalllazyfoo))
            eval(:(const libccalllazybar = $libccalllazybar))
        end"""
        for trailing_comma in (true, false, nothing)
            test_format(s_, s; trailing_comma = trailing_comma)
        end
    end

    @testset "1018 macro do-block" begin
        # A macro call using `do` with keyword-style args must be formatted like the
        # function-call form, not left partially unformatted with extra spaces and
        # unindented multiline `do` arguments.
        test_format(
            "y = @foo(a=1,  b=2)  do x,\ny\n    x + y\nend\n",
            "y = @foo(a=1, b=2) do x, y\n    x + y\nend\n",
            BlueStyle(),
        )
        test_format(
            "expr_spec = @template_spec(parameters=(p1=10, p2=10, p3=1),  expressions=(f, g))  do x1,\nx2,\nclass\n\n    x1 * 2\nend\n",
            "expr_spec = @template_spec(\n    parameters=(p1=10, p2=10, p3=1), expressions=(f, g)\n) do x1, x2, class\n    x1 * 2\nend\n",
            BlueStyle(),
        )
        # default-style macrocall + do-block keeps single spaces and indents the body
        test_format("@modify(x) do y\n    y\nend", "@modify(x) do y\n    y\nend")
        test_format(
            "Makie.@recipe(A, B) do scene\n    t\nend",
            "Makie.@recipe(A, B) do scene\n    t\nend",
        )
        # macroblocks without a closer are unaffected
        test_format("@testset \"x\" begin\n    a\nend", "@testset \"x\" begin\n    a\nend")
    end

    @testset "1046 YAS comments being swallowed" begin
        s = """
        if (# opening inline
            a # another inline
            # stand-alone
            &&
            c # closing inline
            )
            foo
        end
        """ |> strip
        test_format(s, s, YASStyle())

        s2 = """f(# hi\n  a)"""
        test_format(s2, s2, YASStyle())

        # test some hash-eq comments for good measure
        s = """
        f(#= hi =# aaa,
          bbb,
          ccc #= hi =#)
        """
        test_format(s, s, YASStyle())
    end

    @testset "1048 generator idempotence" begin
        s = """
        (
            let x = f() do
                    return body
                end
                x
            end for x in xs
        )"""
        for style in ALL_STYLES
            if style isa YASStyle
                # no boundary newlines inside parens.
                target = "(let x = f() do\n         return body\n     end\n     x\n end\n for x in xs)"
                test_format(s, target, style)
            else
                test_format(s, s, style)
            end
        end

        s = """
        ys = (
            if p1(x)
                f1(x)
            elseif p2(x)
                f2(x)
            else
                f3(x)
            end for x in xs
        )"""
        for style in ALL_STYLES
            if style isa YASStyle
                target = """
                ys = (if p1(x)
                          f1(x)
                      elseif p2(x)
                          f2(x)
                      else
                          f3(x)
                      end
                      for x in xs)"""
                test_format(s, target, style)
            else
                test_format(s, s, style)
            end
        end
    end

    @testset "1062 docstring indent on rhs of short function def" begin
        for str in (
            "test_f() = \"\"\"\nxxxxx\n\"\"\"",
            "test_f = \"\"\"\nxxxxx\n\"\"\"",
        )
            for style in ALL_STYLES
                test_format(str, str)
                test_format(str, str; margin=4)
            end
        end
    end

    @testset "1064 space before hasheq-comment" begin
        s = "combine(x, 3 #= this is the magic number =#)"
        for style in ALL_STYLES
            test_format(s, s, style)
        end
    end

    @testset "1070 idempotent hasheq-comment in parameter list" begin
        # A `#= =#` comment on its own line in a nested parameter list must not gain a
        # spurious blank line on reformat. The signature is long enough to stay nested.
        s = """
        function f(
            obj;
            #=c=#
            keyword_argument_one::SomeLongTypeName,
            keyword_argument_two::AnotherLongType,
            keyword_argument_three::OneMoreType,
        )
            return obj
        end
        """
        test_format(s, s)
    end

    @testset "1072 exporting colon" begin
        for keyword in ("export", "public")
            s_ = "$(keyword) +, :, -"
            for style in ALL_STYLES
                test_format(s_, s_, style; margin=length(s_))
            end
            for style in (DefaultStyle(), BlueStyle(), MinimalStyle())
                s = "$(keyword) +,\n    :,\n    -"
                test_format(s_, s, style; margin=5)
            end
            for style in (SciMLStyle(), YASStyle())
                s = "$(keyword) +,\n       :,\n       -"
                test_format(s_, s, style; margin=5)
            end
        end
    end

    @testset "1076 avoid un-nesting chain" begin
        s_ = """
        if curs_row >= 0 && cur_row + 1 >= rows &&             # when too many lines,
                            cur_row - curs_row + 1 >= rows ÷ 2 # center the cursor
            lastline = true
        end"""
        s = """
        if curs_row >= 0 &&
           cur_row + 1 >= rows &&             # when too many lines,
           cur_row - curs_row + 1 >= rows ÷ 2 # center the cursor
            lastline = true
        end"""
        test_format(s_, s)

        sblue = """
        if curs_row >= 0 &&
            cur_row + 1 >= rows &&             # when too many lines,
            cur_row - curs_row + 1 >= rows ÷ 2 # center the cursor
            lastline = true
        end"""
        test_format(s_, sblue, BlueStyle())

        syas = """
        if curs_row >= 0 && cur_row + 1 >= rows &&             # when too many lines,
           cur_row - curs_row + 1 >= rows ÷ 2 # center the cursor
            lastline = true
        end"""
        for style in (YASStyle(), SciMLStyle())
            test_format(s_, syas, style)
        end

        # MinimalStyle enables `indent_binary_continuations`, so chain continuations get one
        # indent level instead of being aligned to the column of the first operand (#592).
        sminimal = """
        if curs_row >= 0 && cur_row + 1 >= rows &&             # when too many lines,
            cur_row - curs_row + 1 >= rows ÷ 2 # center the cursor
            lastline = true
        end"""
        test_format(s_, sminimal, MinimalStyle())
    end

    @testset "1078 <: and >: as function calls" begin
        for s in (
            "<:(A, B)",
            ">:(A, B)",
            "f(<:(A, B))",
            "f(>:(A, B))",
            "@m <:(A, B)",
            "@m >:(A, B)",
        )
            for style in ALL_STYLES
                test_format(s, s, style)
            end
        end
    end

    @testset "1079 operator calls with (args...)" begin
        for s in (
            "<:(args...)",
            ">:(args...)",
            "+(args...)",
            "f(<:(args...))",
            "f(>:(args...))",
            "f(+(args...))",
            "@m <:(args...)",
            "@m >:(args...)",
            "@m +(args...)",
        )
            for style in ALL_STYLES
                test_format(s, s, style)
            end
        end
    end

    @testset "1088 comment after do" begin
        for comment_and_do_arg in (
            "# comment",
            "x # comment",
            "(x, y) # comment",
            "#= comment =# x",
        )
            for maybe_macro in ("@test ", "")
                s = """
                $(maybe_macro)f() do $(comment_and_do_arg)
                    return g
                end"""
                for style in ALL_STYLES
                    test_format(s, s, style)
                end
            end
        end
    end

    @testset "1103 YAS indentation after =>" begin
        for s in (
        """
        long_name => [
                      #
                      1,
                      2,
                      3
                      #
                      ]""",

        """
        ccc => function ()
            return f() do x
                return aaaaaaaaaaaaa
            end
        end""",
        )
            test_format(s, s, YASStyle())
        end
    end

    @testset "1105 typed comprehension idempotence" begin
        s = """
        function f()
            initial_incoming_vals = Pair{Any, Any}[
                if 0 in defuses[x].defs
                    Pair{Any, Any}(Argument(x), true)
                elseif !defuses[x].any_newvar
                    Pair{Any, Any}(UNDEF_TOKEN, false)
                else
                    Pair{Any, Any}(SSAValue(-2), false)
                end for x in 1:length(ci.slotflags)
            ]
        end"""
        target = """
        function f()
            initial_incoming_vals = Pair{Any,Any}[
                if 0 in defuses[x].defs
                    Pair{Any,Any}(Argument(x), true)
                elseif !defuses[x].any_newvar
                    Pair{Any,Any}(UNDEF_TOKEN, false)
                else
                    Pair{Any,Any}(SSAValue(-2), false)
                end for x = 1:length(ci.slotflags)
            ]
        end"""
        for style in ALL_STYLES
            if style isa DefaultStyle
                test_format(s, target, style)
            else
                test_format(s, nothing, style)
            end
        end
    end

    @testset "1107 surround_whereop_typeparameters idempotence" begin
        s = "sig = Tuple{T, Val{T}} where T<:(Val{T} where T<:(Val{T} where T<:(Val{T} where T<:(Val{T} where T<:Val))))"
        for style in ALL_STYLES
            test_format(s, nothing, style; ast=true, margin=88)
            test_format(s, nothing, style; ast=true, surround_whereop_typeparameters = true, margin=88)
        end
    end

    @testset "1108 always_for_in idempotence" begin
        # The bug was that without the `in` -> `=`, it's over margin, so lines were broken.
        # But after converting to `=` it's within margin, so the formatter decided to join
        # it back, leading to idempotence failure.
        s_ = """
        function f()
            d = Dict([randstring(8) => [RainbowString(randstring(8)) for i in 1:10] for j in 1:5]...)
        end"""
        s = """
        function f()
            d = Dict([randstring(8) => [RainbowString(randstring(8)) for i = 1:10] for j = 1:5]...)
        end"""
        test_format(s_, s)
        # Check that other style decisions don't mess with it
        for style in ALL_STYLES
            test_format(s_, s, style; margin=92, always_use_return=false, always_for_in=true, for_in_replacement="=")
        end
    end

    @testset "1109 multiline string idempotence" begin
        # All of these were idempotence bugs with JuliaLang/julia@v1.12.6.

        # from test/intrinsics.jl
        s1 = """
        @testset "issue #54548" begin
            @inline passthrough(ptr::Core.LLVMPtr{T,A}) where {T,A} = Base.llvmcall((
                \"""
        define ptr addrspace(1) @entry(ptr addrspace(1) %0) #0 {
        entry:
            ret ptr addrspace(1) %0
        }

        attributes #0 = { alwaysinline }\""",
                "entry",
            ), Core.LLVMPtr{T,A}, Tuple{Core.LLVMPtr{T,A}}, ptr)
            f(gws) = passthrough(Core.bitcast(Core.LLVMPtr{UInt32,1}, gws))
            f(C_NULL)
        end
        """

        # from test/show.jl
        s2 = raw"""
        eval(Meta._parse_string(
            \"""function my_fun28173(x)
            y = if x == 1
                    "HI"
                elseif x == 2
                    r = 1
                    s = try
                        r = 2
                        Base.inferencebarrier(false) && error()
                        "BYE"
                    catch
                        r = 3
                        "CAUGHT!"
                    end
                    "\$r\$s"
                else
                    "three"
                end
            return y
        end\""",
            "a"^80,
            1,
            1,
            :statement,
        )[1]) # use parse to control the line numbers
        """

        # from test/syntax.jl
        s3 = """
        @test isempty(Test.collect_test_logs() do
            include_string(
                @__MODULE__,
                \"""
        function foo37126()
            f(lhs::Integer, rhs::Integer) = nothing
            f(lhs::Integer, rhs::AbstractVector{<:Integer}) = nothing
            return f
        end
        struct Bar37126{T<:Real, P<:Real} end
        \""",
            )
        end[1])
        """

        for s in (s1, s2, s3)
            for style in ALL_STYLES
                test_format(s, nothing, style; v2_stable_multiline_strings=true)
            end
        end
    end

    @testset "1114 parenthesised caller in function def" begin
        for where in ("", " where T", " where {S,T}", " where S where T")
            s = """
            function (foo::Foo)(a, b)$(where)
               foo
            end
            """
            for style in ALL_STYLES
                test_format(s, nothing, style; ast=true, always_use_return=false)
                test_format(s, nothing, style; ast=true, always_use_return=false, margin=10)
            end
        end

        s = """
        @inline function (boundary_condition::BoundaryConditionNavierStokesWall{<:NoSlip,
                                                                                <:Adiabatic})(flux_inner,
                                                                                              u_inner,
                                                                                              orientation::Integer,
                                                                                              direction,
                                                                                              x,
                                                                                              t,
                                                                                              operator_type::Gradient,
                                                                                              equations::CompressibleNavierStokesDiffusion1D{GradientVariablesPrimitive})
            v1 = boundary_condition.boundary_condition_velocity.boundary_value_function(x, t,
                                                                                        equations)
            return SVector(u_inner[1], v1, u_inner[3])
        end"""
        output = """
        @inline function (boundary_condition::BoundaryConditionNavierStokesWall{
            <:NoSlip,
            <:Adiabatic,
        })(
            flux_inner,
            u_inner,
            orientation::Integer,
            direction,
            x,
            t,
            operator_type::Gradient,
            equations::CompressibleNavierStokesDiffusion1D{GradientVariablesPrimitive},
        )
            v1 = boundary_condition.boundary_condition_velocity.boundary_value_function(
                x,
                t,
                equations,
            )
            return SVector(u_inner[1], v1, u_inner[3])
        end"""
        test_format(s, output; ast=true)

        s = raw"""
        function (f::AbsAffineSchemeMor{<:AbsAffineScheme{S},<:AbsAffineScheme{S},<:Any,<:Any,Nothing})(P::AbsAffineRationalPoint) where {S}
          # The Nothing type parameter assures that the base morphism is trivial.
          @req domain(f) == codomain(P) "$(P) not in domain"
          @req base_ring(domain(f)) == base_ring(codomain(f)) "schemes must be defined over the same base ring. Try to map the point as an ideal instead"
          x = coordinates(codomain(f))
          g = pullback(f)
          p = coordinates(P)
          imgs = [evaluate(lift(g(y)),p) for y in x]
          return codomain(f)(imgs; check=false)
        end"""
        out = raw"""
        function (f::AbsAffineSchemeMor{
            <:AbsAffineScheme{S},
            <:AbsAffineScheme{S},
            <:Any,
            <:Any,
            Nothing,
        })(
            P::AbsAffineRationalPoint,
        ) where {S}
            # The Nothing type parameter assures that the base morphism is trivial.
            @req domain(f) == codomain(P) "$(P) not in domain"
            @req base_ring(domain(f)) == base_ring(codomain(f)) "schemes must be defined over the same base ring. Try to map the point as an ideal instead"
            x = coordinates(codomain(f))
            g = pullback(f)
            p = coordinates(P)
            imgs = [evaluate(lift(g(y)), p) for y in x]
            return codomain(f)(imgs; check = false)
        end"""
        test_format(s, out; ast=true)

        # Check that parenthesised callers outside of function definitions aren't affected.
        s = "(loooooong)(1, 2, 3)"
        out = "(\n    loooooong\n)(\n    1,\n    2,\n    3,\n)"
        test_format(s, out; ast=true, margin=10)
        s = """
        (function()
            foo
        end)()"""
        out = """
        (
            function ()
                foo
            end
        )()"""
        test_format(s, out; ast=true, margin=10)
    end

    @testset "1121 standalone circuit inconsistency" begin
        for prefix in (
            "",
            "x = ",
            "x + ",
            "return ",
        )
            s = "$(prefix)f(a, mmmmm || nnnnn, c)"
            out = "$(prefix)f(\n    a,\n    mmmmm ||\n        nnnnn,\n    c,\n)"
            test_format(s, out; ast=true, margin=10)
        end

        # and the original trigger
        s = """
        function f()
            EnzymeInterpreter(cache_or_token, mt, world, mode == API.DEM_ForwardMode, mode == API.DEM_ReverseModeCombined || mode == API.DEM_ReverseModePrimal || mode == API.DEM_ReverseModeGradient, inactive_rules, broadcast_rewrite, within_autodiff_rewrite, handler)
        end"""
        out = """
        function f()
            return EnzymeInterpreter(
                cache_or_token,
                mt,
                world,
                mode == API.DEM_ForwardMode,
                mode == API.DEM_ReverseModeCombined ||
                    mode == API.DEM_ReverseModePrimal ||
                    mode == API.DEM_ReverseModeGradient,
                inactive_rules,
                broadcast_rewrite,
                within_autodiff_rewrite,
                handler,
            )
        end"""
        test_format(s, out, BlueStyle())
    end

    @testset "1123 short_circuit_to_if inside calls" begin
        # short_circuit_to_if should not expand `&&`/`||` inside function calls,
        # tuples, etc. where the value is used.
        for s in (
            "f(a && b)",
            "return f(a && b)",
            "x = f(a && b)",
            "(a && b, c)",
            "[a && b]",
            "@macro a && b",
            "(a && b) + c", # even when parenthesised
        )
            test_format(s, s; short_circuit_to_if=true)
        end

        # But standalone `a && b` in a block should still expand -- as long as it's not at
        # the end of the block (in which case the block evaluates to it).
        for (block_begin, block_end) in (
            ("function g()", "end"),
            ("if foo", "end"),
            ("for i = 1:10", "end"),
            ("while true", "end"),
            ("let x = 1", "end"),
            ("begin", "end"),
        )
            test_format(
                "$block_begin\n    a && b\n    2\n$block_end",
                "$block_begin\n    if a\n        b\n    end\n    2\n$block_end";
                short_circuit_to_if=true,
            )

            # Check that it doesn't expand at the end of the block.
            test_format(
                "$block_begin\n    a && b\n$block_end",
                "$block_begin\n    a && b\n$block_end",
                short_circuit_to_if=true,
            )
        end

        # Should expand at the top level.
        test_format("a && b", "if a\n    b\nend"; short_circuit_to_if=true)
    end

    @testset "1124 do not change syntax in Exprs" begin
        @testset "short to long funcdef" begin
            for s in (
                ":(f(x) = 1)",
                "@macro f(x) = 1",
                "@macro(f(x) = 1)",
            )
                for style in ALL_STYLES
                    test_format(s, s, style; short_to_long_function_def=true, force_long_function_def=true)
                end
            end
        end
    end

    @testset "1125 always_use_return idempotence" begin
        s = """
        function f()
            if visible
                any_visible = any(ALL_SCREENS) do s
                    s !== screen && s.owns_glscreen &&
                        GLAbstraction.context_alive(s.glscreen) &&
                        GLFW.GetWindowAttrib(s.glscreen, GLFW.VISIBLE) != 0
                end
                any_visible || macos_set_dock_visible(false)
            end
        end"""
        output = """
        function f()
            if visible
                any_visible = any(ALL_SCREENS) do s
                    return s !== screen &&
                           s.owns_glscreen &&
                           GLAbstraction.context_alive(s.glscreen) &&
                           GLFW.GetWindowAttrib(s.glscreen, GLFW.VISIBLE) != 0
                end
                any_visible || macos_set_dock_visible(false)
            end
        end"""
        test_format(s, output; always_use_return=true)
        test_format(s, output, BlueStyle())
    end

    @testset "1132 BlueStyle chained ternary expansion idempotence" begin
        s = "f() = a ? b : c ? d : e"
        output = """
        f() =
            if a
                b
            elseif c
                d
            else
                e
            end"""
        test_format(s, output, BlueStyle())
    end

    @testset "1142 chained ternary expansion comments in condition" begin
        # the elseif condition needs to be parenthesised, otherwise the
        # comment ruins the day
        for expr in ("c && d", "c + d")
            s = """
            begin
                a ? b :
                # comment
                $(expr) ? e : f
            end"""
            output = """
            begin
                if a
                    b
                elseif (
                    # comment
                    $(expr)
                )
                    e
                else
                    f
                end
            end"""
            test_format(s, output, BlueStyle())
        end

        # if expr is c(d), it gets shifted above. Just don't ask. It's a JuliaSyntax thing.
        s = """
        begin
            a ? b :
            # comment
            c(d) ? e : f
        end"""
        output = """
        begin
            if a
                b
                # comment
            elseif c(d)
                e
            else
                f
            end
        end"""
        test_format(s, output, BlueStyle())
    end

    @testset "1144 ops as keyword names" begin
        for s in (
            "Compiler.sort!(v; by = x -> -x, < = >) === v == [1,2,3]",
            "sort(v; by, lt) == Compiler.sort!(copy(v); by, < = lt)",
        )
            for style in ALL_STYLES
                test_format(s, nothing, style; ast=true)
            end
        end

        # Don't need to parenthesise if there are comments to help us separate
        s = "f(x; < #= comment =# = >)"
        out = "f(x; < #= comment =# =(>))"
        test_format(s, out, BlueStyle())
        for style in (DefaultStyle(), SciMLStyle(), YASStyle(), MinimalStyle())
            test_format(s, nothing, style; ast=true)
        end

        s = "f(x; < = #= comment =# >)"
        out = "f(x; (<)= #= comment =# >)"
        test_format(s, out, BlueStyle())
        for style in (DefaultStyle(), SciMLStyle(), YASStyle(), MinimalStyle())
            test_format(s, nothing, style; ast=true)
        end
    end

    @testset "1147 pipe_to_function_call with assignment" begin
        for parens in (
            "(a = b)",
            "(#= 1 =# a #= 2 =# = #= 3 =# b #= 4 =#)",
        )
            s = "$(parens) |> f"
            expected_out = "f($(parens))"
            for style in ALL_STYLES
                test_format(s, expected_out, style; pipe_to_function_call=true)
            end
        end

        s = """(
            a = b # why
        ) |> f"""
        expected_out = """f((
            a = b # why
        ))"""
        for style in (DefaultStyle(), BlueStyle())
            test_format(s, expected_out, style; pipe_to_function_call=true)
        end
    end

    @testset "1149 array literal idempotence" begin
        s = """begin
            @test [-1m -1y -1y-1m + 1w -1y-1m + 1d; -1y-1m + 1h -1y-1m + 1mi -1y-1m + 1s -1y-1m + 1ms]
        end"""
        for style in ALL_STYLES
            test_format(s, nothing, style; ast=true)
        end

        s = "@f [a b c; d e f]"
        for style in ALL_STYLES
            test_format(s, nothing, style; ast=true)
        end
    end

    @testset "1127 short to long function indentation" begin
        s = """begin
            a() = b
        end"""
        for always_use_return in (true, false)
            maybe_return = always_use_return ? "return " : ""
            output = """begin
                function a()
                    $(maybe_return)b
                end
            end"""
            for style in ALL_STYLES
                test_format(s, output, style; always_use_return=always_use_return, short_to_long_function_def=true, force_long_function_def=true)
            end
        end

        # With one more level
        s = """begin
            begin
            a() = b
            end
        end"""
        out = """begin
            begin
                function a()
                    return b
                end
            end
        end"""
        test_format(s, out, BlueStyle(); margin=10)

        # Avoid over-indenting expressions that already have their own indent
        s = """begin
            get_gradient_backends() = [AutoForwardDiff(), AutoEnzyme(mode = Enzyme.set_runtime_activity(Enzyme.Reverse))]
        end"""
        out = """begin
            function get_gradient_backends()
                return [
                    AutoForwardDiff(),
                    AutoEnzyme(; mode=Enzyme.set_runtime_activity(Enzyme.Reverse)),
                ]
            end
        end"""
        test_format(s, out, BlueStyle())

        s = """begin
            DifferencePolyRingElem{T}(dpr::DifferencePolyRing{T}) where {T} = new{T}(zero(dpr.upoly_ring), dpr, true, Int[])
        end"""
        out = """begin
            function DifferencePolyRingElem{T}(dpr::DifferencePolyRing{T}) where {T}
                return new{T}(zero(dpr.upoly_ring), dpr, true, Int[])
            end
        end"""
        test_format(s, out, BlueStyle())
    end

    @testset "1153 & 1170 empty blocks" begin
        for prefix in ("begin", "@testset begin", "function f(g)")
            for nls in ("\n\n", "\n\n\n")
                s = "$(prefix)$(nls)end"
                test_format(s, "$(prefix) end", DefaultStyle())
                test_format(s, "$(prefix) end", BlueStyle())
                test_format(s, "$(prefix)\nend", SciMLStyle())
                test_format(s, "$(prefix)\nend", YASStyle())
                test_format(s, "$(prefix)$(nls)end", MinimalStyle())
            end

            s_ = "$(prefix)\n#= hi =#\nend"
            s = "$(prefix)\n    #= hi =#\nend"
            for style in ALL_STYLES
                test_format(s_, s, style)
            end

            s_ = "$(prefix)\n# hi\nend"
            s = "$(prefix)\n    # hi\nend"
            for style in ALL_STYLES
                test_format(s_, s, style)
            end
        end
    end

    @testset "1159 chained ternary block with parens" begin
        s = "x ? y : p ? (q; r) : s"
        out = """if x
            y
        elseif p
            (q; r)
        else
            s
        end"""
        test_format(s, out, BlueStyle())

        s = "p ? (q; r) : s ? t : u"
        out = """if p
            (q; r)
        elseif s
            t
        else
            u
        end"""
        test_format(s, out, BlueStyle())
    end

    @testset "1162 chained ternary in generator" begin
        s = """m = [i ? j : m ? p : q for i in j]"""
        out = """
        m = [
            if i
                j
            elseif m
                p
            else
                q
            end for i in j
        ]"""
        test_format(s, out, BlueStyle())

        s = """
        mat = [j == 1 ? NoQuote(rownms[i]) :
               j-1 == ct.pvalcol ? NoQuote(sprint(show, PValue(cols[j-1][i]))) :
               j-1 in ct.teststatcol ? TestStat(cols[j-1][i]) :
               cols[j-1][i] isa AbstractString ? NoQuote(cols[j-1][i]) : cols[j-1][i]
               for i in 1:nr, j in 1:nc+1]"""
        out = """
        mat = [
            if j == 1
                NoQuote(rownms[i])
            elseif j-1 == ct.pvalcol
                NoQuote(sprint(show, PValue(cols[j - 1][i])))
            elseif j-1 in ct.teststatcol
                TestStat(cols[j - 1][i])
            elseif cols[j - 1][i] isa AbstractString
                NoQuote(cols[j - 1][i])
            else
                cols[j - 1][i]
            end for i in 1:nr, j in 1:(nc + 1)
        ]"""
        test_format(s, out, BlueStyle())
    end
    
    @testset "1163 macros with dots" begin
        for s in ("Optimizers.@.. foo", "Base.@. foo")
            for style in ALL_STYLES
                test_format(s, s, style)
            end
        end

        test_format("@Base.foo 1", "Base.@foo 1")
        test_format("@Base.Foo.foo 1", "Base.Foo.@foo 1")

        s = raw":($(@__MODULE__).@macro foo)"
        test_format(s, s)
    end

    @testset "1166 emojis" begin
        s1 = raw"""
        @😬 \"foo
             foo\"
        """
        s2 = raw"""
        😬(\"foo
            foo\")
        """
        for s in (s1, s2)
            for style in ALL_STYLES
                test_format(s, s, style)
            end
        end

        # Multiline string with emojis in macro name: alignment must be idempotent.
        s = raw"""
        @😬 \"ssl_read ⬅️  $n $(n == MBEDTLS_ERR_SSL_PEER_CLOSE_NOTIFY ? foo :
                               n == MBEDTLS_ERR_SSL_CONN_EOF          ? foo :
                               n == MBEDTLS_ERR_NET_CONN_RESET        ? foo :
                               n == MBEDTLS_ERR_SSL_WANT_READ         ? foo : boo)\"
        """
        test_format(s, s)

        # Wide CJK characters should be measured by display width (textwidth), not
        # character count (length). This line is 63 display columns wide but only
        # 39 characters long, so it should nest at margin = 62 but not at margin = 63.
        str = """
        f("日本語は実はわかりません", "Claudeがこのテストを書きました")
        """
        str_nested = """
        f(
            "日本語は実はわかりません",
            "Claudeがこのテストを書きました",
        )
        """
        test_format(str, str_nested; margin = 62)
        test_format(str, str; margin = 63)
    end

    @testset "1172 line comments after inline" begin
        for s in (
            "#= hi \n =# # bye",
            "#= hi \n =## bye",
            "#= hi \n =#   # bye",
            "a #= hi \n =#   # bye",
            "#= hi \n =#   # bye",
        )
            for style in ALL_STYLES
                test_format(s, s, style)
            end
        end

        # Inserts a newline here but I don't really care enough to fix it.
        # At least it preserves meaning
        s_ = "#= hi \n =# a # bye"
        s = "#= hi \n =#\na # bye"
        for style in ALL_STYLES
            test_format(s_, s, style)
        end
    end

    @testset "1177 chained ternary and shortcircuit" begin
        s = """
        function f()
            x =
            a ? b :
            (aaaaaaaaaaaaaaaaaaaa || bbbbbbbbbbbbbbbbb) && ccccccccccccccccccccccccccccccccc ? d : e
            return 1
        end"""
        out = """
        function f()
            x = if a
                b
            elseif (aaaaaaaaaaaaaaaaaaaa || bbbbbbbbbbbbbbbbb) && ccccccccccccccccccccccccccccccccc
                d
            else
                e
            end
            return 1
        end"""
        test_format(s, out, BlueStyle())
    end

    @testset "1179 separate_kwargs_with_semicolon with comment" begin
        for s in (
            "foo(#comment,\na=a;\nb=b)",
            "foo(#comment,\na=a,\nb=b)",
        )
            expected = """
            foo(; #comment,
                a = a,
                b = b,
            )"""
            test_format(s, expected; separate_kwargs_with_semicolon=true)
        end

        s = "foo(\n#comment,\na=a;\nb=b)"
        expected = """
        foo(;
            #comment,
            a = a,
            b = b,
        )"""
        test_format(s, expected; separate_kwargs_with_semicolon=true)
    end

    @testset "1219 dedenting empty do-block argument" begin
        s = """
        ccc => function ()
            return f() do
                return aaaaaaaaaaaaa
            end
        end"""
        test_format(s, s, YASStyle(); margin=30)
    end

    @testset "1225 YAS trailing comma with zero args" begin
        s_ = """
        f(
             # Hi
        )"""
        s = """
        f(
          # Hi
          )"""
        test_format(s_, s, YASStyle())

        s_ = """
        f(
             #= Hi =#
        )"""
        s = """
        f(
          #= Hi =#)"""
        test_format(s_, s, YASStyle())
    end

    @testset "1238 block as the first element of a tuple" begin
        str_ = "(begin x = 1 end, 1)"
        str1 = "(begin\n    x = 1\nend, 1)"
        str2 = "(begin\n     x = 1\n end, 1)"
        str3 = "(\n    begin\n        x = 1\n    end,\n    1,\n)"
        test_format(str_, str1, DefaultStyle())
        test_format(str_, str1, MinimalStyle())
        test_format(str_, str2, YASStyle())
        test_format(str_, str3, BlueStyle())

        str_ = "(for _ = 1:10; x = 1; end, 1)"
        str = "(for _ = 1:10\n    x = 1\nend, 1)"
        for st in (DefaultStyle(), MinimalStyle())
            test_format(str_, str, st)
        end

        str_ = "aa = (begin x = 1 end, 1)"
        str = "aa = (begin\n    x = 1\nend, 1)"
        for st in (DefaultStyle(), MinimalStyle())
            test_format(str_, str, st)
        end
    end

    @testset "1241 array idempotence MinimalStyle" begin
        s = """
        [
            [a
                []

            if b
                c
            end
            ]
        ]"""
        test_format(s, nothing, MinimalStyle())
    end

    @testset "1244 join_lines idempotence fail with for ... in" begin
        s = "[foo(bar) for i in I]"
        test_format(s, nothing; join_lines_based_on_source=true, margin=16, ast=true)

        s_ = """
        begin
          HSeriesList = [multi_hilbert_series(quo(P,I)[1]; parent=HSRing, backend=backend)[1][1]  for I in IdealList];
        end"""

        s = """
        begin
            HSeriesList = [
                multi_hilbert_series(quo(P, I)[1]; parent = HSRing, backend = backend)[1][1] for
                I in IdealList
            ]
        end"""
        test_format(s_, s; join_lines_based_on_source=true)
    end

    @testset "1250 no gluing operators when it changes tokenization" begin
        # MinimalStyle has `trailing_zero = false`, so the trailing-dot floats survive
        # as-is and gluing the operators to them would produce `A[1...1., :]` (invalid)
        # and `SA[1.+2*cos(1.), 1.]` (ambiguous `.` syntax). The space must be kept.
        test_format("x = A[1. .. 1., :]", "x = A[1. .. 1., :]", MinimalStyle(); ast=true)
        test_format(
            "y = SA[1. + 2*cos(1.), 1.]",
            "y = SA[1. + 2*cos(1.), 1.]",
            MinimalStyle();
            ast=true,
        )

        # DefaultStyle normalizes `1.` to `1.0`, after which gluing is unambiguous.
        test_format("x = A[1. .. 1., :]", "x = A[1.0..1.0, :]", DefaultStyle(); ast=true)

        # A binary operator must not be glued against a unary operator: `A[1--2]` does
        # not parse. This previously errored for DefaultStyle and MinimalStyle too
        # (YAS/Blue/SciML keep the spaces via `whitespace_ops_in_indices = true`).
        for style in ALL_STYLES
            test_format("A[1 - -2]", nothing, style; ast=true)
        end

        # Non-regression: gluing still happens whenever it is safe.
        test_format("A[1 + 2]", "A[1+2]", MinimalStyle(); ast=true)
        test_format("A[1 + 2]", "A[1+2]", DefaultStyle(); ast=true)
        # `1.:2` tokenizes the same as `1. : 2`, so a trailing-dot float does not
        # blanket-disable gluing.
        test_format("A[1. : 2]", "A[1.:2]", MinimalStyle(); ast=true)
        # The adjoint `'` (including suffixed forms) and string delimiters next to an
        # operator are fine to glue.
        test_format("A[a' - b]", "A[a'-b]", MinimalStyle(); ast=true)
        test_format("A[a'ᵀ - b]", "A[a'ᵀ-b]", MinimalStyle(); ast=true)
        test_format("A[a'ᵀ - b]", "A[a'ᵀ-b]", DefaultStyle(); ast=true)
        test_format("A[\"a\" * \"b\"]", "A[\"a\"*\"b\"]", DefaultStyle(); ast=true)
    end

    @testset "1251 re-indentation must not change multiline string contents" begin
        # For a regular (non-triple-quoted) multiline string literal every leading space
        # of the continuation lines is part of the string's value. Re-indenting the
        # surrounding code must therefore leave the interior lines untouched; only the
        # line with the opening quote moves.
        #
        # We use `begin ... end` instead of `function` to avoid Blue/YAS styles
        # inserting `return` and changing the expected output.
        s = """
        begin
                x = "line one
                line two"
        end
        """
        expected = """
        begin
            x = "line one
                line two"
        end
        """
        for style in ALL_STYLES
            test_format(s, expected, style; ast=true)
            # cmd literals and non-triple string-macro literals have the same no-dedent
            # semantics and use the same code path
            test_format(
                "begin\n        c = `cmd one\n        two`\nend\n",
                "begin\n    c = `cmd one\n        two`\nend\n",
                style;
                ast=true,
            )
            test_format(
                "begin\n        r = r\"aa\n        bb\"x\nend\n",
                "begin\n    r = r\"aa\n        bb\"x\nend\n",
                style;
                ast=true,
            )
            test_format(
                "begin\n        r = raw\"aa\n        bb\"\nend\n",
                "begin\n    r = raw\"aa\n        bb\"\nend\n",
                style;
                ast=true,
            )
            # blank interior line
            test_format(
                "begin\n        x = \"a\n\n        b\"\nend\n",
                "begin\n    x = \"a\n\n        b\"\nend\n",
                style;
                ast=true,
            )
        end

        # a multiline string at top level (indent 0) is left completely unchanged
        for style in ALL_STYLES
            test_format("x = \"a\n    b\"\n", "x = \"a\n    b\"\n", style; ast=true)
        end
        # interior line starting at column 0, left of the opening quote
        for style in ALL_STYLES
            test_format(
                "begin\n        x = \"a\nb\"\nend\n",
                "begin\n    x = \"a\nb\"\nend\n",
                style;
                ast=true,
            )
        end

        # Control: triple-quoted strings have dedent semantics, so their interior lines
        # DO shift with the surrounding code (issue #501 tracks those separately).
        for style in ALL_STYLES
            test_format(
                "begin\n        x = \"\"\"\n        line\n        \"\"\"\nend\n",
                "begin\n    x = \"\"\"\n    line\n    \"\"\"\nend\n",
                style;
                ast=true,
            )
        end

        # interplay with v2_stable_multiline_strings
        for style in ALL_STYLES
            test_format(s, expected, style; v2_stable_multiline_strings=true, ast=true)
        end
    end
end

end

module AlwaysUseReturnTests

using JuliaFormatter: DefaultStyle, YASStyle, BlueStyle, SciMLStyle, MinimalStyle, format_text
using JuliaFormatter.Internal: test_format
using Test

@testset "always_use_return" begin
    @testset "option disabled: no return added" begin
        str = """
        function foo()
            expr1
            expr2
        end
        """
        test_format(str, str; always_use_return = false)
    end

    @testset "not in function/macro/do body: no return added" begin
        str = """
        begin
            expr1
            expr2
        end
        """
        test_format(str, str; always_use_return = true)
    end

    @testset "last statement is already return" begin
        str = """
        function foo()
            expr1
            return expr2
        end
        """
        test_format(str, str; always_use_return = true)
    end

    @testset "docstring-preceded statement is left alone (#405)" begin
        str = """
        function foo()
            \"\"\"docstring\"\"\"
            bar
        end
        """
        test_format(str, str; always_use_return = true)
    end

    @testset "short-to-long function def" begin
        # NOTE(penelopeysm): This is cursed because it uses prepend_return_fst!.
        # Very easy to trigger idempotence failures!
        str_ = "foo(a) = bodybodybody"
        str = """
        function foo(a)
            return bodybodybody
        end"""
        test_format(
            str_,
            str;
            margin = length(str_) - 1,
            short_to_long_function_def = true,
            always_use_return = true,
        )
    end

    @testset "function body" begin
        str_ = """
        function foo()
            expr1
            expr2
        end"""
        str = """
        function foo()
            expr1
            return expr2
        end"""
        test_format(str_, str; always_use_return = true)
    end

    @testset "macro body" begin
        str_ = """
        macro foo()
            expr1
            expr2
        end"""
        str = """
        macro foo()
            expr1
            return expr2
        end"""
        test_format(str_, str; always_use_return = true)
    end

    @testset "do block" begin
        str_ = """
        map(arg1, arg2) do x, y
            expr1
            expr2
        end"""
        str = """
        map(arg1, arg2) do x, y
            expr1
            return expr2
        end"""
        test_format(str_, str; always_use_return = true)
    end

    @testset "cases where we don't want to insert return" begin
        @testset "already has return" begin
            # Technically the idempotence tests already catch this, but may as well be
            # explicit
            str = """
            function foo()
                expr1
                return expr2
            end"""
            test_format(str, str; always_use_return = true)
        end

        @testset "macros" begin
            str = """
            function foo()
                @macrocall(expr2)
            end"""
            test_format(str, str; always_use_return = true)

            str = """
            function foo()
                @macroblock expr2
            end"""
            test_format(str, str; always_use_return = true)
        end

        @testset "do-block calls" begin
            str = """
            function foo()
                open("metrics.out", "w") do f
                    return JSON.print(f, metrics)
                end
            end
            """
            test_format(str, str; always_use_return = true)
        end

        @testset "blocks" begin
            str = """
            function foo()
                for i = 1:10
                    println(i)
                end
            end"""
            test_format(str, str; always_use_return = true)

            str = """
            function f(a)
                if a > 0
                    return -1
                else
                    return 1
                end
            end"""
            test_format(str, str; always_use_return = true)
        end

        @testset "parenthesized compound expression gets return" begin
            str_ = """
            function foo(integrator, dt)
                (integrator.dtpropose = dt; integrator.dtcache = dt)
            end
            """
            str = """
            function foo(integrator, dt)
                return (integrator.dtpropose = dt; integrator.dtcache = dt)
            end
            """
            test_format(str_, str; always_use_return = true)
        end

        @testset "expressions containing returns" begin
            str = """
            function f()
                (1 + 1; return 2)
            end
            """
            test_format(str, str; always_use_return = true)

            str = """
            function foo(x)
                x > 0 ? (return 1) : (return 2)
            end
            """
            test_format(str, str; always_use_return = true)

            str = """
            function foo(x)
                x > 0 ? (return 1) : 2
            end
            """
            test_format(str, str; always_use_return = true)

            for op in ("&&", "||")
                str = """
                function foo(x)
                    x > 0 $op (return 1)
                end
                """
                test_format(str, str; always_use_return = true)
            end
        end
    end
end

end

module SciMLStyleTests

using Test
using JuliaFormatter: format_text, SciMLStyle
using JuliaFormatter.Internal: test_format

@testset "SciML Style" begin
    # Test for mathematical expressions not breaking unnecessarily
    str = raw"""
    du[i, j, 1] = alpha * (u[im1, j, 1] + u[ip1, j, 1] + u[i, jp1, 1] + u[i, jm1, 1] - 4u[i, j, 1]) + B + u[i, j, 1]^2 * u[i, j, 2] - (A + 1) * u[i, j, 1] + brusselator_f(x, y)
    """
    # Should not break if within margin (92 chars)
    if length(str) <= 92
        @test format_text(str, SciMLStyle()) == str
    end

    # Test for function calls not breaking unnecessarily
    str = raw"""
    res = NLS.solve(nlls_prob, NLS.LevenbergMarquardt(); maxiters = 1000, show_trace = Val(true))
    """
    # Should remain on one line if it fits
    @test format_text(str, SciMLStyle()) == str

    # Test for anonymous function parameters not breaking
    str = raw"""
    f! = @closure (cfx, cx, user_ctx) -> begin
        # function body
    end
    """
    formatted_str = raw"""
    f! = @closure (cfx, cx, user_ctx) -> begin
        # function body
    end
    """
    @test format_text(str, SciMLStyle()) == formatted_str

    # Test for array indexing not breaking unnecessarily
    str = raw"""
    du[i, j, 1] = alpha * (u[im1, j, 1] + u[ip1, j, 1] + u[i, jp1, 1] + u[i, jm1, 1] - 4u[i, j, 1])
    """
    # Should not break du[i, j, 1] when close to margin
    formatted = format_text(str, SciMLStyle())
    @test !contains(formatted, "du[\n")
    @test startswith(strip(formatted), "du[i, j, 1]")
    str = raw"""
       @noinline require_complete(m::Matching) = m.inv_match === nothing && throw(ArgumentError("Backwards matching not defined. `complete` the matching first."))
    """
    formatted_str = raw"""
    @noinline require_complete(m::Matching) = m.inv_match === nothing &&
                                              throw(ArgumentError("Backwards matching not defined. `complete` the matching first."))
    """
    @test format_text(str, SciMLStyle()) == formatted_str

    str = raw"""
    begin include("hi") end
    """
    formatted_str = raw"""
    begin
        include("hi")
    end
    """
    @test format_text(str, SciMLStyle()) == formatted_str

    str = raw"""
    begin include("hi"); 1 end
    """
    formatted_str = raw"""
    begin
        include("hi")
        1
    end
    """
    @test format_text(str, SciMLStyle()) == formatted_str

    str = raw"""
    BipartiteGraph(fadj::AbstractVector, badj::Union{AbstractVector,Integer} = maximum(maximum, fadj); metadata = nothing) = BipartiteGraph(mapreduce(length, +, fadj; init = 0), fadj, badj, metadata)
    """
    formatted_str = raw"""
    function BipartiteGraph(fadj::AbstractVector,
            badj::Union{AbstractVector, Integer} = maximum(maximum, fadj); metadata = nothing)
        BipartiteGraph(mapreduce(length, +, fadj; init = 0), fadj, badj, metadata)
    end
    """
    @test format_text(str, SciMLStyle()) == formatted_str

    str = raw"""
    @parameters a=b b=c
    """
    formatted_str = raw"""
    @parameters a=b b=c
    """
    @test format_text(str, SciMLStyle()) == formatted_str

    str = raw"""
    @parameters a = b b = c
    """
    formatted_str = raw"""
    @parameters a=b b=c
    """
    @test format_text(str, SciMLStyle()) == formatted_str

    str = raw"""
    @parameters a=b
    """
    formatted_str = raw"""
    @parameters a=b
    """
    @test format_text(str, SciMLStyle()) == formatted_str

    str = raw"""
    @parameters a = b
    """
    formatted_str = raw"""
    @parameters a = b
    """
    @test format_text(str, SciMLStyle()) == formatted_str

    @testset "function argument indent" begin
        str = raw"""
        function my_large_function(argument1, argument2,
                                   argument3, argument4,
                                   argument5, x, y, z)
            foo(x) + goo(y)
        end
        """

        formatted_str = raw"""
        function my_large_function(argument1, argument2,
                argument3, argument4,
                argument5, x, y, z)
            foo(x) + goo(y)
        end
        """
        @test format_text(str, SciMLStyle()) == formatted_str

        formatted_str_yas_nesting = raw"""
        function my_large_function(argument1, argument2,
                                   argument3, argument4,
                                   argument5, x, y, z)
            foo(x) + goo(y)
        end
        """
        @test format_text(str, SciMLStyle(); yas_style_nesting = true) ==
              formatted_str_yas_nesting
    end

    @testset "indent on rhs of assignment" begin
        # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/935
        str = "xyz = T[a => 1,\n      b => 2]"
        yas_result = "xyz = T[a => 1,\n        b => 2]"
        sciml_result = "xyz = T[a => 1,\n    b => 2]"
        @test format_text(str, SciMLStyle(); yas_style_nesting = true) == yas_result
        @test format_text(str, SciMLStyle()) == sciml_result
    end

    @testset "postfix operator" begin
        # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/pull/1011
        str1 = "@view (Q_temp' * _vstar_perp)[1:nus]"
        @test format_text(str1, SciMLStyle()) == str1
        str2 = "(Q' * 2)[]"
        @test format_text(str2, SciMLStyle()) == str2
    end

    str = raw"""
    Dict{Int, Int}(1 => 2,
        3 => 4)
    """

    # This should be valid with and without `Dict` in `variable_call_indent`
    @test format_text(str, SciMLStyle()) == str
    @test format_text(str, SciMLStyle(); variable_call_indent = ["Dict"]) == str

    str = raw"""
    SVector(1.0,
        2.0)
    """

    # Test the same with different callers
    @test format_text(str, SciMLStyle(); variable_call_indent = ["Dict"]) == str
    @test format_text(str, SciMLStyle(); variable_call_indent = ["SVector", "test2"]) == str

    str = raw"""
    Dict{Int, Int}(
    1 => 2,
               3 => 4)
    """

    formatted_str1 = raw"""
    Dict{Int, Int}(
        1 => 2,
        3 => 4)
    """

    formatted_str2 = raw"""
    Dict{Int, Int}(
        1 => 2,
        3 => 4)
    """

    # `variable_call_indent` keeps the line break and doesn't align
    @test format_text(str, SciMLStyle()) == formatted_str1
    @test format_text(str, SciMLStyle(); variable_call_indent = ["Dict"]) == formatted_str2

    str = raw"""
    SVector(
    1.0,
               2.0)
    """

    formatted_str1 = raw"""
    SVector(
        1.0,
        2.0)
    """

    formatted_str2 = raw"""
    SVector(
        1.0,
        2.0)
    """

    # Test the same with different callers
    @test format_text(str, SciMLStyle(); variable_call_indent = ["Dict"]) == formatted_str1
    @test format_text(str, SciMLStyle(); variable_call_indent = ["test", "SVector"]) ==
          formatted_str2

    str = raw"""
    Dict{Int, Int}(
        1 => 2,
        3 => 4,
    )
    """

    # appears on a different line in source
    formatted_str = raw"""
    Dict{Int, Int}(
        1 => 2,
        3 => 4
    )
    """

    formatted_str_yas_nesting = raw"""
    Dict{Int, Int}(1 => 2,
                   3 => 4)
    """

    # This is already valid with `variable_call_indent`
    @test format_text(str, SciMLStyle()) == formatted_str
    @test format_text(str, SciMLStyle(); yas_style_nesting = true) ==
          formatted_str_yas_nesting
    @test format_text(str, SciMLStyle(); variable_call_indent = ["Dict"]) == formatted_str

    str = raw"""
    SomeLongerTypeThanJustString = String
    y = Dict{Int, SomeLongerTypeThanJustString}(1 => "some arbitrary string bla bla bla bla bla bla",
        2 => "another longer arbitrary string bla bla bla bla bla bla bla bla")
    """

    # over margin will nest
    formatted_str1 = raw"""
    SomeLongerTypeThanJustString = String
    y = Dict{Int, SomeLongerTypeThanJustString}(
        1 => "some arbitrary string bla bla bla bla bla bla",
        2 => "another longer arbitrary string bla bla bla bla bla bla bla bla")
    """

    formatted_str2 = raw"""
    SomeLongerTypeThanJustString = String
    y = Dict{Int, SomeLongerTypeThanJustString}(
        1 => "some arbitrary string bla bla bla bla bla bla",
        2 => "another longer arbitrary string bla bla bla bla bla bla bla bla")
    """

    # Here, `variable_call_indent` forces the line break because the line is too long
    @test format_text(str, SciMLStyle()) == formatted_str1
    @test format_text(str, SciMLStyle(); variable_call_indent = ["Dict"]) == formatted_str2

    str = raw"""
    Dict{Int, Int}(
                   # Comment
                   1 => 2,
                   3 => 4)
    """

    formatted_str = raw"""
    Dict{Int, Int}(
        # Comment
        1 => 2,
        3 => 4)
    """

    # Test `variable_call_indent` with a comment in a separate line
    @test format_text(str, SciMLStyle()) == formatted_str
    @test format_text(str, SciMLStyle(); variable_call_indent = ["Dict"]) == formatted_str

    str = raw"""
    SVector(
            # Comment
            1.0,
            2.0)
    """

    formatted_str = raw"""
    SVector(
        # Comment
        1.0,
        2.0)
    """

    # Test the same with different callers
    @test format_text(str, SciMLStyle()) == formatted_str
    @test format_text(str, SciMLStyle(); variable_call_indent = ["SVector"]) ==
          formatted_str

    str = raw"""
    Dict{Int, Int}(# Comment
                   1 => 2,
                   3 => 4)
    """

    formatted_str1 = raw"""
    Dict{Int, Int}(# Comment
        1 => 2,
        3 => 4)
    """

    formatted_str2 = raw"""
    Dict{Int, Int}(# Comment
        1 => 2,
        3 => 4)
    """

    # Test `variable_call_indent` with an inline comment after the opening parenthesis
    # With `variable_call_indent = false`, the comment will be eaten,
    # see https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/609
    @test format_text(str, SciMLStyle()) == formatted_str1
    @test format_text(str, SciMLStyle(); variable_call_indent = ["Dict"]) == formatted_str2

    str = raw"""
    Dict{Int, Int}( # Comment
            # Comment
            1 => 2,
            # Another comment
            3 => 4)
    """

    formatted_str = raw"""
    Dict{Int, Int}( # Comment
        # Comment
        1 => 2,
        # Another comment
        3 => 4)
    """

    # Test `variable_call_indent` with both an inline comment after the opening parenthesis
    # and a comment in a separate line.
    @test format_text(str, SciMLStyle()) == formatted_str
    @test format_text(str, SciMLStyle(); variable_call_indent = ["Dict"]) == formatted_str

    str = raw"""
    SVector( # Comment
                # Comment
                1.0,
                # Another comment
                2.0)
    """

    formatted_str = raw"""
    SVector( # Comment
        # Comment
        1.0,
        # Another comment
        2.0)
    """

    # Test the same with different callers
    @test format_text(str, SciMLStyle(); variable_call_indent = ["test"]) == formatted_str
    @test format_text(str, SciMLStyle(); variable_call_indent = ["SVector", "test"]) ==
          formatted_str

    str = """
    function alg_cache(alg::FineRKN4, u, rate_prototype, ::Type{uEltypeNoUnits},
           ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
          dt, reltol, p, calck, ::Val{true}) where {uEltypeNoUnits,
        uBottomEltypeNoUnits,tTypeNoUnits}

        reduced_rate_prototype = rate_prototype.x[2]
        tab = FineRKN4ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
        k1 = zero(rate_prototype)
        k2 = zero(reduced_rate_prototype)
        k3 = zero(reduced_rate_prototype)
        k4 = zero(reduced_rate_prototype)
        k5 = zero(reduced_rate_prototype)
        k = zero(rate_prototype)
        utilde = zero(u)
        atmp = similar(u, uEltypeNoUnits)
        recursivefill!(atmp, false)
        tmp = zero(u)
        FineRKN4Cache(u, uprev, k1, k2, k3, k4, k5, k, utilde, tmp, atmp, tab)
    end"""

    formatted_str = """
    function alg_cache(alg::FineRKN4, u, rate_prototype, ::Type{uEltypeNoUnits},
            ::Type{uBottomEltypeNoUnits}, ::Type{tTypeNoUnits}, uprev, uprev2, f, t,
            dt, reltol, p, calck,
            ::Val{true}) where {uEltypeNoUnits,
            uBottomEltypeNoUnits, tTypeNoUnits}
        reduced_rate_prototype = rate_prototype.x[2]
        tab = FineRKN4ConstantCache(constvalue(uBottomEltypeNoUnits), constvalue(tTypeNoUnits))
        k1 = zero(rate_prototype)
        k2 = zero(reduced_rate_prototype)
        k3 = zero(reduced_rate_prototype)
        k4 = zero(reduced_rate_prototype)
        k5 = zero(reduced_rate_prototype)
        k = zero(rate_prototype)
        utilde = zero(u)
        atmp = similar(u, uEltypeNoUnits)
        recursivefill!(atmp, false)
        tmp = zero(u)
        FineRKN4Cache(u, uprev, k1, k2, k3, k4, k5, k, utilde, tmp, atmp, tab)
    end"""
    @test format_text(str, SciMLStyle()) == formatted_str

    str = """
    function SpatialMassActionJump(urates::A, srates::B, rs::S, ns::U, pmapper::V;
                                   scale_rates = true, useiszero = true,
                                   nocopy = false) where {A <: AVecOrNothing,
                                                          B <: AMatOrNothing, S, U, V}
        SpatialMassActionJump{A, B, S, U, V}(urates, srates, rs, ns, pmapper, scale_rates,
                                             useiszero, nocopy)
    end"""

    formatted_str = """
    function SpatialMassActionJump(urates::A, srates::B, rs::S, ns::U, pmapper::V;
            scale_rates = true, useiszero = true,
            nocopy = false) where {A <: AVecOrNothing,
            B <: AMatOrNothing, S, U, V}
        SpatialMassActionJump{A, B, S, U, V}(urates, srates, rs, ns, pmapper, scale_rates,
            useiszero, nocopy)
    end"""
    @test format_text(str, SciMLStyle()) == formatted_str

    str = """
    xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx::SomePrettyLongTypeName{Foo}
    """

    # disallow_single_arg_nesting is true by defaultin sciml formatting options, so we don't want the line break
    @test format_text(str, SciMLStyle()) == str
    # With `yas_style_nesting=true`, we don't want the line break, as it will look like this:
    # xxxxx::SomePrettyLongTypeName{
    #                               Foo
    #                              }
    @test format_text(str, SciMLStyle(); yas_style_nesting = true) == str

    # https://github.com/SciML/JumpProcesses.jl/pull/362#discussion_r1375432275
    str_ = """
    function (p::CoevolveJumpAggregation{
        T,
        S,
        F1,
        F2,
    })(integrator::AbstractSSAIntegrator) where {T, S, F1, F2 <: Union{Tuple, Nothing}}
        body
    end"""
    str = """
    function (p::CoevolveJumpAggregation{
            T,
            S,
            F1,
            F2
    })(integrator::AbstractSSAIntegrator) where {
            T,
            S,
            F1,
            F2 <:
            Union{
                Tuple,
                Nothing}}
        body
    end"""
    @test format_text(str_, SciMLStyle(); margin = 1) == str

    str_ = """
    macro (p::CoevolveJumpAggregation{
        T,
        S,
        F1,
        F2,
    })(integrator::AbstractSSAIntegrator) where {T, S, F1, F2 <: Union{Tuple, Nothing}}
        body
    end"""
    str = """
    macro (p::CoevolveJumpAggregation{
            T,
            S,
            F1,
            F2
    })(integrator::AbstractSSAIntegrator) where {
            T,
            S,
            F1,
            F2 <:
            Union{
                Tuple,
                Nothing}}
        body
    end"""
    @test format_text(str_, SciMLStyle(); margin = 1) == str

    @testset "optimal nesting" begin
        @testset "function definition" begin
            str = """
            function foo(arg1, arg2, arg3, arg4, arg5)
                body
            end
            """

            fstr = """
            function foo(
                    arg1, arg2, arg3, arg4, arg5)
                body
            end
            """
            @test format_text(str, SciMLStyle(); margin = 41) == fstr
            @test format_text(str, SciMLStyle(); margin = 37) == fstr

            fstr = """
            function foo(arg1, arg2, arg3,
                    arg4, arg5)
                body
            end
            """
            @test format_text(str, SciMLStyle(); margin = 36) == fstr
            # should be 30? might be a unnesting off by 1 error
            @test format_text(str, SciMLStyle(); margin = 31) == fstr

            fstr = """
            function foo(
                    arg1, arg2, arg3,
                    arg4, arg5)
                body
            end
            """
            @test format_text(str, SciMLStyle(); margin = 29) == fstr
            @test format_text(str, SciMLStyle(); margin = 25) == fstr

            fstr = """
            function foo(
                    arg1, arg2,
                    arg3,
                    arg4, arg5)
                body
            end
            """
            @test format_text(str, SciMLStyle(); margin = 24) == fstr

            fstr = """
            function foo(
                    arg1,
                    arg2,
                    arg3,
                    arg4,
                    arg5)
                body
            end
            """
            @test format_text(str, SciMLStyle(); margin = 18) == fstr
        end

        @testset "vector definition" begin
            str = """
            test = [arg1, arg2, arg3, arg4, arg5]
            """

            # Fits within the margin
            @test format_text(str, SciMLStyle(); margin = 41) == str
            @test format_text(str, SciMLStyle(); margin = 37) == str

            fstr = """
            test = [
                arg1, arg2, arg3, arg4, arg5]
            """
            @test format_text(str, SciMLStyle(); margin = 36) == fstr
            @test format_text(str, SciMLStyle(); margin = 33) == fstr

            fstr = """
            test = [arg1, arg2, arg3,
                arg4, arg5]
            """
            @test format_text(str, SciMLStyle(); margin = 32) == fstr
            # should be 25? might be a unnesting off by 1 error
            @test format_text(str, SciMLStyle(); margin = 26) == fstr

            fstr = """
            test = [
                arg1, arg2, arg3,
                arg4, arg5]
            """
            @test format_text(str, SciMLStyle(); margin = 25) == fstr
            @test format_text(str, SciMLStyle(); margin = 21) == fstr

            fstr = """
            test = [arg1, arg2,
                arg3,
                arg4, arg5]
            """
            @test format_text(str, SciMLStyle(); margin = 20) == fstr
            # should be 19? might be a unnesting off by 1 error
            # @test format_text(str, SciMLStyle(), margin = 19) == fstr

            fstr = """
            test = [
                arg1, arg2,
                arg3,
                arg4, arg5]
            """
            @test format_text(str, SciMLStyle(); margin = 19) == fstr
            # should be 15? might be a unnesting off by 1 error
            @test format_text(str, SciMLStyle(); margin = 16) == fstr

            fstr = """
            test = [
                arg1, arg2,
                arg3,
                arg4,
                arg5]
            """
            @test format_text(str, SciMLStyle(); margin = 15) == fstr

            fstr = """
            test = [arg1,
                arg2,
                arg3,
                arg4,
                arg5]
            """
            @test format_text(str, SciMLStyle(); margin = 14) == fstr

            fstr = """
            test = [
                arg1,
                arg2,
                arg3,
                arg4,
                arg5]
            """
            @test format_text(str, SciMLStyle(); margin = 13) == fstr
        end

        @testset "for tuple binding regression" begin
            # see: https://github.com/JuliaEditorSupport/JuliaFormatter.jl/pull/998
            str = """
            function copy_values!(destination::ThreadedArray, source::AbstractArray)
                @threaded destination.scheduler for (dest_id, src_id) in zip(eachindex(destination),
                                                            eachindex(source))
                    @inbounds destination[dest_id] = source[src_id]
                end
            end
            """

            fstr = """
            function copy_values!(destination::ThreadedArray, source::AbstractArray)
                @threaded destination.scheduler for (dest_id, src_id) in zip(eachindex(destination),
                                                                             eachindex(source))
                    @inbounds destination[dest_id] = source[src_id]
                end
            end
            """
            @test format_text(str, SciMLStyle(); yas_style_nesting = true) == fstr

            str = """
            @threaded destination.scheduler for (dest_id, src_id, aaaa, bbbb, ccccc, dddd) in zip(eachindex(destination),
                      eachindex(source))
                @inbounds destination[dest_id] = source[src_id]
            end
            """

            fstr = """
            @threaded destination.scheduler for (dest_id, src_id, aaaa, bbbb, ccccc, dddd) in zip(eachindex(destination),
                                                                                                  eachindex(source))
                @inbounds destination[dest_id] = source[src_id]
            end
            """
            @test format_text(str, SciMLStyle(); yas_style_nesting = true, margin = 92) == fstr

            fstr = """
            @threaded destination.scheduler for (dest_id, src_id, aaaa, bbbb, ccccc,
                                                 dddd) in zip(eachindex(destination),
                                                              eachindex(source))
                @inbounds destination[dest_id] = source[src_id]
            end
            """
            @test format_text(
                str,
                SciMLStyle();
                yas_style_nesting = true,
                margin = 92,
                sciml_margin_overrun = 0,
            ) == fstr

            # todo:
            # fstr = """
            # @threaded destination.scheduler for (dest_id, src_id, aaaa, bbbb, ccccc, dddd) in zip(
            #                                      eachindex(destination),
            #                                      eachindex(source))
            #     @inbounds destination[dest_id] = source[src_id]
            # end
            # """

            fstr = """
            @threaded destination.scheduler for (dest_id, src_id, aaaa, bbbb, ccccc, dddd) in zip(
                eachindex(destination),
                eachindex(source))
                @inbounds destination[dest_id] = source[src_id]
            end
            """
            @test format_text(str, SciMLStyle(); margin = 92) == fstr
            @test format_text(str, SciMLStyle(); margin = 92, sciml_margin_overrun = 0) ==
                  fstr

            str = """
            @threaded destination.scheduler for i in zip(eachindex(destination),
                      eachindex(source))
                body
            end
            """

            fstr = """
            @threaded destination.scheduler for i in zip(eachindex(destination),
                eachindex(source))
                body
            end
            """
            @test format_text(str, SciMLStyle(); margin = 92) == fstr

            str = """
            @threaded destination.scheduler for (dest_id, src_id, aaaa, bbbb, ccccc, dddd) ∈ zip(eachindex(destination),
                      eachindex(source))
                @inbounds destination[dest_id] = source[src_id]
            end
            """

            fstr = """
            @threaded destination.scheduler for (dest_id, src_id, aaaa, bbbb, ccccc, dddd) ∈ zip(eachindex(destination),
                                                                                                 eachindex(source))
                @inbounds destination[dest_id] = source[src_id]
            end
            """
            @test format_text(
                str,
                SciMLStyle();
                yas_style_nesting = true,
                margin = 92,
                always_for_in = false,
            ) == fstr

            fstr = """
            @threaded destination.scheduler for (dest_id, src_id, aaaa, bbbb, ccccc,
                                                 dddd) ∈ zip(eachindex(destination),
                                                             eachindex(source))
                @inbounds destination[dest_id] = source[src_id]
            end
            """
            @test format_text(
                str,
                SciMLStyle();
                yas_style_nesting = true,
                margin = 92,
                always_for_in = false,
                sciml_margin_overrun = 0,
            ) == fstr
        end
    end

    @testset "additional nesting coverage" begin
        str = """
        path_lookup = [
            "Hash table implementation notes" => joinpath("src",
                                                          "hash_table.md"),
        ]
        """

        fstr = """
        path_lookup = [
            "Hash table implementation notes" => joinpath("src",
                                                          "hash_table.md"),
        ]
        """
        @test format_text(str, SciMLStyle(); yas_style_nesting = true) == fstr

        str = """
        function collect_close_items(points, min_distance)
            foreach_neighbor(points, points, index;
                             backend=SerialBackend()) do item, neighbor,
                                                         _, _
                if item != neighbor
                    push!(result, item)
                end
            end
        end
        """

        fstr = """
        function collect_close_items(points, min_distance)
            foreach_neighbor(points, points, index;
                             backend=SerialBackend()) do item, neighbor,
                                                         _, _
                if item != neighbor
                    push!(result, item)
                end
            end
        end
        """
        @test format_text(
            str,
            SciMLStyle();
            yas_style_nesting = true,
            whitespace_in_kwargs = false,
        ) == fstr

        str = "Dict(\"a\" => (x = 1,), \"longer key\" => (y = 2,))"
        @test format_text(str, SciMLStyle()) == str

        str = """
        metadata = Pair{String, Any}["Start vertex" => first(graph.vertices),
        "Final vertex" => last(graph.vertices),
        "search algorithm" => traversal.algorithm |> typeof |> nameof,
        "directed" => graph.is_directed]
        """ |> strip
        sciml = """
        metadata = Pair{String, Any}["Start vertex" => first(graph.vertices),
            "Final vertex" => last(graph.vertices),
            "search algorithm" => traversal.algorithm |> typeof |> nameof,
            "directed" => graph.is_directed]
        """ |> strip
        test_format(str, sciml, SciMLStyle())
        with_yas = """
        metadata = Pair{String, Any}["Start vertex" => first(graph.vertices),
                                     "Final vertex" => last(graph.vertices),
                                     "search algorithm" => traversal.algorithm |> typeof |> nameof,
                                     "directed" => graph.is_directed]
        """ |> strip
        test_format(str, with_yas, SciMLStyle(); yas_style_nesting = true)
    end

    str = raw"""
    x = [
        1, 2, 3
    ]
    """

    # This should be valid with and without `yas_style_nesting`
    @test format_text(str, SciMLStyle()) == str
    @test format_text(str, SciMLStyle(); yas_style_nesting = true) == str

    # Test for comprehensive line break fixes
    # https://github.com/SciML/DiffEqGPU.jl/pull/356/files

    # Test 1: Array indexing should not be broken across lines
    str = """
    du[II[i, j, 1]] = α * (u[II[im1, j, 1]] + u[II[ip1, j, 1]] + u[II[i, jp1, 1]] + u[II[i, jm1, 1]])
    """
    formatted = format_text(str, SciMLStyle())
    # The key fix: array indices should not be broken between parameters
    @test !contains(formatted, "II[i,\n")  # Should not break between i and j
    @test !contains(formatted, "II[i, j,\n")  # Should not break between j and 1

    # Test 2: @unpack macro calls should not be broken unnecessarily
    str = "@unpack γ, a31, a32, a41, a42, a43, btilde1, btilde2, btilde3, btilde4, c3 = integ.tab"
    formatted = format_text(str, SciMLStyle())
    # Should not break the unpack statement awkwardly
    lines = split(formatted, "\n")
    @test length(lines) <= 2  # Should fit on 1-2 lines max

    # Test 3: Function calls should not be broken awkwardly
    str = "beta1, beta2, qmax, qmin, gamma = build_adaptive_controller_cache(integ.alg, T)"
    formatted = format_text(str, SciMLStyle())
    lines = split(formatted, "\n")
    @test length(lines) <= 2  # Should not create excessive line breaks

    # Test 4: Type parameters should not be broken unnecessarily
    str = "Vector{Float64, Int32, String}"
    formatted = format_text(str, SciMLStyle())
    @test !contains(formatted, "{\n")  # Should not break type parameters

    # Test 5: Short vector literals should not be broken
    str = "[a, b, c, d]"
    formatted = format_text(str, SciMLStyle())
    @test formatted == str  # Should remain on one line

    @testset "SciML Repository Regression Tests" begin
        # These tests are based on real formatting issues found in SciML repositories
        # that were broken by JuliaFormatter v2 changes

        @testset "DiffEqGPU.jl regressions" begin
            # Test case from: https://github.com/SciML/DiffEqGPU.jl/pull/356/files
            # Array indexing in mathematical expressions should not be broken
            str = """
            du[II[i, j, 1]] = α * (u[II[im1, j, 1]] + u[II[ip1, j, 1]] + u[II[i, jp1, 1]] +
                                   u[II[i, jm1, 1]] - 4u[II[i, j, 1]]) +
                                  B + u[II[i, j, 1]]^2 * u[II[i, j, 2]] - (A + 1) * u[II[i, j, 1]] +
                                  brusselator_f(x, y, t)
            """
            formatted = format_text(str, SciMLStyle())
            # Array indices should not be broken between parameters
            @test !contains(formatted, "II[i,\n")
            @test !contains(formatted, "II[i, j,\n")
            @test !contains(formatted, "II[im1,\n")
            @test !contains(formatted, "II[ip1,\n")

            # Second array indexing case from the same PR
            str = """
            du[II[i, j, 2]] = α * (u[II[im1, j, 2]] + u[II[ip1, j, 2]] + u[II[i, jp1, 2]] +
                                   u[II[i, jm1, 2]] - 4u[II[i, j, 2]]) +
                                  A * u[II[i, j, 1]] - u[II[i, j, 1]]^2 * u[II[i, j, 2]]
            """
            formatted = format_text(str, SciMLStyle())
            @test !contains(formatted, "II[i,\n")
            @test !contains(formatted, "II[i, j,\n")

            # @unpack macro should not break awkwardly
            str = "@unpack γ, a31, a32, a41, a42, a43, btilde1, btilde2, btilde3, btilde4, c3, α31, α32 = integ.tab"
            formatted = format_text(str, SciMLStyle())
            lines = split(formatted, "\n")
            @test length(lines) <= 2  # Should not break across many lines
            # Accept the current behavior - the key improvement is limiting to 2 lines max
            # The original problem was much worse breaking across many lines

            # Function assignment should not break awkwardly
            str = "beta1, beta2, qmax, qmin, gamma, qoldinit, _ = build_adaptive_controller_cache(integ.alg, T)"
            formatted = format_text(str, SciMLStyle())
            lines = split(formatted, "\n")
            @test length(lines) <= 2
            # The underscore should not be on its own line
            @test !contains(formatted, "qoldinit,\n_ =")
        end

        @testset "General SciML formatting patterns" begin
            # Common patterns that should not be broken excessively

            # Mathematical expressions with multiple array accesses
            str = "result = A[i, j] + B[i, k] * C[k, j] - D[i, j]"
            formatted = format_text(str, SciMLStyle())
            @test !contains(formatted, "[i,\n")
            @test !contains(formatted, "[i, j,\n")
            @test !contains(formatted, "[i, k,\n")
            @test !contains(formatted, "[k, j,\n")

            # Function calls with multiple parameters should be conservative
            str = "solve(prob, alg, abstol=1e-6, reltol=1e-3, callback=cb)"
            formatted = format_text(str, SciMLStyle())
            # Should not break every single parameter
            lines = split(formatted, "\n")
            @test length(lines) <= 3  # Allow some breaking but not excessive

            # Type annotations should not break unnecessarily
            str = "function foo(x::AbstractVector{T}, y::AbstractMatrix{T}) where T<:Real end"
            formatted = format_text(str, SciMLStyle())
            @test !contains(formatted, "AbstractVector{\nT")
            @test !contains(formatted, "AbstractMatrix{\nT")

            # Macro calls with assignments should be protected
            str = "@inbounds @simd for i in 1:n; end"
            formatted = format_text(str, SciMLStyle())
            # Allow reasonable formatting - the key is not excessive breaking
            @test length(split(formatted, "\n")) <= 4  # Allow reasonable flexibility

            # Complex expressions should prioritize readability
            str = "u_new[idx] = u_old[idx] + dt * (k1[idx] + 2*k2[idx] + 2*k3[idx] + k4[idx]) / 6"
            formatted = format_text(str, SciMLStyle())
            @test !contains(formatted, "[idx,\n")
            @test !contains(formatted, "k1[idx,\n")
            @test !contains(formatted, "k2[idx,\n")
            @test !contains(formatted, "k3[idx,\n")
            @test !contains(formatted, "k4[idx,\n")
        end

        @testset "Edge cases from issue #930" begin
            # These are patterns mentioned in the GitHub issue that should be handled well

            # Short parameter lists should not be broken
            str = "f(a, b, c, d)"
            formatted = format_text(str, SciMLStyle())
            @test formatted == str

            # Short array literals should not be broken
            str = "[1, 2, 3, 4, 5]"
            formatted = format_text(str, SciMLStyle())
            @test formatted == str

            # Short tuple should not be broken
            str = "(x, y, z, w)"
            formatted = format_text(str, SciMLStyle())
            @test formatted == str

            # Short type parameters should not be broken
            str = "Vector{Float64}"
            formatted = format_text(str, SciMLStyle())
            @test formatted == str

            str = "Dict{String, Int}"
            formatted = format_text(str, SciMLStyle())
            @test formatted == str
        end

        @testset "Additional SciML repository patterns" begin
            # Patterns found in various SciML repositories that were problematic

            # Long function calls should not break every argument (common pattern)
            str = "OrdinaryDiffEqCore._ode_addsteps!(k, t, uprev, u, dt, f, p, cache, always_calc_begin, true, true)"
            formatted = format_text(str, SciMLStyle())
            # Should not put every single argument on its own line
            lines = split(formatted, "\n")
            @test length(lines) <= 4  # Allow reasonable breaking but not excessive

            # Complex constructor calls should be handled reasonably
            str = "CellGenotype([Float64(1)], :aSymbiontGenotype)"
            formatted = format_text(str, SciMLStyle())
            # Should not break the array literal unnecessarily
            @test !contains(formatted, "[Float64(\n")
            @test !contains(formatted, "Float64(1\n")

            # Nested function calls should prioritize readability
            str = "construct(Plant, (deepcopy(organ1), deepcopy(organ2)), Float64[], PlantSettings(1))"
            formatted = format_text(str, SciMLStyle())
            # Should not break simple arguments unnecessarily
            @test !contains(formatted, "deepcopy(\n")
            @test !contains(formatted, "Float64[\n")

            # Mathematical expressions with array indexing should stay readable
            str = "du[i] = α * u[i-1] + β * u[i] + γ * u[i+1]"
            formatted = format_text(str, SciMLStyle())
            @test !contains(formatted, "u[i-\n")
            @test !contains(formatted, "u[i+\n")
            @test !contains(formatted, "du[\n")

            # Complex type annotations should not break type parameters
            str = "function solve(prob::BVProblem{T,U,V}, alg::Algorithm) where {T,U,V} end"
            formatted = format_text(str, SciMLStyle())
            @test !contains(formatted, "BVProblem{\nT")
            @test !contains(formatted, "{T,\nU")

            # Closure definitions should be handled gracefully
            str = "@closure (t, u, du) -> du .= vec(prob.f(reshape(u, u0_size), prob.p, t))"
            formatted = format_text(str, SciMLStyle())
            # Should not break the simple parameter list
            @test !contains(formatted, "(t,\n")
            @test !contains(formatted, "u,\n")

            # Array slicing operations should not be broken
            str = "left_bc = reshape(@view(r[1:no_left_bc]), left_bc_size)"
            formatted = format_text(str, SciMLStyle())
            @test !contains(formatted, "r[1:\n")
            @test !contains(formatted, "@view(\n")

            # Multiple assignment patterns should be conservative
            str = "ya, yb, ya_size, yb_size = extract_parameters(prob)"
            formatted = format_text(str, SciMLStyle())
            lines = split(formatted, "\n")
            @test length(lines) <= 2  # Should not break excessively

            # Nested array access should stay together
            str = "cache.u[cache.stage_indices[i]][j]"
            formatted = format_text(str, SciMLStyle())
            @test !contains(formatted, "cache.u[\n")
            @test !contains(formatted, "stage_indices[\n")
            @test !contains(formatted, "][j\n")
        end
    end

    @testset "semantic safety" begin
        # Test 1: Whitespace-sensitive array literals
        # Space means horizontal concatenation, ; or newline means vertical
        str = "[1 2 3]"  # 1×3 matrix
        @test format_text(str, SciMLStyle()) == str

        str = "[1; 2; 3]"  # 3×1 matrix
        @test format_text(str, SciMLStyle()) == str

        str = "[1 2; 3 4]"  # 2×2 matrix
        @test format_text(str, SciMLStyle()) == str

        # Test that we don't accidentally change array dimensions
        str = """
        A = [1 2 3
             4 5 6]
        """
        formatted = format_text(str, SciMLStyle())
        @test contains(formatted, "1 2 3") # Ensure spaces preserved
        @test !contains(formatted, "1; 2; 3") # Ensure no semicolons added

        # Test 2: Operator precedence preservation
        precedence_tests = [
            ("x = a + b * c", "x = a + b * c"),
            ("x = a * b + c", "x = a * b + c"),
            ("x = a^b^c", "x = a^b^c"),  # Right associative
            ("x = a / b * c", "x = a / b * c"),  # Left associative
            ("x = -a^2", "x = -a^2"),  # Unary minus precedence
        ]

        for (input, expected) in precedence_tests
            @test format_text(input, SciMLStyle()) == expected
        end

        # Test 3: Coefficient syntax preservation
        # In Julia, 2x means 2*x, but 2 x is an error
        str = "y = 2x + 3y - 4z"
        @test format_text(str, SciMLStyle()) == str

        str = "y = 2(x + y)"  # Coefficient with parentheses
        @test format_text(str, SciMLStyle()) == str

        # Test 4: Macro scope preservation
        str = "@. x = y + z"
        formatted = format_text(str, SciMLStyle())
        @test formatted == str
        @test contains(formatted, "@.")

        str = "@views x[1:n] = y[1:n]"
        formatted = format_text(str, SciMLStyle())
        @test contains(formatted, "@views")
        @test !contains(formatted, "@views\n")  # Macro not separated from expression

        # Test 5: String and character literals (must not break)
        str = "msg = \"This is a long string that should not be broken\""
        @test format_text(str, SciMLStyle()) == str

        str = "c = 'a'"
        @test format_text(str, SciMLStyle()) == str

        # Test 6: Ternary operator associativity
        str = "x = a ? b : c ? d : e"  # Right associative
        formatted = format_text(str, SciMLStyle())
        # Ensure it doesn't become (a ? b : c) ? d : e
        @test Meta.parse(str) == Meta.parse(formatted)

        # Test 7: Short-circuit evaluation order
        str = "a && b || c && d"
        formatted = format_text(str, SciMLStyle())
        @test Meta.parse(str) == Meta.parse(formatted)

        # Test 8: Anonymous function syntax
        str = "f = x -> x^2"
        @test format_text(str, SciMLStyle()) == str

        str = "g = (x, y) -> x + y"
        @test format_text(str, SciMLStyle()) == str

        # Test 9: Array comprehension preservation
        str = "[i * j for i in 1:3, j in 1:3]"
        formatted = format_text(str, SciMLStyle())
        @test contains(formatted, "for i in 1:3, j in 1:3")

        # Test 10: Broadcasting syntax
        str = "x .= y .+ z .* w"
        @test format_text(str, SciMLStyle()) == str

        str = "sin.(x) .+ cos.(y)"
        @test format_text(str, SciMLStyle()) == str

        # Test 11: Type parameter syntax
        str = "Vector{Float64}"
        @test format_text(str, SciMLStyle()) == str

        str = "Dict{String,Int}"
        formatted = format_text(str, SciMLStyle())
        @test formatted == str || formatted == "Dict{String, Int}"  # Space after comma is ok

        # Test 12: Splatting and slurping
        str = "f(x...)"
        @test format_text(str, SciMLStyle()) == str

        str = "g(a, b..., c)"
        @test format_text(str, SciMLStyle()) == str

        # Test 13: Range syntax preservation
        str = "1:10"
        @test format_text(str, SciMLStyle()) == str

        str = "1:2:10"
        @test format_text(str, SciMLStyle()) == str

        # Test 14: Rational number syntax
        str = "1//2"
        @test format_text(str, SciMLStyle()) == str

        # Test 15: Complex number syntax
        str = "1 + 2im"
        @test format_text(str, SciMLStyle()) == str

        # Test 16: Symbol syntax
        str = ":symbol"
        @test format_text(str, SciMLStyle()) == str

        str = ":(a + b)"
        @test format_text(str, SciMLStyle()) == str

        # Test 17: Interpolation in strings
        str = "\"x = \$x, y = \$(y + 1)\""
        @test format_text(str, SciMLStyle()) == str

        # Test 18: Command literals
        str = "`echo hello`"
        @test format_text(str, SciMLStyle()) == str

        # Test 19: Version number literals
        str = "v\"1.2.3\""
        @test format_text(str, SciMLStyle()) == str

        # Test 20: Regex literals
        str = "r\"[a-z]+\""
        @test format_text(str, SciMLStyle()) == str

        # Test 21: Critical array literal semantic preservation
        # These MUST not change dimensions

        # Horizontal concatenation (space)
        str = "[1 2 3]"
        formatted = format_text(str, SciMLStyle())
        @test formatted == "[1 2 3]"  # Must preserve spaces

        # Vertical concatenation (semicolon)
        str = "[1; 2; 3]"
        formatted = format_text(str, SciMLStyle())
        @test formatted == "[1; 2; 3]"  # Must preserve semicolons

        # Mixed (creates matrix)
        str = "[1 2; 3 4]"
        formatted = format_text(str, SciMLStyle())
        @test formatted == "[1 2; 3 4]"  # Must preserve exact structure

        # Test 21b: More array literal edge cases
        # Mixed spaces and semicolons
        str = "[1 2; 3 4; 5 6]"  # 3×2 matrix
        @test format_text(str, SciMLStyle()) == str

        # Nested arrays
        str = "[[1, 2], [3, 4]]"
        @test format_text(str, SciMLStyle()) == str

        # Array with trailing comma (1-element array vs scalar)
        str = "[1,]"  # 1-element array
        formatted = format_text(str, SciMLStyle())
        @test formatted == "[1]" || formatted == "[1,]"  # Both are valid

        # Empty arrays with type
        str = "Float64[]"
        @test format_text(str, SciMLStyle()) == str

        str = "Vector{Int}()"
        @test format_text(str, SciMLStyle()) == str

        # Test 22: Tuple vs array distinction
        str = "(1, 2, 3)"  # Tuple
        @test format_text(str, SciMLStyle()) == str

        str = "(1,)"  # 1-element tuple (comma required)
        @test format_text(str, SciMLStyle()) == str

        # Test 23: Generator expressions
        str = "(x^2 for x in 1:10)"
        formatted = format_text(str, SciMLStyle())
        @test contains(formatted, "for x in 1:10")

        # Test 24: Multi-line array construction preservation
        str = """
        A = [
            1 2 3
            4 5 6
            7 8 9
        ]
        """
        formatted = format_text(str, SciMLStyle())
        # Should preserve the matrix structure
        @test contains(formatted, "1 2 3")
        @test contains(formatted, "4 5 6")
        @test contains(formatted, "7 8 9")

        # Test 25: Coefficient with array indexing
        str = "y = 2A[i, j]"  # 2*A[i,j], not 2 A[i,j]
        @test format_text(str, SciMLStyle()) == str

        # Test 26: Multiple dispatch syntax
        str = "f(::Type{T}) where T = T"
        formatted = format_text(str, SciMLStyle())
        @test contains(formatted, "where") &&
              contains(formatted, "T") &&
              contains(formatted, "Type{T}")

        # Test 27: Subtype syntax
        str = "T <: Number"
        @test format_text(str, SciMLStyle()) == str

        # Test 28: Union types
        str = "Union{Int, Float64}"
        @test format_text(str, SciMLStyle()) == str

        # Test 29: Parametric types with constraints
        str = "struct Foo{T<:Real} end"
        formatted = format_text(str, SciMLStyle())
        @test contains(formatted, "T<:Real") || contains(formatted, "T <: Real")

        # Test 30: Named tuples
        str = "(a=1, b=2)"
        formatted = format_text(str, SciMLStyle())
        # Named tuples might get spaces around =
        @test formatted == str || formatted == "(a = 1, b = 2)"

        # Test 31: Keyword arguments
        str = "f(x; y=1, z=2)"
        formatted = format_text(str, SciMLStyle())
        @test contains(formatted, "; y")  # Semicolon preserved

        # Test 32: Do block syntax
        str = """
        map(1:3) do x
            x^2
        end
        """
        formatted = format_text(str, SciMLStyle())
        @test contains(formatted, "do x")

        # Test 33: Let block with multiple bindings
        str = "let x = 1, y = 2; x + y end"
        formatted = format_text(str, SciMLStyle())
        # Check semantic equivalence by comparing string representation without line numbers
        str_ast = replace(string(Meta.parse(str)), r"#= \S+:\d+ =#" => "")
        form_ast = replace(string(Meta.parse(formatted)), r"#= \S+:\d+ =#" => "")
        @test str_ast == form_ast

        # Test 34: Destructuring
        str = "a, b, c = 1, 2, 3"
        @test format_text(str, SciMLStyle()) == str

        # Test 35: Unicode operators
        str = "x ∈ A ∩ B"
        @test format_text(str, SciMLStyle()) == str

        # Test 36: Pipe operator
        str = "x |> f |> g"
        @test format_text(str, SciMLStyle()) == str

        # Test 37: Pairs syntax
        str = "a => b"
        @test format_text(str, SciMLStyle()) == str

        # Test 38: Quote expressions
        str = ":(x + y)"
        @test format_text(str, SciMLStyle()) == str

        # Test 39: Escaped identifiers
        str = "var\"strange name\""
        @test format_text(str, SciMLStyle()) == str

        # Test 40: Line number nodes (should be preserved in macros)
        str = """
        macro foo()
            quote
                x = 1
                y = 2
            end
        end
        """
        formatted = format_text(str, SciMLStyle())
        @test contains(formatted, "quote")
    end

    @testset "line break quality" begin
        # Helper function to analyze line utilization
        function analyze_line_quality(formatted_code)
            lines = split(formatted_code, '\n')
            non_empty_lines = filter(l -> !isempty(strip(l)), lines)

            if isempty(non_empty_lines)
                return (max_length = 0, avg_length = 0.0, num_lines = 0, efficiency = 0.0)
            end

            lengths = [length(rstrip(line)) for line in non_empty_lines]
            max_length = maximum(lengths)
            avg_length = sum(lengths) / length(lengths)

            # Efficiency: how well lines use available space (0-1)
            # Penalize both very short lines and lines over margin
            efficiency_scores = map(lengths) do len
                if len > 92
                    0.5 * (92 / len)  # Penalty for exceeding margin
                elseif len < 20
                    len / 40  # Penalty for very short lines
                else
                    len / 92  # Normal efficiency
                end
            end
            efficiency = sum(efficiency_scores) / length(efficiency_scores)

            return (
                max_length = max_length,
                avg_length = avg_length,
                num_lines = length(non_empty_lines),
                efficiency = efficiency,
            )
        end

        # Test 1: Simple expressions should stay on one line when they fit
        @testset "single line preservation" begin
            # These should remain on one line
            single_line_cases = [
                "x = a + b * c - d",
                "result = solve(prob, alg)",
                "arr[i, j] = value * scale",
                "y = sin(x) + cos(z) * exp(-t)",
                "data = [1, 2, 3, 4, 5]",
            ]

            for code in single_line_cases
                formatted = format_text(code, SciMLStyle())
                @test !contains(formatted, '\n')
                @test formatted == code
            end
        end

        # Test 2: Long lines should break efficiently
        @testset "efficient line breaking" begin
            # Function call with many parameters
            str = """
            result = solve(NonlinearProblem(f, u0, p), NewtonRaphson(; autodiff=AutoForwardDiff()), abstol=1e-10, reltol=1e-10, maxiters=1000, show_trace=true)
            """
            formatted = format_text(str, SciMLStyle())
            quality = analyze_line_quality(formatted)

            @test quality.max_length <= 92  # Should respect margin
            @test quality.avg_length > 50   # Should use space efficiently
            @test quality.efficiency > 0.6   # Good space utilization

            # Mathematical expression
            str = """
            residual = alpha * (u[i-1, j] + u[i+1, j] - 2u[i, j]) / dx^2 + beta * (u[i, j-1] + u[i, j+1] - 2u[i, j]) / dy^2 + gamma * u[i, j]
            """
            formatted = format_text(str, SciMLStyle())
            quality = analyze_line_quality(formatted)

            # Should break but maintain good line density
            @test quality.num_lines >= 2
            @test quality.avg_length > 40  # Not too many short lines
        end

        # Test 3: Type parameters should wrap nicely
        @testset "type parameter wrapping" begin
            str = """
            function f(x::AbstractArray{T,N}, y::AbstractMatrix{S}) where {T<:Real, S<:Number, N}
                return x
            end
            """
            formatted = format_text(str, SciMLStyle())
            quality = analyze_line_quality(formatted)

            # Should fit on 3 lines max
            @test quality.num_lines <= 3
            @test quality.max_length <= 92

            # Long type parameter list
            str = """
            struct MyType{T1,T2,T3,T4,T5,T6,T7,T8,T9,T10} <: AbstractType{T1,T2,T3,T4,T5,T6,T7,T8,T9,T10}
            end
            """
            formatted = format_text(str, SciMLStyle())
            lines = split(formatted, '\n')

            # Should break but not excessively
            @test length(lines) <= 4
            # No single parameter on a line
            for line in lines
                if contains(line, "T") && !contains(line, "end")
                    @test contains(line, ",") || contains(line, "{") || contains(line, "}")
                end
            end
        end

        # Test 4: Array operations should maintain structure
        @testset "array operation formatting" begin
            # Array comprehension
            str = "[f(i, j) * g(k) for i in 1:n, j in 1:m, k in 1:p if condition(i, j, k)]"
            formatted = format_text(str, SciMLStyle())

            # Should keep comprehension readable
            @test contains(formatted, "for i in 1:n, j in 1:m")
            quality = analyze_line_quality(formatted)
            @test quality.efficiency > 0.5

            # Matrix literal
            str = """
            A = [
                a11 a12 a13 a14
                a21 a22 a23 a24
                a31 a32 a33 a34
            ]
            """
            formatted = format_text(str, SciMLStyle())
            # Should preserve matrix structure
            @test contains(formatted, "a11 a12 a13 a14")
            @test contains(formatted, "a21 a22 a23 a24")
        end

        # Test 5: Function definitions with multiple arguments
        @testset "function definition formatting" begin
            # Moderate length - should stay on 2-3 lines
            str = """
            function solve(prob::ODEProblem, alg::Tsit5; abstol=1e-6, reltol=1e-3, saveat=[], callback=nothing)
                # body
            end
            """
            formatted = format_text(str, SciMLStyle())
            quality = analyze_line_quality(formatted)

            @test quality.num_lines <= 4  # Reasonable number of lines
            @test quality.avg_length > 30  # Reasonable line utilization

            # Very long parameter list
            str = """
            function complex_solver(problem::NonlinearProblem{uType,tType,isinplace}, algorithm::NewtonRaphson{CS,AD,FDT,L,P,ST,CJ}, x0::AbstractVector, p::NamedTuple; abstol::Float64=1e-8, reltol::Float64=1e-8, maxiters::Int=1000, callback=nothing, show_trace::Bool=false) where {uType,tType,isinplace,CS,AD,FDT,L,P,ST,CJ}
                # body
            end
            """
            formatted = format_text(str, SciMLStyle())
            lines = split(formatted, '\n')

            # Should break intelligently
            @test all(length(rstrip(line)) <= 92 for line in lines)
            # But not too many lines
            @test length(lines) <= 12  # Complex function may need more lines
        end

        # Test 6: Nested expressions should maintain hierarchy
        @testset "nested expression formatting" begin
            str = """
            result = transform(integrate(differentiate(interpolate(data, method=:cubic), order=2), bounds=(a, b)), scaling=:log)
            """
            formatted = format_text(str, SciMLStyle())

            # Should break at outer function calls first
            @test contains(formatted, "transform(")
            quality = analyze_line_quality(formatted)
            @test quality.efficiency > 0.5

            # Nested array access
            str = "value = data[indices[i]][subindices[j]][k]"
            formatted = format_text(str, SciMLStyle())
            # Should keep array access together when reasonable
            @test !contains(formatted, "[\n")
        end

        # Test 7: Mathematical expressions should break at operators
        @testset "mathematical expression breaking" begin
            # Long equation
            str = """
            energy = 0.5 * mass * velocity^2 + mass * gravity * height + 0.5 * spring_constant * displacement^2 + friction_coefficient * mass * gravity * distance
            """
            formatted = format_text(str, SciMLStyle())
            lines = split(formatted, '\n')

            # Should break at + operators
            for line in lines[2:end]
                stripped = strip(line)
                if !isempty(stripped)
                    # Continuation lines should start with operator or be aligned
                    @test startswith(stripped, "+") ||
                          startswith(stripped, "-") ||
                          startswith(stripped, "*") ||
                          startswith(stripped, "/") ||
                          length(lstrip(line)) < length(line)  # Or be indented
                end
            end

            quality = analyze_line_quality(formatted)
            @test quality.avg_length > 40  # Efficient use of space
        end

        # Test 8: Avoid "orphan" parameters
        @testset "avoid orphan parameters" begin
            # Should not leave single parameters on lines
            str = "f(a, b, c, d, e, f, g, h, i, j, k, l, m, n, o, p, q, r, s, t, u, v, w, x, y, z)"
            formatted = format_text(str, SciMLStyle())
            lines = split(formatted, '\n')

            for line in lines
                stripped = strip(line)
                # If it's just a single letter and comma/paren, it's an orphan
                if match(r"^[a-z],?\)?$", stripped) !== nothing
                    @test false  # Should not have orphan parameters
                end
            end
        end

        # Test 9: Keyword arguments should group nicely
        @testset "keyword argument grouping" begin
            str = """
            solve(prob; abstol=1e-8, reltol=1e-8, dtmin=1e-10, dtmax=0.1, maxiters=10000, adaptive=true, save_everystep=false, save_start=true, save_end=true, verbose=true)
            """
            formatted = format_text(str, SciMLStyle())

            # Should group related kwargs when possible
            lines = split(formatted, '\n')
            # First line should have multiple kwargs if they fit
            if length(lines) > 1
                @test contains(lines[1], ",") || contains(lines[1], ";")
            end

            quality = analyze_line_quality(formatted)
            @test quality.efficiency > 0.6
        end

        # Test 10: Preserve logical grouping
        @testset "logical grouping preservation" begin
            # Coordinates should stay together
            str = "plot(x1, y1, x2, y2, x3, y3; xlabel=\"Time\", ylabel=\"Value\", title=\"Results\")"
            formatted = format_text(str, SciMLStyle())

            # x,y pairs should stay together when possible
            @test contains(formatted, "x1, y1") || contains(formatted, "x1,y1")

            # Matrix multiplication chain
            str = "result = A * B * C * D * E * F"
            formatted = format_text(str, SciMLStyle())
            # Should keep some products together
            @test length(split(formatted, '\n')) <= 3
        end

        # Test 11: Real-world examples from SciML
        @testset "SciML real-world examples" begin
            # From OrdinaryDiffEq
            str = """
            @muladd function perform_step!(integrator, cache::RK4Cache, repeat_step=false)
                @unpack t, dt, uprev, u, f, p = integrator
                @unpack k1, k2, k3, k4, tmp = cache
                f(k1, uprev, p, t)
                f(k2, uprev + dt/2 * k1, p, t + dt/2)
                f(k3, uprev + dt/2 * k2, p, t + dt/2)
                f(k4, uprev + dt * k3, p, t + dt)
                @. u = uprev + dt/6 * (k1 + 2*k2 + 2*k3 + k4)
            end
            """
            formatted = format_text(str, SciMLStyle())
            quality = analyze_line_quality(formatted)

            # Should maintain readability
            @test quality.max_length <= 92
            @test quality.avg_length > 30

            # From ModelingToolkit
            str = """
            @parameters t σ ρ β
            @variables x(t) y(t) z(t)
            D = Differential(t)
            eqs = [D(x) ~ σ * (y - x), D(y) ~ x * (ρ - z) - y, D(z) ~ x * y - β * z]
            """
            formatted = format_text(str, SciMLStyle())

            # Should keep equations readable
            @test contains(formatted, "D(x) ~ σ * (y - x)")
            lines = split(formatted, '\n')
            # Equations should be nicely formatted
            eq_lines = filter(l -> contains(l, "D("), lines)
            @test length(eq_lines) > 0
        end
    end
end

end

module MultidimensionalArrayTests

using JuliaFormatter
using JuliaFormatter.Internal: test_format, ALL_STYLES
using Test

@testset "array literal examples" begin
    # Don't really care how it formats, but make sure that it parses to the same AST. Some
    # of these are probably redundant; that's fine, we can just be safe.
    for T in ("", "T", "x = ")
        for s in (
            # These are taken from the docs:
            # https://docs.julialang.org/en/v1/manual/arrays/#man-array-literals
            "$(T)[1, 2, 3]",
            "$(T)[1, 2.3, 4//5]",
            "$(T)[1:2, 4:5]",
            "$(T)[1:2\n 4:5\n 6]",
            "$(T)[1:2  4:5  7:8]",
            "$(T)[[1,2]  [4,5]  [7,8]]",
            "$(T)[1 2 3]",
            "$(T)[1;; 2;; 3;; 4]",
            "$(T)[1 2\n 3 4]",
            "$(T)[zeros(Int, 2, 2) [1; 2]\n [3 4]            5]",
            "$(T)[[1 1]; 2 3; [4 4]]",
            "$(T)[zeros(Int, 2, 2) ; [3 4] ;; [1; 2] ; 5]",
            "$(T)[1:2; 4;; 1; 3:4]",
            "$(T)[1; 2;; 3; 4;; 5; 6;;;\n 7; 8;; 9; 10;; 11; 12]",
            "$(T)[1 3 5\n 2 4 6;;;\n 7 9 11\n 8 10 12]",
            "$(T)[1 2;;; 3 4;;;; 5 6;;; 7 8]",
            "$(T)[[1 2;;; 3 4];;;; [5 6];;; [7 8]]",
            "$(T)[1 2 ;;\n 3 4]",
            "$(T)[1;;]",
            "$(T)[2; 3;;;]",
            "$(T)[[1 2] [3 4]]",

            # These are supplements, not from the docs
            "$(T)[1\n2\n3\n4]",
            "$(T)[1\n2;;\n3\n4]",
            "$(T)[f(a)\n f(a);;\n f(a)\n f(a)]",
            "$(T)[\n1\n2;;\n3\n4\n]", # extra newlines
            "$(T)[]",
            "$(T)[;]",
            "$(T)[;;]",
            "$(T)[;;;]",
            "$(T)[1 2 ;;\n 3 4 ; 2 3 4 5]", # issue 1080
            "$(T)[1 2 ;;\n 3 4 ;;; 5 6 ;;\n 7 8]", # issue 1080
            "$(T)[1\n\n2\n\n3]", # issue 1242
        )
            for style in ALL_STYLES
                @testset let style = style
                    test_format(s, nothing, style; ast=true)
                end
            end
        end
    end
end

@testset "hcat and typed_hcat nodes" begin
    # hcat nodes are the ones without T; typed_hcat nodes are the ones with T. Both
    # should more or less be formatted the same way.
    for T in ("", "T")
        @testset "spaces only" begin
            # Additionally check that superfluous whitespace is removed.
            for s in ("x = $(T)[a b]", "x = $(T)[a      b     ]")
                for style in ALL_STYLES
                    test_format(s, "x = $(T)[a b]", style)
                end
                test_format(s, "x = $(T)[\n    a b\n]"; margin = 5+length(T))

                # TODO(penelopeysm): The indentation for other styles is all over the
                # place. But we can at least check for now that it parses to the same
                # AST (meaning that at worst, it's ugly, but not wrong), and that it's
                # idempotent.
                for style in ALL_STYLES,
                    kwargs in
                    ((;), (; margin = 5+length(T)), (; join_lines_based_on_source = false))

                    test_format(s, nothing, style; kwargs...)
                end
            end
        end

        @testset ";;\\n only" begin
            for s in ("x = $(T)[a;;\n b]", "x = $(T)[a    ;;\n   b   ]")
                # because the original matrix is already split across a newline,
                # the formatter will insert more newlines
                expected_default = "x = $(T)[\n    a;;\n    b\n]"
                test_format(s, expected_default)
                test_format(s, expected_default; margin = 5+length(T))

                ws = " " ^ (5 + length(T))
                expected_sciml = "x = $(T)[a;;\n$(ws)b]"
                test_format(s, expected_sciml, SciMLStyle())
                test_format(s, expected_sciml, SciMLStyle(); margin = 5+length(T))
                test_format(s, expected_sciml, YASStyle())
                test_format(s, expected_sciml, YASStyle(); margin = 5+length(T))
            end
        end

        @testset "mixture of space and ;;\\n" begin
            for s in ("x = $(T)[a b;;\n c d]", "x = $(T)[a    b   ;;\n   c    d   ]")
                # because the original matrix is already split across a newline,
                # the formatter will insert more newlines
                expected = "x = $(T)[\n    a b;;\n    c d\n]"
                test_format(s, expected)
                test_format(s, expected; margin = 5+length(T))

                # TODO(penelopeysm): The indentation for other styles is all over the
                # place. But we can at least check for now that it parses to the same
                # AST (meaning that at worst, it's ugly, but not wrong), and that it's
                # idempotent.
                kwargs_combos = (
                    (;),
                    (; margin = 5+length(T)),
                    (; join_lines_based_on_source = false)
                )
                for style in ALL_STYLES, kwargs in kwargs_combos
                    test_format(s, nothing, style; kwargs...)
                end
            end
        end

        @testset "comments are not lost" begin
            s = "[a b;; # comment\nc d]"
            for st in (DefaultStyle(), BlueStyle(), MinimalStyle())
                target = "[a b;; # comment\n    c d]"
                test_format(s, target, st; ast=true)
            end
            target = "[a b;; # comment\n c d]"
            for st in (SciMLStyle(), YASStyle())
                test_format(s, target, st; ast=true)
            end

            s = "[#=1=# a #=2=# b #=3=# ;;\n#=4=# c #=5=# d #=6=#]"
            for st in ALL_STYLES
                # Idempotence & semantic invariance
                test_format(s, nothing, st; ast=true)
                # Check that the comment is still there
                out = format_text(s, st)
                for i in 1:6
                    @test occursin("#=$(i)=#", out)
                end
            end
        end
    end
end

@testset "ncat and typed ncat nodes" begin
    @testset "newline and ;;" begin
        s = "[1\n2;;\n3\n4]"
        # Default and Blue style will impose the standard 4-space indentation
        expected_indent4 = "[\n    1\n    2;;\n    3\n    4\n]"
        # SciML and YAS style will indent to the opening brace
        expected_indent1 = "[1\n 2;;\n 3\n 4]"
        for style in (DefaultStyle(), BlueStyle())
            test_format(s, expected_indent4, style)
            test_format(s, expected_indent4, style; margin = 1)
        end
        for style in (SciMLStyle(), YASStyle())
            test_format(s, expected_indent1, style)
            test_format(s, expected_indent1, style; margin = 1)
        end
        # MinimalStyle keeps the brackets where they are, and indents every continuation
        # line by one level
        test_format(s, "[1\n    2;;\n    3\n    4]", MinimalStyle())
    end
end

@testset "MinimalStyle indentation of array literals" begin
    # MinimalStyle leaves the brackets where they are, so every line after the opening
    # bracket gets exactly one extra level of indentation, whichever kind of concatenation
    # the newline stands for.
    @testset "rows are all indented equally" begin
        for (s, expected) in (
            ("[1\n2\n3]", "[1\n    2\n    3]"),
            ("[1\n2;;\n3]", "[1\n    2;;\n    3]"),
            ("[1\n2;;\n3\n4]", "[1\n    2;;\n    3\n    4]"),
            ("[1;\n2;;\n3;\n4]", "[1;\n    2;;\n    3;\n    4]"),
            ("[1;;\n2]", "[1;;\n    2]"),
            ("[1 2;;\n3 4]", "[1 2;;\n    3 4]"),
            # rows nested inside rows
            ("[1\n2;;\n3;;;\n4]", "[1\n    2;;\n    3;;;\n    4]"),
            ("[1\n2;;;\n3\n4]", "[1\n    2;;;\n    3\n    4]"),
            # hcat rows inside a vcat
            ("[1 2\n3 4]", "[1 2\n    3 4]"),
            ("T[1\n2;;\n3]", "T[1\n    2;;\n    3]"),
        )
            @testset let s = s
                test_format(s, expected, MinimalStyle(); ast=true)
            end
        end
    end

    @testset "nested brackets" begin
        s = """
        [[1,
        2]; 3;;
        4]"""
        expected = """
        [[1,
            2]; 3;;
            4]"""
        test_format(s, expected, MinimalStyle(); ast=true)

        s = """
        [[1,
        2] 3
        4 5]"""
        expected = """
        [[1,
            2] 3
            4 5]"""
        test_format(s, expected, MinimalStyle(); ast=true)

        s = """
        [1 2
        [3,
        4] 5]"""
        expected = """
        [1 2
            [3,
                4] 5]"""
        test_format(s, expected, MinimalStyle(); ast=true)
    end

    @testset "indentation is relative to the enclosing scope" begin
        s = """
        function f()
            x = [1
            2;;
            3
            4]
            return x
        end"""
        expected = """
        function f()
            x = [1
                2;;
                3
                4]
            return x
        end"""
        test_format(s, expected, MinimalStyle(); ast=true)
    end
end

@testset "#490" begin
    @testset "DefaultStyle" begin
        str = "[1;; 2]"
        test_format(str, str)

        str_ = """
        [
            1;;
            2
        ]"""
        test_format(str, str_; margin = 1)

        str = "T[1;; 2]"
        test_format(str, str)

        str_ = """
        T[
            1;;
            2
        ]"""
        test_format(str, str_; margin = 1)
    end

    @testset "YASStyle" begin
        str = "[1;; 2]"
        test_format(str, str, YASStyle())

        str_ = """
        [1;;
         2]"""
        test_format(str, str_, YASStyle(); margin = 1)

        str = "T[1;; 2]"
        test_format(str, str, YASStyle())

        str_ = """
        T[1;;
          2]"""
        test_format(str, str_, YASStyle(); margin = 1)
    end
end

@testset "#620" begin
    s = "[1; 0;;]"
    test_format(s, s)
    test_format(s, s, YASStyle())
end

@testset "#582" begin
    test_format("[a;b;;]", "[a; b;;]", YASStyle())
end

@testset "#608" begin
    s1 = """
    hcat([zeros(1); ones(3)], [zeros(2); ones(2)], [zeros(3); ones(1)], [zeros(1); ones(3)], [zeros(2); ones(2)], [zeros(3); ones(1)])
    """
    s2 = """
    hcat([zeros(1); ones(3)], [zeros(2); ones(2)], [zeros(3); ones(1)], [zeros(1); ones(3)],
         [zeros(2); ones(2)], [zeros(3); ones(1)])
    """
    test_format(s1, s2, YASStyle())
end

@testset "#532" begin
    s = "(; a = [1;;], b = cos[2;;])"
    s_nospace = "(; a=[1;;], b=cos[2;;])"
    for style in (DefaultStyle(), SciMLStyle())
        test_format(s, s, style)
    end
    # whitespace_around_kwarg = false
    for style in (BlueStyle(), YASStyle(), MinimalStyle())
        test_format(s, s_nospace, style)
    end
end

@testset "#1113 - comments in vcat array literals" begin
    for s in (
        "X = [\n    # leading\n    1 2\n    3 4\n]\n",
        "X = [\n    1 2\n    3 4\n    # trailing\n]\n",
        "X = [\n    # foo\n    1 2\n    3 4\n    # bar\n]\n",
        "X = [\n    1 2\n    # between\n    3 4\n]\n",
        "X = Int[\n    # foo\n    1 2\n    3 4\n    # bar\n]\n",
    )
        for style in ALL_STYLES
            if style isa DefaultStyle
                # Default should leave it unchanged
                test_format(s, s; ast = true)
            else
                test_format(s, nothing, style; ast = true)
            end
        end
    end
end

@testset "#1113 - comments in ncat array literals" begin
    for s in (
        "[\n    # leading\n    1\n    2;;\n    3\n    4\n]\n",
        "[\n    1\n    2;;\n    3\n    4\n    # trailing\n]\n",
        "[\n    1\n    2;;\n    # between\n    3\n    4\n]\n",
        "[\n    1;\n    2;;\n    # between\n    3;\n    4\n]\n",
    )
        for style in ALL_STYLES
            if style isa DefaultStyle
                # Default should leave it unchanged
                test_format(s, s; ast = true)
            else
                test_format(s, nothing, style; ast = true)
            end
        end
    end

    # this one is still a bit wonky because the \n after 2;; is collapsed
    s = "[\n    # leading\n    1\n    2;;\n    3\n    4;;;\n    5\n    6;;\n    7\n    8\n]\n"
    for style in ALL_STYLES
        test_format(s, nothing, style; ast = true)
        @test occursin("# leading", format_text(s))
    end
    @test_broken format_text(s) == s
end

@testset "#1113 - comments in hcat array literals" begin
    for s in (
        "X = [\n    # only\n    1 2\n]\n",
        "X = [\n    1 2\n    # trailing\n]\n",
        "X = [\n    # foo\n    1 2\n    # bar\n]\n",
        "X = [\n    1 2;;\n    # hi\n    3 4\n]\n",
        "X = [#= inline =# 1 2]\n",
        "X = [1 #= mid =# 2]\n",
    )
        for style in ALL_STYLES
            if style isa DefaultStyle
                test_format(s, s; ast = true)
            else
                test_format(s, nothing, style; ast = true)
            end
        end
    end
end

@testset "1168 vcats in rows of other arrays" begin
    s = """[x [y z
        [q
        s
        # a
        # b
        ]]
        f]"""
    for style in ALL_STYLES
        test_format(s, nothing, style; ast=true)
    end
end

end # module

module InternalUtilsTests

import Test: @testset, @test
import JuliaFormatter as JF
import JuliaSyntax as JS

@testset "Internal utilities" begin
    # Build the same parser/document/state objects the formatter utilities consume.
    function parsed_node(text)
        doc = JF.Document(text)
        state = JF.State(doc, JF.Options())
        root = JS.parseall(JS.GreenNode, text; version=JF.SUPPORTED_SYNTAX_VERSION)
        nodes = filter(n -> !JS.is_whitespace(n), JS.children(root))
        return doc, state, only(nodes)
    end

    @testset "source operator recovery" begin
        # JS v1 can represent source operators as Identifier leaves; recover
        # the actual operator kind from the original source text.
        _, state, node = parsed_node("a + b")
        op_indices = JF.source_operator_indices(node)
        op = JS.children(node)[only(op_indices)]

        @test JF.source_op_kind_from_offset(state, op, 3) === JS.Kind("+")
        @test JF.source_op_kind(state, node) === JS.Kind("+")

        _, state, node = parsed_node("x .+ y")
        @test JF.source_operator_indices(node) == [3, 4]
        @test JF.source_op_kind(state, node) === JS.Kind("+")

        _, state, node = parsed_node("x < y < z")
        @test JF.source_operator_indices(node) == [3, 7]
        @test JF.source_op_kind(state, node) === JS.Kind("<")
    end

    @testset "source_unary_operator_index prefix $text" for text in (
        "+(y)",
        "-(y)",
        ">=(y)",
        "+y",
        "-y",
        "!y",
    )
        _, state, node = parsed_node(text)
        @test JF.source_unary_operator_index(true, node, state) == 1
    end

    @testset "source_unary_operator_index postfix $text" for text in (
        "y...",
        "y'",
        "x'ᵀ",
        "(y)...",
        "[1, 2]'",
    )
        _, state, node = parsed_node(text)
        @test JF.source_unary_operator_index(false, node, state) ==
              length(JS.children(node))
    end

    @testset "short-form function utilities" begin
        # Short-form definitions parse as function nodes but need binary-op handling
        # so the equals sign keeps assignment-like spacing and metadata.
        _, state, node = parsed_node("f(x) = x")

        @test JF.is_short_function_def(node)
        @test JF.source_operator_indices(node) == [3]
        @test JF.source_op_kind(state, node) === JS.Kind("=")

        # Compound assignments split the source operator across multiple child nodes.
        _, state, node = parsed_node("x += 1")
        @test JF.source_operator_indices(node) == [3, 4]
        @test JF.source_op_kind(state, node) === JS.Kind("op=")

        _, state, node = parsed_node("x .+= 1")
        @test JF.source_operator_indices(node) == [3, 4, 5]
        @test JF.source_op_kind(state, node) === JS.Kind("op=")

        # Long-form definitions must stay on the dedicated function-definition path.
        _, _, node = parsed_node("""
        function f(x)
            x
        end
        """)
        @test !JF.is_short_function_def(node)
    end

    @testset "assignment predicate" begin
        # Use JS's syntactic-assignment category instead of rebuilding
        # assignment membership from precedence ranges and child checks.
        _, _, node = parsed_node("x = 1")
        @test JF.is_assignment(node)

        _, _, node = parsed_node("x += 1")
        @test JF.is_assignment(node)

        _, _, node = parsed_node("x in xs")
        @test !JF.is_assignment(node)
    end

    @testset "do-block and iteration utilities" begin
        # Calls with a do block are split so the call arguments and do body can be
        # formatted by their dedicated paths.
        _, _, node = parsed_node("""
        map(xs) do x
            x + 1
        end
        """)
        childs = JS.children(node)
        do_idx = JF.do_block_index(childs)

        @test do_idx == 5
        @test JF.has_do_block_call(node) == do_idx
        @test length(JF.call_args(childs[1:(do_idx-1)])) == 1

        # Single-iterator loops can inspect the RHS iterable directly.
        _, _, node = parsed_node("""
        for x in [1, 2]
        end
        """)
        iter = JS.children(node)[2]
        @test !JF.iteration_has_comma(iter)
        @test JS.kind(JF.iteration_rhs(iter)) === JS.Kind("vect")

        # Cartesian iterations need to detect the comma and use the final iteration
        # expression as the effective RHS.
        _, _, node = parsed_node("""
        for x in [1, 2], y in 3:4
        end
        """)
        iter = JS.children(node)[2]
        @test JF.iteration_has_comma(iter)
        @test JS.kind(JF.iteration_rhs(iter)) === JS.Kind("call")
    end

    @testset "display-width source offsets" begin
        # cursor_loc returns display columns, not byte offsets; the combining mark
        # in s\u0304_b should not add a visible column.
        text = "s\u0304_b      = 1\n"
        doc = JF.Document(text)
        eq_byte_offset = findfirst(isequal('='), text)
        state = JF.State(doc, JF.Options())
        state.offset = eq_byte_offset
        loc = JF.cursor_loc(state)

        @test eq_byte_offset > 10
        @test loc[2] == 10
        @test JF.node_align_length(JF.FST(JF.IDENTIFIER, 1, 1, 1, "s\u0304_b")) == 3
    end

    @testset "module flags" begin
        # JS v1 stores baremodule as a module node with a flag.
        _, _, node = parsed_node("""
        baremodule A
        end
        """)

        @test JS.kind(node) === JS.Kind("module")
        @test JS.has_flags(node, JS.BARE_MODULE_FLAG)
        @test !JF.is_short_function_def(node)
        @test JF.format_text("baremodule A\nend") == "baremodule A end"
    end
end

@testset "predicates on GreenNodes" begin
    @testset "unary_info" begin
        # [1] to index into the actual node we care about
        p(x) = JS.parseall(JS.GreenNode, strip(x); version=JF.SUPPORTED_SYNTAX_VERSION)[1]
        # Prefix operator
        @test JF.unary_info(p("+(x)")) === true
        @test JF.unary_info(p("+x")) === true
        @test JF.unary_info(p("+x")) === true
        @test JF.unary_info(p("+[1,2]")) === true
        @test JF.unary_info(p("<:x")) === true
        @test JF.unary_info(p("-x")) === true
        @test JF.unary_info(p("-[1,2]")) === true
        # Postfix operators
        @test JF.unary_info(p("x'")) === false
        @test JF.unary_info(p("x'ᵀ")) === false
        @test JF.unary_info(p("x'...")) === false
        @test JF.unary_info(p("[1,2]'")) === false
        @test JF.unary_info(p("x...")) === false
        @test JF.unary_info(p("[1,2]...")) === false
        # Things that aren't unaries at all
        @test JF.unary_info(p("+")) === nothing
        @test JF.unary_info(p("<:")) === nothing
        @test JF.unary_info(p("x + y")) === nothing
        @test JF.unary_info(p("f(x)")) === nothing
        @test JF.unary_info(p("x")) === nothing
        @test JF.unary_info(p("[1, 2]")) === nothing
        @test JF.unary_info(p("x.y")) === nothing
        @test JF.unary_info(p("+(x, y)")) === nothing
        @test JF.unary_info(p("string(x)")) === nothing
    end

    @testset "first_nonws_leaf_and_offset" begin
        p(x) = JS.parseall(JS.GreenNode, x; version=JF.SUPPORTED_SYNTAX_VERSION)
        # Simple identifier
        let result = JF.first_nonws_leaf_and_offset(p("x")[1])
            @test result !== nothing
            @test JS.kind(result[1]) === JS.Kind("Identifier")
            @test result[2] == 0
        end
        # Operator application — first leaf is the operator
        let result = JF.first_nonws_leaf_and_offset(p("+x")[1])
            @test result !== nothing
            @test result[2] == 0
        end
        # With some whitespace
        let result = JF.first_nonws_leaf_and_offset(p("  +x"))
            @test result !== nothing
            @test result[2] == 2
        end
    end

    @testset "source_begins_with_op_needing_parens" begin
        function check(code)
            node = JS.parseall(JS.GreenNode, code; version=JF.SUPPORTED_SYNTAX_VERSION)[1]
            opts = JF.Options()
            s = JF.State(JF.Document(code), opts)
            return JF.source_begins_with_op_needing_parens(s, node, s.offset)
        end
        # Operators
        @test check("+x")
        @test check("-x")
        @test check("!x")
        @test check(">=(x)")
        # Non-operators / already parenthesised
        @test !check("(+x)")
        @test !check("string(x)")
        @test !check("x")
        @test !check("[1, 2]")
        @test !check("x'")
        @test !check("x'ᵀ")
        @test !check("a ? b : c")
        # Manual exclusions (see source_begins_with_op_needing_parens comments)
        @test !check(":x")
        @test !check("isa(x, T)")
    end
end

end # module

module LongToShortFunctionDefTests

using JuliaFormatter.Internal: test_format, ALL_STYLES
using Test

@testset "long_to_short_function_def" begin
    @testset "basic" begin
        str_ = """
        function foo(a)
            bodybodybody
        end"""
        str = "foo(a) = bodybodybody"
        test_format(str_, str_; indent=4, margin=length(str) - 1, long_to_short_function_def=true)
        test_format(str_, str; indent=4, margin=length(str), long_to_short_function_def=true)

        str_ = """
        function foo(a::T) where {T}
            bodybodybodybodybodybodyb
        end"""
        str = "foo(a::T) where {T} = bodybodybodybodybodybodyb"
        test_format(str_, str_; indent=4, margin=length(str) - 1, long_to_short_function_def=true)
        test_format(str_, str; indent=4, margin=length(str), long_to_short_function_def=true)

        str_ = """
        function foo(a::T)::R where {T}
            bodybodybodybodybodybodybody
        end"""
        str = "foo(a::T)::R where {T} = bodybodybodybodybodybodybody"
        test_format(str_, str_; indent=4, margin=length(str) - 1, long_to_short_function_def=true)
        test_format(str_, str; indent=4, margin=length(str), long_to_short_function_def=true)

        str_ = """
        function foo(a)
            return a + 1
        end"""
        str = "foo(a) = a + 1"
        test_format(str_, str; indent=4, margin=length(str), long_to_short_function_def=true)

        str = """
        function foo()
            expr1
            expr2
        end"""
        test_format(str, str; indent=4, margin=length(str), long_to_short_function_def=true)

        str_ = """
        function foo(a)
            return if a > 1
                2
            else
                nothing
            end
        end"""

        str = """
        foo(a) =
            if a > 1
                2
            else
                nothing
            end"""
        test_format(str_, str; indent=4, margin=length(str), long_to_short_function_def=true)
        test_format(str_, str; indent=4, margin=length(str), long_to_short_function_def=true)
    end

    @testset "not in macros and exprs" begin
        s1 = """
        @macro function foo()
            return 1
        end"""
        s2 = """
        quote
            function foo()
                return 1
            end
        end"""
        s3 = """
        :(function foo()
            return 1
        end)"""
        for s in (s1, s2, s3)
            for style in ALL_STYLES
                # YAS has slightly different indentation, so don't test the exact output--
                # but we can use ast=true to check that the function hasn't been collapsed
                test_format(s, nothing, style; ast=true, long_to_short_function_def=true)
            end
        end
    end
end

end # module

# Line-range formatting (the `lines` keyword / `jlfmt --lines`).
#
# JuliaFormatter formats whole files. To restrict formatting to a set of line ranges (e.g.
# only the lines touched by a PR, or the `Range`s of an LSP `textDocument/rangesFormatting`
# request) we do *not* teach the formatting pipeline about line ranges. Instead, following
# the approach Runic.jl takes (https://github.com/fredrikekre/Runic.jl/pull/120), we keep
# the feature completely orthogonal to the formatting logic:
#
#   1. Insert marker comments around the requested line ranges in the source text.
#   2. Format the whole (marked) source as usual -- the in-range code is therefore formatted
#      in its full surrounding context, so it reflows correctly.
#   3. Splice the result back together line by line: take the formatted lines that fall
#      *between* a begin/end marker pair, take the *original* source verbatim everywhere
#      else, and drop the marker lines themselves.
#
# This means out-of-range lines are emitted byte-for-byte as they appeared in the input,
# which is exactly the "don't churn unrelated lines / git blame" property we want.

# Markers delimiting an in-range block. We deliberately use *line* comments rather than
# `#= ... =#` block comments: JuliaFormatter is known to relocate block comments onto the
# end of the preceding line (https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/571),
# which would break the line-based splice in `remove_line_range_markers`. A standalone line
# comment is reliably kept on its own line. The names are intentionally obscure so they are
# very unlikely to collide with anything a user actually wrote.
const LINE_RANGE_MARKER_BEGIN = "#! __JuliaFormatter_line_range_begin__"
const LINE_RANGE_MARKER_END = "#! __JuliaFormatter_line_range_end__"

# A line counts as a marker only when it consists of *nothing but* that marker (ignoring
# surrounding whitespace). We match exactly rather than with `occursin` to guard against the
# unlikely case where the formatter relocates a marker comment onto a line that also holds
# real code: such a line is then left untouched instead of being silently dropped, and a
# missing marker surfaces as an assertion failure in `remove_line_range_markers` rather than
# as corrupted output.
is_line_range_marker(line::AbstractString, marker::AbstractString) = strip(line) == marker

"""
    normalize_line_ranges(lines::Vector{Tuple{Int,Int}}) -> Vector{UnitRange{Int}}

Convert the user-supplied `lines` (inclusive, 1-based `(start, stop)` line ranges) into a
sorted vector of non-overlapping, non-adjacent `UnitRange{Int}`s.

Overlapping and *adjacent* ranges are merged rather than rejected: this keeps the core API
robust for callers such as LSP `rangesFormatting`, which may legitimately hand us touching
or overlapping ranges. Bounds against the actual file length are checked later, in
[`add_line_range_markers`](@ref).
"""
function normalize_line_ranges(lines::Vector{Tuple{Int,Int}})
    ranges = UnitRange{Int}[]
    for (a, b) in lines
        a >= 1 || throw(
            ArgumentError(
                "invalid `lines` entry $((a, b)): line numbers are 1-based, got start $a",
            ),
        )
        a <= b || throw(
            ArgumentError(
                "invalid `lines` entry $((a, b)): empty range (start $a > stop $b)",
            ),
        )
        push!(ranges, a:b)
    end
    sort!(ranges; by = first)
    merged = UnitRange{Int}[]
    for r in ranges
        # Merge when this range overlaps or is directly adjacent to the previous one
        # (`first(r) <= last(prev) + 1`), so e.g. `1:3` and `4:6` collapse into `1:6`.
        if !isempty(merged) && first(r) <= last(merged[end]) + 1
            prev = merged[end]
            merged[end] = first(prev):max(last(prev), last(r))
        else
            push!(merged, r)
        end
    end
    return merged
end

"""
    add_line_range_markers(text::AbstractString, ranges::Vector{UnitRange{Int}}) -> String

Return a copy of `text` with `LINE_RANGE_MARKER_BEGIN` / `LINE_RANGE_MARKER_END`
comment lines inserted just before and just after each range in `ranges` (a normalized
vector of `UnitRange{Int}`). Throws an `ArgumentError` if a range is out of bounds.
"""
function add_line_range_markers(text::AbstractString, ranges::Vector{UnitRange{Int}})
    lines = collect(eachline(IOBuffer(text); keep = true))
    isempty(lines) && return text
    # Insert from the back so that the indices of earlier ranges are unaffected by the
    # insertions made for later ones.
    for r in sort(ranges; by = first, rev = true)
        a, b = first(r), last(r)
        # Some tooling treats a trailing newline as the start of a new (empty) line. Allow a
        # range to reference that phantom line by clamping `b` back onto the last real line
        # (and skipping the range entirely if it is *only* that phantom line).
        if endswith(lines[end], "\n") && b == length(lines) + 1
            a == length(lines) + 1 && continue
            b = length(lines)
        end
        if a < 1 || b > length(lines)
            throw(
                ArgumentError(
                    "`lines` range $a:$b is out of bounds (input has $(length(lines)) lines)",
                ),
            )
        end
        # If the file's final line has no trailing newline and the range reaches it, add one
        # so that the END marker we insert after it lands on its own line instead of being
        # glued onto the final line of code.
        if b == length(lines) && !endswith(lines[end], "\n")
            lines[end] *= "\n"
        end
        insert!(lines, b + 1, LINE_RANGE_MARKER_END * "\n")
        insert!(lines, a, LINE_RANGE_MARKER_BEGIN * "\n")
    end
    return join(lines)
end

"""
    remove_line_range_markers(marked_src::AbstractString, formatted::AbstractString) -> String

Splice the formatted in-range blocks back into the original source. `marked_src` is the
marker-annotated source produced by [`add_line_range_markers`](@ref) and `formatted` is the
result of formatting it. The two streams are walked line by line in lockstep:

  - outside a marker pair we keep the (verbatim) `marked_src` line,
  - inside a marker pair we keep the `formatted` line,
  - marker lines themselves are dropped.

Both streams contain the same markers in the same order, so the begin/end markers act as
synchronization points between them.
"""
function remove_line_range_markers(marked_src::AbstractString, formatted::AbstractString)
    src_lines = collect(eachline(IOBuffer(marked_src); keep = true))
    fmt_lines = collect(eachline(IOBuffer(formatted); keep = true))
    nsrc, nfmt = length(src_lines), length(fmt_lines)
    io = IOBuffer()
    si = fi = 1
    while true
        # Emit source (out-of-range) lines until the next begin marker, dropping any marker
        # lines we pass (the leading line here may be an end marker left over from the
        # previous iteration).
        while si <= nsrc && !is_line_range_marker(src_lines[si], LINE_RANGE_MARKER_BEGIN)
            if !is_line_range_marker(src_lines[si], LINE_RANGE_MARKER_END)
                write(io, src_lines[si])
            end
            si += 1
        end
        si > nsrc && break
        # `src_lines[si]` is a begin marker: skip the original in-range source up to its end
        # marker (we use the formatted version of those lines instead).
        while si <= nsrc && !is_line_range_marker(src_lines[si], LINE_RANGE_MARKER_END)
            si += 1
        end
        @assert si <= nsrc "unbalanced line-range markers in source"
        # Advance the formatted stream to its matching begin marker, dropping the formatted
        # out-of-range lines (we already emitted those from the source).
        while fi <= nfmt && !is_line_range_marker(fmt_lines[fi], LINE_RANGE_MARKER_BEGIN)
            fi += 1
        end
        @assert fi <= nfmt "begin marker did not survive formatting"
        # Emit formatted in-range lines until the end marker.
        while fi <= nfmt && !is_line_range_marker(fmt_lines[fi], LINE_RANGE_MARKER_END)
            if !is_line_range_marker(fmt_lines[fi], LINE_RANGE_MARKER_BEGIN)
                write(io, fmt_lines[fi])
            end
            fi += 1
        end
        @assert fi <= nfmt "end marker did not survive formatting"
    end
    return String(take!(io))
end

"""
    _format_line_ranges(
        text::AbstractString,
        style::AbstractStyle,
        lines::Vector{Tuple{Int,Int}};
        kwargs...,
    ) -> String

Format only the lines of `text` covered by `lines` (a vector of inclusive, 1-based
`(start, stop)` line ranges), emitting all other lines verbatim. See the comment at the top
of this file for the overall strategy.
"""
function _format_line_ranges(
    text::AbstractString,
    style::AbstractStyle,
    lines::Vector{Tuple{Int,Int}},
    opts::Options{Union{}},
)
    ranges = normalize_line_ranges(lines)
    isempty(ranges) && return text  # nothing requested -> nothing formatted
    marked = add_line_range_markers(text, ranges)
    formatted = _format_text(marked, style, opts)
    spliced = remove_line_range_markers(marked, formatted)
    # When the range reaches the final line, `add_line_range_markers` may have appended a
    # trailing newline (so the END marker lands on its own line). Match the input's
    # trailing-newline state, just as whole-file `format_text` preserves it, rather than
    # gaining a stray newline.
    if !endswith(text, "\n") && endswith(spliced, "\n")
        spliced = String(chomp(spliced))
    end
    return spliced
end

# The content of this file was directly copied from Documenter.jl

# REPL doctest splitter.

const PROMPT_REGEX = r"^julia> (.*)$"
const SOURCE_REGEX = r"^       (.*)$"

function repl_splitter(code)
    lines = split(string(code, "\n"), '\n')
    input = String[]
    output = String[]
    buffer = IOBuffer() # temporary buffer for doctest inputs and outputs
    found_first_prompt = false
    while !isempty(lines)
        line = popfirst!(lines)
        prompt = match(PROMPT_REGEX, line)
        # We allow comments before the first julia> prompt
        if !found_first_prompt && startswith(line, '#')
            continue
        else
            false
        end
        if prompt === nothing
            source = match(SOURCE_REGEX, line)
            if source === nothing
                savebuffer!(input, buffer)
                println(buffer, line)
                takeuntil!(PROMPT_REGEX, buffer, lines)
            else
                println(buffer, source[1])
            end
        else
            found_first_prompt = true
            savebuffer!(output, buffer)
            println(buffer, prompt[1])
        end
    end
    savebuffer!(output, buffer)
    zip(input, output)
end

function savebuffer!(out, buf)
    n = bytesavailable(seekstart(buf))
    n > 0 ? push!(out, rstrip(String(take!(buf)))) : out
end

function takeuntil!(r, buf, lines)
    while !isempty(lines)
        line = lines[1]
        if !occursin(r, line)
            println(buf, popfirst!(lines))
        else
            break
        end
    end
end

module V2StableMultilineStringsTests

using JuliaFormatter: DefaultStyle, YASStyle, BlueStyle, SciMLStyle, MinimalStyle, format_text, JuliaFormatter
using JuliaFormatter.Internal: test_format, format_to_stage, ALL_STYLES
using Test

@testset "v2_stable_multiline_strings" begin
    @testset "length calculation" begin
        @testset "a case where it's different" begin
            s = """
            s = \"""
                1234567890
            \"""
            """

            # 10 characters past the column before the opening quote
            fst = format_to_stage(:fst, s)
            stringn = fst[1][end]
            @test stringn.typ == JuliaFormatter.StringN
            @test stringn.len == 10

            # Opening quote only
            fst = format_to_stage(:fst, s; v2_stable_multiline_strings=true)
            stringn = fst[1][end]
            @test stringn.typ == JuliaFormatter.StringN
            @test stringn.len == 3
        end

        @testset "a case where it's the same" begin
            s = """
            s = \"""1234567890
                1234567890
            \"""
            """
            for val in (false, true)
                fst = format_to_stage(:fst, s; v2_stable_multiline_strings=val)
                stringn = fst[1][end]
                @test stringn.typ == JuliaFormatter.StringN
                @test stringn.len == 13
            end
        end
    end

    @testset "example of docs idempotence" begin
        s = """
        foooo((\"""
        12345\""", g),
            a, b)
        """
        output = """
        foooo((
            \"""
        12345\""",
            g,
        ), a, b)
        """
        test_format(s, output; margin=21, v2_stable_multiline_strings=true)
    end

    @testset "example of differing nesting behaviour in docs" begin
        s = """
        throw(ArgumentError(\"""
                            ooohhhhhh a very long thing
                            \"""))
        """
        for style in ALL_STYLES
            test_format(s, s, style; margin=46, v2_stable_multiline_strings=true)
        end

        ordinary_output = """
        throw(
            ArgumentError(
                \"""
                ooohhhhhh a very long thing
                \""",
            ),
        )
        """
        test_format(s, ordinary_output; margin=46, v2_stable_multiline_strings=false)
    end
end

end # module

"""
    JuliaFormatter.format_md(
        text::AbstractString,
        style::AbstractStyle = DefaultStyle();
        formatting_options...
    )

Normalizes the Markdown source and formats Julia code blocks.

See [Formatting Options](@ref formatting-options) for a list of available formatting options.
"""
function format_md(text::AbstractString; style::AbstractStyle = DefaultStyle(), kwargs...)
    return format_md(text, style; kwargs...)
end
function format_md(text::AbstractString, style::AbstractStyle; kwargs...)
    isempty(text) && return text
    opts = merge_options(options(style), Options{_Unset}(; kwargs...))
    return _format_md(text, style, opts)
end

function _format_md(text::AbstractString, style::AbstractStyle, opts::Options{Union{}})
    markdown(
        enable!(
            Parser(),
            [
                AdmonitionRule(),
                FootnoteRule(),
                MathRule(),
                TableRule(),
                FrontMatterRule(),
                FormatRule(style, opts, MarkdownFile),
            ],
        )(
            text,
        ),
    )
end

flattenable(k) = kind(k) in KSet"&& || |>"
flattenable(::Nothing) = false

"""
Flattens a binary operation call tree if the operation repeats 2 or more times.
"`a && b && c`" will be transformed while "`a && b`" will not.
"""
function flatten_binaryopcall(fst::FST; top = true)
    nodes = FST[]
    kind = op_kind(fst)
    always_nest = must_nest(fst)

    lhs = fst[1]
    rhs = fst[end]
    lhs_kind = op_kind(lhs)
    rhs_kind = op_kind(rhs)
    lhs_same_op = lhs_kind === kind
    rhs_same_op = rhs_kind === kind
    idx = findlast(n -> n.typ === PLACEHOLDER, fst.nodes::Vector{FST})

    if (top && !lhs_same_op && !rhs_same_op) || idx === nothing
        return nodes, always_nest
    end

    if lhs_same_op
        lhs_nodes, lhs_always_nest = flatten_binaryopcall(lhs; top = false)
        append!(nodes, lhs_nodes)
        always_nest |= lhs_always_nest
    else
        flatten_fst!(lhs)
        push!(nodes, lhs)
    end
    # everything except the indentation placeholder
    append!(nodes, fst[2:(idx-1)])

    if rhs_same_op
        rhs_nodes, rhs_always_nest = flatten_binaryopcall(rhs; top = false)
        append!(nodes, rhs_nodes)
        always_nest |= rhs_always_nest
    else
        flatten_fst!(rhs)
        push!(nodes, rhs)
    end

    return nodes, always_nest
end

function flatten_conditionalopcall(fst::FST)
    nodes = FST[]
    for n in fst.nodes::Vector{FST}
        if n.typ === Conditional
            append!(nodes, flatten_conditionalopcall(n))
        else
            push!(nodes, n)
        end
    end
    return nodes
end

function flatten_fst!(fst::FST)
    if is_leaf(fst)
        return
    end
    for n in fst.nodes::Vector{FST}
        if is_leaf(n)
            continue
        elseif n.typ === Binary && flattenable(op_kind(n))
            # possibly convert Binary to Chain
            nnodes, always_nest = flatten_binaryopcall(n)
            if length(nnodes) > 0
                n.typ = Chain
                n.nodes = nnodes
                # if any of the child nodes needed to be nested, then this node also needs
                # to be nested to preserve the original nesting structure
                if always_nest
                    n.nest_behavior = AlwaysNest
                end
            else
                flatten_fst!(n)
            end
        else
            flatten_fst!(n)
        end
    end
end

function import_to_usings(fst::FST, s::State)
    nodes = fst.nodes::Vector{FST}
    if !(findfirst(n -> is_colon(n) || n.typ === As, nodes) === nothing)
        return FST[]
    end
    # Skip if any import path has dots (relative imports like `..A` or submodule
    # paths like `A.B`). An ImportPath with only an identifier has one child;
    # anything with dots has more.
    idxs = findall(n -> !is_leaf(n), nodes)
    for i in idxs
        n = fst[i]
        if n.typ === ImportPath && length(n.nodes::Vector{FST}) > 1
            return FST[]
        end
    end

    usings = FST[]
    for i in idxs
        n = fst[i]
        sl = n.startline
        el = n.endline
        use = FST(Using, fst.indent)
        use.startline = sl
        use.endline = el

        add_node!(use, FST(KEYWORD, -1, sl, el, "using"), s)
        add_node!(use, Whitespace(1), s)

        add_node!(use, n, s; join_lines = true)
        colon = FST(OPERATOR, -1, sl, el, ":")
        colon.metadata = Metadata(K"::")
        add_node!(use, colon, s; join_lines = true)
        add_node!(use, Whitespace(1), s)
        add_node!(use, n[end], s; join_lines = true)

        push!(usings, use)
    end

    return usings
end

"""
    annotate_typefields_with_any!(fst::FST, s::State)

Annotates fields in a type definitions with `::Any` if
no type annotation is provided.
"""
function annotate_typefields_with_any!(fst::FST, s::State)
    if is_leaf(fst)
        return
    end
    for (i, n) in enumerate(fst.nodes::Vector{FST})
        if n.typ === IDENTIFIER
            nn = FST(Binary, n.indent)
            nn.startline = n.startline
            nn.endline = n.endline
            add_node!(nn, n, s)
            line_offset = n.line_offset + length(n)
            op = FST(OPERATOR, line_offset, n.startline, n.endline, "::")
            op.metadata = Metadata(K"::")
            add_node!(nn, op, s; join_lines = true)
            line_offset += 2
            add_node!(
                nn,
                FST(IDENTIFIER, line_offset, n.startline, n.endline, "Any"),
                s;
                join_lines = true,
            )
            fst[i] = nn
        else
            continue
        end
    end
end

"""
    short_to_long_function_def!(fst::FST, s::State)

Transforms a *short* function definition

```julia
f(arg1, arg2) = body
```

to a *long* function definition

```julia
function f(arg2, arg2)
    body
end
```
"""
function short_to_long_function_def!(
    fst::FST,
    s::State,
    lineage::Vector{Tuple{FNode,Union{Nothing,Metadata}}},
)
    if (fst[1].typ !== Call && fst[1].typ !== Where)
        return false
    end

    for i in (length(lineage)-1):-1:1
        parent = lineage[i]
        # maybe need to know metadata too?
        if parent[1] in (If, Do, Try, Begin, For, While, Quote, Block)
            continue
        elseif parent[1] in (FunctionN, Macro, MacroBlock, MacroCall) ||
               (!isnothing(parent[2]) && parent[2].is_short_form_function)
            return false
        else
            break
        end
    end

    # 3 cases
    #
    # case 1
    #   func(a) = body
    #
    # case 2
    #   func(a::T) where T = body
    #
    # case 3
    #   func(a::T)::R where T = body
    funcdef = FST(FunctionN, fst.indent)
    # function
    kw = FST(KEYWORD, -1, fst[1].startline, fst[1].endline, "function")
    add_node!(funcdef, kw, s)
    add_node!(funcdef, Whitespace(1), s)

    # func(a)
    # OR
    # func(a) where T
    add_node!(funcdef, fst[1], s; join_lines = true)

    # body

    s.opts.always_use_return && prepend_return_fst!(fst[end], s)
    if fst[end].typ === Block
        add_node!(funcdef, fst[end], s; max_padding = s.opts.indent)
        add_indent!(funcdef[end], s, s.opts.indent)
    elseif fst[end].typ === Begin
        # case where body is wrapped in a `begin` block
        # which becomes superfluous when converted to a
        # long function definition
        #
        # abc() = begin
        #    body
        # end
        #
        #
        # find Block node in fs[tend]
        idx = findfirst(n -> n.typ === Block, fst[end].nodes)
        if idx === nothing
            return false
        end
        bnode = fst[end][idx]
        add_indent!(bnode, s, -s.opts.indent)
        add_node!(funcdef, bnode, s; max_padding = s.opts.indent)
        add_indent!(funcdef[end], s, s.opts.indent)
    else
        # The body is a single expression (not a Block or Begin). Wrap it
        # in a Block so the indentation logic works. The body node may
        # already carry some indent from the original context (e.g. a Vect
        # inherits the Binary's indent=4, but a plain identifier has
        # indent=0). We target funcdef.indent + opts.indent and subtract
        # what the body already has.
        body_indent = fst[end].indent
        bl = FST(Block, body_indent)
        add_node!(bl, fst[end], s)
        add_node!(funcdef, bl, s; max_padding = s.opts.indent)
        add_indent!(funcdef[end], s, funcdef.indent + s.opts.indent - body_indent)
    end

    if s.opts.always_use_return
        prepend_return_fst!(funcdef[end], s)
    end

    # end
    kw = FST(KEYWORD, -1, fst[end].startline, fst[end].endline, "end")
    add_node!(funcdef, kw, s)

    fst.typ = funcdef.typ
    fst.nodes = funcdef.nodes
    fst.len = funcdef.len

    return true
end

"""
    long_to_short_function_def!(fst::FST, s::State)

Transforms a *long* function definition

```julia
function f(arg2, arg2)
    body
end
```

to a *short* function definition

```julia
f(arg1, arg2) = body
```
"""
function long_to_short_function_def!(fst::FST, s::State)
    nodes = fst.nodes::Vector{FST}
    if any(is_comment, nodes)
        return false
    end

    I = findall(n -> n.typ === Block, nodes)
    if !(length(I) == 1)
        return false
    end

    block = nodes[first(I)]
    if !(length(block.nodes::Vector{FST}) == 1)
        return false
    end

    I = findfirst(n -> n.typ === Call || n.typ === Where, nodes)
    if I === nothing
        return false
    end
    lhs = nodes[I]

    rhs = first(block.nodes)

    if rhs.typ === Return
        rhs = (rhs.nodes::Vector{FST})[end]
    end

    # length(Whitespace(1) * "=" * Whitespace(1)) = 3
    line_margin = s.line_offset + length(lhs) + 3 + length(rhs) + fst.extra_margin
    if line_margin > s.opts.margin
        return false
    end

    if rhs.indent > 0
        add_indent!(rhs, s, -s.opts.indent)
    end

    funcdef = FST(Binary, fst.indent)
    funcdef.metadata = Metadata(K"=", false, false, true, false, false, false, false)
    kw = (join_lines = true, override_join_lines_based_on_source = true)

    add_node!(funcdef, lhs, s; kw...)
    add_node!(funcdef, Whitespace(1), s; kw...)
    op = FST(OPERATOR, 0, 0, 0, "=")
    op.metadata = Metadata(K"=")
    add_node!(funcdef, op, s; kw...)
    add_node!(funcdef, Placeholder(1), s; kw...)
    add_node!(funcdef, Placeholder(0), s; kw...)
    add_node!(funcdef, rhs, s; kw...)

    if rhs.typ in (If, Do, Try, For, While, Let)
        funcdef.nest_behavior = AlwaysNest
    end

    fst.typ = funcdef.typ
    fst.nodes = funcdef.nodes
    fst.len = funcdef.len
    fst.metadata = funcdef.metadata
    fst.nest_behavior = funcdef.nest_behavior
    return true
end

# TODO: revisit this
"""
    binaryop_to_whereop(fst::FST, s::State)

Handles the case of a function def defined as:

```julia
foo(a::A)::R where A = body
```

In this case instead of it being parsed as (1):

```
Binary
 - Where
 - OP
 - RHS
```

It's parsed as (2):

```
Binary
 - Binary
  - LHS
  - OP
  - Where
   - R
   - ...
 - OP
 - RHS
```

(1) is preferrable since it's the same parsed result as:

```julia
foo(a::A) where A = body
```

This transformation converts (2) to (1).

ref <https://github.com/julia-vscode/CSTParser.jl/issues/93>
"""
function binaryop_to_whereop!(fst::FST, s::State)
    # transform fst[1] to a Where
    oldbinop = fst[1]
    oldwhereop = fst[1][end]

    # get everything up to the where
    binop = FST(Binary, fst[1].indent)
    binop.metadata = oldbinop.metadata
    for n in oldbinop.nodes
        if n.typ === Where
            break
        end
        add_node!(binop, n, s; join_lines = true)
    end
    # # foo(a::A)::R gets the "R"
    add_node!(binop, oldwhereop[1], s; join_lines = true)

    whereop = FST(Where, fst[1].indent)
    add_node!(whereop, binop, s)

    # "foo(a::A)::R where A"
    for n in oldwhereop[2:end]
        add_node!(whereop, n, s; join_lines = true)
    end

    fst[1] = whereop
end

"""
    prepend_return_fst!(fst::FST, s::State)

Prepends `return` to the last expression of a block if applicable.

*Note*: This function is only called when a short-form function definition is converted to a
long-form one, AND `always_use_return` is true. For ordinary, pre-existing long-form
function definitions, the implementation of `always_use_return` is in `p_block` in
`default/pretty.jl`. This is done to avoid post-FST passes which tend to cause idempotence
issues.

```julia
function foo()
    a = 2 * 3
    a / 3
end
```

to

```julia
function foo()
    a = 2 * 3
    return a / 3
end
```
"""
function prepend_return_fst!(fst::FST, s::State)
    if fst.typ !== Block || length(fst.nodes::Vector{FST}) == 0
        return
    end

    # Skip trailing inline block comments (`#= … =#`) and whitespace to find the
    # actual last expression.  Inline line comments are already placed outside the
    # Block by `add_node!`, but block comments live inside it as siblings.
    nodes = fst.nodes::Vector{FST}
    last_idx = findlast(
        n -> n.typ !== HASHEQCOMMENT && n.typ !== WHITESPACE && n.typ !== PLACEHOLDER,
        nodes,
    )
    if last_idx === nothing
        return
    end

    ln = fst[last_idx]
    if is_block(ln) || ln.typ in (Return, MacroCall, MacroBlock, MacroStr)
        return
    end
    if last_idx > 2 && (fst[last_idx-2].typ === MacroStr || is_macrodoc(fst[last_idx-2]))
        return
    end
    # check to see if the last node already has a return
    found_return = false
    f = (fst::FST, ::State) -> begin
        if fst.typ === Return
            found_return = true
        end
        return
    end
    lo = s.line_offset
    walk(f, ln, s)
    s.line_offset = lo
    if found_return
        return
    end

    ret = FST(Return, fst.indent)
    kw = FST(KEYWORD, -1, ln.startline, ln.startline, "return")
    add_node!(ret, kw, s; join_lines = true)
    add_node!(ret, Whitespace(1), s)
    add_node!(ret, ln, s; join_lines = true)
    fst[last_idx] = ret
    return
end

"""
    move_at_sign_to_the_end(fst::FST, s::State)

NOTE: Assumes `fst` is the caller name of a macrocall such as
`@macro` or `Module.@macro`.

Moves `@` to the last identifier.

Example:

```julia
@Module.macro
```

to

```julia
Module.@macro
```
"""
function move_at_sign_to_the_end(fst::FST, s::State)
    val = ""
    f = (n::FST, _) -> begin
        if n.typ === MACRONAME && n.line_offset == -33
            val *= gettreeval(n)
            return false
        elseif is_leaf(n)
            v = gettreeval(n)
            val *= v
        end
    end
    walk(f, fst, s)

    splits = split(val, "@")
    if length(splits) != 2
        return fst
    end
    qualifier, macro_name = splits[1], splits[2]

    # In general, we can't just split on '.' and call it a day, because this leads to all
    # sorts of problems with macro or module names that have dots in them. So we'll be
    # conservative and only move things that look like "Modulename." from the macro name to
    # the qualifier.
    while true
        m = match(r"^[A-Za-z_][A-Za-z0-9_]*\.", macro_name)
        if m === nothing
            break
        end
        qualifier *= m.match
        macro_name = macro_name[(length(m.match)+1):end]
    end
    val = qualifier * "@" * macro_name

    return FST(MACRONAME, -33, fst.startline, fst.startline, val)
end

function conditional_to_if_block!(fst::FST, s::State, top::Bool)
    t = FST(If, fst.indent)
    kw = FST(KEYWORD, -1, fst.startline, fst.startline, top ? "if" : "elseif")
    add_node!(t, kw, s; max_padding = 0)
    add_node!(t, Whitespace(1), s; join_lines = true)
    add_node!(t, fst[1], s; join_lines = true)

    nodes = fst.nodes::Vector{FST}
    idx1 = findfirst(n -> n.typ === OPERATOR && n.val == "?", nodes)::Int
    idx2 = findfirst(n -> n.typ === OPERATOR && n.val == ":", nodes)::Int

    block1 = FST(Block, fst.indent + s.opts.indent)
    for n in nodes[(idx1+1):(idx2-1)]
        if n.typ === PLACEHOLDER ||
           n.typ === WHITESPACE ||
           n.typ === NEWLINE ||
           is_comment(n)
            continue
        end
        add_node!(block1, n, s)
    end
    add_node!(t, block1, s; max_padding = s.opts.indent)

    block2 = FST(Block, fst.indent)
    padding = 0
    if fst[end].typ === Conditional
        conditional_to_if_block!(fst[end], s, false)
    else
        block2.indent += s.opts.indent
        padding = s.opts.indent
        kw = FST(KEYWORD, 0, 0, -1, "else")
        add_node!(t, kw, s; max_padding = 0)
    end
    add_node!(block2, fst[end], s)
    add_node!(t, block2, s; max_padding = 0)

    if top
        kw = FST(KEYWORD, 0, 0, -1, "end")
        add_node!(t, kw, s; max_padding = 0)
    end

    fst.typ = t.typ
    fst.nodes = t.nodes
    fst.len = t.len

    return nothing
end

"""
    separate_kwargs_with_semicolon!(fst::FST)

Ensures keyword arguments are separated by a "`;`".

### Examples

Replace "`,`" with "`;`".

```julia
a = f(x, y = 3)

->

a = f(x; y = 3)
```

Move ";" to the prior to the first positional argument.

```julia
a = f(x = 1; y = 2)

->

a = f(; x = 1, y = 2)
```
"""
function separate_kwargs_with_semicolon!(fst::FST)
    nodes = fst.nodes::Vector{FST}
    first_kw_idx = findfirst(n -> n.typ === Kw, nodes)
    # who knows if this list is exhaustive... would be much easier at the CST level
    last_nonkw_idx = findlast(
        n -> !(
            n.typ in (
                Kw,
                PUNCTUATION,
                SEMICOLON,
                WHITESPACE,
                PLACEHOLDER,
                TRAILINGCOMMA,
                NEWLINE,
                INLINECOMMENT,
                HASHEQCOMMENT,
            )
        ),
        nodes,
    )
    # No keyword arguments
    isnothing(first_kw_idx) && return

    semicolon_index = findfirst(n -> n.typ === SEMICOLON, nodes)
    # first "," prior to a kwarg
    last_comma_idx = findprev(is_comma, nodes, first_kw_idx - 1)
    last_ph_idx = findprev(n -> n.typ === PLACEHOLDER, nodes, first_kw_idx - 1)

    if !isnothing(semicolon_index) && semicolon_index > first_kw_idx
        # move ; prior to first kwarg
        fst[semicolon_index].val = ","
        fst[semicolon_index].typ = PUNCTUATION
        if isnothing(last_comma_idx)
            if !isnothing(last_ph_idx)
                if last_ph_idx > 1 && fst[last_ph_idx-1].typ === INLINECOMMENT
                    insert!(fst, last_ph_idx - 1, Whitespace(1))
                    insert!(fst, last_ph_idx - 1, Semicolon())
                else
                    fst[last_ph_idx] = Placeholder(1)
                    insert!(fst, last_ph_idx, Semicolon())
                end
            else
                insert!(fst, first_kw_idx, Placeholder(1))
                insert!(fst, first_kw_idx, Semicolon())
            end
        else
            fst[last_comma_idx].val = ";"
            fst[last_comma_idx].typ = SEMICOLON
        end
    elseif isnothing(semicolon_index) && isnothing(last_comma_idx)
        if !isnothing(last_ph_idx)
            if last_ph_idx > 1 && fst[last_ph_idx-1].typ === INLINECOMMENT
                insert!(fst, last_ph_idx - 1, Whitespace(1))
                insert!(fst, last_ph_idx - 1, Semicolon())
            else
                fst[last_ph_idx] = Placeholder(1)
                insert!(fst, last_ph_idx, Semicolon())
            end
        else
            insert!(fst, first_kw_idx, Placeholder(1))
            insert!(fst, first_kw_idx, Semicolon())
        end
    elseif isnothing(semicolon_index)
        # Don't convert f(x, y=z, q) to f(x; y=z, q); i.e., if there is any positional
        # argument after the first keyword argument, don't convert it
        if last_nonkw_idx > first_kw_idx
            return
        end
        fst[last_comma_idx].val = ";"
        fst[last_comma_idx].typ = SEMICOLON
    end

    return
end

"""
    remove_superfluous_whitespace!(fst::FST)

Soft deletes `WHITESPACE` or `PLACEHOLDER` that's directly followed by a `NEWLINE` or `INLINECOMMENT` node.
"""
function remove_superfluous_whitespace!(fst::FST)
    if is_leaf(fst)
        return
    end
    nodes = fst.nodes::Vector{FST}
    for (i, n) in enumerate(nodes)
        if (n.typ === WHITESPACE || n.typ === PLACEHOLDER || n.typ === NEWLINE) &&
           can_remove(n) &&
           i < length(nodes) &&
           (fst[i+1].typ === NEWLINE || fst[i+1].typ === INLINECOMMENT)
            fst[i] = Whitespace(0)
        else
            remove_superfluous_whitespace!(n)
        end
    end
    return
end

function _short_circuit_to_if!(fst::FST, s::State, value_is_needed::Bool)
    # change it into an if
    t = FST(If, fst.indent)
    kw = FST(KEYWORD, -1, fst.startline, fst.startline, "if")
    add_node!(t, kw, s; max_padding = 0)
    add_node!(t, Whitespace(1), s; join_lines = true)

    nodes = fst.nodes::Vector{FST}
    idx = findlast(n -> n.typ === OPERATOR && (n.val == "||" || n.val == "&&"), nodes)::Int
    is_or = nodes[idx].val == "||"

    wrap_with_parens = !(nodes[1].typ === Brackets)

    if is_or
        call = FST(Unary, fst.indent)
        add_node!(call, FST(OPERATOR, -1, fst.startline, fst.startline, "!"), s)

        if wrap_with_parens
            brackets = FST(Brackets, fst.indent)
            add_node!(
                brackets,
                FST(PUNCTUATION, -1, fst.startline, fst.startline, "("),
                s;
                join_lines = true,
            )
            add_node!(brackets, Placeholder(0), s)
            # inner
            lhs = FST(Chain, fst.indent)
            for n in nodes[1:(idx-1)]
                add_node!(lhs, n, s; join_lines = true)
            end
            # remove extra ws
            if lhs[end].typ === WHITESPACE
                lhs[end] = Whitespace(0)
            end

            add_node!(brackets, lhs, s; join_lines = true)
            add_node!(brackets, Placeholder(0), s)
            add_node!(
                brackets,
                FST(PUNCTUATION, -1, nodes[idx-2].startline, nodes[idx-2].startline, ")"),
                s;
                join_lines = true,
            )
            add_node!(call, brackets, s; join_lines = true)
        else
            add_node!(call, fst[1], s; join_lines = true)
        end

        add_node!(t, call, s; join_lines = true)
    else
        # from idx-1 go backwards until we find a node that's not a
        lhs = FST(Chain, fst.indent)
        for n in nodes[1:(idx-1)]
            add_node!(lhs, n, s; join_lines = true)
        end
        # remove extra ws
        if lhs[end].typ === WHITESPACE
            lhs[end] = Whitespace(0)
        end
        add_node!(t, lhs, s; join_lines = true)
    end

    block1 = FST(Block, fst.indent + s.opts.indent)
    for n in nodes[(idx+1):end]
        if n.typ === PLACEHOLDER ||
           n.typ === WHITESPACE ||
           n.typ === NEWLINE ||
           is_comment(n)
            continue
        end
        add_node!(block1, n, s)
    end
    add_node!(t, block1, s; max_padding = s.opts.indent)

    if value_is_needed
        # Add the 'else' branch
        else_kw = FST(KEYWORD, 0, 0, -1, "else")
        add_node!(t, else_kw, s; max_padding = 0)
        # add second block is this is not a return
        block2 = FST(Block, fst.indent + s.opts.indent)

        # Determine the default return value based on the operator
        default_val =
            is_or ? FST(KEYWORD, -1, 0, -1, "true") : FST(KEYWORD, -1, 0, -1, "false")
        add_node!(block2, default_val, s; join_lines = true)
        add_node!(t, block2, s; max_padding = s.opts.indent)
    end

    # Close the if statement
    end_kw = FST(KEYWORD, 0, 0, -1, "end")
    add_node!(t, end_kw, s; max_padding = 0)

    fst.typ = t.typ
    fst.nodes = t.nodes
    fst.len = t.len

    return nothing
end

function short_circuit_to_if_pass!(fst::FST, s::State)
    if is_leaf(fst)
        return
    end
    for (i, n) in enumerate(fst.nodes::Vector{FST})
        if is_leaf(n)
            continue
        elseif (n.typ === Binary || n.typ === Chain) &&
               !isnothing(n.metadata) &&
               (n.metadata::Metadata).is_expandable_shortcircuit &&
               fst.typ in (Block, TopLevel, Return)
            # Only expand short-circuit expressions that appear as statements in a block
            # (e.g. function body, loop body) or at the top level. Don't expand inside
            # calls, tuples, etc. where the value is being used -- `a && b` and
            # `if a; b; end` have different return values when `a` is falsy.
            last_expr_idx = findlast(
                n ->
                    n.typ !== HASHEQCOMMENT &&
                    n.typ !== WHITESPACE &&
                    n.typ !== NEWLINE &&
                    n.typ !== PLACEHOLDER,
                fst.nodes::Vector{FST},
            )
            value_is_needed =
                i == last_expr_idx && (fst.typ === Block || fst.typ === Return)
            if !value_is_needed
                _short_circuit_to_if!(n, s, false)
            end
        else
            short_circuit_to_if_pass!(n, s)
        end
    end
end

module OptionsForToInTests

using JuliaFormatter: DefaultStyle, YASStyle, BlueStyle, SciMLStyle, MinimalStyle, format_text
using JuliaFormatter.Internal: test_format, ALL_STYLES
using Test

@testset "for_to_in normalization" begin
    @testset "always convert `=` to `in` (for loops)" begin
        str_ = """
        for i = 1:n
            println(i)
        end"""
        str = """
        for i in 1:n
            println(i)
        end"""
        for style in ALL_STYLES
             test_format(str_, str, style; always_for_in = true)
        end

        str_ = """
        for i = I1, j in I2
            println(i, j)
        end"""
        str = """
        for i in I1, j in I2
            println(i, j)
        end"""
        for style in ALL_STYLES
            if style isa SciMLStyle
                @test_broken false
            else
                test_format(str_, str, style; always_for_in = true)
            end
        end

        str_ = """
        for i = 1:30, j = 100:-2:1
            println(i, j)
        end"""
        str = """
        for i in 1:30, j in 100:-2:1
            println(i, j)
        end"""
        for style in ALL_STYLES
            test_format(str_, str; always_for_in = true)
            test_format(str_, str_; always_for_in = nothing)
            test_format(str, str; always_for_in = nothing)
        end

        str_ = "[(i,j) for i=I1,j=I2]"
        str = "[(i, j) for i in I1, j in I2]"
        for style in ALL_STYLES
             test_format(str_, str, style; always_for_in = true)
        end

        str_ = "((i,j) for i=I1,j=I2)"
        str = "((i, j) for i in I1, j in I2)"
        for style in ALL_STYLES
             test_format(str_, str, style; always_for_in = true)
        end

        str_ = "[(i, j) for i = 1:2:10, j = 100:-1:10]"
        str = "[(i, j) for i in 1:2:10, j in 100:-1:10]"
        for style in ALL_STYLES
             test_format(str_, str, style; always_for_in = true)
        end

        str_ = "[i for i = 1:10 if i == 2]"
        str = "[i for i in 1:10 if i == 2]"
        for style in ALL_STYLES
             test_format(str_, str, style; always_for_in = true)
        end
    end

    @testset "for_in_replacement" begin
        str_ = """
        for a = b
        end
        """
        str = """
        for a ∈ b
        end
        """
        for style in ALL_STYLES
             test_format(str_, str, style; always_for_in = true, for_in_replacement = "∈")
        end

        # generator
        str_ = "[(i, j) for i = 1:2:10, j = 100:-1:10]"
        str = "[(i, j) for i ∈ 1:2:10, j ∈ 100:-1:10]"
        for style in ALL_STYLES
             test_format(str_, str, style; always_for_in = true, for_in_replacement = "∈")
        end

        str_ = "[i for i = 1:10 if i == 2]"
        str = "[i for i ∈ 1:10 if i == 2]"
        for style in ALL_STYLES
             test_format(str_, str, style; always_for_in = true, for_in_replacement = "∈")
        end

        @test_throws ArgumentError format_text(
            str_;
            always_for_in = true,
            for_in_replacement = "ni!",
        )
    end

    @testset "default" begin
        # non-range: = → in
        test_format("for i = xs\nend", "for i in xs\nend"; ast=true)
        test_format("[x for i = xs]", "[x for i in xs]"; ast=true)
        # range: in → =
        test_format("for i = 1:10\nend", "for i = 1:10\nend"; ast=true)
        test_format("[x for i in 1:2, j in 3:4]", "[x for i = 1:2, j = 3:4]"; ast=true)
    end

    @testset "always_for_in = true" begin
        for style in ALL_STYLES
            test_format("for i = 1:10\nend", "for i in 1:10\nend", style; always_for_in=true, ast=true)
            test_format("[x for i = 1:10]", "[x for i in 1:10]", style; always_for_in=true, ast=true)
        end
    end

    @testset "always_for_in = nothing (disabled)" begin
        for style in ALL_STYLES
            test_format("[x for i = xs]", "[x for i = xs]", style; always_for_in=nothing, ast=true)
            test_format("for i = xs\nend", "for i = xs\nend", style; always_for_in=nothing, ast=true)
        end
    end

    @testset "for_in_replacement" begin
        test_format("[x for i = xs]", "[x for i ∈ xs]"; always_for_in=true, for_in_replacement="∈", ast=true)
        test_format("[x for i = xs]", "[x for i = xs]"; always_for_in=true, for_in_replacement="=", ast=true)
    end

    @testset "multi-variable iteration" begin
        test_format("[x for i = xs, j = ys]", "[x for i in xs, j in ys]"; ast=true)
    end

    @testset "nested for" begin
        test_format("[x for i = xs for j = ys]", "[x for i in xs for j in ys]"; ast=true)
    end

    @testset "filter" begin
        test_format("[x for i = xs if i > 0]", "[x for i in xs if i > 0]"; ast=true)
    end

    @testset "body `=` is preserved" begin
        for T in ("", "T")
            # non-range iteration
            test_format("$(T)[x = f() for i = xs]", "$(T)[x = f() for i in xs]"; ast=true)
            test_format("$(T)[x = f() for i = xs]", "$(T)[x = f() for i in xs]"; always_for_in=true, ast=true)
            # range iteration
            test_format("$(T)[x = f() for i = 1:10]", "$(T)[x = f() for i = 1:10]"; ast=true)
            test_format("$(T)[x = f() for i = 1:10]", "$(T)[x = f() for i in 1:10]"; always_for_in=true, ast=true)
        end
    end

    @testset "body `in`/`∈` is preserved" begin
        test_format("[x in S for i = xs]", "[x in S for i in xs]"; ast=true)
        test_format("[x ∈ S for i = xs]", "[x ∈ S for i in xs]"; always_for_in=true, ast=true)
        # body `in` must not become `=` even with for_in_replacement = "="
        test_format(
            "[x in S for i in xs]",
            "[x in S for i = xs]";
            always_for_in=true,
            for_in_replacement="=",
            ast=true,
        )
    end

    @testset "body `=` with multi-variable iteration and filter" begin
        test_format(
            "[x = f(i, j) for i = xs, j = ys if g(i, j)]",
            "[x = f(i, j) for i in xs, j in ys if g(i, j)]";
            always_for_in=true,
            ast=true,
        )
        test_format("[x = y for i = xs for j = ys]", "[x = y for i in xs for j in ys]"; ast=true)
    end

    @testset "generator in function call" begin
        test_format("sum(x = f(i) for i = xs)", "sum(x = f(i) for i in xs)"; ast=true)
        test_format(
            "Iterators.flatten(x = y for y = zs if y in allowed for zs = xss)",
            "Iterators.flatten(x = y for y in zs if y in allowed for zs in xss)";
            ast=true,
        )
    end

    @testset "nested comprehensions" begin
        test_format(
            "[[x = f() for j = ys] for i = xs]",
            "[[x = f() for j in ys] for i in xs]";
            ast=true,
        )
        test_format(
            "collect(x = y for y = (a = b for a = xs))",
            "collect(x = y for y in (a = b for a in xs))";
            ast=true,
        )
    end

    @testset "BlueStyle (always_for_in = true by default)" begin
        test_format("[x = f() for i = xs]", "[x = f() for i in xs]", BlueStyle(); ast=true)
        test_format("[x in S for i = xs]", "[x in S for i in xs]", BlueStyle(); ast=true)
    end

    @testset "SciMLStyle (always_for_in = true by default)" begin
        test_format("[x = f() for i = xs]", "[x = f() for i in xs]", SciMLStyle(); ast=true)
    end
end

end

module ShimsTests

import JuliaFormatter.Shims as S
import JuliaSyntax
using Test

cst(s::String) = JuliaSyntax.parseall(JuliaSyntax.GreenNode, s)[1]

@testset "is_function_call" begin
    # True function calls
    @testset "$(func)$(args)" for func in ("f", "f.", "g!", "g!.", "+", ".+", "<:", ".<:"), args in ("()", "(x, y)", "(x, y; kw=1)", "(; kw=1)", "(args...)")
        @test S.is_function_call(cst("$(func)$(args)"))
    end

    # Exclude unary ops
    @testset "$(func)(x)" for func in ("f", "f.", "g!", "g!.", ".<:")
        @test S.is_function_call(cst("$(func)(x)"))
    end
    @testset "$(func)x" for func in ("+", ".+", "<:")
        @test !S.is_function_call(cst("$(func)x"))
    end

    # But not the parenthesised versions
    @testset "$(func)(x)" for func in ("+", ".+", "<:")
        @test S.is_function_call(cst("$(func)(x)"))
    end
    @testset "$(func)(x, y)" for func in ("+", ".+", "<:")
        @test S.is_function_call(cst("$(func)(x, y)"))
    end

    # Exclude bare operators
    @testset "$(func)" for func in ("+", ".+", "<:", ".<:")
        @test !S.is_function_call(cst("$(func)"))
    end

    # Exclude infix calls
    @testset "a $(op) b" for op in ("+", ".+", "<:", ".<:")
        @test !S.is_function_call(cst("a $(op) b"))
    end

    # Check that it's robust towards whitespace and comments
    @test S.is_function_call(cst("f( <:(x, y))")[3])
    @test S.is_function_call(cst("@m <:(x, y)")[3])
    @test S.is_function_call(cst("<:(#=hi=# x, y)"))
    @test S.is_function_call(cst("<:(x #=hi=#, y)"))
    @test S.is_function_call(cst("<:(x, #=hi=# y)"))
    @test S.is_function_call(cst("<:(x, y#=hi=#)"))
end

@testset "is_valid_nonword_operator" begin
    @test S.is_valid_nonword_operator("+")
    @test S.is_valid_nonword_operator("<")
    @test S.is_valid_nonword_operator("::")
    @test !S.is_valid_nonword_operator("in")
    @test !S.is_valid_nonword_operator("isa")
    @test !S.is_valid_nonword_operator("where")
    @test !S.is_valid_nonword_operator("foo")
end

end

using Pkg: Pkg
Pkg.develop(; path = dirname(@__DIR__))

using Documenter, DocumenterCodeBlocks, JuliaFormatter

makedocs(;
    sitename = "JuliaFormatter",
    format = Documenter.HTML(),
    modules = [JuliaFormatter],
    pages = [
        "Overview" => "index.md",
        "Options" => [
            "Formatting Options" => "formatting_options.md",
            "Custom Alignment" => "custom_alignment.md",
        ],
        "Styles" => [
            "Default Style" => "default_style.md",
            "YAS Style" => "yas_style.md",
            "Blue Style" => "blue_style.md",
            "SciML Style" => "sciml_style.md",
        ],
        "Skipping Formatting" => "skipping_formatting.md",
        "Configuration File" =>
            [".JuliaFormatter.toml" => "config.md", "File Options" => "file_options.md"],
        "Command-Line Interface" => "cli.md",
        "Integrations" => [
            "Editors" => "editors.md",
            "GitHub Actions" => "github_actions.md",
            "pre-commit" => "precommit.md",
            "PackageCompiler" => "packagecompiler.md",
        ],
        "How It Works" => "how_it_works.md",
        "API Reference" => "api.md",
        "Contributing" => "contributing.md",
        "Known Issues" => "known_issues.md",
        "Project Status" => "status.md",
    ],
    checkdocs = :export,
    plugins = [CodeBlocks()],
)

deploydocs(;
    repo = "github.com/JuliaEditorSupport/JuliaFormatter.jl.git",
    push_preview = true,
)

module JlfmtAppTests

using Test: @test, @testset
using JuliaFormatter
using JuliaFormatter: UNFORMATTED_EXIT_CODE, ERROR_EXIT_CODE
using UUIDs: uuid4

const PROJECT_DIR = dirname(abspath(Base.active_project()))
const CONFIG_FILE_NAME = ".JuliaFormatter.toml"

function jlfmt_cmd(julia_flags::Cmd = ``)
    `$(Base.julia_cmd()) $julia_flags --project=$PROJECT_DIR -m JuliaFormatter`
end

function with_sandbox(f)
    mktempdir(; prefix = "jlfmt_test_$(uuid4())_") do dir
        cd(dir) do
            f(dir)
        end
    end
end

function capture_stderr(f)
    path = tempname()
    try
        return open(path, "w+") do io::IOStream
            result = redirect_stderr(f, io)
            flush(io)
            seekstart(io)
            return result, read(io, String)
        end
    finally
        rm(path; force = true)
    end
end

function check_exitcode(expected::Int, cmd::Cmd)
    @test run(ignorestatus(cmd)).exitcode == expected
end

@static if VERSION < v"1.12"
    @info "Skipping jlfmt app tests for pre-v1.12 Julia."
else
    @testset "Test jlfmt app" begin
        @testset "--threads" begin
            with_sandbox() do _
                write("spacing_and_call.jl", "f( x,y )=x+y\nz=f( 1,2 )\n")
                write(
                    "control_flow_and_collection.jl",
                    "function g(xs)\nys=[ x*2 for x in xs if x>0 ]\nreturn ys\nend\n",
                )
                write(
                    "struct_and_keywords.jl",
                    "struct Foo\nx::Int\ny::String\nend\n\nh(;a=1,b=2)=a+b\n",
                )

                threaded_cmd = jlfmt_cmd(`--threads=3`)
                check_exitcode(UNFORMATTED_EXIT_CODE, `$threaded_cmd --check .`)
                @test success(`$threaded_cmd --inplace .`)
                @test success(`$threaded_cmd --check .`)
            end
        end

        @testset "doesn't crash on empty files" begin
            with_sandbox() do _
                write("empty.jl", "")
                run(`$(jlfmt_cmd()) --inplace empty.jl`)
                @test isempty(readchomp("empty.jl"))
            end
        end

        @testset "DefaultStyle is used if not configured" begin
            with_sandbox() do _
                text = "(; a=1)"
                write("a.jl", text)
                run(`$(jlfmt_cmd()) --inplace a.jl`)
                @test readchomp("a.jl") == format_text(text, DefaultStyle())
                # Sanity check that the text is actually being formatted
                @test text != format_text(text, DefaultStyle())
            end
        end

        @testset "ignore" begin
            text = "a+ b"
            formatted = format_text(text)
            @assert text != formatted

            function write_ignore_test_files()
                write("fmt.jl", text)
                write("skip_me.jl", text)
                mkdir("sub")
                write("sub/also_fmt.jl", text)
                write("sub/skip_me_too.jl", text)
            end

            function check_ignore_results()
                @test readchomp("fmt.jl") == formatted
                @test readchomp("sub/also_fmt.jl") == formatted
                @test readchomp("skip_me.jl") == text
                @test readchomp("sub/skip_me_too.jl") == text
            end

            @testset "via --ignore flag" begin
                with_sandbox() do _
                    write_ignore_test_files()
                    run(
                        `$(jlfmt_cmd()) --inplace --ignore=skip_me.jl --ignore=sub/skip_me_too.jl .`,
                    )
                    check_ignore_results()
                end
            end

            @testset "via .JuliaFormatter.toml" begin
                with_sandbox() do _
                    write_ignore_test_files()
                    write(
                        CONFIG_FILE_NAME,
                        """ignore = ["skip_me.jl", "sub/skip_me_too.jl"]\n""",
                    )
                    run(`$(jlfmt_cmd()) --inplace .`)
                    check_ignore_results()
                end
            end
        end

        @testset "--check" begin
            with_sandbox() do _
                fname = "a.jl"
                unformatted = "f( x,y )=x+y"

                # Format first, then --check should pass
                write(fname, unformatted)
                run(`$(jlfmt_cmd()) --inplace $fname`)
                @test success(`$(jlfmt_cmd()) --check $fname`)

                # --check should fail on unformatted file
                write(fname, unformatted)
                errno, stderr = capture_stderr() do
                    JuliaFormatter.main(["--check", fname])
                end
                @test errno == UNFORMATTED_EXIT_CODE
                @test occursin(
                    "Some files are not formatted correctly. Run again with `--inplace` instead of `--check` to format them.",
                    stderr,
                )
                # --check should not modify the file
                @test readchomp(fname) == unformatted
            end
        end

        @testset "multiple input diagnostics" begin
            with_sandbox() do _
                write("a.jl", "f( x,y )=x+y")
                write("b.jl", "g( x,y )=x+y")

                errno, stderr = capture_stderr() do
                    JuliaFormatter.main(["."])
                end
                @test errno == ERROR_EXIT_CODE
                @test occursin(
                    "multiple input files require either `--inplace` to write changes or `--check` to verify formatting",
                    stderr,
                )
            end
        end

        @testset "--inplace" begin
            with_sandbox() do _
                fname = "a.jl"
                unformatted = "f( x,y )=x+y"
                formatted = format_text(unformatted)

                write(fname, unformatted)
                run(`$(jlfmt_cmd()) --inplace $fname`)
                @test readchomp(fname) == formatted

                # Running again on already-formatted file is a no-op
                run(`$(jlfmt_cmd()) --inplace $fname`)
                @test readchomp(fname) == formatted
            end
        end

        @testset "stdout mode" begin
            with_sandbox() do _
                fname = "a.jl"
                unformatted = "f( x,y )=x+y"
                formatted = format_text(unformatted)

                write(fname, unformatted)
                output = readchomp(`$(jlfmt_cmd()) $fname`)
                @test output == formatted
                # File should be unchanged
                @test readchomp(fname) == unformatted
            end
        end

        @testset "--prioritize-config-file" begin
            @testset "style" begin
                with_sandbox() do _
                    fname = "a.jl"
                    text = "(; a = 1)"
                    write(fname, text)
                    write(CONFIG_FILE_NAME, "style = \"blue\"")

                    # By default, CLI --style overrides config
                    run(`$(jlfmt_cmd()) --inplace --style=default $fname`)
                    @test readchomp(fname) == text

                    # With --prioritize-config-file, config wins over CLI
                    run(
                        `$(jlfmt_cmd()) --inplace --prioritize-config-file --style=default $fname`,
                    )
                    @test readchomp(fname) == format_text(text, BlueStyle())
                end
            end

            @testset "options" begin
                with_sandbox() do _
                    fname = "a.jl"
                    text = "f(a = 1)"
                    write(fname, text)
                    write(CONFIG_FILE_NAME, "whitespace_in_kwargs = false")

                    # By default, CLI flag overrides config
                    run(`$(jlfmt_cmd()) --inplace --whitespace_in_kwargs $fname`)
                    @test readchomp(fname) == text

                    # With --prioritize-config-file, config wins over CLI
                    run(
                        `$(jlfmt_cmd()) --inplace --prioritize-config-file --whitespace_in_kwargs $fname`,
                    )
                    @test readchomp(fname) ==
                          format_text(text; whitespace_in_kwargs = false)
                end
            end
        end

        @testset "style is picked up from config correctly" begin
            # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/951
            with_sandbox() do _
                fname = "a.jl"
                text = "(; a = 1)"
                write(fname, text)

                write(CONFIG_FILE_NAME, "style = \"blue\"")
                run(`$(jlfmt_cmd()) --inplace .`)
                @test readchomp(fname) == format_text(text, BlueStyle())
                @test text != format_text(text, BlueStyle())

                write(".JuliaFormatter.toml", "style = \"default\"")
                run(`$(jlfmt_cmd()) --inplace .`)
                @test readchomp(fname) == text
            end
        end

        @testset "--lines" begin
            @testset "single range formats only that line" begin
                with_sandbox() do _
                    fname = "a.jl"
                    write(fname, "f(x,y)=1\ng( a ,b )=2\n")
                    run(`$(jlfmt_cmd()) --inplace --lines=1:1 $fname`)
                    # line 1 formatted, line 2 kept verbatim
                    @test readchomp(fname) == "f(x, y) = 1\ng( a ,b )=2"
                end
            end

            @testset "multiple ranges via repetition" begin
                with_sandbox() do _
                    fname = "a.jl"
                    write(fname, "f(a,b)=1\ng( x ,y )=2\nh(c,d)=3\n")
                    run(`$(jlfmt_cmd()) --inplace --lines=1:1 --lines=3:3 $fname`)
                    @test readchomp(fname) == "f(a, b) = 1\ng( x ,y )=2\nh(c, d) = 3"
                end
            end

            @testset "stdin" begin
                out = read(
                    pipeline(
                        `$(jlfmt_cmd()) --lines=1:1`;
                        stdin = IOBuffer("f(x,y)=1\ng( a ,b )=2\n"),
                    ),
                    String,
                )
                @test out == "f(x, y) = 1\ng( a ,b )=2\n"
            end

            @testset "--check only inspects the requested lines" begin
                with_sandbox() do _
                    fname = "a.jl"
                    # line 1 already formatted, line 2 not
                    write(fname, "f(x, y) = 1\ng( a ,b )=2\n")
                    # checking only line 1 passes (it is already formatted)...
                    @test success(`$(jlfmt_cmd()) --check --lines=1:1 $fname`)
                    # ...but checking line 2 fails (it needs formatting)
                    check_exitcode(UNFORMATTED_EXIT_CODE, `$(jlfmt_cmd()) --check --lines=2:2 $fname`)
                    # --check must not modify the file
                    @test readchomp(fname) == "f(x, y) = 1\ng( a ,b )=2"
                end
            end

            @testset "errors" begin
                with_sandbox() do _
                    write("a.jl", "f(x,y)=1\ng(a,b)=2\n")
                    write("b.jl", "h(x,y)=1\n")
                    write("a.md", "x=1\n")

                    # multiple input files
                    errno, stderr = capture_stderr() do
                        JuliaFormatter.main(["--check", "--lines=1:1", "a.jl", "b.jl"])
                    end
                    @test errno == ERROR_EXIT_CODE
                    @test occursin(
                        "option `--lines` cannot be used together with multiple input files",
                        stderr,
                    )

                    # malformed argument
                    errno, stderr = capture_stderr() do
                        JuliaFormatter.main(["--lines=abc", "a.jl"])
                    end
                    @test errno == ERROR_EXIT_CODE
                    @test occursin("invalid value `abc` for option `--lines=abc`", stderr)

                    # start greater than stop
                    errno, stderr = capture_stderr() do
                        JuliaFormatter.main(["--lines=5:2", "a.jl"])
                    end
                    @test errno == ERROR_EXIT_CODE
                    @test occursin("start is greater than stop", stderr)

                    # out of bounds (reported cleanly, no backtrace)
                    errno, stderr = capture_stderr() do
                        JuliaFormatter.main(["--lines=1:99", "a.jl"])
                    end
                    @test errno == ERROR_EXIT_CODE
                    @test occursin("out of bounds", stderr)
                    @test !occursin("Stacktrace", stderr)

                    # Markdown input is not supported
                    errno, stderr = capture_stderr() do
                        JuliaFormatter.main(["--format_markdown", "--lines=1:1", "a.md"])
                    end
                    @test errno == ERROR_EXIT_CODE
                    @test occursin(
                        "option `--lines` is not supported for Markdown input",
                        stderr,
                    )
                end
            end
        end

        @testset "config file vs CLI argument interaction" begin
            @testset "CLI overrides config file by default" begin
                with_sandbox() do _
                    fname = "a.jl"
                    text = "if true\nx = 1\nend\n"
                    write(fname, text)
                    write(CONFIG_FILE_NAME, "indent = 8")

                    # CLI --indent=2 should win over config indent=8
                    run(`$(jlfmt_cmd()) --inplace --indent=2 $fname`)
                    @test readchomp(fname) == rstrip(format_text(text; indent = 2))
                    # Sanity check: the config value (8) would give different output
                    @test format_text(text; indent = 2) != format_text(text; indent = 8)
                end
            end

            @testset "config provides defaults for options not on CLI" begin
                with_sandbox() do _
                    fname = "a.jl"
                    text = "if true\nx = 1\nend\n"
                    write(fname, text)
                    # Config sets indent=8; CLI does not specify --indent
                    write(CONFIG_FILE_NAME, "indent = 8")

                    run(`$(jlfmt_cmd()) --inplace $fname`)
                    @test readchomp(fname) == rstrip(format_text(text; indent = 8))
                end
            end

            @testset "config and CLI options merge (different keys)" begin
                with_sandbox() do _
                    fname = "a.jl"
                    text = "f(a = 1)\n"
                    write(fname, text)
                    # Config sets whitespace_in_kwargs=false; CLI sets indent=2
                    # Both should take effect since they control different things
                    write(CONFIG_FILE_NAME, "whitespace_in_kwargs = false")

                    run(`$(jlfmt_cmd()) --inplace --indent=2 $fname`)
                    @test readchomp(fname) ==
                          rstrip(format_text(text; whitespace_in_kwargs = false, indent = 2))
                end
            end

            @testset "--config-dir loads config from specified directory" begin
                with_sandbox() do dir
                    fname = "a.jl"
                    text = "if true\nx = 1\nend\n"
                    write(fname, text)

                    # Put the config in a subdirectory, not the file's own directory
                    config_subdir = joinpath(dir, "config")
                    mkdir(config_subdir)
                    write(joinpath(config_subdir, CONFIG_FILE_NAME), "indent = 8")

                    # Without --config-dir, no config is found (file is in sandbox root)
                    run(`$(jlfmt_cmd()) --inplace $fname`)
                    default_result = readchomp(fname)

                    # Reset the file
                    write(fname, text)

                    # With --config-dir, config from subdirectory is used
                    run(`$(jlfmt_cmd()) --inplace --config-dir=$config_subdir $fname`)
                    @test readchomp(fname) == rstrip(format_text(text; indent = 8))
                    @test readchomp(fname) != default_result
                end
            end

            @testset "config style with CLI option override" begin
                with_sandbox() do _
                    fname = "a.jl"
                    # BlueStyle sets f(a = 1) -> f(; a=1)
                    text = "f(a = 1)\n"
                    write(fname, text)
                    # But we also want to test that a CLI option can override a style default
                    # CLI overrides whitespace_in_kwargs=true
                    write(CONFIG_FILE_NAME, "style = \"blue\"")

                    run(
                        `$(jlfmt_cmd()) --inplace --whitespace-in-kwargs=true $fname`,
                    )
                    output = readchomp(fname)
                    @test output == rstrip(
                        format_text(text, BlueStyle(); whitespace_in_kwargs = true),
                    )
                    @test output != strip(format_text(text, BlueStyle()))
                end
            end

            @testset "no config file uses only CLI args" begin
                with_sandbox() do _
                    fname = "a.jl"
                    text = "if true\nx = 1\nend\n"
                    write(fname, text)
                    # No config file written in sandbox

                    run(`$(jlfmt_cmd()) --inplace --indent=8 $fname`)
                    @test readchomp(fname) == rstrip(format_text(text; indent = 8))
                end
            end

            @testset "CLI --ignore replaces config ignore" begin
                text = "a+ b"
                formatted = format_text(text)
                @assert text != formatted

                with_sandbox() do _
                    write("keep.jl", text)
                    write("skip.jl", text)
                    # Config ignores "keep.jl", but CLI ignores "skip.jl" instead.
                    # Since merge replaces the :ignore key, only CLI's pattern applies.
                    write(CONFIG_FILE_NAME, """ignore = ["keep.jl"]\n""")

                    run(`$(jlfmt_cmd()) --inplace --ignore=skip.jl .`)
                    @test readchomp("keep.jl") == formatted
                    @test readchomp("skip.jl") == text
                end
            end

            @testset "nested config files" begin
                with_sandbox() do _
                    # root/
                    # ├── .JuliaFormatter.toml  (indent = 2)
                    # ├── a.jl
                    # └── sub/
                    #     ├── .JuliaFormatter.toml  (indent = 8)
                    #     └── b.jl
                    text = "if true\nx = 1\nend\n"
                    write(CONFIG_FILE_NAME, "indent = 2")
                    write("a.jl", text)
                    mkdir("sub")
                    write(joinpath("sub", CONFIG_FILE_NAME), "indent = 8")
                    write(joinpath("sub", "b.jl"), text)

                    run(`$(jlfmt_cmd()) --inplace .`)
                    @test readchomp("a.jl") == rstrip(format_text(text; indent = 2))
                    @test readchomp(joinpath("sub", "b.jl")) ==
                          rstrip(format_text(text; indent = 8))
                end
            end

            @testset "--prioritize-config-file with --config-dir" begin
                with_sandbox() do dir
                    fname = "a.jl"
                    text = "if true\nx = 1\nend\n"
                    write(fname, text)

                    config_subdir = joinpath(dir, "config")
                    mkdir(config_subdir)
                    write(joinpath(config_subdir, CONFIG_FILE_NAME), "indent = 8")

                    # CLI says indent=2, but --prioritize-config-file makes config win
                    run(
                        `$(jlfmt_cmd()) --inplace --prioritize-config-file --config-dir=$config_subdir --indent=2 $fname`,
                    )
                    @test readchomp(fname) == rstrip(format_text(text; indent = 8))
                end
            end
        end
    end
end

end # module

const VALID_FOR_IN_OPERATORS = ("in", "=", "∈")

struct _Unset end
Base.convert(::Type{Union{_Unset,T}}, x) where {T} = convert(T, x)
Base.convert(::Type{Union{_Unset,T}}, t::Union{_Unset,T}) where {T} = t

"""
    Options{T<:_Unset}

Struct containing all the options for formatting.

The type parameter `T` is used to indicate whether the option is allowed to be unset.
By default, `T` is `Union{}`.

- `Options{Union{}}` indicates that all options MUST be set to some value. For example,

      Options(; always_use_return=true)

   creates a set of default options but with `always_use_return` set to `true`.

- `Options{_Unset}` indicates that all options are allowed to be unset. For example.

      Options{_Unset}(; always_use_return=true)

  creates a set of empty options but with `always_use_return` set to `true`.

This allows us to perform a merge on two `Options` objects which can be partially populated.
"""
Base.@kwdef struct Options{T<:_Unset}
    align_assignment::Union{T,Bool} = false
    align_conditional::Union{T,Bool} = false
    align_matrix::Union{T,Bool} = false
    align_pair_arrow::Union{T,Bool} = false
    align_struct_field::Union{T,Bool} = false
    always_for_in::Union{T,Union{Bool,Nothing}} = false
    always_use_return::Union{T,Bool} = false
    annotate_untyped_fields_with_any::Union{T,Bool} = true
    conditional_to_if::Union{T,Bool} = false
    disallow_single_arg_nesting::Union{T,Bool} = false
    enforce_triplequoted_docstrings::Union{T,Bool} = true
    for_in_replacement::Union{T,String} = "in"
    force_long_function_def::Union{T,Bool} = false
    format_docstrings::Union{T,Bool} = false
    import_to_using::Union{T,Bool} = false
    indent::Union{T,Int} = 4
    indent_submodule::Union{T,Bool} = false
    join_lines_based_on_source::Union{T,Bool} = false
    long_to_short_function_def::Union{T,Bool} = false
    margin::Union{T,Int} = 92
    max_iterations::Union{T,Int} = 1
    normalize_line_endings::Union{T,String} = "auto"
    pipe_to_function_call::Union{T,Bool} = false
    remove_extra_newlines::Union{T,Bool} = false
    sciml_margin_overrun::Union{T,Int} = 20
    separate_kwargs_with_semicolon::Union{T,Bool} = false
    short_circuit_to_if::Union{T,Bool} = false
    short_to_long_function_def::Union{T,Bool} = false
    surround_whereop_typeparameters::Union{T,Bool} = true
    trailing_comma::Union{T,Bool,Nothing} = true
    trailing_zero::Union{T,Bool} = true
    transform_syntax_in_macros::Union{T,Bool} = false
    v2_stable_multiline_strings::Union{T,Bool} = false
    variable_call_indent::Union{T,Vector{String}} = []
    whitespace_in_kwargs::Union{T,Bool} = true
    whitespace_ops_in_indices::Union{T,Bool} = false
    whitespace_typedefs::Union{T,Bool} = false
    yas_style_nesting::Union{T,Bool} = false

    Options(args...) = verify_options(new{Union{}}(args...))
    Options{_Unset}(args...) = new{_Unset}(args...)
end
function Options{_Unset}(; kwargs...)
    # Has to be an outer constructor because @kwdef messes things up
    kw = Dict{Symbol,Any}(kwargs)
    unused_options = setdiff(keys(kw), fieldnames(Options))
    if !isempty(unused_options)
        options_joined = join(map(o -> "`$o`", collect(unused_options)), ", ")
        @info "ignoring invalid formatting options: $(options_joined)"
    end
    return Options{_Unset}((get(kw, f, _Unset()) for f in fieldnames(Options))...)
end

function verify_options(opts::Options{Union{}})::Options{Union{}}
    if (opts.force_long_function_def === true) &&
       (opts.short_to_long_function_def === false)
        msg = """
        The combination `force_long_function_def = true` and `short_to_long_function_def = false` is invalid.
        """
        throw(ArgumentError(msg))
    end
    if opts.sciml_margin_overrun < 0
        throw(ArgumentError("`sciml_margin_overrun` must be greater than or equal to 0."))
    end
    if opts.always_for_in == true && !(opts.for_in_replacement in VALID_FOR_IN_OPERATORS)
        throw(
            ArgumentError(
                "`for_in_replacement` is set to an invalid operator \"$(opts.for_in_replacement)\", valid operators are $(VALID_FOR_IN_OPERATORS). Change it to one of the valid operators and then reformat.",
            ),
        )
    end
    return opts
end

function Base.show(io::IO, opt::Options{T}) where {T}
    fields = fieldnames(Options)
    max_len = maximum(length ∘ string, fields)
    print(io, T === Union{} ? "Options(" : "Options{_Unset}(")
    for (i, f) in enumerate(fields)
        v = getfield(opt, f)
        println(io)
        printstyled(io, "  ", rpad(f, max_len))
        print(io, " = ")
        if v isa _Unset
            printstyled(io, "_Unset()"; color = :white)
        else
            print(io, repr(v))
        end
        i < length(fields) && print(io, ",")
    end
    print(io, "\n)")
end

function needs_alignment(opts::Options{Union{}})::Bool
    if !(
        opts.align_struct_field ||
        opts.align_conditional ||
        opts.align_assignment ||
        opts.align_pair_arrow
    )
        opts.align_matrix
    else
        true
    end
end

function merge_options(opts1::Options{T1}, opts2::Options{T2}) where {T1<:_Unset,T2<:_Unset}
    # Merge two Options objects, with any set values in opts2 taking precedence over opts1.
    Tout = T1 === _Unset && T2 === _Unset ? _Unset : Union{}
    kwargs = Dict{Symbol,Any}()
    for f in fieldnames(Options)
        v1 = getfield(opts1, f)
        v2 = getfield(opts2, f)
        kwargs[f] = v2 isa _Unset ? v1 : v2
    end
    return Tout === Union{} ? Options(; kwargs...) : Options{Tout}(; kwargs...)
end

module OptionsFormatDocstringsTests

using JuliaFormatter.Internal: test_format, ALL_STYLES
using Test

@testset "format_docstrings" begin
    @testset "basic" begin
        for style in ALL_STYLES
            normalized = """
            \"""
            doc
            \"""
            function f()
                return 20
            end"""

            str = """
            \"""doc
            \"""
            function f()
                return 20
            end"""
            test_format(str, str, style)
            test_format(str, normalized, style; format_docstrings = true)

            str = """
            \"""
            doc\"""
            function f()
                return 20
            end"""
            test_format(str, str, style)
            test_format(str, normalized, style; format_docstrings = true)

            str = """
            \"""doc\"""
            function f()
                return 20
            end"""
            test_format(str, str, style)
            test_format(str, normalized, style; format_docstrings = true)

            str = """
            "doc
            "
            function f()
                return 20
            end"""
            test_format(str, str, style)
            test_format(str, normalized, style; format_docstrings = true)

            str = """
            "
            doc"
            function f()
                return 20
            end"""
            test_format(str, str, style)
            test_format(str, normalized, style; format_docstrings = true)

            str = """
            "doc"
            function f()
                return 20
            end"""
            test_format(str, str, style)
            test_format(str, normalized, style; format_docstrings = true)

            # test aligning to function identation
            str_ = """
                "doc"
            function f()
                return 20
            end"""
            str = """
            "doc"
            function f()
                return 20
            end"""
            test_format(str_, str, style)
            test_format(str_, normalized, style; format_docstrings = true)

            str = """\"""
                     doc for Foo
                     \"""
                     Foo"""
            test_format(str, str, style)

            str = """
            \"""
            doc
            \"""
            function f()    #  comment
                return 20
            end"""
            test_format(str, str, style)
            test_format(str, str, style; format_docstrings = true)

            # Issue 157
            str = raw"""
            @doc \"""
               foo()
            \"""
            foo() = bar()"""
            test_format(str, str, style)
            test_format(str, str, style; format_docstrings = true)

            str = raw"""
            @doc docϵ\"""
               foo()
            \"""
            foo() = bar()"""
            test_format(str, str, style)
            test_format(str, str, style; format_docstrings = true)

            str = raw"""@doc "doc for foo" foo"""
            test_format(str, str, style)
            test_format(str, str, style; format_docstrings = true)

            str = raw"""@doc \"""doc for foo\""" foo"""
            test_format(str, str, style)
            test_format(str, str, style; format_docstrings = true)

            str = raw"""@doc doc\"""doc for foo\""" foo()"""
            test_format(str, str, style)
            test_format(str, str, style; format_docstrings = true)

            str = raw"""@doc foo"""
            test_format(str, str, style)
            test_format(str, str, style; format_docstrings = true)

            # issue 160
            str = raw"""
            module MyModule

            import Markdown: @doc_str

            @doc doc\"""
                foo()
            \"""
            foo() = bar()

            end # module"""
            test_format(str, str, style)
            test_format(str, str, style; format_docstrings = true)
        end
    end

    @testset "with code" begin
        for style in ALL_STYLES
            unformatted = """
            \"""
            This is a docstring

            ```@example
            a =  1
             b  = 2
             a + b
            ```

            ```jldoctest
            a =  1
            b  = 2
            a + b

            # output

            3
            ```

            ```jldoctest
            julia> a =  1
            1

            julia> b  = 2;

            julia>  a + b
            3

            julia> function test(x)
                   x + 1
                   return x + 2
                   end;
            ```
            \"""
            function test(x)
                return x
            end"""

            formatted = """
            \"""
            This is a docstring

            ```@example
            a = 1
            b = 2
            a + b
            ```

            ```jldoctest
            a = 1
            b = 2
            a + b

            # output

            3
            ```

            ```jldoctest
            julia> a = 1
            1

            julia> b = 2;

            julia> a + b
            3

            julia> function test(x)
                       x + 1
                       return x + 2
                   end;

            ```
            \"""
            function test(x)
                return x
            end"""
            test_format(unformatted, formatted, style; format_docstrings = true)
        end
    end

    @testset "issue 602" begin
        s = """
        \"""
        ```jldoctest
        julia> foo()

        julia> 1
        1
        ```
        \"""
        foo() = nothing
        """
        test_format(s, s; format_docstrings = true)
    end

    @testset "Multi-line indented code-blocks" begin
        unformatted = """
        \"""
            fmt(
            )
        \"""
        function fmt() end"""

        formatted = """
        \"""
            fmt(
            )
        \"""
        function fmt() end"""
        test_format(unformatted, formatted; format_docstrings = true)
    end

    @testset "Empty line in docstring" begin
        unformatted = """
        \"""

        \"""
        function test() end"""

        formatted = """
        \"""
        \"""
        function test() end"""
        test_format(unformatted, formatted; format_docstrings = true)
        test_format(unformatted, unformatted; format_docstrings = false)
    end

    @testset "Indented docstring" begin
        unformatted = """
        begin
            \"""
            Indented docstring

            with multiple paragraphs
            \"""
            indented_item
        end"""
        formatted = """
        begin
            \"""
            Indented docstring

            with multiple paragraphs
            \"""
            indented_item
        end"""
        test_format(unformatted, formatted; format_docstrings = true)

        short = """
        begin
            "Short docstring"
            item
        end
        """
        short_formatted = """
        begin
            \"""
            Short docstring
            \"""
            item
        end
        """
        test_format(short, short_formatted; format_docstrings = true)
    end

    @testset "597 printing to stdout" begin
        str_ = """
        \"""
        ```julia
        julia>  foo()
        hello world
        ```
        \"""
        foo() = println("hello world")
        """

        str = """
        \"""
        ```julia
        julia> foo()
        hello world
        ```
        \"""
        foo() = println("hello world")
        """
        test_format(str_, str; format_docstrings = true)

        s = """
        \"\"\"
        ```jldoctest
        foo()

        # output

        1-element Vector{Int64}:
         1
        ```
        \"\"\"
        foo() = [1]
        """
        test_format(str, str; format_docstrings = true)
    end

    @testset "812 empty jldoctest" begin
        s = """
        \"""
        ```jldoctest foo
        ```
        \"""
        function foo end
        """
        test_format(s, s; format_docstrings=true)
    end

    @testset "812 triple quotes in jldoctest" begin
        s = """
        \"""
        ```jldoctest
        \\\"""
        ```
        \"""
        f() = 1
        """
        test_format(s, s; format_docstrings=true)
    end

    @testset "1206 doesn't attempt to format invalid code" begin
        for prefix in ("julia", "{julia}", "@example")
            str = """
            \"""
                foo(a::MySpecialArg)

            Do foo to a special arg. Example:

            ```$(prefix)
            a = MySpecialArg(...) # set up your arg
            foo(a)
            ```
            \"""
            foo(a::MySpecialArg) = a
            """
            test_format(str, str; format_docstrings = true)
        end
    end

    @testset "1223 comments not duplicated into docstrings" begin
        # Single code block
        str = """
        \"""
        a
        ```julia
        b
        ```
        \"""
        function f end
        # comment
        f() = 1
        """
        expected = """
        \"""
        a

        ```julia
        b
        ```
        \"""
        function f end
        # comment
        f() = 1
        """
        test_format(str, expected; format_docstrings = true)

        # Two code blocks
        str = """
        \"""
        a
        ```julia
        b
        ```
        foo
        ```julia
        c
        ```
        \"""
        function f end
        # comment
        f() = 1
        """
        expected = """
        \"""
        a

        ```julia
        b
        ```

        foo

        ```julia
        c
        ```
        \"""
        function f end
        # comment
        f() = 1
        """
        for style in ALL_STYLES
            test_format(str, expected, style; format_docstrings = true)
        end
    end

    @testset "1224 escape sequences" begin
        for escaped_julia_code in (
            raw"@macro a.\$s",
            raw"A \\ b",
            "A = \\\"hello\\\"",
        )
            s = """
            \"""
            ```julia
            $(escaped_julia_code)
            ```
            \"""
            f
            """
            for style in ALL_STYLES
                test_format(s, s, style; format_docstrings=true)
            end
        end

        @testset "normalisation of triple quotes" begin
            # Regardless of how the user has escaped their triple quotes inside docstrings,
            # we want to always normalise them to `\"""`
            s_ = """
            \"""
            ```julia
            s = \\\"\\\"\\\"hello\\\"\\\"\\\"
            ```
            \"""
            f
            """

            s = """
            \"""
            ```julia
            s = \\\"\"\"hello\\\"\"\"
            ```
            \"""
            f
            """
            for style in ALL_STYLES
                test_format(s_, s, style; format_docstrings=true)
                test_format(s, s, style; format_docstrings=true)
            end

            # However if the docstring is single quoted we need to normalise to `\"\"\"`
            # instead
            s = """
            \"```julia
            s = \\\"\\\"\\\"hello\\\"\\\"\\\"
            ```\"
            f
            """ 
            for style in ALL_STYLES
                test_format(s, s, style; format_docstrings=true, enforce_triplequoted_docstrings=false)
            end
        end
    end
end

end # module OptionsFormatDocstringsTests

function options(::BlueStyle)
    return Options(;
        always_use_return = true,
        short_to_long_function_def = true,
        long_to_short_function_def = false,
        whitespace_ops_in_indices = true,
        remove_extra_newlines = true,
        always_for_in = true,
        import_to_using = true,
        pipe_to_function_call = true,
        whitespace_in_kwargs = false,
        annotate_untyped_fields_with_any = false,
        conditional_to_if = true,
        indent_submodule = true,
        separate_kwargs_with_semicolon = true,
        indent = 4,
        margin = 92,
        whitespace_typedefs = false,
        format_docstrings = false,
        align_struct_field = false,
        align_assignment = false,
        align_conditional = false,
        align_pair_arrow = false,
        normalize_line_endings = "auto",
        align_matrix = false,
        join_lines_based_on_source = false,
        trailing_comma = true,
        trailing_zero = true,
        surround_whereop_typeparameters = true,
        variable_call_indent = [],
        yas_style_nesting = false,
    )
end

function is_binaryop_nestable(::BlueStyle, cst::JuliaSyntax.GreenNode)
    # TODO(penelopeysm): In theory, here we also need to include `x |> f` nodes which will
    # be converted to `f(x)` calls (since the latter would satisfy is_iterable). If we
    # don't, there are idempotence issues because on the second pass this will return true.
    # This is a massive pain to do though.
    # See https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/1175
    if is_assignment(cst) && haschildren(cst) && is_iterable(cst[end])
        return false
    end
    return is_binaryop_nestable(DefaultStyle(), cst)
end

function p_return(
    bs::BlueStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(bs)
    t = FST(Return, nspaces(s))
    if !haschildren(cst)
        return t
    end

    childs = children(cst)
    n_args = 0
    for c in childs
        if !JuliaSyntax.is_whitespace(c)
            n_args += 1
        end
    end

    if n_args > 1
        return p_return(DefaultStyle(bs), cst, s, ctx, lineage)
    end

    for c in childs
        add_node!(t, pretty(style, c, s, ctx, lineage), s; join_lines = true)
    end
    add_node!(t, Whitespace(1), s)
    no = FST(KEYWORD, -1, t.endline, t.endline, "nothing")
    add_node!(t, no, s; join_lines = true)
    t
end

function _ternary_to_ifelse!(
    # output_fst is mutated
    output_fst::FST,
    style::AbstractStyle,
    # cst must be a ternary operator with a ternary operator as its rhs
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
    # The outermost call emits "if" and appends "end"; recursive calls emit "elseif" and
    # produce a nested If sub-tree (mirroring JuliaSyntax's output).
    is_outermost::Bool,
    comment_nodes_from_parent::Vector{FST},
)
    question_mark_idx = findfirst(c -> kind(c) === K"?" && !haschildren(c), children(cst))
    colon_idx = findfirst(c -> kind(c) === K":" && !haschildren(c), children(cst))
    if question_mark_idx === nothing || colon_idx === nothing
        error(
            "expected a ternary operator with a question mark and a colon, but couldn't find one or both",
        )
    end

    # JuliaSyntax's CST places #= inline comments =# as top-level children of the `?` node.
    # We want to move them into the relevant blocks. To do that, we'll need to capture them
    # as we go along.
    comment_nodes = FST[]

    for (i, c) in enumerate(children(cst))
        if kind(c) === K"Comment"
            n = pretty(style, c, s, ctx, lineage)
            if n.typ === HASHEQCOMMENT
                push!(comment_nodes, n)
            else
                add_node!(output_fst, n, s)
            end
        elseif JuliaSyntax.is_whitespace(c)
            add_node!(output_fst, pretty(style, c, s, ctx, lineage), s)
        elseif kind(c) in KSet"? :" && !haschildren(c)
            s.offset += span(c)
        elseif i < question_mark_idx
            # Condition — emit "if" (outermost) or "elseif" (recursive).
            loc = cursor_loc(s)
            keyword = is_outermost ? "if" : "elseif"
            add_node!(
                output_fst,
                FST(KEYWORD, loc[2], loc[1], loc[1], keyword),
                s;
                max_padding = 0,
            )
            add_node!(output_fst, Whitespace(1), s)
            # If the condition begins with a line comment, we need to parenthesise it...
            # https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/1142
            if JuliaSyntax.is_leaf(c)
                add_node!(
                    output_fst,
                    pretty(style, c, s, ctx, lineage),
                    s;
                    join_lines = true,
                )
            else
                first_nonws_idx =
                    findfirst(cc -> !JuliaSyntax.is_whitespace(cc), children(c))
                # Note: this catches inline comments as well -- not just line comments, so
                # the parenthesisation is over-conservative, but it's just really annoying
                # to figure out whether a comment is inline or not, so this is a reasonable
                # compromise. (We can't reliably check for the presence of a newline after
                # the comment because that isn't unique to line comments.)
                node = if any(cc -> kind(cc) === K"Comment", children(c)[1:first_nonws_idx])
                    paren_fst = FST(Brackets, nspaces(s))
                    add_node!(
                        paren_fst,
                        FST(PUNCTUATION, loc[2], loc[1], loc[1], "("),
                        s;
                        join_lines = true,
                    )
                    add_node!(paren_fst, Placeholder(0), s)
                    add_node!(
                        paren_fst,
                        pretty(style, c, s, ctx, lineage),
                        s;
                        join_lines = true,
                    )
                    add_node!(paren_fst, Placeholder(0), s)
                    add_node!(
                        paren_fst,
                        FST(PUNCTUATION, loc[2], loc[1], loc[1], ")"),
                        s;
                        join_lines = true,
                    )
                    paren_fst
                else
                    pretty(style, c, s, ctx, lineage)
                end
                add_node!(output_fst, node, s; join_lines = true)
            end
        elseif i > question_mark_idx && i < colon_idx
            # True branch — wrap in a Block if not already one.
            s.indent += s.opts.indent
            if is_block(c, style)
                for n in [comment_nodes_from_parent..., comment_nodes...]
                    add_node!(output_fst, n, s)
                end
                comment_nodes = FST[]
                add_node!(
                    output_fst,
                    pretty(style, c, s, newctx(ctx; ignore_single_line = true), lineage),
                    s;
                    max_padding = s.opts.indent,
                )
            else
                block_fst = FST(Block, nspaces(s))
                for n in [comment_nodes_from_parent..., comment_nodes...]
                    add_node!(block_fst, n, s)
                end
                comment_nodes = FST[]
                add_node!(
                    block_fst,
                    pretty(style, c, s, newctx(ctx; ignore_single_line = true), lineage),
                    s;
                    max_padding = s.opts.indent,
                )
                add_node!(output_fst, block_fst, s; max_padding = s.opts.indent)
            end
            s.indent -= s.opts.indent
        elseif i > colon_idx
            # False branch.
            if kind(c) === K"?" && haschildren(c)
                # Chained ternary: build a nested If sub-tree for the elseif part, then add
                # it with the same max-len pattern that p_if uses for elseif subtrees.
                # 
                # TODO(penelopeysm): Why does p_if generate a nested tree anyway??
                inner_if = FST(If, nspaces(s))
                _ternary_to_ifelse!(
                    inner_if,
                    style,
                    c,
                    s,
                    ctx,
                    lineage,
                    false,
                    comment_nodes,
                )
                comment_nodes = FST[]
                len_before = length(output_fst)
                add_node!(output_fst, inner_if, s)
                output_fst.len = max(len_before, length(inner_if))
            else
                # Terminal else branch.
                loc = cursor_loc(s)
                add_node!(
                    output_fst,
                    FST(KEYWORD, loc[2], loc[1], loc[1], "else"),
                    s;
                    max_padding = 0,
                )
                s.indent += s.opts.indent
                if is_block(c, style)
                    for n in comment_nodes
                        add_node!(output_fst, n, s)
                    end
                    comment_nodes = FST[]
                    add_node!(
                        output_fst,
                        pretty(
                            style,
                            c,
                            s,
                            newctx(ctx; ignore_single_line = true),
                            lineage,
                        ),
                        s;
                        max_padding = s.opts.indent,
                    )
                else
                    block_fst = FST(Block, nspaces(s))
                    for n in comment_nodes
                        add_node!(block_fst, n, s)
                    end
                    comment_nodes = FST[]
                    add_node!(
                        block_fst,
                        pretty(
                            style,
                            c,
                            s,
                            newctx(ctx; ignore_single_line = true),
                            lineage,
                        ),
                        s;
                        max_padding = s.opts.indent,
                    )
                    add_node!(output_fst, block_fst, s; max_padding = s.opts.indent)
                end
                s.indent -= s.opts.indent
            end
        end
    end

    # Only the outermost call appends "end" — inner elseif sub-trees don't have their own
    # "end", matching the structure that p_if produces from real if/elseif/else source.
    if is_outermost
        loc = cursor_loc(s)
        add_node!(output_fst, FST(KEYWORD, loc[2], loc[1], loc[1], "end"), s)
    end

    return nothing
end

# Overload so that chained ternaries are always converted to if/elseif/else, regardless of
# the `conditional_to_if` option.
function p_conditionalopcall(
    bs::BlueStyle,
    cst::JuliaSyntax.GreenNode,
    s::State,
    ctx::PrettyContext,
    lineage::Vector{Tuple{JuliaSyntax.Kind,Bool,Bool}},
)
    style = getstyle(bs)
    if !haschildren(cst)
        return FST(Conditional, nspaces(s))
    end

    return if is_chained_ternary(cst)
        output_fst = FST(If, nspaces(s))
        _ternary_to_ifelse!(output_fst, style, cst, s, ctx, lineage, true, FST[])
        output_fst
    else
        p_conditionalopcall(DefaultStyle(bs), cst, s, ctx, lineage)
    end
end

module YasStyleTests

using JuliaFormatter.Internal: test_format
using Test
using JuliaFormatter: YASStyle
using JuliaFormatter: format_text

@testset "YAS Style" begin
    @testset "basic" begin
        str_ = "foo(; k =v)"
        str = "foo(; k=v)"
        test_format(str_, str, YASStyle(); indent=4, margin=80)

        str_ = "[a,]"
        str = "[a]"
        test_format(str_, str, YASStyle(); indent=4, margin=92)

        str_ = "T[a,]"
        str = "T[a]"
        test_format(str_, str, YASStyle(); indent=4, margin=92)

        str_ = "{a,}"
        str = "{a}"
        test_format(str_, str, YASStyle(); indent=4, margin=92)

        str_ = "T{a,}"
        str = "T{a}"
        test_format(str_, str, YASStyle(); indent=4, margin=92)

        str_ = "T(a,)"
        str = "T(a)"
        test_format(str_, str, YASStyle(); indent=4, margin=92)

        str_ = "(a,)"
        str = "(a,)"
        test_format(str_, str, YASStyle(); indent=4, margin=92)

        str_ = "@foo(a,)"
        str = "@foo(a,)"
        test_format(str_, str, YASStyle(); indent=4, margin=92)

        str_ = "a = (arg1, arg2, arg3)"
        str = """
        a = (arg1, arg2,
             arg3)"""
        test_format(str_, str, YASStyle(); indent=4, margin=length(str_) - 1)
        test_format(str_, str, YASStyle(); indent=4, margin=16)

        str = """
        a = (arg1,
             arg2,
             arg3)"""
        test_format(str_, str, YASStyle(); indent=4, margin=15)
        test_format(str_, str, YASStyle(); indent=4, margin=1)

        str_ = "a = [arg1, arg2, arg3]"
        str = """
        a = [arg1, arg2,
             arg3]"""
        test_format(str_, str, YASStyle(); indent=4, margin=length(str_) - 1)
        test_format(str_, str, YASStyle(); indent=4, margin=16)

        str = """
        a = [arg1,
             arg2,
             arg3]"""
        test_format(str_, str, YASStyle(); indent=4, margin=15)
        test_format(str_, str, YASStyle(); indent=4, margin=1)

        str_ = "a = {arg1,arg2,arg3}"
        str = """
        a = {arg1, arg2, arg3}"""
        test_format(str_, str, YASStyle(); indent=4, margin=22)

        str = """
        a = {arg1, arg2,
             arg3}"""
        test_format(str_, str, YASStyle(); indent=4, margin=21)
        test_format(str_, str, YASStyle(); indent=4, margin=16)

        str = """
        a = {arg1,
             arg2,
             arg3}"""
        test_format(str_, str, YASStyle(); indent=4, margin=15)
        test_format(str_, str, YASStyle(); indent=4, margin=1)

        str_ = "a = Union{arg1, arg2, arg3}"
        str = """
        a = Union{arg1,arg2,arg3}"""
        test_format(str_, str, YASStyle(); indent=4, margin=25)

        str = """
        a = Union{arg1,arg2,
                  arg3}"""
        test_format(str_, str, YASStyle(); indent=4, margin=24)
        test_format(str_, str, YASStyle(); indent=4, margin=20)

        str = """
        a = Union{arg1,
                  arg2,
                  arg3}"""
        test_format(str_, str, YASStyle(); indent=4, margin=19)
        test_format(str_, str, YASStyle(); indent=4, margin=1)

        str_ = "a = fcall(arg1,arg2,arg3)"
        str = """
        a = fcall(arg1, arg2, arg3)"""
        test_format(str_, str, YASStyle(); indent=4, margin=length(str))

        str = """
        a = fcall(arg1, arg2,
                  arg3)"""
        test_format(str_, str, YASStyle(); indent=4, margin=26)
        test_format(str_, str, YASStyle(); indent=4, margin=21)

        str = """
        a = fcall(arg1,
                  arg2,
                  arg3)"""
        test_format(str_, str, YASStyle(); indent=4, margin=20)
        test_format(str_, str, YASStyle(); indent=4, margin=1)

        str_ = "a = @call(arg1,arg2,arg3)"
        str = """
        a = @call(arg1, arg2, arg3)"""
        test_format(str_, str, YASStyle(); indent=4, margin=length(str))

        str = """
        a = @call(arg1, arg2,
                  arg3)"""
        test_format(str_, str, YASStyle(); indent=4, margin=26)
        test_format(str_, str, YASStyle(); indent=4, margin=21)

        str = """
        a = @call(arg1,
                  arg2,
                  arg3)"""
        test_format(str_, str, YASStyle(); indent=4, margin=20)
        test_format(str_, str, YASStyle(); indent=4, margin=1)

        str_ = "a = array[arg1,arg2,arg3]"
        str = """
        a = array[arg1, arg2, arg3]"""
        test_format(str_, str, YASStyle(); indent=4, margin=length(str))

        str = """
        a = array[arg1, arg2,
                  arg3]"""
        test_format(str_, str, YASStyle(); indent=4, margin=26)
        test_format(str_, str, YASStyle(); indent=4, margin=21)

        str = """
        a = array[arg1,
                  arg2,
                  arg3]"""
        test_format(str_, str, YASStyle(); indent=4, margin=20)
        test_format(str_, str, YASStyle(); indent=4, margin=1)

        str_ = """
        using Cassette: A, B, C"""
        str = """
        using Cassette: A,
                        B,
                        C"""
        test_format(str_, str, YASStyle(); indent=4, margin=1)
    end

    # more complicated samples
    @testset "pretty" begin
        str_ = "comp = [a * b for a in 1:10, b in 11:20]"
        str = """
        comp = [a * b
                for a in 1:10, b in 11:20]"""
        test_format(str_, str, YASStyle(); indent=2, margin=length(str_) - 1, always_for_in = true)
        test_format(str_, str, YASStyle(); indent=2, margin=34, always_for_in = true)

        str = """
        comp = [a * b
                for a in 1:10,
                    b in 11:20]"""
        test_format(str_, str, YASStyle(); indent=2, margin=33, always_for_in = true)

        str = """
        comp = [a *
                b
                for a in
                    1:10,
                    b in
                    11:20]"""
        test_format(str_, str, YASStyle(); indent=2, margin=1, always_for_in = true)

        str_ = "comp = Typed[a * b for a in 1:10, b in 11:20]"
        str = """
        comp = Typed[a * b
                     for a in 1:10, b in 11:20]"""
        test_format(str_, str, YASStyle(); indent=2, margin=length(str_) - 1, always_for_in = true)
        test_format(str_, str, YASStyle(); indent=2, margin=39, always_for_in = true)

        str = """
        comp = Typed[a * b
                     for a in 1:10,
                         b in 11:20]"""
        test_format(str_, str, YASStyle(); indent=2, margin=38, always_for_in = true)

        str = """
        comp = Typed[a *
                     b
                     for a in
                         1:10,
                         b in
                         11:20]"""
        test_format(str_, str, YASStyle(); indent=2, margin=1, always_for_in = true)

        str_ = "foo(arg1, arg2, arg3) == bar(arg1, arg2, arg3)"
        str = """
        foo(arg1, arg2, arg3) ==
        bar(arg1, arg2, arg3)"""
        # change in default behavior
        test_format(str, str_, YASStyle(); indent=2, margin=length(str_), join_lines_based_on_source = false)
        test_format(str_, str, YASStyle(); indent=2, margin=length(str_) - 1)
        test_format(str_, str, YASStyle(); indent=2, margin=24)

        str = """
        foo(arg1, arg2,
            arg3) ==
        bar(arg1, arg2, arg3)"""
        test_format(str_, str, YASStyle(); indent=2, margin=23)
        test_format(str_, str, YASStyle(); indent=2, margin=21)

        str = """
        foo(arg1, arg2,
            arg3) ==
        bar(arg1, arg2,
            arg3)"""
        test_format(str_, str, YASStyle(); indent=2, margin=20)
        test_format(str_, str, YASStyle(); indent=2, margin=15)

        str = """
        foo(arg1,
            arg2,
            arg3) ==
        bar(arg1,
            arg2,
            arg3)"""
        test_format(str_, str, YASStyle(); indent=2, margin=14)
        test_format(str_, str, YASStyle(); indent=2, margin=1)

        str_ = """
        function func(arg1::Type1, arg2::Type2, arg3) where {Type1,Type2}
          body
        end"""
        str = """
        function func(arg1::Type1, arg2::Type2,
                      arg3) where {Type1,Type2}
          return body
        end"""
        test_format(str_, str, YASStyle(); indent=2, margin=64)
        test_format(str_, str, YASStyle(); indent=2, margin=39)

        str = """
        function func(arg1::Type1,
                      arg2::Type2,
                      arg3) where {Type1,
                                   Type2}
          return body
        end"""
        test_format(str_, str, YASStyle(); indent=2, margin=31)
        test_format(str_, str, YASStyle(); indent=2, margin=1)

        str_ = """
        @test TimeSpan(spike_annotation) == TimeSpan(first(spike_annotation), last(spike_annotation))"""
        str = """
        @test TimeSpan(spike_annotation) ==
              TimeSpan(first(spike_annotation), last(spike_annotation))"""
        test_format(str_, str, YASStyle(); indent=4, margin=length(str_) - 1)
        test_format(str_, str, YASStyle(); indent=4, margin=63)
        str_ = """
        @test TimeSpan(spike_annotation) == TimeSpan(first(spike_annotation), last(spike_annotation))"""
        str = """
        @test TimeSpan(spike_annotation) ==
              TimeSpan(first(spike_annotation),
                       last(spike_annotation))"""
        test_format(str_, str, YASStyle(); indent=4, margin=62)

        str_ =
            raw"""ecg_signal = signal_from_template(eeg_signal; channel_names=[:avl, :avr], file_extension=Symbol("lpcm.zst"))"""
        str = raw"""
        ecg_signal = signal_from_template(eeg_signal; channel_names=[:avl, :avr],
                                          file_extension=Symbol("lpcm.zst"))"""
        test_format(str_, str, YASStyle(); indent=4, margin=length(str_) - 1)
        test_format(str_, str, YASStyle(); indent=4, margin=75)

        str = raw"""
        ecg_signal = signal_from_template(eeg_signal;
                                          channel_names=[:avl, :avr],
                                          file_extension=Symbol("lpcm.zst"))"""
        test_format(str_, str, YASStyle(); indent=4, margin=71)
        str = raw"""
        ecg_signal = signal_from_template(eeg_signal;
                                          channel_names=[:avl,
                                                         :avr],
                                          file_extension=Symbol("lpcm.zst"))"""
        test_format(str_, str, YASStyle(); indent=4, margin=1)
    end

    @testset "inline comments with arguments" begin
        str_ = """
        var = fcall(arg1,
            arg2, arg3, # comment
                            arg4, arg5)"""
        str = """
        var = fcall(arg1, arg2, arg3, # comment
                    arg4, arg5)"""
        test_format(str_, str, YASStyle(); indent=4, margin=80, join_lines_based_on_source = false)
        test_format(str_, str, YASStyle(); indent=4, margin=29, join_lines_based_on_source = false)

        str = """
        var = fcall(arg1, arg2,
                    arg3, # comment
                    arg4, arg5)"""
        test_format(str_, str, YASStyle(); indent=4, margin=28, join_lines_based_on_source = false)
        test_format(str_, str, YASStyle(); indent=4, margin=23, join_lines_based_on_source = false)

        str = """
        var = fcall(arg1,
                    arg2,
                    arg3, # comment
                    arg4,
                    arg5)"""
        test_format(str_, str, YASStyle(); indent=4, margin=22)
        test_format(str_, str, YASStyle(); indent=4, margin=1)

        str_ = """
        comp = [
        begin
                    x = a * b + c
                    y = x^2 + 3x # comment 1
            end
                       for a in 1:10,  # comment 2
                    b in 11:20,
           c in 300:400]"""

        str = """
        comp = [begin
                  x = a * b + c
                  y = x^2 + 3x # comment 1
                end
                for a in 1:10,  # comment 2
                    b in 11:20, c in 300:400]"""
        test_format(str_, str, YASStyle(); indent=2, margin=80, join_lines_based_on_source = false)
        test_format(str_, str, YASStyle(); indent=2, margin=38, join_lines_based_on_source = false)

        str = """
        comp = [begin
                  x = a * b + c
                  y = x^2 + 3x # comment 1
                end
                for a in 1:10,  # comment 2
                    b in 11:20,
                    c in 300:400]"""
        test_format(str_, str, YASStyle(); indent=2, margin=36)

        str_ = """
        ys = ( if p1(x)
                 f1(x)
        elseif p2(x)
            f2(x)
        else
            f3(x)
        end for    x in xs)
        """
        str = """
        ys = (if p1(x)
                f1(x)
              elseif p2(x)
                f2(x)
              else
                f3(x)
              end
              for x in xs)
        """
        test_format(str_, str, YASStyle(); indent=2, margin=80)

        str_ = """spike_annotation = first(ann for ann in recording.annotations if ann.value == "epileptiform_spike")"""
        str = """
        spike_annotation = first(ann
                                 for ann in recording.annotations
                                 if ann.value == "epileptiform_spike")"""
        test_format(str_, str, YASStyle(); indent=2, margin=80)

        # only that
        str_ = "foo(a, b) = (arg1, arg2, arg3)"
        str = """
        foo(a, b) = (arg1, arg2,
                     arg3)"""
        test_format(str_, str, YASStyle(); indent=2, margin=length(str_) - 1, short_to_long_function_def=false)

        str = """
        foo(a, b) = (arg1,
                     arg2,
                     arg3)"""
        test_format(str_, str, YASStyle(); indent=2, margin=1, short_to_long_function_def=false)

        str_ = """
        fooooooooooooooooooo(arg1, arg2,
        x -> begin
        body
        end
        )"""
        str = """
        fooooooooooooooooooo(arg1, arg2,
                             x -> begin
                                 body
                             end)"""
        test_format(str_, str, YASStyle(); indent=4, margin=32)

        # parsing error is newline is placed front of `for` here
        str_ = "var = ((x, y) for x = 1:10, y = 1:10)"
        str = """
        var = ((x, y) for x in 1:10,
                          y in 1:10)"""
        test_format(str_, str, YASStyle(); indent=4, margin=length(str_) - 1)
    end

    @testset "parens" begin
        str_ = """
        if ((
          aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa ||
          aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa ||
          aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa
        ))
          nothing
        end"""
        str = """
        if ((aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa ||
             aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa ||
             aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa))
          nothing
        end"""
        test_format(str_, str, YASStyle(); indent=2, margin=92)
    end

    @testset "issue 189" begin
        str_ = """
    D2 = [
            (b_hat * y - delta_hat[i] * y) * gamma[i] + (b * y_hat - delta[i] * y_hat) *
                                                            gamma_hat[i] + (b_hat - y_hat) *
                                                                           delta[i] + (b - y) *
                                                                                      delta_hat[i] - delta[i] * delta_hat[i]
            for i = 1:8
        ]"""
        str = """
        D2 = [(b_hat * y - delta_hat[i] * y) * gamma[i] +
              (b * y_hat - delta[i] * y_hat) * gamma_hat[i] +
              (b_hat - y_hat) * delta[i] +
              (b - y) * delta_hat[i] - delta[i] * delta_hat[i]
              for i in 1:8]"""
        test_format(str_, str, YASStyle(); indent=2, margin=60, join_lines_based_on_source = false)
    end

    @testset "issue 237" begin
        str_ = """
        for x in (arg1, arg2,)
            @info "Test"
        end"""
        str = """
        for x in (arg1, arg2)
            @info "Test"
        end"""
        test_format(str_, str, YASStyle(); indent=4, margin=92)
    end

    @testset "issue 320" begin
        str_ = "[x[i] for i = 1:length(x)]"
        str = "[x[i] for i in 1:length(x)]"
        test_format(str_, str, YASStyle(); indent=4, margin=92, always_for_in = true)
    end

    @testset "issue 321 - exponential inline comments !!!" begin
        str = """
        scaled_ticks, mini, maxi = optimize_ticks(scale_func(lmin), scale_func(lmax); k_min=4, # minimum number of ticks
                                                  k_max=8)"""
        test_format(str, str, YASStyle(); indent=4, margin=92, whitespace_in_kwargs = false)
    end

    @testset "issue 355 - vcat/typedvcat" begin
        str = """
        mpoly_rules = T[@rule(~x::ismpoly - ~y::ismpoly => ~x + -1 * (~y))
                        @rule(-(~x) => -1 * ~x)
                        @acrule(~x::ismpoly + ~y::ismpoly => ~x + ~y)
                        @rule(+(~x) => ~x)
                        @acrule(~x::ismpoly * ~y::ismpoly => ~x * ~y)
                        @rule(*(~x) => ~x)
                        @rule((~x::ismpoly)^(~a::isnonnegint) => (~x)^(~a))]"""
        test_format(str, str, YASStyle())

        str = """
        mpoly_rules = [@rule(~x::ismpoly - ~y::ismpoly => ~x + -1 * (~y))
                       @rule(-(~x) => -1 * ~x)
                       @acrule(~x::ismpoly + ~y::ismpoly => ~x + ~y)
                       @rule(+(~x) => ~x)
                       @acrule(~x::ismpoly * ~y::ismpoly => ~x * ~y)
                       @rule(*(~x) => ~x)
                       @rule((~x::ismpoly)^(~a::isnonnegint) => (~x)^(~a))]"""
        test_format(str, str, YASStyle())

        str_ = """
        [10 20; 30 40; 50 60;
         10
         10]"""
        test_format(str_, str_, YASStyle(); indent=4, margin=21)

        str = """
        [10 20; 30 40;
         50 60;
         10
         10]"""
        test_format(str_, str, YASStyle(); indent=4, margin=20)
        test_format(str_, str, YASStyle(); indent=4, margin=14)

        str = """
        [10 20;
         30 40;
         50 60;
         10
         10]"""
        test_format(str_, str, YASStyle(); indent=4, margin=13)

        str_ = """
        T[10 20; 30 40; 50 60;
          10
          10]"""
        test_format(str_, str_, YASStyle(); indent=4, margin=22)

        str = """
        T[10 20; 30 40;
          50 60;
          10
          10]"""
        test_format(str_, str, YASStyle(); indent=4, margin=21)
        test_format(str_, str, YASStyle(); indent=4, margin=15)

        str = """
        T[10 20;
          30 40;
          50 60;
          10
          10]"""
        test_format(str_, str, YASStyle(); indent=4, margin=14)

        str = "(T[10 20; 30 40; 50 60;])"
        test_format(str, str, YASStyle(); indent=4, margin=25)
        str = "(T[10 20; 30 40; 50 60])"
        test_format(str, str, YASStyle(); indent=4, margin=24)

        str_ = """
        (T[10 20; 30 40;
           50 60])"""
        test_format(str, str_, YASStyle(); indent=4, margin=23)
    end

    @testset "imports no placeholder, no error" begin
        str = "import A"
        test_format(str, "using A: A", YASStyle())

        str = "export A"
        test_format(str, str, YASStyle())

        str = "using A"
        test_format(str, str, YASStyle())
    end

    @testset "blank lines inside iterables" begin
        # YAS always glues the closing bracket to the last argument (its `p_vect` and
        # friends pass `override_join_lines_based_on_source = true` for the closer). A
        # blank line before the closer used to defeat that override and strand it on its
        # own line, e.g. `[a,\n b\n ]`.
        @testset "$opener … $closer" for (opener, closer, expected) in (
            ("[", "]", "[a,\n b]"),
            ("(", ")", "(a,\n b)"),
            ("f(", ")", "f(a,\n  b)"),
            ("T{", "}", "T{a,\n  b}"),
            ("x[", "]", "x[a,\n  b]"),
            ("{", "}", "{a,\n b}"),
        )
            str_ = """
            $opener
                a,
                b,

            $closer"""
            test_format(str_, expected, YASStyle())

            str_ = """
            $opener
                a,

                b,
            $closer"""
            test_format(str_, expected, YASStyle())
        end
    end

    @testset "issue 582 - vcat" begin
        test_format("[sts...;]", "[sts...;]", YASStyle())
        test_format("[a;b;]", "[a; b;]", YASStyle())
        test_format("[a;b;;]", "[a; b;;]", YASStyle())
    end

    @testset "variable_call_indent" begin
        str = raw"""
        Dict{Int,Int}(1 => 2,
                      3 => 4)
        """

        # This should be valid with and without `Dict` in `variable_call_indent`
        test_format(str, str, YASStyle())
        test_format(str, str, YASStyle(); variable_call_indent = ["Dict"])

        str = raw"""
        SVector(1.0,
                2.0)
        """
        test_format(str, str, YASStyle())
        test_format(str, str, YASStyle(); variable_call_indent = ["SVector", "test2"])
        test_format(str, str, YASStyle(); variable_call_indent = ["Dict"])

        str = raw"""
        Dict{Int,Int}(
        1 => 2,
                3 => 4)
        """
        formatted_str1 = raw"""
        Dict{Int,Int}(1 => 2,
                      3 => 4)
        """
        formatted_str2 = raw"""
        Dict{Int,Int}(
            1 => 2,
            3 => 4)
        """
        # `variable_call_indent` keeps the line break and doesn't align
        test_format(str, formatted_str1, YASStyle())
        test_format(str, formatted_str2, YASStyle(); variable_call_indent = ["Dict"])

        str = raw"""
        SVector(
        1.0,
                2.0)
        """
        formatted_str1 = raw"""
        SVector(1.0,
                2.0)
        """
        formatted_str2 = raw"""
        SVector(
            1.0,
            2.0)
        """
        test_format(str, formatted_str1, YASStyle(); variable_call_indent = ["Dict"])
        test_format(str, formatted_str2, YASStyle(); variable_call_indent = ["test", "SVector"])

        str = raw"""
        Dict{Int,Int}(
            1 => 2,
            3 => 4,
        )
        """
        formatted_str = raw"""
        Dict{Int,Int}(1 => 2,
                      3 => 4)
        """
        test_format(str, formatted_str, YASStyle())
        test_format(str, str, YASStyle(); variable_call_indent = ["Dict"])

        str = raw"""
        SomeLongerTypeThanJustString = String
        y = Dict{Int,SomeLongerTypeThanJustString}(1 => "some arbitrary string bla bla bla bla bla bla",
            2 => "another longer arbitrary string bla bla bla bla bla bla bla bla")
        """

        formatted_str1 = raw"""
        SomeLongerTypeThanJustString = String
        y = Dict{Int,SomeLongerTypeThanJustString}(1 => "some arbitrary string bla bla bla bla bla bla",
                                                   2 => "another longer arbitrary string bla bla bla bla bla bla bla bla")
        """

        formatted_str2 = raw"""
        SomeLongerTypeThanJustString = String
        y = Dict{Int,SomeLongerTypeThanJustString}(
            1 => "some arbitrary string bla bla bla bla bla bla",
            2 => "another longer arbitrary string bla bla bla bla bla bla bla bla",
        )
        """

        # Here, `variable_call_indent` forces the line break because the line is too long.
        # For some reason, this has to be formatted twice.
        # (TODO penelopeysm -- isn't this an idempotence bug?)
        @test_broken false
        @test format_text(str, YASStyle()) == formatted_str1
        intermediate_str = format_text(str, YASStyle(); variable_call_indent = ["Dict"])
        @test format_text(intermediate_str, YASStyle(); variable_call_indent = ["Dict"]) ==
              formatted_str2

        str = raw"""
        Dict{Int,Int}(
                      # Comment
                      1 => 2,
                      3 => 4)
        """
        formatted_str = raw"""
        Dict{Int,Int}(
            # Comment
            1 => 2,
            3 => 4)
        """
        # Test `variable_call_indent` with a comment in a separate line
        test_format(str, str, YASStyle())
        test_format(str, formatted_str, YASStyle(); variable_call_indent = ["Dict"])

        str = raw"""
        SVector(
                # Comment
                1.0,
                2.0)
        """
        formatted_str = raw"""
        SVector(
            # Comment
            1.0,
            2.0)
        """
        # Test the same with different callers
        test_format(str, str, YASStyle())
        test_format(str, formatted_str, YASStyle(); variable_call_indent = ["SVector"])

        str = raw"""
        Dict{Int,Int}(# Comment
                    1 => 2,
                    3 => 4)
        """
        formatted_str1 = raw"""
        Dict{Int,Int}(# Comment
                      1 => 2,
                      3 => 4)
        """
        formatted_str2 = raw"""
        Dict{Int,Int}(# Comment
            1 => 2,
            3 => 4)
        """
        # Test `variable_call_indent` with an inline comment after the opening parenthesis
        test_format(str, formatted_str1, YASStyle())
        test_format(str, formatted_str2, YASStyle(); variable_call_indent = ["Dict"])

        str = raw"""
        Dict{Int,Int}( # Comment
                # Comment
                1 => 2,
                # Another comment
                3 => 4)
        """
        formatted_str1 = raw"""
        Dict{Int,Int}( # Comment
                      # Comment
                      1 => 2,
                      # Another comment
                      3 => 4)
        """
        formatted_str2 = raw"""
        Dict{Int,Int}( # Comment
            # Comment
            1 => 2,
            # Another comment
            3 => 4)
        """
        # Test `variable_call_indent` with both an inline comment after the opening parenthesis
        # and a comment in a separate line.
        test_format(str, formatted_str1, YASStyle())
        test_format(str, formatted_str2, YASStyle(); variable_call_indent = ["Dict"])

        str = raw"""
        SVector( # Comment
                    # Comment
                    1.0,
                    # Another comment
                    2.0)
        """
        formatted_str1 = raw"""
        SVector( # Comment
                # Comment
                1.0,
                # Another comment
                2.0)
        """
        formatted_str2 = raw"""
        SVector( # Comment
            # Comment
            1.0,
            # Another comment
            2.0)
        """
        # Test the same with different callers
        test_format(str, formatted_str1, YASStyle(); variable_call_indent = ["test"])
        test_format(str, formatted_str2, YASStyle(); variable_call_indent = ["SVector", "test"])
    end

    @testset "indentation of binary ops" begin
        s1 = """
        begin
            @test aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa == ["theta[1]",
                                                           "theta[2]",
                                                           "theta[3]",
                                                           "theta[4]",
                                                           "tau"]
        end"""
        # different margins have different code paths so test both
        for margin in (80, 2000)
            test_format(s1, s1, YASStyle(); margin=margin)
        end

        s2 = """
        begin
            @test ccc => function ()
                return f() do x
                    return aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaa
                end
            end
        end"""
        for margin in (80, 2000)
            test_format(s2, s2, YASStyle(); margin=margin)
        end
    end

    @testset "realignment of RHS after un-nesting a binary op" begin
        s_ = """
        for x in @mac [aaaaa, bbbbb, ccccc]
            foo
        end"""
        s = """
        for x in @mac [aaaaa, bbbbb,
                       ccccc]
            foo
        end"""
        test_format(s_, s, YASStyle(); margin=30)

        s_ = """
        for x in @mac f(aaaaa, bbbbb, ccccc)
            foo
        end"""
        s = """
        for x in @mac f(aaaaa, bbbbb,
                        ccccc)
            foo
        end"""
        test_format(s_, s, YASStyle(); margin=31)

        s_ = """
        ccc => @mac function ()
            return aaa
        end"""
        s = """
        ccc => @mac function ()
            return aaa
        end"""
        test_format(s_, s, YASStyle(); margin=24)

        s_ = """
        for x in yyy::Foo(aaaaa, bbbbb, ccccc)
            foo
        end"""
        s = """
        for x in yyy::Foo(aaaaa, bbbbb,
                          ccccc)

            foo
        end"""
        test_format(s_, s, YASStyle(); margin=33)

        s_ = """
        for x in @mac aaaa = [bbbbbb, cccccc, dddddd]
            foo
        end"""
        s = """
        for x in @mac aaaa = [bbbbbb, cccccc,
                              dddddd]
            foo
        end"""
        test_format(s_, s, YASStyle(); margin=39)

        s_ = """
        for x in !(aaaa == 1 && (bbbb(cc) || dddd))
            foo
        end"""
        s = """
        for x in !(aaaa == 1 &&
                   (bbbb(cc) || dddd))
            foo
        end"""
        test_format(s_, s, YASStyle(); margin=24)

        s_ = """
        for x in Foo{A} where {Aa<:Xx, Bb<:Yy, Cc<:Zz}
            foo
        end"""
        s = """
        for x in Foo{A} where {Aa<:Xx,Bb<:Yy,
                               Cc<:Zz}

            foo
        end"""
        test_format(s_, s, YASStyle(); margin=38)
    end
end

end

#! format: off
@setup_workload begin
    dir = joinpath(@__DIR__,"..", "..")
    str = raw"""
       @noinline require_complete(m::Matching) =
           m.inv_match === nothing && throw(ArgumentError("Backwards matching not defined. `complete` the matching first."))
    """
    sandbox_dir = joinpath(tempdir(), join(rand('a':'z', 40)))
    mkdir(sandbox_dir)
    cp(dir, sandbox_dir; force = true)

    @compile_workload begin
        format(dir)
        for style = [DefaultStyle(), BlueStyle(), SciMLStyle(), YASStyle(), MinimalStyle()]
          format_text(str, style)
        end
    end
end

module TransformSyntaxInMacrosTests

using JuliaFormatter.Internal: test_format
using Test

@testset "transform_syntax_in_macros" begin
    # For each syntax transformation that respects transform_syntax_in_macros, we test:
    # 1. The transformation does NOT fire inside a macro by default
    # 2. The transformation DOES fire inside a macro when transform_syntax_in_macros=true

    @testset "always_use_return" begin
        s = """
        @macro function foo()
            1
        end"""
        s_transformed = """
        @macro function foo()
            return 1
        end"""
        test_format(s, s; always_use_return=true)
        test_format(
            s,
            s_transformed;
            always_use_return=true,
            transform_syntax_in_macros=true,
        )
    end

    @testset "annotate_untyped_fields_with_any" begin
        s = """
        @macro struct Foo
            x
        end"""
        s_transformed = """
        @macro struct Foo
            x::Any
        end"""
        test_format(s, s; annotate_untyped_fields_with_any=true)
        test_format(
            s,
            s_transformed;
            annotate_untyped_fields_with_any=true,
            transform_syntax_in_macros=true,
        )
    end

    @testset "import_to_using" begin
        s = "@eval import Foo"
        s_transformed = "@eval using Foo: Foo"
        test_format(s, s; import_to_using=true)
        test_format(
            s,
            s_transformed;
            import_to_using=true,
            transform_syntax_in_macros=true,
        )
    end

    @testset "long_to_short_function_def" begin
        s = """
        @macro function foo()
            return 1
        end"""
        s_transformed = """
        @macro foo() = 1"""
        test_format(s, s; long_to_short_function_def=true)
        test_format(
            s,
            s_transformed;
            long_to_short_function_def=true,
            transform_syntax_in_macros=true,
        )
    end

    @testset "short_circuit_to_if" begin
        s = """
        @foo function f()
            a && b
            return c
        end"""
        s_transformed = """
        @foo function f()
            if a
                b
            end
            return c
        end"""
        test_format(s, s; short_circuit_to_if=true)
        test_format(
            s,
            s_transformed;
            short_circuit_to_if=true,
            transform_syntax_in_macros=true,
        )
    end

    # @testset "short_to_long_function_def" begin
    #     s = """
    #     @macro foo() = 1"""
    #     s_transformed = """
    #     @macro function foo()
    #         1
    #     end"""
    #     test_format(
    #         s,
    #         s;
    #         margin=length("@macro foo() = 1"),
    #         short_to_long_function_def=true,
    #     )
    #     test_format(
    #         s,
    #         s_transformed;
    #         margin=length("@macro foo() = 1") - 1,
    #         short_to_long_function_def=true,
    #         transform_syntax_in_macros=true,
    #     )
    # end

    # These transformations should NOT fire inside macros even with
    # transform_syntax_in_macros=true

    @testset "pipe_to_function_call still blocked" begin
        s = """
        @macro begin
            a |> b
        end"""
        test_format(s, s; pipe_to_function_call=true)
        test_format(
            s,
            s;
            pipe_to_function_call=true,
            transform_syntax_in_macros=true,
        )
    end

    @testset "separate_kwargs_with_semicolon still blocked" begin
        s = """
        @macro begin
            foo(a, b = 1)
        end"""
        test_format(s, s; separate_kwargs_with_semicolon=true)
        test_format(
            s,
            s;
            separate_kwargs_with_semicolon=true,
            transform_syntax_in_macros=true,
        )
    end

    # quote and :() are InsideExpr, so transforms should remain blocked
    # even with transform_syntax_in_macros=true

    @testset "quote blocks still blocked" begin
        s = """
        quote
            function foo()
                1
            end
        end"""
        test_format(s, s; always_use_return=true)
        test_format(
            s,
            s;
            always_use_return=true,
            transform_syntax_in_macros=true,
        )
    end

    @testset "interpolation expressions still blocked" begin
        s = """
        :(function foo()
            1
        end)"""
        test_format(s, s; always_use_return=true)
        test_format(
            s,
            s;
            always_use_return=true,
            transform_syntax_in_macros=true,
        )
    end
end

end # module

module ShortCircuitToIfTests

using JuliaFormatter.Internal: test_format, ALL_STYLES
using Test

@testset "short_circuit_to_if" begin
    s_ = """
        begin
        a && b
        2
        end
    """
    s = """
    begin
        if a
            b
        end
        2
    end
    """
    test_format(s_, s; margin=92, short_circuit_to_if = true)

    s_ = """
        begin
        a || b
        2
        end
    """
    s = """
    begin
        if !(a)
            b
        end
        2
    end
    """
    test_format(s_, s; margin=11, short_circuit_to_if = true)

    s = """
    begin
        if !(
            a
        )
            b
        end
        2
    end
    """
    test_format(s_, s; margin=10, short_circuit_to_if = true)

    # > 1
    s_ = """
        begin
        a && b && c && d
        2
        end
    """
    s = """
    begin
        if a && b && c
            d
        end
        2
    end
    """
    test_format(s_, s; margin=92, short_circuit_to_if = true)

    s_ = """
        begin
        a && b && c || d
        2
        end
    """
    s1 = """
    begin
        if !(a && b && c)
            d
        end
        2
    end
    """
    test_format(s_, s1; margin=21, short_circuit_to_if = true)

    s2 = """
    begin
        if !(
            a && b && c
        )
            d
        end
        2
    end
    """
    test_format(s_, s2; margin=20, short_circuit_to_if = true)

    s_ = """
        begin
        (a && b && c) || d
        2
        end
    """
    test_format(s_, s1; margin=21, short_circuit_to_if = true)
    test_format(s_, s2; margin=20, short_circuit_to_if = true)

    s_ = """
    function foo()
        a && (b || c || d)
        2
    end
    """
    s = """
    function foo()
        if a
            (b || c || d)
        end
        2
    end
    """
    test_format(s_, s; margin=92, short_circuit_to_if = true)

    s_ = """
    function foo(a)
        a || return "bar"

        "hello"
    end
    """
    s = """
    function foo(a)
        if !(a)
            return "bar"
        end

        "hello"
    end
    """
    test_format(s_, s; margin=92, short_circuit_to_if = true)

    s_ = """
    function foo(a, b)
        a || return "bar"

        "hello"

        b && return "ooo"
        2
    end
    """
    s = """
    function foo(a, b)
        if !(a)
            return "bar"
        end

        "hello"

        if b
            return "ooo"
        end
        2
    end
    """
    test_format(s_, s; margin=92, short_circuit_to_if = true)

    @testset "return statement" begin
        for op in ("&&", "||")
            # If the return statement is already there, don't expand it!
            s = """
            function f()
                return a $(op) b
            end"""
            test_format(s, s; short_circuit_to_if = true)

            # Also don't expand if it's the last statement in the function and always_use_return
            # is true -- because that means it's conceptually the same as a returned value.
            s_noreturn = """
            function f()
                a $(op) b
            end"""
            test_format(s_noreturn, s; short_circuit_to_if = true, always_use_return = true)
        end
    end

    @testset "don't expand before trailing block comment" begin
        # The short-circuit is the last expression in the block (the block comment
        # doesn't count), so its value is needed and it shouldn't be expanded.
        # The comment stays on its own line (#1194) but `a && b` is still recognised
        # as the last expression.
        s = """
        function foo(a, b)
            a && b
            #= hello =#
        end"""
        test_format(s, s; short_circuit_to_if = true)
    end

    @testset "don't expand in while cond" begin
        s = """
        while a && b
            c
        end
        """
        test_format(s, s; short_circuit_to_if = true)
    end

    @testset "not in macro/expr" begin
        s1 = "@foo a && b"
        s2 = """
        @foo function f()
            a && b
            return c
        end"""
        s3 = ":(a && b)"
        s4 = """
        quote
            begin
                a && b
            end
        end"""
        for s in (s1, s2, s3, s4)
            for style in ALL_STYLES
                test_format(s, s; short_circuit_to_if = true)
                test_format(s, s; short_circuit_to_if = false)
            end
        end
    end
end

end # module

import .ArgParse:
    ParseArgsError,
    ParsedArgs,
    parse_args,
    parse_raw,
    PARSER,
    StdoutMode,
    InplaceMode,
    CheckMode,
    print_help

# For thread-safe printing
const print_lock = ReentrantLock()

const SUCCESS_EXIT_CODE = 0
# If files were not correctly formatted.
const UNFORMATTED_EXIT_CODE = 1
# If an error occurred during formatting (e.g. parse error, invalid input, etc.)
const ERROR_EXIT_CODE = 2

supports_color(io) = get(io, :color, false)

macro tryx(ex, fallback)
    return :(
        try
            $(esc(ex))
        catch
            $(esc(fallback))
        end
    )
end

# Scan directory for Julia files recursively
function scandir!(files, root)
    # Don't recurse into `.git`
    if occursin(".git", root) && ".git" in splitpath(root)
        @assert endswith(root, ".git")
        return
    end
    @tryx(isdir(root), false) || return
    dirs = Vector{String}()
    for f in @tryx(readdir(root), String[])
        jf = joinpath(root, f)
        if @tryx(isdir(jf), false)
            push!(dirs, f)
        elseif (@tryx(isfile(jf), false) || @tryx(islink(jf), false))
            # Check for .jl, .md, .jmd, .qmd files
            if endswith(jf, ".jl") ||
               endswith(jf, ".md") ||
               endswith(jf, ".jmd") ||
               endswith(jf, ".qmd")
                push!(files, jf)
            end
        end
    end
    for dir in dirs
        scandir!(files, joinpath(root, dir))
    end
    return
end

function panic(
    msg::String,
    err::Union{Exception,Nothing} = nothing,
    bt::Union{Vector{Base.StackFrame},Nothing} = nothing,
)
    printstyled(stderr, "ERROR: "; color = :red, bold = true)
    print(stderr, msg)
    if err !== nothing
        print(stderr, sprint(showerror, err))
    end
    if bt !== nothing
        Base.show_backtrace(stderr, bt)
    end
    println(stderr)
    return ERROR_EXIT_CODE
end

function okln(io::IO, msg::String = "✓")
    printstyled(io, msg; color = :green, bold = true)
    println(io)
    return
end

function errln(io::IO, msg::String = "✗")
    printstyled(io, msg; color = :red, bold = true)
    println(io)
    return
end

function print_version()
    print(stdout, "jlfmt (JuliaFormatter) version ")
    print(stdout, string(pkgversion(JuliaFormatter)))
    print(stdout, ", julia version ")
    print(stdout, VERSION)
    println(stdout)
    return
end

# Type-stable output struct
struct Output{IO}
    which::Symbol
    file::String
    stream::IO
    output_is_file::Bool
    output_is_samefile::Bool
end

function writeo(output::Output, content::String)
    @assert output.which !== :devnull
    if output.which === :file
        write(output.file, content)
    elseif output.which == :stdout
        write(output.stream, content)
    end
    return
end

function main(argv::Vector{String})
    args = try
        parse_args(argv)
    catch err
        err isa ParseArgsError || rethrow()
        return panic(err.message)
    end

    if args.help
        print_help(PARSER)
        return Cint(0)
    end
    if args.version
        print_version()
        return Cint(0)
    end

    inplace = args.mode == InplaceMode
    check = args.mode == CheckMode
    outputfile = something(args.outputfile, "")

    inputfiles = String[]
    input_is_stdin = true
    # There might be multiple inputs if either more than one path is given, or if a single
    # directory is given. This catches the first case
    multiple_inputs = length(args.paths) > 1

    for x in args.paths
        if x == "-"
            if length(args.paths) > 1
                return panic("input `-` cannot be combined with other input")
            end
        else
            input_is_stdin = false
            if isdir(x)
                # This catches the second case (single-directory)
                scandir!(inputfiles, x)
                multiple_inputs = true
            else
                push!(inputfiles, x)
            end
        end
    end

    # Validate the arguments
    if inplace && input_is_stdin
        return panic("option `--inplace` cannot be used together with stdin input")
    end
    if outputfile != "" && multiple_inputs
        return panic("option `--output` cannot be used together with multiple input files")
    end
    if multiple_inputs && !(inplace || check)
        return panic(
            "multiple input files require either `--inplace` to write changes or `--check` to verify formatting",
        )
    end
    if !isempty(args.line_ranges) && multiple_inputs
        return panic(
            "option `--lines` cannot be used together with multiple input files or directories",
        )
    end
    if args.diff
        if Sys.which("git") === nothing
            return panic("option `--diff` requires `git` to be installed")
        end
    end

    # Disable verbose if piping from/to stdin/stdout
    output_is_stdout = !inplace && !check && (outputfile in ("", "-"))
    print_progress = args.verbose && !(input_is_stdin || output_is_stdout)

    fileargs_to_process = if input_is_stdin
        # Sentinel value representing stdin.
        [
            ProcessFileArgs(
                "",
                1,
                "1",
                print_progress,
                check,
                inplace,
                outputfile,
                true,
                args.stdin_filename,
                args.config_dir,
                args.ignore_config,
                args.config,
                args.line_ranges,
                args.diff,
                args.config_priority,
            ),
        ]
    else
        nfiles_str = string(length(inputfiles))
        [
            ProcessFileArgs(
                inputfile,
                file_counter,
                nfiles_str,
                print_progress,
                check,
                inplace,
                outputfile,
                false,
                args.stdin_filename,
                args.config_dir,
                args.ignore_config,
                args.config,
                args.line_ranges,
                args.diff,
                args.config_priority,
            ) for (file_counter, inputfile) in enumerate(inputfiles)
        ]
    end

    # Use multithreading for multiple files (only if multiple threads available)
    # Single file or stdin or single thread: process sequentially
    use_threading = length(inputfiles) > 1 && Threads.nthreads() > 1

    exit_code = if use_threading
        # Parallel processing for multiple files
        # Use Threads.Atomic to track errors across threads
        has_unformatted = Threads.Atomic{Bool}(false)
        has_error = Threads.Atomic{Bool}(false)
        Threads.@threads for fileargs in fileargs_to_process
            err = process_file(fileargs)
            if err == UNFORMATTED_EXIT_CODE
                Threads.atomic_or!(has_unformatted, true)
            elseif err == ERROR_EXIT_CODE
                Threads.atomic_or!(has_error, true)
            end
        end
        if has_error[]
            ERROR_EXIT_CODE
        elseif has_unformatted[]
            UNFORMATTED_EXIT_CODE
        else
            SUCCESS_EXIT_CODE
        end
    else
        # Sequential processing
        has_unformatted = false
        has_error = false
        for opts in fileargs_to_process
            err = process_file(opts)
            if err == UNFORMATTED_EXIT_CODE
                has_unformatted = true
            elseif err == ERROR_EXIT_CODE
                has_error = true
            end
        end
        if has_error
            ERROR_EXIT_CODE
        elseif has_unformatted
            UNFORMATTED_EXIT_CODE
        else
            SUCCESS_EXIT_CODE
        end
    end

    # Print summary message for check mode
    if check && exit_code == UNFORMATTED_EXIT_CODE
        printstyled(
            stderr,
            "Some files are not formatted correctly. Run again with `--inplace` instead of `--check` to format them.\n";
            color = :red,
        )
    end

    return Cint(exit_code)
end

struct ProcessFileArgs
    inputfile::String
    file_counter::Int
    nfiles_str::String
    print_progress::Bool
    check::Bool
    inplace::Bool
    outputfile::String
    input_is_stdin::Bool
    stdin_filename::String
    config_dir::String
    ignore_config::Bool
    config::Configuration
    line_ranges::Vector{Tuple{Int,Int}}
    diff::Bool
    config_priority::Bool
end

function process_file(args::ProcessFileArgs)
    # Build progress message if needed
    progress_prefix = if args.print_progress
        @assert !args.input_is_stdin
        input_pretty = relpath(args.inputfile)
        if Sys.iswindows()
            input_pretty = replace(input_pretty, "\\" => "/")
        end
        prefix = string(
            "[",
            lpad(string(args.file_counter), textwidth(args.nfiles_str), " "),
            "/",
            args.nfiles_str,
            "] ",
        )
        verb = args.check ? "Checking" : "Formatting"
        str = string(prefix, verb, " `", input_pretty, "` ")
        ndots = 80 - textwidth(str) - 1 - 1
        dots = ndots > 0 ? "."^ndots : ""
        string(str, dots, " ")
    else
        ""
    end

    # Emit a single progress line -- the dotted prefix followed by whatever `f` writes to its
    # `io` argument -- to stderr under the print lock. A no-op unless progress printing is on.
    report_status = function (f)
        args.print_progress || return
        @lock print_lock begin
            buf = IOBuffer()
            io = IOContext(buf, :color => supports_color(stderr))
            printstyled(io, progress_prefix; color = :blue)
            f(io)
            print(stderr, String(take!(buf)))
        end
        return
    end

    # Check if we should skip markdown files
    inputfile_pretty = args.input_is_stdin ? args.stdin_filename : args.inputfile
    _, ext = splitext(inputfile_pretty)
    is_markdown = ext in (".md", ".jmd", ".qmd")
    if is_markdown && !isempty(args.line_ranges)
        # Line-range formatting is not (yet) wired through the Markdown path.
        return panic("option `--lines` is not supported for Markdown input")
    end

    # Read the input
    sourcetext = if args.input_is_stdin
        try
            read(stdin, String)
        catch err
            report_status() do io
                errln(io, "✗ read failed")
            end
            return panic("could not read input from stdin: ", err)
        end
    elseif isfile(args.inputfile)
        try
            read(args.inputfile, String)
        catch err
            report_status() do io
                errln(io, "✗ read failed")
            end
            return panic("could not read input from file `$(args.inputfile)`: ", err)
        end
    else
        report_status() do io
            errln(io, "✗ not found")
        end
        return panic("input path is not a file or directory: `$(args.inputfile)`")
    end

    output = if args.inplace
        @assert args.outputfile == ""
        @assert isfile(args.inputfile)
        @assert !args.input_is_stdin
        Output(:file, args.inputfile, stdout, true, true)
    elseif args.check
        @assert args.outputfile == ""
        Output(:devnull, "", stdout, false, false)
    else
        if args.outputfile == "" || args.outputfile == "-"
            Output(:stdout, "", stdout, false, false)
        elseif isfile(args.outputfile) &&
               !args.input_is_stdin &&
               samefile(args.outputfile, args.inputfile)
            report_status() do io
                errln(io, "✗ invalid output")
            end
            return panic(
                "cannot use same file for input and output, use `--inplace` to modify a file in place",
            )
        else
            Output(:file, args.outputfile, stdout, true, false)
        end
    end

    # Look up .JuliaFormatter.toml config
    file_config = if args.ignore_config
        Configuration()
    else
        config_path = try
            if args.config_dir != ""
                find_config_file(args.config_dir)
            elseif !args.input_is_stdin
                find_config_file(args.inputfile)
            else
                nothing
            end
        catch e
            # find_config_file returns `nothing` if there isn't a config file,
            # but it can still throw (for example if --config-dir doesn't exist).
            if e isa ArgumentError
                return panic(e.msg)
            else
                rethrow()
            end
        end
        config_path !== nothing ? configuration_from_file(config_path) : Configuration()
    end
    # Merge: defaults < file config < CLI args (or defaults < CLI < file with
    # --prioritize-config-file)
    defaults = Configuration()
    config = if args.config_priority
        merge_config(merge_config(defaults, args.config), file_config)
    else
        merge_config(merge_config(defaults, file_config), args.config)
    end

    # Skip markdown files unless format_markdown is enabled
    if is_markdown && !something(config.format_markdown, false)
        report_status() do io
            okln(io, "skipped (markdown)")
        end
        return 0
    end

    # Check if file should be ignored (based on .JuliaFormatter.toml ignore patterns)
    if !args.input_is_stdin &&
       config.ignore !== nothing &&
       isignored(args.inputfile, config)
        report_status() do io
            okln(io, "skipped (ignored)")
        end
        return 0
    end

    style = config.style
    merged_options = get_formatting_options(config)

    formatted_str = try
        if is_markdown
            _format_md(sourcetext, style, merged_options)
        elseif !isempty(args.line_ranges)
            _format_line_ranges(sourcetext, style, args.line_ranges, merged_options)
        else
            _format_text(
                sourcetext,
                style,
                merged_options;
                check_output = true,
                ensure_trailing_newline = true,
            )
        end
    catch err
        if err isa JuliaSyntax.ParseError
            report_status() do io
                errln(io, "✗ parse error")
            end
            return panic(string("failed to parse input from ", inputfile_pretty, ": "), err)
        end
        if err isa ArgumentError
            # User input error (e.g. an out-of-bounds `--lines` range). Report it cleanly,
            # without a backtrace, just like a parse error.
            report_status() do io
                errln(io, "✗ invalid input")
            end
            return panic(
                string("failed to format input from ", inputfile_pretty, ": "),
                err,
            )
        end
        report_status() do io
            errln(io, "✗ format failed")
        end
        msg = string("failed to format input from ", inputfile_pretty, ": ")
        bt = stacktrace(catch_backtrace())
        bt = bt[1:min(5, length(bt))]
        return panic(msg, err, bt)
    end

    changed = (formatted_str != sourcetext)
    if args.check
        if changed
            report_status() do io
                errln(io, "✗ needs formatting")
            end
        else
            report_status() do io
                okln(io, "✓ already formatted")
            end
        end
    elseif changed || !args.inplace
        @assert output.which !== :devnull
        try
            writeo(output, formatted_str)
        catch err
            report_status() do io
                errln(io, "✗ write failed")
            end
            panic("could not write to output file `$(output.file)`: ", err)
            return 1
        end
        report_status() do io
            if args.inplace
                okln(io, "✓ formatted")
            else
                okln(io)
            end
        end
    else
        # inplace && !changed
        report_status() do io
            okln(io, "no changes")
        end
    end

    if changed && args.diff
        mktempdir() do dir
            a = joinpath(dir, "original")
            b = joinpath(dir, "formatted")
            A = joinpath(a, inputfile_pretty)
            B = joinpath(b, inputfile_pretty)
            mkpath(dirname(A))
            mkpath(dirname(B))
            write(A, sourcetext)
            write(B, formatted_str)
            color = supports_color(stderr) ? "always" : "never"
            git_argv = String[
                Sys.which("git"),
                "--no-pager",
                "diff",
                "--diff-algorithm=patience",
                "--color=$(color)",
                "--no-index",
                "--no-prefix",
                relpath(A, dir),
                relpath(B, dir),
            ]
            cmd = Cmd(git_argv)
            # `ignorestatus` because --no-index implies --exit-code
            cmd = setenv(ignorestatus(cmd); dir = dir)
            cmd = pipeline(cmd; stdout = stderr, stderr = stderr)
            run(cmd)
        end
    end

    return (changed && args.check) ? UNFORMATTED_EXIT_CODE : SUCCESS_EXIT_CODE
end

@static if isdefined(Base, Symbol("@main"))
    @main
end

#!/usr/bin/env bash

# Wrapper for the jlfmt executable, which is used in the jlfmt pre-commit hook.
#
# Resolution order for jlfmt:
#
#   1. --jlfmt-path=<path> (explicit override)
#   2. jlfmt on PATH
#   3. $JULIA_DEPOT_PATH/bin (each entry, colon-separated)
#   4. ~/.julia/bin (default depot)
#
# Gracefully errors if jlfmt can't be found.

jlfmt=""

# Parse --jlfmt-path argument and pass the rest through.
args=()
for arg in "$@"; do
    case "$arg" in
        --jlfmt-path=*) jlfmt="${arg#--jlfmt-path=}" ;;
        *) args+=("$arg") ;;
    esac
done

if [ -n "$jlfmt" ]; then
    # Path was explicitly specified. Expand tildes and check if it exists
    jlfmt="${jlfmt/#\~/$HOME}"
    if ! command -v "$jlfmt" &>/dev/null; then
        echo "Error: The executable '$jlfmt' (passed via --jlfmt-path) was not found."
        exit 1
    fi
else
    # Not specified, we'll have to search for it ourselves.
    # Step 1: Check PATH
    if command -v jlfmt &>/dev/null; then
        jlfmt="jlfmt"
    # Step 2: Check JULIA_DEPOT_PATH
    elif [ -n "$JULIA_DEPOT_PATH" ]; then
        IFS=: read -ra depots <<< "$JULIA_DEPOT_PATH"
        for depot in "${depots[@]}"; do
            depot="${depot/#\~/$HOME}"
            if [ -x "$depot/bin/jlfmt" ]; then
                jlfmt="$depot/bin/jlfmt"
                break
            fi
        done
    fi
    # Step 3: Check ~/.julia/bin (default fallback: cf. Julia's
    # `Base.init_depot_path()` implementation). In principle, we would like to
    # run `julia -e 'println(DEPOT_PATH)'`, but that takes too long, so is not
    # a viable option for pre-commit.
    if [ -z "$jlfmt" ] && [ -x "${HOME}/.julia/bin/jlfmt" ]; then
        jlfmt="${HOME}/.julia/bin/jlfmt"
    fi
    # Error
    if [ -z "$jlfmt" ]; then
        echo "ERROR: 'jlfmt' not found."
        echo "Install it with: julia -e 'import Pkg; Pkg.Apps.add(\"JuliaFormatter\")'"
        echo "Then make sure that jlfmt is on your PATH, or tell pre-commit its location with:"
        echo ""
        echo "    args: [\"--jlfmt-path=/path/to/jlfmt\"]"
        echo ""
        echo "See https://juliaeditorsupport.github.io/JuliaFormatter.jl/stable/integrations/ for details."
        exit 1
    fi
fi

exec "$jlfmt" --threads=auto -- --inplace "${args[@]}"

## [`pre-commit`](@id pre-commit)

[`pre-commit`](https://pre-commit.com) is a tool for installing and managing pre-commit Git hooks, which makes Git automatically run specified commands before commits are made.
This is useful for ensuring that code matches a certain quality standard before it is committed: for example, you can use `pre-commit` to run `JuliaFormatter.jl` on your code before it is committed.

JuliaFormatter provides two pre-commit hooks for you to use.
One uses the old-style `julia -e ...` invocation; the other uses the `jlfmt` app, which must be installed separately.

### `julia-formatter` hook (uses `julia -e ...`)

This hook launches JuliaFormatter via your global Julia installation, which means that you must first install JuliaFormatter as a package.

```julia
import Pkg; Pkg.add("JuliaFormatter")
```

To use the hook, you can add the following to your `.pre-commit-config.yaml`:

```yaml
repos:
- repo: https://github.com/JuliaEditorSupport/JuliaFormatter.jl
  rev: 0935890389c9fbc45f4ee150064c0abe5340b6a9 # v2.4.0
  hooks:
  - id: "julia-formatter"
```

(If you have other pre-commit hooks, just add the `repo: ...` block to your pre-existing list of repos.)

To pass additional arguments to the Julia invocation (e.g. if JuliaFormatter is installed in a specific project), you can use the `args` field, like so:

```yaml
repos:
- repo: https://github.com/JuliaEditorSupport/JuliaFormatter.jl
  rev: 0935890389c9fbc45f4ee150064c0abe5340b6a9 # v2.4.0
  hooks:
  - id: "julia-formatter"
    args: ["--project=/path/to/myproj"]
```

**Note that `rev` controls the version of the _hook_ that is checked out; it does not control which version of JuliaFormatter is actually used to format your code.**
The version used to do the actual formatting is determined by the version of JuliaFormatter that is installed in your global Julia environment.
This means that if you want to format your code with JuliaFormatter v1, you must make sure that you install v1 in your global Julia environment.

The `rev` field above is a commit hash that points to [v2.4.0 of JuliaFormatter.jl](https://github.com/JuliaEditorSupport/JuliaFormatter.jl/releases/tag/v2.4.0).
As of the time of writing, this is the latest release of JuliaFormatter.jl.
However, it is extremely unlikely that this hook will change in future releases, so you do not need to worry about 'updating' it to a newer version.

!!! note
    You could also point to a branch or a release tag, but it is safer to point to a commit hash, since that is immutable and is not vulnerable to e.g. supply chain attacks.

### `jlfmt` hook (uses the `jlfmt` app)

To use the `jlfmt` hook you must first make sure that the `jlfmt` app is installed on your system.
Instructions for installing the `jlfmt` app are given in the [CLI documentation](@ref cli).

The version of `jlfmt` that you install here will be the version that is used to actually format your code.
The `jlfmt` app was only introduced in v2.2.0, so versions before that are inaccessible: if you want to format your code with JuliaFormatter v1, you will not be able to use this hook.

Once you have the `jlfmt` app installed, you can add the following to your `.pre-commit-config.yaml`:

```yaml
repos:
- repo: https://github.com/JuliaEditorSupport/JuliaFormatter.jl
  rev: 0935890389c9fbc45f4ee150064c0abe5340b6a9 # v2.4.0
  hooks:
  - id: "jlfmt"
```

The path to the `jlfmt` executable can be specified in the `args` field of the hook, like so (although you should not _need_ to do so—see below):

```yaml
repos:
- repo: https://github.com/JuliaEditorSupport/JuliaFormatter.jl
  rev: 0935890389c9fbc45f4ee150064c0abe5340b6a9 # v2.4.0
  hooks:
  - id: "jlfmt"
    args: ["--jlfmt-path=/path/to/jlfmt"]
```

However, even without this argument, the pre-commit hook will attempt to locate `jlfmt` for you.
It looks in the following places, in order:

1. Using the executable specified via the `--jlfmt-path` argument, if provided.
2. A `jlfmt` executable on your system `PATH`.
3. `{dir}/bin/jlfmt` for each directory `{dir}` in the `JULIA_DEPOT_PATH` environment variable.
4. `~/.julia/bin/jlfmt`, which is the default depot path if `JULIA_DEPOT_PATH` is not set.

Just like for the `julia-formatter` hook, the `rev` field controls the version of the _hook_ that is checked out, not the version of JuliaFormatter that is used to do the formatting: that is governed by the version of the `jlfmt` app that you installed.
The `rev` field used here points to JuliaFormatter v2.4.0, but this hook is unlikely to change in future releases, so you do not need to worry about updating it to a newer version.

!!! note
    You could also point `rev` to a branch or a release tag, but it is safer to point to a commit hash, since that is immutable and is not vulnerable to e.g. supply chain attacks.

# [Known Issues](@id known-issues)

This page tries to collate a list of things that are known to be broken or otherwise unexpected.

## Importing operators

The following syntax

```julia
import Base: :+
```

is valid on Julia 1.10 and 1.11, but not on Julia 1.9 or 1.12 (the removal of this syntax in Julia 1.12 is [a bugfix in Julia, i.e., an intentional change](https://github.com/JuliaLang/julia/issues/62045)).
JuliaFormatter will refuse to format this code (because JuliaSyntax.jl doesn't parse it).

You should change your code to either of the following, which both format fine:

```julia
import Base: +
import Base: (+)
```

## Insertion of `return`

When using [`always_use_return = true`](@ref options-always-use-return) (or any style that sets that, e.g. BlueStyle), JuliaFormatter will add `return` statements to things that aren't really a meaningful return value:

```@example return
using JuliaFormatter: format_text

s = """
function foo()
    error("oops")
end
"""

format_text(s; always_use_return = true) |> println
```

!!! note "throw"
    Currently, JuliaFormatter special-cases `throw(...)` in that a `return` is not inserted before it. I personally dislike this heuristic because it's not provably *correct*: the cases that are special-cased are not the same as the cases that do not return. I intend to remove it in v3.

This is intentional and doesn't change any semantics (note that even though `error(...)` doesn't evaluate to an actual value, it is still an expression and has a type of `Union{}`, which is [the bottom type](https://en.wikipedia.org/wiki/Bottom_type)).
If you want to avoid this, you can insert a `return nothing` statement at the end of your function:

```@example return
s2 = """
function foo()
    error("oops")
    return nothing  # unreachable
end
"""

format_text(s2; always_use_return = true) |> println
```

## Inline comments

JuliaFormatter is _quite buggy_ with inline comments of the form `#= ... =#`, especially because they aren't thoroughly tested.
For example, sometimes they get inadvertently deleted, or formatting can be non-idempotent when they are present.

If you come across such problems please don't hesitate to [open an issue](https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues), but I wanted to document this because it is specifically known to be a bit of a pain point.
`# ...` comments are likely to be much more reliable.

# JuliaFormatter.jl

Width-sensitive formatter for Julia code, inspired by gofmt, refmt, black, and prettier.
Built with [`JuliaSyntax.jl`](https://github.com/JuliaLang/JuliaSyntax.jl).

- Provides sane defaults out of the box, with [a number of customisation options](@ref formatting-options).

- Supports [YAS](@ref yas-style), [Blue](@ref blue-style), and [SciML](@ref sciml-style) style guides.

- Admits a [`.JuliaFormatter.toml` configuration file](@ref config) for project-level formatting settings.

- Can be used as [a command-line app](@ref cli).

## Quickstart

Traditionally, JuliaFormatter is invoked from the Julia REPL.
(However, you may well find that [the command-line `jlfmt` app](@ref cli) is more convenient!)

To use JuliaFormatter from the REPL, install with:

```julia
]add JuliaFormatter
```

Then you can do:

```julia
julia> using JuliaFormatter

# Recursively formats all Julia files in the current directory
julia> format(".")

# Formats an individual file
julia> format_file("foo.jl")

# Formats a string
julia> format_text(str)
```

# Contributing

Contributions are very much welcome!

JuliaFormatter is a pretty difficult project to get into.
Conceptually there is not _that_ much going on: the [How It Works](@ref how-it-works) page has a high-level overview of the different stages of formatting.
However, the complexity comes from the fact that:

- Some parts of Julia's syntax itself can be quite complex! Array literals for example are a massive headache for formatters.

- JuliaSyntax's CST contains quite a few quirks and edge cases.

- Changing the formatting of one node can often have knock-on effects on other places especially with more complex examples.

I'm happy to help with any questions about how best to implement stuff, although please note I'm also finding my way around the codebase myself, so I might not always have the best answer.

In this page I've attempted to document some assorted bits of information that may be useful if you are contributing to JuliaFormatter.

## The `JuliaFormatter.Internal` module

JuliaFormatter contains some useful utilities which are explicitly marked as internal (i.e., not semver-compliant), inside the `JuliaFormatter.Internal` module.

There are currently two functions.
`format_to_stage` is more of a helper function for investigating what goes on during the formatting process.
However, `test_format` is used extensively in the test suite.
**Please note that all new tests that check the output of formatting should be written using `test_format`.**

```@docs
JuliaFormatter.Internal.format_to_stage
JuliaFormatter.Internal.test_format
```

## Disabling precompilation for development

JuliaFormatter contains a nontrivial precompilation workload, which can be quite annoying to run locally when iterating on changes.
To disable it, consider adding the following to `LocalPreferences.toml`.
The file belongs in the directory corresponding to your Julia environment.
For example, if you use `julia --project=/path/to/JuliaFormatter`, then the file should be located at `/path/to/JuliaFormatter/LocalPreferences.toml`:

```toml
[JuliaFormatter]
precompile_workload = false
```

(This suggestion is taken from [the PrecompileTools.jl docs](https://julialang.github.io/PrecompileTools.jl/stable/#Package-developers:-reducing-the-cost-of-precompilation-during-development).)

## Installing an MCP tool

If you are actively developing JuliaFormatter and are using agentic AI to investigate bugs, you likely want to install an MCP tool or similar which the agent can use to run JuliaFormatter.

In particular, I have [a fork of `julia-mcp`](https://github.com/penelopeysm/julia-format-mcp) which includes an additional `julia-format` tool specifically for running JuliaFormatter.
JuliaFormatter contains an `AGENTS.md` file which instructs your agent to use this tool.

To set this up, run the following commands:

```bash
# You can clone it anywhere you like, but I like to keep it inside ~/.julia.
git clone https://github.com/penelopeysm/julia-format-mcp ~/.julia/julia-format-mcp
claude mcp add --scope user julia -- uv run --directory ~/.julia/julia-format-mcp python server.py
```

For other harnesses, please see the [julia-mcp docs](https://github.com/aplavin/julia-mcp#usage) for corresponding instructions.

Claude Code (as of v2.1.177) has [an annoying issue](https://github.com/anthropics/claude-code/issues/45839) where results from the MCP tool are only displayed to the user in JSON, which is impossible to read whenever multiline strings are involved.
To get around this, you can install a post-tool hook which prints the tool's results directly into your Claude Code session.
If you are using the fork above, you can add this block to your `~/.claude/settings.json` file:

```json
{
  ...,
  "hooks": {
    "PostToolUse": [
      {
        "matcher": "mcp__julia__julia_eval|mcp__julia__julia_format",
        "hooks": [
          {
            "type": "command",
            "command": "jq -r '.tool_response | fromjson | (.content[0].text // .result)' | jq -Rs '{systemMessage: (\"\\n\" + .)}' 2>/dev/null || true"
          }
        ]
      }
    ]
  },
  ...,
}
```

and every time `julia_eval` or `julia_format` is called, the hook will print whatever output Julia generated.

## GitHub-specific things

### FormatBot

JuliaFormatter has a small Python script in `.github/scripts/formatbot.py`, whose job is to compare differences between two revisions of JuliaFormatter.
It can be invoked as follows:

```
python3 formatbot.py
    owner/repo[@REV]
    [--base-ref BASE_REF]
    [jlfmt_options...]
```

This script **must** be run from a local Git checkout of JuliaFormatter, as that will be used as the 'new' version of JuliaFormatter.
It will then:

1. Clones the target repository at the specified revision (or the default branch if no revision is specified).

1. Uses the current local checkout of JuliaFormatter to format the target repository.
   The changes are saved to a branch which we'll call `fmt` (the script technically generates a random name for this branch to avoid collisions).

1. Resets the target repository to the unformatted code if needed.

1. **If `--base-ref` is given**, clones JuliaFormatter at that specified revision into a tempdir, and uses that to format the target repository.
   The changes are saved to a branch, which again technically has a random name, but which we'll call `basefmt`.

   **If `--base-ref` is not given**, the `basefmt` branch is simply the unformatted code.

1. Diffs the `fmt` branch against `basefmt`.

FormatBot will also include a warning if formatting is not idempotent, or fails.

All other command-line options are passed directly to the `jlfmt` app.

This script can also be invoked on GitHub by posting a comment on a PR with the following format:

```
!formatbot owner/repo[@REV] [jlfmt_options...]
```

In this case, the base revision is always the target branch of the PR, and the formatting is checked against the head commit of the PR.
Once the script has finished, it will post a comment on the PR with the results.

### [Issue triage](@id issue-triage)

Issues (and sometimes PRs) will be assigned a priority label, with a larger number indicating more important.
The exact label for an issue is left to my discretion, but generally these are the categories that they will fall into:

- **P5** - silently changes the meaning of code. This is absolutely terrible!

- **P4** - fails to format code (still bad, but at least this errors loudly). Non-idempotent formatting also falls into this category.

- **P3** - fails to respect formatting options

- **P2** - formatting is ugly but not a bug *per se*, or feature requests in general

- **P1** - really small things, like typos

Additionally where possible I'll also add **good first issue** tags for changes that are quite self-contained.
These may include any priority level but should generally be P3 or lower.

You can see a list of all triaged issues [here](https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues?q=is%3Aissue%20state%3Aopen%20label%3AP5%2CP4%2CP3%2CP2%2CP1).

## AI usage

LLMs and AI in general can be really useful for tracing through some of the logic in the codebase.
(I use them a lot myself!)
However, my experience is that they are still quite poor at design choices:

- They tend to chase short-term gains at the expense of long-term maintainability (i.e., they're happy to fix a bug by inserting hacky code).

- Unless prompted carefully, they won't recognise the effect that a change in one part of the codebase will have on other parts.

Essentially, LLMs if not used carefully are a great path into a _local minimum_.

Please do feel free to use LLMs to help explore the codebase, but when making PRs please consider the above points.

I don't think it's sensible (or indeed possible) completely ban LLM usage, but maintaining an open-source project is difficult and my experience is that LLM contributions tend to be [extractive (in the words of the LLVM project)](https://llvm.org/docs/AIToolPolicy.html).
I don't want to spend all my time cleaning up LLM stuff.
**Therefore, PRs which are clearly LLM-generated, and additionally do not show evidence of human engagement or are too big to be easily reviewed will be rejected.**

If you're just getting started with the codebase and want to help out but don't know where to start, please do just reach out.
I'm genuinely very happy to help *people* with this.
But please don't just ask an LLM to make a PR for you.

Finally, following the LLVM policy, **it is also forbidden to use LLMs to fix good first issues**.

# [YAS Style](@id yas-style)

```@docs; canonical=false
YASStyle
```

## Configuration File Example

The `.JuliaFormatter.toml` which represents these settings is

```toml
style = "yas"
```

Or to use `YASStyle` except change one of the settings:

```toml
style = "yas"
remove_extra_newlines = false
```

## Direct Usage

```julia
format("file.jl", YASStyle())
```

Or to use `YASStyle` except change one of the settings:

```julia
format("file.jl", YASStyle(), remove_extra_newlines=false)
```

## Differences from `DefaultStyle`

There are three main differences between `YASStyle` and `DefaultStyle`. They are based
on alignment and line break behaviors.

 1. Arguments are aligned to just after the start of the *opener* `[, {, (, etc`.

    ```julia
    function_call(arg1,
                  arg2)
    ```

 2. As you can see from the above the *closer* sticks to the final argument.

 3. Nesting (line breaks) only occur when the margin of the next argument exceeds
    the maximim limit.

    ```julia
    function_call(arg1, arg2,
                  arg3)
    ```

`arg3` exceeded the margin limit and so it was placed on the following line.

### Nesting `=`

Unlike `DefaultStyle`, assignment operations `=` are not nested. That
is, the following

```julia
my_function(arg1, arg2) = arg1 * arg2
```

Is not nested to

```julia
my_function(arg1, arg2) =
    arg1 * arg2
```

It is highly recommended setting `short_to_long_function_def` to `true`. This option
transforms the above to a long function definition if it exceeds the maximum margin.

```julia
function my_function(arg1, arg2)
    arg1 * arg2
end
```

## Additional Options

The `YASStyle` supports the additional option `variable_call_indent`,
which is set to `[]` by default.
It allows calls without aligning to the opening parenthesis:

```julia
# Allowed with and without `Dict in variable_call_indent`
Dict{Int,Int}(1 => 2,
              3 => 4)

# Allowed when `Dict in variable_call_indent`, but
# will be changed to the first example when `Dict ∉ variable_call_indent`.
Dict{Int,Int}(
    1 => 2,
    3 => 4)
```

# [File Options](@id file-options)

These options can be specified either in a [`.JuliaFormatter.toml` configuration file](@ref config), or as extra arguments to the [`jlfmt` command-line tool](@ref cli).

On top of these, you can also add all [formatting options](@ref formatting-options) to the configuration file or CLI arguments.

## [`style`](@id options-style)

To choose another base style, such as `YASStyle` you can write this in your configuration like so:

```toml
style = "yas"
```

Style choices are:

- `"default"` (default choice if nothing is specified)
- `"yas"`
- `"blue"`
- `"sciml"`
- `"minimal"`

## [`overwrite`](@id options-overwrite)

Default: `true`

If `true` the file will be reformatted in-place, overwriting the existing file; if it is `false`, the formatted version will not be written anywhere.

## [`verbose`](@id options-verbose)

Default: `false`

If `true`, extra details about the formatting process are printed to `stdout`.

## [`format_markdown`](@id options-format-markdown)

Default: `false`

If `true`, Markdown files are also formatted.
Julia code blocks will be formatted, in addition to the Markdown being normalized.

## [`ignore`](@id options-ignore)

An array of paths to files and directories (with possible glob wildcards, as implemented by [Glob.jl])(https://github.com/vtjnash/Glob.jl)) which will not be formatted.

For example, if `.JuliaFormatter.toml` contains

```toml
ignore = ["file.jl", "directory", "file_*.jl"]
```

then JuliaFormatter will skip over all of these files:

- `file.jl`
- `directory/something.jl`
- `other_directory/file.jl`
- `file_1.jl`
- `other_directory/file_name.jl`

!!! note "Path separators"
    Glob.jl uses `/` as its path separator (`\` is an escape sequence), so even if you are on Windows, you should specify your ignore patterns with `/`.

# Skipping Formatting

By default, formatting is applied to all lines of a file, but this can be toggled with the following comments:

```julia
#! format: off
# Turns off formatting from this point onwards
...

#! format: on
# Turns formatting back on from this point onwards
```

To make an entire file not be formatted, add `#! format: off` at the top of the file:

```julia
#! format: off
#
# It doesn't actually matter if it's on
# the first line of the line but anything
# onwards will NOT be formatted.

module Foo
...
end
```

Note that the formatter expects `#! format: on` and `#! format: off` to be on its own line, and the whitespace to be an exact match.

!!! note "Ignoring files"
    You can also ignore entire files and directories by supplying [the `ignore` option](@ref options-ignore) in `.JuliaFormatter.toml`.

## Preventing indentation

Sometimes you may wish for a block of code to not be indented.
You can achieve this with a more targeted approach of `#! format: noindent`.

```julia
begin
@muladd begin
    #! format: noindent
    a = 10
    b = 20
    begin
       # another indent
        z = 33
    end

    a * b
end
        end
```

is formatted to


```julia
begin
    @muladd begin
    #! format: noindent
    a = 10
    b = 20
    begin
        # another indent
        z = 33
    end

    a * b
    end
end
```

Notice the contents of `@muladd begin` are not indented beyond their pre-existing indentation.
Without the `#! format: noindent` comment, the contents of `@muladd begin` would be indented at an additional level:

```julia
begin
    @muladd begin
        a = 10
        b = 20
        begin
            # another indent
            z = 33
        end

        a * b
    end
end
```

`#! format: noindent` can also be nested.

## One-off range formatting

Sometimes it is quite useful to only format specific ranges of a file.
This situation can occur e.g. when highlighting a block of code in an editor and formatting only that block.
(Indeed, both LanguageServer.jl and JETLS.jl support this feature.)

It is also useful for minimising diffs: by formatting only the lines that have been newly changed, you can avoid introducing formatting-only diffs in other parts of a file.

Since version 2.7, JuliaFormatter allows you to do this with the `lines` keyword argument in `format_text(...; lines=[(start_line, end_line)], ...)`.
Multiple ranges can be specified; each range must be a tuple of two (1-indexed) integers representing the start and end line of the range to format.

```@example lines
s = """
f(a      , g(b      ,
    h(  12  ),
))"""

# Format only line 2.
using JuliaFormatter
format_text(s; lines=[(2, 2)]) |> println
```

The second line (`h(12)`) is now formatted, but the extra spaces in the first line have not been collapsed.

With the `jlfmt` CLI, you can specify `--lines=2:2` to achieve the same effect.

Note, however, that this works best when the lines to be formatted are a self-contained block of code.
This is because formatting is context-sensitive: it's not possible to format a single line in isolation without considering where it occurs!

This can sometimes lead to odd results, and indeed the example above was chosen to showcase this.
**In general, formatting of partial expressions is performed only on a best-effort basis.**
For example:

```@example lines
# Format only line 2, but with a smaller margin.
format_text(s; lines=[(2, 2)], margin=10) |> println
```

Here, the formatter decided to indent the call `h(12)` by eight spaces, even though based on its position in the file it should have been indented by only four spaces.
Furthermore, as a result of this increased indentation, the formatter also decided to break up `h(12)` into multiple lines, even though `h(12),` with a four-space indent would have fit within the margin.

To understand why, we need to look at what would happen if *all* the text were to be formatted:

```@example lines
format_text(s; margin=10) |> println
```

Because of the small margin, JuliaFormatter decided to break the calls to `f` and `g`, meaning that `h(12)` would now get two levels of indentation.
When formatting only line 2, however, you don't see the changes to the surrounding code: the only visible change is that of `h(12)`.

## A note about other special comments

Note that any comment that begins with `#! __JuliaFormatter` is reserved for internal use.
For example, the option to format only specific lines of a file uses such marker comments.
If you have one of these in your source code, unexpected results may occur.

It is very unlikely that your source code will inadvertently include such a comment, but this is documented here for completeness!

# [Configuration File](@id config)

Since v0.4.3, JuliaFormatter offers [`.prettierrc`-style](https://prettier.io/docs/en/configuration.html) configuration file support.

When JuliaFormatter is called, it will look for `.JuliaFormatter.toml` in the location of the file being formatted, and searching _up_ the file tree until a config file is (or isn't) found.
If found, the configurations in the file will override any options passed to JuliaFormatter's functions.

## Specifying options

In `.JuliaFormatter.toml`, you can specify any of the [formatting options](@ref formatting-options) in TOML.
For example, if `somedir/.JuliaFormatter.toml` contains

```toml
indent = 2
margin = 100
```

then files under `somedir` will be formatted with 2 spaces of indentation and a maximum line length of 100.

Configuration files also admit some extra options that are not formatting-related, such as `ignore`.
See [File Options](@ref file-options) for more details.

## Search path

`.JuliaFormatter.toml` will be searched _up_ from the directory of the file being formatted.
So if you have:

```
dir
├─ .JuliaFormatter.toml
├─ code.jl
└─ subdir
   └─ sub_code.jl
```

then:

- `format("subdir/sub_code.jl")` will take its configuration from `dir/.JuliaFormatter.toml`; and
- `format("dir")` will format both `dir/code.jl` and `dir/subdir/sub_code.jl` according to the same configuration.

If there are multiple `.JuliaFormatter.toml` files, the _deepest_ configuration takes precedence.
For example, if you have

```
dir
├─ .JuliaFormatter.toml
├─ code.jl
├─ subdir1
│  ├─ .JuliaFormatter.toml
│  └─ sub_code1.jl
└─ subdir2
   └─ sub_code2.jl
```

and call `format("dir")`, then

- `code.jl` and `sub_code2.jl` will be formatted according to the rules defined in `dir/.JuliaFormatter.toml`, whereas
- `sub_code1.jl` will be formatted according to `dir/subdir1/.JuliaFormatter.toml`.

# [SciML Style](@id sciml-style)

!!! warning "`SciMLStyle()` !== 'SciML style' === Runic"

    Note that the SciML Style Guide [currently suggests using Runic.jl for formatting instead](https://github.com/SciML/SciMLStyle/tree/af867dabfeb1012d9c3f8d76e458b56a934b6212#Runic).

    JuliaFormatter's `SciMLStyle()` represents a collection of styles that predated this recommendation, and is being kept in v2 for compatibility.
    In a future major release this style may be renamed to avoid confusion.

```@docs; canonical=false
SciMLStyle
```

## Configuration File Example

The `.JuliaFormatter.toml` which represents these settings is

```toml
style = "sciml"
```

Or to use `SciMLStyle` except change one of the settings:

```toml
style = "sciml"
remove_extra_newlines = false
```

## Direct Usage

```julia
format("file.jl", SciMLStyle())
```

Or to use `SciMLStyle` except change one of the settings:

```julia
format("file.jl", SciMLStyle(), remove_extra_newlines=false)
```

## Additional Options

The `SciMLStyle` supports the following additional options, which have no effect on other styles:

- [`sciml_margin_overrun`](@ref options-sciml-margin-overrun)
- [`variable_call_indent`](@ref options-variable-call-indent)
- [`yas_style_nesting`](@ref options-yas-style-nesting)

```@meta
CurrentModule = JuliaFormatter
```

# [Default style](@id default-style)

JuliaFormatter has a default style.
This page is intended to give a rough overview of how the output of a formatted file looks like when using the default style.
Additional examples can be found in [JuliaFormatter's codebase itself](https://github.com/JuliaEditorSupport/JuliaFormatter.jl).

All examples assume indentation of 4 spaces.

## Nesting decisions

Where possible JuliaFormatter's default style attempts to keep code on a single line.

### With no arguments

Functions, macros, and structs with no arguments are placed on a single line.
This also applies to abstract and primitive types:

```julia
function  foo
end
abstract type
AbstractFoo
end
```

is formatted to

```julia
function foo end
abstract type AbstractFoo end
```

### With arguments

Functions calls `foo(args...)`, tuples `(args...)`, arrays `[args...]`, braces `{args...}`, and type parameter definitions `Foo{args...}` are placed on a single line.
This applies to any code which has opening and closing punctuation: `(...)`, `{...}`, `[...]`.

Whitespace is inserted after commas, but not for type definitions:

```julia
f(

a,b

,c )

Foo{
a,b
,c }
```

is formatted to

```julia
f(a, b, c)
Foo{a,b,c}
```

### Blocks

Blocks and their bodies are spread across multiple lines and properly indented.

Example 1:

```julia
begin
  a
    b; c
       end

struct Foo{A, B}
 a::A
  b::B
end
```

is formatted to

```julia
begin
    a
    b
    c
end

struct Foo{A,B}
    a::A
    b::B
end
```

### Binary operators (without nesting)

Binary calls are placed on a single line where possible.
Their operands are separated by whitespace, except for `:` operators (i.e. ranges), and for operators which are inside indexing brackets.

Example 1:

```julia
a+b
a : a : c
list[a + b]
```

```julia
a + b
a:b:c
list[a+b]
```

Ternary expressions are placed on a single line and separated by whitespace:

```julia
cond1 ?
expr1 :     expr2
```

is formatted to

```julia
cond1 ? expr1 : expr2
```

Comments are aligned with surrounding code blocks.

```julia
# comment
if a
# comment
else
# comment
end
# comment
```

is formatted to

```julia
# comment
if a
    # comment
else
    # comment
end
# comment
```

## Binary operators (with nesting)

If a binary operation exceeds the margin, they are nested back-to-front:

```julia
arg1 + arg2
```

becomes (with a small margin)

```julia
arg1 + 
arg2
```

For the ternary operator, as the margin decreases, the `:` is first moved to the next line, and then the `?`:

```julia
cond ? e1 : e2
```

becomes (with a small margin)

```julia
cond ? e1 :
e2
```

and with an even smaller margin

```julia
cond ? 
e1 : e2
```

and with a _yet_ smaller margin

```julia
cond ? 
e1 :
e2
```

If nesting is required for an assignment (i.e., a binary operation with `=` as the operator), the RHS is placed on the following line and indented.

```julia
foo() = body
```

is formatted to

```julia
foo() =
    body
```

All arguments of a function call (applies to any opening/closing punctuation type) are nested if the expression exceeds the margin.
The arguments are indented one level.

```julia
function longfunctionname_that_is_long(lots, of, args, even, more, args)
    body
end
```

becomes

```julia
function longfunctionname_that_is_long(
    lots, 
    of, 
    args,
    even, 
    more, 
    args,
)
    body
end
```

With `where` operations (`A where B`), `A` is nested prior to `B`.

```julia
function f(arg1::A, key1 = val1; key2 = val2) where {A,B,C}
    body
end
```

becomes

```julia
function f(
    arg1::A,
    key1 = val1;
    key2 = val2,
) where {A,B,C}
    body
end
```

and if the margin is shrunk even more,

```julia
function f(
    arg1::A,
    key1 = val1;
    key2 = val2,
) where {
    A,
    B,
    C,
}
    body
end
```

If a comment is detected inside of an expression, that expression is automatically nested:

```julia
var = foo(
    a, b, # comment
    c,
)
```

becomes

```julia
var = foo(
    a,
    b, # comment
    c,
)
```

### Unnesting

In certain cases it is desirable to _unnest_ parts of a `FST` to avoid excessive whitespace.
For example, the following

```julia
var =
    funccall(
        arg1,
        arg2,
        arg3,
    )
```

will be un-nested to

```julia
var = funccall(arg1, arg2, arg3)
```

or 

```julia
var = funccall(
    arg1,
    arg2,
    arg3,
)
```

## Syntax transformations

### `for in` vs. `for =`

By default if the RHS is a range, e.g. `1:10`, then `for ... in ...` is converted to `for ... = ...`.
Otherwise `for ... = ...` is converted to `for ... in ...`.
See [this issue](https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/34) for the rationale and further explanation.

This behaviour can be controlled using the [`always_for_in` option](@ref options-always-for-in).
Setting `always_for_in=true` will always convert `=` to `in` even if the RHS is a range.
`always_for_in=nothing` will leave the choice of `in` vs `=` up to the user.

### Trailing Commas

If the node is _iterable_, for example a function call or list and is nested, a trailing comma is added to the last argument.
The trailing comma is removed if unnested:

```julia
func(a, b, c)
```

becomes

```julia
func(
    a,
    b,
    c,
)
```

See [this issue](https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/44) for more details.

### Trailing Semicolons

If a matrix node is nested, the semicolons are removed.

```julia
A = [1 0; 0 1]

->

A = [
    1 0
    0 1
]
```

See [this issue](https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/77) for more details.

### Leading and trailing 0s for float literals

If a float literal is missing a trailing or leading 0, it is added:

```julia
a = 1.
b = .1
```

becomes

```julia
a = 1.0
b = 0.1
```

For `Float32` literals, if there is no decimal point, `.0` is added:

```julia
a = 1f0

->

a = 1.0f0
```

See [this issue](https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/66) for more details.

### Surround `where` arguments with curly brackets

If the arguments of a `where` call are not surrounded by curly brackets, they are added:

```julia
foo(x::T) where T = ...
```

becomes

```julia
foo(x::T) where {T} = ...
```

This can be controlled with the [`surround_whereop_typeparameters` option](@ref options-surround-whereop-typeparameters).

See [this issue](https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/53) for more details.

### Annotate unannotated type fields with `Any`

In structs, if a field is unannotated, it is annotated with `Any`:

```julia
struct Foo
    field
end
```

becomes

```julia
struct Foo
    field::Any
end
```

This can be controlled with the [`annotate_untyped_fields_with_any` option](@ref options-annotate-untyped-fields-with-any).

### Move `@` in macro calls to the final identifier

```julia
@Module.macro
```

becomes

```julia
Module.@macro
```

# [Command Line Interface](@id cli)

JuliaFormatter provides a command-line executable `jlfmt` for formatting Julia source code.
This is a [Pkg app](https://pkgdocs.julialang.org/v1/apps/), and therefore requires Julia v1.12 or later.

## Installation

The app can be installed using Julia's app manager:

```julia
# Install the latest available version
import Pkg; Pkg.Apps.add("JuliaFormatter")

# Or a specific version. Note that the version must be >= v2.2.0 since that is
# when the `jlfmt` app was introduced.
import Pkg; Pkg.Apps.add(; name = "JuliaFormatter", version = v"2.3.0")
```

This should create a new binary, called `jlfmt`, inside the Julia depot's `bin` directory (usually `~/.julia/bin`; but you can check with the `DEPOT_PATH` variable in Julia).

Alternatively, you can invoke the app directly without installation:

```bash
julia -m JuliaFormatter [<options>] <path>...
```

!!! note "Runic Compatibility"
    The CLI interface is designed to be compatible with [Runic.jl](https://github.com/fredrikekre/Runic.jl)'s CLI where possible, making it easier to switch between formatters. This includes the repeatable `--lines=<start>:<stop>` option for formatting only specific line ranges (e.g. `jlfmt --lines=1:10 --lines=42:47 src/file.jl`).

## Quick Start

```bash
# Preview formatted output
jlfmt src/file.jl

# Check if files are already formatted with verbose mode
jlfmt --check -v src/

# Format files in-place with multiple threads
jlfmt --threads=6 -- --inplace -v src/

# Show diff without modifying
jlfmt --diff src/file.jl
```

## Options

All formatting options can be passed to `jlfmt` as command-line arguments, e.g. `--indent=2 --always-use-return=true`.

In general the way that CLI options are specified are exactly the same as in `.JuliaFormatter.toml`, with some exceptions:

- When specified on the CLI options are hyphenated (e.g. `--always-use-return`), while in the config file they are underscored (e.g. `always_use_return`).
- To set an option to `nothing`, use `--option=nothing` (in the config file it would have to be `option = "nothing"`).
- To pass a list of strings for `variable_call_indent`, specify the option multiple times on the CLI, e.g. `--variable-call-indent=foo --variable-call-indent=bar` (in the config file it would be `variable_call_indent = ["foo", "bar"]`).

You can run `jlfmt --help` for a full list of available options (the output of this is at the bottom of this page, to avoid clutter).

!!! note "Deprecated options"

    In previous versions of `jlfmt`, some (but not all) Boolean options could be specified using `--option_name` or `--no-option_name` flags (e.g. `--always-use-return` or `--no-always-use-return`).
    This is now deprecated in favor of `--option-name=true` or `--option-name=false` (note hyphens instead of underscores, and the value must be explicitly supplied!), and will be removed in a future release.

## Configuration Files

`jlfmt` searches for [`.JuliaFormatter.toml` configuration](@ref config) files starting from each input file's directory and walking up the directory tree.

A specific directory containing a configuration file can be specified with `--config-dir`:

```bash
# Search upwards from home directory for a config file
jlfmt --config-dir=~ src/file.jl
```

By default, command-line options override configuration file settings:

```bash
# Use indent=2 even if config file specifies indent=4
jlfmt --indent=2 src/file.jl
```

Use `--prioritize-config-file` to make configuration file settings take precedence (might be useful for language server integration):

```bash
jlfmt --prioritize-config-file --indent=2 src/file.jl
```

If you want to ignore preexisting configuration files, use `--ignore-config` (this is mostly useful for JuliaFormatter's own testing pipelines):

```bash
# Ignore any config files and use only CLI args
jlfmt --ignore-config --indent=2 src/file.jl
```

### Configuration with stdin

When formatting from stdin, no configuration file is used by default.
Use `--config-dir` to specify a directory for configuration file lookup:

```bash
# Format stdin using config from ./src directory
echo 'f(x,y)=x+y' | jlfmt --config-dir=./src

# Useful in editor integrations to respect project config
cat file.jl | jlfmt --config-dir=$(dirname file.jl)
```

The formatter will search for `.JuliaFormatter.toml` in the specified directory and its parent directories, just like it does for regular file inputs.

## Conventions

`jlfmt` follows standard CLI conventions:
- Exit code 0 on success
- Exit code 1 on formatting errors or when `--check` detects unformatted files
- Formatted output to stdout (default) or in-place with `--inplace`
- Error messages to stderr

## Help text

```@repl
using JuliaFormatter # hide
JuliaFormatter.main(["--help"]); # hide
```

# Code editors

If you are using any reasonably modern code editor, the easiest option for integrating JuliaFormatter into your editor is to use a language server which provides formatting capabilities.

## LanguageServer.jl

[LanguageServer.jl](https://github.com/julia-vscode/LanguageServer.jl) provides LSP support for Julia and uses JuliaFormatter to format Julia code.
Instructions for setting up LanguageServer.jl for your editor of choice can be found in the LanguageServer.jl docs.

!!! warning "JuliaFormatter version with LanguageServer.jl"

    Note that JuliaFormatter is a dependency of LanguageServer.jl, and thus, the version of JuliaFormatter used for formatting code will be set once when you install LanguageServer.jl and fixed after that.

    This is **not** an ideal situation because often, the version of formatter used is a project-level setting: for example, CI will be configured to run with a specific version of JuliaFormatter, and you will want to use the same version when formatting locally.

    The real solution here is to decouple the formatter from the language server, for example, by having the language server call out to a separate formatter process.
    This will hopefully change in the future, but for now this is a genuine limitation.

### VSCode

If you use [the Julia VSCode extension](https://marketplace.visualstudio.com/items?itemName=julialang.language-julia) this is already backed by LanguageServer.jl and hence JuliaFormatter.
[`.JuliaFormatter.toml`](@ref config) files in your project will be detected automatically.
See [the extension's docs](https://www.julia-vscode.org/docs/stable/userguide/formatter/) for more information.

!!! note "JuliaFormatter version"
    As described above, the version of JuliaFormatter used is dictated by the extension.
    See e.g. [this issue](https://github.com/julia-vscode/julia-vscode/issues/4010#issue-3888453945) for an example of how to work around this by installing a custom formatter in VSCode.

## JETLS.jl

[JETLS.jl](https://github.com/aviatesk/JETLS.jl) is a new language server implementation for Julia, backed by much more thorough static analysis of Julia code.
It also contains support for formatting code, and importantly, it does so by invoking a formatter executable!
This means that you can use any version of JuliaFormatter you like (from v2.2 onwards, since that is when the [`jlfmt` CLI app](@ref cli) became available).

Please see the JETLS.jl docs for more information on [editor setup](https://aviatesk.github.io/JETLS.jl/release/#index/editor-setup) and [configuring the formatter](https://aviatesk.github.io/JETLS.jl/release/formatting/).

!!! warning "JETLS.jl is cutting-edge"
    JETLS.jl's README currently states "Experimental: JETLS is under active development. Not production-ready; APIs and behavior may change. Stability and performance are limited. Expect bugs and rough edges."

## Helix

To use JuliaFormatter with [Helix](https://helix-editor.com/), you can either use the LSP approach, or if you wish to use a specific version of JuliaFormatter, you can install the `jlfmt` CLI app and configure Helix to use it.
Place the following in [a `language.toml` file](https://docs.helix-editor.com/languages.html):

```toml
[[language]]
name = "julia"

[language.formatter]
command = "jlfmt"
args = ["--config-dir=%sh{pwd}"]
```

## Legacy editor support

Before the days where LSP was ubiquitous, there were various editor plugins which provided direct integration with JuliaFormatter:

- [Vim / Neovim](https://github.com/kdheepak/JuliaFormatter.vim)
- [Emacs](https://codeberg.org/FelipeLema/julia-formatter.el)
- [VSCode (deprecated)](https://github.com/singularitti/vscode-julia-formatter/)
- [Atom (maintenance-only)](https://github.com/JunoLab/Atom.jl)

# GitHub Actions

To set up a formatting check in CI, here is a barebones action.
This will just fail if any files are not formatted.

!!! note "Pin the version of JuliaFormatter"
    It is **strongly** recommended that you pin the version of JuliaFormatter used in your CI workflow.

```yaml
name: Format

on:
  push:
    branches:
      - main
  pull_request:

jobs:
  format:
    name: Format
    runs-on: ubuntu-latest
    steps:
      - uses: actions/checkout@9c091bb21b7c1c1d1991bb908d89e4e9dddfe3e0 # 7.0.0
      - uses: julia-actions/setup-julia@fa02766e078afaaf09b14210362cee14137e6a32 # 3.0.2
      - uses: julia-actions/cache@a45e8fa8be21c18a06b7177052533149e61e9b38 # 3.1.0
      - name: Install JuliaFormatter
        run: |
          julia -e 'using Pkg; Pkg.Registry.add("General"); Pkg.Registry.update(); Pkg.Apps.add(name="JuliaFormatter", version=v"2.10.1")'
      - name: Check formatting
        run: |
          ${HOME}/.julia/bin/jlfmt --check --verbose .
```

If you want an action that makes comments on PRs with suggested formatting changes, you can use [the `julia-actions/julia-format` action](https://github.com/julia-actions/julia-format): please see that repository's documentations for instructions on how to set it up.

Alternatively, if you have JuliaFormatter set up as part of your repository's [pre-commit checks](@ref pre-commit) checks, you can directly use pre-commit's CI tooling:

- [GitHub Action workflow](https://github.com/pre-commit/action)
- [GitHub App](https://pre-commit.ci/)

# API Documentation

## Public API

```@docs
JuliaFormatter.format
JuliaFormatter.format_text
JuliaFormatter.format_file
JuliaFormatter.format_md
JuliaFormatter.DefaultStyle
JuliaFormatter.YASStyle
JuliaFormatter.BlueStyle
JuliaFormatter.SciMLStyle
JuliaFormatter.MinimalStyle
```

## Internal API

Note that these are subject to change in any version (even patches), and the docstrings are not necessarily up to date!

```@autodocs
Modules = [JuliaFormatter, JuliaFormatter.Shims]
Filter = t -> !(t in (format, format_text, format_file, format_md, DefaultStyle, YASStyle, BlueStyle, SciMLStyle, MinimalStyle))
```

## [PackageCompiler.jl](@id packagecompiler)

By default, each time JuliaFormatter is launched, it will incur some startup cost due to JIT compilation.
This is the (infamous) TTFX that Julia has in general.

Although recent releases of JuliaFormatter are substantially faster due to intelligent usage of precompilation, the TTFX can still be a problem in the following circumstances:

- If you are using JuliaFormatter v1 (which can be quite painfully slow sometimes)
- If you are running JuliaFormatter frequently, e.g. via pre-commit

which is to say, in many common scenarios!

To mitigate this problem, you can use [PackageCompiler.jl](https://julialang.github.io/PackageCompiler.jl/) to create a custom sysimage that includes cached precompiled code.
While this one-time setup can be quite a bit of a hassle, the benefits can be quite substantial, with speedups of 10x being quite common in practice for JuliaFormatter v1.

Here is a step-by-step walkthrough of how to do this:

1. Make a scratch directory to do stuff in.

   ```bash
   mkdir scratch
   cd scratch
   ```

1. Download any Julia codebase that is large enough and contains code that is representative of the code you want to format.

   When generating the compiled sysimage, we will format this codebase.
   The choice of codebase can affect the results because the precompilation process will cache code paths that are encountered during this formatting, meaning that you should obtain the largest speedups if you choose a codebase that is similar (or identical!) to the code you will be formatting in the future.
   
   As an example, we'll use the Julia base repository itself.

   ```bash
   git clone --depth 1 --branch v1.11.9 https://github.com/JuliaLang/julia.git
   cd julia
   ```

1. Now launch Julia with the following flags:

   ```bash
   julia --startup-file=no --compile=yes -O3 --threads=auto
   ```

1. And run the following in the Julia REPL.
   **Note that the version of JuliaFormatter you install here will be the version that is used to format your code.**

   ```bash
   using Pkg
   Pkg.activate(; temp=true)
   Pkg.add(name="JuliaFormatter", version="2") # Or your preferred version
   Pkg.add("PackageCompiler")

   # Write the precompilation workload to a file.
   open("precompile_file.jl", "w") do io
       write(io, "using JuliaFormatter; format(\".\")")
   end

   # Generate a sysimage with that workload.
   using PackageCompiler
   create_sysimage(
       ["JuliaFormatter"];
       sysimage_path="../juliaformatter.so",
       precompile_execution_file="precompile_file.jl"
   )
   ```

1. Now you should have a sysimage file in the `scratch` directory you made just now (but of course you can change that `sysimage_path` if you prefer).
   Move it to somewhere that is more permanent.
   Once you have done so, you can delete the entire `scratch` directory.

1. After that, to run JuliaFormatter, you can launch Julia as follows:

   ```bash
   julia --startup-file=no --threads=auto -J SYSIMAGE_PATH -O0 --compile=min -e 'using JuliaFormatter; format(".")'
   ```

   where `SYSIMAGE_PATH` is the path to the sysimage you generated in the previous steps.

This is the basic process: you can tweak any aspect of this to your liking, for example, by wrapping the final `julia` invocation in a script/function that takes a path as an argument and passes it into the `julia` call.
For some ideas, see e.g. [this issue](https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/633#issuecomment-1518805248) and [this Gist](https://gist.github.com/penelopeysm/9338c160eeb05437205535c2edcf80ee).

### Subsequent usage with `pre-commit`

Once you have generated the sysimage, you can make a custom `pre-commit` hook that uses it, like so:

```yaml
repos:
- repo: local
  hooks:
  - id: format
    name: format
    language: system
    entry: julia --startup-file=no ... # The same command as above.
```

Unfortunately, there is one finicky bit with this approach, which relates to the fact that *your* sysimage is not portable across machines.
This means that you probably should not commit the above `.pre-commit-config.yaml` to source control, as it won't work for other people who clone your repository.
To get around this, you can do one of the following, depending on whether your repository already has a `.pre-commit-config.yaml` file.

- If you *don't* have one yet, then you can add `.pre-commit-config.yaml` to `.git/info/exclude`.
  This file behaves exactly like `.gitignore`, except that it is user-specific (i.e., you aren't stopping anyone else from adding a `.pre-commit-config.yaml` file).

- If you *already* have one, for example a pre-commit config that uses the slower path, then you just want to make sure that you don't commit your local changes.
  To do this you can run

  ```bash
  git update-index --skip-worktree .pre-commit-config.yaml
  ```

  This tells git to ignore any local changes you make to the file.

# Project status

([Penny speaking here](https://github.com/penelopeysm); my views are only my own, etc. etc.)

This is a less formal page, where I discuss the current state of JuliaFormatter development and some long-term goals.

## Update - 25 June 2026

Since I wrote this page, a lot of work has gone into making JuliaFormatter v2 more reliable, with fewer cases where formatting changes the meaning of code, fails, or is non-idempotent.
These efforts have so far mainly been focused on Default and Blue styles.
These two styles are now tested extensively on around 5 million lines of Julia code in CI, and I believe that they are now much more reliable than they were in previous v2 releases.

Note that, as described in the [Formatting Options](@ref formatting-options) page, to guarantee idempotence it is recommended that you set certain options:

- `v2_stable_multiline_strings = true`
- `conditional_to_if = false`
- `pipe_to_function_call = false`

Without these, idempotence cannot be guaranteed.

**I would say that as of v2.10, Default and Blue styles are ready for general usage.**
While it is possible that there will be some changes to the output as a result of other bug fixes, formatting should largely stay unchanged going forwards.

However, SciMLStyle and YASStyle are still quite buggy, and I would not (yet) recommend using them in v2.
(Unfortunately, they also contain a lot of custom code, which is why I have put them off for now, and also why I have much less motivation to fix them...)
JuliaFormatter v1 might still be the safer option for these styles.

PRs to improve SciML and YAS styles are very welcome!

## Stability

At present, I do not consider it possible to outright guarantee that formatted output will not change between versions.

That is to say, the version of JuliaFormatter guarantees its public library API, along with its configuration options.
However, I cannot give a blanket guarantee that v2.p.q will not change the formatting of v2.r.s.
(Note that this is consistent with the way that JuliaFormatter has been developed to date.)

The main reason for this is because JuliaFormatter v2 still contains a number of bugs, *in particular*, with SciML and YAS styles.
With Default and Blue styles the situation is much better, and it is likely that there will be fewer changes in formatting between versions; however, I can't *promise* this.

A secondary reason is that the codebase is in what I consider to be a local minimum.
It often happens to work, but there are for example several functions which are overloaded in different places for different purposes.
There is definitely some refactoring needed to make the code easier to maintain and easier to improve.
It is very hard to do this without breaking _some_ formatting _somewhere_.

Another lesser point is that JuliaFormatter is designed to be customisable and it's not trivial at all to predict how the introduction of a new formatting option interacts with the rest of the codebase.

### Pinning the JuliaFormatter version

**If you want absolute stability, you should pin the version of JuliaFormatter you use.
In fact, I believe that even if JuliaFormatter *was* more stable, pinning the version is *still* a good idea.**
It's common to just let CI use 'v2' of JuliaFormatter or something similar, which will naturally resolve to the most recent version each time CI is run.
**In my opinion this is bad practice.**

The reason for this is because formatting changes should be separate from other code changes, and should be only introduced as part of an intentional upgrade.
This avoids noisy diffs, and also plays well with the `git blame --ignore-rev` option: if you have a commit that consists only of formatting changes, you can add that to `.git-blame-ignore-revs`, and GitHub/GitLab will ignore that commit when showing the history of a file (see e.g. [this post](https://andreynautilus.github.io/posts/2025-08-23-git-blame-ignore/)).

On top of that, there's really no reason why one should ever want to upgrade to the *latest* version of JuliaFormatter *unless* you specifically want to take advantage of new features or bug fixes.
If you are already happy with v2.p.q then v2.r.s is not going to offer you anything better than that.
You should just pin that version and be done with it.

## What to look forward to in v3?

[You can see this issue for more info about what I'd generally like to have in v3.](https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/1033)

However, to throw a spanner in the works: *I don't actually think that v3 of JuliaFormatter is the right way to do this.*
I think that it's better to do this in a separate package.

There are several reasons for this:

1. I'd really like to make a clean break from the current aims of JuliaFormatter.
   I think that the extreme customisability makes it difficult to maintain.

1. It would be essentially a massive rewrite anyway.

1. While the above can still happen in a new major version, if anything, my experience of v1 -> v2 has shown that having two different versions of a formatter is a pain point for users.
   For example, you can't install both versions in the same environment.
   Also, since JuliaFormatter is bundled with LanguageServer.jl, it is quite difficult to use a different version of JuliaFormatter from whatever it ships with.
   Although creating a new formatter [runs a risk](https://xkcd.com/927/), it avoids the problem of having to somehow juggle two (or three) different versions of the same package.

# [How It Works](@id how-it-works)

JuliaFormatter works in several stages:

1. Parsing the source code to generate a _concrete syntax tree_ (CST).

2. Generating a _formatted syntax tree_ (FST) from the CST.
   This is not a formal term; it's just a term that's used internally to represent a CST with additional formatting-specific metadata, such as placeholders indicating spots where newlines can be inserted.

3. Nesting the FST, i.e., determining where newlines should be inserted.

4. Printing the FST to text.

These stages are described in more detail below.


## Parsing: `String -> CST`

A [concrete syntax tree](https://en.wikipedia.org/wiki/Parse_tree) differs from the more familiar [_abstract_ syntax tree](https://en.wikipedia.org/wiki/Abstract_syntax_tree) in that it retains all information in the source code that is not semantically relevant, such as whitespace, extra parentheses, and comments.

In particular, JuliaFormatter v2.5 uses [JuliaSyntax.jl v1](https://github.com/JuliaLang/JuliaSyntax.jl) as its CST parser.
Here is an example of a CST:

```@example howitworks
using JuliaSyntax: parseall, GreenNode

text = "x = f(y + z) # comment"
cst = parseall(GreenNode, text)
```

In this example, you can see that JuliaSyntax has generated a tree structure.
The numbers on the left-hand side indicate the byte offsets of each node in the original source code.

Notice that the whitespace and comment in the original source code is preserved in the CST.
In contrast, an AST, generated e.g. using `Meta.parse`, would discard this information.
In principle, we could pretty-print the AST and thus reconstruct "formatted" code with the same semantics.
However, this would not be ideal since we would lose (for example) comments as well as the original parenthesisation of expressions, which a user may have intentionally added for readability.

```@example howitworks
dump(Meta.parse(text))
```

!!! note
    The CST parsing backend has varied across versions.
    JuliaFormatter v2 - v2.4 used JuliaSyntax.jl v0, and JuliaFormatter v1 used [CSTParser.jl](https://github.com/julia-vscode/CSTParser.jl).

## Generating an `FST`

From the CST we transform it into a slightly richer representation, which is internally called an FST.
The FST is very similar to the CST, but it contains additional information that is specific to formatting.

For example, the CST is very lightweight: it actually does not store any strings for the various nodes, only byte offsets.
When generating the FST, we use the byte offsets plus the original source code to extract the relevant substrings and store them in the FST.

```@example howitworks
using JuliaFormatter: State, Document, Options, pretty, DefaultStyle

state = State(Document(text), Options(; margin=10))
fst = pretty(DefaultStyle(), cst, state)
```

In this very simple example here, `margin=10` does not actually affect the FST.
However, in general, the style as well as the options passed in here will affect the structure of the generated FST, either via multiple dispatch, or via the `state.opts` field.

Notice that each node in this tree contains a `val` field, which is the string corresponding to that node in the CST.
On top of that, there are some mysterious `PLACEHOLDER` nodes, which are not present in the CST.
These indicate potential locations where we can insert newlines when we later _nest_ the FST.
For example, in the string `x = f(y + z)` we can insert a newline in several places:

```
x = f( y + z )
   ^  ^   ^ ^
```

Each of these potential newline locations is represented by a `PLACEHOLDER` node in the FST.

Several other transformations happen at this stage:

- Code and comments are indented to match surrounding code blocks.
- Unnecessary whitespace is removed (although newlines in between code blocks are untouched).
- Code is flattened as much as possible. For example, if an expression can be put on a single line, it will be: it doesn't matter if it's over the margin or not at this stage.
  However, if the expression has a block-like structure to it, such as a `try`, `if`, or a `struct` definition, it will be spread across multiple lines appropriately:

The important invariant underpinning a FST is any two strings that are syntactically the same (ignoring whitespace) will produce an identical `FST`.
For example:

```julia
a = 
       foo(a,                     b,           
       c,d)
```

and

```julia
a =                      foo(a,
b,
c,d)
```

will produce the same FST, which when printed would look like `a = foo(a, b, c, d)`.

## Nesting the FST

At this point we have not actually yet decided which of these (if any) need to be converted into newlines.
This depends on, for example, the margin.
We can see how this affects the output here:

```@example howitworks
using JuliaFormatter: format_text

format_text(text; margin=40) |> print
```

```@example howitworks
format_text(text; margin=10) |> print
```

The decision on where to insert newlines is made in the nesting stage, which converts `PLACEHOLDER` nodes to `NEWLINE` nodes as needed.
Recall that above we specified `margin=10`.
This will cause the `nest!` function to insert newlines such that no line exceeds 10 characters.
Just as before, the style and options passed in here will affect the decisions made inside `nest!`.

```@example howitworks
using JuliaFormatter: nest!

nest!(DefaultStyle(), fst, state)
fst
```

## Printing the FST

Once the FST has been nested the rest is straightforward: traverse the tree and print it out into a string!

```@example howitworks
using JuliaFormatter: print_tree

io = IOBuffer()
print_tree(io, fst, state)
String(take!(io)) |> print
```

# [Blue Style](@id blue-style)

```@docs; canonical=false
BlueStyle
```

## Configuration File Example

The `.JuliaFormatter.toml` which represents these settings is

```toml
style = "blue"
```

Or to use `BlueStyle` except change one of the settings:

```toml
style = "blue"
remove_extra_newlines = false
```

## Direct Usage

```julia
format("file.jl", BlueStyle())
```

Or to use `BlueStyle` except change one of the settings:

```julia
format("file.jl", BlueStyle(), remove_extra_newlines=false)
```

# Running Julia code

- If you have a Julia MCP tool, always run code with that.
  Don't invoke julia from bash as that is very slow.

- To investigate formatting with JuliaFormatter, use the `julia_format` tool.
  The first time you run it, you need to specify `formatter_path=...` with the local checkout of JulaiFormatter.

- To run generic Julia code, use the `julia_eval` tool.
  Avoid passing a specific `env_path` as that will clutter the user's environment.
  In the absence of an `env_path`, the tool will create a temporary environment for you.
  In this environment you can `Pkg.develop(; path=...)` the local checkout of JuliaFormatter and add any other packages you need.

- Code changes in the local checkout should be immediately visible without having to reload the session (thanks to Revise.jl).
  If you encounter any issues with this, try restarting the MCP session.

# Tracing JuliaFormatter's output

- Always use the `JuliaFormatter.Internal.format_to_stage` function to inspect the output of each stage of the formatting process.
  If `s` is a string containing the code to be formatted, then `format_to_stage(stage, s[, style]; options...)` will give the output of the specified stage, where `stage` is one of:

  - `:cst` gives the CST from JuliaSyntax;
  - `:fst` gives the initial FST that JuliaFormatter constructs from the CST using `pretty()`;
  - `:nest` gives the FST after flattening, alignment, and nesting;
  - `:out` gives the final formatted string;
  - `:print` prints the final formatted string.

  If `format_text` generates invalid Julia code, it will throw, which is unhelpful for debugging.
  In such cases you should use `format_to_stage(:out, ...)` as that will show you the actual invalid code.

# Running tests

- Do NOT run complete segments of the test suite unless explicitly instructed to.
  Only run specific, targeted tests that are relevant to the changes you are making, using `JuliaFormatter.Internal.test_format(input_string, expected_output[, style]; options...)`
  This function checks that formatting `input_string` produces `expected_output`, and also for idempotence.
  It also prints helpful information if it fails so that you can easily debug the issue.

- To test whether a string is valid Julia code, you can use `Meta.parse(s)` or `format_to_stage(:cst, s)`. Both throw if the code is invalid.

# Comment style

JuliaFormatter is a complex codebase with many moving parts.
Do not assume that other developers will understand terse comments as they do not have the same context as you.
For example, when writing function-level comments, it's useful to illustrate your point with a concrete example of code that is being formatted.

# Avoid hacks

- Do not write off any valid syntactic construct as "pathological" or not worth supporting.
  ALL valid Julia code should be supported by the formatter, even if it's not common in practice.

- Do not use fragile heuristics or hacks to achieve the desired formatting.
  Where possible, you should always try to implement formatting logic at the CST stage (i.e. `pretty()`), because the CST has more precise structural information about the code being run.

# Options

The content on this page has been split up into [Formatting Options](@ref formatting-options) and [File Options](@ref file-options).

File options refer to those which can only be used in [`.JuliaFormatter.toml` configuration files](@ref config) (they control the overall behaviour of JuliaFormatter when run on a filesystem).

# [Custom Alignment](@id custom-alignment)

Custom alignment is a scenario where extra whitespace is inserted into the formatted output to make sure that tokens (typically operators, such as `=`, `?`, and `::`) on contiguous lines are vertically aligned.
This was implemented as a solution for [issue 179](https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/179).

Custom alignment is determined by a whitespace heuristic.
Since JuliaFormatter usually only outputs either 0 or 1 spaces as separations between tokens, the presence of more than one space between tokens is used as a signal to trigger custom alignment.
If a formatter detects that a token is custom-aligned, then all tokens in the same code block (i.e., contiguous lines, not separated by comments or empty lines) will be aligned to the furthest aligned token.

!!! warning
    If active, custom alignment will override pre-existing nesting behaviour.
    This means that lines can exceed the maximum margin.

Custom alignment must be opted into via [the configuration options](@ref formatting-options) `align_assignment`, `align_conditional`, `align_matrix`, `align_pair_arrow`, and `align_struct_field`.

### Example

Suppose the source text is as follows:

```julia
const variable1 = 1
const var2      = 2
const var3 = 3
const var4 = 4
const var5          = 5
```

If the option `align_assignment=true` is set, the formatter will detect that `var2` is aligned to `variable1` *and* that `var2` has more than 1 space prior to its `=`.
Since `var3`,`var4`, and `var5` are part of the same code block (no comments or newlines separating code) their `=` operators will then be aligned to `var2`'s `=`, which is the furthest aligned token.

The resulting output would be

```julia
const variable1 = 1
const var2      = 2
const var3      = 3
const var4      = 4
const var5      = 5
```

Notice how the `=` operator for `var5` is correctly positioned despite it being located further to the right than other `=` operators in the original source.

However, if the source code is

```julia
const variable1 = 1
const variable2 = 2
const var3 = 3
const var4 = 4
const var5 = 5
```

it is now not clear whether the user intended for this to be aligned and so the formatter will not inject any custom behaviour.

## Alignment Options

In order for custom alignment to occur, the corresponding option must be set to `true`. Available options:

- `align_assignment`
- `align_struct_field`
- `align_conditional`
- `align_pair_arrow`
- `align_matrix`

### `align_assignment`

Align `=`-like operators.
This covers variable assignments and short definition functions.

Here are some examples of code formatted with `align_assignment=true`:

```julia
const UTF8PROC_STABLE    = (1 << 1)
const UTF8PROC_COMPAT    = (1 << 2)
const UTF8PROC_COMPOSE   = (1 << 3)
const UTF8PROC_DECOMPOSE = (1 << 4)
const UTF8PROC_IGNORE    = (1 << 5)
const UTF8PROC_REJECTNA  = (1 << 6)
const UTF8PROC_NLF2LS    = (1 << 7)
const UTF8PROC_NLF2PS    = (1 << 8)
const UTF8PROC_NLF2LF    = (UTF8PROC_NLF2LS | UTF8PROC_NLF2PS)
const UTF8PROC_STRIPCC   = (1 << 9)
const UTF8PROC_CASEFOLD  = (1 << 10)
const UTF8PROC_CHARBOUND = (1 << 11)
const UTF8PROC_LUMP      = (1 << 12)
const UTF8PROC_STRIP     = (1 << 13)


vcat(X::T...) where {T}         = T[X[i] for i = 1:length(X)]
vcat(X::T...) where {T<:Number} = T[X[i] for i = 1:length(X)]
hcat(X::T...) where {T}         = T[X[j] for i = 1:1, j = 1:length(X)]
hcat(X::T...) where {T<:Number} = T[X[j] for i = 1:1, j = 1:length(X)]

a  = 1
bc = 2

long_variable = 1
other_var     = 2
```

### `align_struct_field`

Align struct field definitions to `::` or `=`, whichever has higher precedence.

```julia
Base.@kwdef struct Options
    indent::Int                            = 4
    margin::Int                            = 92
    always_for_in::Bool                    = false
    whitespace_typedefs::Bool              = false
    whitespace_ops_in_indices::Bool        = false
    remove_extra_newlines::Bool            = false
    import_to_using::Bool                  = false
    pipe_to_function_call::Bool            = false
    short_to_long_function_def::Bool       = false
    always_use_return::Bool                = false
    whitespace_in_kwargs::Bool             = true
    annotate_untyped_fields_with_any::Bool = true
    format_docstrings::Bool                = false
    align_struct_fields::Bool              = false

    # no custom whitespace so this block is not aligned
    another_field1::BlahBlahBlah = 10
    field2::Foo = 10

    # no custom whitespace but single line blocks are not aligned
    # either way
    Options() = new()
end


mutable struct Foo
    a             :: T
    longfieldname :: T
end
```

### `align_conditional`

Align conditional expressions to either `?`, `:`, or both.

```julia
# This will remain like this if using YASStyle
index = zeros(n <= typemax(Int8)  ? Int8  :
              n <= typemax(Int16) ? Int16 :
              n <= typemax(Int32) ? Int32 : Int64, n)

# Using DefaultStyle
index = zeros(
    n <= typemax(Int8)  ? Int8  :
    n <= typemax(Int16) ? Int16 :
    n <= typemax(Int32) ? Int32 : Int64,
    n,
)

# Note even if the maximum margin is set to 1, the alignment remains intact
index =
    zeros(
        n <= typemax(Int8)  ? Int8  :
        n <= typemax(Int16) ? Int16 :
        n <= typemax(Int32) ? Int32 : Int64,
        n,
    )
```

### `align_pair_arrow`

Align pair arrows (`=>`).

```julia
pages = [
    "Introduction"        => "index.md",
    "How It Works"        => "how_it_works.md",
    "Code Style"          => "style.md",
    "Skipping Formatting" => "skipping_formatting.md",
    "Syntax Transforms"   => "transforms.md",
    "Custom Alignment"    => "custom_alignment.md",
    "Custom Styles"       => "custom_styles.md",
    "YAS Style"           => "yas_style.md",
    "Configuration File"  => "config.md",
    "API Reference"       => "api.md",
]
```

# [Formatting Options](@id formatting-options)

JuliaFormatter is intended to be configurable and comes with a number of options to control the output of the formatter.
Suggestions for more options are welcome; please open an issue!

All of these [_formatting options_](@ref formatting-options) can be specified as:

- keyword arguments to [`JuliaFormatter.format`](@ref), [`JuliaFormatter.format_text`](@ref) and [`JuliaFormatter.format_file`](@ref)
- entries in a [`.JuliaFormatter.toml`](@ref config) file, or
- command-line arguments to the [`jlfmt`](@ref cli) command.

!!! note "File options"
    `.JuliaFormatter.toml` and `jlfmt` further accept additional options that control which files are to be formatted.
    These options are not passed to `format` and friends, and are thus categorised as _file options_ instead: please see the [File Options](@ref file-options) page for more deatils.

Below is a table of all the currently available formatting options, along with what each style sets each option to.
Values that differ from `DefaultStyle` are shown in **bold**.

Note that, although styles each define a different set of options, they are not _just_ collections of options; they also have unique formatting rules that are not captured by the options.

## A note about options

Not all options are created equal.
This section is intended to help you understand the implications of enabling certain options.

### Syntax transformations

**Some of the options below are more dangerous than others, because they perform syntax transformations** (i.e., `Meta.parse(format_text(s))` may not be equal to `Meta.parse(s)`).
These options can therefore change the meaning of the code being formatted depending on the context, and should be used with caution.

To help you identify dangerous options, there is an emoji legend in the 'Kind' column:

- 📐: purely about whitespace
- ♻️: syntax normalisation — this does more than just whitespace as it can insert e.g. parentheses, but it does not change the AST in any way
- ⚠️: syntax transformation — this does change the AST, but the transformations are conservatively scoped and thus should be safe
- 🔥: dangerous syntax transformation — this can change the AST, and it is not actually possible to be conservative because that would defeat the entire purpose of the option.

Currently, only [**`pipe_to_function_call`**](@ref options-pipe-to-function-call) is in the last category.
**Note that YASStyle and BlueStyle both enable `pipe_to_function_call` by default, so if you use either of those styles, you should be aware that this can change the meaning of your code!**

As a guard against unwanted syntax transformations, by default, JuliaFormatter does not perform any syntax transformations inside macros or Exprs.

This can be overly cautious in some cases: many macros, such as `@test` and `@inline`, are completely agnostic to their contents.
If you want to enable selected syntax transformations inside macros, you can [set `transform_syntax_in_macros` to `true`](@ref options-transform-syntax-in-macros).
However, there is no option to enable syntax transformations inside `Expr`s as that changes the literal meaning of the `Expr`.

### Options that can spoil idempotence

Some of the options below additionally have the potential to cause non-idempotent formatting if enabled (or, in the case of [`v2_stable_multiline_strings`](@ref options-v2-stable-multiline-strings), if disabled).
They are marked with a 🪃 emoji.

If you want to ensure idempotence, it is recommended to disable these options.
If you absolutely must enable them, you may need to run the formatter multiple times to reach a fixed point: you can use the [`max_iterations`](@ref options-max-iterations) option to control the number of passes JuliaFormatter will do.

| Option                                                                              | Kind  | Default   | YAS         | Blue        | SciML        | Minimal       |
| :-------                                                                            | ----- | --------- | -----       | ------      | -------      | ---------     |
| [`align_assignment`](@ref options-align-star)                                       | 📐    | `false`   | `false`     | `false`     | `false`      | `false`       |
| [`align_conditional`](@ref options-align-star)                                      | 📐    | `false`   | `false`     | `false`     | `false`      | `false`       |
| [`align_matrix`](@ref options-align-matrix)                                         | 📐    | `false`   | `false`     | `false`     | `false`      | `false`       |
| [`align_pair_arrow`](@ref options-align-star)                                       | 📐    | `false`   | `false`     | `false`     | `false`      | `false`       |
| [`align_struct_field`](@ref options-align-star)                                     | 📐    | `false`   | `false`     | `false`     | `false`      | `false`       |
| [`always_for_in`](@ref options-always-for-in)                                       | ♻️    | `false`   | **`true`**  | **`true`**  | **`true`**   | **`nothing`** |
| [`always_use_return`](@ref options-always-use-return)                               | ⚠️    | `false`   | **`true`**  | **`true`**  | `false`      | `false`       |
| [`annotate_untyped_fields_with_any`](@ref options-annotate-untyped-fields-with-any) | ⚠️    | `true`    | `true`      | **`false`** | `true`       | **`false`**   |
| [`conditional_to_if`](@ref options-conditional-to-if)                               | 🪃 ♻️ | `false`   | `false`     | **`true`**  | `false`      | `false`       |
| [`disallow_single_arg_nesting`](@ref options-disallow-single-arg-nesting)           | 📐    | `false`   | `false`     | `false`     | **`true`**   | `false`       |
| [`enforce_triplequoted_docstrings`](@ref options-enforce-triplequoted-docstrings)   | ⚠️    | `true`    | `true`      | `true`      | `true`       | `true`        |
| [`for_in_replacement`](@ref options-for-in-replacement)                             | ♻️    | `"in"`    | `"in"`      | `"in"`      | `"in"`       | `"in"`        |
| [`force_long_function_def`](@ref options-force-long-function-def)                   | ⚠️    | `false`   | `false`     | `false`     | `false`      | `false`       |
| [`format_docstrings`](@ref options-format-docstrings)                               | ⚠️    | `false`   | `false`     | `false`     | `false`      | `false`       |
| [`import_to_using`](@ref options-import-to-using)                                   | ⚠️    | `false`   | **`true`**  | **`true`**  | `false`      | `false`       |
| [`indent`](@ref options-indent)                                                     | 📐    | `4`       | `4`         | `4`         | `4`          | `4`           |
| [`indent_binary_continuations`](@ref options-indent-binary-continuations)           | 📐    | `false`   | `false`     | `false`     | `false`      | **`true`**    |
| [`indent_submodule`](@ref options-indent-submodule)                                 | 📐    | `false`   | `false`     | **`true`**  | `false`      | `false`       |
| [`join_lines_based_on_source`](@ref options-join-lines-based-on-source)             | 📐    | `false`   | **`true`**  | `false`     | **`true`**   | **`true`**    |
| [`long_to_short_function_def`](@ref options-long-to-short-function-def)             | ⚠️    | `false`   | `false`     | `false`     | `false`      | `false`       |
| [`margin`](@ref options-margin)                                                     | 📐    | `92`      | `92`        | `92`        | `92`         | **`10_000`**  |
| [`max_iterations`](@ref options-max-iterations)                                     |       | `1`       | `1`         | `1`         | `1`          | `1`           |
| [`normalize_line_endings`](@ref options-normalize-line-endings)                     | 📐    | `"auto"`  | `"auto"`    | `"auto"`    | **`"unix"`** | `"auto"`      |
| [`pipe_to_function_call`](@ref options-pipe-to-function-call)                       | 🪃 🔥 | `false`   | **`true`**  | **`true`**  | `false`      | `false`       |
| [`remove_extra_newlines`](@ref options-remove-extra-newlines)                       | 📐    | `false`   | **`true`**  | **`true`**  | **`true`**   | `false`       |
| [`sciml_margin_overrun`](@ref options-sciml-margin-overrun)                         | 📐    | unused    | unused      | unused      | **`20`**     | unused        |
| [`separate_kwargs_with_semicolon`](@ref options-separate-kwargs-with-semicolon)     | ⚠️    | `false`   | **`true`**  | **`true`**  | `false`      | `false`       |
| [`short_circuit_to_if`](@ref options-short-circuit-to-if)                           | ⚠️    | `false`   | `false`     | `false`     | `false`      | `false`       |
| [`short_to_long_function_def`](@ref options-short-to-long-function-def)             | ⚠️    | `false`   | **`true`**  | **`true`**  | **`true`**   | `false`       |
| [`surround_whereop_typeparameters`](@ref options-surround-whereop-typeparameters)   | ♻️    | `true`    | `true`      | `true`      | `true`       | **`false`**   |
| [`trailing_comma`](@ref options-trailing-comma)                                     | ♻️    | `true`    | `true`      | `true`      | **`false`**  | **`nothing`** |
| [`trailing_zero`](@ref options-trailing-zero)                                       | ♻️    | `true`    | `true`      | `true`      | `true`       | **`false`**   |
| [`transform_syntax_in_macros`](@ref options-transform-syntax-in-macros)             | ⚠️    | `false`   | `false`     | `false`     | `false`      | `false`       |
| [`v2_stable_multiline_strings`](@ref options-v2-stable-multiline-strings)           | 🪃 📐 | `false`   | `false`     | `false`     | `false`      | `false`       |
| [`variable_call_indent`](@ref options-variable-call-indent)                         | 📐    | `[]`      | `[]`        | `[]`        | `[]`         | `[]`          |
| [`whitespace_in_kwargs`](@ref options-whitespace-in-kwargs)                         | 📐    | `true`    | **`false`** | **`false`** | `true`       | **`false`**   |
| [`whitespace_ops_in_indices`](@ref options-whitespace-ops-in-indices)               | 📐    | `false`   | **`true`**  | **`true`**  | **`true`**   | `false`       |
| [`whitespace_typedefs`](@ref options-whitespace-typedefs)                           | 📐    | `false`   | `false`     | `false`     | **`true`**   | `false`       |
| [`yas_style_nesting`](@ref options-yas-style-nesting)                               | 📐    | `false`   | `false`     | `false`     | `false`      | `false`       |

## [`align_...`](@id options-align-star)

Default: `false`

The `align_assignment`, `align_conditional`, `align_pair_arrow`, and `align_struct_field` options allow you to vertically align operators on consecutive lines.
See the [`Custom Alignment`](@ref custom-alignment) page for more details and examples.

## [`align_matrix`](@id options-align-matrix)

Default: `false`

If enabled, this option preserves pre-existing whitespace surrounding matrix elements in the original source file.
If you want to align matrix elements yourself, you should set this to `true`.

```@example align-matrix
using JuliaFormatter: format_text

# Elements left-aligned in original source
s = """
a = [
100 300 400
1   eee 40000
2   α   b
]"""

format_text(s, align_matrix=true) |> print
```

```@example align-matrix
# Elements right-aligned in original source
s = """
a = [
100 300   400
  1  ee 40000
  2   a     b
]"""

format_text(s, align_matrix=true) |> print
```

## [`always_for_in`](@id options-always-for-in)

Default: `false`

If `true`, iterators e.g. in `for` loops will always be formatted with `in` instead of `=`.
The default replacement is `in`, but this can be changed with the [`for_in_replacement`](@ref options-for-in-replacement) option.
For example, to replace all `=` and `in` with `∈` in iterators, set `for_in_replacement` to `"∈"`.

If `false`, JuliaFormatter still performs a very specific normalisation: for *range iterators*, e.g. `for i = 1:10`, JuliaFormatter uses `=`.
For all other iterators, `in` is used.

If `nothing`, the choice between `in` and `=` is left to the user, and no normalisation is performed.

!!! Setting an option to `nothing` in .JuliaFormatter.toml
    TOML does not have a null value. To specify a `nothing` value in a `.JuliaFormatter.toml` file, set the option to the string `"nothing"`, e.g. `always_for_in = "nothing"`.

## [`always_use_return`](@id options-always-use-return)

Default: `false`

If true, `return` will be prepended to the last expression in function definitions, macro definitions, and do blocks.

For example:

```@example always-use-return
s = """
function foo()
    expr1
    expr2
end"""

using JuliaFormatter: format_text
format_text(s; always_use_return=true) |> println
```

A number of cases are skipped over:

- If the final expression is (already) `return`.
- If the final expression is a macro.
- If the final expression is a multiline block expression (e.g. `if...end`, `begin...end`, etc.). This includes calls with do blocks.
- If the final expression contains a `return` statement somewhere in it (e.g. `cond ? (return 1) : (return 2)`).
- If the final expression has a docstring attached to it.

Note that `return` *is* prepended to calls to functions such as `throw(...)`  and `error()`.
If you don't want this behaviour, add a `return nothing` at the end of the function (or just disable this option!).
Click the "Show explanation" toggle below for a more detailed explanation of why I choose *not* to do this.
(You may also be interested in [the corresponding discussion on Runic.jl](https://github.com/fredrikekre/Runic.jl/issues/202), which has the same behaviour.)

!!! details "Show explanation for always_use_return"

    There are several reasons why I don't want to carve out an exception for `throw(...)`.

    The first is pragmatic.
    Previous versions of JuliaFormatter implemented `always_use_return` at the FST level, that is to say, it would construct an `FST` and *then* insert `return` in (usually...) the right place.
    This, however, causes idempotence issues because the formatting of the return value can depend on whether it is prepended with `return` or not.
    In other words, formatting choices are already baked into the FST before the `return` is inserted, and on the second formatting pass, the formatting choices may be different, which can lead to non-idempotence!

    To fix these bugs I moved the return insertion one stage prior, so that the FST is constructed *with* the `return` keyword from the start.
    However, this means that we don't have easy access to the identifier `throw`, not without a lot of incredibly finicky code to extract the CST node and then count the offsets carefully to find the identifier in the source text.

    While I *could* have implemented this, I'm unwilling to because of the second reason, which is more philosophical.
    I don't even really agree that `throw()` should be exempt from `return`.
    Firstly, `throw()` *does* have a type: it's `Union{}`, which is [a bottom type](https://en.wikipedia.org/wiki/Bottom_type).
    Sure, that type cannot be inhabited, i.e., there's no actual value that belongs to that type.

    However, from a theoretical point of view there's absolutely nothing wrong with "return"ing something that has type `Union{}`.
    It is vacuous, much like saying "select an element from an empty set", but that doesn't mean it's *wrong*; it's just *meaningless*.

    Furthermore, Julia's semantics are that the last statement in a block is the value it evaluates to.
    (This is not unique to Julia: see e.g. Haskell / OCaml / Rust.)
    If `throw(...)` could not be treated as a value, then following that logic, `throw()` should not even be *allowed* to be the last statement in a block.
    But clearly it can be!
    Correspondingly, there's no reason why returning it is wrong.

    The last reason is that it is impossible at the syntax level to determine what expressions are guaranteed to throw an exception (or more generally, what expressions are guaranteed to not return a value).
    For example, if we special-case `throw`, then one could argue that we should also special-case qualified calls like `Base.throw`, and other functions like `error` and `exit`, and then user-defined functions like

    ```julia
    mythrow(x) = throw("error: \$x")
    ```

    or constructs like

    ```julia
    function f()
        do_other_stuff()
        f()  # This never returns, so maybe we shouldn't add return?!
    end
    ```

    Obviously it doesn't make any sense to special-case any of that, so the only *principled* approach is not to special-case anything.
    I don't believe that JuliaFormatter should have an exception list that claims to do the right thing but cannot.

    Indeed, even if we could perform semantic analysis on the programme, it's not possible to determine such cases, because answering the question 'does this expression return a value' amounts to solving the halting problem.

## [`annotate_untyped_fields_with_any`](@id options-annotate-untyped-fields-with-any)

Default: `true`

Annotates fields in a type definitions with `::Any` if no type annotation is provided:

```@example annotate-untyped-fields-with-any
s = """
struct A
    arg1
end
"""

using JuliaFormatter: format_text
format_text(s; annotate_untyped_fields_with_any=true) |> println
```

## [`conditional_to_if`](@id options-conditional-to-if)

Default: `false`

If a ternary expression exceeds the margin, convert it into the equivalent `if` block:

```@example conditional-to-if
s = "cond ? trueval : falseval"

using JuliaFormatter: format_text
format_text(s; margin=20, conditional_to_if=true) |> println
```

!!! warning "Enabling this can cause lack of idempotence"
    
    Enabling `conditional_to_if` can cause non-idempotent formatting, because the `if` block may trigger different formatting choices compared to the ternary.

    For more details, click on the "Show explanation" toggle below.

!!! details "Show explanation for conditional_to_if"

    Here is an example of non-idempotence.
    As you can see it is very easy to trigger!

    ```@example conditional-to-if
    s = "foo(cond ? trueval : falseval)"
    length(s)
    ```

    Let's format this with a margin of 28.
    (Obviously, this is smaller than typical real-world margins; but this is chosen for the purposes of simplicity.
    With a margin of 92, you can still hit such cases easily with longer expressions, variable names, or indentation—basically, with real-world code!)

    On the first pass, two things happen:

    1. The function call's arguments are nested because the length of the arguments (including the ternary) exceeds the line margin.

    2. This at first leads to something like

       ```julia
       foo(
           cond ? trueval : falseval,
       )
       ```

       (this string itself is never materialised, but there is an intermediate data structure that essentially represents this).
       Now, because the ternary itself is still over the margin, the ternary is converted to `if...end`.

    Collectively, these steps give us the formatting of the first pass:

    ```@example conditional-to-if
    out1 = format_text(s; margin=28, conditional_to_if=true)
    println(out1)
    ```

    On the second time we format, the function call `foo(...)` sees that it has only one argument which is a block, and thus collapses the nesting (the logic being that the argument can handle the line-breaking itself):

    ```@example conditional-to-if
    out2 = format_text(out1; margin=28, conditional_to_if=true)
    println(out2)
    ```

    Fundamentally, the issue is that formatting choices for the function call `foo(...)` depend on whether or not the ternary is expanded or not, but by the time the ternary is expanded, the function call has already been formatted.

## [`disallow_single_arg_nesting`](@id options-disallow-single-arg-nesting)

Prevents the nesting of a single argument `arg` in parenthesis, brackets, and curly braces.

```julia
# Without `disallow_single_arg_nesting`:
function_call(
    "String argument"
)
[array_item(
    10
)]
{key => value(
    "String value"
)}

# With `disallow_single_arg_nesting` enabled:
function_call("String argument")
[array_item(10)]
{key => value("String value")}
```

## [`enforce_triplequoted_docstrings`](@id options-enforce-triplequoted-docstrings)

Default: `true`

Convert docstrings with single quotes to the equivalent triple-quoted form.

Only useful if [`format_docstrings`](@ref options-format-docstrings) is on.

```@example enforce-triplequoted-docstrings
using JuliaFormatter: format_text

s = """
"docstring"
function foo end
"""

format_text(s; format_docstrings=true, enforce_triplequoted_docstrings=true) |> println
```

```@example enforce-triplequoted-docstrings
format_text(s; format_docstrings=true, enforce_triplequoted_docstrings=false) |> println
```

## [`for_in_replacement`](@id options-for-in-replacement)

Can be used when [`always_for_in`](@ref options-always-for-in) is `true` to replace the default `in` with `∈` (`\\in`),
or `=` instead. The replacement options are `("in", "=", "∈")`.

```julia
for a = 1:10
end

# formatted with always_for_in = true, for_in_replacement = "∈"
for a ∈ 1:10
end
```

## [`force_long_function_def`](@id options-force-long-function-def)
Default: `false`

If `true`, tweaks the behavior of [`short_to_long_function_def`](@ref options-short-to-long-function-def) to force the transformation no matter how short the function definition is.

## [`format_docstrings`](@id options-format-docstrings)

Default: `false`

Format code docstrings with the same options used for the code source.

Markdown is formatted with [`CommonMark`](https://github.com/MichaelHatherly/CommonMark.jl) alongside Julia code.

!!! note "Invalid code"
    Invalid Julia code inside docstrings is silently ignored.
    This is because docstrings sometimes intentionally contain invalid code that is meant more as an illustration than as a working example.

## [`import_to_using`](@id options-import-to-using)

Default: `false`

If true, `import` expressions are rewritten to equivalent `using` expressions:

```@example import-to-using
s = """
import A
import B, C, D"""

using JuliaFormatter: format_text
format_text(s; import_to_using=true) |> println
```

There are some exceptions to this, which makes this transformation quite conservative:

- This transformation is disabled inside macros or `Expr`s.

- `import X as Y` cannot be rewritten in a semantically equivalent way, so is skipped.

- `import A.b` cannot be properly resolved (it may either be `using A: b` or `using A.b: b`), so is skipped.

- `import ..X` cannot be rewritten because `X` may not necessarily be a module.
  See e.g. [this issue](https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/723).

## [`indent`](@id options-indent)

Default: `4`

The number of spaces used for one level of indentation.

There is at present no option to use tabs for indentation: please open an issue if you want this feature.

## [`indent_binary_continuations`](@id options-indent-binary-continuations)

Default: `false`

Controls how the continuation lines of binary operations are laid out when the expression has to be split over several lines.

When set to `false`, the continuation lines are aligned with the opening line or operand:

```@example indent-binary-continuations
using JuliaFormatter: format_text

s = "x = a + b + c\nf(a + b + c)"
format_text(s; margin=2) |> println
```

When set to `true` they instead receive one indent level relative to the opening line:

```@example indent-binary-continuations
format_text(s; margin=2, indent_binary_continuations=true) |> println
```

Note that assignments, short-form function definitions, and the `=>` and `->` operators always use indentation-based nesting and are therefore unaffected by this option.

## [`indent_submodule`](@id options-indent-submodule)

Default: `false`

When set to `true`, submodule(s) appearing in the same file will be indented.

```julia
module A
a = 1

module B
b = 2
module C
c = 3
end
end

d = 4

end
```

will be formatted to:

```julia
module A
a = 1

module B
    b = 2
    module C
        c = 3
    end
end

d = 4

end
```

## [`join_lines_based_on_source`](@id options-join-lines-based-on-source)

Default: `false`

When `true` lines are joined as they appear in the original source file.

```julia
function foo(arg1,
                       arg2, arg3
                       )
       body
end
```

When `false` and the maximum margin is > than the length of `"function foo(arg1, arg2, arg3)"`
this is formatted to

```julia
function foo(arg1, arg2, arg3)
    body
end
```

When `true`, `arg1` and `arg2, arg3` will remain on separate lines even if they can fit on the
same line since it's within maximum margin. The indentation is dependent on the style.

```julia
function foo(arg1,
    arg2, arg3,
)
end
```

There are exceptions to this:

```julia
if a body1 elseif b body2 else body3 end
```

will be formatted to the following, even if this option is set to `true`:

```julia
if a
    body1
elseif b
    body2
else
    body3
end
```

!!! warning

    The maximum margin still applies even when this option is set to `true`.

## [`long_to_short_function_def`](@id options-long-to-short-function-def)

Default: `false`

Transforms a *long* function definition

```julia
function f(arg2, arg2)
    body
end
```

to a *short* function definition if the short function definition does not exceed the maximum margin.

```julia
f(arg1, arg2) = body
```

See also: [`short_to_long_function_def`](@ref options-short-to-long-function-def).

## [`margin`](@id options-margin)

Default: `92`

The maximum length of a line.
Code exceeding this margin will, in general, be formatted across multiple lines.

## [`max_iterations`](@id options-max-iterations)

Default: `1`

JuliaFormatter is *intended* to be idempotent, meaning that formatted code should not change if formatted again.
However, with certain options enabled, this may not be the case.
(Please see the top of this page for more information!)

This option exists in order to allow you to perform multiple rounds of formatting, if you wish to.
Note that this will cause formatting to be slower.
JuliaFormatter will format the code up to `max_iterations` times, stopping if the code is unchanged after a formatting pass.

## [`normalize_line_endings`](@id options-normalize-line-endings)

Default: `"auto"`

One of `"unix"` (normalize all `\r\n` to `\n`), `"windows"` (normalize all `\n` to `\r\n`), `"auto"` (automatically choose based on which line ending is more common in the file).

## [`pipe_to_function_call`](@id options-pipe-to-function-call)

Default: `false`

If true, `x |> f` is rewritten to `f(x)`, and `x .|> f` to `f.(x)`.

!!! danger "Semantics may be changed"

    **Note that this transformation may change the semantics of the code in
    some cases:**

    1. If `Base.:(|>)` is overloaded to have a different meaning for a given
       `f` and `x`.

    2. If the call to `x |> f` is intercepted by a macro that transforms it to 
       something other than `f(x)`. For example,
       [Pipe.jl](https://github.com/oxinabox/Pipe.jl).

    To avoid (2), JuliaFormatter refuses to apply this transformation within the
    body of a macro. However, there is no way to detect (1). As such,
    JuliaFormatter will emit a warning if this transformation is applied during
    formatting, to alert the user to the potential of unwanted changes.

    It is recommended to set this option to `true` only if you are confident
    that there are no such cases. **Note:** `pipe_to_function_call` is set to
    `true` by default for Blue and YAS styles, so in such cases you have to opt
    out manually!

!!! warning "This option may cause non-idempotent formatting"

    Enabling `pipe_to_function_call` can cause non-idempotent formatting, because the function call may trigger different formatting choices compared to the pipe.
    See [this issue](https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/1175) for an example.

    *In principle*, this can be fixed, since we can determine ahead of time when the pipe will be transformed into the function call.
    However, my current judgment is that this is not really worth it since it would make the codebase more complex and brittle.
    On top of that, it's probably not a good idea to enable `pipe_to_function_call` anyway.

## [`remove_extra_newlines`](@id options-remove-extra-newlines)

Default: `false`

If true, superfluous newlines will be removed. For example:

```julia
module M



a = 1

function foo()


    return nothing

end


b = 2


end
```

is rewritten as

```julia
module M

a = 1

function foo()
    return nothing
end

b = 2

end
```

Modules are the only type of code block where it is permissible to keep a single newline prior to the initial or after the final piece of code.

## [`sciml_margin_overrun`](@id options-sciml-margin-overrun)

Default: `20`

Additional columns `SciMLStyle` may use when a slightly over-margin line is
more readable than an aggressive line break.
Set this to `0` to make SciML soft-margin checks strict.

This option has no effect for other styles.

## [`separate_kwargs_with_semicolon`](@id options-separate-kwargs-with-semicolon)

Default: `false`

When set to `true`, keyword arguments in a function call will be separated with a semicolon.

```@example separate-kwargs-with-semicolon
s = "f(a, b = 1)"

using JuliaFormatter: format_text
format_text(s; separate_kwargs_with_semicolon=true) |> println
```

This transformation is disabled in several cases:

- Inside macros or `Expr`s.
- In the signature of a function definition. For example, these are different:

  ```julia
  function f(a, b = 1)  # b is an optional positional argument
      body
  end

  function f(a; b = 1)  # b is a keyword argument
      body
  end
  ```

- When the function call does not have a semicolon, but has positional arguments after keyword arguments.
  For example, `f(p, q=r, s)` is not transformed.
  See [this issue](https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/625) for details.

## [`short_circuit_to_if`](@id options-short-circuit-to-if)

If `true`, converts logical operators to the equivalent if-expression, if it is clear that the value is not used.

In particular, `a && f()` is converted to `if a; f(); end`, and `a || f()` is converted to `if !a; f(); end`.

```@example short-circuit-to-if
s = """
function foo(a, b)
    a || return "bar"
    b && return "ooo"
    return 5
end"""

using JuliaFormatter: format_text
format_text(s; short_circuit_to_if=true) |> println
```

In general these are only converted if they are a top-level statement inside a block.
If the value of the logical operator is in any way used, it will not be converted.
These include:

- Conditions in `if`, `elseif`, and `while` statements.
- The value being assigned to a variable or otherwise being part of some expression.
- The value being returned (including implicitly, by being the last statement in a block).

## [`short_to_long_function_def`](@id options-short-to-long-function-def)

Default: `false`

Transforms a *short* function definition

```julia
f(arg1, arg2) = body
```

to a *long* function definition if the short function definition exceeds the maximum margin, or if [`force_long_function_def`](@ref options-force-long-function-def) is set to `true`.

```julia
function f(arg2, arg2)
    body
end
```

See also: [`long_to_short_function_def`](@ref options-long-to-short-function-def).

This transformation is disabled inside macros or `Expr`s.

## [`surround_whereop_typeparameters`](@id options-surround-whereop-typeparameters)

Default: `true`

If `true`, surrounds type parameters with curly braces if the braces are not already present.

```julia
function func(...) where TPARAM
end
```

becomes

```julia
function func(...) where {TPARAM}
end
```

## [`trailing_comma`](@id options-trailing-comma)

Default: `true`

One of `true`, `false`, or `nothing`.

Trailing commas are added after the final argument when nesting occurs and the closing punctuation appears on the next line.

For example when the following is nested (assuming `DefaultStyle`):

```julia
funccall(arg1, arg2, arg3)
```

it turns into:

```julia
funccall(
    arg1,
    arg2,
    arg3, # trailing comma added after `arg3` (final argument) !!!
)
```

* When set to `true`, the trailing comma is always added during nesting.
* When set to `false`, the trailing comma is always removed during nesting.
* When set to `nothing`, the trailing comma appears as it does in the original source.

!!! Setting an option to `nothing` in .JuliaFormatter.toml
    TOML does not have a null value. To specify a `nothing` value in a `.JuliaFormatter.toml` file, set the option to the string `"nothing"`, e.g. `always_for_in = "nothing"`.

## [`trailing_zero`](@id options-trailing-zero)

Default: `true`

Add a trailing zero, if needed.

## [`transform_syntax_in_macros`](@id options-transform-syntax-in-macros)

Default: `false`

If `true`, the following syntax transformations will be permitted inside macros (if the corresponding option has been enabled):

- [`always_use_return`](@ref options-always-use-return)
- [`annotate_untyped_fields_with_any`](@ref options-annotate-untyped-fields-with-any)
- [`import_to_using`](@ref options-import-to-using)
- [`long_to_short_function_def`](@ref options-long-to-short-function-def)
- [`short_circuit_to_if`](@ref options-short-circuit-to-if)
- [`short_to_long_function_def`](@ref options-short-to-long-function-def)

The following syntax transformations will *not* be permitted inside macros, even if `transform_syntax_in_macros` is true:

- [`pipe_to_function_call`](@ref options-pipe-to-function-call)
- [`separate_kwargs_with_semicolon`](@ref options-separate-kwargs-with-semicolon)

For example, `always_use_return` does not fire inside a macro by default:

```@example transform-syntax-in-macros
s = """
@macro function f()
    1
end"""

using JuliaFormatter: format_text
format_text(s; always_use_return=true) |> println
```

However, if `transform_syntax_in_macros` is set to `true`, then it does:

```@example transform-syntax-in-macros
format_text(s; always_use_return=true, transform_syntax_in_macros=true) |> println
```

## [`v2_stable_multiline_strings`](@id options-v2-stable-multiline-strings)

Default: `false`

If `true`, changes the nesting behaviour for multiline strings to guarantee idempotence on formatting.

In general, setting this option to `true` will cause multiline strings to be indented more to the right; equivalently, setting it to `false` will cause multiline strings to be shifted onto new lines more easily.
**However, note that this option is not intended to primarily be used as a way to control indentation of multiline strings.**
Its primary purpose is to guarantee idempotence; the indentation differences are a side effect which are documented here for users' awareness.

Here is an example of the different output that can be produced by the two settings.
This is with the default value of `false`:

```@example stable-multiline
s = """
throw(ArgumentError(\"""
                    ooohhhhhh a very long thing
                    \"""))
"""

using JuliaFormatter: format_text
format_text(s; margin=46, v2_stable_multiline_strings=false) |> println
```

But when `v2_stable_multiline_strings` is set to `true`, the output is:

```@example stable-multiline
format_text(s; margin=46, v2_stable_multiline_strings=true) |> println
```

If that description is enough for you, feel free to not read on.

However, a rather long explanation (it is a complicated issue!) is included for the curious reader.
Click on the "Show explanation" toggle below to read it.

!!! details "Show explanation for v2_stable_multiline_strings"

    We begin by introducing an example of non-idempotence:

    ```@example stable-multiline
    s = """
    foooo((\"""
    12345\""", g),
        a, b)
    """
        
    s |> println
    ```

    Formatting once:

    ```@example stable-multiline
    using JuliaFormatter: format_text
    format_text(s; margin=21) |> println
    ```

    And formatting twice:

    ```@example stable-multiline
    format_text(format_text(s; margin=21); margin=21) |> println
    ```

    What on earth is going on here?!
    When JuliaFormatter decides whether or not to insert line breaks between arguments, it does so based on the _sum of the 'length's of the arguments_.
    That is, for example, `f(a, b, c)` is ten characters long.
    If `margin < 10`, then JuliaFormatter will opt to move `a`, `b`, and `c` onto their own lines.

    'Length's of most arguments are calculated very straightforwardly by calling `length()`. (Note that this should **really** be `textwidth()`: this is a known issue with JuliaFormatter, which will be fixed in a future version.)

    The 'length' of a multiline string, with `v2_stable_multiline_strings = false`, is the _greatest extent to which any line extends past the column before the opening quote of the string_.
    For example, in the string below, the opening `"""` begins at column 6, so the column before it is 5.
    The "length" of the string is the greatest extent to which any line extends past column 5.
    From the numbers below we can see that this is 7.

    ```
         """4
    000001234
        01234567
       """
    ```

    Cool.
    Now returning to our input text

    ```@example stable-multiline
    s |> println
    ```

    the second line ends _before_ the end of the opening `"""`, so the 'length' of the multiline string is 3 (which corresponds to the triple quotes in the _first_ line).
    If you sum the lengths up you should find that the total length of the arguments is 21 — exactly equal to the margin we used.
    So when JuliaFormatter looks at the **outer** call to `foooo(...)`, it decides that it *doesn't* need to nest its arguments, in other words we can do `foooo((...), a, b)` instead of `foooo(\n    (...),\n    a,\n    b,\n)`:

    ```@example stable-multiline
    format_text(s; margin=21) |> println
    ```

    As expected, `a` and `b` are also kept on the same line.

    To be honest, this logic doesn't really make a lot of sense to me.
    The total 'length' being 21 here is not really a meaningful metric because the arguments to `foooo(...)` would never go on the same line anyway!
    The treatment of multiline strings will probably be reworked a future version.

    Okay, so far so good.
    The problem begins with the fact that for the **inner** tuple, it sees that it has a multiline string as an argument, and because of this it will force line breaks *inside* the tuple.
    (In general, any block-like argument, e.g. `if...else...end` or `begin...end` will force nesting.)
    That's why the first output causes the multiline string and `g` to be moved onto separate lines.

    So far so good, but if we now look at that output, the opening triple quotes have been moved down into a new line.
    **The line below it, `12345"""`, now extends *beyond* the opening triple quote!**
    And so the 'length' of the multiline string is now 4, which causes the entire expression to be over the margin, and the next formatting pass will cause the outer `foooo(...)` call to also be nested.

    ```@example stable-multiline
    format_text(format_text(s; margin=21); margin=21) |> println
    ```

    `v2_stable_multiline_strings = true` fixes this by changing the way the 'length' of a multiline string is calculated.
    With this option enabled, the 'length' is always simply the length of the first line.
    In the example above, this is 3, i.e., just the triple quotes.
    Because of this, the outer call is never nested, and the output looks like:

    ```@example stable-multiline
    kw = (margin=21, v2_stable_multiline_strings=true)
    format_text(s; kw...) |> println
    ```

    Importantly, though, this option means that regardless of how the multiline string is indented, the 'length' will always be constant.
    So, the decision of whether or not to nest the arguments will be consistent across multiple formatting passes.

    ```@example stable-multiline
    format_text(s; kw...) == format_text(format_text(s; kw...); kw...)
    ```

    From the description above, it follows that the 'length' of the multiline string with `v2_stable_multiline_strings = true` is always less than or equal to the 'length' with `v2_stable_multiline_strings = false` (since the former only inspects the first line, whereas the latter takes a maximum over all lines).

    This means that `v2_stable_multiline_strings = true` will reduce the amount of line breaks, at the cost of subsequent lines of the multiline string potentially extending past the margin.
    Returning to the example at the start of this section:

    ```@example stable-multiline
    s = """
    throw(ArgumentError(\"""
                        ooohhhhhh a very long thing
                        \"""))
    """

    # multiline string's 'length' is 27, hence over margin
    format_text(s; margin=46, v2_stable_multiline_strings=false) |> println
    ```

    ```@example stable-multiline
    # multiline string's 'length' is 3, hence under margin
    format_text(s; margin=46, v2_stable_multiline_strings=true) |> println
    ```

    I will happily admit that this is *not* principled either!
    In general, the decision of whether or not to nest arguments when a multiline string is present is more complicated than just looking at the 'length' of the arguments.

    If we take a step back, the broader problem is that the outer call to `foooo(...)` is making formatting decisions without any knowledge of how its children are going to be nested, which could itself change the decisions that `foooo(...)` makes.
    This means that instead of exploring the full space of possible formatting outputs, where nesting decisions in parent and child nodes are coupled, JuliaFormatter is decomposing this into two 'local' decisions: one for the parent and one for the child.
    In many cases these can be fully decoupled, but in this case it can't; furthermore, even though decoupling does not actually ruin idempotence in many other cases, it can still lead to suboptimal formatting (which makes sense -- after all we're trying fewer possibilities).
    *Fixing this properly therefore requires a complete rethink of the formatting algorithm.*
    If you're interested in *that*, see e.g. [this issue](https://github.com/JuliaEditorSupport/JuliaFormatter.jl/issues/1104).

## [`variable_call_indent`](@id options-variable-call-indent)

Default: `[]`

The `SciMLStyle` supports the additional option `variable_call_indent`.
It permits continuation lines in calls to not align with the opening parenthesis.

For example, if `variable_call_indent = ["Dict"]`, the following is allowed:

```julia
Dict{Int, Int}(
    1 => 2,
    3 => 4)
```

(Note that in the configuration, `"Dict"` must be passed as a string: this is because JuliaFormatter matches it against the name of the function being called.)

If `variable_call_indent` is empty, the above will be formatted to

```julia
Dict{Int, Int}(1 => 2,
    3 => 4)
```

## [`whitespace_in_kwargs`](@id options-whitespace-in-kwargs)

Default: `true`

If true, `=` in keyword arguments will be surrounded by whitespace.

```julia
f(; a=4)
```

to

```julia
f(; a = 4)
```

Note that if this option is false, the arguments on either side of the equals may sometimes be parenthesised to avoid parsing ambiguities.
For example, `f(s! = x)` will be transformed to `f((s!)=x)`, and `f(t = >=(1))` will be transformed to `f(t=(>=(1)))`.

## [`whitespace_ops_in_indices`](@id options-whitespace-ops-in-indices)

Default: `false`

If true, whitespace is added for binary operations in indices. Make this
`true` if you prefer `arr[a + b]` to `arr[a+b]`. Additionally, if there's
a colon `:` involved, parenthesis will be added to the LHS and RHS.

Example: `arr[(i1 + i2):(i3 + i4)]` instead of `arr[i1+i2:i3+i4]`.

## [`whitespace_typedefs`](@id options-whitespace-typedefs)

Default: `false`

If true, whitespace is added for type definitions. Make this `true`
if you prefer `Union{A <: B, C}` to `Union{A<:B,C}`.

## [`yas_style_nesting`](@id options-yas-style-nesting)

Default: `false`

The option `yas_style_nesting` is set to `false` by default.
Setting it to `true` makes the `SciMLStyle` use the `YASStyle` nesting rules.
For other styles, this option has no effect.

```julia
# With `yas_style_nesting = false`
function my_large_function(argument1, argument2,
    argument3, argument4,
    argument5, x, y, z)
    foo(x) + goo(y)
end

# With `yas_style_nesting = true`
function my_large_function(argument1, argument2,
                           argument3, argument4,
                           argument5, x, y, z)
    foo(x) + goo(y)
end
```
